***********************************************************************
*     file suppl.F                                                    *
*---------------------------------------------------------------------*
*     30.01.06  Ansgar Denner     last changed  23.11.09              *
***********************************************************************


* test for real subtraction
c#define REALQCDSUBTEST

***********************************************************************
      subroutine printmomenta(x1,x2,p,n)
***********************************************************************
*     provides set of momenta for 3-particle phase space              *
*---------------------------------------------------------------------*
*     03.10.06  Ansgar Denner     last changed  03.10.06              *
***********************************************************************
      implicit none

#include "mcparams.h"
#include "mccommon.h"

      integer n
      real*8 x1,x2,p(maxe,0:3),s(maxe,maxe)


      write(*,*) ' momentum set',n
      do ext=1,n
        do vcomp=0,3
          write(*,100) ext,vcomp,p(ext,vcomp)
        enddo
      enddo
 100  format(6x,' p(',i1,',',i1,')    = ',d20.14)

      call dets(p,s,n,0)
      do ext=1,n
        do ext2=ext+1,n
          write(*,110) ext,ext2,s(ext,ext2)
        enddo
      enddo
 110  format(6x,' s(',i1,',',i1,')    = ',g20.14)

      end

***********************************************************************
      subroutine phsp3(x1,x2,p,out)
***********************************************************************
*     provides set of momenta for 3-particle phase space              *
*---------------------------------------------------------------------*
*     07.04.06  Ansgar Denner     last changed  20.03.06              *
***********************************************************************
      implicit none

#include "mcparams.h"
#include "mccommon.h"

      integer out
      real*8 x1,x2,p(maxe,0:3)


c standard
      goto 10

c MH =170??
      x1       =0.7794425525457286d0
      x2       = 0.9296793467158857d0
      p(1,0)   = 5456.0978678201d0
      p(1,1)   =0.00000000000000d+00
      p(1,2)   =0.00000000000000d+00
      p(1,3)   = 5456.0978678201d0
      p(2,0)   = 6507.7554270112d0
      p(2,1)   =0.00000000000000d+00
      p(2,2)   =0.00000000000000d+00
      p(2,3)   =-6507.7554270112d0
      p(3,0)   = 6480.9517238492d0
      p(3,1)   = 63.103248632236d0
      p(3,2)   =-72.608975570409d0
      p(3,3)   =-6480.2377397393d0
      p(4,0)   = 5059.4535784112d0
      p(4,1)   =-.64023461656937d0
      p(4,2)   =-28.353574852003d0
      p(4,3)   = 5059.3740894493d0
      p(5,0)   = 423.44799257084d0
      p(5,1)   =-62.463014015667d0
      p(5,2)   = 100.96255042241d0
      p(5,3)   = 369.20609109894d0
      goto 999

c     typical point?   (comp with mariano)

c MH=170
 10   x1       = 0.027920288324150003d0
      x2       = 0.17053844187868572d0
      p(1,0)   = 195.44201826905d0
      p(1,1)   =0.00000000000000d0
      p(1,2)   =0.00000000000000d0
      p(1,3)   = 195.44201826905d0
      p(2,0)   = 1193.7690931508d0
      p(2,1)   =0.00000000000000d0
      p(2,2)   =0.00000000000000d0
      p(2,3)   =-1193.7690931508d0
      p(3,0)   = 1146.9455586349d0
      p(3,1)   = 12.975350608095d0
      p(3,2)   =-46.686752411282d0
      p(3,3)   =-1145.9215077388d0
      p(4,0)   = 20.211218664010d0
      p(4,1)   = 14.032029115809d0
      p(4,2)   = 5.1517525565866d0
      p(4,3)   = 13.603490889226d0
      p(5,0)   = 222.05433412093d0
      p(5,1)   =-27.007379723904d0
      p(5,2)   = 41.534999854695d0
      p(5,3)   = 133.99094196777d0
      goto 999

c event with huge weight in real QCD
 200  continue

c       weight    =    3230286229.151696
c       gsum      =   3.8030441520402579E-006
c       factor    =   4.0892931749545820E-004
c       wconv     =    46.18635051112885
c       m2pdfpdf  =    650444.8488014321
      x1  =   2.4842513817973702D-002
      x2  =   0.1220019159393317d0
      p(1,0)    = 0.17389759672582D+03
      p(1,1)    = 0.00000000000000D+00
      p(1,2)    = 0.00000000000000D+00
      p(1,3)    = 0.17389759672582D+03
      p(2,0)    = 853.99952204868d0
      p(2,1)    = 0.00000000000000D+00
      p(2,2)    = 0.00000000000000D+00
      p(2,3)    = -853.99952204868d0
      p(3,0)    = 0.12610672936731D+03
      p(3,1)    = -.11368525121010D+02
      p(3,2)    = 0.21001349051898D+02
      p(3,3)    = 0.12382490527472D+03
      p(4,0)    = 692.8525982122d0
      p(4,1)    = 17.252042613651d0
      p(4,2)    = -62.268803563524d0
      p(4,3)    = -689.83308218649d0
      p(5,0)    = 0.20893779458597D+03
      p(5,1)    = -.58835174926413D+01
      p(5,2)    = 0.41267454511627D+02
      p(5,3)    = -.11409374841108D+03
      p(6,0)    = 0.27075850489056D+00
      p(6,1)    = 0.38603090794496D-02
      p(6,2)    = -.19408481780828D-01
      p(6,3)    = -.27003439932598D+00
      goto 999

      if (out.eq.0) return

 999  write(*,*) ' Born phase-space point'
      do ext=1,5
        do vcomp=0,3
          write(*,100) ext,vcomp,p(ext,vcomp)
        enddo
      enddo
 100  format(6x,' p(',i1,',',i1,')    = ',d20.14)

      end
***********************************************************************
      subroutine phsp3virt(x1,x2,p,out,nevent)
***********************************************************************
*     provides set of momenta for 3-particle phase space              *
*---------------------------------------------------------------------*
*     07.04.06  Ansgar Denner     last changed  20.03.06              *
***********************************************************************
      implicit none

#include "mcparams.h"
#include "mccommon.h"

      integer out,nevent
      real*8 x1,x2,p(maxe,0:3)

      goto (1,2,3) nevent

c      point with large weight in virtual correction  17626
c      channel 2

 1     x1 =  0.1036614099789159
       x2 =  4.0265346451617408d-002
       p(1,0)   =0.72562986985241D+03
       p(1,1)   =0.00000000000000D+00
       p(1,2)   =0.00000000000000D+00
       p(1,3)   =0.72562986985241D+03
       p(2,0)   =0.28185742516132D+03
       p(2,1)   =0.00000000000000D+00
       p(2,2)   =0.00000000000000D+00
       p(2,3)   =-.28185742516132D+03
       p(3,0)   =0.25977822697454D+03
       p(3,1)   =-.14105836468746D+02
       p(3,2)   =0.39729491498768D+02
       p(3,3)   =-.25633439116279D+03
       p(4,0)   =0.37127595049292D+03
       p(4,1)   =0.21575024349745D+02
       p(4,2)   =-.63484378772037D+02
       p(4,3)   =0.36517130691042D+03
       p(5,0)   =0.37643311754627D+03
       p(5,1)   =-.74691878809990D+01
       p(5,2)   =0.23754887273269D+02
       p(5,3)   =0.33493552894347D+03

       goto 999

c      point with large weight in virtual correction   24216
c      channel 1

 2    x1 =  0.2229636359464401
      x2 =  1.2149430980182485d-002
      p(1,0)   =0.15607454516251D+04
      p(1,1)   =0.00000000000000D+00
      p(1,2)   =0.00000000000000D+00
      p(1,3)   =0.15607454516251D+04
       p(2,0)   =0.85046016861277D+02
       p(2,1)   =0.00000000000000D+00
       p(2,2)   =0.00000000000000D+00
       p(2,3)   =-.85046016861277D+02
       p(3,0)   =0.10942439743686D+04
       p(3,1)   =-.22583682539336D+01
       p(3,2)   =-.30925381397300D+02
       p(3,3)   =0.10938045510969D+04
       p(4,0)   =0.68779595242094D+02
       p(4,1)   =0.12286858955442D+01
       p(4,2)   =-.88714253332277D+01
       p(4,3)   =-.68193994348427D+02
       p(5,0)   =0.48276789887564D+03
       p(5,1)   =0.10296823583893D+01
       p(5,2)   =0.39796806730528D+02
       p(5,3)   =0.45008887801532D+03

       goto 999

c      point with large weight in virtual correction   1696746.158786986
c      channel 4

 3     x1 =  0.1560891825692569d0
       x2 =  2.8921068939348009d-002
       p(1,0)   =0.10926242779848D+04
       p(1,1)   =0.00000000000000D+00
       p(1,2)   =0.00000000000000D+00
       p(1,3)   =0.10926242779848D+04
       p(2,0)   =0.20244748257544D+03
       p(2,1)   =0.00000000000000D+00
       p(2,2)   =0.00000000000000D+00
       p(2,3)   =-.20244748257544D+03
       p(3,0)   =0.96584468400355D+03
       p(3,1)   =-.27354380739683D+02
       p(3,2)   =0.56314121252613D+02
       p(3,3)   =0.96381347325083D+03
       p(4,0)   =0.13417940217399D+03
       p(4,1)   =-.52497209852422D+01
       p(4,2)   =0.10605065522826D+02
       p(4,3)   =-.13365659348720D+03
       p(5,0)   =0.19504767438269D+03
       p(5,1)   =0.32604101724925D+02
       p(5,2)   =-.66919186775439D+02
       p(5,3)   =0.60019915645737D+02

 999   if (out.eq.0) return

       write(*,*) ' Virtual phase-space point'
      do ext=1,5
        do vcomp=0,3
          write(*,100) ext,vcomp,p(ext,vcomp)
        enddo
      enddo
 100  format(6x,' p(',i1,',',i1,')    = ',d20.14)

      end

***********************************************************************
      subroutine phsp3x(em,x1,x2,x,p,out)
***********************************************************************
*     provides set of momenta for 3-particle phase space              *
*     as well as sets for rescaled incoming momenta                   *
*---------------------------------------------------------------------*
*     18.09.06  Ansgar Denner     last changed  19.09.06              *
***********************************************************************
      implicit none

#include "mcparams.h"
#include "mccommon.h"

      integer em,out
      real*8 x1,x2,p(maxe,0:3),x

c standard
      goto 1
c standard with exchange 1 <-> 2
      goto 2
c huge QCD event
      goto 10

 1    x1    =   0.24596552174024927d0
      x2    =   0.3807673281285489d0
      x=0.3851497419645885d+00

      if (em.eq.0) then
         p(1,0)=   0.1721758652181745d+04
         p(1,1)=   0.0000000000000000d+00
         p(1,2)=   0.0000000000000000d+00
         p(1,3)=  -0.1721758652181745d+04
         p(2,0)=   0.2665371296899842d+04
         p(2,1)=   0.0000000000000000d+00
         p(2,2)=   0.0000000000000000d+00
         p(2,3)=   0.2665371296899842d+04
         p(3,0)=   0.1649152002125369d+04
         p(3,1)=   0.1803720340629039d+03
         p(3,2)=   0.1429476729875189d+03
         p(3,3)=  -0.1633013845082025d+04
         p(4,0)=   0.2384885856690749d+04
         p(4,1)=  -0.1711598269481641d+02
         p(4,2)=   0.3656786080213642d+02
         p(4,3)=   0.2384544062108376d+04
         p(5,0)=   0.3530920902654701d+03
         p(5,1)=  -0.1632560513680874d+03
         p(5,2)=  -0.1795155337896553d+03
         p(5,3)=   0.1920824276917447d+03
      else if (em.eq.1) then
         p(1,0)=   0.6631349006130970d+03
         p(1,1)=   0.0000000000000000d+00
         p(1,2)=   0.0000000000000000d+00
         p(1,3)=  -0.6631349006130970d+03
         p(2,3)=   0.2665371296899842d+04
         p(2,1)=   0.0000000000000000d+00
         p(2,2)=   0.0000000000000000d+00
         p(2,3)=   0.2665371296899842d+04
         p(3,0)=   0.6270485863904123d+03
         p(3,1)=   0.1747285078219520d+03
         p(3,2)=   0.1373330013951448d+03
         p(3,3)=  -0.5863442034985335d+03
         p(4,0)=   0.2272832336091992d+04
         p(4,1)=  -0.1670162498165104d+02
         p(4,2)=   0.3568259610845851d+02
         p(4,3)=   0.2272490843995486d+04
         p(5,0)=   0.4286252750305355d+03
         p(5,1)=  -0.1580268828403010d+03
         p(5,2)=  -0.1730155975036034d+03
         p(5,3)=   0.3160897557897932d+03
      else if (em.eq.2) then
         p(1,0)=   0.1721758652181746d+04
         p(1,1)=   0.0000000000000000d+00
         p(1,2)=   0.0000000000000000d+00
         p(1,3)=  -0.1721758652181746d+04
         p(2,0)=   0.1026567067240795d+04
         p(2,1)=   0.0000000000000000d+00
         p(2,2)=   0.0000000000000000d+00
         p(2,3)=   0.1026567067240795d+04
         p(3,0)=   0.1583060766189860d+04
         p(3,1)=   0.1747285078219520d+03
         p(3,2)=   0.1373330013951448d+03
         p(3,3)=  -0.1567383483622225d+04
         p(4,0)=   0.8757583487809721d+03
         p(4,1)=  -0.1670162498165104d+02
         p(4,2)=   0.3568259610845851d+02
         p(4,3)=   0.8748717011753826d+03
         p(5,0)=   0.2895066044517094d+03
         p(5,1)=  -0.1580268828403010d+03
         p(5,2)=  -0.1730155975036034d+03
         p(5,3)=  -0.2679802494109224d+01
      endif

      goto 999

 2    x2    =   0.24596552174024927d0
      x1    =   0.3807673281285489d0
      x=0.3851497419645885d+00

      if (em.eq.0) then
         p(2,0)=   0.1721758652181745d+04
         p(2,1)=   0.0000000000000000d+00
         p(2,2)=   0.0000000000000000d+00
         p(2,3)=  -0.1721758652181745d+04
         p(1,0)=   0.2665371296899842d+04
         p(1,1)=   0.0000000000000000d+00
         p(1,2)=   0.0000000000000000d+00
         p(1,3)=   0.2665371296899842d+04
         p(4,0)=   0.1649152002125369d+04
         p(4,1)=   0.1803720340629039d+03
         p(4,2)=   0.1429476729875189d+03
         p(4,3)=  -0.1633013845082025d+04
         p(3,0)=   0.2384885856690749d+04
         p(3,1)=  -0.1711598269481641d+02
         p(3,2)=   0.3656786080213642d+02
         p(3,3)=   0.2384544062108376d+04
         p(5,0)=   0.3530920902654701d+03
         p(5,1)=  -0.1632560513680874d+03
         p(5,2)=  -0.1795155337896553d+03
         p(5,3)=   0.1920824276917447d+03
      else if (em.eq.2) then
         p(2,0)=   0.6631349006130970d+03
         p(2,1)=   0.0000000000000000d+00
         p(2,2)=   0.0000000000000000d+00
         p(2,3)=  -0.6631349006130970d+03
         p(1,0)=   0.2665371296899842d+04
         p(1,1)=   0.0000000000000000d+00
         p(1,2)=   0.0000000000000000d+00
         p(1,3)=   0.2665371296899842d+04
         p(4,0)=   0.6270485863904123d+03
         p(4,1)=   0.1747285078219520d+03
         p(4,2)=   0.1373330013951448d+03
         p(4,3)=  -0.5863442034985335d+03
         p(3,0)=   0.2272832336091992d+04
         p(3,1)=  -0.1670162498165104d+02
         p(3,2)=   0.3568259610845851d+02
         p(3,3)=   0.2272490843995486d+04
         p(5,0)=   0.4286252750305355d+03
         p(5,1)=  -0.1580268828403010d+03
         p(5,2)=  -0.1730155975036034d+03
         p(5,3)=   0.3160897557897932d+03
      else if (em.eq.1) then
         p(2,0)=   0.1721758652181746d+04
         p(2,1)=   0.0000000000000000d+00
         p(2,2)=   0.0000000000000000d+00
         p(2,3)=  -0.1721758652181746d+04
         p(1,0)=   0.1026567067240795d+04
         p(1,1)=   0.0000000000000000d+00
         p(1,2)=   0.0000000000000000d+00
         p(1,3)=   0.1026567067240795d+04
         p(4,0)=   0.1583060766189860d+04
         p(4,1)=   0.1747285078219520d+03
         p(4,2)=   0.1373330013951448d+03
         p(4,3)=  -0.1567383483622225d+04
         p(3,0)=   0.8757583487809721d+03
         p(3,1)=  -0.1670162498165104d+02
         p(3,2)=   0.3568259610845851d+02
         p(3,3)=   0.8748717011753826d+03
         p(5,0)=   0.2895066044517094d+03
         p(5,1)=  -0.1580268828403010d+03
         p(5,2)=  -0.1730155975036034d+03
         p(5,3)=  -0.2679802494109224d+01
      endif

      goto 999

 10   continue
c       generator =              0
c       contribution=            4
c       channel   =            4
c       event     =     68430264
c       weight    =   2.0333909290870375E+017
c       gsum      =   2.1484335626802404E-003
c       factor    =   0.1014350044876027
c       wconv     =    17.34548453424707
c       m2pdfpdf  =    248295312841962.7
       x1  =   0.1362683843328153d0
       x2  =   4.0277349549637460d-002
       x   =   1d0

       if(em.eq.0)then
       p(1,0)    = 0.95387869032971D+03
       p(1,1)    = 0.00000000000000D+00
       p(1,2)    = 0.00000000000000D+00
       p(1,3)    = 0.95387869032971D+03
       p(2,0)    = 0.28194144684746D+03
       p(2,1)    = 0.00000000000000D+00
       p(2,2)    = 0.00000000000000D+00
       p(2,3)    = -.28194144684746D+03
       p(3,0)    = 0.17688149952025D+03
       p(3,1)    = 0.34792983025587D+01
       p(3,2)    = -.60379248075379D-01
       p(3,3)    = 0.17684726661784D+03
       p(4,0)    = 0.27414046039325D+03
       p(4,1)    = 0.49899593884991D+02
       p(4,2)    = 0.16977012595422D+02
       p(4,3)    = -.26902565602200D+03
       p(5,0)    = 0.78479817726367D+03
       p(5,1)    = -.53378892187550D+02
       p(5,2)    = -.16916633347347D+02
       p(5,3)    = 0.76411563288641D+03
      elseif(em.eq.1)then
       p(1,0)    = 0.95387869032971D+03
       p(1,1)    = 0.00000000000000D+00
       p(1,2)    = 0.00000000000000D+00
       p(1,3)    = 0.95387869032971D+03
       p(2,0)    = 0.28194144684746D+03
       p(2,1)    = 0.00000000000000D+00
       p(2,2)    = 0.00000000000000D+00
       p(2,3)    = -.28194144684746D+03
       p(3,0)    = 0.17688149952025D+03
       p(3,1)    = 0.34792983025587D+01
       p(3,2)    = -.60379248075379D-01
       p(3,3)    = 0.17684726661784D+03
       p(4,0)    = 0.27414046039325D+03
       p(4,1)    = 0.49899593884991D+02
       p(4,2)    = 0.16977012595422D+02
       p(4,3)    = -.26902565602200D+03
       p(5,0)    = 0.78479817726367D+03
       p(5,1)    = -.53378892187550D+02
       p(5,2)    = -.16916633347347D+02
       p(5,3)    = 0.76411563288641D+03
      elseif(em.eq.2)then
       p(1,0)    = 0.95387869032971D+03
       p(1,1)    = 0.00000000000000D+00
       p(1,2)    = 0.00000000000000D+00
       p(1,3)    = 0.95387869032971D+03
       p(2,0)    = 0.28194144684746D+03
       p(2,1)    = 0.00000000000000D+00
       p(2,2)    = 0.00000000000000D+00
       p(2,3)    = -.28194144684746D+03
       p(3,0)    = 0.17688149952025D+03
       p(3,1)    = 0.34792983025587D+01
       p(3,2)    = -.60379248075379D-01
       p(3,3)    = 0.17684726661784D+03
       p(4,0)    = 0.27414046039325D+03
       p(4,1)    = 0.49899593884991D+02
       p(4,2)    = 0.16977012595422D+02
       p(4,3)    = -.26902565602200D+03
       p(5,0)    = 0.78479817726367D+03
       p(5,1)    = -.53378892187550D+02
       p(5,2)    = -.16916633347347D+02
       p(5,3)    = 0.76411563288641D+03
      endif
      goto 999

 20   if(em.eq.0)then
      elseif(em.eq.1)then
      elseif(em.eq.2)then
      endif
      goto 999

 999  if (out.eq.0) return

      write(*,*) ' phase-space point: em=',em
      do ext=1,5
        do vcomp=0,3
          write(*,100) ext,vcomp,p(ext,vcomp)
        enddo
      enddo
 100  format(6x,' p(',i1,',',i1,')    = ',d20.14)

      end

***********************************************************************
      subroutine phsp4(x1,x2,p,out)
***********************************************************************
*     provides set of momenta for 4-particle phase space              *
*---------------------------------------------------------------------*
*     11.05.06  Ansgar denner     last changed  19.09.06              *
***********************************************************************
      implicit none

#include "mcparams.h"
#include "mccommon.h"

      integer out
      real*8 x1,x2,p(maxe,0:3)
      real*8 sevent(maxe,maxe),p1(maxe,0:3),p2(maxe,0:3)
      real*8 x12,x22,x11,x21
      integer coll

c standard event
      goto 10
c standard resonant event
c      goto 20
c    standard collinear event
c      goto 143
c    incoming and outgoing collinear particles
      coll=13                   ! 1 and 3 collinear
c     coll=14                   ! 1 and 4 collinear
      coll=16                   ! 1 and 6 collinear
c      coll=23                   ! 2 and 3 collinear
c       coll=24          ! 2 and 4 collinear
c       coll=26          ! 2 and 6 collinear
c      goto 113
c huge event with small s46
c     goto 500
c huge event with small s26
      goto 501

 10   continue
c typical point?  comparision with Mariano
      x1 =  0.105822518d0
      x2 =  0.346434877d0
      p(1,0)   = 740.75762823191    d0
      p(1,1)   = 0.0000000000000    d0
      p(1,2)   = 0.0000000000000    d0
      p(1,3)   = 740.75762823191    d0
      p(2,0)   = 2425.0441416564    d0
      p(2,1)   = 0.0000000000000    d0
      p(2,2)   = 0.0000000000000    d0
      p(2,3)   =-2425.0441416564    d0
      p(3,0)   = 2284.1649203372    d0
      p(3,1)   =-109.20299649889    d0
      p(3,2)   =-39.226874609083    d0
      p(3,3)   =-2281.2157594500    d0
      p(4,0)   = 169.06590947611    d0
      p(4,1)   = 14.218657626899    d0
      p(4,2)   = 9.4377505330044    d0
      p(4,3)   = 168.20237925532    d0
      p(5,0)   = 581.95356436124    d0
      p(5,1)   = 54.689698117277    d0
      p(5,2)   = 31.932343436732    d0
      p(5,3)   = 552.95507361379    d0
      p(6,0)   = 130.61737571377    d0
      p(6,1)   = 40.294640754713    d0
      p(6,2)   =-2.1432193606528    d0
      p(6,3)   =-124.22820684359    d0

      goto 999

 11   continue

c  event with large weight 2.0732984E+10

      x1       =0.00142901927d0
      x2       =0.337322264d0
      p(1,0)   = 10.003134896011d0
      p(1,1)   = 0.0000000000000d0
      p(1,2)   = 0.0000000000000d0
      p(1,3)   = 10.003134896011d0
      p(2,0)   = 2361.2558482436d0
      p(2,1)   = 0.0000000000000d0
      p(2,2)   = 0.0000000000000d0
      p(2,3)   =-2361.2558482436d0
      p(3,0)   = 553.46622183789d0
      p(3,1)   = 17.098113422070d0
      p(3,2)   =-40.295753505270d0
      p(3,3)   =-551.73251262034d0
      p(4,0)   = 653.03400703384d0
      p(4,1)   = 45.816809733644d0
      p(4,2)   = 42.546608951292d0
      p(4,3)   =-650.03386092976d0
      p(5,0)   = 1092.6637533006d0
      p(5,1)   =-63.445298911770d0
      p(5,2)   = 1.4984065084656d0
      p(5,3)   =-1077.4908475717d0
      p(6,0)   = 72.095000967290d0
      p(6,1)   =0.53037575605546d0
      p(6,2)   =-3.7492619544876d0
      p(6,3)   =-71.995492225747d0
      goto 999

 111   continue
c  event with photon collinear to particle 1 2.52562671d-06

       x1       =0.1894157431105d0
       x2       =0.41716254156758574d-2
       p(1,0)   =0.13259102017735d+04
       p(1,1)   =0.00000000000000d+00
       p(1,2)   =0.00000000000000d+00
       p(1,3)   =0.13259102017735d+04
       p(2,0)   =0.29201377909731d+02
       p(2,1)   =0.00000000000000d+00
       p(2,2)   =0.00000000000000d+00
       p(2,3)   =-.29201377909731d+02
       p(3,0)   =0.46112196281984d+02
       p(3,1)   =0.11294406322884d+02
       p(3,2)   =-.12295332370650d+01
       p(3,3)   =0.44690706861503d+02
       p(4,0)   =0.53449100897491d+02
       p(4,1)   =0.28157812508828d+02
       p(4,2)   =-.51431212848034d+01
       p(4,3)   =0.45138589753310d+02
       p(5,0)   =0.33703056863870d+03
       p(5,1)   =-.38888167179196d+02
       p(5,2)   =0.50263034324055d+01
       p(5,3)   =0.28836097330287d+03
       p(6,0)   =0.91851971386510d+03
       p(6,1)   =-.56405165251616d+00
       p(6,2)   =0.13463510894628d+01
       p(6,3)   =0.91851855394613d+03
      goto 999


c event with photon collinear to particle 3
 143  continue
      x1       =0.8562244195395285d0
      x2       =0.9886297323794428d0
      p(1,0)   =0.59935709367767d+04
      p(1,1)   =0.00000000000000d+00
      p(1,2)   =0.00000000000000d+00
      p(1,3)   =0.59935709367767d+04
      p(2,0)   =0.69204081266561d+04
      p(2,1)   =0.00000000000000d+00
      p(2,2)   =0.00000000000000d+00
      p(2,3)   =-.69204081266561d+04
      p(3,0)   =0.11860259624494d+04
      p(3,1)   =0.11572853774637d+04
      p(3,2)   =0.23112881385670d+03
      p(3,3)   =-.11801529611888d+03
      p(4,0)   =0.40920751020207d+04
      p(4,1)   =0.39805512328878d+04
      p(4,2)   =0.88990947145393d+03
      p(4,3)   =-.32916812656924d+03
      p(5,0)   =0.64504773793365d+04
      p(5,1)   =-.62945181787048d+04
      p(5,2)   =-.13520210520325d+04
      p(5,3)   =-.36171590253598d+03
      p(6,0)   =0.11854006196262d+04
      p(6,1)   =0.11566815683533d+04
      p(6,2)   =0.23098276672183d+03
      p(6,3)   =-.11793786465529d+03
      goto 999


c event with photon collinear to particle 1  0.33182499901159d-02
c s34 resonant

 113  continue

       p1(1,0)   =0.11987141873553d+05
       p1(1,1)   =0.00000000000000d+00
       p1(1,2)   =0.00000000000000d+00
       p1(1,3)   =0.11987141873553d+05
       p1(2,0)   =0.69204081266561d+04
       p1(2,1)   =0.00000000000000d+00
       p1(2,2)   =0.00000000000000d+00
       p1(2,3)   =-.69204081266561d+04
       p1(3,0)   =0.23714247077732d+04
       p1(3,1)   =0.23139665477618d+04
       p1(3,2)   =0.46210402678285d+03
       p1(3,3)   =-.23595302267208d+03
       p1(4,0)   =0.40920726898268d+04
       p1(4,1)   =0.39805516309430d+04
       p1(4,2)   =0.88989666161388d+03
       p1(4,3)   =-.32916795693285d+03
       p1(5,0)   =0.64504816658834d+04
       p1(5,1)   =-.62945181787048d+04
       p1(5,2)   =-.13520414206724d+04
       p1(5,3)   =-.36171621008539d+03
       p1(6,0)   =0.59935709367260d+04
       p1(6,1)   =0.24940501791447d-17
       p1(6,2)   =0.40732275663277d-01
       p1(6,3)   =0.59935709365876d+04

       x11 = 0.3074569021753d+00
       x21 = 0.38076732812855d+00

       p1(1,0)   =0.21521983152271d+04
       p1(1,1)   =0.00000000000000d+00
       p1(1,2)   =0.00000000000000d+00
       p1(1,3)   =-.21521983152271d+04
       p1(2,0)   =0.26653712968998d+04
       p1(2,1)   =0.00000000000000d+00
       p1(2,2)   =0.00000000000000d+00
       p1(2,3)   =0.26653712968998d+04
       p1(3,0)   =0.16491522335833d+04
       p1(3,1)   =0.18037203406290d+03
       p1(3,2)   =0.14295091168584d+03
       p1(3,3)   =-.16330137953210d+04
       p1(4,0)   =0.23848859158709d+04
       p1(4,1)   =-.17115982694816d+02
       p1(4,2)   =0.36570891634689d+02
       p1(4,3)   =0.23845440748162d+04
       p1(5,0)   =0.35309179962227d+03
       p1(5,1)   =-.16325605136809d+03
       p1(5,2)   =-.17951502901165d+03
       p1(5,2)   =-.17951502901165d+03
       p1(5,3)   =0.19208236517479d+03
       p1(6,0)   =0.43043966305056d+03
       p1(6,1)   =-.41479308537175d-18
       p1(6,2)   =-.67743088883550d-02
       p1(6,3)   =-.43043966299725d+03




       x12 = 0.24596552174025d+00
       x22 = 0.423074809031714d0
       p2(1,0)   =0.17217586521817d+04
       p2(1,1)   =0.00000000000000d+00
       p2(1,2)   =0.00000000000000d+00
       p2(1,3)   =-.17217586521817d+04
       p2(2,0)   =0.29615236632220d+04
       p2(2,1)   =0.00000000000000d+00
       p2(2,2)   =0.00000000000000d+00
       p2(2,3)   =0.29615236632220d+04
       p2(3,0)   =0.16491519533326d+04
       p2(3,1)   =0.18037203406290d+03
       p2(3,2)   =0.14294699021001d+03
       p2(3,3)   =-.16330138555746d+04
       p2(4,0)   =0.23848858442119d+04
       p2(4,1)   =-.17115982694816d+02
       p2(4,2)   =0.36567221846543d+02
       p2(4,3)   =0.23845440594264d+04
       p2(5,0)   =0.35309215153829d+03
       p2(5,1)   =-.16325605136809d+03
       p2(5,2)   =-.17951564020627d+03
       p2(5,3)   =0.19208244087103d+03
       p2(6,0)   =0.29615236632096d+03
       p2(6,1)   =0.87446060499308d-19
       p2(6,2)   =0.14281497107436d-02
       p2(6,3)   =0.29615236631752d+03


       if (coll.eq.16) then
         x1=x11
         x2=x21
         do vcomp=0,3
           p(1,vcomp)=p1(1,vcomp)
           p(2,vcomp)=p1(2,vcomp)
           p(3,vcomp)=p1(3,vcomp)
           p(4,vcomp)=p1(4,vcomp)
           p(5,vcomp)=p1(5,vcomp)
           p(6,vcomp)=p1(6,vcomp)
         enddo
       elseif (coll.eq.14) then
         x1=x11
         x2=x21
         do vcomp=0,3
           p(1,vcomp)=p1(1,vcomp)
           p(2,vcomp)=p1(2,vcomp)
           p(3,vcomp)=p1(3,vcomp)
           p(6,vcomp)=p1(4,vcomp)
           p(5,vcomp)=p1(5,vcomp)
           p(4,vcomp)=p1(6,vcomp)
         enddo
       elseif (coll.eq.13) then
         x1=x11
         x2=x21
         do vcomp=0,3
           p(1,vcomp)=p1(1,vcomp)
           p(2,vcomp)=p1(2,vcomp)
           p(6,vcomp)=p1(3,vcomp)
           p(4,vcomp)=p1(4,vcomp)
           p(5,vcomp)=p1(5,vcomp)
           p(3,vcomp)=p1(6,vcomp)
         enddo
       elseif (coll.eq.26) then
         x1=x12
         x2=x22
         do vcomp=0,3
           p(1,vcomp)=p2(1,vcomp)
           p(2,vcomp)=p2(2,vcomp)
           p(3,vcomp)=p2(3,vcomp)
           p(4,vcomp)=p2(4,vcomp)
           p(5,vcomp)=p2(5,vcomp)
           p(6,vcomp)=p2(6,vcomp)
         enddo
       elseif (coll.eq.24) then
         x1=x12
         x2=x22
         do vcomp=0,3
           p(1,vcomp)=p2(1,vcomp)
           p(2,vcomp)=p2(2,vcomp)
           p(3,vcomp)=p2(3,vcomp)
           p(6,vcomp)=p2(4,vcomp)
           p(5,vcomp)=p2(5,vcomp)
           p(4,vcomp)=p2(6,vcomp)
         enddo
       elseif (coll.eq.23) then
         x1=x12
         x2=x22
         do vcomp=0,3
           p(1,vcomp)=p2(1,vcomp)
           p(2,vcomp)=p2(2,vcomp)
           p(6,vcomp)=p2(3,vcomp)
           p(4,vcomp)=p2(4,vcomp)
           p(5,vcomp)=p2(5,vcomp)
           p(3,vcomp)=p2(6,vcomp)
         enddo
       endif

       goto 999


c event with huge weight in real QCD
 200     continue

c       weight    =    3230286229.151696
c       gsum      =   3.8030441520402579d-006
c       factor    =   4.0892931749545820d-004
c       wconv     =    46.18635051112885
c       m2pdfpdf  =    650444.8488014321
             x1  =   2.4842513817973702D-02
             x2  =   0.1220019159393317d0
         p(1,0)    = 0.17389759672582D+03
         p(1,1)    = 0.00000000000000D+00
         p(1,2)    = 0.00000000000000D+00
         p(1,3)    = 0.17389759672582D+03
         p(2,0)    = 0.85401341157532D+03
         p(2,1)    = 0.00000000000000D+00
         p(2,2)    = 0.00000000000000D+00
         p(2,3)    = -.85401341157532D+03
         p(3,0)    = 0.12610672936731D+03
         p(3,1)    = -.11368525121010D+02
         p(3,2)    = 0.21001349051898D+02
         p(3,3)    = 0.12382490527472D+03
         p(4,0)    = 0.69259572584297D+03
         p(4,1)    = 0.17248182304572D+02
         p(4,2)    = -.62249395081743D+02
         p(4,3)    = -.68957693731381D+03
         p(5,0)    = 0.20893779458597D+03
         p(5,1)    = -.58835174926413D+01
         p(5,2)    = 0.41267454511627D+02
         p(5,3)    = -.11409374841108D+03
         p(6,0)    = 0.27075850489056D+00
         p(6,1)    = 0.38603090794496D-02
         p(6,2)    = -.19408481780828D-01
         p(6,3)    = -.27003439932598D+00

      goto 999

 20   p(1,0)    = 0.10003134896011D+02
      p(1,1)    = 0.00000000000000D+00
      p(1,2)    = 0.00000000000000D+00
      p(1,3)    = 0.10003134896011D+02
      p(2,0)    = 0.23612558482436D+04
      p(2,1)    = 0.00000000000000D+00
      p(2,2)    = 0.00000000000000D+00
      p(2,3)    = -.23612558482436D+04
      p(3,0)    = 0.55346622183789D+03
      p(3,1)    = 0.17098113422070D+02
      p(3,2)    = -.40295753505270D+02
      p(3,3)    = -.55173251262034D+03
      p(4,0)    = 0.65303400703384D+03
      p(4,1)    = 0.45816809733644D+02
      p(4,2)    = 0.42546608951292D+02
      p(4,3)    = -.65003386092976D+03
      p(5,0)    = 0.10926637533006D+04
      p(5,1)    = -.63445298911770D+02
      p(5,2)    = 0.14984065084656D+01
      p(5,3)    = -.10774908475717D+04
      p(6,0)    = 0.72095000967290D+02
      p(6,1)    = 0.53037575605546D+00
      p(6,2)    = -.37492619544876D+01
      p(6,3)    = -.71995492225747D+02

      goto 999

 500  continue

             x1  =   6.7289861500315133d-002
             x2  =   0.2542216441744457d0
       p(1,0)    = 0.47102903050221D+03
       p(1,1)    = 0.00000000000000D+00
       p(1,2)    = 0.00000000000000D+00
       p(1,3)    = 0.47102903050221D+03
       p(2,0)    = 0.17795515092211D+04
       p(2,1)    = 0.00000000000000D+00
       p(2,2)    = 0.00000000000000D+00
       p(2,3)    = -.17795515092211D+04
       p(3,0)    = 0.74953955699218D+02
       p(3,1)    = -.22299286110478D+02
       p(3,2)    = -.10783170603911D+02
       p(3,3)    = 0.70742918696152D+02
       p(4,0)    = 0.16316364521801D+04
       p(4,1)    = -.61625907686933D+01
       p(4,2)    = -.12199388853799D+01
       p(4,3)    = -.16316243582109D+04
       p(5,0)    = 0.41693721872208D+03
       p(5,1)    = 0.28941747936535D+02
       p(5,2)    = 0.12098104173315D+02
       p(5,3)    = 0.37941093217973D+03
       p(6,0)    = 0.12705291312190D+03
       p(6,1)    = -.47987105736358D+00
       p(6,2)    = -.94994684024802D-01
       p(6,3)    = -.12705197138392D+03


      goto 999


 501  continue
             x1  =   3.7425640140175362E-002
             x2  =   5.6426296351136784E-002
       p(1,0)    = 0.26197948098123D+03
       p(1,1)    = 0.00000000000000D+00
       p(1,2)    = 0.00000000000000D+00
       p(1,3)    = 0.26197948098123D+03
       p(2,0)    = 0.39498407445796D+03
       p(2,1)    = 0.00000000000000D+00
       p(2,2)    = 0.00000000000000D+00
       p(2,3)    = -.39498407445796D+03
       p(3,0)    = 0.14300997999997D+03
       p(3,1)    = -.24129723594134D+02
       p(3,2)    = -.12443511693318D+01
       p(3,3)    = 0.14095411455161D+03
       p(4,0)    = 0.33251276089741D+03
       p(4,1)    = 0.48989118874391D+01
       p(4,2)    = 0.31662493827880D+00
       p(4,3)    = -.33247652032976D+03
       p(5,0)    = 0.18097042087453D+03
       p(5,1)    = 0.19230811526936D+02
       p(5,2)    = 0.92772631566738D+00
       p(5,3)    = 0.58988205968688D+02
       p(6,0)    = 0.47039366727228D+00
       p(6,1)    = 0.17975918198032D-06
       p(6,2)    = -.84614357395501D-07
       p(6,3)    = -.47039366727224D+00

      goto 999


 999  continue

      if (out.eq.0) return

      write(*,*)
      write(*,*) ' Real phase-space point'
      do ext=1,6
        do vcomp=0,3
          write(*,1000) ext,vcomp,p(ext,vcomp)
        enddo
      enddo
 1000 format(6x,' p(',i1,',',i1,')    = ',d20.14)
      call dets(p,sevent,6,0)
      do ext=1,5
        do ext2=ext+1,6
          write(*,1100) ext,ext2,sevent(ext,ext2)
        enddo
      enddo
 1100 format(6x,' s(',i1,',',i1,')    = ',g20.14)
      end

***********************************************************************
      subroutine phsp4gen(x1,x2,p,out)
***********************************************************************
*     provides set of momenta for 4-particle phase space              *
*     based on momenta for 3-particle phase space                     *
*---------------------------------------------------------------------*
*     02.06.06  Ansgar Denner     last changed  19.09.06              *
***********************************************************************
      implicit none

#include "mcparams.h"
#include "mccommon.h"

      integer out
      real*8 x1,x2,p(maxe,0:3)
      real*8 sevent(maxe,maxe)

      real*8 y,z,v,omz
      data y /0.1d0/, omz /0.1d0/
      data v /1d-9/

      goto 1

      x1       =0.7794425525457286d0
      x2       =0.9296793467158857d0
      p(1,0)   = 5456.0978678201d0
      p(1,1)   =0.00000000000000d+00
      p(1,2)   =0.00000000000000d+00
      p(1,3)   = 5456.0978678201d0
      p(2,0)   = 6507.7554270112d0
      p(2,1)   =0.00000000000000d+00
      p(2,2)   =0.00000000000000d+00
      p(2,3)   =-6507.7554270112d0
      p(3,0)   = 6480.9517238492d0
      p(3,1)   = 63.103248632236d0
      p(3,2)   =-72.608975570409d0
      p(3,3)   =-6480.2377397393d0
      p(4,0)   = 5059.4535784112d0
      p(4,1)   =-.64023461656937d0
      p(4,2)   =-28.353574852003d0
      p(4,3)   = 5059.3740894493d0
      p(5,0)   = 423.44799257084d0
      p(5,1)   =-62.463014015667d0
      p(5,2)   = 100.96255042241d0
      p(5,3)   = 369.20609109894d0


      goto 999

c     typical point?   (comp with mariano)

      x1       =2.7920288324150122d-002
      x2       =0.1705384418786879d0
      p(1,0)   = 195.44201826905d0
      p(1,1)   =0.00000000000000d0
      p(1,2)   =0.00000000000000d0
      p(1,3)   = 195.44201826905d0
      p(2,0)   = 1193.7690931508d0
      p(2,1)   =0.00000000000000d0
      p(2,2)   =0.00000000000000d0
      p(2,3)   =-1193.7690931508d0
      p(3,0)   = 1146.9455586349d0
      p(3,1)   = 12.975350608095d0
      p(3,2)   =-46.686752411282d0
      p(3,3)   =-1145.9215077388d0
      p(4,0)   = 20.211218664010d0
      p(4,1)   = 14.032029115809d0
      p(4,2)   = 5.1517525565866d0
      p(4,3)   = 13.603490889226d0
      p(5,0)   = 222.05433412093d0
      p(5,1)   =-27.007379723904d0
      p(5,2)   = 41.534999854695d0
      p(5,3)   = 133.99094196777d0


c    point with large invariants
      x1 =  0.588741239d0
      x2 =  0.999293394d0
       p(1,0)   =0.41211886753922d+04
       p(1,1)   =0.00000000000000d+00
       p(1,2)   =0.00000000000000d+00
       p(1,3)   =0.41211886753922d+04
       p(2,0)   =0.69950537556244d+04
       p(2,1)   =0.00000000000000d+00
       p(2,2)   =0.00000000000000d+00
       p(2,3)   =-.69950537556244d+04
       p(3,0)   =0.36462606975350d+04
       p(3,1)   =0.55723699502237d+03
       p(3,2)   =0.59421491737061d+02
       p(3,3)   =0.36029395071367d+04
       p(4,0)   =0.68550553557920d+04
       p(4,1)   =-.12526594435765d+03
       p(4,2)   =-.21060668618306d+03
       p(4,3)   =-.68506742148414d+04
       p(5,0)   =0.61492637768962d+03
       p(5,1)   =-.43197105066472d+03
       p(5,2)   =0.15118519444600d+03
       p(5,3)   =0.37386962747250d+03

c   point with small boost  small s34!
       x1 =  0.85622442d0
       x2 =  0.988629732d0
       p(1,0)   =0.59935709367767d+04
       p(1,1)   =0.00000000000000d+00
       p(1,2)   =0.00000000000000d+00
       p(1,3)   =0.59935709367767d+04
       p(2,0)   =0.69204081266561d+04
       p(2,1)   =0.00000000000000d+00
       p(2,2)   =0.00000000000000d+00
       p(2,3)   =-.69204081266561d+04
       p(3,0)   =0.23714261728680d+04
       p(3,1)   =0.23139665477618d+04
       p(3,2)   =0.46211149158758d+03
       p(3,3)   =-.23595312785735d+03
       p(4,0)   =0.40920755112283d+04
       p(4,1)   =0.39805516309430d+04
       p(4,2)   =0.88990956044489d+03
       p(4,3)   =-.32916815948606d+03
       p(5,0)   =0.64504773793365d+04
       p(5,1)   =-.62945181787048d+04
       p(5,2)   =-.13520210520325d+04
       p(5,3)   =-.36171590253598d+03


c  standard event for comparison
 1    x1    =   0.24596552174024927d0
      x2    =   0.3807673281285489d0
       p(1,0)    = 0.17217586521817d+04
       p(1,1)    = 0.00000000000000d+00
       p(1,2)    = 0.00000000000000d+00
       p(1,3)    = -.17217586521817d+04
       p(2,0)    = 0.26653712968998d+04
       p(2,1)    = 0.00000000000000d+00
       p(2,2)    = 0.00000000000000d+00
       p(2,3)    = 0.26653712968998d+04
       p(3,0)    = 0.16491520021254d+04
       p(3,1)    = 0.18037203406290d+03
       p(3,2)    = 0.14294767298752d+03
       p(3,3)    = -.16330138450820d+04
       p(4,0)    = 0.23848858566907d+04
       p(4,1)    = -.17115982694816d+02
       p(4,2)    = 0.36567860802136d+02
       p(4,3)    = 0.23845440621084d+04
       p(5,0)    = 0.35309209026547d+03
       p(5,1)    = -.16325605136809d+03
       p(5,2)    = -.17951553378966d+03
       p(5,3)    = 0.19208242769174d+03


 200  format(6x,a6,d20.14)
 100  format(6x,' p(',i1,',',i1,')   =',d20.14)
 1100 format(6x,' s(',i1,',',i1,')   =',g20.14)


 999  continue

      if (out.eq.0) return



c 3 collinear to photon
c      y=y/10d0
c      call genbrems(p,1d0,y,.5d0,1d0,0d0,3,4,6,5,0)
c      write(*,*) ' Real radiation space point, y=',y
c      write(*,*) ' Real radiation phase space point, y = ',y

c 2 collinear to photon
c      omz=omz/10d0
c      z=1d0-omz
c      call genbrems(p,.5d0,1d0,z,1d0,0d0,2,3,6,5,0)
c      write(*,*) ' Real radiation phase space point, 1-z=',omz

c emitter 1 and collinear 6
      v=v/10d0
      call genbrems(p,.8d0,.5d0,.5d0,v,0d0,1,2,6,5,0)
      write(*,*) ' Real radiation space point, v=',v

c emitter 2 and collinear 6
c      v=v/10d0
c      call genbrems(p,.9d0,.5d0,.5d0,v,0d0,2,1,6,5,0)
c      write(*,*) ' Real radiation space point, v=',v


      write(*,200)  ' x1 = ',x1
      write(*,200)  ' x2 = ',x2
      do ext=1,6
        do vcomp=0,3
          write(*,100) ext,vcomp,p(ext,vcomp)
        enddo
      enddo

      call dets(p,sevent,6,0)
      do ext=1,5
        do ext2=ext+1,6
          write(*,1100) ext,ext2,sevent(ext,ext2)
        enddo
      enddo

      do ext=1,6
          write(*,1100) ext,ext, p(ext,0)*p(ext,0) -
     &      p(ext,1)*p(ext,1)-p(ext,2)*p(ext,2)-p(ext,3)*p(ext,3)
      enddo
      end




ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     mapping from n- into (n+1)-particle phase space             c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine genbrems(k,x,y,z,v,phi,em,sp,co,lnext,switch)
      implicit none

#include "mcparams.h"
#include "mccommon.h"

c local variables
c      integer maxch,maxg,maxe
c      parameter(maxch=10000,maxg=4,maxe=7)
      real*8 random(3),k(maxe,0:3),kt(maxe,0:3),m2,m
      real*8 kem(0:3),ksp(0:3),ktr(0:3),ck(0:3),ckt(0:3)
c      real*8 ksum(0:3),kj(maxe,0:3),y,h,z,f,v,c,x,kk(maxe,maxe)
      real*8 ksum(0:3),y,z,f,v,c,x,kk(maxe,maxe),phi
      integer i1,i2,j,em,sp,co,lnext,switch

      random(3)= phi/(2*pi)

      if(switch.gt.0)return
      if(em.eq.0.and.sp.eq.0.and.co.eq.0)return
c mapping from n- into (n+1)-particle phase space
      do i1=0,3
        kem(i1)=k(em,i1)
        ksp(i1)=k(sp,i1)
        ksum(i1)=kem(i1)+ksp(i1)
      enddo
      m2=ksum(0)**2-ksum(1)**2-ksum(2)**2-ksum(3)**2
      if(m2.le.0d0)then
        switch=34
        if(numout.lt.maxout.and.lnoutmc.ge.5)then
 100        format(/" event = ",i9,", gen = ",i4,", channel = ",i4,
     &        ", exit = ",i4,(a))
            write(nout,100) nevt,cogen,cocha,switch,
c          write(*,'(" event= ",i9,",",(a))'),nevt,
     &          ', genbrems: m2 <= 0'
          numout=numout+1
        endif
        return
      else
        m=sqrt(m2)
      endif
      if(em.ge.3.and.sp.ge.3)then
c final-state emitter with final-state spectator
c        y=1d0-h(random(1),powerexmap,0d0,0d0,1d0,switch)
c        z=1d0-h(random(2),powerexmap,0d0,0d0,1d0,switch)
        f=sqrt(y*z/(1d0-z))
c        write(*,*) 'genbrems f ',f,y,z
        ktr(0)=-f*f*m
        ktr(1)=f*m*dcos(2d0*pi*random(3))
        ktr(2)=f*m*dsin(2d0*pi*random(3))
        ktr(3)=-f*f*m
c        write(*,*) 'genbrems ktr ',ktr
        call transverse(ksum,ksp,ktr,switch)
c        write(*,*) 'genbrems ktr ',ktr
c        write(*,*) 'genbrems kem ',kem
c        write(*,*) 'genbrems ksp ',ksp
        do i1=0,3
          k(em,i1)=y*(1d0+z)*ksp(i1)+z*kem(i1)+(1d0-z)*ktr(i1)
          k(co,i1)=(1d0-z)*kem(i1)-y*z*ksp(i1)-(1d0-z)*ktr(i1)
          k(sp,i1)=(1d0-y)*ksp(i1)
        enddo
c final-state emitter with initial-state spectator
      elseif(em.ge.3.and.sp.le.2)then
c        z=1d0-h(random(2),powerexmap,0d0,0d0,1d0,switch)
        f=sqrt(z*(1d0-x)/(1d0-z)/x)
        ktr(0)=-f*f*m
        ktr(1)=f*m*dcos(2d0*pi*random(3))
        ktr(2)=f*m*dsin(2d0*pi*random(3))
        ktr(3)=-f*f*m
c ktr is orthogonal to spectator (not to emitter)
        call transverse(ksum,ksp,ktr,switch)
        do i1=0,3
          k(co,i1)=(1-z)*kem(i1)-(1d0-x)/x*z*ksp(i1)-(1d0-z)*ktr(i1)
          k(em,i1)=(1d0-x)/x*(1d0+z)*ksp(i1)+z*kem(i1)
     *      +(1d0-z)*ktr(i1)
          k(sp,i1)=ksp(i1)/x
        enddo
c initial-state emitter with final-state spectator
      elseif(em.le.2.and.sp.ge.3)then
c        z=1d0-h(random(2),powerexmap,0d0,0d0,1d0,switch)
        f=sqrt((1d0-z)*(1d0-x)/z/x)
        ktr(0)=-f*f*m
        ktr(1)=f*m*dcos(2d0*pi*random(3))
        ktr(2)=f*m*dsin(2d0*pi*random(3))
        ktr(3)=-f*f*m
        call transverse(ksum,kem,ktr,switch)
        do i1=0,3
          k(co,i1)=(1d0-x)/x*(2d0-z)*kem(i1)+(1d0-z)*ksp(i1)
     *      +z*ktr(i1)
          k(sp,i1)=z*ksp(i1)-(1d0-x)/x*(1d0-z)*kem(i1)-z*ktr(i1)
          k(em,i1)=kem(i1)/x
        enddo
c initial-state emitter with initial-state spectator
      elseif(em.le.2.and.sp.le.2)then
        do i1=3,lnext
        do i2=0,3
          kt(i1,i2)=k(i1,i2)
        enddo
        enddo
c        v=random(2)*(1d0-x)
        f=sqrt(v*(1d0-x-v)/x)
        ktr(0)=0d0
        ktr(1)=f*m*dcos(2d0*pi*random(3))
        ktr(2)=f*m*dsin(2d0*pi*random(3))
        ktr(3)=0d0
        call transverse(ksum,kem,ktr,switch)
        do i1=0,3
          ck(i1)=(x+v)/x*kem(i1)+(1d0-v)*ksp(i1)-ktr(i1)
          ckt(i1)=kem(i1)+ksp(i1)
        enddo
        do i1=0,3
          k(co,i1)=v*ksp(i1)+(1d0-x-v)/x*kem(i1)+ktr(i1)
          k(em,i1)=kem(i1)/x
        enddo
        do j=3,lnext
        if(j.ne.co)then
          c=ktr(0)*kt(j,0)-ktr(1)*kt(j,1)-ktr(2)*kt(j,2)
     *      -ktr(3)*kt(j,3)
          kk(em,sp)=kem(0)*ksp(0)-kem(1)*ksp(1)-kem(2)*ksp(2)
     *      -kem(3)*ksp(3)
          kk(em,j)=kt(j,0)*kem(0)-kt(j,1)*kem(1)-kt(j,2)*kem(2)
     *      -kt(j,3)*kem(3)
          kk(sp,j)=kt(j,0)*ksp(0)-kt(j,1)*ksp(1)-kt(j,2)*ksp(2)
     *      -kt(j,3)*ksp(3)
          do i1=0,3
            k(j,i1)=kt(j,i1)
     *        -((2d0*x+v)*kk(em,j)+(2d0-v)*x*kk(sp,j)-x*c)
     *         /(4d0*x+v-x*v)/kk(em,sp)*(ck(i1)+ckt(i1))
     *        +(kk(em,j)+kk(sp,j))/kk(em,sp)*ck(i1)
          enddo
        endif
        enddo
      endif
      end


