************************************************************************
        subroutine calcform_HWW4f(F0,F1,Fgd,Fgnd,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for WW-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    up       anti-down     down     anti-up
*-----------------------------------------------------------------------
*       13.11.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        complex*16 v,cv
        COMPLEX*16 F0(13,-1:1,-1:1),F1(13,-1:1,-1:1),pw12,pw34
        COMPLEX*16 Fgd(13,-1:1,-1:1),Fgnd(13,-1:1,-1:1)
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(s12.lt.0d0))) then
          pw12 = 1d0/(s12-mw2)
        else
          pw12 = 1d0/(s12-cmw2)
        endif
        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(s34.lt.0d0))) then
          pw34 = 1d0/(s34-mw2)
        else
          pw34 = 1d0/(s34-cmw2)
        endif

        F0(1,-1,-1) = F0(1,-1,-1)+(PW12*PW34*XMW)/(2D0*XSW*XSW2)

	if (qferm.eq.1) call add_HWW4f_ferm(F1,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)

	if (qbos.eq.1) then
	  call add_HWW4f_self(F1,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
	  call add_HWW4f_vert(F1,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
	  call add_HWW4f_box(F1,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
	  call add_HWW4f_pent(F1,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
	elseif (qbos.eq.2) then
	  call add_HWW4f_self_bgf(F1,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
	  call add_HWW4f_vert_bgf(F1,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
	  call add_HWW4f_box_bgf(F1,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
	  call add_HWW4f_pent(F1,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
	endif

	if (qqcddiag.eq.1) call add_HWW4f_qcdv(Fgd,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)

	if (qqcdnondiag.eq.1) then
	  call add_HWW4f_qcdv(Fgnd,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
	  call add_HWW4f_gpent(Fgnd,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
	endif

	if (qsoft.eq.1) call add_HWW4f_endp(F1,Fgd,Fgnd,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)

	end

************************************************************************
        subroutine add_HWW4f_ferm(F,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for WW-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    up       anti-down     down     anti-up
*	fermion-loop contributions
*-----------------------------------------------------------------------
*       15.12.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pw12,pw34
        COMPLEX*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
        complex*16 dZuur,dZuul,dZddr,dZddl
        complex*16 ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl
	integer i

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/xrenc_ferm/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &         dZuur,dZuul,dZddr,dZddl,
     &         ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl

	do 100 i=1,3

c*** self-energies
c-----------------

C       Process: S1F21aF22F23aF24,   Model: SM4f

C       G(T3,N25,FULL)
        CALL xB012345_(S12,NULL,XML2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*XMW*XSW2**(-2)*(12D0*B2(0,0)+S12+
     &  6D0*B1(1)*S12+6D0*B2(1,1)*S12-3D0*XML2(I)))/(48D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N24,FULL)
        CALL xB012345_(S12,XMQP2(I),XMQM2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*XMW*XSW2**(-2)*(12D0*B2(0,0)+S12+
     &  6D0*B1(1)*S12+6D0*B2(1,1)*S12-3D0*XMQM2(I)-3D0*XMQP2(I)))/
     &  (16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N49,FULL)
        CALL xB012345_(S34,NULL,XML2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*XMW*XSW2**(-2)*(12D0*B2(0,0)+S34+
     &  6D0*B1(1)*S34+6D0*B2(1,1)*S34-3D0*XML2(I)))/(48D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N48,FULL)
        CALL xB012345_(S34,XMQM2(I),XMQP2(I),B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*XMW*XSW2**(-2)*(12D0*B2(0,0)+S34+
     &  6D0*B1(1)*S34+6D0*B2(1,1)*S34-3D0*XMQM2(I)-3D0*XMQP2(I)))/
     &  (16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE


c*** vertex corrections
c----------------------

	qeps = 1d0

C       Process: S1F21aF22F23aF24,   Model: SM4f

C       G(T9,N310,FULL)+G(T9,N324,FULL)+G(T9,N336,FULL)+G(T9,N348,
C       FULL)
        CALL xC01234_(S12,MH2,S34,NULL,XML2(I),XML2(I),
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)

        PRE = -((ALPHA*PW12*PW34*XSW2**(-2)*XML2(I))/(32D0*PI*XMW*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0-8D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13-QEPS*
     &  S13-S14-QEPS*S14-S23+QEPS*S23-S24+QEPS*S24)-4D0*C2(2,2)*S34+
     &  C1(2)*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(6,-1,-1) = F(6,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))
        F(7,-1,-1) = F(7,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(8,-1,-1) = F(8,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))

C       G(T9,N311,FULL)+G(T9,N325,FULL)+G(T9,N337,FULL)+G(T9,N349,
C       FULL)
        CALL xC01234_(S12,MH2,S34,XMQM2(I),XMQP2(I),XMQP2(I),
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)

        PRE = -((3D0*ALPHA*PW12*PW34*XSW2**(-2)*XMQP2(I))/(32D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0-8D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13+QEPS*
     &  S13-S14+QEPS*S14-S23-QEPS*S23-S24-QEPS*S24)-4D0*C2(2,2)*S34+
     &  C1(2)*(S13+QEPS*S13+S14+QEPS*S14+S23-QEPS*S23+S24-QEPS*S24-
     &  2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))
        F(6,-1,-1) = F(6,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(7,-1,-1) = F(7,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))
        F(8,-1,-1) = F(8,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))

C       G(T9,N309,FULL)+G(T9,N323,FULL)+G(T9,N335,FULL)+G(T9,N347,
C       FULL)
        CALL xC01234_(S12,MH2,S34,XMQP2(I),XMQM2(I),XMQM2(I),
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)

        PRE = -((3D0*ALPHA*PW12*PW34*XSW2**(-2)*XMQM2(I))/(32D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0-8D0*C2(0,0)-4D0*C2(1,1)*
     &  S12+4D0*C2(1,2)*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13-QEPS*
     &  S13-S14-QEPS*S14-S23+QEPS*S23-S24+QEPS*S24)-4D0*C2(2,2)*S34+
     &  C1(2)*(S13-QEPS*S13+S14-QEPS*S14+S23+QEPS*S23+S24+QEPS*S24-
     &  2D0*S34))
        F(5,-1,-1) = F(5,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(6,-1,-1) = F(6,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))
        F(7,-1,-1) = F(7,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(1)*(1D0+
     &  QEPS)+C1(2)*(1D0-QEPS))
        F(8,-1,-1) = F(8,-1,-1)-2D0*PRE*(4D0*C2(1,2)+C1(2)*(1D0+
     &  QEPS)+C1(1)*(1D0-QEPS))

100	continue

c*** counterterms
c----------------

        F(1,-1,-1) = F(1,-1,-1)+(PW12*PW34*XMW)/(2D0*XSW*XSW2)
     &		*( ct_hww + 2d0*ct_wud 
     &		   -2d0*dZw + dmw2*pw12 + dmw2*pw34 )

	end

************************************************************************
        subroutine add_HWW4f_self(F,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for WW-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    up       anti-down     down     anti-up
*	self-energy contributions
*	boson loops only
*-----------------------------------------------------------------------
*       23.12.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pw12,pw34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
        complex*16 dZuur,dZuul,dZddr,dZddl
        complex*16 ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl
	integer i

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/xrenc/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &         dZuur,dZuul,dZddr,dZddl,
     &         ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl

C       Process: S1F21aF22F23aF24,   Model: SM4f

C       G(T1,N5,FULL)+G(T2,N11,FULL)

C       G(T1,N2,FULL)+G(T2,N8,FULL)
        A0 = xA0_(XMH2)

        PRE = -((A0*ALPHA*PW12*PW34*(PW12+PW34)*XMW*XSW2**(-2))/
     &  (32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N1,FULL)+G(T1,N4,FULL)+G(T2,N10,FULL)+G(T2,N7,FULL)
        A0 = xA0_(XMW2)

        PRE = -((ALPHA*PW12*PW34*(PW12+PW34)*XMW*(7D0*A0-4D0*XMW2)*
     &  XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N3,FULL)+G(T1,N6,FULL)+G(T2,N12,FULL)+G(T2,N9,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((ALPHA*PW12*PW34*(PW12+PW34)*XMW*(A0*(1D0+12D0*
     &  XCW2)-8D0*XCW2*XMZ2)*XSW2**(-2))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N14,FULL)+G(T3,N18,FULL)+G(T3,N20,FULL)+G(T3,N28,FULL)+
C       G(T3,N32,FULL)+G(T3,N34,FULL)+G(T3,N35,FULL)
        CALL xB012345_(S12,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*XMW*(16D0*B2(0,0)+S12+2D0*B1(1)*
     &  S12+2D0*B2(1,1)*S12-3D0*XMW2+B0*(5D0*S12-XMW2)))/(8D0*PI*
     &  XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N13,FULL)+G(T3,N16,FULL)+G(T3,N26,FULL)+G(T3,N30,FULL)
        CALL xB012345_(S12,XMW2,XMH2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((ALPHA*PW12**2*PW34*XMW*(-(B2(0,0))+B0*XMW2)*XSW2**
     &  (-2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N15,FULL)+G(T3,N17,FULL)+G(T3,N21,FULL)+G(T3,N27,FULL)+
C       G(T3,N29,FULL)+G(T3,N31,FULL)+G(T3,N33,FULL)+G(T3,N36,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*XMW*XSW2**(-2)*(2D0*B1(1)*S12*
     &  XCW2+2D0*B2(1,1)*S12*XCW2+B2(0,0)*(1D0+16D0*XCW2)+XCW2*(S12-
     &  3D0*XMW2-3D0*XMZ2)+(B0*(5D0*S12*XCW2**2-XMW2*XSW2**2))/
     &  XCW2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N19,FULL)

C       G(T4,N38,FULL)+G(T4,N43,FULL)+G(T4,N44,FULL)+G(T4,N52,FULL)+
C       G(T4,N56,FULL)+G(T4,N58,FULL)+G(T4,N59,FULL)
        CALL xB012345_(S34,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*XMW*(16D0*B2(0,0)+S34+2D0*B1(1)*
     &  S34+2D0*B2(1,1)*S34-3D0*XMW2+B0*(5D0*S34-XMW2)))/(8D0*PI*
     &  XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N37,FULL)+G(T4,N40,FULL)+G(T4,N50,FULL)+G(T4,N54,FULL)
        CALL xB012345_(S34,XMW2,XMH2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((ALPHA*PW12*PW34**2*XMW*(-(B2(0,0))+B0*XMW2)*XSW2**
     &  (-2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N39,FULL)+G(T4,N42,FULL)+G(T4,N45,FULL)+G(T4,N51,FULL)+
C       G(T4,N53,FULL)+G(T4,N55,FULL)+G(T4,N57,FULL)+G(T4,N60,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*XMW*XSW2**(-2)*(2D0*B1(1)*S34*
     &  XCW2+2D0*B2(1,1)*S34*XCW2+B2(0,0)*(1D0+16D0*XCW2)+XCW2*(S34-
     &  3D0*XMW2-3D0*XMZ2)+(B0*(5D0*S34*XCW2**2-XMW2*XSW2**2))/
     &  XCW2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N41,FULL)

c*** counterterms
c----------------

        F(1,-1,-1) = F(1,-1,-1)+(PW12*PW34*XMW)/(2D0*XSW*XSW2)
     &		*( -2d0*dZw + dmw2*pw12 + dmw2*pw34 ) 

	end

************************************************************************
        subroutine add_HWW4f_vert(F,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for WW-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    up       anti-down     down     anti-up
*	vertex corrections             
*	boson loops only
*-----------------------------------------------------------------------
*       27.12.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(3)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pw12,pw34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
        complex*16 dZuur,dZuul,dZddr,dZddl
        complex*16 ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl
        complex*16 guu,gdd            
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)
	integer i

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/xrenc/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &         dZuur,dZuul,dZddr,dZddl,
     &         ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl
        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

C       Process: S1F21aF22F23aF24,   Model: SM4f

C       G(T8,N56,FULL)
        CALL xB012345_(MH2,XMH2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((3D0*ALPHA*B0*PW12*PW34*XMH2*XSW2**(-2))/(64D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T8,N55,FULL)+G(T8,N58,FULL)
        CALL xB012345_(MH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*PW12*PW34*(-(8D0*XMW)+(B0*(XMH2+12D0*XMW2))/
     &  XMW)*XSW2**(-2))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T8,N57,FULL)+G(T8,N59,FULL)
        CALL xB012345_(MH2,XMZ2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*PW12*PW34*(-(16D0*XMW)+(B0*(XMH2+24D0*XMW2))/
     &  XMW)*XSW2**(-2))/(64D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T10,N63,FULL)
        CALL xB012345_(S12,NULL,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T10,N65,FULL)
        CALL xB012345_(S12,XMW2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T10,N64,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW)/(16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N60,FULL)
        CALL xB012345_(S34,NULL,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N62,FULL)
        CALL xB012345_(S34,XMW2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N61,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW)/(16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N14,FULL)
        CALL xC01234_(RMF2(1),MH2,T11,CMF2(1),XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW34*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*
     &  QF(1)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N13,FULL)
        CALL xC01234_(RMF2(1),MH2,T11,CMF2(2),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW34*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N3,FULL)+G(T1,N7,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(2),CMF2(1),NULL,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(1)*ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S12+
     &  C1(2)*S12+C2(1,2)*S12)*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N4,FULL)+G(T1,N8,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(2),CMF2(1),XMZ2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S12+C1(2)*
     &  S12+C2(1,2)*S12)*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2))/(8D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N2,FULL)+G(T1,N6,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(2),CMF2(2),XMW2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S12+C1(2)*
     &  S12+C2(1,2)*S12)*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2))/(8D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N1,FULL)+G(T1,N5,FULL)
        CALL xC01234_(RMF2(2),RMF2(1),S12,NULL,CMF2(2),XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = (QF(2)*ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)-C1(1)*S12-
     &  C1(2)*S12-C2(1,2)*S12-C2(2,2)*S12-C0*S12)*XMW)/(4D0*PI*XSW*
     &  XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N12,FULL)
        CALL xC01234_(RMF2(2),MH2,T12,CMF2(1),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW34*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N9,FULL)
        CALL xC01234_(RMF2(2),S12,RMF2(1),NULL,CMF2(2),CMF2(1),
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(1)*QF(2)*ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S12+C1(2)*S12+C2(1,2)*S12+C0*S12)*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N15,FULL)
        CALL xC01234_(RMF2(3),MH2,T13,CMF2(4),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW12*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N53,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),NULL,CMF2(3),CMF2(4),
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(3)*QF(4)*ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S34+C1(2)*S34+C2(1,2)*S34+C0*S34)*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N45,FULL)+G(T7,N49,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),CMF2(3),NULL,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = (QF(3)*ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S34+
     &  C1(2)*S34+C2(1,2)*S34)*XMW)/(4D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N46,FULL)+G(T7,N50,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),CMF2(3),XMZ2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S34+C1(2)*
     &  S34+C2(1,2)*S34)*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2))/(8D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N48,FULL)+G(T7,N52,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),CMF2(4),XMW2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)+C1(1)*S34+C1(2)*
     &  S34+C2(1,2)*S34)*XMW*XSW2**(-2)*(1D0-2D0*QF(4)*XSW2))/(8D0*
     &  PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N47,FULL)+G(T7,N51,FULL)
        CALL xC01234_(RMF2(4),RMF2(3),S34,NULL,CMF2(4),XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(4)*ALPHA*PW12*PW34*(1D0-6D0*C2(0,0)-C1(1)*S34-
     &  C1(2)*S34-C2(1,2)*S34-C2(2,2)*S34-C0*S34)*XMW)/(4D0*PI*XSW*
     &  XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N10,FULL)
        CALL xC01234_(S12,RMF2(1),RMF2(2),CMF2(2),CMF2(1),XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)-C1(1)*S12-C1(2)*S12-
     &  C2(1,1)*S12-C2(1,2)*S12)*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0+2D0*QF(2)*XSW2))/(16D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T5,N25,FULL)+G(T5,N26,FULL)+G(T5,N31,FULL)+G(T5,N34,FULL)+
C       G(T5,N37,FULL)+G(T5,N41,FULL)
        CALL xC01234_(S12,MH2,S34,NULL,XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)
        K(1) = C1(1)+C1(2)+2D0*C2(1,2)

        PRE = -((ALPHA*PW12*PW34*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(7D0-40D0*C2(0,0)-6D0*C2(1,1)*
     &  S12+6D0*C2(1,2)*(S13+S14+S23+S24)-C1(1)*(2D0*S12-S13-S14-
     &  S23-S24)-6D0*C2(2,2)*S34+C1(2)*(S13+S14+S23+S24-2D0*S34)+C0*
     &  (5D0*S13+4D0*S14+4D0*S23+3D0*S24-T12-T14+XMH2))
        F(5,-1,-1) = F(5,-1,-1)+8D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+8D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+8D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+8D0*K(1)*PRE

C       G(T5,N30,FULL)+G(T5,N33,FULL)+G(T5,N36,FULL)+G(T5,N39,FULL)
        CALL xC01234_(S12,MH2,S34,XMH2,XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)
        K(1) = 2D0*C1(1)*XMW+2D0*C1(2)*XMW+(C2(1,2)*(XMH2+2D0*
     &  XMW2))/XMW

        PRE = -((ALPHA*PW12*PW34*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0*C0*XMW*XMW2-(C2(0,0)*(XMH2+
     &  2D0*XMW2))/XMW)
        F(5,-1,-1) = F(5,-1,-1)+K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(1)*PRE

C       G(T5,N22,FULL)+G(T5,N23,FULL)
        CALL xC01234_(S12,MH2,S34,XMW2,XMH2,XMH2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)

        PRE = -((3D0*ALPHA*PW12*PW34*XMH2*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(C0*XMW-(C2(0,0))/XMW)
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*PRE)/XMW
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*PRE)/XMW
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*PRE)/XMW
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*PRE)/XMW

C       G(T5,N17,FULL)+G(T5,N18,FULL)+G(T5,N19,FULL)+G(T5,N20,FULL)+
C       G(T5,N21,FULL)+G(T5,N28,FULL)+G(T5,N29,FULL)
        CALL xC01234_(S12,MH2,S34,XMW2,XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)
        K(1) = XCW2+XSW2
        K(2) = XCW2*XMH2+18D0*XCW2*XMW2+2D0*XMW2*XSW2
        K(3) = 8D0*C0*XMW-(2D0*C1(1)*XMW*(XCW2+XSW2))/XCW2-(2D0*
     &  C1(2)*XMW*(XCW2+XSW2))/XCW2-(C2(1,2)*(XCW2*XMH2+18D0*XCW2*
     &  XMW2+2D0*XMW2*XSW2))/(XCW2*XMW)

        PRE = -((ALPHA*PW12*PW34*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(6D0*XMW-4D0*C2(1,1)*S12*XMW+
     &  4D0*C2(1,2)*(S13+S14+S23+S24)*XMW-C1(1)*(2D0*S12-S13-S14-
     &  S23-S24)*XMW-4D0*C2(2,2)*S34*XMW+C1(2)*(S13+S14+S23+S24-2D0*
     &  S34)*XMW-(C2(0,0)*(XCW2*XMH2+34D0*XCW2*XMW2+2D0*XMW2*XSW2))/
     &  (XCW2*XMW)+C0*XCW2**(-2)*XMW*(5D0*S13*XCW2**2+5D0*S14*XCW2**
     &  2+5D0*S23*XCW2**2+5D0*S24*XCW2**2+2D0*XMW2*XSW2**2))
        F(5,-1,-1) = F(5,-1,-1)-K(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-K(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-K(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-K(3)*PRE

C       G(T5,N24,FULL)+G(T5,N27,FULL)+G(T5,N32,FULL)+G(T5,N35,FULL)+
C       G(T5,N38,FULL)+G(T5,N40,FULL)+G(T5,N42,FULL)
        CALL xC01234_(S12,MH2,S34,XMZ2,XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)
        K(1) = XCW2-3D0*XSW2
        K(2) = XMH2+18D0*XCW2*XMW2+2D0*XMW2*XSW2
        K(3) = 8D0*C0*XMW*(XCW2+XSW2)-2D0*C1(1)*XMW*(XCW2-3D0*XSW2)-
     &  2D0*C1(2)*XMW*(XCW2-3D0*XSW2)-(C2(1,2)*(XMH2+18D0*XCW2*XMW2+
     &  2D0*XMW2*XSW2))/XMW

        PRE = -((ALPHA*PW12*PW34*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(C1(1)*(2D0*S12-S13-S14-S23-
     &  S24)*XCW2*XMW)+C1(2)*(S13+S14+S23+S24-2D0*S34)*XCW2*XMW-2D0*
     &  C2(1,1)*S12*XMW*(2D0*XCW2-XSW2)+2D0*C2(1,2)*(S13+S14+S23+
     &  S24)*XMW*(2D0*XCW2-XSW2)-2D0*C2(2,2)*S34*XMW*(2D0*XCW2-
     &  XSW2)+XMW*(6D0*XCW2-XSW2)-(C2(0,0)*(XMH2+34D0*XCW2*XMW2-6D0*
     &  XMW2*XSW2))/XMW+(C0*XMW*(5D0*S13*XCW2**2+5D0*S14*XCW2**2+
     &  5D0*S23*XCW2**2+5D0*S24*XCW2**2+S14*XCW2*XSW2+S23*XCW2*XSW2+
     &  2D0*S24*XCW2*XSW2+T12*XCW2*XSW2+T14*XCW2*XSW2+XMH2*XSW2**
     &  2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)-K(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-K(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-K(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-K(3)*PRE

C       G(T7,N54,FULL)
        CALL xC01234_(S34,RMF2(4),RMF2(3),CMF2(3),CMF2(4),XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)-C1(1)*S34-C1(2)*S34-
     &  C2(1,1)*S34-C2(1,2)*S34)*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*
     &  XSW2)*(1D0-2D0*QF(4)*XSW2))/(16D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N11,FULL)
        CALL xC01234_(T12,MH2,RMF2(2),CMF2(2),XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW34*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*
     &  QF(2)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N16,FULL)
        CALL xC01234_(T13,MH2,RMF2(3),CMF2(3),XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW12*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*
     &  QF(3)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T6,N43,FULL)
        CALL xC01234_(T14,MH2,RMF2(4),CMF2(3),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW12*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T6,N44,FULL)
        CALL xC01234_(T14,MH2,RMF2(4),CMF2(4),XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW12*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*
     &  QF(4)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

c*** counterterms
c----------------

        F(1,-1,-1) = F(1,-1,-1)+(PW12*PW34*XMW)/(2D0*XSW*XSW2)
     &		*( ct_hww + 2d0*ct_wud )

	end

************************************************************************
        subroutine add_HWW4f_box(F,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for WW-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    up       anti-down     down     anti-up
*	box corrections             
*-----------------------------------------------------------------------
*       27.12.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(3)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pw12,pw34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        COMPLEX*16 xD0_,D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        COMPLEX*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)
	integer i

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

C       Process: S1F21aF22F23aF24,   Model: SM4f

C       G(T1,N2,FULL)+G(T1,N4,FULL)
        CALL xD012345_(RMF2(1),RMF2(2),MH2,S34,T12,S12,NULL,CMF2(1),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((QF(1)*ALPHA*PW34*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(28D0*D2(0,0))-5D0*D2(1,2)*
     &  S12-5D0*D2(2,2)*S12+4D0*D1(1)*(S13+S14)+5D0*D2(1,3)*(S13+
     &  S14)+4D0*D0*(S13+S14)+5D0*D2(2,3)*(S13+S14+S23+S24)-5D0*
     &  D2(3,3)*S34+D1(3)*(S13+S14-4D0*S34)-D1(2)*(2D0*MH2-S12-4D0*
     &  S13-4D0*S14-2D0*S23-2D0*S24-2D0*T12))
        F(5,-1,-1) = F(5,-1,-1)+8D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+8D0*(D1(2)+D2(2,3))*PRE
        F(7,-1,-1) = F(7,-1,-1)+8D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+8D0*(D1(2)+D2(2,3))*PRE

C       G(T6,N14,FULL)
        CALL xD012345_(RMF2(1),MH2,S34,RMF2(2),S12,T11,CMF2(1),XMZ2,
     &  XMZ2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2))/
     &  (16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))+2D0*D2(1,3)*
     &  S12+D1(1)*(S12-S13-S14)-2D0*D1(3)*(S23+S24)-2D0*D2(2,3)*
     &  (S23+S24)-D1(2)*(3D0*S23+3D0*S24+S34)-2D0*D2(2,2)*T11+2D0*
     &  D2(1,2)*(MH2-T11))
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE

C       G(T6,N16,FULL)+G(T6,N18,FULL)
        CALL xD012345_(RMF2(1),MH2,S34,RMF2(2),S12,T11,CMF2(2),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW34*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2))/
     &  (32D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(4D0*D1(3)*(S23+S24)+(D2(1,3)*
     &  S12*(-(2D0*XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(D2(2,3)*(S23+S24)*
     &  (-(2D0*XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(D2(2,2)*T11*(-(2D0*
     &  XCW)+XSW)*(2D0*XCW+XSW))/XCW2+(D2(1,2)*(MH2-T11)*(-(2D0*
     &  XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(4D0*D2(0,0)*(-(6D0*XCW2)+
     &  XSW2))/XCW2-(2D0*D1(1)*(S12*XCW2-S13*XCW2-S14*XCW2-MH2*XSW2+
     &  T11*XSW2))/XCW2+(2D0*D1(2)*(3D0*S23*XCW2+3D0*S24*XCW2+S34*
     &  XCW2-T11*XSW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)-8D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)
        F(7,-1,-1) = F(7,-1,-1)-8D0*(D1(1)+D2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)-4D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)

C       G(T6,N15,FULL)+G(T6,N17,FULL)
        CALL xD012345_(RMF2(2),RMF2(1),MH2,S34,T11,S12,NULL,CMF2(2),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (QF(2)*ALPHA*PW34*XMW)/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(28D0*D2(0,0))-5D0*D2(1,2)*
     &  S12-5D0*D2(2,2)*S12+4D0*D1(1)*(S23+S24)+5D0*D2(1,3)*(S23+
     &  S24)+4D0*D0*(S23+S24)+5D0*D2(2,3)*(S13+S14+S23+S24)-5D0*
     &  D2(3,3)*S34+D1(3)*(S23+S24-4D0*S34)-D1(2)*(2D0*MH2-S12-2D0*
     &  S13-2D0*S14-4D0*S23-4D0*S24-2D0*T11))
        F(5,-1,-1) = F(5,-1,-1)+8D0*(D1(2)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+8D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(7,-1,-1) = F(7,-1,-1)+8D0*(D1(2)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+8D0*(D1(3)+D2(1,3)+D2(2,3))*PRE

C       G(T1,N3,FULL)+G(T1,N5,FULL)
        CALL xD012345_(RMF2(2),MH2,S34,RMF2(1),S12,T12,CMF2(1),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW34*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2))/
     &  (32D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(4D0*D1(3)*(S13+S14)+(D2(1,3)*
     &  S12*(-(2D0*XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(D2(2,3)*(S13+S14)*
     &  (-(2D0*XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(D2(2,2)*T12*(-(2D0*
     &  XCW)+XSW)*(2D0*XCW+XSW))/XCW2+(D2(1,2)*(MH2-T12)*(-(2D0*
     &  XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(4D0*D2(0,0)*(-(6D0*XCW2)+
     &  XSW2))/XCW2-(2D0*D1(1)*(S12*XCW2-S23*XCW2-S24*XCW2-MH2*XSW2+
     &  T12*XSW2))/XCW2+(2D0*D1(2)*(3D0*S13*XCW2+3D0*S14*XCW2+S34*
     &  XCW2-T12*XSW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)-4D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)
        F(6,-1,-1) = F(6,-1,-1)-8D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)
        F(8,-1,-1) = F(8,-1,-1)-8D0*(D1(1)+D2(1,2))*PRE

C       G(T1,N1,FULL)
        CALL xD012345_(RMF2(2),MH2,S34,RMF2(1),S12,T12,CMF2(2),XMZ2,
     &  XMZ2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2))/
     &  (16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))+2D0*D2(1,3)*
     &  S12-2D0*D1(3)*(S13+S14)-2D0*D2(2,3)*(S13+S14)+D1(1)*(S12-
     &  S23-S24)-D1(2)*(3D0*S13+3D0*S14+S34)-2D0*D2(2,2)*T12+2D0*
     &  D2(1,2)*(MH2-T12))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE

C       G(T7,N23,FULL)
        CALL xD012345_(RMF2(3),MH2,S12,RMF2(4),S34,T13,CMF2(3),XMZ2,
     &  XMZ2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW12*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2))/
     &  (16D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(12D0*D2(0,0)+2D0*D1(3)*(S14+
     &  S24)+2D0*D2(2,3)*(S14+S24)+D1(2)*(S12+3D0*S14+3D0*S24)-2D0*
     &  D2(1,3)*S34+D1(1)*(S13+S23-S34)+2D0*D2(2,2)*T13-2D0*D2(1,2)*
     &  (MH2-T13))
        F(5,-1,-1) = F(5,-1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE

C       G(T7,N20,FULL)+G(T7,N22,FULL)
        CALL xD012345_(RMF2(3),MH2,S12,RMF2(4),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW12*XMW*XSW2**(-2)*(1D0-2D0*QF(4)*XSW2))/
     &  (32D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(4D0*D1(3)*(S14+S24)-(D2(2,3)*
     &  (S14+S24)*(-(2D0*XCW)+XSW)*(2D0*XCW+XSW))/XCW2+(D2(1,3)*S34*
     &  (-(2D0*XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(D2(2,2)*T13*(-(2D0*
     &  XCW)+XSW)*(2D0*XCW+XSW))/XCW2+(D2(1,2)*(MH2-T13)*(-(2D0*
     &  XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(4D0*D2(0,0)*(-(6D0*XCW2)+
     &  XSW2))/XCW2+(2D0*D1(2)*(S12*XCW2+3D0*S14*XCW2+3D0*S24*XCW2-
     &  T13*XSW2))/XCW2+(2D0*D1(1)*(S13*XCW2+S23*XCW2-S34*XCW2+MH2*
     &  XSW2-T13*XSW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)-8D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-8D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)
        F(8,-1,-1) = F(8,-1,-1)-4D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)

C       G(T9,N27,FULL)+G(T9,N29,FULL)
        CALL xD012345_(RMF2(3),S12,MH2,RMF2(4),S34,T14,CMF2(3),NULL,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (QF(3)*ALPHA*PW12*XMW)/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(28D0*D2(0,0))-4D0*D1(1)*(S13+
     &  S23)-5D0*D2(1,2)*(S13+S23)+5D0*D2(1,3)*S34-5D0*D2(2,2)*T14-
     &  2D0*D1(2)*(S12+3D0*S13+3D0*S23+T14)+5D0*D2(2,3)*(MH2-T14)+
     &  2D0*D1(3)*(MH2-S14-S24+S34-T14))
        F(5,-1,-1) = F(5,-1,-1)-8D0*(D2(1,2)+D2(2,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-8D0*(D2(1,2)+D2(2,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+8D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+8D0*(D1(3)+D2(2,3))*PRE

C       G(T9,N28,FULL)+G(T9,N30,FULL)
        CALL xD012345_(RMF2(3),S12,MH2,RMF2(4),S34,T14,CMF2(3),XMZ2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW12*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2))/
     &  (32D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(4D0*D1(1)*(S13+S23)-(D2(1,2)*
     &  (S13+S23)*(-(2D0*XCW)+XSW)*(2D0*XCW+XSW))/XCW2+(D2(1,3)*S34*
     &  (-(2D0*XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(D2(2,2)*T14*(-(2D0*
     &  XCW)+XSW)*(2D0*XCW+XSW))/XCW2+(D2(2,3)*(MH2-T14)*(-(2D0*
     &  XCW)+XSW)*(2D0*XCW+XSW))/XCW2-(4D0*D2(0,0)*(-(6D0*XCW2)+
     &  XSW2))/XCW2+(2D0*D1(2)*(S12*XCW2+3D0*S13*XCW2+3D0*S23*XCW2-
     &  T14*XSW2))/XCW2+(2D0*D1(3)*(S14*XCW2+S24*XCW2-S34*XCW2+MH2*
     &  XSW2-T14*XSW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)-4D0*PRE*(-(2D0*D2(1,2))-2D0*D2(2,2)+
     &  (D1(1)*(XCW2+XSW2))/XCW2)
        F(6,-1,-1) = F(6,-1,-1)-4D0*PRE*(-(2D0*D2(1,2))-2D0*D2(2,2)+
     &  (D1(1)*(XCW2+XSW2))/XCW2)
        F(7,-1,-1) = F(7,-1,-1)-8D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)-8D0*(D1(3)+D2(2,3))*PRE

C       G(T9,N31,FULL)
        CALL xD012345_(RMF2(3),S12,MH2,RMF2(4),S34,T14,CMF2(4),XMW2,
     &  XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW12*XMW*XSW2**(-2)*(1D0-2D0*QF(4)*XSW2))/
     &  (16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(12D0*D2(0,0))-2D0*D1(1)*(S13+
     &  S23)-2D0*D2(1,2)*(S13+S23)-D1(2)*(S12+3D0*S13+3D0*S23)+2D0*
     &  D2(1,3)*S34-D1(3)*(S14+S24-S34)-2D0*D2(2,2)*T14+2D0*D2(2,3)*
     &  (MH2-T14))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(3)+D2(2,3))*PRE

C       G(T7,N19,FULL)+G(T7,N21,FULL)
        CALL xD012345_(RMF2(4),RMF2(3),MH2,S12,T13,S34,NULL,CMF2(4),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((QF(4)*ALPHA*PW12*XMW)/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(28D0*D2(0,0))-5D0*D2(3,3)*
     &  S12+4D0*D1(1)*(S14+S24)+5D0*D2(1,3)*(S14+S24)+4D0*D0*(S14+
     &  S24)+5D0*D2(2,3)*(S13+S14+S23+S24)-D1(3)*(4D0*S12-S14-S24)-
     &  5D0*D2(1,2)*S34-5D0*D2(2,2)*S34-D1(2)*(2D0*MH2-2D0*S13-4D0*
     &  S14-2D0*S23-4D0*S24-S34-2D0*T13))
        F(5,-1,-1) = F(5,-1,-1)+8D0*(D1(2)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+8D0*(D1(2)+D2(2,3))*PRE
        F(7,-1,-1) = F(7,-1,-1)+8D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+8D0*(D1(3)+D2(1,3)+D2(2,3))*PRE

C       G(T5,N13,FULL)
        CALL xD012345_(S12,RMF2(3),MH2,RMF2(4),T13,T14,CMF2(4),
     &  CMF2(3),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW12*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*
     &  QF(3)*XSW2)*(1D0-2D0*QF(4)*XSW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0*D2(0,0)+D1(1)*S12+D1(2)*
     &  S12+D2(1,1)*S12+D2(1,2)*(2D0*S12+S13+S23)-D1(3)*(S14+S24)-
     &  D2(1,3)*(S14+S24)+D2(2,2)*T14-D2(2,3)*(MH2-T14))
        F(5,-1,-1) = F(5,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE

C       G(T4,N12,FULL)
        CALL xD012345_(S34,RMF2(2),MH2,RMF2(1),T12,T11,CMF2(1),
     &  CMF2(2),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*
     &  QF(1)*XSW2)*(1D0+2D0*QF(2)*XSW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0*D2(0,0)-D1(3)*(S13+S14)-
     &  D2(1,3)*(S13+S14)+D1(1)*S34+D1(2)*S34+D2(1,1)*S34+D2(1,2)*
     &  (S23+S24+2D0*S34)+D2(2,2)*T11-D2(2,3)*(MH2-T11))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE

	end

************************************************************************
        subroutine add_HWW4f_pent(F,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for WW-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    up       anti-down     down     anti-up
*	pentagon corrections             
*-----------------------------------------------------------------------
*       27.12.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(1)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pw12,pw34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        COMPLEX*16 xD0_,D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        COMPLEX*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
        COMPLEX*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
        COMPLEX*16 E4n(0:4,0:4,0:4,0:4)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)
	integer i

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

C       Process: S1F21aF22F23aF24,   Model: SM4f

C       G(T3,N9,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(4),RMF2(3),MH2,RMF2(2),S14,S34,
     &  T13,T12,S12,CMF2(1),NULL,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((QF(1)*QF(4)*ALPHA*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)-E1N(4)*S12-
     &  2D0*E2N(1,4)*S12+E1N(1)*S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+
     &  2D0*E2N(1,3)*S14+2D0*E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+
     &  2D0*E2N(3,3)*(S14+S34)+E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*
     &  (2D0*S14+S34)-2D0*E2N(3,4)*(MH2-T12))
        F(2,-1,-1) = F(2,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E2N(3,4)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)-E2N(3,4)*PRE
        F(11,-1,-1) = F(11,-1,-1)+K(1)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T3,N10,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(4),RMF2(3),MH2,RMF2(2),S14,S34,
     &  T13,T12,S12,CMF2(1),XMZ2,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*(1D0-2D0*
     &  QF(4)*XSW2))/(32D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)-E1N(4)*S12-
     &  2D0*E2N(1,4)*S12+E1N(1)*S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+
     &  2D0*E2N(1,3)*S14+2D0*E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+
     &  2D0*E2N(3,3)*(S14+S34)+E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*
     &  (2D0*S14+S34)-2D0*E2N(3,4)*(MH2-T12))
        F(2,-1,-1) = F(2,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E2N(3,4)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)-E2N(3,4)*PRE
        F(11,-1,-1) = F(11,-1,-1)+K(1)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T3,N11,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(4),RMF2(3),MH2,RMF2(2),S14,S34,
     &  T13,T12,S12,CMF2(2),XMW2,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)-E1N(4)*S12-
     &  2D0*E2N(1,4)*S12+E1N(1)*S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+
     &  2D0*E2N(1,3)*S14+2D0*E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+
     &  2D0*E2N(3,3)*(S14+S34)+E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*
     &  (2D0*S14+S34)-2D0*E2N(3,4)*(MH2-T12))
        F(2,-1,-1) = F(2,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E2N(3,4)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)-E2N(3,4)*PRE
        F(11,-1,-1) = F(11,-1,-1)+K(1)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T8,N26,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(4),RMF2(3),MH2,RMF2(1),S24,S34,
     &  T13,T11,S12,CMF2(1),XMW2,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)

        PRE = -((ALPHA*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(-(2D0*E2N(3,4)*S13)+E1N(1)*
     &  S24)
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*E2N(3,4)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+E2N(3,4)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(-(E1N(3))-E2N(1,3)-E2N(2,3)-
     &  E2N(3,3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(E2N(2,4)+E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E1N(2))-E1N(3)-E2N(1,2)-E2N(1,
     &  3)-E2N(2,2)-2D0*E2N(2,3)-E2N(3,3))*PRE
        F(13,-1,-1) = F(13,-1,-1)-E2N(0,0)*PRE

C       G(T8,N24,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(4),RMF2(3),MH2,RMF2(1),S24,S34,
     &  T13,T11,S12,CMF2(2),NULL,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)

        PRE = (QF(2)*QF(4)*ALPHA*XMW)/(8D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(-(2D0*E2N(3,4)*S13)+E1N(1)*
     &  S24)
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*E2N(3,4)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+E2N(3,4)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(-(E1N(3))-E2N(1,3)-E2N(2,3)-
     &  E2N(3,3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(E2N(2,4)+E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E1N(2))-E1N(3)-E2N(1,2)-E2N(1,
     &  3)-E2N(2,2)-2D0*E2N(2,3)-E2N(3,3))*PRE
        F(13,-1,-1) = F(13,-1,-1)-E2N(0,0)*PRE

C       G(T8,N25,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(4),RMF2(3),MH2,RMF2(1),S24,S34,
     &  T13,T11,S12,CMF2(2),XMZ2,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)

        PRE = -((ALPHA*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*(1D0-2D0*
     &  QF(4)*XSW2))/(32D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(-(2D0*E2N(3,4)*S13)+E1N(1)*
     &  S24)
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*E2N(3,4)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+E2N(3,4)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(-(E1N(3))-E2N(1,3)-E2N(2,3)-
     &  E2N(3,3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(E2N(2,4)+E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E1N(2))-E1N(3)-E2N(1,2)-E2N(1,
     &  3)-E2N(2,2)-2D0*E2N(2,3)-E2N(3,3))*PRE
        F(13,-1,-1) = F(13,-1,-1)-E2N(0,0)*PRE

C       G(T2,N6,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(2),MH2,RMF2(4),S13,S12,
     &  T12,T14,S34,CMF2(3),NULL,CMF2(1),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((QF(1)*QF(3)*ALPHA*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+2D0*(E1N(1)+2D0*E1N(2)+2D0*E1N(3)+
     &  2D0*E2N(1,2)+2D0*E2N(1,3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*
     &  E2N(3,3))*PRE*S13
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+K(1)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,
     &  3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)-E2N(3,4)*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T2,N7,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(2),MH2,RMF2(4),S13,S12,
     &  T12,T14,S34,CMF2(3),XMZ2,CMF2(1),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = (ALPHA*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(32D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+2D0*(E1N(1)+2D0*E1N(2)+2D0*E1N(3)+
     &  2D0*E2N(1,2)+2D0*E2N(1,3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*
     &  E2N(3,3))*PRE*S13
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+K(1)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,
     &  3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)-E2N(3,4)*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T2,N8,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(2),MH2,RMF2(4),S13,S12,
     &  T12,T14,S34,CMF2(4),XMW2,CMF2(2),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = (ALPHA*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0-2D0*QF(4)*XSW2))/(32D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+2D0*(E1N(1)+2D0*E1N(2)+2D0*E1N(3)+
     &  2D0*E2N(1,2)+2D0*E2N(1,3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*
     &  E2N(3,3))*PRE*S13
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+K(1)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,
     &  3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)-E2N(3,4)*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T10,N32,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(1),MH2,RMF2(4),S23,S12,
     &  T11,T14,S34,CMF2(3),NULL,CMF2(2),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((QF(2)*QF(3)*ALPHA*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)+E1N(1)*S23+
     &  2D0*E1N(2)*S23+2D0*E2N(1,2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,
     &  2)*S23+2D0*E2N(3,3)*(S12+S23)+E1N(3)*(S12+2D0*S23)+2D0*
     &  E2N(2,3)*(S12+2D0*S23)-E1N(4)*S34-2D0*E2N(1,4)*S34-2D0*
     &  E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*(MH2-T14))
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E2N(3,4)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)+K(1)*PRE
        F(11,-1,-1) = F(11,-1,-1)-E2N(3,4)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T10,N33,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(1),MH2,RMF2(4),S23,S12,
     &  T11,T14,S34,CMF2(3),XMZ2,CMF2(2),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(32D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)+E1N(1)*S23+
     &  2D0*E1N(2)*S23+2D0*E2N(1,2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,
     &  2)*S23+2D0*E2N(3,3)*(S12+S23)+E1N(3)*(S12+2D0*S23)+2D0*
     &  E2N(2,3)*(S12+2D0*S23)-E1N(4)*S34-2D0*E2N(1,4)*S34-2D0*
     &  E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*(MH2-T14))
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E2N(3,4)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)+K(1)*PRE
        F(11,-1,-1) = F(11,-1,-1)-E2N(3,4)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T10,N34,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(1),MH2,RMF2(4),S23,S12,
     &  T11,T14,S34,CMF2(4),XMW2,CMF2(1),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0-2D0*QF(4)*XSW2))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)+E1N(1)*S23+
     &  2D0*E1N(2)*S23+2D0*E2N(1,2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,
     &  2)*S23+2D0*E2N(3,3)*(S12+S23)+E1N(3)*(S12+2D0*S23)+2D0*
     &  E2N(2,3)*(S12+2D0*S23)-E1N(4)*S34-2D0*E2N(1,4)*S34-2D0*
     &  E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*(MH2-T14))
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E2N(3,4)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)+K(1)*PRE
        F(11,-1,-1) = F(11,-1,-1)-E2N(3,4)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

	end

************************************************************************
        subroutine add_HWW4f_self_bgf(F,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for WW-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    up       anti-down     down     anti-up
*	self-energy contributions
*	boson loops only
*	background-field formalism
*-----------------------------------------------------------------------
*       23.12.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pw12,pw34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
        complex*16 dZuur,dZuul,dZddr,dZddl
        complex*16 ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl
	integer i

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/xrenc_bgf/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &         dZuur,dZuul,dZddr,dZddl,
     &         ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl

C       Process: S10F2100aF2200F2300aF2400,   Model: SMbgf4f

C       G(T1,N7,FULL)+G(T1,N9,FULL)+G(T2,N17,FULL)+G(T2,N19,FULL)

C       G(T1,N2,FULL)+G(T2,N12,FULL)
        A0 = xA0_(XMH2)

        PRE = -((A0*ALPHA*PW12*PW34*(PW12+PW34)*XMW*XSW2**(-2))/
     &  (32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N1,FULL)+G(T1,N4,FULL)+G(T1,N5,FULL)+G(T1,N8,FULL)+
C       G(T2,N11,FULL)+G(T2,N14,FULL)+G(T2,N15,FULL)+G(T2,N18,FULL)
        A0 = xA0_(XMW2)

        PRE = -((ALPHA*PW12*PW34*(PW12+PW34)*XMW*(5D0*A0-4D0*XMW2)*
     &  XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N10,FULL)+G(T1,N3,FULL)+G(T1,N6,FULL)+G(T2,N13,FULL)+
C       G(T2,N16,FULL)+G(T2,N20,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((ALPHA*PW12*PW34*(PW12+PW34)*XMW*(A0*(1D0+8D0*XCW2)-
     &  8D0*XCW2*XMZ2)*XSW2**(-2))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N23,FULL)+G(T3,N28,FULL)+G(T3,N30,FULL)+G(T3,N31,FULL)+
C       G(T3,N39,FULL)+G(T3,N44,FULL)+G(T3,N46,FULL)+G(T3,N47,FULL)
        CALL xB012345_(S12,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*XMW*(12D0*B2(0,0)+S12-3D0*XMW2+
     &  6D0*B0*(2D0*S12-XMW2)))/(12D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N21,FULL)+G(T3,N25,FULL)+G(T3,N37,FULL)+G(T3,N41,FULL)
        CALL xB012345_(S12,XMW2,XMH2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((ALPHA*PW12**2*PW34*XMW*(-(B2(0,0))+B0*XMW2)*XSW2**
     &  (-2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N22,FULL)+G(T3,N24,FULL)+G(T3,N26,FULL)+G(T3,N27,FULL)+
C       G(T3,N29,FULL)+G(T3,N32,FULL)+G(T3,N38,FULL)+G(T3,N40,FULL)+
C       G(T3,N42,FULL)+G(T3,N43,FULL)+G(T3,N45,FULL)+G(T3,N48,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12**2*PW34*XMW*XSW2**(-2)*(3D0*B2(0,0)*(1D0+
     &  8D0*XCW2)+2D0*XCW2*(S12-3D0*XMW2-3D0*XMZ2)+(3D0*B0*(8D0*S12*
     &  XCW2**2-XCW2*XMW2-XCW2**2*XMW2+2D0*XCW2*XMW2*XSW2-XMW2*
     &  XSW2**2))/XCW2))/(24D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N51,FULL)+G(T4,N56,FULL)+G(T4,N58,FULL)+G(T4,N59,FULL)+
C       G(T4,N67,FULL)+G(T4,N72,FULL)+G(T4,N74,FULL)+G(T4,N75,FULL)
        CALL xB012345_(S34,NULL,XMW2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*XMW*(12D0*B2(0,0)+S34-3D0*XMW2+
     &  6D0*B0*(2D0*S34-XMW2)))/(12D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N49,FULL)+G(T4,N53,FULL)+G(T4,N65,FULL)+G(T4,N69,FULL)
        CALL xB012345_(S34,XMW2,XMH2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((ALPHA*PW12*PW34**2*XMW*(-(B2(0,0))+B0*XMW2)*XSW2**
     &  (-2))/(8D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N50,FULL)+G(T4,N52,FULL)+G(T4,N54,FULL)+G(T4,N55,FULL)+
C       G(T4,N57,FULL)+G(T4,N60,FULL)+G(T4,N66,FULL)+G(T4,N68,FULL)+
C       G(T4,N70,FULL)+G(T4,N71,FULL)+G(T4,N73,FULL)+G(T4,N76,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PW12*PW34**2*XMW*XSW2**(-2)*(3D0*B2(0,0)*(1D0+
     &  8D0*XCW2)+2D0*XCW2*(S34-3D0*XMW2-3D0*XMZ2)+(3D0*B0*(8D0*S34*
     &  XCW2**2-XCW2*XMW2-XCW2**2*XMW2+2D0*XCW2*XMW2*XSW2-XMW2*
     &  XSW2**2))/XCW2))/(24D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

c*** counterterms
c----------------

        F(1,-1,-1) = F(1,-1,-1)+(PW12*PW34*XMW)/(2D0*XSW*XSW2)
     &		*( -2d0*dZw + dmw2*pw12 + dmw2*pw34 ) 

	end

************************************************************************
        subroutine add_HWW4f_vert_bgf(F,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for WW-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    up       anti-down     down     anti-up
*	vertex corrections             
*	boson loops only
*	background-field formalism
*-----------------------------------------------------------------------
*       27.12.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(3)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pw12,pw34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
        complex*16 dZuur,dZuul,dZddr,dZddl
        complex*16 ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl
        complex*16 guu,gdd            
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)
	integer i

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/xrenc_bgf/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &         dZuur,dZuul,dZddr,dZddl,
     &         ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl
        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

C       Process: S10F2100aF2200F2300aF2400,   Model: SMbgf4f

C       G(T8,N62,FULL)
        CALL xB012345_(MH2,XMH2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((3D0*ALPHA*B0*PW12*PW34*XMH2*XSW2**(-2))/(64D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T8,N61,FULL)+G(T8,N64,FULL)+G(T8,N65,FULL)+G(T8,N67,FULL)
        CALL xB012345_(MH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*PW12*PW34*(-(8D0*XMW)+(B0*(XMH2+10D0*XMW2))/
     &  XMW)*XSW2**(-2))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T8,N63,FULL)+G(T8,N66,FULL)+G(T8,N68,FULL)
        CALL xB012345_(MH2,XMZ2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*PW12*PW34*(-(16D0*XMW)+(B0*(XCW2*XMH2+2D0*
     &  XMW2+16D0*XCW2*XMW2))/(XCW2*XMW))*XSW2**(-2))/(64D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T10,N73,FULL)
        CALL xB012345_(S12,NULL,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T10,N75,FULL)
        CALL xB012345_(S12,XMW2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T10,N74,FULL)+G(T10,N76,FULL)
        CALL xB012345_(S12,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW*XSW2**(-2)*(XCW2+XCW2**2-
     &  2D0*XCW2*XSW2+XSW2**2))/(16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N69,FULL)
        CALL xB012345_(S34,NULL,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N71,FULL)
        CALL xB012345_(S34,XMW2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T9,N70,FULL)+G(T9,N72,FULL)
        CALL xB012345_(S34,XMW2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PW12*PW34*XMW*XSW2**(-2)*(XCW2+XCW2**2-
     &  2D0*XCW2*XSW2+XSW2**2))/(16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N14,FULL)
        CALL xC01234_(RMF2(1),MH2,T11,CMF2(1),XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW34*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*
     &  QF(1)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T3,N13,FULL)
        CALL xC01234_(RMF2(1),MH2,T11,CMF2(2),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW34*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N3,FULL)+G(T1,N7,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(2),CMF2(1),NULL,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(1)*ALPHA*PW12*PW34*(1D0-4D0*C2(0,0)+2D0*C1(1)*
     &  S12+2D0*C1(2)*S12)*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N4,FULL)+G(T1,N8,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(2),CMF2(1),XMZ2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-4D0*C2(0,0)+2D0*C1(1)*S12+2D0*
     &  C1(2)*S12)*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N2,FULL)+G(T1,N6,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(2),CMF2(2),XMW2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-4D0*C2(0,0)+2D0*C1(1)*S12+2D0*
     &  C1(2)*S12)*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N1,FULL)+G(T1,N5,FULL)
        CALL xC01234_(RMF2(2),RMF2(1),S12,NULL,CMF2(2),XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = (QF(2)*ALPHA*PW12*PW34*(1D0-4D0*C2(0,0)-2D0*C1(1)*S12-
     &  2D0*C0*S12)*XMW)/(8D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N12,FULL)
        CALL xC01234_(RMF2(2),MH2,T12,CMF2(1),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW34*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N9,FULL)
        CALL xC01234_(RMF2(2),S12,RMF2(1),NULL,CMF2(2),CMF2(1),
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(1)*QF(2)*ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S12+C1(2)*S12+C2(1,2)*S12+C0*S12)*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N15,FULL)
        CALL xC01234_(RMF2(3),MH2,T13,CMF2(4),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*PW12*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N59,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),NULL,CMF2(3),CMF2(4),
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(3)*QF(4)*ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S34+C1(2)*S34+C2(1,2)*S34+C0*S34)*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N51,FULL)+G(T7,N55,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),CMF2(3),NULL,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = (QF(3)*ALPHA*PW12*PW34*(1D0-4D0*C2(0,0)+2D0*C1(1)*S34+
     &  2D0*C1(2)*S34)*XMW)/(8D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N52,FULL)+G(T7,N56,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),CMF2(3),XMZ2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-4D0*C2(0,0)+2D0*C1(1)*S34+2D0*
     &  C1(2)*S34)*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N54,FULL)+G(T7,N58,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),CMF2(4),XMW2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PW12*PW34*(1D0-4D0*C2(0,0)+2D0*C1(1)*S34+2D0*
     &  C1(2)*S34)*XMW*XSW2**(-2)*(1D0-2D0*QF(4)*XSW2))/(16D0*PI*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T7,N53,FULL)+G(T7,N57,FULL)
        CALL xC01234_(RMF2(4),RMF2(3),S34,NULL,CMF2(4),XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(4)*ALPHA*PW12*PW34*(1D0-4D0*C2(0,0)-2D0*C1(1)*
     &  S34-2D0*C0*S34)*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T1,N10,FULL)
        CALL xC01234_(S12,RMF2(1),RMF2(2),CMF2(2),CMF2(1),XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)-C1(1)*S12-C1(2)*S12-
     &  C2(1,1)*S12-C2(1,2)*S12)*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0+2D0*QF(2)*XSW2))/(16D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T5,N26,FULL)+G(T5,N27,FULL)+G(T5,N35,FULL)+G(T5,N39,FULL)+
C       G(T5,N43,FULL)+G(T5,N47,FULL)
        CALL xC01234_(S12,MH2,S34,NULL,XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)
        K(1) = C1(1)+C1(2)+2D0*C2(1,2)

        PRE = -((ALPHA*PW12*PW34*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(1D0-4D0*C2(0,0)-C0*(2D0*S12+
     &  2D0*S34-XMH2-2D0*XMW2))
        F(5,-1,-1) = F(5,-1,-1)+2D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*K(1)*PRE

C       G(T5,N33,FULL)+G(T5,N37,FULL)+G(T5,N41,FULL)+G(T5,N45,FULL)
        CALL xC01234_(S12,MH2,S34,XMH2,XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)
        K(1) = 2D0*C1(1)*XMW+2D0*C1(2)*XMW+(C2(1,2)*(XMH2+2D0*
     &  XMW2))/XMW

        PRE = -((ALPHA*PW12*PW34*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0*C0*XMW*XMW2-(C2(0,0)*(XMH2+
     &  2D0*XMW2))/XMW)
        F(5,-1,-1) = F(5,-1,-1)+K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(1)*PRE

C       G(T5,N19,FULL)+G(T5,N20,FULL)
        CALL xC01234_(S12,MH2,S34,XMW2,XMH2,XMH2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)

        PRE = -((3D0*ALPHA*PW12*PW34*XMH2*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(C0*XMW-(C2(0,0))/XMW)
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*PRE)/XMW
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*PRE)/XMW
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*PRE)/XMW
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*PRE)/XMW

C       G(T5,N17,FULL)+G(T5,N18,FULL)+G(T5,N21,FULL)+G(T5,N22,FULL)+
C       G(T5,N23,FULL)+G(T5,N24,FULL)+G(T5,N29,FULL)+G(T5,N30,FULL)+
C       G(T5,N31,FULL)+G(T5,N32,FULL)
        CALL xC01234_(S12,MH2,S34,XMW2,XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)
        K(1) = XCW2+XSW2
        K(2) = XCW2*XMH2+2D0*XMW2+16D0*XCW2*XMW2
        K(3) = 8D0*C0*XMW-(C2(1,2)*(XCW2*XMH2+2D0*XMW2+16D0*XCW2*
     &  XMW2))/(XCW2*XMW)-(2D0*C1(1)*XMW*(XCW2+XSW2))/XCW2-(2D0*
     &  C1(2)*XMW*(XCW2+XSW2))/XCW2

        PRE = (ALPHA*PW12*PW34*XSW2**(-2))/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*XMW)+(C2(0,0)*K(2))/
     &  (XCW2*XMW)+C0*XCW2**(-2)*XMW*(4D0*S12*XCW2**2-4D0*S13*XCW2**
     &  2-4D0*S14*XCW2**2-4D0*S23*XCW2**2-4D0*S24*XCW2**2+4D0*S34*
     &  XCW2**2-XCW2**2*XMH2-2D0*XCW2*XMW2-2D0*XCW2**2*XMW2+4D0*
     &  XCW2*XMW2*XSW2-2D0*XMW2*XSW2**2))
        F(5,-1,-1) = F(5,-1,-1)+K(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(3)*PRE

C       G(T5,N25,FULL)+G(T5,N28,FULL)+G(T5,N34,FULL)+G(T5,N36,FULL)+
C       G(T5,N38,FULL)+G(T5,N40,FULL)+G(T5,N42,FULL)+G(T5,N44,FULL)+
C       G(T5,N46,FULL)+G(T5,N48,FULL)
        CALL xC01234_(S12,MH2,S34,XMZ2,XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0-2D0*XCW2+2D0*XSW2
        K(2) = XMH2+2D0*XMW2+16D0*XCW2*XMW2
        K(3) = -((C2(1,2)*(XMH2+2D0*XMW2+16D0*XCW2*XMW2))/XMW)+8D0*
     &  C0*XMW*(XCW2+XSW2)+2D0*C1(1)*XMW*(1D0-2D0*XCW2+2D0*XSW2)+
     &  2D0*C1(2)*XMW*(1D0-2D0*XCW2+2D0*XSW2)

        PRE = (ALPHA*PW12*PW34*XSW2**(-2))/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*XCW2*XMW)+(C2(0,0)*K(2))/
     &  XMW+(C0*XMW*(4D0*S12*XCW2**2-4D0*S13*XCW2**2-4D0*S14*XCW2**
     &  2-4D0*S23*XCW2**2-4D0*S24*XCW2**2+4D0*S34*XCW2**2-XCW2**2*
     &  XMH2-2D0*XCW2*XMW2-2D0*XCW2**2*XMW2-4D0*S12*XCW2*XSW2-4D0*
     &  S13*XCW2*XSW2-4D0*S14*XCW2*XSW2-4D0*S23*XCW2*XSW2-4D0*S24*
     &  XCW2*XSW2-4D0*S34*XCW2*XSW2+2D0*XCW2*XMH2*XSW2+4D0*XCW2*
     &  XMW2*XSW2-XMH2*XSW2**2-2D0*XMW2*XSW2**2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)+K(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(3)*PRE

C       G(T7,N60,FULL)
        CALL xC01234_(S34,RMF2(4),RMF2(3),CMF2(3),CMF2(4),XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PW12*PW34*(1D0-2D0*C2(0,0)-C1(1)*S34-C1(2)*S34-
     &  C2(1,1)*S34-C2(1,2)*S34)*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*
     &  XSW2)*(1D0-2D0*QF(4)*XSW2))/(16D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T2,N11,FULL)
        CALL xC01234_(T12,MH2,RMF2(2),CMF2(2),XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW34*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*
     &  QF(2)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T4,N16,FULL)
        CALL xC01234_(T13,MH2,RMF2(3),CMF2(3),XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW12*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*
     &  QF(3)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T6,N49,FULL)
        CALL xC01234_(T14,MH2,RMF2(4),CMF2(3),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW12*XMW*XSW2**(-2))/(8D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

C       G(T6,N50,FULL)
        CALL xC01234_(T14,MH2,RMF2(4),CMF2(4),XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*PW12*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*
     &  QF(4)*XSW2)**2)/(16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE

c*** counterterms
c----------------

        F(1,-1,-1) = F(1,-1,-1)+(PW12*PW34*XMW)/(2D0*XSW*XSW2)
     &		*( ct_hww + 2d0*ct_wud )

	end

************************************************************************
        subroutine add_HWW4f_box_bgf(F,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for WW-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    up       anti-down     down     anti-up
*	box corrections             
*	background-field formalism
*-----------------------------------------------------------------------
*       27.12.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(3)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pw12,pw34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        COMPLEX*16 xD0_,D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        COMPLEX*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)
	integer i

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

C       Process: S10F2100aF2200F2300aF2400,   Model: SMbgf4f

C       G(T1,N3,FULL)+G(T1,N5,FULL)
        CALL xD012345_(RMF2(1),RMF2(2),MH2,S34,T12,S12,NULL,CMF2(1),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((QF(1)*ALPHA*PW34*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(2D0*D2(0,0))+D1(1)*(S13+S14)+
     &  D0*(S13+S14)-D1(3)*T12+D1(2)*(MH2+S13+S14-S23-S24-T12))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(2)+D2(2,3))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(2)+D2(2,3))*PRE

C       G(T6,N15,FULL)+G(T6,N16,FULL)
        CALL xD012345_(RMF2(1),MH2,S34,RMF2(2),S12,T11,CMF2(1),XMZ2,
     &  XMZ2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2))/
     &  (16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-2D0*D1(3)*(S23+
     &  S24)-D1(2)*(2D0*S23+2D0*S24+T11)+D1(1)*(MH2-2D0*S13-2D0*S14-
     &  T11))
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE

C       G(T6,N18,FULL)+G(T6,N20,FULL)
        CALL xD012345_(RMF2(1),MH2,S34,RMF2(2),S12,T11,CMF2(2),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2))/
     &  (16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-2D0*D1(3)*(S23+
     &  S24)+(D1(1)*(MH2*XCW2-2D0*S13*XCW2-2D0*S14*XCW2-T11*XCW2-
     &  MH2*XSW2+T11*XSW2))/XCW2-(D1(2)*(2D0*S23*XCW2+2D0*S24*XCW2+
     &  T11*XCW2-T11*XSW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)
        F(7,-1,-1) = F(7,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)

C       G(T6,N17,FULL)+G(T6,N19,FULL)
        CALL xD012345_(RMF2(2),RMF2(1),MH2,S34,T11,S12,NULL,CMF2(2),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (QF(2)*ALPHA*PW34*XMW)/(4D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(2D0*D2(0,0))+D1(1)*(S23+S24)+
     &  D0*(S23+S24)-D1(3)*T11+D1(2)*(MH2-S13-S14+S23+S24-T11))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(2)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(2)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE

C       G(T1,N4,FULL)+G(T1,N6,FULL)
        CALL xD012345_(RMF2(2),MH2,S34,RMF2(1),S12,T12,CMF2(1),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*XMW*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2))/
     &  (16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-2D0*D1(3)*(S13+
     &  S14)+(D1(1)*(MH2*XCW2-2D0*S23*XCW2-2D0*S24*XCW2-T12*XCW2-
     &  MH2*XSW2+T12*XSW2))/XCW2-(D1(2)*(2D0*S13*XCW2+2D0*S14*XCW2+
     &  T12*XCW2-T12*XSW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)+2D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE

C       G(T1,N1,FULL)+G(T1,N2,FULL)
        CALL xD012345_(RMF2(2),MH2,S34,RMF2(1),S12,T12,CMF2(2),XMZ2,
     &  XMZ2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*XMW*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2))/
     &  (16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-2D0*D1(3)*(S13+
     &  S14)-D1(2)*(2D0*S13+2D0*S14+T12)+D1(1)*(MH2-2D0*S23-2D0*S24-
     &  T12))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE

C       G(T7,N23,FULL)+G(T7,N26,FULL)
        CALL xD012345_(RMF2(3),MH2,S12,RMF2(4),S34,T13,CMF2(3),XMZ2,
     &  XMZ2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW12*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2))/
     &  (16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-2D0*D1(3)*(S14+
     &  S24)-D1(2)*(2D0*S14+2D0*S24+T13)+D1(1)*(MH2-2D0*S13-2D0*S23-
     &  T13))
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)-2D0*D2(2,2)-2D0*D2(2,3))*
     &  PRE

C       G(T7,N22,FULL)+G(T7,N25,FULL)
        CALL xD012345_(RMF2(3),MH2,S12,RMF2(4),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW12*XMW*XSW2**(-2)*(1D0-2D0*QF(4)*XSW2))/
     &  (16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(4D0*D2(0,0))-2D0*D1(3)*(S14+
     &  S24)+(D1(1)*(MH2*XCW2-2D0*S13*XCW2-2D0*S23*XCW2-T13*XCW2-
     &  MH2*XSW2+T13*XSW2))/XCW2-(D1(2)*(2D0*S14*XCW2+2D0*S24*XCW2+
     &  T13*XCW2-T13*XSW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*(D1(1)+D2(1,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)
        F(8,-1,-1) = F(8,-1,-1)+2D0*PRE*(-(2D0*D2(2,2))-2D0*D2(2,3)+
     &  (D1(3)*(XCW2+XSW2))/XCW2)

C       G(T9,N30,FULL)+G(T9,N33,FULL)
        CALL xD012345_(RMF2(3),S12,MH2,RMF2(4),S34,T14,CMF2(3),NULL,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((QF(3)*ALPHA*PW12*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0*D2(0,0)+D1(1)*(S13+S23)+
     &  D1(2)*(S13+S23+T14)-D1(3)*(MH2-S14-S24-T14))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D2(1,2)+D2(2,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D2(1,2)+D2(2,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)-2D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*(D1(3)+D2(2,3))*PRE

C       G(T9,N31,FULL)+G(T9,N34,FULL)
        CALL xD012345_(RMF2(3),S12,MH2,RMF2(4),S34,T14,CMF2(3),XMZ2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW12*XMW*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2))/
     &  (16D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(4D0*D2(0,0)+2D0*D1(1)*(S13+
     &  S23)-(D1(3)*(MH2*XCW2-2D0*S14*XCW2-2D0*S24*XCW2-T14*XCW2-
     &  MH2*XSW2+T14*XSW2))/XCW2+(D1(2)*(2D0*S13*XCW2+2D0*S23*XCW2+
     &  T14*XCW2-T14*XSW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)-2D0*PRE*(-(2D0*D2(1,2))-2D0*D2(2,2)+
     &  (D1(1)*(XCW2+XSW2))/XCW2)
        F(6,-1,-1) = F(6,-1,-1)-2D0*PRE*(-(2D0*D2(1,2))-2D0*D2(2,2)+
     &  (D1(1)*(XCW2+XSW2))/XCW2)
        F(7,-1,-1) = F(7,-1,-1)-4D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)-4D0*(D1(3)+D2(2,3))*PRE

C       G(T9,N32,FULL)+G(T9,N35,FULL)
        CALL xD012345_(RMF2(3),S12,MH2,RMF2(4),S34,T14,CMF2(4),XMW2,
     &  XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = (ALPHA*PW12*XMW*XSW2**(-2)*(1D0-2D0*QF(4)*XSW2))/
     &  (16D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*(4D0*D2(0,0)+2D0*D1(1)*(S13+
     &  S23)+D1(2)*(2D0*S13+2D0*S23+T14)-D1(3)*(MH2-2D0*S14-2D0*S24-
     &  T14))
        F(5,-1,-1) = F(5,-1,-1)-2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*(D1(1)-2D0*D2(1,2)-2D0*D2(2,2))*
     &  PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*(D1(3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)-4D0*(D1(3)+D2(2,3))*PRE

C       G(T7,N21,FULL)+G(T7,N24,FULL)
        CALL xD012345_(RMF2(4),RMF2(3),MH2,S12,T13,S34,NULL,CMF2(4),
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((QF(4)*ALPHA*PW12*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(-(2D0*D2(0,0))+D1(1)*(S14+S24)+
     &  D0*(S14+S24)-D1(3)*T13+D1(2)*(MH2-S13+S14-S23+S24-T13))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(2)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+2D0*(D1(2)+D2(2,3))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE

C       G(T5,N14,FULL)
        CALL xD012345_(S12,RMF2(3),MH2,RMF2(4),T13,T14,CMF2(4),
     &  CMF2(3),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW12*XCW2**(-2)*XMW*XSW2**(-2)*(1D0+2D0*
     &  QF(3)*XSW2)*(1D0-2D0*QF(4)*XSW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0*D2(0,0)+D1(1)*S12+D1(2)*
     &  S12+D2(1,1)*S12+D2(1,2)*(2D0*S12+S13+S23)-D1(3)*(S14+S24)-
     &  D2(1,3)*(S14+S24)+D2(2,2)*T14-D2(2,3)*(MH2-T14))
        F(5,-1,-1) = F(5,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE

C       G(T4,N13,FULL)
        CALL xD012345_(S34,RMF2(2),MH2,RMF2(1),T12,T11,CMF2(1),
     &  CMF2(2),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)

        PRE = -((ALPHA*PW34*XCW2**(-2)*XMW*XSW2**(-2)*(1D0-2D0*
     &  QF(1)*XSW2)*(1D0+2D0*QF(2)*XSW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(2D0*D2(0,0)-D1(3)*(S13+S14)-
     &  D2(1,3)*(S13+S14)+D1(1)*S34+D1(2)*S34+D2(1,1)*S34+D2(1,2)*
     &  (S23+S24+2D0*S34)+D2(2,2)*T11-D2(2,3)*(MH2-T11))
        F(5,-1,-1) = F(5,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE
        F(7,-1,-1) = F(7,-1,-1)+2D0*(D1(3)+D2(1,3)+D2(2,3))*PRE
        F(8,-1,-1) = F(8,-1,-1)-2D0*(D2(1,2)+D2(2,2))*PRE

	end

************************************************************************
        subroutine add_HWW4f_endp(F,Fgd,Fgnd,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for WW-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    up       anti-down     down     anti-up
*	endpoint contribution for dipole subtraction
*-----------------------------------------------------------------------
*       1.1.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pw12,pw34
        COMPLEX*16 Fgd(13,-1:1,-1:1),Fgnd(13,-1:1,-1:1)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
	real*8 s(4,4),sh(4),q(4),m2(4)
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
	integer i,j

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/constsub/constff,constfi,constif,constii
        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        COMMON/IR/LAMBDA,LAMBDA2,DELTAS
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        L(p2,mi2,mj2) =  (log(mi2/p2)+log(mj2/p2)+2d0)*log(lambda2/p2)
     &                  -log(mi2/p2)**2/2d0+log(mi2/p2)/2d0
     &                  -log(mj2/p2)**2/2d0+log(mj2/p2)/2d0

	q(1)  = qu
	q(2)  = qd
	q(3)  = qd
	q(4)  = qu
	m2(1) = mu2
	m2(2) = md2
	m2(3) = md2
	m2(4) = mu2

	s(1,2) = s12
	s(1,3) = s13
	s(1,4) = s14
	s(2,3) = s23
	s(2,4) = s24
	s(3,4) = s34
	sh(1)  = t11
	sh(2)  = t12
	sh(3)  = t13
	sh(4)  = t14

        Gsub = 0d0
        Gsubgd = 0d0
        Gsubgnd = 0d0
        do 20 i=2,4
        do 20 j=1,i-1
	  diri = sign(1d0,sh(i))
	  dirj = sign(1d0,sh(j))
          if (diri*dirj.lt.0d0) const = constif+constfi+1d0
          if ((diri.lt.0d0).and.(dirj.lt.0d0)) const = 2d0*constii+1d0
          if ((diri.gt.0d0).and.(dirj.gt.0d0)) const = 2d0*constff+1d0
	  fac = (-1)**(i+j)*(L(abs(s(j,i)),m2(i),m2(j)) + const)
          if (qbos.ne.0)
     &      Gsub = Gsub - q(i)*q(j)*fac
          if ((qqcddiag.ne.0).and.((i+j.eq.3).or.(i+j.eq.7)))
     &      Gsubgd = Gsubgd - fac
          if (qqcdnondiag.ne.0) 
     &      Gsubgnd = Gsubgnd - fac
20      continue

        Gsub = Gsub*alpha/4d0/pi
        Gsubgd = Gsubgd*alphas/3d0/pi
        Gsubgnd = Gsubgnd*alphas/3d0/pi

	pre = (PW12*PW34*XMW)/(2D0*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1) + pre*Gsub
        Fgd(1,-1,-1) = Fgd(1,-1,-1) + pre*Gsubgd
        Fgnd(1,-1,-1) = Fgnd(1,-1,-1) + pre*Gsubgnd

	end

************************************************************************
        subroutine add_HWW4f_qcdv(F,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for WW-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    up       anti-down     down     anti-up
*	gluonic vertex corrections             
*-----------------------------------------------------------------------
*       4.1.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(3)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pw12,pw34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 dZuu,dZdd
        complex*16 guu,gdd            
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)
	integer i

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        COMMON/UV/MUDIM2
        COMMON/IR/LAMBDA,LAMBDA2,DELTAS

        dZuu = -1d0/3D0/PI*(log(mudim2/mu2)+4d0+4d0*log(lambda/mu))
        dZdd = -1d0/3D0/PI*(log(mudim2/md2)+4d0+4d0*log(lambda/md))

C       G(T1,N9,FULL)
        CALL xC01234_(RMF2(2),S12,RMF2(1),NULL,CMF2(2),CMF2(1),
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((4d0/3d0*alphas*PW12*PW34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S12+C1(2)*S12+C2(1,2)*S12+C0*S12)*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

c counterterm
        F(1,-1,-1) = F(1,-1,-1)+(PW12*PW34*XMW)/(2D0*XSW*XSW2)
     &			*alphas*(dZuu+dZdd)/2d0

C       G(T7,N53,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(4),NULL,CMF2(3),CMF2(4),
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((4d0/3d0*alphas*PW12*PW34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S34+C1(2)*S34+C2(1,2)*S34+C0*S34)*XMW)/(4D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+PRE

c counterterm
        F(1,-1,-1) = F(1,-1,-1)+(PW12*PW34*XMW)/(2D0*XSW*XSW2)
     &			*alphas*(dZuu+dZdd)/2d0

	end

************************************************************************
        subroutine add_HWW4f_gpent(F,pw12,pw34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for WW-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    up       anti-down     down     anti-up
*	gluonic pentagon corrections             
*-----------------------------------------------------------------------
*       4.1.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(1)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pw12,pw34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        COMPLEX*16 xD0_,D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        COMPLEX*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
        COMPLEX*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
        COMPLEX*16 E4n(0:4,0:4,0:4,0:4)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)
	integer i

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

c squared Higgs momentum 
	ph2 = s12+s13+s14+s23+s24+s34

C       Process: S1F21aF22F23aF24,   Model: SM4f

C       G(T3,N9,FULL)
        CALL xE01234_NEW(RMF2(1),RMF2(4),RMF2(3),ph2,RMF2(2),S14,S34,
     &  T13,T12,S12,CMF2(1),NULL,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((4d0/3d0*alphas*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)-E1N(4)*S12-
     &  2D0*E2N(1,4)*S12+E1N(1)*S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+
     &  2D0*E2N(1,3)*S14+2D0*E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+
     &  2D0*E2N(3,3)*(S14+S34)+E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*
     &  (2D0*S14+S34)-2D0*E2N(3,4)*(ph2-T12))
        F(2,-1,-1) = F(2,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E2N(3,4)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)-E2N(3,4)*PRE
        F(11,-1,-1) = F(11,-1,-1)+K(1)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T8,N24,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(4),RMF2(3),ph2,RMF2(1),S24,S34,
     &  T13,T11,S12,CMF2(2),NULL,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)

        PRE = (4d0/3d0*alphas*XMW)/(8D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(-(2D0*E2N(3,4)*S13)+E1N(1)*
     &  S24)
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*E2N(3,4)*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+E2N(3,4)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(-(E1N(3))-E2N(1,3)-E2N(2,3)-
     &  E2N(3,3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(E2N(2,4)+E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E1N(2))-E1N(3)-E2N(1,2)-E2N(1,
     &  3)-E2N(2,2)-2D0*E2N(2,3)-E2N(3,3))*PRE
        F(13,-1,-1) = F(13,-1,-1)-E2N(0,0)*PRE

C       G(T2,N6,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(1),RMF2(2),ph2,RMF2(4),S13,S12,
     &  T12,T14,S34,CMF2(3),NULL,CMF2(1),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((4d0/3d0*alphas*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+2D0*(E1N(1)+2D0*E1N(2)+2D0*E1N(3)+
     &  2D0*E2N(1,2)+2D0*E2N(1,3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*
     &  E2N(3,3))*PRE*S13
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-8D0*K(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*E1N(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*E1N(4)*PRE
        F(9,-1,-1) = F(9,-1,-1)+K(1)*PRE
        F(10,-1,-1) = F(10,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,
     &  3))*PRE
        F(11,-1,-1) = F(11,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(12,-1,-1) = F(12,-1,-1)-E2N(3,4)*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T10,N32,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(1),ph2,RMF2(4),S23,S12,
     &  T11,T14,S34,CMF2(3),NULL,CMF2(2),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((4d0/3d0*alphas*XMW)/(8D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)+E1N(1)*S23+
     &  2D0*E1N(2)*S23+2D0*E2N(1,2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,
     &  2)*S23+2D0*E2N(3,3)*(S12+S23)+E1N(3)*(S12+2D0*S23)+2D0*
     &  E2N(2,3)*(S12+2D0*S23)-E1N(4)*S34-2D0*E2N(1,4)*S34-2D0*
     &  E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*(ph2-T14))
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E2N(3,4)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)+K(1)*PRE
        F(11,-1,-1) = F(11,-1,-1)-E2N(3,4)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

	end

