***********************************************************************
*     file public.F                                                   *
*     adapted from COFFERGG by Markus Roth                            *
*---------------------------------------------------------------------*
*     30.01.06  Ansgar Denner     last changed  09.06.10              *
***********************************************************************

* read input from file
#define READINPUT

#define RANLUX




ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     read input file                                             c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine readinput
      implicit none

#include "mcinput.h"
#include "mcparams.h"
#include "mccommon.h"

c for initcarry
      integer x(0:24),carry,initsteps
      common/randomseed/x,carry,initsteps

c local variables
      integer i1,isep1,isep2,linputline,hemicut,higgsbjets
      integer printweightmax
      integer sonsborn,sonsqcd
      integer lqedfacscale,lqcdrenscale
      character*100 identifier,orgidentifier
      character*101 directive,orgdirective,storeinput
      character*100 inputline
      integer      autofreq

      data linputline /100/, autofreq /1/, printweightmax /0/

#ifdef RANLUX
      integer ranluxseed
      common/ranluxseed/ranluxseed
#endif

      integer qalps
      common/qalps/qalps

      integer num
#ifdef multpdf
#include "multpdf.h"
      integer nset
#endif
c initialization
      lcmsgen=.true.
      lcmsgen=.false.
      do gen=0,maxg
        sgen(gen)=0
        sborn(gen)=0
        swborn(gen)=0
        svirt(gen)=0
        spbrems(gen)=0
        sgbrems(gen)=0
        spinc(gen)=0
        sginc(gen)=0
        ssub(gen)=0
        ssli(gen)=0
        seff(gen)=0
        sendp(gen)=0
        scuts(gen)=0
        srecomb(gen)=0
        sconv(gen)=0
        soaisr(gen)=0
        sincludecuts(gen)=1
        do icon=1,maxcon
          freqgencon(gen,icon)=1
          sgencon(gen,icon)=0
        enddo
        nextgen(gen)=5
c CHANGED
      enddo
      nextmax=nextgen(0)

c test input

       outputfile=' '
       outputfile2='sigma.dat'
       outputvar=' '
      energy=14000d0

      nevents=100 000 000
       nevents=20 000 000
       nevents=10 000 000
       nevents=2000
       nevents=20



      outputfile=' '
      outputfile2='sigma2.dat'

c initsteps: initialization steps for initcarry
      initsteps = 100000

c lnoutmc=5 full output of montecarlo
c lnoutmc=3 medium output of montecarlo
c lnoutmc=1 standard output of montecarlo
      lnoutmc=1

c lnoutgen=1 minimal output of generator
c lnoutgen=0 no output of generator
      lnoutgen=0

c maximal number of error messages
      maxout=100
      maxout=0

c salp=0   alpha(0) scheme
c salp=1   alpha(mz) scheme
c salp=2   alpha(gf) scheme
      salp =2

c sborn=0   Born not included
c sborn=1   Born included
      sborn(0)=1

c sconv=0   no convolution with pdf
c sconv=1   convolution with pdf
      sconv(0)=1

c swidth=0  zero width
c swidth=1  complex mass scheme
c swidth=2  naive fixed width scheme
      swidth=1

c swdiag=0  W-exchange diagrams excluded
c swdiag=1  W-exchange diagrams included
      swdiag=1

c szdiag=0  Z-exchange diagrams excluded
c szdiag=1  Z-exchange diagrams included
      szdiag=1

c scp=0  CP symmetry not used
c scp=1  CP symmetry used in lowest order matrix elements
      scp=0

c svirt=0   virtual corrections not included
c svirt=1   virtual corrections included
      svirt(0)=1

c sew=0  electroweak corrections not included
c sew=1  electroweak corrections included
      sew=1

c sweak=0  weak virtual corrections not included
c sweak=1  weak virtual (fermionic and bosonic) corrections included
c sweak=1  weak virtual fermionic corrections included
c sweak=1  weak virtual bosonic corrections included
      sweak=1

c sqcd=0  qcd corrections not included
c sqcd=1  qcd corrections included
      sqcd=1

c sqcddiag=0  diagonal qcd corrections not included
c sqcddiag=1  diagonal qcd corrections included
      sqcddiag=1

c sqcdnondiag=0  nondiagonal qcd corrections not included
c sqcdnondiag=1  nondiagonal qcd corrections included
      sqcdnondiag=1

c sqcdgsplit=0  qqg qcd corrections not included
c sqcdgsplit=1  qqg qcd corrections included
      sqcdgsplit=1

c sqcdggfus=0  gg fusion qcd corrections not included
c sqcdggfus=1  gg fusion qcd corrections included
      sqcdggfus=1

c sscha= 0:  switches off contributions connected to s-channel W/Z's in LO
c sscha= 1:  switches on contributions connected to s-channel W/Z's in LO
      sscha= 1

c stcha= 0:  switches off contributions connected to t-channel W/Z's in LO
c stcha= 1:  switches on contributions connected to t-channel W/Z's in LO
      stcha= 1
*     Note: qschan & qtchan =/= 0 do not work for photon-induced processes,
*           because this splitting is not gauge invariant there.

* sch2  = 0:  switches off contributions connected to squared LO diagrams
* sch2  = 1:  switches on contributions connected to squared LO diagrams
      sch2  = 1

* schint= 0:  switches off contributions connected to LO interferences
* schint= 1:  switches on contributions connected to LO interferences
      schint= 1

* sbini = 0:  switches off b-quarks in the initial state
* sbini = 1:  switches on b-quarks in the initial state
      sbini=0

* sbfin = 0:  switches off b-quarks in the final state
* sbfin = 1:  switches on b-quarks in the final state
      sbfin=0
*		Note: channels with external b-quarks included only in LO,
*		      and qbini & qbfin are only active in subroutines
*		      Mat2born, Mat2born1, Mat2born2.

* shh2  = 0:  switches off 2-loop heavy-Higgs effects of O(GF^2*MH^4)
* shh2  = 1:  switches on 2-loop heavy-Higgs effects of O(GF^2*MH^4)
*			included for squared t-channel diagrams
*			following Frink et al., Phys.Rev.D54 (1996) 4548
*						[hep-ph/9606310]
      shh2=1

c sfactqed=0   no factorization of QED
c sfactqed=1   MSbar factorization of QED
c sfactqed=2   DIS factorization of QED
      sfactqed=2

c sfactqcd=0   no factorization for QCD
c sfactqcd=1   MSbar factorization of QCD
c sfactqcd=2   DIS factorization of QCD
      sfactqcd=1

c spbrems(1)=0 photon bremsstrahlung not included
c spbrems(1)=1 photon bremsstrahlung included
      spbrems(1)=1
      spbrems(0)=spbrems(1)

c sgbrems(2)=0 gluon bremsstrahlung not included
c sgbrems(2)=1 gluon bremsstrahlung included
      sgbrems(2)=1
      sgbrems(0)=sgbrems(2)

c spinc(3)=0 incoming photon contribution 1 not included
c spinc(3)=1 incoming photon contribution 1 included
      spinc(3)=1
      spinc(0)=spinc(3)

c spinc(4)=0 incoming photon contribution 2 not included
c spinc(4)=1 incoming photon contribution 2 included
      spinc(4)=1

c sginc(5)=0 incoming gluon contribution 1 not included
c sginc(5)=1 incoming gluon contribution 1 included
      sginc(5)=1
      sginc(0)=sginc(5)

c sginc(6)=0 incoming gluon contribution 2 not included
c sginc(6)=1 incoming gluon contribution 2 included
      sginc(6)=1

c ssub=1    massless subtraction terms of STD
c ssub=2    massless subtraction terms of MAR
      ssub(0)=1
      do gen=1,maxg
        ssub(gen)=ssub(0)
      enddo

c ssli=1    massless slicing terms of CHM
      ssli(0)=0
      do gen=1,maxg
        ssli(gen)=ssli(0)
      enddo

c seff=1    effective collinear factors
      seff(0)=0
      do gen=1,maxg
        seff(gen)=seff(0)
      enddo

c sendp(0)=0  no virtual endpoint contribution included
c sendp(0)=-1  virtual endpoint contribution included in M_virt
c sendp(0)=1  virtual endpoint contribution included in MC
      sendp(0)=-1

c sincludecuts=1  cuts included in generator
c sincludecuts=0  cuts not included in generator
      sincludecuts(0)=1

c srecomb=0  no recombination
      srecomb(0)=0
c srecomb=1  kt-clustering   ycut=5
      srecomb(0)=1
c srecomb=2  kt-clustering   ycut=1d10
c     srecomb(0)=2

c scuts=0   no cuts applied
      scuts(0)=0
c scuts=1   standard ppqqh cuts with pt ordering
      scuts(0)=1
c scuts=2   standard ppqqh cuts with E ordering
c       scuts(0)=2


c spdf=1   MRST2004QED [with O(alpha) effects]
       spdf=1
c spdf=2   MRST2004QED [without O(alpha) effects]
c       spdf=2
c spdf=11  cteq6m pdfs [Standard MSbar scheme (alphas(mz)=0.118)]
c       spdf=11
c spdf=14  cteq6l1 pdfs [Leading Order (alphas(mz)=0.130)]
c       spdf=14
c spdf=99  LHApdf     (needs pdfname or pdfpath)
c      spdf=99

c pdfmap=1 flat mapping of pdfs
c       pdfmap=1
c pdfmap=4 1/x and 1/tau mapping of pdfs
       pdfmap=4

c treatment of Higgs boson
c shtr=0   on-shell Higgs boson
       shtr=0
c shtr=1   off-shell Higgs boson with Breit-Wigner distribution
c      shtr=1
c shtr=2   off-shell Higgs boson decaying to two neutral massless particles
c      shtr=2

c on-shell projection of off-shell Higgs boson for LO
c lonsborn=F  no on-shell projection
       lonsborn=.false.
c sonsborn=T  on-shell projection
c      lonsborn=.true.

c on-shell projection of off-shell Higgs boson for QCD corrections
c lonsqcd=F  no on-shell projection
       lonsqcd=.false.
c lonsqcd=T  on-shell projection
c      lonsqcd=.true.

c on-shell projection of off-shell Higgs boson for EW corrections required
c lonsew=T  on-shell projection
       lonsew=.true.

c on-shell projection of off-shell Higgs boson
c sonsproj=0  no on-shell projection
c      sonsproj=0
c sonsproj=1  on-shell projection via rescaling of outgoing momenta
       sonsproj=1
c sonsproj=2   on-shell projection via rescaling of all momenta
c      sonsproj=2

c Higgs branching ratio
       hbr=1d0

c scalings for factorization and renormalization scales
       qcdfacscalefac=1d0
       qedfacscalefac=1d0
       qcdrenscalefac=1d0


c       nhisto=0
       nhisto=11
       do i1=1,maxh
       lhisto(i1)=1
       enddo

 201  continue

c initialize parameters
      ssoft=1            !  choice of subtraction terms
      sexcl=0

      slightfermions=1



















      if(srecomb(0).eq.1)then
        ktd=0.8d0
        partetacut=5d0
      elseif(srecomb(0).eq.2)then
        ktd=0.8d0
        partetacut=1d10
      elseif(srecomb(0).eq.3)then
        recparam(1,0)=5d0
        recparam(2,0)=2d0
        recparam(3,0)=0.8d0
        recparam(4,0)=0d0    ! calo
      elseif(srecomb(0).eq.4)then
        recparam(1,0)=1d0     !  eta=4.7
        recparam(2,0)=1d0
        recparam(3,0)=0d0
        recparam(4,0)=25d0    ! calo
      endif
      if(scuts(0).eq.1.or.scuts(0).eq.2)then
        ptcutj=20d0
        ycutj=4.5d0
        dycutjj=4d0
        lhemicut=.true.
        mcutjj=0d0
        ycuth=1d10
        ecuth=0d0
        ptcuth=0d0
        mlcuth=1d-2             ! lower cut on Higgs invariant mass
        mucuth=1d30             ! upper cut on Higgs invariant mass
        lhiggsbjets=.false.
        ptcuts=0d0
        ycuts=1d10
        drcutjs=0d0
      elseif(scuts(0).eq.3)then
        ptcutj=20d0
        ycutj=4.5d0
      elseif(scuts(0).eq.9)then
        ptcuth=50d0
      elseif(scuts(0).eq.0)then
        mlcuth=1d-2             ! lower cut on Higgs invariant mass
        mucuth=1d30             ! upper cut on Higgs invariant mass
      endif

c default slicing cut parameters
      mcslideltac=1d-6
      mcslideltas=1d-4

#ifdef RANLUX
c default ranlux initialization
      ranluxseed=314159265
      ranluxseed=0
#endif

#ifdef READINPUT
       nevents=100
       pdfmember=0
#ifdef multpdf
       pdfmemberfrom=1
       pdfmemberto=0
       pdfmembercentral=pdfmember
#endif
       pdfname='cteq6m.LHpdf'

#ifdef mpiuse
       open(unit=5,file='inputfile',status='old')
 50    read(5,'((a))',end=51,err=52) inputline
#else
 50    read(*,'((a))',end=51,err=52) inputline
#endif

       if(inputline(1:1).eq.'!'.or.inputline(1:1).eq.'#') goto 50
       isep1=0
       isep2=linputline+1


       do i1=1,linputline
         if(inputline(i1:i1).eq.'=') then
           isep1=i1
           goto53
         elseif(inputline(i1:i1).eq.'!') then
           isep2=i1
           goto54
         endif
       enddo
 53    continue


       do i1=isep1+1,linputline
         if(inputline(i1:i1).eq.'!') then
           isep2=i1
           goto54
         endif
       enddo
 54    continue


       if(isep1.gt.0)then
         identifier= inputline(1:isep1-1)
         orgidentifier=identifier
         do i1=isep1-1,1,-1
           if (identifier(i1:i1).eq.' ') then
             identifier=identifier(1:i1-1)//identifier(i1+1:linputline)
     &           //' '
           elseif(identifier(i1:i1).ge.'A'.and.identifier(i1:i1).le.'Z')
     &         then
             if(identifier(i1:i1).eq.'A') then
               identifier(i1:i1)='a'
             elseif(identifier(i1:i1).eq.'B') then
               identifier(i1:i1)='b'
             elseif(identifier(i1:i1).eq.'C') then
               identifier(i1:i1)='c'
             elseif(identifier(i1:i1).eq.'D') then
               identifier(i1:i1)='d'
             elseif(identifier(i1:i1).eq.'E') then
               identifier(i1:i1)='e'
             elseif(identifier(i1:i1).eq.'F') then
               identifier(i1:i1)='f'
             elseif(identifier(i1:i1).eq.'G') then
               identifier(i1:i1)='g'
             elseif(identifier(i1:i1).eq.'H') then
               identifier(i1:i1)='h'
             elseif(identifier(i1:i1).eq.'I') then
               identifier(i1:i1)='i'
             elseif(identifier(i1:i1).eq.'J') then
               identifier(i1:i1)='j'
             elseif(identifier(i1:i1).eq.'K') then
               identifier(i1:i1)='k'
             elseif(identifier(i1:i1).eq.'L') then
               identifier(i1:i1)='l'
             elseif(identifier(i1:i1).eq.'M') then
               identifier(i1:i1)='m'
             elseif(identifier(i1:i1).eq.'N') then
               identifier(i1:i1)='n'
             elseif(identifier(i1:i1).eq.'O') then
               identifier(i1:i1)='o'
             elseif(identifier(i1:i1).eq.'P') then
               identifier(i1:i1)='p'
             elseif(identifier(i1:i1).eq.'Q') then
               identifier(i1:i1)='q'
             elseif(identifier(i1:i1).eq.'R') then
               identifier(i1:i1)='r'
             elseif(identifier(i1:i1).eq.'S') then
               identifier(i1:i1)='s'
             elseif(identifier(i1:i1).eq.'T') then
               identifier(i1:i1)='t'
             elseif(identifier(i1:i1).eq.'U') then
               identifier(i1:i1)='u'
             elseif(identifier(i1:i1).eq.'V') then
               identifier(i1:i1)='v'
             elseif(identifier(i1:i1).eq.'W') then
               identifier(i1:i1)='w'
             elseif(identifier(i1:i1).eq.'X') then
               identifier(i1:i1)='x'
             elseif(identifier(i1:i1).eq.'Y') then
               identifier(i1:i1)='y'
             elseif(identifier(i1:i1).eq.'Z') then
               identifier(i1:i1)='z'
             endif
           endif
         enddo
         write(storeinput,*) inputline(isep1+1:isep2-1)


         if(identifier.eq.'nevents') then
           read(storeinput,'(i100)',err=61) nevents
           read(storeinput,*) nevents


         elseif(identifier.eq.'energy  ') then
           read(storeinput,'(f50.50)',err=61) energy
           read(storeinput,*) energy


         elseif(identifier.eq.'outputfile') then
           read(storeinput,'(a100)',err=61) outputfile
           read(storeinput,*) outputfile


         elseif(identifier.eq.'outputfile2') then
           read(storeinput,'(a100)',err=61) outputfile2
           read(storeinput,*) outputfile2


         elseif(identifier.eq.'outputvar') then
           read(storeinput,*) outputvar


         elseif(identifier.eq.'1/alpha0') then
           read(storeinput,'(f50.50)',err=61) alpha0in
           read(storeinput,*) alpha0in
           alpha0in=1d0/alpha0in
         elseif(identifier.eq.'1/alphaz') then
           read(storeinput,'(f50.50)',err=61) alphazin
           read(storeinput,*) alphazin
           alphazin=1d0/alphazin
         elseif(identifier.eq.'gf') then
           read(storeinput,'(f50.50)',err=61) gfin
           read(storeinput,*) gfin
         elseif(identifier.eq.'mz') then
           read(storeinput,'(f50.50)',err=61) mzin
           read(storeinput,*) mzin
         elseif(identifier.eq.'gz') then
           read(storeinput,'(f50.50)',err=61) gzin
           read(storeinput,*) gzin
         elseif(identifier.eq.'mw') then
           read(storeinput,'(f50.50)',err=61) mwin
           read(storeinput,*) mwin
         elseif(identifier.eq.'gw') then
           read(storeinput,'(f50.50)',err=61) gwin
           read(storeinput,*) gwin
         elseif(identifier.eq.'me') then
           read(storeinput,'(f50.50)',err=61) mein
           read(storeinput,*) mein
         elseif(identifier.eq.'mmu') then
           read(storeinput,'(f50.50)',err=61) mmuin
           read(storeinput,*) mmuin
         elseif(identifier.eq.'mtau') then
           read(storeinput,'(f50.50)',err=61) mtauin
           read(storeinput,*) mtauin
         elseif(identifier.eq.'mu') then
           read(storeinput,'(f50.50)',err=61) muin
           read(storeinput,*) muin
         elseif(identifier.eq.'md') then
           read(storeinput,'(f50.50)',err=61) mdin
           read(storeinput,*) mdin
         elseif(identifier.eq.'ms') then
           read(storeinput,'(f50.50)',err=61) msin
           read(storeinput,*) msin
         elseif(identifier.eq.'mc') then
           read(storeinput,'(f50.50)',err=61) mcin
           read(storeinput,*) mcin
         elseif(identifier.eq.'mb') then
           read(storeinput,'(f50.50)',err=61) mbin
           read(storeinput,*) mbin
         elseif(identifier.eq.'mt') then
           read(storeinput,'(f50.50)',err=61) mtin
           read(storeinput,*) mtin
         elseif(identifier.eq.'mh') then
           read(storeinput,'(f50.50)',err=61) mhin
           read(storeinput,*) mhin
         elseif(identifier.eq.'gh') then
           read(storeinput,'(f50.50)',err=61) ghin
           read(storeinput,*) ghin
         elseif(identifier.eq.'hbr') then
           read(storeinput,'(f50.50)',err=61) hbr
           read(storeinput,*) hbr
         elseif(identifier.eq.'qcdfacscalefac') then
           read(storeinput,'(f50.50)',err=61) qcdfacscalefac
           read(storeinput,*) qcdfacscalefac
         elseif(identifier.eq.'qcdrenscalefac') then
           read(storeinput,'(f50.50)',err=61) qcdrenscalefac
           read(storeinput,*) qcdrenscalefac
         elseif(identifier.eq.'qedfacscalefac') then
           read(storeinput,'(f50.50)',err=61) qedfacscalefac
           read(storeinput,*) qedfacscalefac
         elseif(identifier.eq.'qcdfacscalefac2') then
           read(storeinput,'(f50.50)',err=61) qcdfacscalefac
           read(storeinput,*) qcdfacscalefac
           qcdfacscalefac=sqrt(qcdfacscalefac)
         elseif(identifier.eq.'qcdrenscalefac2') then
           read(storeinput,'(f50.50)',err=61) qcdrenscalefac
           read(storeinput,*) qcdrenscalefac
           qcdrenscalefac=sqrt(qcdrenscalefac)
         elseif(identifier.eq.'qedfacscalefac2') then
           read(storeinput,'(f50.50)',err=61) qedfacscalefac
           read(storeinput,*) qedfacscalefac
           qedfacscalefac=sqrt(qedfacscalefac)
         elseif(identifier.eq.'lqcdrenscale') then
           read(storeinput,'(i100)',err=61) lqcdrenscale
           read(storeinput,*) lqcdrenscale
           if (lqcdrenscale.eq.1) then
             qcdrenscalefac=qcdfacscalefac
           elseif (lqcdrenscale.eq.-1) then
             qcdrenscalefac=1d0/qcdfacscalefac
           else
             goto 61
           endif
         elseif(identifier.eq.'lqedfacscale') then
           read(storeinput,'(i100)',err=61) lqedfacscale
           read(storeinput,*) lqedfacscale
           if (lqedfacscale.eq.1) then
             qedfacscalefac=qcdfacscalefac
           else
             goto 61
           endif
         elseif(identifier.eq.'srecomb') then
           read(storeinput,'(i100)',err=61) srecomb(0)
           read(storeinput,*) srecomb(0)
           if(srecomb(0).eq.1)then
             ktd=0.8d0
             partetacut=5d0
           elseif(srecomb(0).eq.2)then
             ktd=0.8d0
             partetacut=1d10
           elseif(srecomb(0).eq.3)then
             recparam(1,0)=5d0
             recparam(2,0)=2d0
             recparam(3,0)=0.8d0
             recparam(4,0)=0d0    ! calo
           elseif(srecomb(0).eq.4)then
             recparam(1,0)=1d0     !  eta=4.7
             recparam(2,0)=1d0
             recparam(3,0)=0d0
             recparam(4,0)=25d0    ! calo
           endif
         elseif(identifier.eq.'scuts') then
           read(storeinput,'(i100)',err=61) scuts(0)
           read(storeinput,*) scuts(0)
           if(scuts(0).eq.1.or.scuts(0).eq.2)then
             ptcutj=20d0
             ycutj=4.5d0
             dycutjj=4d0
             lhemicut=.true.
             mcutjj=0d0
             ptcuth=0d0
             ycuth=1d10
             ecuth=0d0
           elseif(scuts(0).eq.0)then
             ptcutj=0d0
             ycutj=1d10
             dycutjj=0d0
             lhemicut=.false.
             mcutjj=0d0
             ptcuth=0d0
             ycuth=1d10
             ecuth=0d0
           elseif(scuts(0).eq.3)then
             ptcutj=20d0
             ycutj=4.5d0
           elseif(scuts(0).eq.9)then
             ptcuth=50d0
           endif
         elseif(identifier.eq.'sincludecuts') then
           read(storeinput,'(i100)',err=61) sincludecuts(0)
           read(storeinput,*) sincludecuts(0)
         elseif(identifier.eq.'sirtr') then
           read(storeinput,'(i100)',err=61) sirtr
           read(storeinput,*) sirtr
           if(sirtr.eq.0)then
             ssub(0)=1
             ssli(0)=0
           elseif(sirtr.eq.1)then
             ssub(0)=0
             ssli(0)=1
           else
             write(*,*) 'input not known: sirtr = ',sirtr
             stop
           endif
         elseif(identifier.eq.'ssub') then
           read(storeinput,'(i100)',err=61) ssub(0)
           read(storeinput,*) ssub(0)
         elseif(identifier.eq.'ssli') then
           read(storeinput,'(i100)',err=61) ssli(0)
           read(storeinput,*) ssli(0)
         elseif(identifier.eq.'seff') then
           read(storeinput,'(i100)',err=61) seff(0)
           read(storeinput,*) seff(0)
         elseif(identifier.eq.'sborn') then
           read(storeinput,'(i100)',err=61) sborn(0)
           read(storeinput,*) sborn(0)
         elseif(identifier.eq.'sew') then
           read(storeinput,'(i100)',err=61) sew
           read(storeinput,*) sew
           if(sew.eq.1)then
             svirt(0)=1
             sweak=1
             shh2=1
             spbrems(0)=1
             spbrems(1)=1
             spinc(0)=1
             spinc(3)=1
             spinc(4)=1
           elseif(sew.eq.0)then
             sweak=0
             shh2=0
             spbrems(0)=0
             spbrems(1)=0
             spinc(0)=0
             spinc(3)=0
             spinc(4)=0
           else
             write(*,*) 'input not known: sew = ',sew
             stop
           endif
         elseif(identifier.eq.'sqcd') then
           read(storeinput,'(i100)',err=61) sqcd
           read(storeinput,*) sqcd
           if(sqcd.eq.1)then
             svirt(0)=1
             sqcddiag=1
             sqcdnondiag=1
             sqcdggfus=1
             sqcdgsplit=1
             sgbrems(0)=1
             sgbrems(2)=1
             sginc(0)=1
             sginc(5)=1
             sginc(6)=1
           elseif(sqcd.eq.0)then
             sqcddiag=0
             sqcdnondiag=0
             sqcdggfus=0
             sqcdgsplit=0
             sgbrems(0)=0
             sgbrems(2)=0
             sginc(0)=0
             sginc(5)=0
             sginc(6)=0
           else
             write(*,*) 'input not known: sqcd = ',sqcd
             stop
           endif
         elseif(identifier.eq.'shtr') then
           read(storeinput,'(i100)',err=61) shtr
           read(storeinput,*) shtr
         elseif(identifier.eq.'sonsborn') then
           read(storeinput,'(i100)',err=61) sonsborn
           read(storeinput,*) sonsborn
           if(sonsborn.eq.1) then
             lonsborn=.true.
           elseif(sonsborn.eq.0) then
             lonsborn=.false.
           else
             write(*,*)  'input not known: sonsborn = ',sonsborn
           endif
         elseif(identifier.eq.'sonsqcd') then
           read(storeinput,'(i100)',err=61) sonsqcd
           read(storeinput,*) sonsqcd
           if(sonsqcd.eq.1) then
             lonsqcd=.true.
           elseif(sonsqcd.eq.0) then
             lonsqcd=.false.
           else
             write(*,*)  'input not known: sonsqcd = ',sonsqcd
           endif
         elseif(identifier.eq.'sonsproj') then
           read(storeinput,'(i100)',err=61) sonsproj
           read(storeinput,*) sonsproj
         elseif(identifier.eq.'svirt') then
           read(storeinput,'(i100)',err=61) svirt(0)
           read(storeinput,*) svirt(0)
         elseif(identifier.eq.'sweak') then
           read(storeinput,'(i100)',err=61) sweak
           read(storeinput,*) sweak
         elseif(identifier.eq.'sqcddiag') then
           read(storeinput,'(i100)',err=61) sqcddiag
           read(storeinput,*) sqcddiag
         elseif(identifier.eq.'sqcdnondiag') then
           read(storeinput,'(i100)',err=61) sqcdnondiag
           read(storeinput,*) sqcdnondiag
         elseif(identifier.eq.'sqcdggfus') then
           read(storeinput,'(i100)',err=61) sqcdggfus
           read(storeinput,*) sqcdggfus
         elseif(identifier.eq.'sqcdgsplit') then
           read(storeinput,'(i100)',err=61) sqcdgsplit
           read(storeinput,*) sqcdgsplit
         elseif(identifier.eq.'sscha') then
           read(storeinput,'(i100)',err=61) sscha
           read(storeinput,*) sscha
         elseif(identifier.eq.'stcha') then
           read(storeinput,'(i100)',err=61) stcha
           read(storeinput,*) stcha
         elseif(identifier.eq.'sch2') then
           read(storeinput,'(i100)',err=61) sch2
           read(storeinput,*) sch2
         elseif(identifier.eq.'schint') then
           read(storeinput,'(i100)',err=61) schint
           read(storeinput,*) schint
         elseif(identifier.eq.'sbini') then
           read(storeinput,'(i100)',err=61) sbini
           read(storeinput,*) sbini
         elseif(identifier.eq.'sbfin') then
           read(storeinput,'(i100)',err=61) sbfin
           read(storeinput,*) sbfin
         elseif(identifier.eq.'shh2') then
           read(storeinput,'(i100)',err=61) shh2
           read(storeinput,*) shh2
         elseif(identifier.eq.'scp') then
           read(storeinput,'(i100)',err=61) scp
           read(storeinput,*) scp
         elseif(identifier.eq.'spdf') then
           read(storeinput,'(i100)',err=61) spdf
           read(storeinput,*) spdf
         elseif(identifier.eq.'pdfmap') then
           read(storeinput,'(i100)',err=61) pdfmap
           read(storeinput,*) pdfmap
         elseif(identifier.eq.'pdfname') then
           read(storeinput,'(a100)',err=61) pdfname
           read(storeinput,*) pdfname
           pdfpath=''


         elseif(identifier.eq.'pdfpath') then

           read(storeinput,'(a100)',err=61) pdfpath
           read(storeinput,*) pdfpath
           pdfname=''


         elseif(identifier.eq.'pdfmember') then
           read(storeinput,'(i100)',err=61) pdfmember
           read(storeinput,*) pdfmember
         elseif(identifier.eq.'pdfmemberfrom') then
#ifdef multpdf
           read(storeinput,'(i100)',err=61) pdfmemberfrom
           read(storeinput,*) pdfmemberfrom
#else
           write(*,*) 'define multpdf to use pdfmemberfrom'
           stop
#endif
         elseif(identifier.eq.'pdfmemberto') then
#ifdef multpdf
           read(storeinput,'(i100)',err=61) pdfmemberto
           read(storeinput,*) pdfmemberto
#else
           write(*,*) 'define multpdf to use pdfmemberto'
           stop
#endif
         elseif(identifier.eq.'sfactqcd') then
           read(storeinput,'(i100)',err=61) sfactqcd
           read(storeinput,*) sfactqcd
         elseif(identifier.eq.'sfactqed') then
           read(storeinput,'(i100)',err=61) sfactqed
           read(storeinput,*) sfactqed
         elseif(identifier.eq.'spbrems') then
           read(storeinput,'(i100)',err=61) spbrems(0)
           read(storeinput,*) spbrems(0)
           spbrems(1)=spbrems(0)
         elseif(identifier.eq.'sgbrems') then
           read(storeinput,'(i100)',err=61) sgbrems(0)
           read(storeinput,*) sgbrems(0)
           sgbrems(2)=sgbrems(0)
         elseif(identifier.eq.'spbrems(1)') then
           read(storeinput,'(i100)',err=61) spbrems(1)
           read(storeinput,*) spbrems(1)
         elseif(identifier.eq.'sgbrems(2)') then
           read(storeinput,'(i100)',err=61) sgbrems(2)
           read(storeinput,*) sgbrems(2)
         elseif(identifier.eq.'spinc') then
           read(storeinput,'(i100)',err=61) spinc(0)
           read(storeinput,*) spinc(0)
           spinc(3)=spinc(0)
           spinc(4)=spinc(0)
         elseif(identifier.eq.'sginc') then
           read(storeinput,'(i100)',err=61) sginc(0)
           read(storeinput,*) sginc(0)
           sginc(5)=sginc(0)
           sginc(6)=sginc(0)
         elseif(identifier.eq.'lnoutmc') then
           read(storeinput,'(i100)',err=61) lnoutmc
           read(storeinput,*) lnoutmc
         elseif(identifier.eq.'maxout') then
           read(storeinput,'(i100)',err=61) maxout
           read(storeinput,*) maxout
         elseif(identifier.eq.'lnoutgen') then
           read(storeinput,'(i100)',err=61) lnoutgen
           read(storeinput,*) lnoutgen
         elseif(identifier.eq.'nhisto') then
           read(storeinput,'(i100)',err=61) nhisto
           read(storeinput,*) nhisto
         elseif(identifier.eq.'deltas') then
           read(storeinput,'(f50.50)',err=61) mcslideltas
           read(storeinput,*) mcslideltas
         elseif(identifier.eq.'deltac') then
           read(storeinput,'(f50.50)',err=61) mcslideltac
           read(storeinput,*) mcslideltac
         elseif(identifier.eq.'deltas2') then
           read(storeinput,'(f50.50)',err=61) mcslideltas
           read(storeinput,*) mcslideltas
           mcslideltas=sqrt(mcslideltas)
         elseif(identifier.eq.'deltac2') then
           read(storeinput,'(f50.50)',err=61) mcslideltac
           read(storeinput,*) mcslideltac
           mcslideltac=sqrt(mcslideltac)
         elseif(identifier.eq.'ptcut(jet)') then
           read(storeinput,'(f50.50)',err=61) ptcutj
           read(storeinput,*) ptcutj
         elseif(identifier.eq.'ycut(jet)') then
           read(storeinput,'(f50.50)',err=61) ycutj
           read(storeinput,*) ycutj
         elseif(identifier.eq.'dycut(jet,jet)') then
           read(storeinput,'(f50.50)',err=61) dycutjj
           read(storeinput,*) dycutjj
          elseif(identifier.eq.'mcut(jet,jet)') then
           read(storeinput,'(f50.50)',err=61) mcutjj
           read(storeinput,*) mcutjj
         elseif(identifier.eq.'hemispherecut') then
           read(storeinput,'(i100)',err=61) hemicut
           read(storeinput,*) hemicut
           if(hemicut.eq.1) then
             lhemicut=.true.
           elseif(hemicut.eq.0) then
             lhemicut=.false.
           else
             goto 61
           endif
         elseif(identifier.eq.'higgsbetweenjets') then
           read(storeinput,'(i100)',err=61) higgsbjets
           read(storeinput,*) higgsbjets
           if(higgsbjets.eq.1) then
             lhiggsbjets=.true.
           elseif(higgsbjets.eq.0) then
             lhiggsbjets=.false.
           else
             goto 61
           endif
         elseif(identifier.eq.'ptcut(higgs)') then
           read(storeinput,'(f50.50)',err=61) ptcuth
           read(storeinput,*) ptcuth
         elseif(identifier.eq.'ycut(higgs)') then
           read(storeinput,'(f50.50)',err=61) ycuth
           read(storeinput,*) ycuth
         elseif(identifier.eq.'ecut(higgs)') then
           read(storeinput,'(f50.50)',err=61) ecuth
           read(storeinput,*) ecuth
         elseif(identifier.eq.'mucut(higgs)') then
           read(storeinput,'(f50.50)',err=61) mucuth
           read(storeinput,*) mucuth
         elseif(identifier.eq.'mlcut(higgs)') then
           read(storeinput,'(f50.50)',err=61) mlcuth
           read(storeinput,*) mlcuth
         elseif(identifier.eq.'ptcut(decp)') then
           read(storeinput,'(f50.50)',err=61) ptcuts
           read(storeinput,*) ptcuts
         elseif(identifier.eq.'ycut(decp)') then
           read(storeinput,'(f50.50)',err=61) ycuts
           read(storeinput,*) ycuts
         elseif(identifier.eq.'drcut(jet,decp)') then
           read(storeinput,'(f50.50)',err=61) dRcutjs
           read(storeinput,*) dRcutjs
         elseif(identifier.eq.'dparameter') then
           read(storeinput,'(f50.50)',err=61) ktd
           read(storeinput,*) ktd
         elseif(identifier.eq.'etacut(parton)') then
           read(storeinput,'(f50.50)',err=61) partetacut
           read(storeinput,*) partetacut
         elseif(identifier.eq.'autofreq') then
           read(storeinput,'(i100)',err=61) autofreq
           read(storeinput,*) autofreq
         elseif(identifier.eq.'printweightmax') then
           read(storeinput,'(i100)',err=61) printweightmax
           read(storeinput,*) printweightmax
          if(printweightmax.eq.1) then
             lprintweightmax=.true.
           elseif(printweightmax.eq.0) then
             lprintweightmax=.false.
           else
             goto 61
           endif
         elseif(identifier.eq.'initsteps') then
           read(storeinput,'(i100)',err=61) initsteps
           read(storeinput,*) initsteps
         elseif(identifier.eq.'ranluxseed') then
#ifdef RANLUX
           read(storeinput,'(i100)',err=61) ranluxseed
           read(storeinput,*) ranluxseed
#endif
         elseif(identifier.ne.' ') then
           write(*,*) 'identifier not known:  ',identifier
           write(*,*) 'identifier not known:  ',orgidentifier
           stop
         endif
         goto 50
       else
         directive= inputline(1:isep2-1)
         orgdirective=directive
         do i1=isep2-1,1,-1
           if (directive(i1:i1).eq.' ') then
             directive=directive(1:i1-1)//directive(i1+1:linputline)
     &           //' '
           elseif(directive(i1:i1).ge.'A'.and.directive(i1:i1).le.'Z')
     &         then
             if(directive(i1:i1).eq.'A') then
               directive(i1:i1)='a'
             elseif(directive(i1:i1).eq.'B') then
               directive(i1:i1)='b'
             elseif(directive(i1:i1).eq.'C') then
               directive(i1:i1)='c'
             elseif(directive(i1:i1).eq.'D') then
               directive(i1:i1)='d'
             elseif(directive(i1:i1).eq.'E') then
               directive(i1:i1)='e'
             elseif(directive(i1:i1).eq.'F') then
               directive(i1:i1)='f'
             elseif(directive(i1:i1).eq.'G') then
               directive(i1:i1)='g'
             elseif(directive(i1:i1).eq.'H') then
               directive(i1:i1)='h'
             elseif(directive(i1:i1).eq.'I') then
               directive(i1:i1)='i'
             elseif(directive(i1:i1).eq.'J') then
               directive(i1:i1)='j'
             elseif(directive(i1:i1).eq.'K') then
               directive(i1:i1)='k'
             elseif(directive(i1:i1).eq.'L') then
               directive(i1:i1)='l'
             elseif(directive(i1:i1).eq.'M') then
               directive(i1:i1)='m'
             elseif(directive(i1:i1).eq.'N') then
               directive(i1:i1)='n'
             elseif(directive(i1:i1).eq.'O') then
               directive(i1:i1)='o'
             elseif(directive(i1:i1).eq.'P') then
               directive(i1:i1)='p'
             elseif(directive(i1:i1).eq.'Q') then
               directive(i1:i1)='q'
             elseif(directive(i1:i1).eq.'R') then
               directive(i1:i1)='r'
             elseif(directive(i1:i1).eq.'S') then
               directive(i1:i1)='s'
             elseif(directive(i1:i1).eq.'T') then
               directive(i1:i1)='t'
             elseif(directive(i1:i1).eq.'U') then
               directive(i1:i1)='u'
             elseif(directive(i1:i1).eq.'V') then
               directive(i1:i1)='v'
             elseif(directive(i1:i1).eq.'W') then
               directive(i1:i1)='w'
             elseif(directive(i1:i1).eq.'X') then
               directive(i1:i1)='x'
             elseif(directive(i1:i1).eq.'Y') then
               directive(i1:i1)='y'
             elseif(directive(i1:i1).eq.'Z') then
               directive(i1:i1)='z'
             endif
           endif
         enddo
         write(storeinput,*) inputline(1:isep2-1)


         if(directive.eq.'qcdonly') then
           sborn(0)=1
           svirt(0)=1
           sweak=0
           shh2=0
           sqcddiag=1
           sqcdnondiag=1
           sqcdggfus=1
           sqcdgsplit=1
           spbrems(0)=0
           sgbrems(0)=1
           spbrems(1)=0
           sgbrems(2)=1
           spinc(0)=0
           sginc(0)=1
           spinc(3)=0
           spinc(4)=0
           sginc(5)=1
           sginc(6)=1
         elseif(directive.eq.'bornonly') then
           sborn(0)=1
           svirt(0)=0
           sweak=0
           shh2=0
           sqcddiag=0
           sqcdnondiag=0
           sqcdggfus=0
           sqcdgsplit=0
           spbrems(0)=0
           sgbrems(0)=0
           spbrems(1)=0
           sgbrems(2)=0
           spinc(0)=0
           sginc(0)=0
           spinc(3)=0
           spinc(4)=0
           sginc(5)=0
           sginc(6)=0
           ssub(0)=0
           ssli(0)=0
           seff(0)=0
         elseif(directive.eq.'ewonly') then
           sborn(0)=1
           svirt(0)=1
           sweak=1
           sqcddiag=0
           sqcdnondiag=0
           sqcdggfus=0
           sqcdgsplit=0
           spbrems(0)=1
           sgbrems(0)=0
           spbrems(1)=1
           sgbrems(2)=0
           spinc(0)=1
           sginc(0)=0
           spinc(3)=1
           spinc(4)=1
           sginc(5)=0
           sginc(6)=0
         elseif(directive.eq.'endinput') then
           goto 51
         elseif(directive.ne.' ') then
           write(*,*) 'directive not known:  ',directive
           write(*,*) 'directive not known:  ',orgdirective
           stop
         endif
         goto 50
       end if

 52    write(*,*) 'input not known',inputline
       stop
 61    write(*,*) 'input not appropriate for identifier ''',
     &     identifier(1:isep1-1),''' : ',storeinput
       stop

 51    continue
#ifdef mpiuse
       close(5)
#endif

#endif


c check for inconsistent switches
       if(srecomb(0).eq.0.and.scuts(0).gt.0) then
         write(*,'(a22,a22,i4)')' Inconsistent input: '//
     &       'srecomb = 0 and 0< scuts = ',scuts
         stop
       endif

c check for inconsistent switches
       if(shtr.gt.0.and.sew.ne.0.and.(sonsproj.eq.0.or..not.lonsew))
     &     then
         write(*,'(a44,i2,/a50)') ' Inconsistent input: '//
     &       'sonsproj = 0 and sew = ',sew,
     &       'electroweak corrections need on-shell projection'
         stop
       endif

       nsteps = max(nevents/100,10000)

c initialize pdfs
      if (spdf.ge.10.and.spdf.lt.20) then
        spinc(0)=0
        spinc(3)=0
        spinc(4)=0
        Call SetCtq6(spdf-10)
      else if (spdf.eq.99) then
#ifdef includeLHAPDF
        spinc(0)=0
        spinc(3)=0
        spinc(4)=0
        if (pdfpath.ne.'') then
#ifndef mpiuse
          write(*,*) 'pdfpath = ',pdfpath
#endif
          call InitPDFset(pdfpath)
        elseif(pdfname.ne.'') then
#ifndef mpiuse
          write(*,*) 'pdfname = ',pdfname
#endif
          call InitPDFsetByName(pdfname)
        else
          write(*,*) 'no pdf set specified for LHApdf'
          stop
        endif
        call numberPDF(num)
        If(pdfmember.LT.0.OR.pdfmember.GT.num) Then
	  write(nout,*) 'pdfmember out of range: set to         0'
	  pdfmember=0
	Endif
#ifdef multpdf
	pdfmembercentral=pdfmember
#endif
        call InitPDF(pdfmember)
#else
       Print *,"LHAPDF not included: #define includeLHAPDF"
       Stop
#endif
      endif

      qalps=spdf

c contributions for generator 0 (Born generator)
      sgen(0)=1
c contribution 1: Born
      if (sborn(0).eq.1) sgencon(0,1)=1
      swborn(0)=1
c contribution 2: electroweak virtual - end-point part
      if ((svirt(0).eq.1.or.sendp(0).eq.1).and.
     &    (sweak.ne.0.or.shh2.ne.0))
     &    sgencon(0,2)=1
c contribution 3: singular parts of photonic real and virtual corrections
      if((sweak.eq.1.or.sweak.eq.3).and.spbrems(0).ne.0.and.
     &    (ssub(0).gt.0.or.ssli(0).gt.0.or.seff(0).gt.0))then
        sgencon(0,3)=1
      endif
c contribution 4: singular parts of gluonic real and virtual corrections
      if((sqcddiag.eq.1.or.sqcdnondiag.eq.1).and.sgbrems(0).ne.0.and.
     &    (ssub(0).gt.0.or.ssli(0).gt.0.or.seff(0).gt.0)) then
        sgencon(0,4)=1
      endif
c contribution 5: qcd virtual - end-point part
      if ((svirt(0).eq.1.or.sendp(0).eq.1).and.(sqcddiag.ne.0.or.
     &    sqcdnondiag.ne.0.or.sqcdgsplit.ne.0.or.sqcdggfus.ne.0))
     &    sgencon(0,5)=1
c contribution 6: incoming photon contribution 1
      if((sweak.eq.1.or.sweak.eq.3).and.spinc(0).ne.0.and.
     &    (ssub(0).gt.0.or.ssli(0).gt.0.or.seff(0).gt.0)) then
        sgencon(0,6)=1
      endif

c contribution 7: incoming photon contribution 2
      if((sweak.eq.1.or.sweak.eq.3).and.spinc(0).ne.0.and.
     &    (ssub(0).gt.0.or.ssli(0).gt.0.or.seff(0).gt.0)) then
        sgencon(0,7)=1
      endif
c contribution 8: incoming gluon contribution 1
      if((sqcddiag.ne.0.or.sqcdnondiag.ne.0).and.sginc(0).ne.0.and.
     &    (ssub(0).gt.0.or.ssli(0).gt.0.or.seff(0).gt.0)) then
        sgencon(0,8)=1
      endif
c contribution 9: incoming gluon contribution 2
      if((sqcddiag.ne.0.or.sqcdnondiag.ne.0).and.sginc(0).ne.0.and.
     &    (ssub(0).gt.0.or.ssli(0).gt.0.or.seff(0).gt.0)) then
        sgencon(0,9)=1
      endif

c contributions for generator 1 (real photon radiation)
c contribution 1: real corrections - subtraction terms
      if (spbrems(1).ne.0) sgen(1)=1

c contributions for generator 2 (real gluon radiation)
c contribution 1: real corrections - subtraction terms
      if ((sqcddiag.eq.1.or.sqcdnondiag.eq.1).and.sgbrems(2).ne.0)
     &    sgen(2)=1

c contributions for generator 3 (incoming photon contribution 1)
c contribution 1: real corrections - subtraction terms
      if (spinc(3).ne.0) sgen(3)=1

c contributions for generator 4 (incoming photon contribution 2)
c contribution 1: real corrections - subtraction terms
      if (spinc(4).ne.0) sgen(4)=1

c contributions for generator 5 (incoming gluon contribution 1)
c contribution 1: real corrections - subtraction terms
      if ((sqcddiag.eq.1.or.sqcdnondiag.eq.1).and.sginc(5).ne.0)
     &    sgen(5)=1

c contributions for generator 5 (incoming gluon contribution 2)
c contribution 1: real corrections - subtraction terms
      if ((sqcddiag.eq.1.or.sqcdnondiag.eq.1).and.sginc(6).ne.0)
     &    sgen(6)=1

      if (sincludecuts(0).gt.2.and.mcutjj.gt.0d0) then
        write(*,*)
        write(*,*) ' sincludecuts > 2 not allowed in presence of '
     &      //'invariant-mass cuts'
        write(*,*) ' sincludecuts = ',sincludecuts(0)
        stop
      endif

      do gen=1,maxg
        sgencon(gen,1)=sgen(gen)
        ssub(gen)=ssub(0)
        ssli(gen)=ssli(0)
        seff(gen)=seff(0)
        sincludecuts(gen)=sincludecuts(0)
      enddo

      if (ssli(0).ne.0.and.ssub(0).ne.0.or.
     &    ssli(0).ne.0.and.seff(0).ne.0.or.
     &    seff(0).ne.0.and.ssub(0).ne.0) then
        write(*,*)
        write(*,*) ' either slicing or subtraction or '
     &      ,'effective collinear factors must be used'
        write(*,*) ' ssli = ',ssli(1)
        write(*,*) ' ssub = ',ssub(1)
        write(*,*) ' seff = ',seff(1)
        stop
      endif

      if(autofreq.eq.1)then
        if(sgencon(0,1).eq.1.or.sgencon(0,4).eq.1) freqgencon(0,2)=100
        if(sgencon(0,1).eq.1.or.sgencon(0,4).eq.1) freqgencon(0,5)=10
        if(sgencon(0,4).eq.1) freqgencon(0,3)=10
        if(sgencon(0,8).eq.1) freqgencon(0,6)=10
        if(sgencon(0,9).eq.1) freqgencon(0,7)=10
        if(sgencon(2,1).eq.1) freqgencon(1,1)=10
        if(sgencon(5,1).eq.1) freqgencon(3,1)=10
        if(sgencon(6,1).eq.1) freqgencon(4,1)=10
c for subtraction
      elseif(autofreq.eq.2)then
        if(sgencon(0,1).eq.1) then
          freqgencon(0,2)=1000
          freqgencon(0,3)=100
          freqgencon(0,4)=5
          freqgencon(0,5)=100
          freqgencon(0,6)=100
          freqgencon(0,7)=100
          freqgencon(0,8)=10
          freqgencon(0,9)=10
          freqgencon(1,1)=100
          freqgencon(2,1)=5
          freqgencon(3,1)=100
          freqgencon(4,1)=100
          freqgencon(5,1)=10
          freqgencon(6,1)=10
        else if(
     &      sgencon(2,1).eq.1.or.sgencon(0,4).eq.1)then
          freqgencon(0,2)=200
          freqgencon(0,3)=20
          freqgencon(0,4)=1
          freqgencon(0,5)=20
          freqgencon(0,6)=20
          freqgencon(0,7)=20
          freqgencon(0,8)=2
          freqgencon(0,9)=2
          freqgencon(1,1)=20
          freqgencon(2,1)=1
          freqgencon(3,1)=20
          freqgencon(4,1)=20
          freqgencon(5,1)=2
          freqgencon(6,1)=2
        elseif(sgencon(0,8).eq.1.or.sgencon(0,9).eq.1.or.
     &    sgencon(5,1).eq.1.or.sgencon(6,1).eq.1)then
          freqgencon(0,2)=100
          freqgencon(0,3)=10
          freqgencon(0,5)=10
          freqgencon(0,6)=10
          freqgencon(0,7)=10
          freqgencon(0,8)=1
          freqgencon(0,9)=1
          freqgencon(1,1)=10
          freqgencon(3,1)=10
          freqgencon(4,1)=10
          freqgencon(5,1)=1
          freqgencon(6,1)=1
        elseif(sgencon(0,2).eq.1.or.sgencon(0,3).eq.1.or.
     &        sgencon(0,5).eq.1.or.
     &        sgencon(0,8).eq.1.or.sgencon(0,9).eq.1.or.
     &        sgencon(3,1).eq.1.or.sgencon(4,1).eq.1) then
          freqgencon(0,2)=10
          freqgencon(0,3)=1
          freqgencon(0,5)=1
          freqgencon(0,6)=1
          freqgencon(0,7)=1
          freqgencon(1,1)=1
          freqgencon(3,1)=1
          freqgencon(4,1)=1
        endif
c for slicing
      elseif(autofreq.eq.3)then
        if(sgencon(0,1).eq.1.or.
     &      sgencon(2,1).eq.1.or.sgencon(0,4).eq.1)then
          freqgencon(0,2)=10000
          freqgencon(0,3)=100
          freqgencon(0,4)=1
          freqgencon(0,5)=1000
          freqgencon(0,6)=10000
          freqgencon(0,7)=10000
          freqgencon(0,8)=100
          freqgencon(0,9)=100
          freqgencon(1,1)=10
          freqgencon(2,1)=1
          freqgencon(3,1)=1000
          freqgencon(4,1)=1000
          freqgencon(5,1)=10
          freqgencon(6,1)=10
        elseif(sgencon(1,1).eq.1.or.
     &    sgencon(5,1).eq.1.or.sgencon(6,1).eq.1)then
          freqgencon(0,2)=10
          freqgencon(0,2)=1000
          freqgencon(0,3)=10
          freqgencon(0,5)=100
          freqgencon(0,6)=1000
          freqgencon(0,7)=1000
          freqgencon(0,8)=10
          freqgencon(0,9)=10
          freqgencon(1,1)=1
          freqgencon(3,1)=100
          freqgencon(4,1)=100
          freqgencon(5,1)=1
          freqgencon(6,1)=1
        elseif(sgencon(0,2).eq.1.or.sgencon(0,3).eq.1.or.
     &    sgencon(0,8).eq.1.or.sgencon(0,9).eq.1)then
          freqgencon(0,2)=1
          freqgencon(0,2)=100
          freqgencon(0,3)=1
          freqgencon(0,5)=10
          freqgencon(0,6)=100
          freqgencon(0,7)=100
          freqgencon(0,8)=1
          freqgencon(0,9)=1
          freqgencon(3,1)=10
          freqgencon(4,1)=10
        elseif(sgencon(0,5).eq.1.or.
     &    sgencon(3,1).eq.1.or.sgencon(4,1).eq.1) then
          freqgencon(0,2)=10
          freqgencon(0,5)=1
          freqgencon(0,6)=10
          freqgencon(0,7)=10
          freqgencon(3,1)=1
          freqgencon(4,1)=1
        endif
      endif


      if(lprintweightmax) then
        open(unit=20,file='dat.weightmax',status='unknown')
      endif






      if(sqcddiag.eq.0.and.sqcdnondiag.eq.0.and.sgen(2).eq.0.and.
     &    sgen(5).eq.0.and.sgen(6).eq.0)then

        if(shtr.eq.0)then
          smodel=1
        else
          smodel=15
        endif
        if(spinc(4).eq.1)then
          ngenerator=4
        elseif(spinc(3).eq.1)then
          ngenerator=3
        else
          ngenerator=1
        endif
      else
        if(shtr.eq.0)then
          smodel=12
        else
          smodel=125
        endif
        if(sginc(6).eq.1)then
          ngenerator=6
        elseif(sginc(5).eq.1)then
          ngenerator=5
        else
          ngenerator=2
        endif
      endif

c equal parameters for all generators
      do gen=0,ngenerator
        scuts(gen)=scuts(0)
        srecomb(gen)=srecomb(0)
        recparam(1,gen)=recparam(1,0)
        recparam(2,gen)=recparam(2,0)
        recparam(3,gen)=recparam(3,0)
        recparam(4,gen)=recparam(4,0)
        sconv(gen)=sconv(0)
        name(1,gen)='proton'
        name(2,gen)='proton'
        name(3,gen)='jet'
        name(4,gen)='jet'
        name(5,gen)='h0'
        name(6,gen)='photon'
      enddo

c fixing external particles of bremsstrahlung generators
      if(sgen(1).eq.1)then
        gen=1
        nextgen(gen)=nextgen(0)+1
        name(nextgen(gen),gen)='photon'
        nextmax=max(nextmax,nextgen(gen))
      endif
      if(sgen(2).eq.1)then
        gen=2
        nextgen(gen)=nextgen(0)+1
        nextmax=max(nextmax,nextgen(gen))
        name(nextgen(gen),gen)='gluon'
      endif
c fixing external particles of incoming photon generators
      if(sgen(3).eq.1)then
        gen=3
        nextgen(gen)=nextgen(0)+1
        nextmax=max(nextmax,nextgen(gen))
        name(nextgen(gen),gen)='jet'
        name(1,gen)='photon'
      endif
      if(sgen(4).eq.1)then
        gen=4
        nextgen(gen)=nextgen(0)+1
        nextmax=max(nextmax,nextgen(gen))
        name(nextgen(gen),gen)='jet'
        name(2,gen)='photon'
      endif
c fixing external particles of incoming gluon generators
      if(sgen(5).eq.1)then
        gen=5
        nextgen(gen)=nextgen(0)+1
        nextmax=max(nextmax,nextgen(gen))
        name(nextgen(gen),gen)='jet'
        name(1,gen)='gluon'
      endif
      if(sgen(6).eq.1)then
        gen=6
        nextgen(gen)=nextgen(0)+1
        nextmax=max(nextmax,nextgen(gen))
        name(nextgen(gen),gen)='jet'
        name(2,gen)='gluon'
      endif

c nextsub: charged external particles:  p p , j j for born

      nextsub(0)=4
      do gen=0,ngenerator
        nextme(gen)=nextgen(gen)
        nextsub(gen)=nextsub(0)
      enddo

      if(shtr.gt.0)then
        do gen=0,ngenerator
          nextgen(gen)=nextgen(gen)+1
          if(gen.eq.0)then
            name(5,gen)='s0'
            name(nextgen(gen),gen)='s0'
          else
            name(nextgen(gen),gen)= name(nextgen(gen)-1,gen)
            name(5,gen)='s0'
            name(6,gen)='s0'
          endif
        enddo
        nextmax=nextmax+1
      endif




c switches for contributions of real generators
      do gen=1,ngenerator
        sgencon(gen,1)=sgen(gen)
      enddo


c equal recombination parameters for all generators
      do gen=0,ngenerator
        recparam(1,gen)=recparam(1,0)
        recparam(2,gen)=recparam(2,0)
        recparam(3,gen)=recparam(3,0)
        recparam(4,gen)=recparam(4,0)
      enddo


      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     setting input parameters                                    c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
***********************************************************************
      subroutine inputparameter
***********************************************************************
*     setting defaults for global input parameters                    *
*---------------------------------------------------------------------*
*     24.07.07  Ansgar Denner     last changed  24.07.07              *
***********************************************************************
      implicit none

#include "mcinput.h"

      alpha0in  = 1d0/137.03599911d0
      alphazin  = 1d0/128.936d0
c     alphasz = 0.1187d0           ! in fixparameter
      GFin      = 1.16637D-5

      mzin   = 91.1876d0
      gzin   = 2.4952d0
      mwin   = 80.425d0
      gwin   = 2.124d0
      mhin   = 120d0
      ghin   = 0.004412d0

      mein   = .51099892d-3
      mmuin  = .105658369d0
      mtauin = 1.77699d0
      mdin  = .066d0
      muin  = .066d0
      msin  = .150d0
      mcin  = 1.2d0
      mbin  = 4.3d0
      mtin  = 174.3d0

      vin(1,1) = 1d0
      vin(1,2) = 0d0
      vin(2,1) = 0d0
      vin(2,2) = 1d0
      vin(1,3) = 0d0
      vin(2,3) = 0d0
      vin(3,1) = 0d0
      vin(3,2) = 0d0
      vin(3,3) = 1d0

      lambdain=1d0
      mudim2in=1d0

      gevtofbin=389379660D3

      end
***********************************************************************
      subroutine fixparameter
***********************************************************************
*     setting dependent parameters                                    *
*---------------------------------------------------------------------*
*     24.07.07  Ansgar Denner     last changed  24.07.07              *
***********************************************************************
      implicit none
      real*8   wfac,zfac
      real*8   alphasf

      integer iNumProcs, iErr, iMyRank
      common/mpistuff/iNumProcs,iMyRank

#include "mcinput.h"
#include "mcparams.h"

c mcoutput        in generator and montecarlo
      integer nout,numout,maxout,noutgen,nsteps,lnoutmc
      common/mcoutput/nout,numout,maxout,noutgen,nsteps,lnoutmc

c qcdrenscale
      real*8 qcdrenscale,qcdrenscale2,qcdrenscalefac
      common /qcdrenscale/ qcdrenscale,qcdrenscale2,qcdrenscalefac

c mcpdf         in public and montecarlo
      real*8 pdf1(-6:6),pdf2(-6:6),pdf_phot1,pdf_phot2
      integer spdf,pdfmap
      common/mcpdf/pdf1,pdf2,pdf_phot1,pdf_phot2,spdf,pdfmap
c mcoptions  in public and montecarlo, initamps
      integer salp
      common/mcrs/salp

      integer nf
      real*8  lambdalo,lambdanlo
      common/qcd/lambdalo,lambdanlo,nf

c LHAPDF
      integer nfmax,num,order
      real*8  alphasPDF,muf,qcdl5

#ifdef multpdf
#include "multpdf.h"
      integer nset
#endif

c transition to pole definition
      wfac = sqrt(1d0+(gwin/mwin)**2)
      mwin   = mwin/wfac
      gwin   = gwin/wfac
      zfac = sqrt(1d0+(gzin/mzin)**2)
      mzin   = mzin/zfac
      gzin   = gzin/zfac


C*** renormalization scheme
        if (salp.eq.0) then
          alphain = alpha0in
        elseif (salp.eq.1) then
          alphain = alphazin
        elseif (salp.eq.2) then
          alphain = sqrt(2d0)*gfin/pi*mwin*mwin
     &        *(1d0-mwin*mwin/(mzin*mzin))
        elseif (salp.eq.3) then
          alphain = alphazin
        endif

c initialize running alphas
      if (spdf.eq.1.or.spdf.eq.2) then
        alphaszin=0.1187d0
        call fixlambdas(mzin,alphaszin,2,5)
      elseif(spdf.eq.11) then
        alphaszin=0.118d0
        call fixlambdas(mzin,alphaszin,2,5)
      elseif(spdf.eq.14) then
        alphaszin=0.130d0
        call fixlambdas(mzin,alphaszin,1,5)
      elseif(spdf.eq.99) then
#ifdef includeLHAPDF
        alphaszin=alphasPDF(mzin)
        call numberPDF(num)
        if(lnoutmc.ge.3)then
          If(iMyrank.EQ.0) write(nout,*) 'members in pdf set:',num
          call GetDesc()
          call GetLam5(1,qcdl5)
          If(iMyrank.EQ.0) write(nout,*) 'lambda5_qcd:',qcdl5
          call GetOrderPDF(order)
          If(iMyrank.EQ.0) write(nout,*) 'order of pdf set:',order
          call GetOrderAS(order)
          If(iMyrank.EQ.0) write(nout,*)
     &     'order of alphas evol:',order
          call GetRenFac(muf)
          If(iMyrank.EQ.0) write(nout,*)
     &     'renormalization factor:',muf
          call GetNF(muf)
          If(iMyrank.EQ.0) write(nout,*) 'number of flavors:',nfmax
        endif
#else
       Print *,"LHAPDF not included: #define includeLHAPDF"
       Stop
#endif
      endif

      call getqcdrenscale(mwin)
      if (spdf.eq.1.or.spdf.eq.2.or.spdf.eq.11) then
        alphasin=alphasf(qcdrenscale,2)
      elseif(spdf.eq.14) then
        alphasin=alphasf(qcdrenscale,1)
      elseif(spdf.eq.99) then
#ifdef includeLHAPDF
#ifdef multpdf
        If(pdfmemberfrom.LT.0.OR.pdfmemberfrom.GT.num) Then
	  write(nout,*) 'pdfmemberfrom = ',pdfmemberfrom
	  write(nout,*) 'pdfmemberfrom out of range: set to         0'
	  pdfmemberfrom=0
	Endif
        If(pdfmemberto.LT.0.OR.pdfmemberto.GT.num) Then
	  write(nout,*) 'pdfmemberto = ',pdfmemberto
	  write(nout,*) 'pdfmemberto out of range: set to ',num
	  pdfmemberto=num
	Endif
        If(pdfmemberto.LT.pdfmemberfrom) Then
	  write(nout,*) 'pdfmemberto smaller than pdfmemberfrom'
	  write(nout,*) 'no additional PDF sets will be calculated'
	Endif
        If(pdfmemberto-pdfmemberfrom+1.GT.maxpdf) Then
	  write(nout,*) 'Too many PDF sets requested'
	  write(nout,*) 'current limit is',maxpdf,' PDFs at once'
	  pdfmemberto=pdfmemberfrom+maxpdf-1
	  write(nout,*) 'pdfmemberto set to ',pdfmemberto
	Endif
	call InitPDF(pdfmembercentral)
	alphasin=alphasPDF(qcdrenscale)
	do nset=1,pdfmemberto-pdfmemberfrom+1
	  call InitPDF(pdfmemberfrom-1+nset)
	  alphasratio(nset)=alphasPDF(qcdrenscale)/alphasin
	enddo
        call InitPDF(pdfmembercentral)
#else
        alphasin=alphasPDF(qcdrenscale)
#endif
#else
       Print *,"LHAPDF not included: #define includeLHAPDF"
       Stop
#endif
      endif

      lambdain=mwin
      mudim2in=mwin*mwin

      end
***********************************************************************
      subroutine mcparameter
***********************************************************************
*     setting input parameters for Monte Carlo generator              *
*---------------------------------------------------------------------*
*     30.01.06  Ansgar Denner     last changed  30.01.06              *
***********************************************************************
      implicit none

#include "mcinput.h"
#include "mcparams.h"
#include "mccommon.h"


c rcoptions
      integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
      common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

c rscheme
      complex*16 dalpz,drbos,drferm
      integer qalp
      common/rscheme/dalpz,drbos,drferm,qalp


c conversion of units
      mcgevtofb=gevtofbin      ! conversion factor GeV^-2 to fbarns

c particle masses in mc (in generator: mcmass)
      do mcpart=1,maxv
         mcm(mcpart)=0
         mcw(mcpart)=0
      enddo
      mcm(1)=mdin          ! d-quark mass
      mcm(2)=muin          ! u-quark mass
      mcm(3)=msin          ! s-quark mass
      mcm(4)=mcin          ! c-quark mass
      mcm(5)=mbin          ! b-quark mass
      mcm(6)=mtin          ! t-quark mass
      mcw(6)=0d0           ! t-quark width
      mcm(11)=mein         ! electron mass
      mcm(13)=mmuin        ! muon mass
      mcm(15)=mtauin       ! tau mass
      mcm(23)=mzin         ! z-boson mass
      mcw(23)=gzin         ! z-boson width
      mcm(24)=mwin         ! w-boson boson
      mcw(24)=gwin         ! w-boson width
      mcm(25)=mhin         ! higgs mass
      mcw(25)=ghin         ! higgs width
      mcm(29)=0d0          ! singlet mass

c for output only
      mcalphasz=alphaszin

c parameters for subtraction terms
      mcalpha=alphain
      mcalphas=alphasin
      mclambda=lambdain
c parton masses for subtraction terms
      nparton =4
      m2parton(1)= mdin*mdin
      m2parton(2)= muin*muin
      m2parton(3)= msin*msin
      m2parton(4)= mcin*mcin


      do iparton=1,nparton
        m2parton(-iparton)=m2parton(iparton)
      enddo

c number of evaluation of virtual corrections
      nvirt=100


c other redundant parameters
      mcalpha0=alpha0in
      mcalphaz=alphazin
      mcgf    = gfin
      mccw= mwin/mzin


c     parameters for mappings:
c     mapping of fermion splitting function denominators with power
c     for gluon splitting 0.7 is slightly better than 0.8 which is
c                                         better than 0.9
c                         1.0 is much worse and larger does not work
      powersplitf=0.95d0
      powersplitf=0.9d0
      powersplitf=0.8d0
c     mapping of photon splitting function denominators with power
c     0.5 better than 0.8 and 0.95 and slightly better than 0.1
c      powersplitp=0.8d0
c      powersplitp=0.95d0
      powersplitp=0.1d0
      powersplitp=0.5d0
c     mapping of x in phase-space transformations with power
      powerexmap=0.8d0
c     powerexmap=0.9d0
c     default mapping of massless propagators with power
      powerprop=0.9d0
c technical parameters in h function and subroutine process
      if(ssub(1).gt.0.or.ssub(2).gt.0)then
        techparam(1)=1d-4       ! small negative mass2 in mapinv-function
      else
        techparam(1)=1d-8
      endif
      techparam(2)=1d-10*energy**2  ! allowed uncertainty tmax in process
      techparam(3)=1d-12*energy     ! allowed uncertainty (q1+q2)_T in process
c good values are between 10^-8 and 10^-12, 10^-15 is already worse
      techparam(4)=1d-10            ! technical cut for x integration
c      techparam(4)=0d0

c mass for effective collinear factors
      mcollreg2=1d-6

c cut on collinear invariant, should be smaller than mcollreg2/shat

      mceffcut=1d-10
      mceffcut=1d-16
      mceffcut=1d-12

#ifndef READINPUT
c     cut parameters
c     slicing cuts
      mcslideltac=1d-6
      mcslideltas=1d-4

#endif



      if(ssli(0).ne.0)then
        omxmaxf=mcslideltas
      elseif(ssub(0).ne.0.or.seff(0).ne.0)then
        omxmaxf=techparam(4)
      endif

c used for testing

      omxmaxp=techparam(4)

      if(ssli(0).ne.0d0.or.ssub(0).ne.0d0)then
      if (powersplitf.ge.1d0.and.omxmaxf.eq.0) then
        write(*,*) ' powersplitf >= 1d0 and omxmaxf = 0d0 not allowed'
        stop
      elseif (powersplitp.ge.1d0.and.omxmaxp.eq.0) then
        write(*,*) ' powersplitp >= 1d0 and omxmaxp = 0d0 not allowed'
        stop
      elseif (powerexmap.ge.1d0) then
        write(*,*) ' powerexmap >= 1d0 not allowed'
        stop
      else if (powerprop.ge.1d0.and.techparam(1).eq.0d0) then
        write(*,*) ' powerprop >= 1d0 and',
     &      ' techparam(1) = 0d0 not allowed'
        stop
      end if
      endif

c     parameters for subtraction branch
c     technical cuts for subtraction
      tcdeltae=0d0
      tcdeltas=1d-4
      tcdeltac=1d0
c changed AD!!!
      tcdeltas=1d-8

c for testing
      tcdeltas=0d0
c this is appropriate for inga2
c       tcdeltas=1d-13
c this is appropriate for inga1
c       tcdeltas=1d-15
c this is best for ingl
      tcdeltas=1d-12


      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     non-standard couplings                                      c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      function nonstandardcoup(p1,p2,p3,g1,g2,g3,schannel)
      implicit none
c local variables
      character*3 p1,p2,p3,g1,g2,g3
      logical nonstandardcoup,schannel
c nonsmcoupl
      real*8 dkg,lg,ac,a0,a0t,gaah
      common/nonsmcoupl/dkg,lg,ac,a0,a0t,gaah
      nonstandardcoup=.true.
      if(gaah.ne.0d0.and.g1.eq.'h0 '.and.g2.eq.'ph '.and.g3.eq.'ph ')
     *  return
      if(ac.ne.0d0.or.a0.ne.0d0.or.a0t.ne.0d0)then
        if(g1.eq.'ph '.and.g2.eq.'ph '.and.g3.eq.'16 ')return
        if(g1.eq.'Z0 '.and.g2.eq.'Z0 '.and.g3.eq.'16~')return
      endif
      nonstandardcoup=.false.
      end

***********************************************************************
      subroutine settings(kbeam,k,lweight,n,gen,step)
***********************************************************************
*     filling of individual histograms                                *
*     definition of histograms done here                              *
*     kbeam: beam momenta                                             *
*     k    : momenta of event                                         *
*     lweight(maxon): weights of (sub)event                           *
*     n    : event number                                             *
*     gen  : generator                                                *
*     steps: flag for subroutine histogram                            *
*           steps=1: initialization                                   *
*           steps=2: start filling histograms                         *
*           steps=3: finish filling of histograms                     *
*           steps=4: print data for histograms                        *
*     adapted from COFFERGG by Markus Roth                            *
*---------------------------------------------------------------------*
*     31.10.06  Ansgar Denner     last changed  21.03.07              *
***********************************************************************
      implicit none

#include "mcparams.h"
#include "mccommon.h"

c local variables
      real*8 kbeam(2,0:3),k(maxe,0:3),lweight(maxcon),lenergy,x
      real*8 kt(maxe),y(maxe)
      real*8 denum,kh(0:3),khvec
      integer n,step,histo,switch
      integer jet1,jet2,nbin,count
      integer lastp
      character*30 hname

      save count
      data nbin /100/

      if(step.eq.2)then
        do icon=1,maxcon
          if (lweight(icon).ne.0d0) goto 100
        enddo
        return
      endif

 100  continue
      switch=0
      lenergy=kbeam(1,0)+kbeam(2,0)

      if(shtr.eq.0)then
        do vcomp=0,3
          kh(vcomp)=k(5,vcomp)
        enddo
        lastp=6
      else
        do vcomp=0,3
          kh(vcomp)=k(5,vcomp)+k(6,vcomp)
        enddo
        lastp=7
      endif

c declaration: histogram(hname,y,x,min,max,parts,histo,n,addpoint,step)
c total cross section
      histo=1
      hname='dat.tot'
      call histogram(hname,lweight,lenergy+0.5d0,lenergy,lenergy+1d0,1,
     *  histo,n,0,gen,step)
c transverse momentum of Higgs boson
      histo=histo+1
      hname='dat.pth'
        x=sqrt(kh(1)**2+kh(2)**2)
      call histogram(hname,lweight,x,0d0,5d2,nbin,histo,n,1,gen,step)
c rapidity of Higgs boson
      histo=histo+1
      hname='dat.yh'
      if(kh(0)-kh(3).ne.0d0.and.kh(0)+kh(3).ne.0d0) then
        x=.5d0*log((kh(0)+kh(3))/(kh(0)-kh(3)))
      else
        x=1d10
      endif
      call histogram(hname,lweight,x,-5d0,5d0,nbin,histo,n,1,gen,step)
c pseudorapidity of Higgs boson
      histo=histo+1
      hname='dat.etah'
      if(sqrt(kh(1)**2+kh(2)**2+kh(3)**2).ne.0d0) then
c        x=acos(kh(3)/sqrt(kh(1)**2+kh(2)**2+kh(3)**2))
        x=min(1d0,max(-1d0,kh(3)/sqrt(kh(1)**2+kh(2)**2+kh(3)**2)))
        x=acos(x)
        if(x.ne.0d0)then
          x=-log(tan(x/2))
        else
          x=1d10
        endif
      endif
      call histogram(hname,lweight,x,-5d0,5d0,nbin,histo,n,1,gen,step)

c select tagging jets with highest pt
      kt(3)=sqrt(k(3,1)**2+k(3,2)**2)
      kt(4)=sqrt(k(4,1)**2+k(4,2)**2)
      kt(lastp)=sqrt(k(lastp,1)**2+k(lastp,2)**2)
      if(kt(3).gt.kt(4).and.kt(3).gt.kt(lastp))then
        jet1=3
        if(kt(4).gt.kt(lastp))then
          jet2=4
        else
          jet2=lastp
        endif
      elseif(kt(4).gt.kt(3).and.kt(4).gt.kt(lastp))then
        jet1=4
        if(kt(3).gt.kt(lastp))then
          jet2=3
        else
          jet2=lastp
        endif
      else
        jet1=lastp
        if(kt(3).gt.kt(4))then
          jet2=3
        else
          jet2=4
        endif
      endif


c distributions in pt of leading and subleading jet
      histo=histo+1
      hname='dat.ptjmax1pt'
      x=kt(jet1)
      if(x.eq.0d0) x=-1d0
      call histogram(hname,lweight,x,0d0,400d0,nbin,histo,n,1,gen,step)
      histo=histo+1
      hname='dat.ptjmax2pt'
      if(x.eq.0d0) x=-1d0
      x=kt(jet2)
      call histogram(hname,lweight,x,0d0,150d0,nbin,histo,n,1,gen,step)

c distributions in y of leading and subleading jet
      histo=histo+1
      hname='dat.yjmax1pt'
      if(k(jet1,0)-k(jet1,3).ne.0d0.and.k(jet1,0)+k(jet1,3).ne.0d0) then
        y(jet1)=.5d0*log((k(jet1,0)+k(jet1,3))/(k(jet1,0)-k(jet1,3)))
      else
        y(jet1)=1d10
      endif
      x=y(jet1)
      call histogram(hname,lweight,x,-5d0,5d0,nbin,histo,n,1,gen,step)
      histo=histo+1
      hname='dat.yjmax2pt'
      if(k(jet2,0)-k(jet2,3).ne.0d0.and.k(jet2,0)+k(jet2,3).ne.0d0) then
        y(jet2)=.5d0*log((k(jet2,0)+k(jet2,3))/(k(jet2,0)-k(jet2,3)))
      else
        y(jet2)=-1d10
      endif
      x=y(jet2)
      call histogram(hname,lweight,x,-5d0,5d0,nbin,histo,n,1,gen,step)

c distribution in dy of leading and subleading jet
      histo=histo+1
      hname='dat.dyjjmaxpt'
      if(y(jet1).lt.1d10.and.y(jet2).gt.-1d10)then
        x=y(jet1)-y(jet2)
      else
        x=2d10
      endif


      call histogram(hname,lweight,x,-10d0,10d0,nbin,histo,n,1,gen,step)

      if(scuts(gen).gt.0.and.
     &    abs(x).lt.dycutjj.and.lweight(1).ne.0d0.and.count.lt.100) then
        count=count+1
        write(*,*) 'dycut violated, step = ',step
        write(*,*) 'jet momenta  '
        do ext=3,lastp
          do vcomp=0,3
            write(*,900) ext,vcomp,k(ext,vcomp)
          enddo
        enddo
 900    format(6x,' p(',i1,',',i1,')    = ',d20.14)
        write(*,*) 'jet transverse momenta   kT= ',kt(3),kt(4),kt(lastp)
        write(*,*) 'leading jets =',jet1,jet2
        write(*,*) 'y(leading jets) =',y(jet1),y(jet2),y(jet1)-y(jet2),
     &      dycutjj
        write(*,*) 'kt(leading jets) =',kt(jet1),kt(jet2)
        write(*,*) 'nevent ',nevt
      endif

c distribution in dphi of leading and subleading jet
      histo=histo+1
      hname='dat.dphijjmaxpt'
      if(kt(jet1)*kt(jet2).ne.0d0)then
        x=(k(jet1,1)*k(jet2,1)+k(jet1,2)*k(jet2,2))/(kt(jet1)*kt(jet2))


        if(x.ge.1d0) then
          x =0d0
        elseif (x.le.-1d0) then
          x=180d0
        else
          x=acos(x)*180d0/pi
        endif
      else
        x=-3d0
      endif
      if(x.eq.0)x=-1d0


      call histogram(hname,lweight,x,0d0,180d0,nbin,
     &    histo,n,1,gen,step)

c distribution in invariant mass of leading and subleading jet
      histo=histo+1
      hname='dat.mjjmaxpt'
      x=((k(jet1,0)+k(jet2,0))**2  -(k(jet1,1)+k(jet2,1))**2
     &      -(k(jet1,2)+k(jet2,2))**2  -(k(jet1,3)+k(jet2,3))**2)
      if(x.le.0d0) then
        x=0d0
      else
        x=sqrt(x)
      endif


      call histogram(hname,lweight,x,0d0,3000d0,nbin,
     &    histo,n,1,gen,step)


c select tagging jets with highest energies
      if(k(3,0).gt.k(4,0).and.k(3,0).gt.k(lastp,0))then
        jet1=3
        if(k(4,0).gt.k(lastp,0))then
          jet2=4
        else
          jet2=lastp
        endif
      elseif(k(4,0).gt.k(3,0).and.k(4,0).gt.k(lastp,0))then
        jet1=4
        if(k(3,0).gt.k(lastp,0))then
          jet2=3
        else
          jet2=lastp
        endif
      else
        jet1=lastp
        if(k(3,0).gt.k(4,0))then
          jet2=3
        else
          jet2=4
        endif
      endif
      kt(jet1)=sqrt(k(jet1,1)**2+k(jet1,2)**2)
      kt(jet2)=sqrt(k(jet2,1)**2+k(jet2,2)**2)

c distributions in pt of leading and subleading jet
      histo=histo+1
      hname='dat.ptjmax1e'
      x=kt(jet1)
      if(x.eq.0d0) x=-1d0


      call histogram(hname,lweight,x,0d0,400d0,nbin,histo,n,1,gen,step)
      histo=histo+1
      hname='dat.ptjmax2e'
      x=kt(jet2)
      if(x.eq.0d0) x=-1d0


      call histogram(hname,lweight,x,0d0,150d0,nbin,histo,n,1,gen,step)

c distributions in y of leading and subleading jet
      histo=histo+1
      hname='dat.yjmax1e'
      if(k(jet1,0)-k(jet1,3).ne.0d0.and.k(jet1,0)+k(jet1,3).ne.0d0) then
        y(jet1)=.5d0*log((k(jet1,0)+k(jet1,3))/(k(jet1,0)-k(jet1,3)))
      else
        y(jet1)=1d10
      endif
      x=y(jet1)


      call histogram(hname,lweight,x,-5d0,5d0,nbin,histo,n,1,gen,step)
      histo=histo+1
      hname='dat.yjmax2e'
      if(k(jet2,0)-k(jet2,3).ne.0d0.and.k(jet2,0)+k(jet2,3).ne.0d0) then
        y(jet2)=.5d0*log((k(jet2,0)+k(jet2,3))/(k(jet2,0)-k(jet2,3)))
      else
        y(jet2)=-1d10
      endif
      x=y(jet2)


      call histogram(hname,lweight,x,-5d0,5d0,nbin,histo,n,1,gen,step)

c distribution in dy of leading and subleading jet
      histo=histo+1
      hname='dat.dyjjmaxe'
      x=y(jet1)-y(jet2)


      call histogram(hname,lweight,x,-10d0,10d0,nbin,histo,n,1,gen,step)

c distribution in dphi of leading and subleading jet
      histo=histo+1
      hname='dat.dphijjmaxe'
      if(kt(jet1)*kt(jet2).ne.0d0)then
        x=(k(jet1,1)*k(jet2,1)+k(jet1,2)*k(jet2,2))/(kt(jet1)*kt(jet2))
        if(x.ge.1d0) then
          x =0d0
        elseif (x.le.-1d0) then
          x=180d0
        else
          x=acos(x)*180d0/pi
        endif
      else
        x=-1d0
      endif


      call histogram(hname,lweight,x,0d0,180d0,nbin,histo,n,1,gen,step)

c distribution in invariant mass of leading and subleading jet
      histo=histo+1
      hname='dat.mjjmaxe'
      x=((k(jet1,0)+k(jet2,0))**2  -(k(jet1,1)+k(jet2,1))**2
     &      -(k(jet1,2)+k(jet2,2))**2  -(k(jet1,3)+k(jet2,3))**2)
      if(x.le.0d0) then
        x=0d0
      else
        x=sqrt(x)
      endif


      call histogram(hname,lweight,x,0d0,3000d0,nbin,
     &    histo,n,1,gen,step)
      return

      end

***********************************************************************
      subroutine getqcdrenscale(scale)
***********************************************************************
*     qcd renormalization scale                                       *
*---------------------------------------------------------------------*
*     20.03.06  Ansgar Denner     last changed  24.07.07              *
***********************************************************************
      implicit none
      real*8   scale

#include "mcparams.h"
#include "mccommon.h"

      qcdrenscale=scale*qcdrenscalefac

      qcdrenscale2=qcdrenscale*qcdrenscale

      end

***********************************************************************
      subroutine getqcdfacscale(scale)
***********************************************************************
*     qcd factorization scale                                         *
*---------------------------------------------------------------------*
*     20.03.06  Ansgar Denner     last changed  24.07.07              *
***********************************************************************
      implicit none
      real*8   scale

#include "mcparams.h"
#include "mccommon.h"

      qcdfacscale=scale*qcdfacscalefac

      qcdfacscale2=qcdfacscale*qcdfacscale

      end

***********************************************************************
      subroutine getqedfacscale(scale)
***********************************************************************
*     factorization scale                                             *
*---------------------------------------------------------------------*
*     21.09.06  Ansgar Denner     last changed  21.09.06              *
***********************************************************************
      implicit none
      real*8   scale

#include "mcparams.h"
#include "mccommon.h"

* local variables

      qedfacscale=scale*qedfacscalefac

      qedfacscale2=qedfacscale*qedfacscale

      end

***********************************************************************
      subroutine applyhiggscut(kbeam,k,generator,lnext,cut,switch)
***********************************************************************
*     application of separation cuts on Higgs boson                   *
*     adapted from COFFERGG by Markus Roth                            *
*---------------------------------------------------------------------*
*     08.02.10  Ansgar Denner     last changed  08.02.10              *
***********************************************************************
      implicit none

#include "mcparams.h"
#include "mccommon.h"

c local variables
      real*8 kbeam(2,0:3),k(maxe,0:3),p(0:3),kvec(maxe),kbeamvec(2)
      real*8 kth,yh,kh(0:3),kt(maxe),y(maxe)
      real*8 s,prod,ktiktj,dR,dy,dphi,sh
      integer lnext,cut,generator,switch,prevcuts

      if(switch.gt.0)return

      prevcuts=40

      if(shtr.eq.0)then
        do vcomp=0,3
          kh(vcomp)=k(5,vcomp)
        enddo
      else
        do vcomp=0,3
          kh(vcomp)=k(5,vcomp)+k(6,vcomp)
        enddo
      endif

      if(scuts(generator).gt.0.or.shtr.gt.0)then

        cut=prevcuts

        ext=5                   ! higgs

c apply transverse momentum cuts
        kth=sqrt(kh(1)**2+kh(2)**2)
        cut=cut+1

        if(kth.lt.ptcuth)return

c apply energy cuts


        cut=cut+1


        if(kh(0).lt.ecuth)return


c apply rapidity cuts
        cut=cut+1
        if(kh(0)-kh(3).ne.0d0)then
          yh=.5d0*log((kh(0)+kh(3))/(kh(0)-kh(3)))
        else
          return
        endif

        if(abs(yh).gt.ycuth)return

c apply invariant mass cuts

        sh=kh(0)*kh(0)-kh(1)*kh(1)-kh(2)*kh(2)
     &      -kh(3)*kh(3)

        cut=cut+1
        if(sh.gt.sucuth.or.sh.lt.slcuth) return

c cuts on Higgs decay singlets
        if(shtr.eq.2)then

c apply transverse momentum cuts
          do ext=5,6
            kt(ext)=sqrt(k(ext,1)**2+k(ext,2)**2)

            cut=cut+1
            if(kt(ext).lt.ptcut(ext,generator))return
          enddo

c apply rapidity cuts
          do ext=5,6
            if(k(ext,0)-k(ext,3).ne.0d0)then
              y(ext)=.5d0*log((k(ext,0)+k(ext,3))/(k(ext,0)-k(ext,3)))
            else
              return
            endif
            cut=cut+1
            if(abs(y(ext)).gt.ycut(ext,generator))return
          enddo

c apply rapidity-azimuthal angle separation cuts between singlets and
c tagging jets
          do ext1=3,4
            y(ext1)=.5d0*
     &          log((k(ext1,0)+k(ext1,3))/(k(ext1,0)-k(ext1,3)))
            kt(ext1)=sqrt(k(ext1,1)**2+k(ext1,2)**2)
          do ext=5,6
            cut=cut+1
            if(kt(ext)*kt(ext1).ne.0d0)then
              ktiktj=(k(ext,1)*k(ext1,1)+k(ext,2)*k(ext1,2))/
     &            (kt(ext)*kt(ext1))
              ktiktj=min(1d0,max(-1d0,ktiktj))
              dphi=acos(ktiktj)
              dR=sqrt((y(ext)-y(ext1))**2+dphi**2)
            else
              return
            endif
            if(dR.lt.dRcut(ext1,ext,generator)) return
          enddo
          enddo

c require singlets to lie in rapidity between tagging jets
          if(lhiggsbjets) then
          do ext=5,6
            cut=cut+1
            if(y(ext).lt.min(y(3),y(4)).or.y(ext).gt.max(y(3),y(4)))
     &          return
          enddo
          endif

        endif
c MOVE TO BETTER PLACE?
        if(cut.gt.maxcut)then
          write(*,*) 'reset maxcut = ',cut
          stop
        endif

      endif

      cut=0

      end

***********************************************************************
      subroutine applycut(kbeam,k,generator,lnext,cut,switch)
***********************************************************************
*     application of separation cuts                                  *
*     adapted from COFFERGG by Markus Roth                            *
*---------------------------------------------------------------------*
*     08.03.06  Ansgar Denner     last changed  28.02.07              *
***********************************************************************
      implicit none

#include "mcparams.h"
#include "mccommon.h"

c local variables
      real*8 kbeam(2,0:3),k(maxe,0:3),p(0:3),kvec(maxe),kbeamvec(2)
      real*8 kt(maxe),y(maxe)
      real*8 s,prod,ktiktj,dR,dy,dphi
      integer lnext,cut,generator,switch,prevcuts


      if(switch.gt.0)return

      prevcuts=3

      if (scuts(generator).eq.1) then

          cut=4
          kt(3)=sqrt(k(3,1)**2+k(3,2)**2)


          if(kt(3).lt.ptcut(3,generator)) return

          cut=5
          kt(4)=sqrt(k(4,1)**2+k(4,2)**2)


          if(kt(4).lt.ptcut(4,generator)) return

          cut=6
          if(k(3,0)-k(3,3).eq.0d0) return
          y(3)=.5d0*log((k(3,0)+k(3,3))/(k(3,0)-k(3,3)))


          if(abs(y(3)).gt.ycut(3,generator)) return

          cut=7
          if(k(4,0)-k(4,3).eq.0d0) return
          y(4)=.5d0*log((k(4,0)+k(4,3))/(k(4,0)-k(4,3)))


          if(abs(y(4)).gt.ycut(4,generator)) return

          cut=8


          if(abs(y(3)-y(4)).lt.dycut(3,4,generator)) return

          cut=9


          if(lhemicut.and.y(3)*y(4).gt.0d0) return



      elseif(scuts(generator).gt.0)then

      cut=prevcuts

c apply transverse momentum cuts
      do ext=3,lnext
        kt(ext)=sqrt(k(ext,1)**2+k(ext,2)**2)
      enddo
      do ext=3,lnext
        cut=cut+1


        if(kt(ext).lt.ptcut(ext,generator))return
      enddo
      cut=prevcuts+nextmax-2                  ! + (nextmax-2)

c apply energy cuts
      do ext=3,lnext
        cut=cut+1
        if(k(ext,0).lt.ecut(ext,generator))return
      enddo
      cut=prevcuts+2*(nextmax-2)                  ! + (nextmax-2)

c apply rapidity cuts
      do ext=3,lnext
        cut=cut+1
        if(k(ext,0)-k(ext,3).ne.0d0)then
          y(ext)=.5d0*log((k(ext,0)+k(ext,3))/(k(ext,0)-k(ext,3)))
        else
          return
        endif


        if(abs(y(ext)).gt.ycut(ext,generator))return
      enddo
      do ext=3,lnext
      do ext2=ext+1,lnext
        dy=abs(y(ext)-y(ext2))
        cut=cut+1
        if(dy.lt.dycut(ext,ext2,generator))return
      enddo
      enddo
      cut=prevcuts+(nextmax-2)*(nextmax+3)/2
! + (nextmax-2)(nextmax-1)/2

c apply angular cuts
      do ext=1,2
        kbeamvec(ext)=sqrt(kbeam(ext,1)**2+kbeam(ext,2)**2
     &    +kbeam(ext,3)**2)
      enddo
      do ext=3,lnext
        kvec(ext)=sqrt(k(ext,1)**2+k(ext,2)**2+k(ext,3)**2)
      enddo
      do ext=1,2
      do ext2=3,lnext
        prod=kbeam(ext,1)*k(ext2,1)+kbeam(ext,2)*k(ext2,2)
     &    +kbeam(ext,3)*k(ext2,3)
        cut=cut+1
        if(kbeamvec(ext).ne.0d0.and.kvec(ext2).ne.0d0.and.
     &    prod.gt.ccut(ext,ext2,generator)*kbeamvec(ext)*kvec(ext2))
     &      return
      enddo
      enddo
      do ext=3,lnext
      do ext2=ext+1,lnext
        prod=k(ext,1)*k(ext2,1)+k(ext,2)*k(ext2,2)+k(ext,3)*k(ext2,3)
        cut=cut+1
        if(kvec(ext).ne.0d0.and.kvec(ext2).ne.0d0.and.
     &    prod.gt.ccut(ext,ext2,generator)*kvec(ext)*kvec(ext2))return
      enddo
      enddo
      cut=prevcuts+(nextmax-2)*(nextmax+2) ! + (nextmax-2)(nextmax+1)/2

c apply invariant-mass cuts
      do ext=3,lnext
      do ext2=ext+1,lnext
        do vcomp=0,3
          p(vcomp)=k(ext,vcomp)+k(ext2,vcomp)
        enddo
        s=p(0)*p(0)-p(1)*p(1)-p(2)*p(2)-p(3)*p(3)
        cut=cut+1
        if(s.lt.scut(ext,ext2,generator))return
      enddo
      enddo
      cut= prevcuts+(nextmax-2)*(nextmax+2) + (nextmax-2)*(nextmax-3)/2
! + (nextmax-2)(nextmax-3)/2


c apply DeltaR cuts
      do ext=3,lnext
      do ext2=ext+1,lnext
        ktiktj=(k(ext,1)*k(ext2,1)+k(ext,2)*k(ext2,2))/
     &        (kt(ext)*kt(ext2))
        cut=cut+1
        ktiktj=min(1d0,max(-1d0,ktiktj))
        dphi=acos(ktiktj)
        dR=sqrt((y(ext)-y(ext1))**2+dphi**2)
        if(dR.lt.dRcut(ext,ext2,generator))return
      enddo
      enddo
      cut= prevcuts+(2*nextmax-1)*(nextmax-2)
!  + (nextmax-2)(nextmax-3)/2

c non-standard cuts can be inserted here


c MOVE TO BETTER PLACE?
      if(cut.gt.maxcut)then
        write(*,*) 'reset maxcut = ',cut
        stop
      endif

      elseif(shtr.ge.1)then
        call applyhiggscut(kbeam,k,generator,lnext,cut,switch)
        if(cut.gt.0) return

      endif

      cut=0
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                 c
c     photon or gluon recombination                               c
c                                                                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine recombination(kbeam,k,krec,generator,lnext,cut,
     *  switch)
      implicit none

#include "mcparams.h"
#include "mccommon.h"

c local variables
      real*8  kbeam(2,0:3),k(maxe,0:3),krec(maxe,0:3),p(maxe,0:3)
      real*8  cost(maxe),s(maxe),srecmin,cmax,kvec(maxe)
      real*8  y(maxe),kt2(maxe),dR2(maxe),dR2min,ktiktj,dphi
      integer nrecomb,generator,lnext,switch,cut
      integer recombine

      real*8  kjet(maxe,0:3)
      integer typepart(maxe),typejet(maxe),npartin,njet

c to avoid compiler warning
      data nrecomb /0/


      if(switch.ne.0)return
      recombine=0
      do ext=1,lnext
      do vcomp=0,3
        krec(ext,vcomp)=k(ext,vcomp)
      enddo
      enddo

c jet recombination

      if(srecomb(generator).eq.1.or.srecomb(generator).eq.2) then

c  900      format(6x,' p(',i1,',',i1,')    = ',d20.14)

        if(generator.eq.0.or.lnext.eq.5.or.shtr.gt.0.and.lnext.eq.6)
     &      then
          typepart(1)=0
          typepart(2)=0
          typepart(3)=1
          typepart(4)=1
          if(shtr.eq.0)then
            typepart(5)=0
            npartin=5
          else
            typepart(5)=0
            typepart(6)=0
            npartin=6
          endif
          call ktcluster(kbeam,k,typepart,kjet,typejet,
     &    npartin,njet,switch)
          call applyjetcut(kbeam,kjet,typejet,krec,
     &    generator,njet,cut,switch)

        elseif(generator.eq.1) then
          typepart(1)=0
          typepart(2)=0
          typepart(3)=1
          typepart(4)=1
          if(shtr.eq.0)then
            typepart(5)=0
            typepart(6)=-1
            npartin=6
          else
            typepart(5)=0
            typepart(6)=0
            typepart(7)=-1
            npartin=7
          endif
          call ktcluster(kbeam,k,typepart,kjet,typejet,
     &    npartin,njet,switch)
          call applyjetcut(kbeam,kjet,typejet,krec,
     &    generator,njet,cut,switch)


        elseif(generator.ge.2.and.generator.le.6) then
          typepart(1)=0
          typepart(2)=0
          typepart(3)=1
          typepart(4)=1
          if(shtr.eq.0)then
            typepart(5)=0
            typepart(6)=1
            npartin=6
          else
            typepart(5)=0
            typepart(6)=0
            typepart(7)=1
            npartin=7
          endif
          call ktcluster(kbeam,k,typepart,kjet,typejet,
     &    npartin,njet,switch)
          call applyjetcut(kbeam,kjet,typejet,krec,
     &    generator,njet,cut,switch)

        else
          write(*,*) 'recombination: recombination not applicable'
          write(*,*) 'recombination',generator,lnext
          stop
        endif


c naive recombination of RacoonWW
      else if(shtr.eq.0.and.lnext.eq.5.or.
     &      shtr.gt.0.and.lnext.eq.6)then
        call applycut(kbeam,krec,generator,lnext,cut,switch)
      else if(srecomb(generator).eq.4)then
        if(dabs(k(lnext,3)).gt.recparam(1,generator)*k(lnext,0))then
          do vcomp=0,3
            krec(lnext,vcomp)=0d0
          enddo

          call applycut(kbeam,krec,generator,lnext-1,cut,switch)
          return
        endif
        do ext=3,lnext-1
           if(recparticle(ext,generator).eq.1)then
            do vcomp=0,3
              p(ext,vcomp)=k(ext,vcomp)+k(lnext,vcomp)
            enddo
            kvec(ext)=sqrt(k(ext,1)**2+k(ext,2)**2+k(ext,3)**2)
            if(kvec(ext).ne.0d0)then
              cost(ext)=(k(ext,1)*k(lnext,1)+k(ext,2)*k(lnext,2)
     &          +k(ext,3)*k(lnext,3))/kvec(ext)/k(lnext,0)
            else
              cost(ext)=1d0
            endif
            s(ext)=p(ext,0)**2-p(ext,1)**2-p(ext,2)**2-p(ext,3)**2

            if(k(lnext,0).le.recparam(2,generator).or.
     &        cost(ext).ge.recparam(3,generator).or.
     &        s(ext).le.recparam(4,generator))recombine=1

          endif
        enddo
        if(recombine.eq.1)then
          srecmin=1d10
          do ext=3,lnext-1
            if(recparticle(ext,generator).eq.1)then
              if(s(ext).lt.srecmin)then
                srecmin=s(ext)
                nrecomb=ext
              endif
            endif
          enddo
        endif
c recombine
        if(recombine.eq.1)then
          do vcomp=0,3
            if(nrecomb.ge.3)then
              krec(nrecomb,vcomp)=p(nrecomb,vcomp)
            endif
            krec(lnext,vcomp)=0d0
          enddo

          call applycut(kbeam,krec,generator,lnext-1,cut,switch)
        else
          call applycut(kbeam,krec,generator,lnext,cut,switch)
        endif

c naive recombination based on rapidity and dR
      elseif(srecomb(generator).eq.3)then
        if(k(lnext,0)-k(lnext,3).ne.0d0)then
          y(lnext)=
     &      .5d0*log((k(lnext,0)+k(lnext,3))/(k(lnext,0)-k(lnext,3)))
        else
          y(lnext)=1d10
        endif
        if(dabs(y(lnext)).gt.recparam(1,generator).or.
     &      k(lnext,0).lt.recparam(2,generator))then
          do vcomp=0,3
            krec(lnext,vcomp)=0d0
          enddo
          call applycut(kbeam,krec,generator,lnext-1,cut,switch)
          return
        endif
        kt2(lnext)=k(lnext,1)**2+k(lnext,2)**2

        do ext=3,lnext-1
          if(recparticle(ext,generator).eq.1)then
            do vcomp=0,3
              p(ext,vcomp)=k(ext,vcomp)+k(lnext,vcomp)
            enddo
            if(k(ext,0)-k(ext,3).ne.0d0)then
              y(ext)=
     &            .5d0*log((k(ext,0)+k(ext,3))/(k(ext,0)-k(ext,3)))
            else
              y(ext)=1d10
            endif
            kt2(ext)=k(ext,1)**2+k(ext,2)**2

            if(kt2(ext).gt.0d0)then
              ktiktj=(k(ext,1)*k(lnext,1)+k(ext,2)*k(lnext,2))/
     &            sqrt(kt2(ext)*kt2(lnext))
              if(abs(ktiktj).gt.1d0)then
                switch=46
                if(numout.lt.maxout.and.lnoutmc.ge.5)then
 100              format(/" event = ",i9,", gen = ",i4,
     &                ", channel = ",i4,", exit = ",i4,(a))
                  write(nout,100) nevt,cogen,cocha,switch,
     &                ', recombination:  |cos(deltaphi)| > 1'
                  numout=numout+1
                endif
                return
              endif
              dphi=acos(ktiktj)
              dR2(ext)= ((y(ext)-y(lnext))**2+dphi**2)
            else
              dR2(ext)=0d0
            endif
            s(ext)=p(ext,0)**2-p(ext,1)**2-p(ext,2)**2-p(ext,3)**2
            if(dR2(ext).le.recparam(3,generator).or.
     &          s(ext).le.recparam(4,generator))recombine=1

          endif
        enddo
        if(recombine.eq.1)then
          dR2min=1d10
          do ext=3,lnext-1
            if(recparticle(ext,generator).eq.1)then
              if(dR2(ext).lt.dR2min)then
                dR2min=dR2(ext)
                nrecomb=ext
              endif
            endif
          enddo
        endif
c recombine


        if(recombine.eq.1)then
          do vcomp=0,3
            if(nrecomb.ge.3)then
              krec(nrecomb,vcomp)=p(nrecomb,vcomp)
            endif
            krec(lnext,vcomp)=0d0


          enddo
          call applycut(kbeam,krec,generator,lnext-1,cut,switch)
        else
          call applycut(kbeam,krec,generator,lnext,cut,switch)
        endif
      else
        call applycut(kbeam,krec,generator,lnext,cut,switch)
      endif
      end

***********************************************************************
      subroutine ktcluster(kbeam,kpart,typepart,kjet,typejet,
     &    npartin,njet,switch)
***********************************************************************
*     run II kT clustering algorithm  (hep-ex/0005012)                *
*     input:     including incoming partons!!!                        *
*     kpart:    momenta of partons                                    *
*     typepart: types of partons                                      *
*     npartin: number of outgoing partons                             *
*     typepart: types of particles                                    *
*     particle types:  1 are jets and merge to jets (quarks,gluons)   *
*     particle types: -1 are NO jets but merge to jets (photons)      *
*     particle types:  0 are NO jets and do not merge to jets         *
*                                                  (Higgs,leptons)    *
*     output:                                                         *
*     kjet:     momenta of jets                                       *
*     typejet:  types of jets          result from particle types     *
*       jet types:  1 are jets                                        *
*       jet types: -1 are photons                                     *
*       jet types:  0 are Higgs,leptons                               *
*     njet:     number of jets                                        *
*     Higgs has ijet=3                                                *
*---------------------------------------------------------------------*
*     21.02.07  Ansgar Denner     last changed  11.05.07              *
***********************************************************************
      implicit none

#include "mcparams.h"
#include "mccommon.h"

      real*8  kbeam(2,0:3),kpart(maxe,0:3),kjet(maxe,0:3)
      integer typepart(maxe),typejet(maxe)
      integer npartin,njet,switch

c local variables

      real*8  kpartl(maxe,0:3),kt2(maxe),yk(maxe),dphi
      real*8  ktiktj,dmin,d2(maxe,maxe)
      integer n1min,n2min,npart,part,part2,mergestep,steps
      integer pointer(maxe)

 900  format(6x,' p(',i1,',',i1,')    = ',d20.14)

      if(switch.ne.0)return

c do not touch incoming partons
      do vcomp=0,3
        kjet(1,vcomp)=kpart(1,vcomp)
        kjet(2,vcomp)=kpart(2,vcomp)
      enddo

      njet=2
      part=0
      do ext=3,npartin
c extract nonclustering partons
        if(typepart(ext).eq.0)then
          njet=njet+1
          typejet(njet)=0
          do vcomp=0,3
            kjet(njet,vcomp)=kpart(ext,vcomp)
          enddo
        else
          if(kpart(ext,0)+kpart(ext,3).ne.0d0.and.
     &        kpart(ext,0)-kpart(ext,3).ne.0d0)then
            yk(ext)=.5d0*log((kpart(ext,0)+kpart(ext,3))/
     &          (kpart(ext,0)-kpart(ext,3)))
            if(yk(ext).lt.-10d0)then
              yk(ext)=-10d0
            elseif(yk(ext).gt.10d0)then
              yk(ext)=10d0
            endif
          else
            yk(ext)=1d10
          endif
c take only clustering partons within acceptance
          if(dabs(yk(ext)).lt.partetacut) then
            part=part+1
            pointer(part)=ext
            do vcomp=0,3
              kpartl(ext,vcomp)=kpart(ext,vcomp)
            enddo
          endif
        endif
      enddo
      npart=part



c calculate cluster parameters
      do part=1,npart
        ext=pointer(part)
        kt2(ext)=kpartl(ext,1)**2+kpartl(ext,2)**2


        yk(ext)=.5d0*log((kpartl(ext,0)+kpartl(ext,3))/
     &      (kpartl(ext,0)-kpartl(ext,3)))
        if(yk(ext).lt.-10d0)then
          yk(ext)=-10d0
        elseif(yk(ext).gt.10d0)then
          yk(ext)=10d0
        endif
        do part2=1,part-1
          ext2=pointer(part2)
          ktiktj=(kpartl(ext,1)*kpartl(ext2,1)
     &        +kpartl(ext,2)*kpartl(ext2,2))/
     &        sqrt(kt2(ext)*kt2(ext2))


          if(abs(ktiktj).gt.1d0)then
            switch=45
            if(numout.lt.maxout.and.lnoutmc.ge.5)then
 100          format(/" event = ",i9,", gen = ",i4,
     &            ", channel = ",i4,", exit = ",i4,(a))
              write(nout,100) nevt,cogen,cocha,switch,
     &            ', ktcluster:  |cos(deltaphi)| > 1'
              numout=numout+1
            endif
            return
          endif
          dphi=acos(ktiktj)
          d2(ext2,ext)=min(kt2(ext),kt2(ext2))*
     &        ((yk(ext)-yk(ext2))**2+dphi**2)/ktd**2
          d2(ext,ext2)=d2(ext2,ext)

        enddo
      enddo


c cluster remaining partons
      steps=npart
      do mergestep=1,steps


c determine dmin
        dmin=kt2(pointer(1))
        n1min=1
        n2min=0
        do part=1,npart
          ext=pointer(part)
          if(kt2(ext).lt.dmin)then
            dmin=kt2(ext)
            n1min=part
            n2min=0
          endif
          do part2=1,part-1
            ext2=pointer(part2)
            if(d2(ext2,ext).lt.dmin.and.
     &          (typepart(ext).gt.0.or.typepart(ext2).gt.0))then
              dmin=d2(ext2,ext)
              n1min=part
              n2min=part2
            endif
          enddo
        enddo

        if(npart.gt.1)then
          if (n2min.eq.0) then
c move parton to jets
            njet=njet+1
            ext=pointer(n1min)
            typejet(njet)=typepart(ext)
            do vcomp=0,3
              kjet(njet,vcomp)=kpartl(ext,vcomp)
            enddo
c shift maximal value of pointer to empty slot
            if(n1min.ne.npart) pointer(n1min)=pointer(npart)
            npart=npart-1
          else
c join two partons
            ext=pointer(n1min)
            ext2=pointer(n2min)
            if(typepart(ext).ne.1.and.typepart(ext2).ne.1) then
              write(*,*) 'ktcluster: error2',ext,ext2,
     &            typepart(ext),typepart(ext2)
              stop
            endif
            typepart(ext)=1
            do vcomp=0,3
              kpartl(ext,vcomp)=kpartl(ext,vcomp)+kpartl(ext2,vcomp)
            enddo


c shift maximal value of pointer to empty slot
            if(n2min.ne.npart) pointer(n2min)=pointer(npart)
            if(n1min.eq.npart) n1min=n2min
            npart=npart-1
c recalculate parameters of new parton
            kt2(ext)=kpartl(ext,1)**2+kpartl(ext,2)**2
            yk(ext)=.5d0*log((kpartl(ext,0)+kpartl(ext,3))/
     &          (kpartl(ext,0)-kpartl(ext,3)))

            do part2=1,npart
              if(part2.ne.n1min)then
                ext2=pointer(part2)
                ktiktj=(kpartl(ext,1)*kpartl(ext2,1)
     &              +kpartl(ext,2)*kpartl(ext2,2))/
     &              sqrt(kt2(ext)*kt2(ext2))
                if(abs(ktiktj).gt.1d0)then
                  switch=45
                  if(numout.lt.maxout.and.lnoutmc.ge.5)then
                    write(nout,100) nevt,cogen,cocha,switch,
     &                  ', ktcluster:  |cos(deltaphi)| > 1'
                    numout=numout+1
                  endif
                  return
                endif
                dphi=acos(ktiktj)
                d2(ext,ext2)=min(kt2(ext),kt2(ext2))*
     &              ((yk(ext)-yk(ext2))**2+dphi**2)/ktd**2
                d2(ext2,ext)=d2(ext,ext2)

              endif

            enddo

          endif
        else
          njet=njet+1
          ext=pointer(1)
          typejet(njet)=typepart(ext)
          do vcomp=0,3
            kjet(njet,vcomp)=kpartl(ext,vcomp)
          enddo
        endif
      enddo

      end


***********************************************************************
      subroutine applyjetcut(kbeam,kjet,typejet,kevent,
     &    generator,njet,cut,switch)
***********************************************************************
*     applies cuts to jets after defining tagging jets                *
*     input:                                                          *
*     kjet:     momenta of jets  (including incoming partons)         *
*     typejet:  types of jets                                         *
*     njet:     number of jets                                        *
*     output:                                                         *
*     kevent:   momenta of event                                      *
*     cut:      number of relevant cut                                *
*---------------------------------------------------------------------*
*     21.02.07  Ansgar Denner     last changed  08.02.10              *
***********************************************************************
      implicit none

#include "mcparams.h"
#include "mccommon.h"

      real*8  kbeam(2,0:3),kjet(maxe,0:3),kevent(maxe,0:3)
      integer typejet(maxe)
      integer generator,njet,cut,switch

c local variables
      real*8  kt2(maxe),y(maxe),swap,sjj
      integer ntjet,nutjet,pointer(maxe)


      if(switch.ne.0)return

      if(typejet(3).ne.0.or.shtr.gt.0.and.typejet(4).ne.0)then
        write(*,*) 'applyjetcut: Higgs is not first jet'
        stop
      endif

      if(shtr.eq.0)then
      if(njet.eq.3) then
c events with Higgs + no jets
        do vcomp=0,3
          kevent(1,vcomp)=kjet(1,vcomp)
          kevent(2,vcomp)=kjet(2,vcomp)
          kevent(5,vcomp)=kjet(3,vcomp)
          kevent(3,vcomp)=0d0
          kevent(4,vcomp)=0d0
          kevent(6,vcomp)=0d0
        enddo
        if(scuts(generator).eq.1.or.scuts(generator).eq.2) then
          cut=1
          return
        elseif(scuts(generator).gt.0) then
          call applycut(kbeam,kevent,generator,njet,cut,switch)
        endif

      elseif(njet.eq.4) then
c events with Higgs + single jet
        do vcomp=0,3
          kevent(1,vcomp)=kjet(1,vcomp)
          kevent(2,vcomp)=kjet(2,vcomp)
          kevent(5,vcomp)=kjet(3,vcomp)
          kevent(3,vcomp)=kjet(4,vcomp)
          kevent(4,vcomp)=0d0
          kevent(6,vcomp)=0d0
        enddo
        if(scuts(generator).eq.1.or.scuts(generator).eq.2) then
          cut=10
          return
        elseif(scuts(generator).gt.0) then
          call applycut(kbeam,kevent,generator,njet,cut,switch)
        endif

      else if (njet.eq.5) then
c events with Higgs + two jets  or Higgs + jet + photon
        if(scuts(generator).eq.1) then
c number of jets passing the cuts (tagged jets)
          ntjet=0
c number of jets not passing the cuts (untagged jets)
          nutjet=0
          do ext=4,5
            if(typejet(ext).eq.1)then
              kt2(ext)=kjet(ext,1)**2+kjet(ext,2)**2
              if(kjet(ext,0)-kjet(ext,3).eq.0) then
                y(ext) = 1d10
              elseif(kjet(ext,0)+kjet(ext,3).eq.0) then
                y(ext) = -1d10
              else
                y(ext)=.5d0*log((kjet(ext,0)+kjet(ext,3))
     &              /(kjet(ext,0)-kjet(ext,3)))
              endif
              if(abs(y(ext)).lt.ycutj.and.kt2(ext).gt.ptcutj**2) then
                ntjet=ntjet+1
                pointer(ntjet)=ext
              else
                nutjet=nutjet+1
                pointer(4-nutjet)=ext
              endif
            else
              nutjet=nutjet+1
              pointer(4-nutjet)=ext
            endif
          enddo

          if(ntjet.lt.2) then
            cut=21
            return
          endif
          cut=22
          if(abs(y(5)-y(4)).lt.dycutjj) return
          cut=23
          if(lhemicut.and.y(5)*y(4).gt.0d0) return
          cut=24
          sjj=(kjet(4,0)+kjet(5,0))**2 -  (kjet(4,1)+kjet(5,1))**2
     &        - (kjet(4,2)+kjet(5,2))**2 - (kjet(4,3)+kjet(5,3))**2


          if(sjj.lt.mcutjj*mcutjj)return

          cut=0
          if(kt2(4).lt.kt2(5))then
            do vcomp=0,3
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(3,vcomp)=kjet(5,vcomp)
              kevent(4,vcomp)=kjet(4,vcomp)
              kevent(6,vcomp)=0d0
            enddo
          else
            do vcomp=0,3
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(3,vcomp)=kjet(4,vcomp)
              kevent(4,vcomp)=kjet(5,vcomp)
              kevent(6,vcomp)=0d0
            enddo
          endif
          call applyhiggscut(kbeam,kevent,generator,njet,cut,switch)
        elseif(scuts(generator).eq.2) then
          kt2(4)=kjet(4,1)**2+kjet(4,2)**2
          if(kjet(4,0)-kjet(4,3).eq.0) then
            y(4) = 1d10
          elseif(kjet(4,0)+kjet(4,3).eq.0) then
            y(4) = -1d10
          else
            y(4)=.5d0*log((kjet(4,0)+kjet(4,3))/(kjet(4,0)-kjet(4,3)))
          endif
          kt2(5)=kjet(5,1)**2+kjet(5,2)**2
          if(kjet(5,0)-kjet(5,3).eq.0) then
            y(5) = 1d10
          elseif(kjet(5,0)+kjet(5,3).eq.0) then
            y(5) = -1d10
          else
            y(5)=.5d0*log((kjet(5,0)+kjet(5,3))/(kjet(5,0)-kjet(5,3)))
          endif
          if(abs(y(4)).gt.ycutj.or.kt2(4).lt.ptcutj**2
     &        .or.abs(y(5)).gt.ycutj.or.kt2(5).lt.ptcutj**2) then
            cut=21
            return
          endif
          cut=22
          if(abs(y(5)-y(4)).lt.dycutjj) return
          cut=23
          if(lhemicut.and.y(5)*y(4).gt.0d0) return
          cut=24
          sjj=(kjet(4,0)+kjet(5,0))**2 -  (kjet(4,1)+kjet(5,1))**2
     &        - (kjet(4,2)+kjet(5,2))**2 - (kjet(4,3)+kjet(5,3))**2
          if(sjj.lt.mcutjj*mcutjj)return
          cut=0
          if(kjet(4,0).lt.kjet(5,0))then
            do vcomp=0,3
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(3,vcomp)=kjet(5,vcomp)
              kevent(4,vcomp)=kjet(4,vcomp)
              kevent(6,vcomp)=0d0
            enddo
          else
            do vcomp=0,3
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(3,vcomp)=kjet(4,vcomp)
              kevent(4,vcomp)=kjet(5,vcomp)
              kevent(6,vcomp)=0d0
            enddo
          endif
          call applyhiggscut(kbeam,kevent,generator,njet,cut,switch)
        elseif(scuts(generator).gt.0) then
          kt2(4)=kjet(4,1)**2+kjet(4,2)**2
          kt2(5)=kjet(5,1)**2+kjet(5,2)**2
          if(kt2(4).lt.kt2(5))then
            do vcomp=0,3
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(3,vcomp)=kjet(5,vcomp)
              kevent(4,vcomp)=kjet(4,vcomp)
              kevent(6,vcomp)=0d0
            enddo
          else
            do vcomp=0,3
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(3,vcomp)=kjet(4,vcomp)
              kevent(4,vcomp)=kjet(5,vcomp)
              kevent(6,vcomp)=0d0
            enddo
          endif
          call applycut(kbeam,kevent,generator,njet,cut,switch)
        endif

      else if (njet.eq.6) then
c events with Higgs + 3 jets or 2 jets + photon

        if(scuts(generator).eq.1) then
c number of jets passing the cuts (tagged jets)
          ntjet=0
c number of jets not passing the cuts (untagged jets)
          nutjet=0
          do ext=4,6
            if(typejet(ext).eq.1)then
              kt2(ext)=kjet(ext,1)**2+kjet(ext,2)**2
              if(kjet(ext,0)-kjet(ext,3).eq.0) then
                y(ext) = 1d10
              elseif(kjet(ext,0)+kjet(ext,3).eq.0) then
                y(ext) = -1d10
              else
                y(ext)=.5d0*log((kjet(ext,0)+kjet(ext,3))
     &              /(kjet(ext,0)-kjet(ext,3)))
              endif
              if(abs(y(ext)).lt.ycutj.and.kt2(ext).gt.ptcutj**2) then
                ntjet=ntjet+1
                pointer(ntjet)=ext
              else
                nutjet=nutjet+1
                pointer(4-nutjet)=ext
              endif
            else
              nutjet=nutjet+1
              pointer(4-nutjet)=ext
            endif
          enddo


          if(ntjet.lt.2)then
            cut=31
            return
          endif
          if(ntjet.eq.2)then
            if(kt2(pointer(1)).lt.kt2(pointer(2)))then
              swap=pointer(1)
              pointer(1)=pointer(2)
              pointer(2)=swap
            endif
          else
            if(kt2(pointer(1)).lt.kt2(pointer(2)))then
              swap=pointer(1)
              pointer(1)=pointer(2)
              pointer(2)=swap
            endif
            if(kt2(pointer(2)).lt.kt2(pointer(3)))then
              swap=pointer(2)
              pointer(2)=pointer(3)
              pointer(3)=swap
            endif
            if(kt2(pointer(1)).lt.kt2(pointer(2)))then
              swap=pointer(1)
              pointer(1)=pointer(2)
              pointer(2)=swap
            endif
          endif


          cut=32
          if(abs(y(pointer(1))-y(pointer(2))).lt.dycutjj) return
          cut=33
          if(lhemicut.and.y(pointer(1))*y(pointer(2)).gt.0d0) return
          cut=34
          sjj=(kjet(pointer(1),0)+kjet(pointer(2),0))**2
     &        - (kjet(pointer(1),1)+kjet(pointer(2),1))**2
     &        - (kjet(pointer(1),2)+kjet(pointer(2),2))**2
     &        - (kjet(pointer(1),3)+kjet(pointer(2),3))**2


          if(sjj.lt.mcutjj*mcutjj)return

          cut=0
          if(ntjet.eq.2)then
            do vcomp=0,3
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(3,vcomp)=kjet(pointer(1),vcomp)
              kevent(4,vcomp)=kjet(pointer(2),vcomp)
              kevent(6,vcomp)=0d0
            enddo
          else
            do vcomp=0,3
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(3,vcomp)=kjet(pointer(1),vcomp)
              kevent(4,vcomp)=kjet(pointer(2),vcomp)
              kevent(6,vcomp)=kjet(pointer(3),vcomp)
            enddo
          endif
          call applyhiggscut(kbeam,kevent,generator,njet,cut,switch)
        else if(scuts(generator).eq.2) then
c number of jets passing the cuts (tagged jets)
          ntjet=0
c number of jets not passing the cuts (untagged jets)
          nutjet=0
          do ext=4,6
            if(typejet(ext).eq.1)then
              kt2(ext)=kjet(ext,1)**2+kjet(ext,2)**2
              if(kjet(ext,0)-kjet(ext,3).eq.0) then
                y(ext) = 1d10
              elseif(kjet(ext,0)+kjet(ext,3).eq.0) then
                y(ext) = -1d10
              else
                y(ext)=.5d0*log((kjet(ext,0)+kjet(ext,3))
     &              /(kjet(ext,0)-kjet(ext,3)))
              endif
              if(abs(y(ext)).lt.ycutj.and.kt2(ext).gt.ptcutj**2) then
                ntjet=ntjet+1
                pointer(ntjet)=ext
              else
                nutjet=nutjet+1
                pointer(4-nutjet)=ext
              endif
            else
              nutjet=nutjet+1
              pointer(4-nutjet)=ext
            endif
          enddo

          if(ntjet.lt.2)then
            cut=31
            return
          endif
          if(ntjet.eq.2)then
            if(kjet(pointer(1),0).lt.kjet(pointer(2),0))then
              swap=pointer(1)
              pointer(1)=pointer(2)
              pointer(2)=swap
            endif
          else
            if(kjet(pointer(1),0).lt.kjet(pointer(2),0))then
              swap=pointer(1)
              pointer(1)=pointer(2)
              pointer(2)=swap
            endif
            if(kjet(pointer(2),0).lt.kjet(pointer(3),0))then
              swap=pointer(2)
              pointer(2)=pointer(3)
              pointer(3)=swap
            endif
            if(kjet(pointer(1),0).lt.kjet(pointer(2),0))then
              swap=pointer(1)
              pointer(1)=pointer(2)
              pointer(2)=swap
            endif
          endif

          cut=32
          if(abs(y(pointer(1))-y(pointer(2))).lt.dycutjj) return
          cut=33
          if(lhemicut.and.y(pointer(1))*y(pointer(2)).gt.0d0) return
          cut=34
          sjj=(kjet(pointer(1),0)+kjet(pointer(2),0))**2
     &        - (kjet(pointer(1),1)+kjet(pointer(2),1))**2
     &        - (kjet(pointer(1),2)+kjet(pointer(2),2))**2
     &        - (kjet(pointer(1),3)+kjet(pointer(2),3))**2
          if(sjj.lt.mcutjj*mcutjj)return
          cut=0
          if(ntjet.eq.2)then
            do vcomp=0,3
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(3,vcomp)=kjet(pointer(1),vcomp)
              kevent(4,vcomp)=kjet(pointer(2),vcomp)
              kevent(6,vcomp)=0d0
            enddo
          else
            do vcomp=0,3
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(3,vcomp)=kjet(pointer(1),vcomp)
              kevent(4,vcomp)=kjet(pointer(2),vcomp)
              kevent(6,vcomp)=kjet(pointer(3),vcomp)
            enddo
          endif
          call applyhiggscut(kbeam,kevent,generator,njet,cut,switch)
        elseif(scuts(generator).gt.0) then
          if(generator.eq.1)then
            kt2(4)=kjet(4,1)**2+kjet(4,2)**2
            kt2(5)=kjet(5,1)**2+kjet(5,2)**2
            if(kt2(4).lt.kt2(5))then
              do vcomp=0,3
                kevent(1,vcomp)=kjet(1,vcomp)
                kevent(2,vcomp)=kjet(2,vcomp)
                kevent(3,vcomp)=kjet(5,vcomp)
                kevent(4,vcomp)=kjet(4,vcomp)
                kevent(6,vcomp)=0d0
              enddo
            else
              do vcomp=0,3
                kevent(1,vcomp)=kjet(1,vcomp)
                kevent(2,vcomp)=kjet(2,vcomp)
                kevent(3,vcomp)=kjet(4,vcomp)
                kevent(4,vcomp)=kjet(5,vcomp)
                kevent(6,vcomp)=0d0
              enddo
            endif
          else
            kt2(4)=kjet(4,1)**2+kjet(4,2)**2
            kt2(5)=kjet(5,1)**2+kjet(5,2)**2
            kt2(6)=kjet(6,1)**2+kjet(6,2)**2
            if(kt2(4).lt.kt2(5).and.kt2(4).lt.kt2(6))then
              if(kt2(5).lt.kt2(6))then
                do vcomp=0,3
                  kevent(1,vcomp)=kjet(1,vcomp)
                  kevent(2,vcomp)=kjet(2,vcomp)
                  kevent(3,vcomp)=kjet(6,vcomp)
                  kevent(4,vcomp)=kjet(5,vcomp)
                  kevent(6,vcomp)=kjet(4,vcomp)
                enddo
              else
                do vcomp=0,3
                  kevent(1,vcomp)=kjet(1,vcomp)
                  kevent(2,vcomp)=kjet(2,vcomp)
                  kevent(3,vcomp)=kjet(5,vcomp)
                  kevent(4,vcomp)=kjet(6,vcomp)
                  kevent(6,vcomp)=kjet(4,vcomp)
                enddo
              endif
            elseif(kt2(5).lt.kt2(4).and.kt2(5).lt.kt2(6))then
              if(kt2(4).lt.kt2(6))then
                do vcomp=0,3
                  kevent(1,vcomp)=kjet(1,vcomp)
                  kevent(2,vcomp)=kjet(2,vcomp)
                  kevent(3,vcomp)=kjet(6,vcomp)
                  kevent(4,vcomp)=kjet(4,vcomp)
                  kevent(6,vcomp)=kjet(5,vcomp)
                enddo
              else
                do vcomp=0,3
                  kevent(1,vcomp)=kjet(1,vcomp)
                  kevent(2,vcomp)=kjet(2,vcomp)
                  kevent(3,vcomp)=kjet(4,vcomp)
                  kevent(4,vcomp)=kjet(6,vcomp)
                  kevent(6,vcomp)=kjet(5,vcomp)
                enddo
              endif
            else
              if(kt2(4).lt.kt2(5))then
                do vcomp=0,3
                  kevent(1,vcomp)=kjet(1,vcomp)
                  kevent(2,vcomp)=kjet(2,vcomp)
                  kevent(3,vcomp)=kjet(5,vcomp)
                  kevent(4,vcomp)=kjet(4,vcomp)
                  kevent(6,vcomp)=kjet(6,vcomp)
                enddo
              else
                do vcomp=0,3
                  kevent(1,vcomp)=kjet(1,vcomp)
                  kevent(2,vcomp)=kjet(2,vcomp)
                  kevent(3,vcomp)=kjet(5,vcomp)
                  kevent(4,vcomp)=kjet(4,vcomp)
                  kevent(6,vcomp)=kjet(6,vcomp)
                enddo
              endif
            endif
          endif
          call applycut(kbeam,kevent,generator,njet,cut,switch)
        endif
      endif

      else   ! if(shtr.gt.0)

      if(njet.eq.4) then
c events with Higgs + no jets
        do vcomp=0,3
          kevent(1,vcomp)=kjet(1,vcomp)
          kevent(2,vcomp)=kjet(2,vcomp)
          kevent(5,vcomp)=kjet(3,vcomp)
          kevent(6,vcomp)=kjet(4,vcomp)
          kevent(3,vcomp)=0d0
          kevent(4,vcomp)=0d0
          kevent(7,vcomp)=0d0
        enddo
        if(scuts(generator).eq.1.or.scuts(generator).eq.2) then
          cut=1
          return
        elseif(scuts(generator).gt.0.or.shtr.eq.1) then
          call applycut(kbeam,kevent,generator,njet,cut,switch)
        endif

      elseif(njet.eq.5) then
c events with Higgs + single jet
        do vcomp=0,3
          kevent(1,vcomp)=kjet(1,vcomp)
          kevent(2,vcomp)=kjet(2,vcomp)
          kevent(5,vcomp)=kjet(3,vcomp)
          kevent(6,vcomp)=kjet(4,vcomp)
          kevent(3,vcomp)=kjet(5,vcomp)
          kevent(4,vcomp)=0d0
          kevent(7,vcomp)=0d0
        enddo
        if(scuts(generator).eq.1.or.scuts(generator).eq.2) then
          cut=10
          return
        elseif(scuts(generator).gt.0.or.shtr.eq.1) then
          call applycut(kbeam,kevent,generator,njet,cut,switch)
        endif

      else if (njet.eq.6) then
c events with Higgs + two jets  or Higgs + jet + photon
        if(scuts(generator).eq.1) then
c number of jets passing the cuts (tagged jets)
          ntjet=0
c number of jets not passing the cuts (untagged jets)
          nutjet=0
          do ext=5,6
            if(typejet(ext).eq.1)then
              kt2(ext)=kjet(ext,1)**2+kjet(ext,2)**2
              if(kjet(ext,0)-kjet(ext,3).eq.0) then
                y(ext) = 1d10
              elseif(kjet(ext,0)+kjet(ext,3).eq.0) then
                y(ext) = -1d10
              else
                y(ext)=.5d0*log((kjet(ext,0)+kjet(ext,3))
     &              /(kjet(ext,0)-kjet(ext,3)))
              endif
              if(abs(y(ext)).lt.ycutj.and.kt2(ext).gt.ptcutj**2) then
                ntjet=ntjet+1
                pointer(ntjet)=ext
              else
                nutjet=nutjet+1
                pointer(4-nutjet)=ext
              endif
            else
              nutjet=nutjet+1
              pointer(4-nutjet)=ext
            endif
          enddo

          if(ntjet.lt.2) then
            cut=21
            return
          endif
          cut=22
          if(abs(y(5)-y(6)).lt.dycutjj) return
          cut=23
          if(lhemicut.and.y(5)*y(6).gt.0d0) return
          cut=24
          sjj=(kjet(6,0)+kjet(5,0))**2 -  (kjet(6,1)+kjet(5,1))**2
     &        - (kjet(6,2)+kjet(5,2))**2 - (kjet(6,3)+kjet(5,3))**2


          if(sjj.lt.mcutjj*mcutjj)return

          cut=0
          if(kt2(5).lt.kt2(6))then
            do vcomp=0,3
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(6,vcomp)=kjet(4,vcomp)
              kevent(3,vcomp)=kjet(6,vcomp)
              kevent(4,vcomp)=kjet(5,vcomp)
              kevent(7,vcomp)=0d0
            enddo
          else
            do vcomp=0,3
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(6,vcomp)=kjet(4,vcomp)
              kevent(3,vcomp)=kjet(5,vcomp)
              kevent(4,vcomp)=kjet(6,vcomp)
              kevent(7,vcomp)=0d0
            enddo
          endif
          call applyhiggscut(kbeam,kevent,generator,njet,cut,switch)
        elseif(scuts(generator).eq.2) then
          kt2(6)=kjet(6,1)**2+kjet(6,2)**2
          if(kjet(6,0)-kjet(6,3).eq.0) then
            y(6) = 1d10
          elseif(kjet(6,0)+kjet(6,3).eq.0) then
            y(6) = -1d10
          else
            y(6)=.5d0*log((kjet(6,0)+kjet(6,3))/(kjet(6,0)-kjet(6,3)))
          endif
          kt2(5)=kjet(5,1)**2+kjet(5,2)**2
          if(kjet(5,0)-kjet(5,3).eq.0) then
            y(5) = 1d10
          elseif(kjet(5,0)+kjet(5,3).eq.0) then
            y(5) = -1d10
          else
            y(5)=.5d0*log((kjet(5,0)+kjet(5,3))/(kjet(5,0)-kjet(5,3)))
          endif
          if(abs(y(6)).gt.ycutj.or.kt2(6).lt.ptcutj**2
     &        .or.abs(y(5)).gt.ycutj.or.kt2(5).lt.ptcutj**2) then
            cut=21
            return
          endif
          cut=22
          if(abs(y(5)-y(6)).lt.dycutjj) return
          cut=23
          if(lhemicut.and.y(5)*y(6).gt.0d0) return
          cut=24
          sjj=(kjet(6,0)+kjet(5,0))**2 -  (kjet(6,1)+kjet(5,1))**2
     &        - (kjet(6,2)+kjet(5,2))**2 - (kjet(6,3)+kjet(5,3))**2
          if(sjj.lt.mcutjj*mcutjj)return
          cut=0
          if(kjet(5,0).lt.kjet(6,0))then
            do vcomp=0,3
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(6,vcomp)=kjet(4,vcomp)
              kevent(3,vcomp)=kjet(6,vcomp)
              kevent(4,vcomp)=kjet(5,vcomp)
              kevent(7,vcomp)=0d0
            enddo
          else
            do vcomp=0,3
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(6,vcomp)=kjet(4,vcomp)
              kevent(3,vcomp)=kjet(5,vcomp)
              kevent(4,vcomp)=kjet(6,vcomp)
              kevent(7,vcomp)=0d0
            enddo
          endif
          call applyhiggscut(kbeam,kevent,generator,njet,cut,switch)
        elseif(scuts(generator).gt.0.or.shtr.eq.1) then
          kt2(6)=kjet(6,1)**2+kjet(6,2)**2
          kt2(5)=kjet(5,1)**2+kjet(5,2)**2
          if(kt2(4).lt.kt2(5))then
            do vcomp=0,3
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(6,vcomp)=kjet(4,vcomp)
              kevent(3,vcomp)=kjet(6,vcomp)
              kevent(4,vcomp)=kjet(5,vcomp)
              kevent(7,vcomp)=0d0
            enddo
          else
            do vcomp=0,3
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(6,vcomp)=kjet(4,vcomp)
              kevent(3,vcomp)=kjet(5,vcomp)
              kevent(4,vcomp)=kjet(6,vcomp)
              kevent(7,vcomp)=0d0
            enddo
          endif
          call applycut(kbeam,kevent,generator,njet,cut,switch)
        endif

      else if (njet.eq.7) then
c events with Higgs + 3 jets or 2 jets + photon

        if(scuts(generator).eq.1) then
c number of jets passing the cuts (tagged jets)
          ntjet=0
c number of jets not passing the cuts (untagged jets)
          nutjet=0
          do ext=5,7
            if(typejet(ext).eq.1)then
              kt2(ext)=kjet(ext,1)**2+kjet(ext,2)**2
              if(kjet(ext,0)-kjet(ext,3).eq.0) then
                y(ext) = 1d10
              elseif(kjet(ext,0)+kjet(ext,3).eq.0) then
                y(ext) = -1d10
              else
                y(ext)=.5d0*log((kjet(ext,0)+kjet(ext,3))
     &              /(kjet(ext,0)-kjet(ext,3)))
              endif
              if(abs(y(ext)).lt.ycutj.and.kt2(ext).gt.ptcutj**2) then
                ntjet=ntjet+1
                pointer(ntjet)=ext
              else
                nutjet=nutjet+1
                pointer(4-nutjet)=ext
              endif
            else
              nutjet=nutjet+1
              pointer(4-nutjet)=ext
            endif
          enddo


          if(ntjet.lt.2)then
            cut=31
            return
          endif
          if(ntjet.eq.2)then
            if(kt2(pointer(1)).lt.kt2(pointer(2)))then
              swap=pointer(1)
              pointer(1)=pointer(2)
              pointer(2)=swap
            endif
          else
            if(kt2(pointer(1)).lt.kt2(pointer(2)))then
              swap=pointer(1)
              pointer(1)=pointer(2)
              pointer(2)=swap
            endif
            if(kt2(pointer(2)).lt.kt2(pointer(3)))then
              swap=pointer(2)
              pointer(2)=pointer(3)
              pointer(3)=swap
            endif
            if(kt2(pointer(1)).lt.kt2(pointer(2)))then
              swap=pointer(1)
              pointer(1)=pointer(2)
              pointer(2)=swap
            endif
          endif


          cut=32
          if(abs(y(pointer(1))-y(pointer(2))).lt.dycutjj) return
          cut=33
          if(lhemicut.and.y(pointer(1))*y(pointer(2)).gt.0d0) return
          cut=34
          sjj=(kjet(pointer(1),0)+kjet(pointer(2),0))**2
     &        - (kjet(pointer(1),1)+kjet(pointer(2),1))**2
     &        - (kjet(pointer(1),2)+kjet(pointer(2),2))**2
     &        - (kjet(pointer(1),3)+kjet(pointer(2),3))**2


          if(sjj.lt.mcutjj*mcutjj)return

          cut=0
          if(ntjet.eq.2)then
            do vcomp=0,3
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(6,vcomp)=kjet(4,vcomp)
              kevent(3,vcomp)=kjet(pointer(1),vcomp)
              kevent(4,vcomp)=kjet(pointer(2),vcomp)
              kevent(7,vcomp)=0d0
            enddo
          else
            do vcomp=0,3
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(6,vcomp)=kjet(4,vcomp)
              kevent(3,vcomp)=kjet(pointer(1),vcomp)
              kevent(4,vcomp)=kjet(pointer(2),vcomp)
              kevent(7,vcomp)=kjet(pointer(3),vcomp)
            enddo
          endif
          call applyhiggscut(kbeam,kevent,generator,njet,cut,switch)
        else if(scuts(generator).eq.2) then
c number of jets passing the cuts (tagged jets)
          ntjet=0
c number of jets not passing the cuts (untagged jets)
          nutjet=0
          do ext=4,6
            if(typejet(ext).eq.1)then
              kt2(ext)=kjet(ext,1)**2+kjet(ext,2)**2
              if(kjet(ext,0)-kjet(ext,3).eq.0) then
                y(ext) = 1d10
              elseif(kjet(ext,0)+kjet(ext,3).eq.0) then
                y(ext) = -1d10
              else
                y(ext)=.5d0*log((kjet(ext,0)+kjet(ext,3))
     &              /(kjet(ext,0)-kjet(ext,3)))
              endif
              if(abs(y(ext)).lt.ycutj.and.kt2(ext).gt.ptcutj**2) then
                ntjet=ntjet+1
                pointer(ntjet)=ext
              else
                nutjet=nutjet+1
                pointer(4-nutjet)=ext
              endif
            else
              nutjet=nutjet+1
              pointer(4-nutjet)=ext
            endif
          enddo

          if(ntjet.lt.2)then
            cut=31
            return
          endif
          if(ntjet.eq.2)then
            if(kjet(pointer(1),0).lt.kjet(pointer(2),0))then
              swap=pointer(1)
              pointer(1)=pointer(2)
              pointer(2)=swap
            endif
          else
            if(kjet(pointer(1),0).lt.kjet(pointer(2),0))then
              swap=pointer(1)
              pointer(1)=pointer(2)
              pointer(2)=swap
            endif
            if(kjet(pointer(2),0).lt.kjet(pointer(3),0))then
              swap=pointer(2)
              pointer(2)=pointer(3)
              pointer(3)=swap
            endif
            if(kjet(pointer(1),0).lt.kjet(pointer(2),0))then
              swap=pointer(1)
              pointer(1)=pointer(2)
              pointer(2)=swap
            endif
          endif

          cut=32
          if(abs(y(pointer(1))-y(pointer(2))).lt.dycutjj) return
          cut=33
          if(lhemicut.and.y(pointer(1))*y(pointer(2)).gt.0d0) return
          cut=34
          sjj=(kjet(pointer(1),0)+kjet(pointer(2),0))**2
     &        - (kjet(pointer(1),1)+kjet(pointer(2),1))**2
     &        - (kjet(pointer(1),2)+kjet(pointer(2),2))**2
     &        - (kjet(pointer(1),3)+kjet(pointer(2),3))**2
          if(sjj.lt.mcutjj*mcutjj)return
          cut=0
          if(ntjet.eq.2)then
            do vcomp=0,3
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(6,vcomp)=kjet(4,vcomp)
              kevent(3,vcomp)=kjet(pointer(1),vcomp)
              kevent(4,vcomp)=kjet(pointer(2),vcomp)
              kevent(7,vcomp)=0d0
            enddo
          else
            do vcomp=0,3
              kevent(1,vcomp)=kjet(1,vcomp)
              kevent(2,vcomp)=kjet(2,vcomp)
              kevent(5,vcomp)=kjet(3,vcomp)
              kevent(6,vcomp)=kjet(4,vcomp)
              kevent(3,vcomp)=kjet(pointer(1),vcomp)
              kevent(4,vcomp)=kjet(pointer(2),vcomp)
              kevent(7,vcomp)=kjet(pointer(3),vcomp)
            enddo
          endif
          call applyhiggscut(kbeam,kevent,generator,njet,cut,switch)
        elseif(scuts(generator).gt.0.or.shtr.eq.1) then
          if(generator.eq.1)then
            kt2(6)=kjet(6,1)**2+kjet(6,2)**2
            kt2(5)=kjet(5,1)**2+kjet(5,2)**2
            if(kt2(5).lt.kt2(6))then
              do vcomp=0,3
                kevent(1,vcomp)=kjet(1,vcomp)
                kevent(2,vcomp)=kjet(2,vcomp)
                kevent(3,vcomp)=kjet(6,vcomp)
                kevent(4,vcomp)=kjet(5,vcomp)
                kevent(5,vcomp)=kjet(3,vcomp)
                kevent(6,vcomp)=kjet(4,vcomp)
                kevent(7,vcomp)=0d0
              enddo
            else
              do vcomp=0,3
                kevent(1,vcomp)=kjet(1,vcomp)
                kevent(2,vcomp)=kjet(2,vcomp)
                kevent(3,vcomp)=kjet(5,vcomp)
                kevent(4,vcomp)=kjet(6,vcomp)
                kevent(5,vcomp)=kjet(3,vcomp)
                kevent(6,vcomp)=kjet(4,vcomp)
                kevent(7,vcomp)=0d0
              enddo
            endif
          else
            kt2(5)=kjet(5,1)**2+kjet(5,2)**2
            kt2(6)=kjet(6,1)**2+kjet(6,2)**2
            kt2(7)=kjet(7,1)**2+kjet(7,2)**2
            if(kt2(7).lt.kt2(5).and.kt2(7).lt.kt2(6))then
              if(kt2(5).lt.kt2(6))then
                do vcomp=0,3
                  kevent(1,vcomp)=kjet(1,vcomp)
                  kevent(2,vcomp)=kjet(2,vcomp)
                  kevent(3,vcomp)=kjet(6,vcomp)
                  kevent(4,vcomp)=kjet(5,vcomp)
                  kevent(5,vcomp)=kjet(3,vcomp)
                  kevent(6,vcomp)=kjet(4,vcomp)
                  kevent(7,vcomp)=kjet(7,vcomp)
                enddo
              else
                do vcomp=0,3
                  kevent(1,vcomp)=kjet(1,vcomp)
                  kevent(2,vcomp)=kjet(2,vcomp)
                  kevent(3,vcomp)=kjet(5,vcomp)
                  kevent(4,vcomp)=kjet(6,vcomp)
                  kevent(5,vcomp)=kjet(3,vcomp)
                  kevent(6,vcomp)=kjet(4,vcomp)
                  kevent(7,vcomp)=kjet(7,vcomp)
                enddo
              endif
            elseif(kt2(5).lt.kt2(7).and.kt2(5).lt.kt2(6))then
              if(kt2(7).lt.kt2(6))then
                do vcomp=0,3
                  kevent(1,vcomp)=kjet(1,vcomp)
                  kevent(2,vcomp)=kjet(2,vcomp)
                  kevent(3,vcomp)=kjet(6,vcomp)
                  kevent(4,vcomp)=kjet(7,vcomp)
                  kevent(5,vcomp)=kjet(3,vcomp)
                  kevent(6,vcomp)=kjet(4,vcomp)
                  kevent(7,vcomp)=kjet(5,vcomp)
                enddo
              else
                do vcomp=0,3
                  kevent(1,vcomp)=kjet(1,vcomp)
                  kevent(2,vcomp)=kjet(2,vcomp)
                  kevent(3,vcomp)=kjet(7,vcomp)
                  kevent(4,vcomp)=kjet(6,vcomp)
                  kevent(5,vcomp)=kjet(3,vcomp)
                  kevent(6,vcomp)=kjet(4,vcomp)
                  kevent(7,vcomp)=kjet(5,vcomp)
                enddo
              endif
            else
              if(kt2(7).lt.kt2(5))then
                do vcomp=0,3
                  kevent(1,vcomp)=kjet(1,vcomp)
                  kevent(2,vcomp)=kjet(2,vcomp)
                  kevent(3,vcomp)=kjet(5,vcomp)
                  kevent(4,vcomp)=kjet(7,vcomp)
                  kevent(5,vcomp)=kjet(3,vcomp)
                  kevent(6,vcomp)=kjet(4,vcomp)
                  kevent(7,vcomp)=kjet(6,vcomp)
                enddo
              else
                do vcomp=0,3
                  kevent(1,vcomp)=kjet(1,vcomp)
                  kevent(2,vcomp)=kjet(2,vcomp)
                  kevent(3,vcomp)=kjet(5,vcomp)
                  kevent(4,vcomp)=kjet(7,vcomp)
                  kevent(5,vcomp)=kjet(3,vcomp)
                  kevent(6,vcomp)=kjet(4,vcomp)
                  kevent(7,vcomp)=kjet(6,vcomp)
                enddo
              endif
            endif
          endif
          call applycut(kbeam,kevent,generator,njet,cut,switch)
        endif
      endif

      endif ! if shtr.eq.0
      end

**********************************************************************
#ifdef multpdf
        subroutine wpdf(x,mfact,pdf,mpdf,pdf_phot,spdf)
#else
        subroutine wpdf(x,mfact,pdf,pdf_phot,spdf)
#endif
**********************************************************************
*       spdf=1:   MRST2004QEDx with    O(alpha) effects
*       spdf=2:   MRST2004QEDx without O(alpha) effects
*       spdf=11:  CTEQ6M
*       spdf=14:  CTEQ6L1
*       spdf=99:  LHApdf
*---------------------------------------------------------------------
*       6.1.06 Stefan Dittmaier
**********************************************************************
        implicit none
#include "mcparams.h"
#ifdef multpdf
#include "multpdf.h"
        integer nset
        double precision mpdf(maxpdf,-6:6)
#endif
c*** boundary for MRST2004QED
        real*8 pdf(-6:6),x,pdf_phot
        real*8 xmin,xmax,qsqmin,qsqmax,mfact
        real*8 upv,dnv,usea,dsea,str,chm,bot,xglu,phot
        real*8 ctq6pdf
	integer i,spdf
        data xmin,xmax,qsqmin,qsqmax/1d-5,1d0,1.25d0,1d7/


        if (spdf.eq.1) then
c*** MRST2004QED [with O(alpha) effects]
c    ===================================
          if ((x.lt.xmin).or.(x.gt.xmax)) then
	    do i=-6,6
	      pdf(i) = 0d0
	    enddo
            pdf_phot = 0d0
            return
          endif
          if (mfact**2.lt.qsqmin) mfact = sqrt(qsqmin)
          if (mfact**2.gt.qsqmax) mfact = sqrt(qsqmax)
          call mrstqed(x,mfact,1,
     &                  upv,dnv,usea,dsea,str,chm,bot,xglu,phot)
          pdf(0)   = xglu / x
          pdf(+1)  = (dnv+dsea) / x
          pdf(-1)  =     dsea / x
          pdf(+2)  = (upv+usea) / x
          pdf(-2)  =     usea / x
          pdf(+3)  = str / x
          pdf(-3)  = str / x
          pdf(+4)  = chm / x
          pdf(-4)  = chm / x
          pdf(+5)  = bot / x
          pdf(-5)  = bot / x
	  pdf_phot = phot / x
        elseif (spdf.eq.2) then

c*** MRST2004QEDx [without O(alpha) effects]
c    =======================================
          if ((x.lt.xmin).or.(x.gt.xmax)) then
	    do i=-6,6
	      pdf(i) = 0d0
	    enddo
            pdf_phot = 0d0
            return
          endif
          if (mfact**2.lt.qsqmin) mfact = sqrt(qsqmin)
          if (mfact**2.gt.qsqmax) mfact = sqrt(qsqmax)
          call mrstqed(x,mfact,3,
     &                  upv,dnv,usea,dsea,str,chm,bot,xglu,phot)
          pdf(0)   = xglu / x
          pdf(+1)  = (dnv+dsea) / x
          pdf(-1)  =     dsea / x
          pdf(+2)  = (upv+usea) / x
          pdf(-2)  =     usea / x
          pdf(+3)  = str / x
          pdf(-3)  = str / x
          pdf(+4)  = chm / x
          pdf(-4)  = chm / x
          pdf(+5)  = bot / x
          pdf(-5)  = bot / x
	  pdf_phot = 0d0


        elseif (spdf.ge.10.and.spdf.lt.20) then

          pdf(0)  = Ctq6Pdf( 0,x,mfact)
          pdf(+1) = Ctq6Pdf( 2,x,mfact)
          pdf(-1) = Ctq6Pdf(-2,x,mfact)
          pdf(+2) = Ctq6Pdf( 1,x,mfact)
          pdf(-2) = Ctq6Pdf(-1,x,mfact)
          pdf(+3) = Ctq6Pdf( 3,x,mfact)
          pdf(-3) = Ctq6Pdf(-3,x,mfact)
          pdf(+4) = Ctq6Pdf( 4,x,mfact)
          pdf(-4) = Ctq6Pdf(-4,x,mfact)
          pdf(+5) = Ctq6Pdf( 5,x,mfact)
          pdf(-5) = Ctq6Pdf(-5,x,mfact)




        elseif (spdf.eq.99) then
#ifdef includeLHAPDF
#ifdef multpdf
	  do nset=1,pdfmemberto-pdfmemberfrom+1
	    call InitPDF(pdfmemberfrom-1+nset)
	    call evolvepdf(x,mfact,pdf)
            mpdf(nset,0)  = pdf(0)/x
            mpdf(nset,+1) = pdf(+1)/x
            mpdf(nset,-1) = pdf(-1)/x
            mpdf(nset,+2) = pdf(+2)/x
            mpdf(nset,-2) = pdf(-2)/x
            mpdf(nset,+3) = pdf(+3)/x
            mpdf(nset,-3) = pdf(-3)/x
            mpdf(nset,+4) = pdf(+4)/x
            mpdf(nset,-4) = pdf(-4)/x
            mpdf(nset,+5) = pdf(+5)/x
            mpdf(nset,-5) = pdf(-5)/x
	  enddo
	  If(pdfmemberto-pdfmemberfrom.GE.0) Then
	    call InitPDF(pdfmembercentral)
	  Endif
	  call evolvepdf(x,mfact,pdf)
          pdf(0)  = pdf(0)/x
          pdf(+1) = pdf(+1)/x
          pdf(-1) = pdf(-1)/x
          pdf(+2) = pdf(+2)/x
          pdf(-2) = pdf(-2)/x
          pdf(+3) = pdf(+3)/x
          pdf(-3) = pdf(-3)/x
          pdf(+4) = pdf(+4)/x
          pdf(-4) = pdf(-4)/x
          pdf(+5) = pdf(+5)/x
          pdf(-5) = pdf(-5)/x 	
#else
          call evolvepdf(x,mfact,pdf)

          pdf(0)  = pdf(0)/x
          pdf(+1) = pdf(+1)/x
          pdf(-1) = pdf(-1)/x
          pdf(+2) = pdf(+2)/x
          pdf(-2) = pdf(-2)/x
          pdf(+3) = pdf(+3)/x
          pdf(-3) = pdf(-3)/x
          pdf(+4) = pdf(+4)/x
          pdf(-4) = pdf(-4)/x
          pdf(+5) = pdf(+5)/x
          pdf(-5) = pdf(-5)/x
#endif
#else
       Print *,"LHAPDF not included: #define includeLHAPDF"
       Stop
#endif
	endif

	end

