************************************************************************
        subroutine calcform_HZZ2233(F0,F1,Fgd,Fgnd,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for ZZ-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    down     anti-down     down     anti-down
*-----------------------------------------------------------------------
*       17.11.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        complex*16 v,cv
        COMPLEX*16 F0(13,-1:1,-1:1),F1(13,-1:1,-1:1),pz12,pz34,pre
        COMPLEX*16 Fgd(13,-1:1,-1:1),Fgnd(13,-1:1,-1:1)
        complex*16 ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2,cmh,cmh2
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
       	common/cparam/ccw,ccw2,csw,csw2,cmw,cmw2,cmz,cmz2
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(s12.lt.0d0))) then
          pz12 = 1d0/(s12-mz2)
        else
          pz12 = 1d0/(s12-cmz2)
        endif
        if ((qwidth.eq.0).or.((qwidth.eq.2).and.(s34.lt.0d0))) then
          pz34 = 1d0/(s34-mz2)
        else
          pz34 = 1d0/(s34-cmz2)
        endif

        PRE = (PZ12*PZ34*XCW2**(-2)*XMW)/4D0

        F0(1,-1,-1) = F0(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
        F0(1,-1,1) = F0(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW
        F0(1,1,-1) = F0(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
        F0(1,1,1) = F0(1,1,1)+4D0*QF(2)*QF(3)*PRE*XSW

	if (qferm.eq.1) call add_HZZ2233_ferm(F1,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)

        if (qbos.eq.1) then
          call add_HZZ2233_self(F1,pz12,pz34,
     &                  s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
          call add_HZZ2233_vert(F1,pz12,pz34,
     &                  s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
          call add_HZZ2233_box(F1,pz12,pz34,
     &                  s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
          call add_HZZ2233_pent(F1,pz12,pz34,
     &                  s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
        elseif (qbos.eq.2) then
          call add_HZZ2233_self_bgf(F1,pz12,pz34,
     &                  s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
          call add_HZZ2233_vert_bgf(F1,pz12,pz34,
     &                  s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
          call add_HZZ2233_box_bgf(F1,pz12,pz34,
     &                  s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
          call add_HZZ2233_pent(F1,pz12,pz34,
     &                  s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
        endif

	if (qqcddiag.eq.1) call add_HZZ2233_qcdv(Fgd,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)

	if (qqcdnondiag.eq.1) then
	  call add_HZZ2233_qcdv(Fgnd,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
	  call add_HZZ2233_gpent(Fgnd,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
	endif

	if (qsoft.eq.1) call add_HZZ2233_endp(F1,Fgd,Fgnd,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)

        if (qqcdgsplit.eq.1) then
          call add_HZZ2233_qcdbox(Fgnd,pz12,pz34,
     &                  s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
          call add_HZZ2233_qcdv2(Fgnd,pz12,pz34,
     &                  s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
        endif

        if (qqcdggfus.eq.1) then
          call add_HZZ2233_qcdferm(Fgnd,pz12,pz34,
     &                  s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
        endif

	end

************************************************************************
        subroutine add_HZZ2233_ferm(F,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for ZZ-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    down     anti-down     down     anti-down
*	fermion-loop contributions
*-----------------------------------------------------------------------
*       15.12.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(22)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pz12,pz34
        COMPLEX*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
        complex*16 dZuur,dZuul,dZddr,dZddl
        complex*16 ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl
	integer i

        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/xrenc_ferm/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &         dZuur,dZuul,dZddr,dZddl,
     &         ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl

	do 100 i=1,3

c*** self-energies
c-----------------

C       Process: S1F22aF22F23aF23,   Model: SM4f

C       G(T3,N42,FULL)
        CALL xB012345_(S12,NULL,NULL,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PZ12**2*PZ34*(12D0*B2(0,0)+S12+6D0*B1(1)*S12+
     &  6D0*B2(1,1)*S12)*XCW2**(-3)*XMW)/(192D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T3,N27,FULL)+G(T3,N40,FULL)
        CALL xB012345_(S12,XMQM2(I),XMQM2(I),B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 9D0*PZ12*S12-6D0*XCW2-12D0*PZ12*S12*XSW2+8D0*XCW2*
     &  XSW2+8D0*PZ12*S12*XSW2**2
        K(2) = -(3D0*PZ12*S12)-3D0*QF(2)*XCW2+2D0*PZ12*S12*XSW2-6D0*
     &  QF(2)*PZ12*S12*XSW2+4D0*QF(2)*XCW2*XSW2+4D0*QF(2)*PZ12*S12*
     &  XSW2**2
        K(3) = 9D0*PZ12*S12-12D0*PZ12*S12*XSW2+18D0*QF(2)*PZ12*S12*
     &  XSW2-12D0*QF(2)*XCW2*XSW2+8D0*PZ12*S12*XSW2**2-24D0*QF(2)*
     &  PZ12*S12*XSW2**2+16D0*QF(2)*XCW2*XSW2**2+16D0*QF(2)*PZ12*
     &  S12*XSW2**3

        PRE = -((ALPHA*PZ12*PZ34*XCW2**(-3)*XMW)/(576D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2)*(-((6D0*
     &  B1(1)*K(3))/XSW2)-(6D0*B2(1,1)*K(3))/XSW2-(12D0*B2(0,0)*
     &  K(3))/(S12*XSW2)+(24D0*K(2)*B0*XMQM2(I))/S12-(K(3)*(S12-6D0*
     &  XMQM2(I)))/(S12*XSW2)))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*(-((6D0*B1(1)*K(3))/
     &  XSW2)-(6D0*B2(1,1)*K(3))/XSW2-(12D0*B2(0,0)*K(3))/(S12*
     &  XSW2)+(24D0*K(2)*B0*XMQM2(I))/S12-(K(3)*(S12-6D0*XMQM2(I)))/
     &  (S12*XSW2))
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2)*(-
     &  (6D0*B1(1)*K(1))-6D0*B2(1,1)*K(1)-(12D0*B2(0,0)*K(1))/S12+
     &  (12D0*B0*(-(3D0*XCW2)-6D0*PZ12*S12*XSW2+4D0*XCW2*XSW2+4D0*
     &  PZ12*S12*XSW2**2)*XMQM2(I))/S12-(K(1)*(S12-6D0*XMQM2(I)))/
     &  S12))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(-(6D0*B1(1)*K(1))-
     &  6D0*B2(1,1)*K(1)-(12D0*B2(0,0)*K(1))/S12+(12D0*B0*(-(3D0*
     &  XCW2)-6D0*PZ12*S12*XSW2+4D0*XCW2*XSW2+4D0*PZ12*S12*XSW2**2)*
     &  XMQM2(I))/S12-(K(1)*(S12-6D0*XMQM2(I)))/S12)

C       G(T3,N29,FULL)+G(T3,N43,FULL)
        CALL xB012345_(S12,XML2(I),XML2(I),B0,B1,B2,B3,B4,B5,2,0)
        K(1) = PZ12*S12-2D0*XCW2-4D0*PZ12*S12*XSW2+8D0*XCW2*XSW2+
     &  8D0*PZ12*S12*XSW2**2
        K(2) = PZ12*S12+QF(2)*XCW2-2D0*PZ12*S12*XSW2+2D0*QF(2)*PZ12*
     &  S12*XSW2-4D0*QF(2)*XCW2*XSW2-4D0*QF(2)*PZ12*S12*XSW2**2
        K(3) = PZ12*S12-4D0*PZ12*S12*XSW2+2D0*QF(2)*PZ12*S12*XSW2-
     &  4D0*QF(2)*XCW2*XSW2+8D0*PZ12*S12*XSW2**2-8D0*QF(2)*PZ12*S12*
     &  XSW2**2+16D0*QF(2)*XCW2*XSW2**2+16D0*QF(2)*PZ12*S12*XSW2**3

        PRE = (ALPHA*PZ12*PZ34*XCW2**(-3)*XMW)/(192D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2)*((6D0*
     &  B1(1)*K(3))/XSW2+(6D0*B2(1,1)*K(3))/XSW2+(12D0*B2(0,0)*
     &  K(3))/(S12*XSW2)+(24D0*K(2)*B0*XML2(I))/S12+(K(3)*(S12-6D0*
     &  XML2(I)))/(S12*XSW2)))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*((6D0*B1(1)*K(3))/XSW2+
     &  (6D0*B2(1,1)*K(3))/XSW2+(12D0*B2(0,0)*K(3))/(S12*XSW2)+
     &  (24D0*K(2)*B0*XML2(I))/S12+(K(3)*(S12-6D0*XML2(I)))/(S12*
     &  XSW2))
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2)*
     &  (6D0*B1(1)*K(1)+6D0*B2(1,1)*K(1)+(12D0*B2(0,0)*K(1))/S12+
     &  (12D0*B0*(XCW2+2D0*PZ12*S12*XSW2-4D0*XCW2*XSW2-4D0*PZ12*S12*
     &  XSW2**2)*XML2(I))/S12+(K(1)*(S12-6D0*XML2(I)))/S12))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(6D0*B1(1)*K(1)+6D0*
     &  B2(1,1)*K(1)+(12D0*B2(0,0)*K(1))/S12+(12D0*B0*(XCW2+2D0*
     &  PZ12*S12*XSW2-4D0*XCW2*XSW2-4D0*PZ12*S12*XSW2**2)*XML2(I))/
     &  S12+(K(1)*(S12-6D0*XML2(I)))/S12)

C       G(T3,N28,FULL)+G(T3,N41,FULL)
        CALL xB012345_(S12,XMQP2(I),XMQP2(I),B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 9D0*PZ12*S12-12D0*XCW2-24D0*PZ12*S12*XSW2+32D0*XCW2*
     &  XSW2+32D0*PZ12*S12*XSW2**2
        K(2) = -(3D0*PZ12*S12)-3D0*QF(2)*XCW2+4D0*PZ12*S12*XSW2-6D0*
     &  QF(2)*PZ12*S12*XSW2+8D0*QF(2)*XCW2*XSW2+8D0*QF(2)*PZ12*S12*
     &  XSW2**2
        K(3) = 9D0*PZ12*S12-24D0*PZ12*S12*XSW2+18D0*QF(2)*PZ12*S12*
     &  XSW2-24D0*QF(2)*XCW2*XSW2+32D0*PZ12*S12*XSW2**2-48D0*QF(2)*
     &  PZ12*S12*XSW2**2+64D0*QF(2)*XCW2*XSW2**2+64D0*QF(2)*PZ12*
     &  S12*XSW2**3

        PRE = -((ALPHA*PZ12*PZ34*XCW2**(-3)*XMW)/(576D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2)*(-((6D0*
     &  B1(1)*K(3))/XSW2)-(6D0*B2(1,1)*K(3))/XSW2-(12D0*B2(0,0)*
     &  K(3))/(S12*XSW2)+(48D0*K(2)*B0*XMQP2(I))/S12-(K(3)*(S12-6D0*
     &  XMQP2(I)))/(S12*XSW2)))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*(-((6D0*B1(1)*K(3))/
     &  XSW2)-(6D0*B2(1,1)*K(3))/XSW2-(12D0*B2(0,0)*K(3))/(S12*
     &  XSW2)+(48D0*K(2)*B0*XMQP2(I))/S12-(K(3)*(S12-6D0*XMQP2(I)))/
     &  (S12*XSW2))
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2)*(-
     &  (6D0*B1(1)*K(1))-6D0*B2(1,1)*K(1)-(12D0*B2(0,0)*K(1))/S12+
     &  (24D0*B0*(-(3D0*XCW2)-6D0*PZ12*S12*XSW2+8D0*XCW2*XSW2+8D0*
     &  PZ12*S12*XSW2**2)*XMQP2(I))/S12-(K(1)*(S12-6D0*XMQP2(I)))/
     &  S12))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(-(6D0*B1(1)*K(1))-
     &  6D0*B2(1,1)*K(1)-(12D0*B2(0,0)*K(1))/S12+(24D0*B0*(-(3D0*
     &  XCW2)-6D0*PZ12*S12*XSW2+8D0*XCW2*XSW2+8D0*PZ12*S12*XSW2**2)*
     &  XMQP2(I))/S12-(K(1)*(S12-6D0*XMQP2(I)))/S12)

C       G(T4,N81,FULL)
        CALL xB012345_(S34,NULL,NULL,B0,B1,B2,B3,B4,B5,2,0)

        PRE = (ALPHA*PZ12*PZ34**2*(12D0*B2(0,0)+S34+6D0*B1(1)*S34+
     &  6D0*B2(1,1)*S34)*XCW2**(-3)*XMW)/(192D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T4,N66,FULL)+G(T4,N79,FULL)
        CALL xB012345_(S34,XMQM2(I),XMQM2(I),B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 9D0*PZ34*S34-6D0*XCW2-12D0*PZ34*S34*XSW2+8D0*XCW2*
     &  XSW2+8D0*PZ34*S34*XSW2**2
        K(2) = -(3D0*PZ34*S34)-3D0*QF(3)*XCW2+2D0*PZ34*S34*XSW2-6D0*
     &  QF(3)*PZ34*S34*XSW2+4D0*QF(3)*XCW2*XSW2+4D0*QF(3)*PZ34*S34*
     &  XSW2**2
        K(3) = 9D0*PZ34*S34-12D0*PZ34*S34*XSW2+18D0*QF(3)*PZ34*S34*
     &  XSW2-12D0*QF(3)*XCW2*XSW2+8D0*PZ34*S34*XSW2**2-24D0*QF(3)*
     &  PZ34*S34*XSW2**2+16D0*QF(3)*XCW2*XSW2**2+16D0*QF(3)*PZ34*
     &  S34*XSW2**3

        PRE = -((ALPHA*PZ12*PZ34*XCW2**(-3)*XMW)/(576D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(-((6D0*
     &  B1(1)*K(3))/XSW2)-(6D0*B2(1,1)*K(3))/XSW2-(12D0*B2(0,0)*
     &  K(3))/(S34*XSW2)+(24D0*K(2)*B0*XMQM2(I))/S34-(K(3)*(S34-6D0*
     &  XMQM2(I)))/(S34*XSW2)))/XSW2
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2)*(-
     &  (6D0*B1(1)*K(1))-6D0*B2(1,1)*K(1)-(12D0*B2(0,0)*K(1))/S34+
     &  (12D0*B0*(-(3D0*XCW2)-6D0*PZ34*S34*XSW2+4D0*XCW2*XSW2+4D0*
     &  PZ34*S34*XSW2**2)*XMQM2(I))/S34-(K(1)*(S34-6D0*XMQM2(I)))/
     &  S34))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(2)*PRE*(-((6D0*B1(1)*K(3))/
     &  XSW2)-(6D0*B2(1,1)*K(3))/XSW2-(12D0*B2(0,0)*K(3))/(S34*
     &  XSW2)+(24D0*K(2)*B0*XMQM2(I))/S34-(K(3)*(S34-6D0*XMQM2(I)))/
     &  (S34*XSW2))
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(-(6D0*B1(1)*K(1))-
     &  6D0*B2(1,1)*K(1)-(12D0*B2(0,0)*K(1))/S34+(12D0*B0*(-(3D0*
     &  XCW2)-6D0*PZ34*S34*XSW2+4D0*XCW2*XSW2+4D0*PZ34*S34*XSW2**2)*
     &  XMQM2(I))/S34-(K(1)*(S34-6D0*XMQM2(I)))/S34)

C       G(T4,N68,FULL)+G(T4,N82,FULL)
        CALL xB012345_(S34,XML2(I),XML2(I),B0,B1,B2,B3,B4,B5,2,0)
        K(1) = PZ34*S34-2D0*XCW2-4D0*PZ34*S34*XSW2+8D0*XCW2*XSW2+
     &  8D0*PZ34*S34*XSW2**2
        K(2) = PZ34*S34+QF(3)*XCW2-2D0*PZ34*S34*XSW2+2D0*QF(3)*PZ34*
     &  S34*XSW2-4D0*QF(3)*XCW2*XSW2-4D0*QF(3)*PZ34*S34*XSW2**2
        K(3) = PZ34*S34-4D0*PZ34*S34*XSW2+2D0*QF(3)*PZ34*S34*XSW2-
     &  4D0*QF(3)*XCW2*XSW2+8D0*PZ34*S34*XSW2**2-8D0*QF(3)*PZ34*S34*
     &  XSW2**2+16D0*QF(3)*XCW2*XSW2**2+16D0*QF(3)*PZ34*S34*XSW2**3

        PRE = (ALPHA*PZ12*PZ34*XCW2**(-3)*XMW)/(192D0*PI*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*((6D0*
     &  B1(1)*K(3))/XSW2+(6D0*B2(1,1)*K(3))/XSW2+(12D0*B2(0,0)*
     &  K(3))/(S34*XSW2)+(24D0*K(2)*B0*XML2(I))/S34+(K(3)*(S34-6D0*
     &  XML2(I)))/(S34*XSW2)))/XSW2
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2)*
     &  (6D0*B1(1)*K(1)+6D0*B2(1,1)*K(1)+(12D0*B2(0,0)*K(1))/S34+
     &  (12D0*B0*(XCW2+2D0*PZ34*S34*XSW2-4D0*XCW2*XSW2-4D0*PZ34*S34*
     &  XSW2**2)*XML2(I))/S34+(K(1)*(S34-6D0*XML2(I)))/S34))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(2)*PRE*((6D0*B1(1)*K(3))/XSW2+
     &  (6D0*B2(1,1)*K(3))/XSW2+(12D0*B2(0,0)*K(3))/(S34*XSW2)+
     &  (24D0*K(2)*B0*XML2(I))/S34+(K(3)*(S34-6D0*XML2(I)))/(S34*
     &  XSW2))
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(6D0*B1(1)*K(1)+6D0*
     &  B2(1,1)*K(1)+(12D0*B2(0,0)*K(1))/S34+(12D0*B0*(XCW2+2D0*
     &  PZ34*S34*XSW2-4D0*XCW2*XSW2-4D0*PZ34*S34*XSW2**2)*XML2(I))/
     &  S34+(K(1)*(S34-6D0*XML2(I)))/S34)

C       G(T4,N67,FULL)+G(T4,N80,FULL)
        CALL xB012345_(S34,XMQP2(I),XMQP2(I),B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 9D0*PZ34*S34-12D0*XCW2-24D0*PZ34*S34*XSW2+32D0*XCW2*
     &  XSW2+32D0*PZ34*S34*XSW2**2
        K(2) = -(3D0*PZ34*S34)-3D0*QF(3)*XCW2+4D0*PZ34*S34*XSW2-6D0*
     &  QF(3)*PZ34*S34*XSW2+8D0*QF(3)*XCW2*XSW2+8D0*QF(3)*PZ34*S34*
     &  XSW2**2
        K(3) = 9D0*PZ34*S34-24D0*PZ34*S34*XSW2+18D0*QF(3)*PZ34*S34*
     &  XSW2-24D0*QF(3)*XCW2*XSW2+32D0*PZ34*S34*XSW2**2-48D0*QF(3)*
     &  PZ34*S34*XSW2**2+64D0*QF(3)*XCW2*XSW2**2+64D0*QF(3)*PZ34*
     &  S34*XSW2**3

        PRE = -((ALPHA*PZ12*PZ34*XCW2**(-3)*XMW)/(576D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(-((6D0*
     &  B1(1)*K(3))/XSW2)-(6D0*B2(1,1)*K(3))/XSW2-(12D0*B2(0,0)*
     &  K(3))/(S34*XSW2)+(48D0*K(2)*B0*XMQP2(I))/S34-(K(3)*(S34-6D0*
     &  XMQP2(I)))/(S34*XSW2)))/XSW2
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2)*(-
     &  (6D0*B1(1)*K(1))-6D0*B2(1,1)*K(1)-(12D0*B2(0,0)*K(1))/S34+
     &  (24D0*B0*(-(3D0*XCW2)-6D0*PZ34*S34*XSW2+8D0*XCW2*XSW2+8D0*
     &  PZ34*S34*XSW2**2)*XMQP2(I))/S34-(K(1)*(S34-6D0*XMQP2(I)))/
     &  S34))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(2)*PRE*(-((6D0*B1(1)*K(3))/
     &  XSW2)-(6D0*B2(1,1)*K(3))/XSW2-(12D0*B2(0,0)*K(3))/(S34*
     &  XSW2)+(48D0*K(2)*B0*XMQP2(I))/S34-(K(3)*(S34-6D0*XMQP2(I)))/
     &  (S34*XSW2))
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(-(6D0*B1(1)*K(1))-
     &  6D0*B2(1,1)*K(1)-(12D0*B2(0,0)*K(1))/S34+(24D0*B0*(-(3D0*
     &  XCW2)-6D0*PZ34*S34*XSW2+8D0*XCW2*XSW2+8D0*PZ34*S34*XSW2**2)*
     &  XMQP2(I))/S34-(K(1)*(S34-6D0*XMQP2(I)))/S34)

c*** vertex corrections
c----------------------

C       Process: S1F22aF22F23aF23,   Model: SM4f

C       G(T9,N691,FULL)+G(T9,N696,FULL)+G(T9,N709,FULL)+G(T9,N714,
C       FULL)+G(T9,N775,FULL)+G(T9,N780,FULL)+G(T9,N793,FULL)+G(T9,
C       N798,FULL)
        CALL xC01234_(S12,MH2,S34,XMQM2(I),XMQM2(I),XMQM2(I),
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S13+S14+S23+S24
        K(4) = -(9D0*C1(1)*PZ12*PZ34*(1D0+2D0*QF(2)*XSW2))-9D0*
     &  C1(2)*PZ12*PZ34*(1D0+2D0*QF(2)*XSW2)-(4D0*C2(1,2)*(9D0*PZ12*
     &  PZ34*S12*S34-6D0*PZ12*S12*XCW2-12D0*PZ12*PZ34*S12*S34*XSW2+
     &  18D0*QF(2)*PZ12*PZ34*S12*S34*XSW2+8D0*PZ12*S12*XCW2*XSW2-
     &  12D0*QF(2)*PZ12*S12*XCW2*XSW2-12D0*QF(2)*PZ34*S34*XCW2*XSW2+
     &  16D0*QF(2)*XCW2**2*XSW2+8D0*PZ12*PZ34*S12*S34*XSW2**2-24D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XSW2**2+16D0*QF(2)*PZ12*S12*XCW2*
     &  XSW2**2+16D0*QF(2)*PZ34*S34*XCW2*XSW2**2+16D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XSW2**3))/(S12*S34)+(2D0*C0*(-(3D0*PZ12*S12*
     &  XCW2)-6D0*PZ12*PZ34*S12*S34*XSW2+4D0*PZ12*S12*XCW2*XSW2-6D0*
     &  QF(2)*PZ12*S12*XCW2*XSW2-6D0*QF(2)*PZ34*S34*XCW2*XSW2+8D0*
     &  QF(2)*XCW2**2*XSW2+4D0*PZ12*PZ34*S12*S34*XSW2**2-12D0*QF(2)*
     &  PZ12*PZ34*S12*S34*XSW2**2+8D0*QF(2)*PZ12*S12*XCW2*XSW2**2+
     &  8D0*QF(2)*PZ34*S34*XCW2*XSW2**2+8D0*QF(2)*PZ12*PZ34*S12*S34*
     &  XSW2**3))/(S12*S34)
        K(5) = -(9D0*C1(1)*PZ12*PZ34*(1D0+2D0*QF(3)*XSW2))-9D0*
     &  C1(2)*PZ12*PZ34*(1D0+2D0*QF(3)*XSW2)-(4D0*C2(1,2)*(9D0*PZ12*
     &  PZ34*S12*S34-6D0*PZ34*S34*XCW2-12D0*PZ12*PZ34*S12*S34*XSW2+
     &  18D0*QF(3)*PZ12*PZ34*S12*S34*XSW2-12D0*QF(3)*PZ12*S12*XCW2*
     &  XSW2+8D0*PZ34*S34*XCW2*XSW2-12D0*QF(3)*PZ34*S34*XCW2*XSW2+
     &  16D0*QF(3)*XCW2**2*XSW2+8D0*PZ12*PZ34*S12*S34*XSW2**2-24D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XSW2**2+16D0*QF(3)*PZ12*S12*XCW2*
     &  XSW2**2+16D0*QF(3)*PZ34*S34*XCW2*XSW2**2+16D0*QF(3)*PZ12*
     &  PZ34*S12*S34*XSW2**3))/(S12*S34)+(2D0*C0*(-(3D0*PZ34*S34*
     &  XCW2)-6D0*PZ12*PZ34*S12*S34*XSW2-6D0*QF(3)*PZ12*S12*XCW2*
     &  XSW2+4D0*PZ34*S34*XCW2*XSW2-6D0*QF(3)*PZ34*S34*XCW2*XSW2+
     &  8D0*QF(3)*XCW2**2*XSW2+4D0*PZ12*PZ34*S12*S34*XSW2**2-12D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XSW2**2+8D0*QF(3)*PZ12*S12*XCW2*
     &  XSW2**2+8D0*QF(3)*PZ34*S34*XCW2*XSW2**2+8D0*QF(3)*PZ12*PZ34*
     &  S12*S34*XSW2**3))/(S12*S34)
        K(6) = -((9D0*C1(1)*PZ12*PZ34*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW2)-(9D0*C1(2)*PZ12*PZ34*(1D0+2D0*QF(2)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2))/XSW2+(4D0*C0*(-(3D0*PZ12*PZ34*
     &  S12*S34)-3D0*QF(3)*PZ12*S12*XCW2-3D0*QF(2)*PZ34*S34*XCW2+
     &  2D0*PZ12*PZ34*S12*S34*XSW2-6D0*QF(2)*PZ12*PZ34*S12*S34*XSW2-
     &  6D0*QF(3)*PZ12*PZ34*S12*S34*XSW2+4D0*QF(3)*PZ12*S12*XCW2*
     &  XSW2-6D0*QF(2)*QF(3)*PZ12*S12*XCW2*XSW2+4D0*QF(2)*PZ34*S34*
     &  XCW2*XSW2-6D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2+8D0*QF(2)*
     &  QF(3)*XCW2**2*XSW2+4D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**2+4D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XSW2**2-12D0*QF(2)*QF(3)*PZ12*PZ34*
     &  S12*S34*XSW2**2+8D0*QF(2)*QF(3)*PZ12*S12*XCW2*XSW2**2+8D0*
     &  QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**2+8D0*QF(2)*QF(3)*PZ12*PZ34*
     &  S12*S34*XSW2**3))/(S12*S34)-(4D0*C2(1,2)*(9D0*PZ12*PZ34*S12*
     &  S34-12D0*PZ12*PZ34*S12*S34*XSW2+18D0*QF(2)*PZ12*PZ34*S12*
     &  S34*XSW2+18D0*QF(3)*PZ12*PZ34*S12*S34*XSW2-12D0*QF(3)*PZ12*
     &  S12*XCW2*XSW2-12D0*QF(2)*PZ34*S34*XCW2*XSW2+8D0*PZ12*PZ34*
     &  S12*S34*XSW2**2-24D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**2-24D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XSW2**2+36D0*QF(2)*QF(3)*PZ12*PZ34*
     &  S12*S34*XSW2**2+16D0*QF(3)*PZ12*S12*XCW2*XSW2**2-24D0*QF(2)*
     &  QF(3)*PZ12*S12*XCW2*XSW2**2+16D0*QF(2)*PZ34*S34*XCW2*XSW2**
     &  2-24D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**2+32D0*QF(2)*QF(3)*
     &  XCW2**2*XSW2**2+16D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**3+16D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XSW2**3-48D0*QF(2)*QF(3)*PZ12*PZ34*
     &  S12*S34*XSW2**3+32D0*QF(2)*QF(3)*PZ12*S12*XCW2*XSW2**3+32D0*
     &  QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**3+32D0*QF(2)*QF(3)*PZ12*
     &  PZ34*S12*S34*XSW2**4))/(S12*S34*XSW2)
        K(7) = -(9D0*C1(1)*PZ12*PZ34)-9D0*C1(2)*PZ12*PZ34+(2D0*C0*(-
     &  (3D0*PZ12*S12*XCW2)-3D0*PZ34*S34*XCW2+4D0*XCW2**2-6D0*PZ12*
     &  PZ34*S12*S34*XSW2+4D0*PZ12*S12*XCW2*XSW2+4D0*PZ34*S34*XCW2*
     &  XSW2+4D0*PZ12*PZ34*S12*S34*XSW2**2))/(S12*S34)-(4D0*C2(1,2)*
     &  (9D0*PZ12*PZ34*S12*S34-6D0*PZ12*S12*XCW2-6D0*PZ34*S34*XCW2+
     &  8D0*XCW2**2-12D0*PZ12*PZ34*S12*S34*XSW2+8D0*PZ12*S12*XCW2*
     &  XSW2+8D0*PZ34*S34*XCW2*XSW2+8D0*PZ12*PZ34*S12*S34*XSW2**2))/
     &  (S12*S34)
        K(8) = 2D0*S12-S13-S14-S23-S24
        K(9) = S13+S14+S23+S24-2D0*S34
        K(10) = S13+S14+S23+S24-2D0*XMQM2(I)
        K(11) = -(3D0*PZ12*S12*XCW2)-3D0*PZ34*S34*XCW2+4D0*XCW2**2-
     &  6D0*PZ12*PZ34*S12*S34*XSW2+4D0*PZ12*S12*XCW2*XSW2+4D0*PZ34*
     &  S34*XCW2*XSW2+4D0*PZ12*PZ34*S12*S34*XSW2**2
        K(12) = 9D0*PZ12*PZ34*S12*S34-6D0*PZ12*S12*XCW2-6D0*PZ34*
     &  S34*XCW2+8D0*XCW2**2-12D0*PZ12*PZ34*S12*S34*XSW2+8D0*PZ12*
     &  S12*XCW2*XSW2+8D0*PZ34*S34*XCW2*XSW2+8D0*PZ12*PZ34*S12*S34*
     &  XSW2**2
        K(13) = 9D0*PZ12*PZ34*S12*S34-3D0*PZ12*S12*XCW2-3D0*PZ34*
     &  S34*XCW2+4D0*XCW2**2-6D0*PZ12*PZ34*S12*S34*XSW2+4D0*PZ12*
     &  S12*XCW2*XSW2+4D0*PZ34*S34*XCW2*XSW2+4D0*PZ12*PZ34*S12*S34*
     &  XSW2**2
        K(14) = -(3D0*PZ12*S12*XCW2)-6D0*PZ12*PZ34*S12*S34*XSW2+4D0*
     &  PZ12*S12*XCW2*XSW2-6D0*QF(2)*PZ12*S12*XCW2*XSW2-6D0*QF(2)*
     &  PZ34*S34*XCW2*XSW2+8D0*QF(2)*XCW2**2*XSW2+4D0*PZ12*PZ34*S12*
     &  S34*XSW2**2-12D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**2+8D0*QF(2)*
     &  PZ12*S12*XCW2*XSW2**2+8D0*QF(2)*PZ34*S34*XCW2*XSW2**2+8D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XSW2**3
        K(15) = -(3D0*PZ34*S34*XCW2)-6D0*PZ12*PZ34*S12*S34*XSW2-6D0*
     &  QF(3)*PZ12*S12*XCW2*XSW2+4D0*PZ34*S34*XCW2*XSW2-6D0*QF(3)*
     &  PZ34*S34*XCW2*XSW2+8D0*QF(3)*XCW2**2*XSW2+4D0*PZ12*PZ34*S12*
     &  S34*XSW2**2-12D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+8D0*QF(3)*
     &  PZ12*S12*XCW2*XSW2**2+8D0*QF(3)*PZ34*S34*XCW2*XSW2**2+8D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XSW2**3
        K(16) = 9D0*PZ12*PZ34*S12*S34-6D0*PZ12*S12*XCW2-12D0*PZ12*
     &  PZ34*S12*S34*XSW2+18D0*QF(2)*PZ12*PZ34*S12*S34*XSW2+8D0*
     &  PZ12*S12*XCW2*XSW2-12D0*QF(2)*PZ12*S12*XCW2*XSW2-12D0*QF(2)*
     &  PZ34*S34*XCW2*XSW2+16D0*QF(2)*XCW2**2*XSW2+8D0*PZ12*PZ34*
     &  S12*S34*XSW2**2-24D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**2+16D0*
     &  QF(2)*PZ12*S12*XCW2*XSW2**2+16D0*QF(2)*PZ34*S34*XCW2*XSW2**
     &  2+16D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**3
        K(17) = 9D0*PZ12*PZ34*S12*S34-3D0*PZ12*S12*XCW2-6D0*PZ12*
     &  PZ34*S12*S34*XSW2+18D0*QF(2)*PZ12*PZ34*S12*S34*XSW2+4D0*
     &  PZ12*S12*XCW2*XSW2-6D0*QF(2)*PZ12*S12*XCW2*XSW2-6D0*QF(2)*
     &  PZ34*S34*XCW2*XSW2+8D0*QF(2)*XCW2**2*XSW2+4D0*PZ12*PZ34*S12*
     &  S34*XSW2**2-12D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**2+8D0*QF(2)*
     &  PZ12*S12*XCW2*XSW2**2+8D0*QF(2)*PZ34*S34*XCW2*XSW2**2+8D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XSW2**3
        K(18) = 9D0*PZ12*PZ34*S12*S34-6D0*PZ34*S34*XCW2-12D0*PZ12*
     &  PZ34*S12*S34*XSW2+18D0*QF(3)*PZ12*PZ34*S12*S34*XSW2-12D0*
     &  QF(3)*PZ12*S12*XCW2*XSW2+8D0*PZ34*S34*XCW2*XSW2-12D0*QF(3)*
     &  PZ34*S34*XCW2*XSW2+16D0*QF(3)*XCW2**2*XSW2+8D0*PZ12*PZ34*
     &  S12*S34*XSW2**2-24D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+16D0*
     &  QF(3)*PZ12*S12*XCW2*XSW2**2+16D0*QF(3)*PZ34*S34*XCW2*XSW2**
     &  2+16D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**3
        K(19) = 9D0*PZ12*PZ34*S12*S34-3D0*PZ34*S34*XCW2-6D0*PZ12*
     &  PZ34*S12*S34*XSW2+18D0*QF(3)*PZ12*PZ34*S12*S34*XSW2-6D0*
     &  QF(3)*PZ12*S12*XCW2*XSW2+4D0*PZ34*S34*XCW2*XSW2-6D0*QF(3)*
     &  PZ34*S34*XCW2*XSW2+8D0*QF(3)*XCW2**2*XSW2+4D0*PZ12*PZ34*S12*
     &  S34*XSW2**2-12D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+8D0*QF(3)*
     &  PZ12*S12*XCW2*XSW2**2+8D0*QF(3)*PZ34*S34*XCW2*XSW2**2+8D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XSW2**3
        K(20) = -(3D0*PZ12*PZ34*S12*S34)-3D0*QF(3)*PZ12*S12*XCW2-
     &  3D0*QF(2)*PZ34*S34*XCW2+2D0*PZ12*PZ34*S12*S34*XSW2-6D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XSW2-6D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XSW2+4D0*QF(3)*PZ12*S12*XCW2*XSW2-6D0*QF(2)*QF(3)*PZ12*S12*
     &  XCW2*XSW2+4D0*QF(2)*PZ34*S34*XCW2*XSW2-6D0*QF(2)*QF(3)*PZ34*
     &  S34*XCW2*XSW2+8D0*QF(2)*QF(3)*XCW2**2*XSW2+4D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XSW2**2+4D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2-
     &  12D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+8D0*QF(2)*QF(3)*
     &  PZ12*S12*XCW2*XSW2**2+8D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**2+
     &  8D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**3
        K(21) = 9D0*PZ12*PZ34*S12*S34-12D0*PZ12*PZ34*S12*S34*XSW2+
     &  18D0*QF(2)*PZ12*PZ34*S12*S34*XSW2+18D0*QF(3)*PZ12*PZ34*S12*
     &  S34*XSW2-12D0*QF(3)*PZ12*S12*XCW2*XSW2-12D0*QF(2)*PZ34*S34*
     &  XCW2*XSW2+8D0*PZ12*PZ34*S12*S34*XSW2**2-24D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XSW2**2-24D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+
     &  36D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+16D0*QF(3)*PZ12*
     &  S12*XCW2*XSW2**2-24D0*QF(2)*QF(3)*PZ12*S12*XCW2*XSW2**2+
     &  16D0*QF(2)*PZ34*S34*XCW2*XSW2**2-24D0*QF(2)*QF(3)*PZ34*S34*
     &  XCW2*XSW2**2+32D0*QF(2)*QF(3)*XCW2**2*XSW2**2+16D0*QF(2)*
     &  PZ12*PZ34*S12*S34*XSW2**3+16D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XSW2**3-48D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**3+32D0*
     &  QF(2)*QF(3)*PZ12*S12*XCW2*XSW2**3+32D0*QF(2)*QF(3)*PZ34*S34*
     &  XCW2*XSW2**3+32D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**4
        K(22) = 9D0*PZ12*PZ34*S12*S34-6D0*PZ12*PZ34*S12*S34*XSW2+
     &  18D0*QF(2)*PZ12*PZ34*S12*S34*XSW2+18D0*QF(3)*PZ12*PZ34*S12*
     &  S34*XSW2-6D0*QF(3)*PZ12*S12*XCW2*XSW2-6D0*QF(2)*PZ34*S34*
     &  XCW2*XSW2+4D0*PZ12*PZ34*S12*S34*XSW2**2-12D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XSW2**2-12D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+
     &  36D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+8D0*QF(3)*PZ12*
     &  S12*XCW2*XSW2**2-12D0*QF(2)*QF(3)*PZ12*S12*XCW2*XSW2**2+8D0*
     &  QF(2)*PZ34*S34*XCW2*XSW2**2-12D0*QF(2)*QF(3)*PZ34*S34*XCW2*
     &  XSW2**2+16D0*QF(2)*QF(3)*XCW2**2*XSW2**2+8D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XSW2**3+8D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**3-
     &  24D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**3+16D0*QF(2)*QF(3)*
     &  PZ12*S12*XCW2*XSW2**3+16D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**
     &  3+16D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**4

        PRE = (ALPHA*XCW2**(-2)*XMQM2(I))/(192D0*PI*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*((72D0*C2(0,0)*K(1)*K(2)*PZ12*
     &  PZ34)/XSW2+(9D0*C1(1)*K(1)*K(2)*K(8)*PZ12*PZ34)/XSW2+(4D0*
     &  C2(2,2)*K(22))/(S12*XSW2)+(4D0*C2(1,1)*K(22))/(S34*XSW2)-
     &  (2D0*K(22))/(S12*S34*XSW2)-(4D0*C2(1,2)*K(22)*K(3))/(S12*
     &  S34*XSW2)-(9D0*C1(2)*K(1)*K(2)*PZ12*PZ34*(K(3)-2D0*S34))/
     &  XSW2+(4D0*K(20)*C0*(K(3)-2D0*XMQM2(I)))/(S12*S34)))/XSW2
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(72D0*C2(0,0)*K(1)*
     &  PZ12*PZ34+9D0*C1(1)*K(1)*K(8)*PZ12*PZ34-9D0*C1(2)*K(1)*PZ12*
     &  PZ34*(K(3)-2D0*S34)+(4D0*C2(2,2)*(K(14)+9D0*PZ12*PZ34*S12*
     &  S34+18D0*QF(2)*PZ12*PZ34*S12*S34*XSW2))/S12+(4D0*C2(1,1)*
     &  (K(14)+9D0*PZ12*PZ34*S12*S34+18D0*QF(2)*PZ12*PZ34*S12*S34*
     &  XSW2))/S34-(2D0*(K(14)+9D0*PZ12*PZ34*S12*S34+18D0*QF(2)*
     &  PZ12*PZ34*S12*S34*XSW2))/(S12*S34)-(4D0*C2(1,2)*K(3)*(K(14)+
     &  9D0*PZ12*PZ34*S12*S34+18D0*QF(2)*PZ12*PZ34*S12*S34*XSW2))/
     &  (S12*S34)+(2D0*K(14)*C0*(K(3)-2D0*XMQM2(I)))/(S12*S34)))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(72D0*C2(0,0)*K(2)*
     &  PZ12*PZ34+9D0*C1(1)*K(2)*K(8)*PZ12*PZ34-9D0*C1(2)*K(2)*PZ12*
     &  PZ34*(K(3)-2D0*S34)+(4D0*C2(2,2)*(K(15)+9D0*PZ12*PZ34*S12*
     &  S34+18D0*QF(3)*PZ12*PZ34*S12*S34*XSW2))/S12+(4D0*C2(1,1)*
     &  (K(15)+9D0*PZ12*PZ34*S12*S34+18D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XSW2))/S34-(2D0*(K(15)+9D0*PZ12*PZ34*S12*S34+18D0*QF(3)*
     &  PZ12*PZ34*S12*S34*XSW2))/(S12*S34)-(4D0*C2(1,2)*K(3)*(K(15)+
     &  9D0*PZ12*PZ34*S12*S34+18D0*QF(3)*PZ12*PZ34*S12*S34*XSW2))/
     &  (S12*S34)+(2D0*K(15)*C0*(K(3)-2D0*XMQM2(I)))/(S12*S34)))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(72D0*C2(0,0)*PZ12*
     &  PZ34+9D0*C1(1)*K(8)*PZ12*PZ34-9D0*C1(2)*PZ12*PZ34*(K(3)-2D0*
     &  S34)+(4D0*C2(2,2)*(K(11)+9D0*PZ12*PZ34*S12*S34))/S12+(4D0*
     &  C2(1,1)*(K(11)+9D0*PZ12*PZ34*S12*S34))/S34-(2D0*(K(11)+9D0*
     &  PZ12*PZ34*S12*S34))/(S12*S34)-(4D0*C2(1,2)*K(3)*(K(11)+9D0*
     &  PZ12*PZ34*S12*S34))/(S12*S34)+(2D0*K(11)*C0*(K(3)-2D0*
     &  XMQM2(I)))/(S12*S34))
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(6)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-(4D0*K(4)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(4D0*K(5)*QF(2)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-8D0*K(7)*QF(2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(6)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-(4D0*K(4)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(4D0*K(5)*QF(2)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-8D0*K(7)*QF(2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(6)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-(4D0*K(4)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(4D0*K(5)*QF(2)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-8D0*K(7)*QF(2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(6)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-(4D0*K(4)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(4D0*K(5)*QF(2)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-8D0*K(7)*QF(2)*QF(3)*PRE

C       G(T9,N693,FULL)+G(T9,N694,FULL)+G(T9,N711,FULL)+G(T9,N712,
C       FULL)+G(T9,N777,FULL)+G(T9,N778,FULL)+G(T9,N795,FULL)+G(T9,
C       N796,FULL)
        CALL xC01234_(S12,MH2,S34,XML2(I),XML2(I),XML2(I),
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S13+S14+S23+S24
        K(4) = C1(1)*PZ12*PZ34*(1D0+2D0*QF(2)*XSW2)+C1(2)*PZ12*PZ34*
     &  (1D0+2D0*QF(2)*XSW2)+(4D0*C2(1,2)*(PZ12*PZ34*S12*S34-2D0*
     &  PZ12*S12*XCW2-4D0*PZ12*PZ34*S12*S34*XSW2+2D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XSW2+8D0*PZ12*S12*XCW2*XSW2-4D0*QF(2)*PZ12*S12*
     &  XCW2*XSW2-4D0*QF(2)*PZ34*S34*XCW2*XSW2+16D0*QF(2)*XCW2**2*
     &  XSW2+8D0*PZ12*PZ34*S12*S34*XSW2**2-8D0*QF(2)*PZ12*PZ34*S12*
     &  S34*XSW2**2+16D0*QF(2)*PZ12*S12*XCW2*XSW2**2+16D0*QF(2)*
     &  PZ34*S34*XCW2*XSW2**2+16D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**
     &  3))/(S12*S34)+(2D0*C0*(PZ12*S12*XCW2+2D0*PZ12*PZ34*S12*S34*
     &  XSW2-4D0*PZ12*S12*XCW2*XSW2+2D0*QF(2)*PZ12*S12*XCW2*XSW2+
     &  2D0*QF(2)*PZ34*S34*XCW2*XSW2-8D0*QF(2)*XCW2**2*XSW2-4D0*
     &  PZ12*PZ34*S12*S34*XSW2**2+4D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**
     &  2-8D0*QF(2)*PZ12*S12*XCW2*XSW2**2-8D0*QF(2)*PZ34*S34*XCW2*
     &  XSW2**2-8D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**3))/(S12*S34)
        K(5) = C1(1)*PZ12*PZ34*(1D0+2D0*QF(3)*XSW2)+C1(2)*PZ12*PZ34*
     &  (1D0+2D0*QF(3)*XSW2)+(4D0*C2(1,2)*(PZ12*PZ34*S12*S34-2D0*
     &  PZ34*S34*XCW2-4D0*PZ12*PZ34*S12*S34*XSW2+2D0*QF(3)*PZ12*
     &  PZ34*S12*S34*XSW2-4D0*QF(3)*PZ12*S12*XCW2*XSW2+8D0*PZ34*S34*
     &  XCW2*XSW2-4D0*QF(3)*PZ34*S34*XCW2*XSW2+16D0*QF(3)*XCW2**2*
     &  XSW2+8D0*PZ12*PZ34*S12*S34*XSW2**2-8D0*QF(3)*PZ12*PZ34*S12*
     &  S34*XSW2**2+16D0*QF(3)*PZ12*S12*XCW2*XSW2**2+16D0*QF(3)*
     &  PZ34*S34*XCW2*XSW2**2+16D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**
     &  3))/(S12*S34)+(2D0*C0*(PZ34*S34*XCW2+2D0*PZ12*PZ34*S12*S34*
     &  XSW2+2D0*QF(3)*PZ12*S12*XCW2*XSW2-4D0*PZ34*S34*XCW2*XSW2+
     &  2D0*QF(3)*PZ34*S34*XCW2*XSW2-8D0*QF(3)*XCW2**2*XSW2-4D0*
     &  PZ12*PZ34*S12*S34*XSW2**2+4D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**
     &  2-8D0*QF(3)*PZ12*S12*XCW2*XSW2**2-8D0*QF(3)*PZ34*S34*XCW2*
     &  XSW2**2-8D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**3))/(S12*S34)
        K(6) = (C1(1)*PZ12*PZ34*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*QF(3)*
     &  XSW2))/XSW2+(C1(2)*PZ12*PZ34*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW2+(4D0*C0*(PZ12*PZ34*S12*S34+QF(3)*PZ12*S12*
     &  XCW2+QF(2)*PZ34*S34*XCW2-2D0*PZ12*PZ34*S12*S34*XSW2+2D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XSW2-4D0*QF(3)*PZ12*S12*XCW2*XSW2+2D0*QF(2)*QF(3)*PZ12*S12*
     &  XCW2*XSW2-4D0*QF(2)*PZ34*S34*XCW2*XSW2+2D0*QF(2)*QF(3)*PZ34*
     &  S34*XCW2*XSW2-8D0*QF(2)*QF(3)*XCW2**2*XSW2-4D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XSW2**2-4D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+
     &  4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**2-8D0*QF(2)*QF(3)*
     &  PZ12*S12*XCW2*XSW2**2-8D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**2-
     &  8D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**3))/(S12*S34)+(4D0*
     &  C2(1,2)*(PZ12*PZ34*S12*S34-4D0*PZ12*PZ34*S12*S34*XSW2+2D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XSW2-4D0*QF(3)*PZ12*S12*XCW2*XSW2-4D0*QF(2)*PZ34*S34*XCW2*
     &  XSW2+8D0*PZ12*PZ34*S12*S34*XSW2**2-8D0*QF(2)*PZ12*PZ34*S12*
     &  S34*XSW2**2-8D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+4D0*QF(2)*
     &  QF(3)*PZ12*PZ34*S12*S34*XSW2**2+16D0*QF(3)*PZ12*S12*XCW2*
     &  XSW2**2-8D0*QF(2)*QF(3)*PZ12*S12*XCW2*XSW2**2+16D0*QF(2)*
     &  PZ34*S34*XCW2*XSW2**2-8D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**2+
     &  32D0*QF(2)*QF(3)*XCW2**2*XSW2**2+16D0*QF(2)*PZ12*PZ34*S12*
     &  S34*XSW2**3+16D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**3-16D0*QF(2)*
     &  QF(3)*PZ12*PZ34*S12*S34*XSW2**3+32D0*QF(2)*QF(3)*PZ12*S12*
     &  XCW2*XSW2**3+32D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**3+32D0*
     &  QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**4))/(S12*S34*XSW2)
        K(7) = C1(1)*PZ12*PZ34+C1(2)*PZ12*PZ34+(2D0*C0*(PZ12*S12*
     &  XCW2+PZ34*S34*XCW2-4D0*XCW2**2+2D0*PZ12*PZ34*S12*S34*XSW2-
     &  4D0*PZ12*S12*XCW2*XSW2-4D0*PZ34*S34*XCW2*XSW2-4D0*PZ12*PZ34*
     &  S12*S34*XSW2**2))/(S12*S34)+(4D0*C2(1,2)*(PZ12*PZ34*S12*S34-
     &  2D0*PZ12*S12*XCW2-2D0*PZ34*S34*XCW2+8D0*XCW2**2-4D0*PZ12*
     &  PZ34*S12*S34*XSW2+8D0*PZ12*S12*XCW2*XSW2+8D0*PZ34*S34*XCW2*
     &  XSW2+8D0*PZ12*PZ34*S12*S34*XSW2**2))/(S12*S34)
        K(8) = 2D0*S12-S13-S14-S23-S24
        K(9) = S13+S14+S23+S24-2D0*S34
        K(10) = S13+S14+S23+S24-2D0*XML2(I)
        K(11) = PZ12*S12*XCW2+PZ34*S34*XCW2-4D0*XCW2**2+2D0*PZ12*
     &  PZ34*S12*S34*XSW2-4D0*PZ12*S12*XCW2*XSW2-4D0*PZ34*S34*XCW2*
     &  XSW2-4D0*PZ12*PZ34*S12*S34*XSW2**2
        K(12) = PZ12*PZ34*S12*S34-2D0*PZ12*S12*XCW2-2D0*PZ34*S34*
     &  XCW2+8D0*XCW2**2-4D0*PZ12*PZ34*S12*S34*XSW2+8D0*PZ12*S12*
     &  XCW2*XSW2+8D0*PZ34*S34*XCW2*XSW2+8D0*PZ12*PZ34*S12*S34*
     &  XSW2**2
        K(13) = PZ12*PZ34*S12*S34-PZ12*S12*XCW2-PZ34*S34*XCW2+4D0*
     &  XCW2**2-2D0*PZ12*PZ34*S12*S34*XSW2+4D0*PZ12*S12*XCW2*XSW2+
     &  4D0*PZ34*S34*XCW2*XSW2+4D0*PZ12*PZ34*S12*S34*XSW2**2
        K(14) = PZ12*S12*XCW2+2D0*PZ12*PZ34*S12*S34*XSW2-4D0*PZ12*
     &  S12*XCW2*XSW2+2D0*QF(2)*PZ12*S12*XCW2*XSW2+2D0*QF(2)*PZ34*
     &  S34*XCW2*XSW2-8D0*QF(2)*XCW2**2*XSW2-4D0*PZ12*PZ34*S12*S34*
     &  XSW2**2+4D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**2-8D0*QF(2)*PZ12*
     &  S12*XCW2*XSW2**2-8D0*QF(2)*PZ34*S34*XCW2*XSW2**2-8D0*QF(2)*
     &  PZ12*PZ34*S12*S34*XSW2**3
        K(15) = PZ34*S34*XCW2+2D0*PZ12*PZ34*S12*S34*XSW2+2D0*QF(3)*
     &  PZ12*S12*XCW2*XSW2-4D0*PZ34*S34*XCW2*XSW2+2D0*QF(3)*PZ34*
     &  S34*XCW2*XSW2-8D0*QF(3)*XCW2**2*XSW2-4D0*PZ12*PZ34*S12*S34*
     &  XSW2**2+4D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2-8D0*QF(3)*PZ12*
     &  S12*XCW2*XSW2**2-8D0*QF(3)*PZ34*S34*XCW2*XSW2**2-8D0*QF(3)*
     &  PZ12*PZ34*S12*S34*XSW2**3
        K(16) = PZ12*PZ34*S12*S34-2D0*PZ12*S12*XCW2-4D0*PZ12*PZ34*
     &  S12*S34*XSW2+2D0*QF(2)*PZ12*PZ34*S12*S34*XSW2+8D0*PZ12*S12*
     &  XCW2*XSW2-4D0*QF(2)*PZ12*S12*XCW2*XSW2-4D0*QF(2)*PZ34*S34*
     &  XCW2*XSW2+16D0*QF(2)*XCW2**2*XSW2+8D0*PZ12*PZ34*S12*S34*
     &  XSW2**2-8D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**2+16D0*QF(2)*PZ12*
     &  S12*XCW2*XSW2**2+16D0*QF(2)*PZ34*S34*XCW2*XSW2**2+16D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XSW2**3
        K(17) = PZ12*PZ34*S12*S34-PZ12*S12*XCW2-2D0*PZ12*PZ34*S12*
     &  S34*XSW2+2D0*QF(2)*PZ12*PZ34*S12*S34*XSW2+4D0*PZ12*S12*XCW2*
     &  XSW2-2D0*QF(2)*PZ12*S12*XCW2*XSW2-2D0*QF(2)*PZ34*S34*XCW2*
     &  XSW2+8D0*QF(2)*XCW2**2*XSW2+4D0*PZ12*PZ34*S12*S34*XSW2**2-
     &  4D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**2+8D0*QF(2)*PZ12*S12*XCW2*
     &  XSW2**2+8D0*QF(2)*PZ34*S34*XCW2*XSW2**2+8D0*QF(2)*PZ12*PZ34*
     &  S12*S34*XSW2**3
        K(18) = PZ12*PZ34*S12*S34-2D0*PZ34*S34*XCW2-4D0*PZ12*PZ34*
     &  S12*S34*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*XSW2-4D0*QF(3)*
     &  PZ12*S12*XCW2*XSW2+8D0*PZ34*S34*XCW2*XSW2-4D0*QF(3)*PZ34*
     &  S34*XCW2*XSW2+16D0*QF(3)*XCW2**2*XSW2+8D0*PZ12*PZ34*S12*S34*
     &  XSW2**2-8D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+16D0*QF(3)*PZ12*
     &  S12*XCW2*XSW2**2+16D0*QF(3)*PZ34*S34*XCW2*XSW2**2+16D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XSW2**3
        K(19) = PZ12*PZ34*S12*S34-PZ34*S34*XCW2-2D0*PZ12*PZ34*S12*
     &  S34*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*XSW2-2D0*QF(3)*PZ12*
     &  S12*XCW2*XSW2+4D0*PZ34*S34*XCW2*XSW2-2D0*QF(3)*PZ34*S34*
     &  XCW2*XSW2+8D0*QF(3)*XCW2**2*XSW2+4D0*PZ12*PZ34*S12*S34*
     &  XSW2**2-4D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+8D0*QF(3)*PZ12*
     &  S12*XCW2*XSW2**2+8D0*QF(3)*PZ34*S34*XCW2*XSW2**2+8D0*QF(3)*
     &  PZ12*PZ34*S12*S34*XSW2**3
        K(20) = PZ12*PZ34*S12*S34+QF(3)*PZ12*S12*XCW2+QF(2)*PZ34*
     &  S34*XCW2-2D0*PZ12*PZ34*S12*S34*XSW2+2D0*QF(2)*PZ12*PZ34*S12*
     &  S34*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*XSW2-4D0*QF(3)*PZ12*
     &  S12*XCW2*XSW2+2D0*QF(2)*QF(3)*PZ12*S12*XCW2*XSW2-4D0*QF(2)*
     &  PZ34*S34*XCW2*XSW2+2D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2-8D0*
     &  QF(2)*QF(3)*XCW2**2*XSW2-4D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**
     &  2-4D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+4D0*QF(2)*QF(3)*PZ12*
     &  PZ34*S12*S34*XSW2**2-8D0*QF(2)*QF(3)*PZ12*S12*XCW2*XSW2**2-
     &  8D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**2-8D0*QF(2)*QF(3)*PZ12*
     &  PZ34*S12*S34*XSW2**3
        K(21) = PZ12*PZ34*S12*S34-4D0*PZ12*PZ34*S12*S34*XSW2+2D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XSW2-4D0*QF(3)*PZ12*S12*XCW2*XSW2-4D0*QF(2)*PZ34*S34*XCW2*
     &  XSW2+8D0*PZ12*PZ34*S12*S34*XSW2**2-8D0*QF(2)*PZ12*PZ34*S12*
     &  S34*XSW2**2-8D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+4D0*QF(2)*
     &  QF(3)*PZ12*PZ34*S12*S34*XSW2**2+16D0*QF(3)*PZ12*S12*XCW2*
     &  XSW2**2-8D0*QF(2)*QF(3)*PZ12*S12*XCW2*XSW2**2+16D0*QF(2)*
     &  PZ34*S34*XCW2*XSW2**2-8D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**2+
     &  32D0*QF(2)*QF(3)*XCW2**2*XSW2**2+16D0*QF(2)*PZ12*PZ34*S12*
     &  S34*XSW2**3+16D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**3-16D0*QF(2)*
     &  QF(3)*PZ12*PZ34*S12*S34*XSW2**3+32D0*QF(2)*QF(3)*PZ12*S12*
     &  XCW2*XSW2**3+32D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**3+32D0*
     &  QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**4
        K(22) = PZ12*PZ34*S12*S34-2D0*PZ12*PZ34*S12*S34*XSW2+2D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XSW2-2D0*QF(3)*PZ12*S12*XCW2*XSW2-2D0*QF(2)*PZ34*S34*XCW2*
     &  XSW2+4D0*PZ12*PZ34*S12*S34*XSW2**2-4D0*QF(2)*PZ12*PZ34*S12*
     &  S34*XSW2**2-4D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+4D0*QF(2)*
     &  QF(3)*PZ12*PZ34*S12*S34*XSW2**2+8D0*QF(3)*PZ12*S12*XCW2*
     &  XSW2**2-4D0*QF(2)*QF(3)*PZ12*S12*XCW2*XSW2**2+8D0*QF(2)*
     &  PZ34*S34*XCW2*XSW2**2-4D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**2+
     &  16D0*QF(2)*QF(3)*XCW2**2*XSW2**2+8D0*QF(2)*PZ12*PZ34*S12*
     &  S34*XSW2**3+8D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**3-8D0*QF(2)*
     &  QF(3)*PZ12*PZ34*S12*S34*XSW2**3+16D0*QF(2)*QF(3)*PZ12*S12*
     &  XCW2*XSW2**3+16D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**3+16D0*
     &  QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**4

        PRE = -((ALPHA*XCW2**(-2)*XML2(I))/(64D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*((8D0*C2(0,0)*K(1)*K(2)*PZ12*
     &  PZ34)/XSW2+(C1(1)*K(1)*K(2)*K(8)*PZ12*PZ34)/XSW2+(4D0*C2(2,
     &  2)*K(22))/(S12*XSW2)+(4D0*C2(1,1)*K(22))/(S34*XSW2)-(2D0*
     &  K(22))/(S12*S34*XSW2)-(4D0*C2(1,2)*K(22)*K(3))/(S12*S34*
     &  XSW2)-(C1(2)*K(1)*K(2)*PZ12*PZ34*(K(3)-2D0*S34))/XSW2-(4D0*
     &  K(20)*C0*(K(3)-2D0*XML2(I)))/(S12*S34)))/XSW2
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(8D0*C2(0,0)*K(1)*PZ12*
     &  PZ34+C1(1)*K(1)*K(8)*PZ12*PZ34+(4D0*C2(2,2)*K(17))/S12+(4D0*
     &  C2(1,1)*K(17))/S34-(2D0*K(17))/(S12*S34)-(4D0*C2(1,2)*K(17)*
     &  K(3))/(S12*S34)-C1(2)*K(1)*PZ12*PZ34*(K(3)-2D0*S34)-(2D0*
     &  K(14)*C0*(K(3)-2D0*XML2(I)))/(S12*S34)))/XSW2
        F(1,1,-1) = F(1,1,-1)-(2D0*QF(2)*PRE*(8D0*C2(0,0)*K(2)*PZ12*
     &  PZ34+C1(1)*K(2)*K(8)*PZ12*PZ34+(4D0*C2(2,2)*K(19))/S12+(4D0*
     &  C2(1,1)*K(19))/S34-(2D0*K(19))/(S12*S34)-(4D0*C2(1,2)*K(19)*
     &  K(3))/(S12*S34)-C1(2)*K(2)*PZ12*PZ34*(K(3)-2D0*S34)-(2D0*
     &  K(15)*C0*(K(3)-2D0*XML2(I)))/(S12*S34)))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(-(8D0*C2(0,0)*PZ12*
     &  PZ34)-C1(1)*K(8)*PZ12*PZ34-(4D0*C2(2,2)*K(13))/S12-(4D0*
     &  C2(1,1)*K(13))/S34+(2D0*K(13))/(S12*S34)+(4D0*C2(1,2)*K(13)*
     &  K(3))/(S12*S34)+C1(2)*PZ12*PZ34*(K(3)-2D0*S34)+(2D0*K(11)*
     &  C0*(K(3)-2D0*XML2(I)))/(S12*S34))
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(6)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-(4D0*K(4)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(4D0*K(5)*QF(2)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-8D0*K(7)*QF(2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(6)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-(4D0*K(4)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(4D0*K(5)*QF(2)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-8D0*K(7)*QF(2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(6)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-(4D0*K(4)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(4D0*K(5)*QF(2)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-8D0*K(7)*QF(2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(6)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-(4D0*K(4)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(4D0*K(5)*QF(2)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-8D0*K(7)*QF(2)*QF(3)*PRE

C       G(T9,N692,FULL)+G(T9,N695,FULL)+G(T9,N710,FULL)+G(T9,N713,
C       FULL)+G(T9,N776,FULL)+G(T9,N779,FULL)+G(T9,N794,FULL)+G(T9,
C       N797,FULL)
        CALL xC01234_(S12,MH2,S34,XMQP2(I),XMQP2(I),XMQP2(I),
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S13+S14+S23+S24
        K(4) = -(9D0*C1(1)*PZ12*PZ34*(1D0+2D0*QF(2)*XSW2))-9D0*
     &  C1(2)*PZ12*PZ34*(1D0+2D0*QF(2)*XSW2)+(4D0*C0*(-(3D0*PZ12*
     &  S12*XCW2)-6D0*PZ12*PZ34*S12*S34*XSW2+8D0*PZ12*S12*XCW2*XSW2-
     &  6D0*QF(2)*PZ12*S12*XCW2*XSW2-6D0*QF(2)*PZ34*S34*XCW2*XSW2+
     &  16D0*QF(2)*XCW2**2*XSW2+8D0*PZ12*PZ34*S12*S34*XSW2**2-12D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XSW2**2+16D0*QF(2)*PZ12*S12*XCW2*
     &  XSW2**2+16D0*QF(2)*PZ34*S34*XCW2*XSW2**2+16D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XSW2**3))/(S12*S34)-(4D0*C2(1,2)*(9D0*PZ12*
     &  PZ34*S12*S34-12D0*PZ12*S12*XCW2-24D0*PZ12*PZ34*S12*S34*XSW2+
     &  18D0*QF(2)*PZ12*PZ34*S12*S34*XSW2+32D0*PZ12*S12*XCW2*XSW2-
     &  24D0*QF(2)*PZ12*S12*XCW2*XSW2-24D0*QF(2)*PZ34*S34*XCW2*XSW2+
     &  64D0*QF(2)*XCW2**2*XSW2+32D0*PZ12*PZ34*S12*S34*XSW2**2-48D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XSW2**2+64D0*QF(2)*PZ12*S12*XCW2*
     &  XSW2**2+64D0*QF(2)*PZ34*S34*XCW2*XSW2**2+64D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XSW2**3))/(S12*S34)
        K(5) = -(9D0*C1(1)*PZ12*PZ34*(1D0+2D0*QF(3)*XSW2))-9D0*
     &  C1(2)*PZ12*PZ34*(1D0+2D0*QF(3)*XSW2)+(4D0*C0*(-(3D0*PZ34*
     &  S34*XCW2)-6D0*PZ12*PZ34*S12*S34*XSW2-6D0*QF(3)*PZ12*S12*
     &  XCW2*XSW2+8D0*PZ34*S34*XCW2*XSW2-6D0*QF(3)*PZ34*S34*XCW2*
     &  XSW2+16D0*QF(3)*XCW2**2*XSW2+8D0*PZ12*PZ34*S12*S34*XSW2**2-
     &  12D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+16D0*QF(3)*PZ12*S12*
     &  XCW2*XSW2**2+16D0*QF(3)*PZ34*S34*XCW2*XSW2**2+16D0*QF(3)*
     &  PZ12*PZ34*S12*S34*XSW2**3))/(S12*S34)-(4D0*C2(1,2)*(9D0*
     &  PZ12*PZ34*S12*S34-12D0*PZ34*S34*XCW2-24D0*PZ12*PZ34*S12*S34*
     &  XSW2+18D0*QF(3)*PZ12*PZ34*S12*S34*XSW2-24D0*QF(3)*PZ12*S12*
     &  XCW2*XSW2+32D0*PZ34*S34*XCW2*XSW2-24D0*QF(3)*PZ34*S34*XCW2*
     &  XSW2+64D0*QF(3)*XCW2**2*XSW2+32D0*PZ12*PZ34*S12*S34*XSW2**2-
     &  48D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+64D0*QF(3)*PZ12*S12*
     &  XCW2*XSW2**2+64D0*QF(3)*PZ34*S34*XCW2*XSW2**2+64D0*QF(3)*
     &  PZ12*PZ34*S12*S34*XSW2**3))/(S12*S34)
        K(6) = -((9D0*C1(1)*PZ12*PZ34*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XSW2)-(9D0*C1(2)*PZ12*PZ34*(1D0+2D0*QF(2)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2))/XSW2+(8D0*C0*(-(3D0*PZ12*PZ34*
     &  S12*S34)-3D0*QF(3)*PZ12*S12*XCW2-3D0*QF(2)*PZ34*S34*XCW2+
     &  4D0*PZ12*PZ34*S12*S34*XSW2-6D0*QF(2)*PZ12*PZ34*S12*S34*XSW2-
     &  6D0*QF(3)*PZ12*PZ34*S12*S34*XSW2+8D0*QF(3)*PZ12*S12*XCW2*
     &  XSW2-6D0*QF(2)*QF(3)*PZ12*S12*XCW2*XSW2+8D0*QF(2)*PZ34*S34*
     &  XCW2*XSW2-6D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2+16D0*QF(2)*
     &  QF(3)*XCW2**2*XSW2+8D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**2+8D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XSW2**2-12D0*QF(2)*QF(3)*PZ12*PZ34*
     &  S12*S34*XSW2**2+16D0*QF(2)*QF(3)*PZ12*S12*XCW2*XSW2**2+16D0*
     &  QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**2+16D0*QF(2)*QF(3)*PZ12*
     &  PZ34*S12*S34*XSW2**3))/(S12*S34)-(4D0*C2(1,2)*(9D0*PZ12*
     &  PZ34*S12*S34-24D0*PZ12*PZ34*S12*S34*XSW2+18D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XSW2+18D0*QF(3)*PZ12*PZ34*S12*S34*XSW2-24D0*
     &  QF(3)*PZ12*S12*XCW2*XSW2-24D0*QF(2)*PZ34*S34*XCW2*XSW2+32D0*
     &  PZ12*PZ34*S12*S34*XSW2**2-48D0*QF(2)*PZ12*PZ34*S12*S34*
     &  XSW2**2-48D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+36D0*QF(2)*
     &  QF(3)*PZ12*PZ34*S12*S34*XSW2**2+64D0*QF(3)*PZ12*S12*XCW2*
     &  XSW2**2-48D0*QF(2)*QF(3)*PZ12*S12*XCW2*XSW2**2+64D0*QF(2)*
     &  PZ34*S34*XCW2*XSW2**2-48D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**
     &  2+128D0*QF(2)*QF(3)*XCW2**2*XSW2**2+64D0*QF(2)*PZ12*PZ34*
     &  S12*S34*XSW2**3+64D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**3-96D0*
     &  QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**3+128D0*QF(2)*QF(3)*
     &  PZ12*S12*XCW2*XSW2**3+128D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**
     &  3+128D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**4))/(S12*S34*
     &  XSW2)
        K(7) = -(9D0*C1(1)*PZ12*PZ34)-9D0*C1(2)*PZ12*PZ34-(4D0*C2(1,
     &  2)*(9D0*PZ12*PZ34*S12*S34-12D0*PZ12*S12*XCW2-12D0*PZ34*S34*
     &  XCW2+32D0*XCW2**2-24D0*PZ12*PZ34*S12*S34*XSW2+32D0*PZ12*S12*
     &  XCW2*XSW2+32D0*PZ34*S34*XCW2*XSW2+32D0*PZ12*PZ34*S12*S34*
     &  XSW2**2))/(S12*S34)+(4D0*C0*(-(3D0*PZ12*S12*XCW2)-3D0*PZ34*
     &  S34*XCW2+8D0*XCW2**2-6D0*PZ12*PZ34*S12*S34*XSW2+8D0*PZ12*
     &  S12*XCW2*XSW2+8D0*PZ34*S34*XCW2*XSW2+8D0*PZ12*PZ34*S12*S34*
     &  XSW2**2))/(S12*S34)
        K(8) = 2D0*S12-S13-S14-S23-S24
        K(9) = S13+S14+S23+S24-2D0*S34
        K(10) = S13+S14+S23+S24-2D0*XMQP2(I)
        K(11) = -(3D0*PZ12*S12*XCW2)-3D0*PZ34*S34*XCW2+8D0*XCW2**2-
     &  6D0*PZ12*PZ34*S12*S34*XSW2+8D0*PZ12*S12*XCW2*XSW2+8D0*PZ34*
     &  S34*XCW2*XSW2+8D0*PZ12*PZ34*S12*S34*XSW2**2
        K(12) = 9D0*PZ12*PZ34*S12*S34-12D0*PZ12*S12*XCW2-12D0*PZ34*
     &  S34*XCW2+32D0*XCW2**2-24D0*PZ12*PZ34*S12*S34*XSW2+32D0*PZ12*
     &  S12*XCW2*XSW2+32D0*PZ34*S34*XCW2*XSW2+32D0*PZ12*PZ34*S12*
     &  S34*XSW2**2
        K(13) = 9D0*PZ12*PZ34*S12*S34-6D0*PZ12*S12*XCW2-6D0*PZ34*
     &  S34*XCW2+16D0*XCW2**2-12D0*PZ12*PZ34*S12*S34*XSW2+16D0*PZ12*
     &  S12*XCW2*XSW2+16D0*PZ34*S34*XCW2*XSW2+16D0*PZ12*PZ34*S12*
     &  S34*XSW2**2
        K(14) = -(3D0*PZ12*S12*XCW2)-6D0*PZ12*PZ34*S12*S34*XSW2+8D0*
     &  PZ12*S12*XCW2*XSW2-6D0*QF(2)*PZ12*S12*XCW2*XSW2-6D0*QF(2)*
     &  PZ34*S34*XCW2*XSW2+16D0*QF(2)*XCW2**2*XSW2+8D0*PZ12*PZ34*
     &  S12*S34*XSW2**2-12D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**2+16D0*
     &  QF(2)*PZ12*S12*XCW2*XSW2**2+16D0*QF(2)*PZ34*S34*XCW2*XSW2**
     &  2+16D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**3
        K(15) = -(3D0*PZ34*S34*XCW2)-6D0*PZ12*PZ34*S12*S34*XSW2-6D0*
     &  QF(3)*PZ12*S12*XCW2*XSW2+8D0*PZ34*S34*XCW2*XSW2-6D0*QF(3)*
     &  PZ34*S34*XCW2*XSW2+16D0*QF(3)*XCW2**2*XSW2+8D0*PZ12*PZ34*
     &  S12*S34*XSW2**2-12D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+16D0*
     &  QF(3)*PZ12*S12*XCW2*XSW2**2+16D0*QF(3)*PZ34*S34*XCW2*XSW2**
     &  2+16D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**3
        K(16) = 9D0*PZ12*PZ34*S12*S34-12D0*PZ12*S12*XCW2-24D0*PZ12*
     &  PZ34*S12*S34*XSW2+18D0*QF(2)*PZ12*PZ34*S12*S34*XSW2+32D0*
     &  PZ12*S12*XCW2*XSW2-24D0*QF(2)*PZ12*S12*XCW2*XSW2-24D0*QF(2)*
     &  PZ34*S34*XCW2*XSW2+64D0*QF(2)*XCW2**2*XSW2+32D0*PZ12*PZ34*
     &  S12*S34*XSW2**2-48D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**2+64D0*
     &  QF(2)*PZ12*S12*XCW2*XSW2**2+64D0*QF(2)*PZ34*S34*XCW2*XSW2**
     &  2+64D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**3
        K(17) = 9D0*PZ12*PZ34*S12*S34-6D0*PZ12*S12*XCW2-12D0*PZ12*
     &  PZ34*S12*S34*XSW2+18D0*QF(2)*PZ12*PZ34*S12*S34*XSW2+16D0*
     &  PZ12*S12*XCW2*XSW2-12D0*QF(2)*PZ12*S12*XCW2*XSW2-12D0*QF(2)*
     &  PZ34*S34*XCW2*XSW2+32D0*QF(2)*XCW2**2*XSW2+16D0*PZ12*PZ34*
     &  S12*S34*XSW2**2-24D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**2+32D0*
     &  QF(2)*PZ12*S12*XCW2*XSW2**2+32D0*QF(2)*PZ34*S34*XCW2*XSW2**
     &  2+32D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**3
        K(18) = 9D0*PZ12*PZ34*S12*S34-12D0*PZ34*S34*XCW2-24D0*PZ12*
     &  PZ34*S12*S34*XSW2+18D0*QF(3)*PZ12*PZ34*S12*S34*XSW2-24D0*
     &  QF(3)*PZ12*S12*XCW2*XSW2+32D0*PZ34*S34*XCW2*XSW2-24D0*QF(3)*
     &  PZ34*S34*XCW2*XSW2+64D0*QF(3)*XCW2**2*XSW2+32D0*PZ12*PZ34*
     &  S12*S34*XSW2**2-48D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+64D0*
     &  QF(3)*PZ12*S12*XCW2*XSW2**2+64D0*QF(3)*PZ34*S34*XCW2*XSW2**
     &  2+64D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**3
        K(19) = 9D0*PZ12*PZ34*S12*S34-6D0*PZ34*S34*XCW2-12D0*PZ12*
     &  PZ34*S12*S34*XSW2+18D0*QF(3)*PZ12*PZ34*S12*S34*XSW2-12D0*
     &  QF(3)*PZ12*S12*XCW2*XSW2+16D0*PZ34*S34*XCW2*XSW2-12D0*QF(3)*
     &  PZ34*S34*XCW2*XSW2+32D0*QF(3)*XCW2**2*XSW2+16D0*PZ12*PZ34*
     &  S12*S34*XSW2**2-24D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+32D0*
     &  QF(3)*PZ12*S12*XCW2*XSW2**2+32D0*QF(3)*PZ34*S34*XCW2*XSW2**
     &  2+32D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**3
        K(20) = -(3D0*PZ12*PZ34*S12*S34)-3D0*QF(3)*PZ12*S12*XCW2-
     &  3D0*QF(2)*PZ34*S34*XCW2+4D0*PZ12*PZ34*S12*S34*XSW2-6D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XSW2-6D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XSW2+8D0*QF(3)*PZ12*S12*XCW2*XSW2-6D0*QF(2)*QF(3)*PZ12*S12*
     &  XCW2*XSW2+8D0*QF(2)*PZ34*S34*XCW2*XSW2-6D0*QF(2)*QF(3)*PZ34*
     &  S34*XCW2*XSW2+16D0*QF(2)*QF(3)*XCW2**2*XSW2+8D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XSW2**2+8D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2-
     &  12D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+16D0*QF(2)*QF(3)*
     &  PZ12*S12*XCW2*XSW2**2+16D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**
     &  2+16D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**3
        K(21) = 9D0*PZ12*PZ34*S12*S34-24D0*PZ12*PZ34*S12*S34*XSW2+
     &  18D0*QF(2)*PZ12*PZ34*S12*S34*XSW2+18D0*QF(3)*PZ12*PZ34*S12*
     &  S34*XSW2-24D0*QF(3)*PZ12*S12*XCW2*XSW2-24D0*QF(2)*PZ34*S34*
     &  XCW2*XSW2+32D0*PZ12*PZ34*S12*S34*XSW2**2-48D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XSW2**2-48D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+
     &  36D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+64D0*QF(3)*PZ12*
     &  S12*XCW2*XSW2**2-48D0*QF(2)*QF(3)*PZ12*S12*XCW2*XSW2**2+
     &  64D0*QF(2)*PZ34*S34*XCW2*XSW2**2-48D0*QF(2)*QF(3)*PZ34*S34*
     &  XCW2*XSW2**2+128D0*QF(2)*QF(3)*XCW2**2*XSW2**2+64D0*QF(2)*
     &  PZ12*PZ34*S12*S34*XSW2**3+64D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XSW2**3-96D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**3+128D0*
     &  QF(2)*QF(3)*PZ12*S12*XCW2*XSW2**3+128D0*QF(2)*QF(3)*PZ34*
     &  S34*XCW2*XSW2**3+128D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**4
        K(22) = 9D0*PZ12*PZ34*S12*S34-12D0*PZ12*PZ34*S12*S34*XSW2+
     &  18D0*QF(2)*PZ12*PZ34*S12*S34*XSW2+18D0*QF(3)*PZ12*PZ34*S12*
     &  S34*XSW2-12D0*QF(3)*PZ12*S12*XCW2*XSW2-12D0*QF(2)*PZ34*S34*
     &  XCW2*XSW2+16D0*PZ12*PZ34*S12*S34*XSW2**2-24D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XSW2**2-24D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+
     &  36D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+32D0*QF(3)*PZ12*
     &  S12*XCW2*XSW2**2-24D0*QF(2)*QF(3)*PZ12*S12*XCW2*XSW2**2+
     &  32D0*QF(2)*PZ34*S34*XCW2*XSW2**2-24D0*QF(2)*QF(3)*PZ34*S34*
     &  XCW2*XSW2**2+64D0*QF(2)*QF(3)*XCW2**2*XSW2**2+32D0*QF(2)*
     &  PZ12*PZ34*S12*S34*XSW2**3+32D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XSW2**3-48D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**3+64D0*
     &  QF(2)*QF(3)*PZ12*S12*XCW2*XSW2**3+64D0*QF(2)*QF(3)*PZ34*S34*
     &  XCW2*XSW2**3+64D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**4

        PRE = (ALPHA*XCW2**(-2)*XMQP2(I))/(192D0*PI*XMW*XSW)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*((72D0*C2(0,0)*K(1)*K(2)*PZ12*
     &  PZ34)/XSW2+(9D0*C1(1)*K(1)*K(2)*K(8)*PZ12*PZ34)/XSW2+(4D0*
     &  C2(2,2)*K(22))/(S12*XSW2)+(4D0*C2(1,1)*K(22))/(S34*XSW2)-
     &  (2D0*K(22))/(S12*S34*XSW2)-(4D0*C2(1,2)*K(22)*K(3))/(S12*
     &  S34*XSW2)-(9D0*C1(2)*K(1)*K(2)*PZ12*PZ34*(K(3)-2D0*S34))/
     &  XSW2+(8D0*K(20)*C0*(K(3)-2D0*XMQP2(I)))/(S12*S34)))/XSW2
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(72D0*C2(0,0)*K(1)*
     &  PZ12*PZ34+9D0*C1(1)*K(1)*K(8)*PZ12*PZ34+(4D0*C2(2,2)*K(17))/
     &  S12+(4D0*C2(1,1)*K(17))/S34-(2D0*K(17))/(S12*S34)-(4D0*C2(1,
     &  2)*K(17)*K(3))/(S12*S34)-9D0*C1(2)*K(1)*PZ12*PZ34*(K(3)-2D0*
     &  S34)+(4D0*K(14)*C0*(K(3)-2D0*XMQP2(I)))/(S12*S34)))/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(72D0*C2(0,0)*K(2)*
     &  PZ12*PZ34+9D0*C1(1)*K(2)*K(8)*PZ12*PZ34+(4D0*C2(2,2)*K(19))/
     &  S12+(4D0*C2(1,1)*K(19))/S34-(2D0*K(19))/(S12*S34)-(4D0*C2(1,
     &  2)*K(19)*K(3))/(S12*S34)-9D0*C1(2)*K(2)*PZ12*PZ34*(K(3)-2D0*
     &  S34)+(4D0*K(15)*C0*(K(3)-2D0*XMQP2(I)))/(S12*S34)))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(72D0*C2(0,0)*PZ12*
     &  PZ34+9D0*C1(1)*K(8)*PZ12*PZ34+(4D0*C2(2,2)*K(13))/S12+(4D0*
     &  C2(1,1)*K(13))/S34-(2D0*K(13))/(S12*S34)-(4D0*C2(1,2)*K(13)*
     &  K(3))/(S12*S34)-9D0*C1(2)*PZ12*PZ34*(K(3)-2D0*S34)+(4D0*
     &  K(11)*C0*(K(3)-2D0*XMQP2(I)))/(S12*S34))
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(6)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-(4D0*K(4)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-(4D0*K(5)*QF(2)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)-8D0*K(7)*QF(2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(6)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-(4D0*K(4)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-(4D0*K(5)*QF(2)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)-8D0*K(7)*QF(2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(6)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-(4D0*K(4)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-(4D0*K(5)*QF(2)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)-8D0*K(7)*QF(2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(6)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-(4D0*K(4)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-(4D0*K(5)*QF(2)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)-8D0*K(7)*QF(2)*QF(3)*PRE

100	continue

c*** counterterms
c----------------
        PRE = (PZ12*PZ34*XCW2**(-2)*XMW)/4D0

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
     &          *( ct_hzz + ct_zddl + ct_zddl
     &             +dZza/2d0*(-qd/gdd(-1)/s12/pz12-qd/gdd(-1)/s34/pz34)
     &             -2d0*dZzz + dmz2*pz12 + dmz2*pz34
     &            -(dZaz/2d0+dZza/2d0/s12/pz12)*(-qd/gdd(-1))
     &            -(dZaz/2d0+dZza/2d0/s34/pz34)*(-qd/gdd(-1)) )
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/XSW
     &          *( ct_hzz + ct_zddl + ct_zddr
     &             +dZza/2d0*(-qd/gdd(-1)/s12/pz12-qd/gdd(+1)/s34/pz34)
     &             -2d0*dZzz + dmz2*pz12 + dmz2*pz34
     &            -(dZaz/2d0+dZza/2d0/s12/pz12)*(-qd/gdd(-1))
     &            -(dZaz/2d0+dZza/2d0/s34/pz34)*(-qd/gdd(+1)) )
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/XSW
     &          *( ct_hzz + ct_zddr + ct_zddl
     &             +dZza/2d0*(-qd/gdd(+1)/s12/pz12-qd/gdd(-1)/s34/pz34)
     &             -2d0*dZzz + dmz2*pz12 + dmz2*pz34
     &            -(dZaz/2d0+dZza/2d0/s12/pz12)*(-qd/gdd(+1))
     &            -(dZaz/2d0+dZza/2d0/s34/pz34)*(-qd/gdd(-1)) )
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*XSW
     &          *( ct_hzz + ct_zddr + ct_zddr
     &             +dZza/2d0*(-qd/gdd(+1)/s12/pz12-qd/gdd(+1)/s34/pz34)
     &             -2d0*dZzz + dmz2*pz12 + dmz2*pz34
     &            -(dZaz/2d0+dZza/2d0/s12/pz12)*(-qd/gdd(+1))
     &            -(dZaz/2d0+dZza/2d0/s34/pz34)*(-qd/gdd(+1)) )

	end

************************************************************************
        subroutine add_HZZ2233_self(F,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for ZZ-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    down     anti-down     down     anti-down
*       self-energy contributions
*       boson loops only
*-----------------------------------------------------------------------
*       23.12.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(4)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pz12,pz34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
        complex*16 dZuur,dZuul,dZddr,dZddl
        complex*16 ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl
	integer i

        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/xrenc/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &         dZuur,dZuul,dZddr,dZddl,
     &         ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl

C       Process: S1F22aF22F23aF23,   Model: SM4f

C       G(T1,N4,FULL)+G(T2,N10,FULL)
        A0 = xA0_(XMH2)

        PRE = -((A0*ALPHA*PZ12*PZ34*(PZ12+PZ34)*XCW2**(-3)*XMW)/
     &  (64D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T1,N1,FULL)+G(T1,N2,FULL)+G(T1,N3,FULL)+G(T1,N6,FULL)+
C       G(T2,N12,FULL)+G(T2,N7,FULL)+G(T2,N8,FULL)+G(T2,N9,FULL)
        A0 = xA0_(XMW2)

        PRE = -((ALPHA*PZ12*PZ34*XMW)/(32D0*PI*S12*S34*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(-(8D0*XMW2*(PZ12*
     &  S12*S34+PZ34*S12*S34-2D0*QF(3)*S12*XSW2-2D0*QF(2)*S34*XSW2+
     &  2D0*QF(2)*PZ12*S12*S34*XSW2+2D0*QF(3)*PZ12*S12*S34*XSW2+2D0*
     &  QF(2)*PZ34*S12*S34*XSW2+2D0*QF(3)*PZ34*S12*S34*XSW2-4D0*
     &  QF(2)*QF(3)*S12*XSW2**2-4D0*QF(2)*QF(3)*S34*XSW2**2+4D0*
     &  QF(2)*QF(3)*PZ12*S12*S34*XSW2**2+4D0*QF(2)*QF(3)*PZ34*S12*
     &  S34*XSW2**2))+A0*XCW2**(-2)*(13D0*PZ12*S12*S34*XCW2**2+13D0*
     &  PZ34*S12*S34*XCW2**2-2D0*PZ12*S12*S34*XCW2*XSW2-2D0*PZ34*
     &  S12*S34*XCW2*XSW2-28D0*QF(3)*S12*XCW2**2*XSW2-28D0*QF(2)*
     &  S34*XCW2**2*XSW2+26D0*QF(2)*PZ12*S12*S34*XCW2**2*XSW2+26D0*
     &  QF(3)*PZ12*S12*S34*XCW2**2*XSW2+26D0*QF(2)*PZ34*S12*S34*
     &  XCW2**2*XSW2+26D0*QF(3)*PZ34*S12*S34*XCW2**2*XSW2+PZ12*S12*
     &  S34*XSW2**2+PZ34*S12*S34*XSW2**2+4D0*QF(3)*S12*XCW2*XSW2**2+
     &  4D0*QF(2)*S34*XCW2*XSW2**2-4D0*QF(2)*PZ12*S12*S34*XCW2*
     &  XSW2**2-4D0*QF(3)*PZ12*S12*S34*XCW2*XSW2**2-4D0*QF(2)*PZ34*
     &  S12*S34*XCW2*XSW2**2-4D0*QF(3)*PZ34*S12*S34*XCW2*XSW2**2-
     &  56D0*QF(2)*QF(3)*S12*XCW2**2*XSW2**2-56D0*QF(2)*QF(3)*S34*
     &  XCW2**2*XSW2**2+52D0*QF(2)*QF(3)*PZ12*S12*S34*XCW2**2*XSW2**
     &  2+52D0*QF(2)*QF(3)*PZ34*S12*S34*XCW2**2*XSW2**2+2D0*QF(2)*
     &  PZ12*S12*S34*XSW2**3+2D0*QF(3)*PZ12*S12*S34*XSW2**3+2D0*
     &  QF(2)*PZ34*S12*S34*XSW2**3+2D0*QF(3)*PZ34*S12*S34*XSW2**3+
     &  8D0*QF(2)*QF(3)*S12*XCW2*XSW2**3+8D0*QF(2)*QF(3)*S34*XCW2*
     &  XSW2**3-8D0*QF(2)*QF(3)*PZ12*S12*S34*XCW2*XSW2**3-8D0*QF(2)*
     &  QF(3)*PZ34*S12*S34*XCW2*XSW2**3+4D0*QF(2)*QF(3)*PZ12*S12*
     &  S34*XSW2**4+4D0*QF(2)*QF(3)*PZ34*S12*S34*XSW2**4))
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(8D0*XMW2*(S12-PZ12*
     &  S12*S34-PZ34*S12*S34+2D0*QF(2)*S12*XSW2+2D0*QF(2)*S34*XSW2-
     &  2D0*QF(2)*PZ12*S12*S34*XSW2-2D0*QF(2)*PZ34*S12*S34*XSW2)+A0*
     &  XCW2**(-2)*(-(14D0*S12*XCW2**2)+13D0*PZ12*S12*S34*XCW2**2+
     &  13D0*PZ34*S12*S34*XCW2**2+2D0*S12*XCW2*XSW2-2D0*PZ12*S12*
     &  S34*XCW2*XSW2-2D0*PZ34*S12*S34*XCW2*XSW2-28D0*QF(2)*S12*
     &  XCW2**2*XSW2-28D0*QF(2)*S34*XCW2**2*XSW2+26D0*QF(2)*PZ12*
     &  S12*S34*XCW2**2*XSW2+26D0*QF(2)*PZ34*S12*S34*XCW2**2*XSW2+
     &  PZ12*S12*S34*XSW2**2+PZ34*S12*S34*XSW2**2+4D0*QF(2)*S12*
     &  XCW2*XSW2**2+4D0*QF(2)*S34*XCW2*XSW2**2-4D0*QF(2)*PZ12*S12*
     &  S34*XCW2*XSW2**2-4D0*QF(2)*PZ34*S12*S34*XCW2*XSW2**2+2D0*
     &  QF(2)*PZ12*S12*S34*XSW2**3+2D0*QF(2)*PZ34*S12*S34*XSW2**
     &  3)))/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(8D0*XMW2*(S34-PZ12*
     &  S12*S34-PZ34*S12*S34+2D0*QF(3)*S12*XSW2+2D0*QF(3)*S34*XSW2-
     &  2D0*QF(3)*PZ12*S12*S34*XSW2-2D0*QF(3)*PZ34*S12*S34*XSW2)+A0*
     &  XCW2**(-2)*(-(14D0*S34*XCW2**2)+13D0*PZ12*S12*S34*XCW2**2+
     &  13D0*PZ34*S12*S34*XCW2**2+2D0*S34*XCW2*XSW2-2D0*PZ12*S12*
     &  S34*XCW2*XSW2-2D0*PZ34*S12*S34*XCW2*XSW2-28D0*QF(3)*S12*
     &  XCW2**2*XSW2-28D0*QF(3)*S34*XCW2**2*XSW2+26D0*QF(3)*PZ12*
     &  S12*S34*XCW2**2*XSW2+26D0*QF(3)*PZ34*S12*S34*XCW2**2*XSW2+
     &  PZ12*S12*S34*XSW2**2+PZ34*S12*S34*XSW2**2+4D0*QF(3)*S12*
     &  XCW2*XSW2**2+4D0*QF(3)*S34*XCW2*XSW2**2-4D0*QF(3)*PZ12*S12*
     &  S34*XCW2*XSW2**2-4D0*QF(3)*PZ34*S12*S34*XCW2*XSW2**2+2D0*
     &  QF(3)*PZ12*S12*S34*XSW2**3+2D0*QF(3)*PZ34*S12*S34*XSW2**
     &  3)))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(8D0*(S12+S34-PZ12*
     &  S12*S34-PZ34*S12*S34)*XMW2+A0*XCW2**(-2)*(-(14D0*S12*XCW2**
     &  2)-14D0*S34*XCW2**2+13D0*PZ12*S12*S34*XCW2**2+13D0*PZ34*S12*
     &  S34*XCW2**2+2D0*S12*XCW2*XSW2+2D0*S34*XCW2*XSW2-2D0*PZ12*
     &  S12*S34*XCW2*XSW2-2D0*PZ34*S12*S34*XCW2*XSW2+PZ12*S12*S34*
     &  XSW2**2+PZ34*S12*S34*XSW2**2))

C       G(T1,N5,FULL)+G(T2,N11,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((A0*ALPHA*PZ12*PZ34*(PZ12+PZ34)*XCW2**(-3)*XMW)/
     &  (64D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T3,N19,FULL)+G(T3,N20,FULL)+G(T3,N47,FULL)+G(T3,N48,FULL)
        CALL xB012345_(S12,XMH2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((ALPHA*PZ12**2*PZ34*XCW2**(-3)*XMW*(-(B2(0,0))+(B0*
     &  XMW2)/XCW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T3,N13,FULL)+G(T3,N14,FULL)+G(T3,N15,FULL)+G(T3,N16,FULL)+
C       G(T3,N17,FULL)+G(T3,N18,FULL)+G(T3,N21,FULL)+G(T3,N22,FULL)+
C       G(T3,N30,FULL)+G(T3,N31,FULL)+G(T3,N32,FULL)+G(T3,N33,FULL)+
C       G(T3,N34,FULL)+G(T3,N35,FULL)+G(T3,N44,FULL)+G(T3,N45,FULL)+
C       G(T3,N46,FULL)+G(T3,N49,FULL)+G(T3,N50,FULL)+G(T3,N51,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 1D0-PZ12*S12
        K(2) = PZ12*S12-2D0*QF(2)*XSW2+2D0*QF(2)*PZ12*S12*XSW2
        K(3) = 5D0*PZ12*S12**2*XCW2**2-10D0*QF(2)*S12*XCW2**2*XSW2+
     &  10D0*QF(2)*PZ12*S12**2*XCW2**2*XSW2-2D0*PZ12*S12*XMW2*XSW2**
     &  2-4D0*QF(2)*XCW2*XMW2*XSW2**2-4D0*QF(2)*PZ12*S12*XMW2*XSW2**
     &  3
        K(4) = 17D0*PZ12*S12*XCW2**2-2D0*PZ12*S12*XCW2*XSW2-36D0*
     &  QF(2)*XCW2**2*XSW2+34D0*QF(2)*PZ12*S12*XCW2**2*XSW2+PZ12*
     &  S12*XSW2**2+4D0*QF(2)*XCW2*XSW2**2-4D0*QF(2)*PZ12*S12*XCW2*
     &  XSW2**2+2D0*QF(2)*PZ12*S12*XSW2**3

        PRE = -((ALPHA*PZ12*PZ34*XMW)/(16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*(2D0*B1(1)*K(2)+2D0*B2(1,1)*
     &  K(2)+(B2(0,0)*K(4)*XCW2**(-2))/S12+(K(3)*B0*XCW2**(-2))/S12+
     &  (K(2)*(S12-6D0*XMW2))/S12)*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(2D0*B1(1)*K(2)+2D0*
     &  B2(1,1)*K(2)+(B2(0,0)*K(4)*XCW2**(-2))/S12+(K(3)*B0*XCW2**(-
     &  2))/S12+(K(2)*(S12-6D0*XMW2))/S12))/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2)*
     &  (2D0*B1(1)*K(1)+2D0*B2(1,1)*K(1)+(K(1)*(S12-6D0*XMW2))/S12-
     &  (B2(0,0)*XCW2**(-2)*(-(18D0*XCW2**2)+17D0*PZ12*S12*XCW2**2+
     &  2D0*XCW2*XSW2-2D0*PZ12*S12*XCW2*XSW2+PZ12*S12*XSW2**2))/S12-
     &  (B0*XCW2**(-2)*(-(5D0*S12*XCW2**2)+5D0*PZ12*S12**2*XCW2**2-
     &  2D0*XCW2*XMW2*XSW2-2D0*PZ12*S12*XMW2*XSW2**2))/S12))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(2D0*B1(1)*K(1)+2D0*
     &  B2(1,1)*K(1)+(K(1)*(S12-6D0*XMW2))/S12-(B2(0,0)*XCW2**(-2)*
     &  (-(18D0*XCW2**2)+17D0*PZ12*S12*XCW2**2+2D0*XCW2*XSW2-2D0*
     &  PZ12*S12*XCW2*XSW2+PZ12*S12*XSW2**2))/S12-(B0*XCW2**(-2)*(-
     &  (5D0*S12*XCW2**2)+5D0*PZ12*S12**2*XCW2**2-2D0*XCW2*XMW2*
     &  XSW2-2D0*PZ12*S12*XMW2*XSW2**2))/S12)

C       G(T4,N58,FULL)+G(T4,N59,FULL)+G(T4,N86,FULL)+G(T4,N87,FULL)
        CALL xB012345_(S34,XMH2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((ALPHA*PZ12*PZ34**2*XCW2**(-3)*XMW*(-(B2(0,0))+(B0*
     &  XMW2)/XCW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T4,N52,FULL)+G(T4,N53,FULL)+G(T4,N54,FULL)+G(T4,N55,FULL)+
C       G(T4,N56,FULL)+G(T4,N57,FULL)+G(T4,N60,FULL)+G(T4,N61,FULL)+
C       G(T4,N69,FULL)+G(T4,N70,FULL)+G(T4,N71,FULL)+G(T4,N72,FULL)+
C       G(T4,N73,FULL)+G(T4,N74,FULL)+G(T4,N83,FULL)+G(T4,N84,FULL)+
C       G(T4,N85,FULL)+G(T4,N88,FULL)+G(T4,N89,FULL)+G(T4,N90,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 1D0-PZ34*S34
        K(2) = PZ34*S34-2D0*QF(3)*XSW2+2D0*QF(3)*PZ34*S34*XSW2
        K(3) = 5D0*PZ34*S34**2*XCW2**2-10D0*QF(3)*S34*XCW2**2*XSW2+
     &  10D0*QF(3)*PZ34*S34**2*XCW2**2*XSW2-2D0*PZ34*S34*XMW2*XSW2**
     &  2-4D0*QF(3)*XCW2*XMW2*XSW2**2-4D0*QF(3)*PZ34*S34*XMW2*XSW2**
     &  3
        K(4) = 17D0*PZ34*S34*XCW2**2-2D0*PZ34*S34*XCW2*XSW2-36D0*
     &  QF(3)*XCW2**2*XSW2+34D0*QF(3)*PZ34*S34*XCW2**2*XSW2+PZ34*
     &  S34*XSW2**2+4D0*QF(3)*XCW2*XSW2**2-4D0*QF(3)*PZ34*S34*XCW2*
     &  XSW2**2+2D0*QF(3)*PZ34*S34*XSW2**3

        PRE = -((ALPHA*PZ12*PZ34*XMW)/(16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*(2D0*B1(1)*K(2)+2D0*B2(1,1)*
     &  K(2)+(B2(0,0)*K(4)*XCW2**(-2))/S34+(K(3)*B0*XCW2**(-2))/S34+
     &  (K(2)*(S34-6D0*XMW2))/S34)*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2)*
     &  (2D0*B1(1)*K(1)+2D0*B2(1,1)*K(1)+(K(1)*(S34-6D0*XMW2))/S34-
     &  (B2(0,0)*XCW2**(-2)*(-(18D0*XCW2**2)+17D0*PZ34*S34*XCW2**2+
     &  2D0*XCW2*XSW2-2D0*PZ34*S34*XCW2*XSW2+PZ34*S34*XSW2**2))/S34-
     &  (B0*XCW2**(-2)*(-(5D0*S34*XCW2**2)+5D0*PZ34*S34**2*XCW2**2-
     &  2D0*XCW2*XMW2*XSW2-2D0*PZ34*S34*XMW2*XSW2**2))/S34))/XSW2
        F(1,1,-1) = F(1,1,-1)-(2D0*QF(2)*PRE*(2D0*B1(1)*K(2)+2D0*
     &  B2(1,1)*K(2)+(B2(0,0)*K(4)*XCW2**(-2))/S34+(K(3)*B0*XCW2**(-
     &  2))/S34+(K(2)*(S34-6D0*XMW2))/S34))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(2D0*B1(1)*K(1)+2D0*
     &  B2(1,1)*K(1)+(K(1)*(S34-6D0*XMW2))/S34-(B2(0,0)*XCW2**(-2)*
     &  (-(18D0*XCW2**2)+17D0*PZ34*S34*XCW2**2+2D0*XCW2*XSW2-2D0*
     &  PZ34*S34*XCW2*XSW2+PZ34*S34*XSW2**2))/S34-(B0*XCW2**(-2)*(-
     &  (5D0*S34*XCW2**2)+5D0*PZ34*S34**2*XCW2**2-2D0*XCW2*XMW2*
     &  XSW2-2D0*PZ34*S34*XMW2*XSW2**2))/S34)

c*** counterterms
c----------------
        PRE = (PZ12*PZ34*XCW2**(-2)*XMW)/4D0

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
     &          *(-2d0*dZzz + dmz2*pz12 + dmz2*pz34
     &            -(dZaz/2d0+dZza/2d0/s12/pz12)*(-qd/gdd(-1))
     &            -(dZaz/2d0+dZza/2d0/s34/pz34)*(-qd/gdd(-1)) )
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/XSW
     &          *(-2d0*dZzz + dmz2*pz12 + dmz2*pz34
     &            -(dZaz/2d0+dZza/2d0/s12/pz12)*(-qd/gdd(-1))
     &            -(dZaz/2d0+dZza/2d0/s34/pz34)*(-qd/gdd(+1)) )
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/XSW
     &          *(-2d0*dZzz + dmz2*pz12 + dmz2*pz34
     &            -(dZaz/2d0+dZza/2d0/s12/pz12)*(-qd/gdd(+1))
     &            -(dZaz/2d0+dZza/2d0/s34/pz34)*(-qd/gdd(-1)) )
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*XSW
     &          *(-2d0*dZzz + dmz2*pz12 + dmz2*pz34
     &            -(dZaz/2d0+dZza/2d0/s12/pz12)*(-qd/gdd(+1))
     &            -(dZaz/2d0+dZza/2d0/s34/pz34)*(-qd/gdd(+1)) )

	end

************************************************************************
        subroutine add_HZZ2233_vert(F,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for ZZ-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    down     anti-down     down     anti-down
*       vertex corrections         
*       boson loops only
*-----------------------------------------------------------------------
*       28.12.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(20)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pz12,pz34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
        complex*16 dZuur,dZuul,dZddr,dZddl
        complex*16 ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)
	integer i

        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/xrenc/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &         dZuur,dZuul,dZddr,dZddl,
     &         ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl

C       Process: S1F22aF22F23aF23,   Model: SM4f

C       G(T8,N118,FULL)
        CALL xB012345_(MH2,XMH2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((3D0*ALPHA*B0*PZ12*PZ34*XCW2**(-2)*XMH2)/(128D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T8,N111,FULL)+G(T8,N112,FULL)+G(T8,N113,FULL)+G(T8,N114,
C       FULL)+G(T8,N115,FULL)+G(T8,N116,FULL)+G(T8,N117,FULL)+G(T8,
C       N120,FULL)
        CALL xB012345_(MH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA)/(64D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(-(16D0*XMW*(PZ12*
     &  S12-2D0*QF(2)*XSW2+2D0*QF(2)*PZ12*S12*XSW2)*(PZ34*S34-2D0*
     &  QF(3)*XSW2+2D0*QF(3)*PZ34*S34*XSW2))+(B0*XCW2**(-2)*(PZ12*
     &  PZ34*S12*S34*XCW2**2*XMH2+24D0*PZ12*PZ34*S12*S34*XCW2**2*
     &  XMW2-2D0*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2-4D0*QF(3)*PZ12*
     &  S12*XCW2**2*XMH2*XSW2-4D0*QF(2)*PZ34*S34*XCW2**2*XMH2*XSW2+
     &  2D0*QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+2D0*QF(3)*
     &  PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2-48D0*QF(3)*PZ12*S12*
     &  XCW2**2*XMW2*XSW2-48D0*QF(2)*PZ34*S34*XCW2**2*XMW2*XSW2+
     &  48D0*QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2+48D0*QF(3)*
     &  PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*XMH2*
     &  XSW2**2+4D0*QF(3)*PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(2)*PZ34*
     &  S34*XCW2*XMH2*XSW2**2-4D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*XMH2*
     &  XSW2**2-4D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2+16D0*
     &  QF(2)*QF(3)*XCW2**2*XMH2*XSW2**2-8D0*QF(2)*QF(3)*PZ12*S12*
     &  XCW2**2*XMH2*XSW2**2-8D0*QF(2)*QF(3)*PZ34*S34*XCW2**2*XMH2*
     &  XSW2**2+4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*
     &  XSW2**2+96D0*QF(2)*QF(3)*XCW2**2*XMW2*XSW2**2-96D0*QF(2)*
     &  QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2**2-96D0*QF(2)*QF(3)*PZ34*
     &  S34*XCW2**2*XMW2*XSW2**2+96D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2**2*XMW2*XSW2**2+2D0*QF(2)*PZ12*PZ34*S12*S34*XMH2*XSW2**
     &  3+2D0*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+8D0*QF(2)*QF(3)*
     &  PZ12*S12*XCW2*XMH2*XSW2**3+8D0*QF(2)*QF(3)*PZ34*S34*XCW2*
     &  XMH2*XSW2**3-8D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XCW2*XMH2*
     &  XSW2**3+4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**4))/
     &  XMW)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(16D0*(1D0-PZ34*S34)*
     &  XMW*(PZ12*S12-2D0*QF(2)*XSW2+2D0*QF(2)*PZ12*S12*XSW2)+(B0*
     &  XCW2**(-2)*(-(2D0*PZ12*S12*XCW2**2*XMH2)+PZ12*PZ34*S12*S34*
     &  XCW2**2*XMH2-24D0*PZ12*S12*XCW2**2*XMW2+24D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2+2D0*PZ12*S12*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*
     &  S12*S34*XCW2*XMH2*XSW2+8D0*QF(2)*XCW2**2*XMH2*XSW2-4D0*
     &  QF(2)*PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(2)*PZ34*S34*XCW2**2*
     &  XMH2*XSW2+2D0*QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+
     &  48D0*QF(2)*XCW2**2*XMW2*XSW2-48D0*QF(2)*PZ12*S12*XCW2**2*
     &  XMW2*XSW2-48D0*QF(2)*PZ34*S34*XCW2**2*XMW2*XSW2+48D0*QF(2)*
     &  PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*XMH2*
     &  XSW2**2+4D0*QF(2)*PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(2)*PZ34*
     &  S34*XCW2*XMH2*XSW2**2-4D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*XMH2*
     &  XSW2**2+2D0*QF(2)*PZ12*PZ34*S12*S34*XMH2*XSW2**3))/XMW))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(16D0*(1D0-PZ12*S12)*
     &  XMW*(PZ34*S34-2D0*QF(3)*XSW2+2D0*QF(3)*PZ34*S34*XSW2)+(B0*
     &  XCW2**(-2)*(-(2D0*PZ34*S34*XCW2**2*XMH2)+PZ12*PZ34*S12*S34*
     &  XCW2**2*XMH2-24D0*PZ34*S34*XCW2**2*XMW2+24D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2+2D0*PZ34*S34*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*
     &  S12*S34*XCW2*XMH2*XSW2+8D0*QF(3)*XCW2**2*XMH2*XSW2-4D0*
     &  QF(3)*PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(3)*PZ34*S34*XCW2**2*
     &  XMH2*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+
     &  48D0*QF(3)*XCW2**2*XMW2*XSW2-48D0*QF(3)*PZ12*S12*XCW2**2*
     &  XMW2*XSW2-48D0*QF(3)*PZ34*S34*XCW2**2*XMW2*XSW2+48D0*QF(3)*
     &  PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*XMH2*
     &  XSW2**2+4D0*QF(3)*PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(3)*PZ34*
     &  S34*XCW2*XMH2*XSW2**2-4D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*XMH2*
     &  XSW2**2+2D0*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3))/XMW))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(-(16D0*(1D0-PZ12*
     &  S12)*(1D0-PZ34*S34)*XMW)+(B0*XCW2**(-2)*(4D0*XCW2**2*XMH2-
     &  2D0*PZ12*S12*XCW2**2*XMH2-2D0*PZ34*S34*XCW2**2*XMH2+PZ12*
     &  PZ34*S12*S34*XCW2**2*XMH2+24D0*XCW2**2*XMW2-24D0*PZ12*S12*
     &  XCW2**2*XMW2-24D0*PZ34*S34*XCW2**2*XMW2+24D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2+2D0*PZ12*S12*XCW2*XMH2*XSW2+2D0*PZ34*S34*
     &  XCW2*XMH2*XSW2-2D0*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2+PZ12*
     &  PZ34*S12*S34*XMH2*XSW2**2))/XMW)

C       G(T8,N119,FULL)
        CALL xB012345_(MH2,XMZ2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*XCW2**(-2)*XMH2)/(128D0*PI*XMW*
     &  XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T10,N130,FULL)+G(T10,N131,FULL)+G(T10,N132,FULL)+G(T10,
C       N133,FULL)+G(T10,N134,FULL)+G(T10,N135,FULL)+G(T10,N136,
C       FULL)+G(T10,N137,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*XCW2**(-2)*XMW)/(16D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(PZ12*S12+2D0*QF(2)*XCW2+2D0*
     &  QF(2)*PZ12*S12*XSW2)*(PZ34*S34+2D0*QF(3)*XCW2+2D0*QF(3)*
     &  PZ34*S34*XSW2)
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*(PZ12*S12+2D0*QF(2)*
     &  XCW2+2D0*QF(2)*PZ12*S12*XSW2)*(XCW2+PZ34*S34*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(2)*PRE*(XCW2+PZ12*S12*XSW2)*
     &  (PZ34*S34+2D0*QF(3)*XCW2+2D0*QF(3)*PZ34*S34*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(XCW2+PZ12*S12*
     &  XSW2)*(XCW2+PZ34*S34*XSW2)

C       G(T10,N138,FULL)
        CALL xB012345_(S12,XMZ2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*XCW2**(-3)*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T9,N121,FULL)+G(T9,N122,FULL)+G(T9,N123,FULL)+G(T9,N124,
C       FULL)+G(T9,N125,FULL)+G(T9,N126,FULL)+G(T9,N127,FULL)+G(T9,
C       N128,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*XCW2**(-2)*XMW)/(16D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*(PZ12*S12+2D0*QF(2)*XCW2+2D0*
     &  QF(2)*PZ12*S12*XSW2)*(PZ34*S34+2D0*QF(3)*XCW2+2D0*QF(3)*
     &  PZ34*S34*XSW2)
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*(PZ12*S12+2D0*QF(2)*
     &  XCW2+2D0*QF(2)*PZ12*S12*XSW2)*(XCW2+PZ34*S34*XSW2)
        F(1,1,-1) = F(1,1,-1)+2D0*QF(2)*PRE*(XCW2+PZ12*S12*XSW2)*
     &  (PZ34*S34+2D0*QF(3)*XCW2+2D0*QF(3)*PZ34*S34*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(XCW2+PZ12*S12*
     &  XSW2)*(XCW2+PZ34*S34*XSW2)

C       G(T9,N129,FULL)
        CALL xB012345_(S34,XMZ2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*XCW2**(-3)*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T3,N10,FULL)+G(T3,N12,FULL)
        CALL xC01234_(RMF2(2),MH2,T11,CMF2(1),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*XMW)/(16D0*PI*S34*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(PZ34*S34+2D0*QF(2)*PZ34*S34*
     &  XSW2+2D0*QF(3)*PZ34*S34*XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*
     &  QF(2)*QF(3)*PZ34*S34*XSW2**2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*(PZ34*S34+2D0*QF(2)*
     &  XCW2+2D0*QF(2)*PZ34*S34*XSW2)

C       G(T3,N11,FULL)+G(T3,N9,FULL)
        CALL xC01234_(RMF2(2),MH2,T11,CMF2(2),XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*XCW2**(-3)*XMW)/(32D0*PI*S34)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*XSW2**(-2)*(1D0+2D0*QF(2)*
     &  XSW2)**2*(PZ34*S34+2D0*QF(2)*PZ34*S34*XSW2+2D0*QF(3)*PZ34*
     &  S34*XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*QF(2)*QF(3)*PZ34*S34*
     &  XSW2**2))/XSW
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2)**
     &  2*(PZ34*S34+2D0*QF(2)*XCW2+2D0*QF(2)*PZ34*S34*XSW2))/(XSW*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*QF(2)**3*PRE*XSW*(PZ34*S34+2D0*
     &  QF(3)*XCW2+2D0*QF(3)*PZ34*S34*XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(2)**3*QF(3)*PRE*XSW*(XCW2+PZ34*
     &  S34*XSW2)

C       G(T2,N6,FULL)+G(T2,N8,FULL)
        CALL xC01234_(RMF2(2),MH2,T12,CMF2(1),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*XMW)/(16D0*PI*S34*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(PZ34*S34+2D0*QF(2)*PZ34*S34*
     &  XSW2+2D0*QF(3)*PZ34*S34*XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*
     &  QF(2)*QF(3)*PZ34*S34*XSW2**2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*(PZ34*S34+2D0*QF(2)*
     &  XCW2+2D0*QF(2)*PZ34*S34*XSW2)

C       G(T1,N3,FULL)
        CALL xC01234_(RMF2(2),S12,RMF2(2),NULL,CMF2(2),CMF2(2),
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(2)**2*ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S12+C1(2)*S12+C2(1,2)*S12+C0*S12)*XCW2**(-2)*XMW)/(8D0*PI))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*XSW

C       G(T1,N2,FULL)
        CALL xC01234_(RMF2(2),S12,RMF2(2),CMF2(1),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PZ12*PZ34*(1D0-6D0*C2(0,0)+C1(1)*S12+C1(2)*
     &  S12+C2(1,2)*S12)*XMW)/(8D0*PI*XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE

C       G(T4,N13,FULL)+G(T4,N15,FULL)
        CALL xC01234_(RMF2(3),MH2,T13,CMF2(4),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*XMW)/(16D0*PI*S12*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(PZ12*S12+2D0*QF(2)*PZ12*S12*
     &  XSW2+2D0*QF(3)*PZ12*S12*XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*
     &  QF(2)*QF(3)*PZ12*S12*XSW2**2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(2)*PRE*(PZ12*S12+2D0*QF(3)*
     &  XCW2+2D0*QF(3)*PZ12*S12*XSW2)

C       G(T7,N109,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(3),NULL,CMF2(3),CMF2(3),
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(3)**2*ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S34+C1(2)*S34+C2(1,2)*S34+C0*S34)*XCW2**(-2)*XMW)/(8D0*PI))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*XSW

C       G(T7,N108,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(3),CMF2(4),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PZ12*PZ34*(1D0-6D0*C2(0,0)+C1(1)*S34+C1(2)*
     &  S34+C2(1,2)*S34)*XMW)/(8D0*PI*XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(2)*PRE

C       G(T1,N1,FULL)
        CALL xC01234_(S12,RMF2(2),RMF2(2),CMF2(1),CMF2(1),XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S12-C1(2)*S12-
     &  C2(1,1)*S12-C2(1,2)*S12)*XCW2**(-2)*XMW*(1D0-2D0*QF(1)*
     &  XSW2))/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE

C       G(T1,N4,FULL)
        CALL xC01234_(S12,RMF2(2),RMF2(2),CMF2(2),CMF2(2),XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S12-C1(2)*
     &  S12-C2(1,1)*S12-C2(1,2)*S12)*XCW2**(-3)*XMW)/(32D0*PI))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*XSW2**(-2)*(1D0+2D0*QF(2)*
     &  XSW2)**3*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2)**
     &  3)/(XSW*XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*QF(2)**3*PRE*XSW*(1D0+2D0*QF(3)*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(2)**3*QF(3)*PRE*XSW*XSW2

C       G(T5,N29,FULL)+G(T5,N30,FULL)+G(T5,N35,FULL)+G(T5,N36,FULL)
        CALL xC01234_(S12,MH2,S34,XMH2,XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = XCW2*XMH2+2D0*XMW2
        K(4) = 2D0*C1(1)*XMW+2D0*C1(2)*XMW+(C2(1,2)*(XCW2*XMH2+2D0*
     &  XMW2))/XMW

        PRE = -((ALPHA*PZ12*PZ34*XCW2**(-3))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(1)*K(2)*PRE*(-((C2(0,0)*K(3))/
     &  XMW)+(2D0*C0*XMW*XMW2)/XCW2)*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)+(2D0*K(1)*QF(3)*PRE*(-((C2(0,0)*K(3))/
     &  XMW)+(2D0*C0*XMW*XMW2)/XCW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(2)*PRE*(-((C2(0,0)*K(3))/
     &  XMW)+(2D0*C0*XMW*XMW2)/XCW2))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(-((C2(0,0)*K(3))/
     &  XMW)+(2D0*C0*XMW*XMW2)/XCW2)
        F(5,-1,-1) = F(5,-1,-1)+K(1)*K(2)*K(4)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(4)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)+(2D0*K(2)*K(4)*QF(2)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)+4D0*K(4)*QF(2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(1)*K(2)*K(4)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(4)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)+(2D0*K(2)*K(4)*QF(2)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)+4D0*K(4)*QF(2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(1)*K(2)*K(4)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(4)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)+(2D0*K(2)*K(4)*QF(2)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)+4D0*K(4)*QF(2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(1)*K(2)*K(4)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(4)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)+(2D0*K(2)*K(4)*QF(2)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)+4D0*K(4)*QF(2)*QF(3)*PRE

C       G(T5,N100,FULL)+G(T5,N101,FULL)+G(T5,N102,FULL)+G(T5,N17,
C       FULL)+G(T5,N18,FULL)+G(T5,N19,FULL)+G(T5,N20,FULL)+G(T5,N21,
C       FULL)+G(T5,N22,FULL)+G(T5,N23,FULL)+G(T5,N24,FULL)+G(T5,N25,
C       FULL)+G(T5,N26,FULL)+G(T5,N27,FULL)+G(T5,N28,FULL)+G(T5,N31,
C       FULL)+G(T5,N32,FULL)+G(T5,N33,FULL)+G(T5,N34,FULL)+G(T5,N37,
C       FULL)+G(T5,N38,FULL)+G(T5,N39,FULL)+G(T5,N40,FULL)+G(T5,N41,
C       FULL)+G(T5,N42,FULL)+G(T5,N43,FULL)+G(T5,N44,FULL)+G(T5,N45,
C       FULL)+G(T5,N46,FULL)+G(T5,N47,FULL)+G(T5,N48,FULL)+G(T5,N49,
C       FULL)+G(T5,N50,FULL)+G(T5,N51,FULL)+G(T5,N52,FULL)+G(T5,N53,
C       FULL)+G(T5,N54,FULL)+G(T5,N55,FULL)+G(T5,N56,FULL)+G(T5,N57,
C       FULL)+G(T5,N58,FULL)+G(T5,N59,FULL)+G(T5,N60,FULL)+G(T5,N61,
C       FULL)+G(T5,N62,FULL)+G(T5,N63,FULL)+G(T5,N64,FULL)+G(T5,N65,
C       FULL)+G(T5,N66,FULL)+G(T5,N67,FULL)+G(T5,N68,FULL)+G(T5,N69,
C       FULL)+G(T5,N70,FULL)+G(T5,N71,FULL)+G(T5,N72,FULL)+G(T5,N73,
C       FULL)+G(T5,N74,FULL)+G(T5,N75,FULL)+G(T5,N76,FULL)+G(T5,N77,
C       FULL)+G(T5,N78,FULL)+G(T5,N79,FULL)+G(T5,N80,FULL)+G(T5,N81,
C       FULL)+G(T5,N82,FULL)+G(T5,N83,FULL)+G(T5,N84,FULL)+G(T5,N85,
C       FULL)+G(T5,N86,FULL)+G(T5,N87,FULL)+G(T5,N88,FULL)+G(T5,N91,
C       FULL)+G(T5,N92,FULL)+G(T5,N93,FULL)+G(T5,N94,FULL)+G(T5,N95,
C       FULL)+G(T5,N96,FULL)+G(T5,N97,FULL)+G(T5,N98,FULL)+G(T5,N99,
C       FULL)
        CALL xC01234_(S12,MH2,S34,XMW2,XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = XCW2+XSW2
        K(4) = S13+S14+S23+S24
        K(5) = (2D0*C1(1)*PZ12*PZ34*XMW*(XCW2+XSW2)**2*(1D0+2D0*
     &  QF(2)*XSW2))/XCW2+(2D0*C1(2)*PZ12*PZ34*XMW*(XCW2+XSW2)**2*
     &  (1D0+2D0*QF(2)*XSW2))/XCW2+(4D0*C0*XMW*(3D0*PZ12*S12*XCW2-
     &  2D0*PZ12*PZ34*S12*S34*XCW2-PZ12*S12*XSW2+2D0*PZ12*PZ34*S12*
     &  S34*XSW2-8D0*QF(2)*XCW2*XSW2+6D0*QF(2)*PZ12*S12*XCW2*XSW2+
     &  6D0*QF(2)*PZ34*S34*XCW2*XSW2-4D0*QF(2)*PZ12*PZ34*S12*S34*
     &  XCW2*XSW2-2D0*QF(2)*PZ12*S12*XSW2**2-2D0*QF(2)*PZ34*S34*
     &  XSW2**2+4D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**2))/(S12*S34)+
     &  (C2(1,2)*(-(2D0*PZ12*S12*XCW2**2*XMH2)+PZ12*PZ34*S12*S34*
     &  XCW2**2*XMH2-20D0*PZ12*S12*XCW2**2*XMW2+18D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2+2D0*PZ12*S12*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*
     &  S12*S34*XCW2*XMH2*XSW2+8D0*QF(2)*XCW2**2*XMH2*XSW2-4D0*
     &  QF(2)*PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(2)*PZ34*S34*XCW2**2*
     &  XMH2*XSW2+2D0*QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+4D0*
     &  PZ12*S12*XCW2*XMW2*XSW2-4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*
     &  XSW2+48D0*QF(2)*XCW2**2*XMW2*XSW2-40D0*QF(2)*PZ12*S12*XCW2**
     &  2*XMW2*XSW2-40D0*QF(2)*PZ34*S34*XCW2**2*XMW2*XSW2+36D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**2+4D0*QF(2)*PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(2)*
     &  PZ34*S34*XCW2*XMH2*XSW2**2-4D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*
     &  XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(2)*
     &  PZ12*S12*XCW2*XMW2*XSW2**2+8D0*QF(2)*PZ34*S34*XCW2*XMW2*
     &  XSW2**2-8D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2**2+2D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+4D0*QF(2)*PZ12*PZ34*
     &  S12*S34*XMW2*XSW2**3))/(S12*S34*XCW2*XMW)
        K(6) = (2D0*C1(1)*PZ12*PZ34*XMW*(XCW2+XSW2)**2*(1D0+2D0*
     &  QF(3)*XSW2))/XCW2+(2D0*C1(2)*PZ12*PZ34*XMW*(XCW2+XSW2)**2*
     &  (1D0+2D0*QF(3)*XSW2))/XCW2+(4D0*C0*XMW*(3D0*PZ34*S34*XCW2-
     &  2D0*PZ12*PZ34*S12*S34*XCW2-PZ34*S34*XSW2+2D0*PZ12*PZ34*S12*
     &  S34*XSW2-8D0*QF(3)*XCW2*XSW2+6D0*QF(3)*PZ12*S12*XCW2*XSW2+
     &  6D0*QF(3)*PZ34*S34*XCW2*XSW2-4D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2*XSW2-2D0*QF(3)*PZ12*S12*XSW2**2-2D0*QF(3)*PZ34*S34*
     &  XSW2**2+4D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2))/(S12*S34)+
     &  (C2(1,2)*(-(2D0*PZ34*S34*XCW2**2*XMH2)+PZ12*PZ34*S12*S34*
     &  XCW2**2*XMH2-20D0*PZ34*S34*XCW2**2*XMW2+18D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2+2D0*PZ34*S34*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*
     &  S12*S34*XCW2*XMH2*XSW2+8D0*QF(3)*XCW2**2*XMH2*XSW2-4D0*
     &  QF(3)*PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(3)*PZ34*S34*XCW2**2*
     &  XMH2*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+4D0*
     &  PZ34*S34*XCW2*XMW2*XSW2-4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*
     &  XSW2+48D0*QF(3)*XCW2**2*XMW2*XSW2-40D0*QF(3)*PZ12*S12*XCW2**
     &  2*XMW2*XSW2-40D0*QF(3)*PZ34*S34*XCW2**2*XMW2*XSW2+36D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**2+4D0*QF(3)*PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(3)*
     &  PZ34*S34*XCW2*XMH2*XSW2**2-4D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*
     &  XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(3)*
     &  PZ12*S12*XCW2*XMW2*XSW2**2+8D0*QF(3)*PZ34*S34*XCW2*XMW2*
     &  XSW2**2-8D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2**2+2D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+4D0*QF(3)*PZ12*PZ34*
     &  S12*S34*XMW2*XSW2**3))/(S12*S34*XCW2*XMW)
        K(7) = -((2D0*C1(1)*PZ12*PZ34*XMW*(XCW2+XSW2)**2*(1D0+2D0*
     &  QF(2)*XSW2)*(1D0+2D0*QF(3)*XSW2))/XCW2)-(2D0*C1(2)*PZ12*
     &  PZ34*XMW*(XCW2+XSW2)**2*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*QF(3)*
     &  XSW2))/XCW2+(8D0*C0*XMW*(PZ12*PZ34*S12*S34*XCW2-PZ12*PZ34*
     &  S12*S34*XSW2-3D0*QF(3)*PZ12*S12*XCW2*XSW2-3D0*QF(2)*PZ34*
     &  S34*XCW2*XSW2+2D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*XSW2+2D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2*XSW2+QF(3)*PZ12*S12*XSW2**2+
     &  QF(2)*PZ34*S34*XSW2**2-2D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**2-
     &  2D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+8D0*QF(2)*QF(3)*XCW2*
     &  XSW2**2-6D0*QF(2)*QF(3)*PZ12*S12*XCW2*XSW2**2-6D0*QF(2)*
     &  QF(3)*PZ34*S34*XCW2*XSW2**2+4D0*QF(2)*QF(3)*PZ12*PZ34*S12*
     &  S34*XCW2*XSW2**2+2D0*QF(2)*QF(3)*PZ12*S12*XSW2**3+2D0*QF(2)*
     &  QF(3)*PZ34*S34*XSW2**3-4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*
     &  XSW2**3))/(S12*S34)-(C2(1,2)*(PZ12*PZ34*S12*S34*XCW2**2*
     &  XMH2+18D0*PZ12*PZ34*S12*S34*XCW2**2*XMW2-2D0*PZ12*PZ34*S12*
     &  S34*XCW2*XMH2*XSW2-4D0*QF(3)*PZ12*S12*XCW2**2*XMH2*XSW2-4D0*
     &  QF(2)*PZ34*S34*XCW2**2*XMH2*XSW2+2D0*QF(2)*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMH2*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*
     &  XMH2*XSW2-4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2-40D0*QF(3)*
     &  PZ12*S12*XCW2**2*XMW2*XSW2-40D0*QF(2)*PZ34*S34*XCW2**2*XMW2*
     &  XSW2+36D0*QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2+36D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**2+4D0*QF(3)*PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(2)*
     &  PZ34*S34*XCW2*XMH2*XSW2**2-4D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*
     &  XMH2*XSW2**2-4D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2+
     &  16D0*QF(2)*QF(3)*XCW2**2*XMH2*XSW2**2-8D0*QF(2)*QF(3)*PZ12*
     &  S12*XCW2**2*XMH2*XSW2**2-8D0*QF(2)*QF(3)*PZ34*S34*XCW2**2*
     &  XMH2*XSW2**2+4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*
     &  XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(3)*PZ12*
     &  S12*XCW2*XMW2*XSW2**2+8D0*QF(2)*PZ34*S34*XCW2*XMW2*XSW2**2-
     &  8D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2**2-8D0*QF(3)*
     &  PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2**2+96D0*QF(2)*QF(3)*XCW2**
     &  2*XMW2*XSW2**2-80D0*QF(2)*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2**
     &  2-80D0*QF(2)*QF(3)*PZ34*S34*XCW2**2*XMW2*XSW2**2+72D0*QF(2)*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2**2+2D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XMH2*XSW2**3+2D0*QF(3)*PZ12*PZ34*S12*S34*XMH2*
     &  XSW2**3+8D0*QF(2)*QF(3)*PZ12*S12*XCW2*XMH2*XSW2**3+8D0*
     &  QF(2)*QF(3)*PZ34*S34*XCW2*XMH2*XSW2**3-8D0*QF(2)*QF(3)*PZ12*
     &  PZ34*S12*S34*XCW2*XMH2*XSW2**3+4D0*QF(2)*PZ12*PZ34*S12*S34*
     &  XMW2*XSW2**3+4D0*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**3+16D0*
     &  QF(2)*QF(3)*PZ12*S12*XCW2*XMW2*XSW2**3+16D0*QF(2)*QF(3)*
     &  PZ34*S34*XCW2*XMW2*XSW2**3-16D0*QF(2)*QF(3)*PZ12*PZ34*S12*
     &  S34*XCW2*XMW2*XSW2**3+4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**4+8D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**
     &  4))/(S12*S34*XCW2*XMW)
        K(8) = (2D0*C1(1)*PZ12*PZ34*XMW*(XCW2+XSW2)**2)/XCW2+(2D0*
     &  C1(2)*PZ12*PZ34*XMW*(XCW2+XSW2)**2)/XCW2+(4D0*C0*XMW*(-(4D0*
     &  XCW2)+3D0*PZ12*S12*XCW2+3D0*PZ34*S34*XCW2-2D0*PZ12*PZ34*S12*
     &  S34*XCW2-PZ12*S12*XSW2-PZ34*S34*XSW2+2D0*PZ12*PZ34*S12*S34*
     &  XSW2))/(S12*S34)+(C2(1,2)*(4D0*XCW2**2*XMH2-2D0*PZ12*S12*
     &  XCW2**2*XMH2-2D0*PZ34*S34*XCW2**2*XMH2+PZ12*PZ34*S12*S34*
     &  XCW2**2*XMH2+24D0*XCW2**2*XMW2-20D0*PZ12*S12*XCW2**2*XMW2-
     &  20D0*PZ34*S34*XCW2**2*XMW2+18D0*PZ12*PZ34*S12*S34*XCW2**2*
     &  XMW2+2D0*PZ12*S12*XCW2*XMH2*XSW2+2D0*PZ34*S34*XCW2*XMH2*
     &  XSW2-2D0*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2+4D0*PZ12*S12*XCW2*
     &  XMW2*XSW2+4D0*PZ34*S34*XCW2*XMW2*XSW2-4D0*PZ12*PZ34*S12*S34*
     &  XCW2*XMW2*XSW2+PZ12*PZ34*S12*S34*XMH2*XSW2**2+2D0*PZ12*PZ34*
     &  S12*S34*XMW2*XSW2**2))/(S12*S34*XCW2*XMW)
        K(9) = -(4D0*XCW2)+3D0*PZ12*S12*XCW2+3D0*PZ34*S34*XCW2-2D0*
     &  PZ12*PZ34*S12*S34*XCW2-PZ12*S12*XSW2-PZ34*S34*XSW2+2D0*PZ12*
     &  PZ34*S12*S34*XSW2
        K(10) = 2D0*XCW2-3D0*PZ12*S12*XCW2-3D0*PZ34*S34*XCW2+4D0*
     &  PZ12*PZ34*S12*S34*XCW2-PZ12*S12*XSW2-PZ34*S34*XSW2+2D0*PZ12*
     &  PZ34*S12*S34*XSW2
        K(11) = -(3D0*PZ12*S12*XCW2)+4D0*PZ12*PZ34*S12*S34*XCW2-
     &  PZ12*S12*XSW2+2D0*PZ12*PZ34*S12*S34*XSW2+4D0*QF(2)*XCW2*
     &  XSW2-6D0*QF(2)*PZ12*S12*XCW2*XSW2-6D0*QF(2)*PZ34*S34*XCW2*
     &  XSW2+8D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*XSW2-2D0*QF(2)*PZ12*
     &  S12*XSW2**2-2D0*QF(2)*PZ34*S34*XSW2**2+4D0*QF(2)*PZ12*PZ34*
     &  S12*S34*XSW2**2
        K(12) = 3D0*PZ12*S12*XCW2-2D0*PZ12*PZ34*S12*S34*XCW2-PZ12*
     &  S12*XSW2+2D0*PZ12*PZ34*S12*S34*XSW2-8D0*QF(2)*XCW2*XSW2+6D0*
     &  QF(2)*PZ12*S12*XCW2*XSW2+6D0*QF(2)*PZ34*S34*XCW2*XSW2-4D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XCW2*XSW2-2D0*QF(2)*PZ12*S12*XSW2**
     &  2-2D0*QF(2)*PZ34*S34*XSW2**2+4D0*QF(2)*PZ12*PZ34*S12*S34*
     &  XSW2**2
        K(13) = -(3D0*PZ34*S34*XCW2)+4D0*PZ12*PZ34*S12*S34*XCW2-
     &  PZ34*S34*XSW2+2D0*PZ12*PZ34*S12*S34*XSW2+4D0*QF(3)*XCW2*
     &  XSW2-6D0*QF(3)*PZ12*S12*XCW2*XSW2-6D0*QF(3)*PZ34*S34*XCW2*
     &  XSW2+8D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*XSW2-2D0*QF(3)*PZ12*
     &  S12*XSW2**2-2D0*QF(3)*PZ34*S34*XSW2**2+4D0*QF(3)*PZ12*PZ34*
     &  S12*S34*XSW2**2
        K(14) = 3D0*PZ34*S34*XCW2-2D0*PZ12*PZ34*S12*S34*XCW2-PZ34*
     &  S34*XSW2+2D0*PZ12*PZ34*S12*S34*XSW2-8D0*QF(3)*XCW2*XSW2+6D0*
     &  QF(3)*PZ12*S12*XCW2*XSW2+6D0*QF(3)*PZ34*S34*XCW2*XSW2-4D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2*XSW2-2D0*QF(3)*PZ12*S12*XSW2**
     &  2-2D0*QF(3)*PZ34*S34*XSW2**2+4D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XSW2**2
        K(15) = 4D0*XCW2**2*XMH2-2D0*PZ12*S12*XCW2**2*XMH2-2D0*PZ34*
     &  S34*XCW2**2*XMH2+PZ12*PZ34*S12*S34*XCW2**2*XMH2+24D0*XCW2**
     &  2*XMW2-20D0*PZ12*S12*XCW2**2*XMW2-20D0*PZ34*S34*XCW2**2*
     &  XMW2+18D0*PZ12*PZ34*S12*S34*XCW2**2*XMW2+2D0*PZ12*S12*XCW2*
     &  XMH2*XSW2+2D0*PZ34*S34*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*S12*S34*
     &  XCW2*XMH2*XSW2+4D0*PZ12*S12*XCW2*XMW2*XSW2+4D0*PZ34*S34*
     &  XCW2*XMW2*XSW2-4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2+PZ12*
     &  PZ34*S12*S34*XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2
        K(16) = PZ12*PZ34*S12*S34*XCW2-PZ12*PZ34*S12*S34*XSW2-3D0*
     &  QF(3)*PZ12*S12*XCW2*XSW2-3D0*QF(2)*PZ34*S34*XCW2*XSW2+2D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XCW2*XSW2+2D0*QF(3)*PZ12*PZ34*S12*
     &  S34*XCW2*XSW2+QF(3)*PZ12*S12*XSW2**2+QF(2)*PZ34*S34*XSW2**2-
     &  2D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**2-2D0*QF(3)*PZ12*PZ34*S12*
     &  S34*XSW2**2+8D0*QF(2)*QF(3)*XCW2*XSW2**2-6D0*QF(2)*QF(3)*
     &  PZ12*S12*XCW2*XSW2**2-6D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**2+
     &  4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XCW2*XSW2**2+2D0*QF(2)*
     &  QF(3)*PZ12*S12*XSW2**3+2D0*QF(2)*QF(3)*PZ34*S34*XSW2**3-4D0*
     &  QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**3
        K(17) = 2D0*PZ12*PZ34*S12*S34*XCW2+PZ12*PZ34*S12*S34*XSW2-
     &  3D0*QF(3)*PZ12*S12*XCW2*XSW2-3D0*QF(2)*PZ34*S34*XCW2*XSW2+
     &  4D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*XSW2+4D0*QF(3)*PZ12*PZ34*
     &  S12*S34*XCW2*XSW2-QF(3)*PZ12*S12*XSW2**2-QF(2)*PZ34*S34*
     &  XSW2**2+2D0*QF(2)*PZ12*PZ34*S12*S34*XSW2**2+2D0*QF(3)*PZ12*
     &  PZ34*S12*S34*XSW2**2+4D0*QF(2)*QF(3)*XCW2*XSW2**2-6D0*QF(2)*
     &  QF(3)*PZ12*S12*XCW2*XSW2**2-6D0*QF(2)*QF(3)*PZ34*S34*XCW2*
     &  XSW2**2+8D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XCW2*XSW2**2-2D0*
     &  QF(2)*QF(3)*PZ12*S12*XSW2**3-2D0*QF(2)*QF(3)*PZ34*S34*XSW2**
     &  3+4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**3
        K(18) = -(2D0*PZ12*S12*XCW2**2*XMH2)+PZ12*PZ34*S12*S34*
     &  XCW2**2*XMH2-20D0*PZ12*S12*XCW2**2*XMW2+18D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2+2D0*PZ12*S12*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*
     &  S12*S34*XCW2*XMH2*XSW2+8D0*QF(2)*XCW2**2*XMH2*XSW2-4D0*
     &  QF(2)*PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(2)*PZ34*S34*XCW2**2*
     &  XMH2*XSW2+2D0*QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+4D0*
     &  PZ12*S12*XCW2*XMW2*XSW2-4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*
     &  XSW2+48D0*QF(2)*XCW2**2*XMW2*XSW2-40D0*QF(2)*PZ12*S12*XCW2**
     &  2*XMW2*XSW2-40D0*QF(2)*PZ34*S34*XCW2**2*XMW2*XSW2+36D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**2+4D0*QF(2)*PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(2)*
     &  PZ34*S34*XCW2*XMH2*XSW2**2-4D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*
     &  XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(2)*
     &  PZ12*S12*XCW2*XMW2*XSW2**2+8D0*QF(2)*PZ34*S34*XCW2*XMW2*
     &  XSW2**2-8D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2**2+2D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+4D0*QF(2)*PZ12*PZ34*
     &  S12*S34*XMW2*XSW2**3
        K(19) = -(2D0*PZ34*S34*XCW2**2*XMH2)+PZ12*PZ34*S12*S34*
     &  XCW2**2*XMH2-20D0*PZ34*S34*XCW2**2*XMW2+18D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2+2D0*PZ34*S34*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*
     &  S12*S34*XCW2*XMH2*XSW2+8D0*QF(3)*XCW2**2*XMH2*XSW2-4D0*
     &  QF(3)*PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(3)*PZ34*S34*XCW2**2*
     &  XMH2*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+4D0*
     &  PZ34*S34*XCW2*XMW2*XSW2-4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*
     &  XSW2+48D0*QF(3)*XCW2**2*XMW2*XSW2-40D0*QF(3)*PZ12*S12*XCW2**
     &  2*XMW2*XSW2-40D0*QF(3)*PZ34*S34*XCW2**2*XMW2*XSW2+36D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**2+4D0*QF(3)*PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(3)*
     &  PZ34*S34*XCW2*XMH2*XSW2**2-4D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*
     &  XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(3)*
     &  PZ12*S12*XCW2*XMW2*XSW2**2+8D0*QF(3)*PZ34*S34*XCW2*XMW2*
     &  XSW2**2-8D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2**2+2D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+4D0*QF(3)*PZ12*PZ34*
     &  S12*S34*XMW2*XSW2**3
        K(20) = PZ12*PZ34*S12*S34*XCW2**2*XMH2+18D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2-2D0*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2-4D0*
     &  QF(3)*PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(2)*PZ34*S34*XCW2**2*
     &  XMH2*XSW2+2D0*QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+2D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2-4D0*PZ12*PZ34*S12*
     &  S34*XCW2*XMW2*XSW2-40D0*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2-
     &  40D0*QF(2)*PZ34*S34*XCW2**2*XMW2*XSW2+36D0*QF(2)*PZ12*PZ34*
     &  S12*S34*XCW2**2*XMW2*XSW2+36D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*XMH2*XSW2**2+4D0*QF(3)*
     &  PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(2)*PZ34*S34*XCW2*XMH2*
     &  XSW2**2-4D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2-4D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2+16D0*QF(2)*QF(3)*
     &  XCW2**2*XMH2*XSW2**2-8D0*QF(2)*QF(3)*PZ12*S12*XCW2**2*XMH2*
     &  XSW2**2-8D0*QF(2)*QF(3)*PZ34*S34*XCW2**2*XMH2*XSW2**2+4D0*
     &  QF(2)*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2**2+2D0*PZ12*
     &  PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(3)*PZ12*S12*XCW2*XMW2*
     &  XSW2**2+8D0*QF(2)*PZ34*S34*XCW2*XMW2*XSW2**2-8D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XCW2*XMW2*XSW2**2-8D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2*XMW2*XSW2**2+96D0*QF(2)*QF(3)*XCW2**2*XMW2*XSW2**2-
     &  80D0*QF(2)*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2**2-80D0*QF(2)*
     &  QF(3)*PZ34*S34*XCW2**2*XMW2*XSW2**2+72D0*QF(2)*QF(3)*PZ12*
     &  PZ34*S12*S34*XCW2**2*XMW2*XSW2**2+2D0*QF(2)*PZ12*PZ34*S12*
     &  S34*XMH2*XSW2**3+2D0*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+
     &  8D0*QF(2)*QF(3)*PZ12*S12*XCW2*XMH2*XSW2**3+8D0*QF(2)*QF(3)*
     &  PZ34*S34*XCW2*XMH2*XSW2**3-8D0*QF(2)*QF(3)*PZ12*PZ34*S12*
     &  S34*XCW2*XMH2*XSW2**3+4D0*QF(2)*PZ12*PZ34*S12*S34*XMW2*
     &  XSW2**3+4D0*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**3+16D0*QF(2)*
     &  QF(3)*PZ12*S12*XCW2*XMW2*XSW2**3+16D0*QF(2)*QF(3)*PZ34*S34*
     &  XCW2*XMW2*XSW2**3-16D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XCW2*
     &  XMW2*XSW2**3+4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**4+
     &  8D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**4

        PRE = -((ALPHA)/(16D0*PI*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(-((2D0*C2(2,2)*
     &  K(17)*XMW)/S12)-(2D0*C2(1,1)*K(17)*XMW)/S34+(2D0*C2(1,2)*
     &  K(17)*K(4)*XMW)/(S12*S34)+(XMW*(6D0*PZ12*PZ34*S12*S34*XCW2+
     &  PZ12*PZ34*S12*S34*XSW2-11D0*QF(3)*PZ12*S12*XCW2*XSW2-11D0*
     &  QF(2)*PZ34*S34*XCW2*XSW2+12D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*
     &  XSW2+12D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*XSW2-QF(3)*PZ12*S12*
     &  XSW2**2-QF(2)*PZ34*S34*XSW2**2+2D0*QF(2)*PZ12*PZ34*S12*S34*
     &  XSW2**2+2D0*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+20D0*QF(2)*
     &  QF(3)*XCW2*XSW2**2-22D0*QF(2)*QF(3)*PZ12*S12*XCW2*XSW2**2-
     &  22D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**2+24D0*QF(2)*QF(3)*
     &  PZ12*PZ34*S12*S34*XCW2*XSW2**2-2D0*QF(2)*QF(3)*PZ12*S12*
     &  XSW2**3-2D0*QF(2)*QF(3)*PZ34*S34*XSW2**3+4D0*QF(2)*QF(3)*
     &  PZ12*PZ34*S12*S34*XSW2**3))/(S12*S34)-(C1(1)*XMW*(2D0*PZ12*
     &  PZ34*S12**2*S34*XCW2-PZ12*PZ34*S12*S13*S34*XCW2-PZ12*PZ34*
     &  S12*S14*S34*XCW2-PZ12*PZ34*S12*S23*S34*XCW2-PZ12*PZ34*S12*
     &  S24*S34*XCW2-8D0*QF(3)*PZ12*S12**2*XCW2*XSW2+4D0*QF(2)*PZ12*
     &  PZ34*S12**2*S34*XCW2*XSW2+4D0*QF(3)*PZ12*PZ34*S12**2*S34*
     &  XCW2*XSW2+4D0*QF(2)*PZ34*S13*S34*XCW2*XSW2-2D0*QF(2)*PZ12*
     &  PZ34*S12*S13*S34*XCW2*XSW2-2D0*QF(3)*PZ12*PZ34*S12*S13*S34*
     &  XCW2*XSW2+4D0*QF(2)*PZ34*S14*S34*XCW2*XSW2-2D0*QF(2)*PZ12*
     &  PZ34*S12*S14*S34*XCW2*XSW2-2D0*QF(3)*PZ12*PZ34*S12*S14*S34*
     &  XCW2*XSW2+4D0*QF(2)*PZ34*S23*S34*XCW2*XSW2-2D0*QF(2)*PZ12*
     &  PZ34*S12*S23*S34*XCW2*XSW2-2D0*QF(3)*PZ12*PZ34*S12*S23*S34*
     &  XCW2*XSW2+4D0*QF(2)*PZ34*S24*S34*XCW2*XSW2-2D0*QF(2)*PZ12*
     &  PZ34*S12*S24*S34*XCW2*XSW2-2D0*QF(3)*PZ12*PZ34*S12*S24*S34*
     &  XCW2*XSW2-4D0*QF(3)*PZ12*S12**2*XSW2**2-2D0*QF(3)*PZ12*S12*
     &  S13*XSW2**2-2D0*QF(3)*PZ12*S12*S14*XSW2**2-2D0*QF(3)*PZ12*
     &  S12*S23*XSW2**2-2D0*QF(3)*PZ12*S12*S24*XSW2**2+4D0*QF(2)*
     &  PZ34*S12*S34*XSW2**2+2D0*QF(2)*PZ34*S13*S34*XSW2**2+2D0*
     &  QF(2)*PZ34*S14*S34*XSW2**2+2D0*QF(2)*PZ34*S23*S34*XSW2**2+
     &  2D0*QF(2)*PZ34*S24*S34*XSW2**2+8D0*QF(2)*QF(3)*S12*XCW2*
     &  XSW2**2-16D0*QF(2)*QF(3)*PZ12*S12**2*XCW2*XSW2**2-4D0*QF(2)*
     &  QF(3)*S13*XCW2*XSW2**2-4D0*QF(2)*QF(3)*S14*XCW2*XSW2**2-4D0*
     &  QF(2)*QF(3)*S23*XCW2*XSW2**2-4D0*QF(2)*QF(3)*S24*XCW2*XSW2**
     &  2+8D0*QF(2)*QF(3)*PZ12*PZ34*S12**2*S34*XCW2*XSW2**2+8D0*
     &  QF(2)*QF(3)*PZ34*S13*S34*XCW2*XSW2**2-4D0*QF(2)*QF(3)*PZ12*
     &  PZ34*S12*S13*S34*XCW2*XSW2**2+8D0*QF(2)*QF(3)*PZ34*S14*S34*
     &  XCW2*XSW2**2-4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S14*S34*XCW2*
     &  XSW2**2+8D0*QF(2)*QF(3)*PZ34*S23*S34*XCW2*XSW2**2-4D0*QF(2)*
     &  QF(3)*PZ12*PZ34*S12*S23*S34*XCW2*XSW2**2+8D0*QF(2)*QF(3)*
     &  PZ34*S24*S34*XCW2*XSW2**2-4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S24*
     &  S34*XCW2*XSW2**2-8D0*QF(2)*QF(3)*PZ12*S12**2*XSW2**3-4D0*
     &  QF(2)*QF(3)*PZ12*S12*S13*XSW2**3-4D0*QF(2)*QF(3)*PZ12*S12*
     &  S14*XSW2**3-4D0*QF(2)*QF(3)*PZ12*S12*S23*XSW2**3-4D0*QF(2)*
     &  QF(3)*PZ12*S12*S24*XSW2**3+8D0*QF(2)*QF(3)*PZ34*S12*S34*
     &  XSW2**3+4D0*QF(2)*QF(3)*PZ34*S13*S34*XSW2**3+4D0*QF(2)*
     &  QF(3)*PZ34*S14*S34*XSW2**3+4D0*QF(2)*QF(3)*PZ34*S23*S34*
     &  XSW2**3+4D0*QF(2)*QF(3)*PZ34*S24*S34*XSW2**3))/(S12*S34)+
     &  (C1(2)*XMW*(PZ12*PZ34*S12*S13*S34*XCW2+PZ12*PZ34*S12*S14*
     &  S34*XCW2+PZ12*PZ34*S12*S23*S34*XCW2+PZ12*PZ34*S12*S24*S34*
     &  XCW2-2D0*PZ12*PZ34*S12*S34**2*XCW2-4D0*QF(3)*PZ12*S12*S13*
     &  XCW2*XSW2-4D0*QF(3)*PZ12*S12*S14*XCW2*XSW2-4D0*QF(3)*PZ12*
     &  S12*S23*XCW2*XSW2-4D0*QF(3)*PZ12*S12*S24*XCW2*XSW2+2D0*
     &  QF(2)*PZ12*PZ34*S12*S13*S34*XCW2*XSW2+2D0*QF(3)*PZ12*PZ34*
     &  S12*S13*S34*XCW2*XSW2+2D0*QF(2)*PZ12*PZ34*S12*S14*S34*XCW2*
     &  XSW2+2D0*QF(3)*PZ12*PZ34*S12*S14*S34*XCW2*XSW2+2D0*QF(2)*
     &  PZ12*PZ34*S12*S23*S34*XCW2*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S23*
     &  S34*XCW2*XSW2+2D0*QF(2)*PZ12*PZ34*S12*S24*S34*XCW2*XSW2+2D0*
     &  QF(3)*PZ12*PZ34*S12*S24*S34*XCW2*XSW2+8D0*QF(2)*PZ34*S34**2*
     &  XCW2*XSW2-4D0*QF(2)*PZ12*PZ34*S12*S34**2*XCW2*XSW2-4D0*
     &  QF(3)*PZ12*PZ34*S12*S34**2*XCW2*XSW2-2D0*QF(3)*PZ12*S12*S13*
     &  XSW2**2-2D0*QF(3)*PZ12*S12*S14*XSW2**2-2D0*QF(3)*PZ12*S12*
     &  S23*XSW2**2-2D0*QF(3)*PZ12*S12*S24*XSW2**2-4D0*QF(3)*PZ12*
     &  S12*S34*XSW2**2+2D0*QF(2)*PZ34*S13*S34*XSW2**2+2D0*QF(2)*
     &  PZ34*S14*S34*XSW2**2+2D0*QF(2)*PZ34*S23*S34*XSW2**2+2D0*
     &  QF(2)*PZ34*S24*S34*XSW2**2+4D0*QF(2)*PZ34*S34**2*XSW2**2+
     &  4D0*QF(2)*QF(3)*S13*XCW2*XSW2**2-8D0*QF(2)*QF(3)*PZ12*S12*
     &  S13*XCW2*XSW2**2+4D0*QF(2)*QF(3)*S14*XCW2*XSW2**2-8D0*QF(2)*
     &  QF(3)*PZ12*S12*S14*XCW2*XSW2**2+4D0*QF(2)*QF(3)*S23*XCW2*
     &  XSW2**2-8D0*QF(2)*QF(3)*PZ12*S12*S23*XCW2*XSW2**2+4D0*QF(2)*
     &  QF(3)*S24*XCW2*XSW2**2-8D0*QF(2)*QF(3)*PZ12*S12*S24*XCW2*
     &  XSW2**2-8D0*QF(2)*QF(3)*S34*XCW2*XSW2**2+4D0*QF(2)*QF(3)*
     &  PZ12*PZ34*S12*S13*S34*XCW2*XSW2**2+4D0*QF(2)*QF(3)*PZ12*
     &  PZ34*S12*S14*S34*XCW2*XSW2**2+4D0*QF(2)*QF(3)*PZ12*PZ34*S12*
     &  S23*S34*XCW2*XSW2**2+4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S24*S34*
     &  XCW2*XSW2**2+16D0*QF(2)*QF(3)*PZ34*S34**2*XCW2*XSW2**2-8D0*
     &  QF(2)*QF(3)*PZ12*PZ34*S12*S34**2*XCW2*XSW2**2-4D0*QF(2)*
     &  QF(3)*PZ12*S12*S13*XSW2**3-4D0*QF(2)*QF(3)*PZ12*S12*S14*
     &  XSW2**3-4D0*QF(2)*QF(3)*PZ12*S12*S23*XSW2**3-4D0*QF(2)*
     &  QF(3)*PZ12*S12*S24*XSW2**3-8D0*QF(2)*QF(3)*PZ12*S12*S34*
     &  XSW2**3+4D0*QF(2)*QF(3)*PZ34*S13*S34*XSW2**3+4D0*QF(2)*
     &  QF(3)*PZ34*S14*S34*XSW2**3+4D0*QF(2)*QF(3)*PZ34*S23*S34*
     &  XSW2**3+4D0*QF(2)*QF(3)*PZ34*S24*S34*XSW2**3+8D0*QF(2)*
     &  QF(3)*PZ34*S34**2*XSW2**3))/(S12*S34)+(C0*XMW*(5D0*PZ12*
     &  PZ34*S12*S13*S34*XCW2**2+5D0*PZ12*PZ34*S12*S14*S34*XCW2**2+
     &  5D0*PZ12*PZ34*S12*S23*S34*XCW2**2+5D0*PZ12*PZ34*S12*S24*S34*
     &  XCW2**2-PZ12*PZ34*S12*S14*S34*XCW2*XSW2-PZ12*PZ34*S12*S23*
     &  S34*XCW2*XSW2-2D0*PZ12*PZ34*S12*S24*S34*XCW2*XSW2-PZ12*PZ34*
     &  S12*S34*T12*XCW2*XSW2-PZ12*PZ34*S12*S34*T14*XCW2*XSW2-10D0*
     &  QF(3)*PZ12*S12*S13*XCW2**2*XSW2-12D0*QF(3)*PZ12*S12*S14*
     &  XCW2**2*XSW2-10D0*QF(3)*PZ12*S12*S23*XCW2**2*XSW2-12D0*
     &  QF(3)*PZ12*S12*S24*XCW2**2*XSW2-10D0*QF(2)*PZ34*S13*S34*
     &  XCW2**2*XSW2+10D0*QF(2)*PZ12*PZ34*S12*S13*S34*XCW2**2*XSW2+
     &  10D0*QF(3)*PZ12*PZ34*S12*S13*S34*XCW2**2*XSW2-10D0*QF(2)*
     &  PZ34*S14*S34*XCW2**2*XSW2+10D0*QF(2)*PZ12*PZ34*S12*S14*S34*
     &  XCW2**2*XSW2+10D0*QF(3)*PZ12*PZ34*S12*S14*S34*XCW2**2*XSW2-
     &  12D0*QF(2)*PZ34*S23*S34*XCW2**2*XSW2+10D0*QF(2)*PZ12*PZ34*
     &  S12*S23*S34*XCW2**2*XSW2+10D0*QF(3)*PZ12*PZ34*S12*S23*S34*
     &  XCW2**2*XSW2-12D0*QF(2)*PZ34*S24*S34*XCW2**2*XSW2+10D0*
     &  QF(2)*PZ12*PZ34*S12*S24*S34*XCW2**2*XSW2+10D0*QF(3)*PZ12*
     &  PZ34*S12*S24*S34*XCW2**2*XSW2-2D0*QF(2)*PZ34*S34*T12*XCW2**
     &  2*XSW2-2D0*QF(3)*PZ12*S12*T14*XCW2**2*XSW2+2D0*QF(3)*PZ12*
     &  S12*S23*XCW2*XSW2**2+2D0*QF(3)*PZ12*S12*S24*XCW2*XSW2**2+
     &  2D0*QF(2)*PZ34*S14*S34*XCW2*XSW2**2-2D0*QF(2)*PZ12*PZ34*S12*
     &  S14*S34*XCW2*XSW2**2-2D0*QF(3)*PZ12*PZ34*S12*S14*S34*XCW2*
     &  XSW2**2-2D0*QF(2)*PZ12*PZ34*S12*S23*S34*XCW2*XSW2**2-2D0*
     &  QF(3)*PZ12*PZ34*S12*S23*S34*XCW2*XSW2**2+2D0*QF(2)*PZ34*S24*
     &  S34*XCW2*XSW2**2-4D0*QF(2)*PZ12*PZ34*S12*S24*S34*XCW2*XSW2**
     &  2-4D0*QF(3)*PZ12*PZ34*S12*S24*S34*XCW2*XSW2**2+2D0*QF(3)*
     &  PZ12*S12*T12*XCW2*XSW2**2-2D0*QF(2)*PZ12*PZ34*S12*S34*T12*
     &  XCW2*XSW2**2-2D0*QF(3)*PZ12*PZ34*S12*S34*T12*XCW2*XSW2**2+
     &  2D0*QF(2)*PZ34*S34*T14*XCW2*XSW2**2-2D0*QF(2)*PZ12*PZ34*S12*
     &  S34*T14*XCW2*XSW2**2-2D0*QF(3)*PZ12*PZ34*S12*S34*T14*XCW2*
     &  XSW2**2+20D0*QF(2)*QF(3)*S13*XCW2**2*XSW2**2-20D0*QF(2)*
     &  QF(3)*PZ12*S12*S13*XCW2**2*XSW2**2+24D0*QF(2)*QF(3)*S14*
     &  XCW2**2*XSW2**2-24D0*QF(2)*QF(3)*PZ12*S12*S14*XCW2**2*XSW2**
     &  2+24D0*QF(2)*QF(3)*S23*XCW2**2*XSW2**2-20D0*QF(2)*QF(3)*
     &  PZ12*S12*S23*XCW2**2*XSW2**2+28D0*QF(2)*QF(3)*S24*XCW2**2*
     &  XSW2**2-24D0*QF(2)*QF(3)*PZ12*S12*S24*XCW2**2*XSW2**2-20D0*
     &  QF(2)*QF(3)*PZ34*S13*S34*XCW2**2*XSW2**2+20D0*QF(2)*QF(3)*
     &  PZ12*PZ34*S12*S13*S34*XCW2**2*XSW2**2-20D0*QF(2)*QF(3)*PZ34*
     &  S14*S34*XCW2**2*XSW2**2+20D0*QF(2)*QF(3)*PZ12*PZ34*S12*S14*
     &  S34*XCW2**2*XSW2**2-24D0*QF(2)*QF(3)*PZ34*S23*S34*XCW2**2*
     &  XSW2**2+20D0*QF(2)*QF(3)*PZ12*PZ34*S12*S23*S34*XCW2**2*
     &  XSW2**2-24D0*QF(2)*QF(3)*PZ34*S24*S34*XCW2**2*XSW2**2+20D0*
     &  QF(2)*QF(3)*PZ12*PZ34*S12*S24*S34*XCW2**2*XSW2**2+4D0*QF(2)*
     &  QF(3)*T12*XCW2**2*XSW2**2-4D0*QF(2)*QF(3)*PZ34*S34*T12*
     &  XCW2**2*XSW2**2+4D0*QF(2)*QF(3)*T14*XCW2**2*XSW2**2-4D0*
     &  QF(2)*QF(3)*PZ12*S12*T14*XCW2**2*XSW2**2+PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**2+2D0*QF(3)*PZ12*S12*XCW2*XMH2*XSW2**2+2D0*QF(2)*
     &  PZ34*S34*XCW2*XMH2*XSW2**2+4D0*QF(2)*QF(3)*XCW2**2*XMH2*
     &  XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2+4D0*QF(3)*PZ12*
     &  S12*XCW2*XMW2*XSW2**2+4D0*QF(2)*PZ34*S34*XCW2*XMW2*XSW2**2+
     &  8D0*QF(2)*QF(3)*XCW2**2*XMW2*XSW2**2+4D0*QF(2)*QF(3)*PZ12*
     &  S12*S23*XCW2*XSW2**3+4D0*QF(2)*QF(3)*PZ12*S12*S24*XCW2*
     &  XSW2**3+4D0*QF(2)*QF(3)*PZ34*S14*S34*XCW2*XSW2**3-4D0*QF(2)*
     &  QF(3)*PZ12*PZ34*S12*S14*S34*XCW2*XSW2**3-4D0*QF(2)*QF(3)*
     &  PZ12*PZ34*S12*S23*S34*XCW2*XSW2**3+4D0*QF(2)*QF(3)*PZ34*S24*
     &  S34*XCW2*XSW2**3-8D0*QF(2)*QF(3)*PZ12*PZ34*S12*S24*S34*XCW2*
     &  XSW2**3+4D0*QF(2)*QF(3)*PZ12*S12*T12*XCW2*XSW2**3-4D0*QF(2)*
     &  QF(3)*PZ12*PZ34*S12*S34*T12*XCW2*XSW2**3+4D0*QF(2)*QF(3)*
     &  PZ34*S34*T14*XCW2*XSW2**3-4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*
     &  T14*XCW2*XSW2**3+2D0*QF(2)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+
     &  2D0*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+4D0*QF(2)*QF(3)*
     &  PZ12*S12*XCW2*XMH2*XSW2**3+4D0*QF(2)*QF(3)*PZ34*S34*XCW2*
     &  XMH2*XSW2**3+4D0*QF(2)*PZ12*PZ34*S12*S34*XMW2*XSW2**3+4D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**3+8D0*QF(2)*QF(3)*PZ12*
     &  S12*XCW2*XMW2*XSW2**3+8D0*QF(2)*QF(3)*PZ34*S34*XCW2*XMW2*
     &  XSW2**3+4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**4+8D0*
     &  QF(2)*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**4))/(S12*S34*XCW2)-
     &  (C2(0,0)*(PZ12*PZ34*S12*S34*XCW2**2*XMH2+34D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2-2D0*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2-4D0*
     &  QF(3)*PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(2)*PZ34*S34*XCW2**2*
     &  XMH2*XSW2+2D0*QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+2D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+4D0*PZ12*PZ34*S12*
     &  S34*XCW2*XMW2*XSW2-64D0*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2-
     &  64D0*QF(2)*PZ34*S34*XCW2**2*XMW2*XSW2+68D0*QF(2)*PZ12*PZ34*
     &  S12*S34*XCW2**2*XMW2*XSW2+68D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*XMH2*XSW2**2+4D0*QF(3)*
     &  PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(2)*PZ34*S34*XCW2*XMH2*
     &  XSW2**2-4D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2-4D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2+16D0*QF(2)*QF(3)*
     &  XCW2**2*XMH2*XSW2**2-8D0*QF(2)*QF(3)*PZ12*S12*XCW2**2*XMH2*
     &  XSW2**2-8D0*QF(2)*QF(3)*PZ34*S34*XCW2**2*XMH2*XSW2**2+4D0*
     &  QF(2)*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2**2+2D0*PZ12*
     &  PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*
     &  XMW2*XSW2**2+8D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2**2+
     &  128D0*QF(2)*QF(3)*XCW2**2*XMW2*XSW2**2-128D0*QF(2)*QF(3)*
     &  PZ12*S12*XCW2**2*XMW2*XSW2**2-128D0*QF(2)*QF(3)*PZ34*S34*
     &  XCW2**2*XMW2*XSW2**2+136D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2**2*XMW2*XSW2**2+2D0*QF(2)*PZ12*PZ34*S12*S34*XMH2*XSW2**
     &  3+2D0*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+8D0*QF(2)*QF(3)*
     &  PZ12*S12*XCW2*XMH2*XSW2**3+8D0*QF(2)*QF(3)*PZ34*S34*XCW2*
     &  XMH2*XSW2**3-8D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XCW2*XMH2*
     &  XSW2**3+4D0*QF(2)*PZ12*PZ34*S12*S34*XMW2*XSW2**3+4D0*QF(3)*
     &  PZ12*PZ34*S12*S34*XMW2*XSW2**3+16D0*QF(2)*QF(3)*PZ12*PZ34*
     &  S12*S34*XCW2*XMW2*XSW2**3+4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**4+8D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**
     &  4))/(S12*S34*XCW2*XMW))
        F(1,-1,1) = F(1,-1,1)+(QF(3)*PRE*(-((2D0*C2(2,2)*K(11)*XMW)/
     &  S12)-(2D0*C2(1,1)*K(11)*XMW)/S34+(2D0*C2(1,2)*K(11)*K(4)*
     &  XMW)/(S12*S34)+(XMW*(-(11D0*PZ12*S12*XCW2)+12D0*PZ12*PZ34*
     &  S12*S34*XCW2-PZ12*S12*XSW2+2D0*PZ12*PZ34*S12*S34*XSW2+20D0*
     &  QF(2)*XCW2*XSW2-22D0*QF(2)*PZ12*S12*XCW2*XSW2-22D0*QF(2)*
     &  PZ34*S34*XCW2*XSW2+24D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*XSW2-
     &  2D0*QF(2)*PZ12*S12*XSW2**2-2D0*QF(2)*PZ34*S34*XSW2**2+4D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XSW2**2))/(S12*S34)-(2D0*C1(1)*XMW*
     &  (-(4D0*PZ12*S12**2*XCW2)+2D0*PZ12*PZ34*S12**2*S34*XCW2-PZ12*
     &  PZ34*S12*S13*S34*XCW2-PZ12*PZ34*S12*S14*S34*XCW2-PZ12*PZ34*
     &  S12*S23*S34*XCW2-PZ12*PZ34*S12*S24*S34*XCW2-2D0*PZ12*S12**2*
     &  XSW2-PZ12*S12*S13*XSW2-PZ12*S12*S14*XSW2-PZ12*S12*S23*XSW2-
     &  PZ12*S12*S24*XSW2+4D0*QF(2)*S12*XCW2*XSW2-8D0*QF(2)*PZ12*
     &  S12**2*XCW2*XSW2-2D0*QF(2)*S13*XCW2*XSW2-2D0*QF(2)*S14*XCW2*
     &  XSW2-2D0*QF(2)*S23*XCW2*XSW2-2D0*QF(2)*S24*XCW2*XSW2+4D0*
     &  QF(2)*PZ12*PZ34*S12**2*S34*XCW2*XSW2+4D0*QF(2)*PZ34*S13*S34*
     &  XCW2*XSW2-2D0*QF(2)*PZ12*PZ34*S12*S13*S34*XCW2*XSW2+4D0*
     &  QF(2)*PZ34*S14*S34*XCW2*XSW2-2D0*QF(2)*PZ12*PZ34*S12*S14*
     &  S34*XCW2*XSW2+4D0*QF(2)*PZ34*S23*S34*XCW2*XSW2-2D0*QF(2)*
     &  PZ12*PZ34*S12*S23*S34*XCW2*XSW2+4D0*QF(2)*PZ34*S24*S34*XCW2*
     &  XSW2-2D0*QF(2)*PZ12*PZ34*S12*S24*S34*XCW2*XSW2-4D0*QF(2)*
     &  PZ12*S12**2*XSW2**2-2D0*QF(2)*PZ12*S12*S13*XSW2**2-2D0*
     &  QF(2)*PZ12*S12*S14*XSW2**2-2D0*QF(2)*PZ12*S12*S23*XSW2**2-
     &  2D0*QF(2)*PZ12*S12*S24*XSW2**2+4D0*QF(2)*PZ34*S12*S34*XSW2**
     &  2+2D0*QF(2)*PZ34*S13*S34*XSW2**2+2D0*QF(2)*PZ34*S14*S34*
     &  XSW2**2+2D0*QF(2)*PZ34*S23*S34*XSW2**2+2D0*QF(2)*PZ34*S24*
     &  S34*XSW2**2))/(S12*S34)+(2D0*C1(2)*XMW*(-(2D0*PZ12*S12*S13*
     &  XCW2)-2D0*PZ12*S12*S14*XCW2-2D0*PZ12*S12*S23*XCW2-2D0*PZ12*
     &  S12*S24*XCW2+PZ12*PZ34*S12*S13*S34*XCW2+PZ12*PZ34*S12*S14*
     &  S34*XCW2+PZ12*PZ34*S12*S23*S34*XCW2+PZ12*PZ34*S12*S24*S34*
     &  XCW2-2D0*PZ12*PZ34*S12*S34**2*XCW2-PZ12*S12*S13*XSW2-PZ12*
     &  S12*S14*XSW2-PZ12*S12*S23*XSW2-PZ12*S12*S24*XSW2-2D0*PZ12*
     &  S12*S34*XSW2+2D0*QF(2)*S13*XCW2*XSW2-4D0*QF(2)*PZ12*S12*S13*
     &  XCW2*XSW2+2D0*QF(2)*S14*XCW2*XSW2-4D0*QF(2)*PZ12*S12*S14*
     &  XCW2*XSW2+2D0*QF(2)*S23*XCW2*XSW2-4D0*QF(2)*PZ12*S12*S23*
     &  XCW2*XSW2+2D0*QF(2)*S24*XCW2*XSW2-4D0*QF(2)*PZ12*S12*S24*
     &  XCW2*XSW2-4D0*QF(2)*S34*XCW2*XSW2+2D0*QF(2)*PZ12*PZ34*S12*
     &  S13*S34*XCW2*XSW2+2D0*QF(2)*PZ12*PZ34*S12*S14*S34*XCW2*XSW2+
     &  2D0*QF(2)*PZ12*PZ34*S12*S23*S34*XCW2*XSW2+2D0*QF(2)*PZ12*
     &  PZ34*S12*S24*S34*XCW2*XSW2+8D0*QF(2)*PZ34*S34**2*XCW2*XSW2-
     &  4D0*QF(2)*PZ12*PZ34*S12*S34**2*XCW2*XSW2-2D0*QF(2)*PZ12*S12*
     &  S13*XSW2**2-2D0*QF(2)*PZ12*S12*S14*XSW2**2-2D0*QF(2)*PZ12*
     &  S12*S23*XSW2**2-2D0*QF(2)*PZ12*S12*S24*XSW2**2-4D0*QF(2)*
     &  PZ12*S12*S34*XSW2**2+2D0*QF(2)*PZ34*S13*S34*XSW2**2+2D0*
     &  QF(2)*PZ34*S14*S34*XSW2**2+2D0*QF(2)*PZ34*S23*S34*XSW2**2+
     &  2D0*QF(2)*PZ34*S24*S34*XSW2**2+4D0*QF(2)*PZ34*S34**2*XSW2**
     &  2))/(S12*S34)+(2D0*C0*XMW*(-(5D0*PZ12*S12*S13*XCW2**2)-6D0*
     &  PZ12*S12*S14*XCW2**2-5D0*PZ12*S12*S23*XCW2**2-6D0*PZ12*S12*
     &  S24*XCW2**2+5D0*PZ12*PZ34*S12*S13*S34*XCW2**2+5D0*PZ12*PZ34*
     &  S12*S14*S34*XCW2**2+5D0*PZ12*PZ34*S12*S23*S34*XCW2**2+5D0*
     &  PZ12*PZ34*S12*S24*S34*XCW2**2-PZ12*S12*T14*XCW2**2+PZ12*S12*
     &  S23*XCW2*XSW2+PZ12*S12*S24*XCW2*XSW2-PZ12*PZ34*S12*S14*S34*
     &  XCW2*XSW2-PZ12*PZ34*S12*S23*S34*XCW2*XSW2-2D0*PZ12*PZ34*S12*
     &  S24*S34*XCW2*XSW2+PZ12*S12*T12*XCW2*XSW2-PZ12*PZ34*S12*S34*
     &  T12*XCW2*XSW2-PZ12*PZ34*S12*S34*T14*XCW2*XSW2+10D0*QF(2)*
     &  S13*XCW2**2*XSW2-10D0*QF(2)*PZ12*S12*S13*XCW2**2*XSW2+12D0*
     &  QF(2)*S14*XCW2**2*XSW2-12D0*QF(2)*PZ12*S12*S14*XCW2**2*XSW2+
     &  12D0*QF(2)*S23*XCW2**2*XSW2-10D0*QF(2)*PZ12*S12*S23*XCW2**2*
     &  XSW2+14D0*QF(2)*S24*XCW2**2*XSW2-12D0*QF(2)*PZ12*S12*S24*
     &  XCW2**2*XSW2-10D0*QF(2)*PZ34*S13*S34*XCW2**2*XSW2+10D0*
     &  QF(2)*PZ12*PZ34*S12*S13*S34*XCW2**2*XSW2-10D0*QF(2)*PZ34*
     &  S14*S34*XCW2**2*XSW2+10D0*QF(2)*PZ12*PZ34*S12*S14*S34*XCW2**
     &  2*XSW2-12D0*QF(2)*PZ34*S23*S34*XCW2**2*XSW2+10D0*QF(2)*PZ12*
     &  PZ34*S12*S23*S34*XCW2**2*XSW2-12D0*QF(2)*PZ34*S24*S34*XCW2**
     &  2*XSW2+10D0*QF(2)*PZ12*PZ34*S12*S24*S34*XCW2**2*XSW2+2D0*
     &  QF(2)*T12*XCW2**2*XSW2-2D0*QF(2)*PZ34*S34*T12*XCW2**2*XSW2+
     &  2D0*QF(2)*T14*XCW2**2*XSW2-2D0*QF(2)*PZ12*S12*T14*XCW2**2*
     &  XSW2+PZ12*S12*XCW2*XMH2*XSW2+2D0*QF(2)*XCW2**2*XMH2*XSW2+
     &  2D0*PZ12*S12*XCW2*XMW2*XSW2+4D0*QF(2)*XCW2**2*XMW2*XSW2+2D0*
     &  QF(2)*PZ12*S12*S23*XCW2*XSW2**2+2D0*QF(2)*PZ12*S12*S24*XCW2*
     &  XSW2**2+2D0*QF(2)*PZ34*S14*S34*XCW2*XSW2**2-2D0*QF(2)*PZ12*
     &  PZ34*S12*S14*S34*XCW2*XSW2**2-2D0*QF(2)*PZ12*PZ34*S12*S23*
     &  S34*XCW2*XSW2**2+2D0*QF(2)*PZ34*S24*S34*XCW2*XSW2**2-4D0*
     &  QF(2)*PZ12*PZ34*S12*S24*S34*XCW2*XSW2**2+2D0*QF(2)*PZ12*S12*
     &  T12*XCW2*XSW2**2-2D0*QF(2)*PZ12*PZ34*S12*S34*T12*XCW2*XSW2**
     &  2+2D0*QF(2)*PZ34*S34*T14*XCW2*XSW2**2-2D0*QF(2)*PZ12*PZ34*
     &  S12*S34*T14*XCW2*XSW2**2+PZ12*PZ34*S12*S34*XMH2*XSW2**2+2D0*
     &  QF(2)*PZ12*S12*XCW2*XMH2*XSW2**2+2D0*QF(2)*PZ34*S34*XCW2*
     &  XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2+4D0*QF(2)*
     &  PZ12*S12*XCW2*XMW2*XSW2**2+4D0*QF(2)*PZ34*S34*XCW2*XMW2*
     &  XSW2**2+2D0*QF(2)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+4D0*QF(2)*
     &  PZ12*PZ34*S12*S34*XMW2*XSW2**3))/(S12*S34*XCW2)-(2D0*C2(0,
     &  0)*(-(2D0*PZ12*S12*XCW2**2*XMH2)+PZ12*PZ34*S12*S34*XCW2**2*
     &  XMH2-32D0*PZ12*S12*XCW2**2*XMW2+34D0*PZ12*PZ34*S12*S34*
     &  XCW2**2*XMW2+2D0*PZ12*S12*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*S12*
     &  S34*XCW2*XMH2*XSW2+8D0*QF(2)*XCW2**2*XMH2*XSW2-4D0*QF(2)*
     &  PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(2)*PZ34*S34*XCW2**2*XMH2*
     &  XSW2+2D0*QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+4D0*PZ12*
     &  PZ34*S12*S34*XCW2*XMW2*XSW2+64D0*QF(2)*XCW2**2*XMW2*XSW2-
     &  64D0*QF(2)*PZ12*S12*XCW2**2*XMW2*XSW2-64D0*QF(2)*PZ34*S34*
     &  XCW2**2*XMW2*XSW2+68D0*QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMW2*
     &  XSW2+PZ12*PZ34*S12*S34*XMH2*XSW2**2+4D0*QF(2)*PZ12*S12*XCW2*
     &  XMH2*XSW2**2+4D0*QF(2)*PZ34*S34*XCW2*XMH2*XSW2**2-4D0*QF(2)*
     &  PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*
     &  XMW2*XSW2**2+8D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2**2+
     &  2D0*QF(2)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+4D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XMW2*XSW2**3))/(S12*S34*XCW2*XMW)))/XSW2
        F(1,1,-1) = F(1,1,-1)+(QF(2)*PRE*(-((2D0*C2(2,2)*K(13)*XMW)/
     &  S12)-(2D0*C2(1,1)*K(13)*XMW)/S34+(2D0*C2(1,2)*K(13)*K(4)*
     &  XMW)/(S12*S34)+(XMW*(-(11D0*PZ34*S34*XCW2)+12D0*PZ12*PZ34*
     &  S12*S34*XCW2-PZ34*S34*XSW2+2D0*PZ12*PZ34*S12*S34*XSW2+20D0*
     &  QF(3)*XCW2*XSW2-22D0*QF(3)*PZ12*S12*XCW2*XSW2-22D0*QF(3)*
     &  PZ34*S34*XCW2*XSW2+24D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*XSW2-
     &  2D0*QF(3)*PZ12*S12*XSW2**2-2D0*QF(3)*PZ34*S34*XSW2**2+4D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XSW2**2))/(S12*S34)-(2D0*C1(1)*XMW*
     &  (2D0*PZ12*PZ34*S12**2*S34*XCW2+2D0*PZ34*S13*S34*XCW2-PZ12*
     &  PZ34*S12*S13*S34*XCW2+2D0*PZ34*S14*S34*XCW2-PZ12*PZ34*S12*
     &  S14*S34*XCW2+2D0*PZ34*S23*S34*XCW2-PZ12*PZ34*S12*S23*S34*
     &  XCW2+2D0*PZ34*S24*S34*XCW2-PZ12*PZ34*S12*S24*S34*XCW2+2D0*
     &  PZ34*S12*S34*XSW2+PZ34*S13*S34*XSW2+PZ34*S14*S34*XSW2+PZ34*
     &  S23*S34*XSW2+PZ34*S24*S34*XSW2+4D0*QF(3)*S12*XCW2*XSW2-8D0*
     &  QF(3)*PZ12*S12**2*XCW2*XSW2-2D0*QF(3)*S13*XCW2*XSW2-2D0*
     &  QF(3)*S14*XCW2*XSW2-2D0*QF(3)*S23*XCW2*XSW2-2D0*QF(3)*S24*
     &  XCW2*XSW2+4D0*QF(3)*PZ12*PZ34*S12**2*S34*XCW2*XSW2+4D0*
     &  QF(3)*PZ34*S13*S34*XCW2*XSW2-2D0*QF(3)*PZ12*PZ34*S12*S13*
     &  S34*XCW2*XSW2+4D0*QF(3)*PZ34*S14*S34*XCW2*XSW2-2D0*QF(3)*
     &  PZ12*PZ34*S12*S14*S34*XCW2*XSW2+4D0*QF(3)*PZ34*S23*S34*XCW2*
     &  XSW2-2D0*QF(3)*PZ12*PZ34*S12*S23*S34*XCW2*XSW2+4D0*QF(3)*
     &  PZ34*S24*S34*XCW2*XSW2-2D0*QF(3)*PZ12*PZ34*S12*S24*S34*XCW2*
     &  XSW2-4D0*QF(3)*PZ12*S12**2*XSW2**2-2D0*QF(3)*PZ12*S12*S13*
     &  XSW2**2-2D0*QF(3)*PZ12*S12*S14*XSW2**2-2D0*QF(3)*PZ12*S12*
     &  S23*XSW2**2-2D0*QF(3)*PZ12*S12*S24*XSW2**2+4D0*QF(3)*PZ34*
     &  S12*S34*XSW2**2+2D0*QF(3)*PZ34*S13*S34*XSW2**2+2D0*QF(3)*
     &  PZ34*S14*S34*XSW2**2+2D0*QF(3)*PZ34*S23*S34*XSW2**2+2D0*
     &  QF(3)*PZ34*S24*S34*XSW2**2))/(S12*S34)+(2D0*C1(2)*XMW*(PZ12*
     &  PZ34*S12*S13*S34*XCW2+PZ12*PZ34*S12*S14*S34*XCW2+PZ12*PZ34*
     &  S12*S23*S34*XCW2+PZ12*PZ34*S12*S24*S34*XCW2+4D0*PZ34*S34**2*
     &  XCW2-2D0*PZ12*PZ34*S12*S34**2*XCW2+PZ34*S13*S34*XSW2+PZ34*
     &  S14*S34*XSW2+PZ34*S23*S34*XSW2+PZ34*S24*S34*XSW2+2D0*PZ34*
     &  S34**2*XSW2+2D0*QF(3)*S13*XCW2*XSW2-4D0*QF(3)*PZ12*S12*S13*
     &  XCW2*XSW2+2D0*QF(3)*S14*XCW2*XSW2-4D0*QF(3)*PZ12*S12*S14*
     &  XCW2*XSW2+2D0*QF(3)*S23*XCW2*XSW2-4D0*QF(3)*PZ12*S12*S23*
     &  XCW2*XSW2+2D0*QF(3)*S24*XCW2*XSW2-4D0*QF(3)*PZ12*S12*S24*
     &  XCW2*XSW2-4D0*QF(3)*S34*XCW2*XSW2+2D0*QF(3)*PZ12*PZ34*S12*
     &  S13*S34*XCW2*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S14*S34*XCW2*XSW2+
     &  2D0*QF(3)*PZ12*PZ34*S12*S23*S34*XCW2*XSW2+2D0*QF(3)*PZ12*
     &  PZ34*S12*S24*S34*XCW2*XSW2+8D0*QF(3)*PZ34*S34**2*XCW2*XSW2-
     &  4D0*QF(3)*PZ12*PZ34*S12*S34**2*XCW2*XSW2-2D0*QF(3)*PZ12*S12*
     &  S13*XSW2**2-2D0*QF(3)*PZ12*S12*S14*XSW2**2-2D0*QF(3)*PZ12*
     &  S12*S23*XSW2**2-2D0*QF(3)*PZ12*S12*S24*XSW2**2-4D0*QF(3)*
     &  PZ12*S12*S34*XSW2**2+2D0*QF(3)*PZ34*S13*S34*XSW2**2+2D0*
     &  QF(3)*PZ34*S14*S34*XSW2**2+2D0*QF(3)*PZ34*S23*S34*XSW2**2+
     &  2D0*QF(3)*PZ34*S24*S34*XSW2**2+4D0*QF(3)*PZ34*S34**2*XSW2**
     &  2))/(S12*S34)+(2D0*C0*XMW*(-(5D0*PZ34*S13*S34*XCW2**2)+5D0*
     &  PZ12*PZ34*S12*S13*S34*XCW2**2-5D0*PZ34*S14*S34*XCW2**2+5D0*
     &  PZ12*PZ34*S12*S14*S34*XCW2**2-6D0*PZ34*S23*S34*XCW2**2+5D0*
     &  PZ12*PZ34*S12*S23*S34*XCW2**2-6D0*PZ34*S24*S34*XCW2**2+5D0*
     &  PZ12*PZ34*S12*S24*S34*XCW2**2-PZ34*S34*T12*XCW2**2+PZ34*S14*
     &  S34*XCW2*XSW2-PZ12*PZ34*S12*S14*S34*XCW2*XSW2-PZ12*PZ34*S12*
     &  S23*S34*XCW2*XSW2+PZ34*S24*S34*XCW2*XSW2-2D0*PZ12*PZ34*S12*
     &  S24*S34*XCW2*XSW2-PZ12*PZ34*S12*S34*T12*XCW2*XSW2+PZ34*S34*
     &  T14*XCW2*XSW2-PZ12*PZ34*S12*S34*T14*XCW2*XSW2+10D0*QF(3)*
     &  S13*XCW2**2*XSW2-10D0*QF(3)*PZ12*S12*S13*XCW2**2*XSW2+12D0*
     &  QF(3)*S14*XCW2**2*XSW2-12D0*QF(3)*PZ12*S12*S14*XCW2**2*XSW2+
     &  12D0*QF(3)*S23*XCW2**2*XSW2-10D0*QF(3)*PZ12*S12*S23*XCW2**2*
     &  XSW2+14D0*QF(3)*S24*XCW2**2*XSW2-12D0*QF(3)*PZ12*S12*S24*
     &  XCW2**2*XSW2-10D0*QF(3)*PZ34*S13*S34*XCW2**2*XSW2+10D0*
     &  QF(3)*PZ12*PZ34*S12*S13*S34*XCW2**2*XSW2-10D0*QF(3)*PZ34*
     &  S14*S34*XCW2**2*XSW2+10D0*QF(3)*PZ12*PZ34*S12*S14*S34*XCW2**
     &  2*XSW2-12D0*QF(3)*PZ34*S23*S34*XCW2**2*XSW2+10D0*QF(3)*PZ12*
     &  PZ34*S12*S23*S34*XCW2**2*XSW2-12D0*QF(3)*PZ34*S24*S34*XCW2**
     &  2*XSW2+10D0*QF(3)*PZ12*PZ34*S12*S24*S34*XCW2**2*XSW2+2D0*
     &  QF(3)*T12*XCW2**2*XSW2-2D0*QF(3)*PZ34*S34*T12*XCW2**2*XSW2+
     &  2D0*QF(3)*T14*XCW2**2*XSW2-2D0*QF(3)*PZ12*S12*T14*XCW2**2*
     &  XSW2+PZ34*S34*XCW2*XMH2*XSW2+2D0*QF(3)*XCW2**2*XMH2*XSW2+
     &  2D0*PZ34*S34*XCW2*XMW2*XSW2+4D0*QF(3)*XCW2**2*XMW2*XSW2+2D0*
     &  QF(3)*PZ12*S12*S23*XCW2*XSW2**2+2D0*QF(3)*PZ12*S12*S24*XCW2*
     &  XSW2**2+2D0*QF(3)*PZ34*S14*S34*XCW2*XSW2**2-2D0*QF(3)*PZ12*
     &  PZ34*S12*S14*S34*XCW2*XSW2**2-2D0*QF(3)*PZ12*PZ34*S12*S23*
     &  S34*XCW2*XSW2**2+2D0*QF(3)*PZ34*S24*S34*XCW2*XSW2**2-4D0*
     &  QF(3)*PZ12*PZ34*S12*S24*S34*XCW2*XSW2**2+2D0*QF(3)*PZ12*S12*
     &  T12*XCW2*XSW2**2-2D0*QF(3)*PZ12*PZ34*S12*S34*T12*XCW2*XSW2**
     &  2+2D0*QF(3)*PZ34*S34*T14*XCW2*XSW2**2-2D0*QF(3)*PZ12*PZ34*
     &  S12*S34*T14*XCW2*XSW2**2+PZ12*PZ34*S12*S34*XMH2*XSW2**2+2D0*
     &  QF(3)*PZ12*S12*XCW2*XMH2*XSW2**2+2D0*QF(3)*PZ34*S34*XCW2*
     &  XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2+4D0*QF(3)*
     &  PZ12*S12*XCW2*XMW2*XSW2**2+4D0*QF(3)*PZ34*S34*XCW2*XMW2*
     &  XSW2**2+2D0*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+4D0*QF(3)*
     &  PZ12*PZ34*S12*S34*XMW2*XSW2**3))/(S12*S34*XCW2)-(2D0*C2(0,
     &  0)*(-(2D0*PZ34*S34*XCW2**2*XMH2)+PZ12*PZ34*S12*S34*XCW2**2*
     &  XMH2-32D0*PZ34*S34*XCW2**2*XMW2+34D0*PZ12*PZ34*S12*S34*
     &  XCW2**2*XMW2+2D0*PZ34*S34*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*S12*
     &  S34*XCW2*XMH2*XSW2+8D0*QF(3)*XCW2**2*XMH2*XSW2-4D0*QF(3)*
     &  PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(3)*PZ34*S34*XCW2**2*XMH2*
     &  XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+4D0*PZ12*
     &  PZ34*S12*S34*XCW2*XMW2*XSW2+64D0*QF(3)*XCW2**2*XMW2*XSW2-
     &  64D0*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2-64D0*QF(3)*PZ34*S34*
     &  XCW2**2*XMW2*XSW2+68D0*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMW2*
     &  XSW2+PZ12*PZ34*S12*S34*XMH2*XSW2**2+4D0*QF(3)*PZ12*S12*XCW2*
     &  XMH2*XSW2**2+4D0*QF(3)*PZ34*S34*XCW2*XMH2*XSW2**2-4D0*QF(3)*
     &  PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*
     &  XMW2*XSW2**2+8D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2**2+
     &  2D0*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+4D0*QF(3)*PZ12*
     &  PZ34*S12*S34*XMW2*XSW2**3))/(S12*S34*XCW2*XMW)))/XSW2
        F(1,1,1) = F(1,1,1)+2D0*QF(2)*QF(3)*PRE*(-((2D0*C2(2,2)*
     &  K(10)*XMW)/S12)-(2D0*C2(1,1)*K(10)*XMW)/S34+(2D0*C2(1,2)*
     &  K(10)*K(4)*XMW)/(S12*S34)+(XMW*(10D0*XCW2-11D0*PZ12*S12*
     &  XCW2-11D0*PZ34*S34*XCW2+12D0*PZ12*PZ34*S12*S34*XCW2-PZ12*
     &  S12*XSW2-PZ34*S34*XSW2+2D0*PZ12*PZ34*S12*S34*XSW2))/(S12*
     &  S34)-(2D0*C1(1)*XMW*(2D0*S12*XCW2-4D0*PZ12*S12**2*XCW2-S13*
     &  XCW2-S14*XCW2-S23*XCW2-S24*XCW2+2D0*PZ12*PZ34*S12**2*S34*
     &  XCW2+2D0*PZ34*S13*S34*XCW2-PZ12*PZ34*S12*S13*S34*XCW2+2D0*
     &  PZ34*S14*S34*XCW2-PZ12*PZ34*S12*S14*S34*XCW2+2D0*PZ34*S23*
     &  S34*XCW2-PZ12*PZ34*S12*S23*S34*XCW2+2D0*PZ34*S24*S34*XCW2-
     &  PZ12*PZ34*S12*S24*S34*XCW2-2D0*PZ12*S12**2*XSW2-PZ12*S12*
     &  S13*XSW2-PZ12*S12*S14*XSW2-PZ12*S12*S23*XSW2-PZ12*S12*S24*
     &  XSW2+2D0*PZ34*S12*S34*XSW2+PZ34*S13*S34*XSW2+PZ34*S14*S34*
     &  XSW2+PZ34*S23*S34*XSW2+PZ34*S24*S34*XSW2))/(S12*S34)+(2D0*
     &  C1(2)*XMW*(S13*XCW2-2D0*PZ12*S12*S13*XCW2+S14*XCW2-2D0*PZ12*
     &  S12*S14*XCW2+S23*XCW2-2D0*PZ12*S12*S23*XCW2+S24*XCW2-2D0*
     &  PZ12*S12*S24*XCW2-2D0*S34*XCW2+PZ12*PZ34*S12*S13*S34*XCW2+
     &  PZ12*PZ34*S12*S14*S34*XCW2+PZ12*PZ34*S12*S23*S34*XCW2+PZ12*
     &  PZ34*S12*S24*S34*XCW2+4D0*PZ34*S34**2*XCW2-2D0*PZ12*PZ34*
     &  S12*S34**2*XCW2-PZ12*S12*S13*XSW2-PZ12*S12*S14*XSW2-PZ12*
     &  S12*S23*XSW2-PZ12*S12*S24*XSW2-2D0*PZ12*S12*S34*XSW2+PZ34*
     &  S13*S34*XSW2+PZ34*S14*S34*XSW2+PZ34*S23*S34*XSW2+PZ34*S24*
     &  S34*XSW2+2D0*PZ34*S34**2*XSW2))/(S12*S34)+(2D0*C0*XMW*(5D0*
     &  S13*XCW2**2-5D0*PZ12*S12*S13*XCW2**2+6D0*S14*XCW2**2-6D0*
     &  PZ12*S12*S14*XCW2**2+6D0*S23*XCW2**2-5D0*PZ12*S12*S23*XCW2**
     &  2+7D0*S24*XCW2**2-6D0*PZ12*S12*S24*XCW2**2-5D0*PZ34*S13*S34*
     &  XCW2**2+5D0*PZ12*PZ34*S12*S13*S34*XCW2**2-5D0*PZ34*S14*S34*
     &  XCW2**2+5D0*PZ12*PZ34*S12*S14*S34*XCW2**2-6D0*PZ34*S23*S34*
     &  XCW2**2+5D0*PZ12*PZ34*S12*S23*S34*XCW2**2-6D0*PZ34*S24*S34*
     &  XCW2**2+5D0*PZ12*PZ34*S12*S24*S34*XCW2**2+T12*XCW2**2-PZ34*
     &  S34*T12*XCW2**2+T14*XCW2**2-PZ12*S12*T14*XCW2**2+XCW2**2*
     &  XMH2+2D0*XCW2**2*XMW2+PZ12*S12*S23*XCW2*XSW2+PZ12*S12*S24*
     &  XCW2*XSW2+PZ34*S14*S34*XCW2*XSW2-PZ12*PZ34*S12*S14*S34*XCW2*
     &  XSW2-PZ12*PZ34*S12*S23*S34*XCW2*XSW2+PZ34*S24*S34*XCW2*XSW2-
     &  2D0*PZ12*PZ34*S12*S24*S34*XCW2*XSW2+PZ12*S12*T12*XCW2*XSW2-
     &  PZ12*PZ34*S12*S34*T12*XCW2*XSW2+PZ34*S34*T14*XCW2*XSW2-PZ12*
     &  PZ34*S12*S34*T14*XCW2*XSW2+PZ12*S12*XCW2*XMH2*XSW2+PZ34*S34*
     &  XCW2*XMH2*XSW2+2D0*PZ12*S12*XCW2*XMW2*XSW2+2D0*PZ34*S34*
     &  XCW2*XMW2*XSW2+PZ12*PZ34*S12*S34*XMH2*XSW2**2+2D0*PZ12*PZ34*
     &  S12*S34*XMW2*XSW2**2))/(S12*S34*XCW2)-(2D0*C2(0,0)*(4D0*
     &  XCW2**2*XMH2-2D0*PZ12*S12*XCW2**2*XMH2-2D0*PZ34*S34*XCW2**2*
     &  XMH2+PZ12*PZ34*S12*S34*XCW2**2*XMH2+32D0*XCW2**2*XMW2-32D0*
     &  PZ12*S12*XCW2**2*XMW2-32D0*PZ34*S34*XCW2**2*XMW2+34D0*PZ12*
     &  PZ34*S12*S34*XCW2**2*XMW2+2D0*PZ12*S12*XCW2*XMH2*XSW2+2D0*
     &  PZ34*S34*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*S12*S34*XCW2*XMH2*
     &  XSW2+4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2+PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2))/(S12*S34*
     &  XCW2*XMW))
        F(5,-1,-1) = F(5,-1,-1)-K(7)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(5)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)+(2D0*K(6)*QF(2)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)+4D0*K(8)*QF(2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-K(7)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(5)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)+(2D0*K(6)*QF(2)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)+4D0*K(8)*QF(2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-K(7)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(5)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)+(2D0*K(6)*QF(2)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)+4D0*K(8)*QF(2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-K(7)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(5)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)+(2D0*K(6)*QF(2)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)+4D0*K(8)*QF(2)*QF(3)*PRE

C       G(T5,N89,FULL)+G(T5,N90,FULL)
        CALL xC01234_(S12,MH2,S34,XMZ2,XMH2,XMH2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = -((3D0*ALPHA*PZ12*PZ34*XCW2**(-2)*XMH2)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(1)*K(2)*PRE*((C0*XMW)/XCW2-(C2(0,
     &  0))/XMW)*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)+(2D0*K(1)*QF(3)*PRE*((C0*XMW)/XCW2-
     &  (C2(0,0))/XMW))/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(2)*PRE*((C0*XMW)/XCW2-
     &  (C2(0,0))/XMW))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*((C0*XMW)/XCW2-
     &  (C2(0,0))/XMW)
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2))/
     &  XMW
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/(XMW*
     &  XSW2)
        F(5,1,-1) = F(5,1,-1)+(2D0*C2(1,2)*K(2)*QF(2)*PRE)/(XMW*
     &  XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*C2(1,2)*QF(2)*QF(3)*PRE)/XMW
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2))/
     &  XMW
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/(XMW*
     &  XSW2)
        F(6,1,-1) = F(6,1,-1)+(2D0*C2(1,2)*K(2)*QF(2)*PRE)/(XMW*
     &  XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*C2(1,2)*QF(2)*QF(3)*PRE)/XMW
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2))/
     &  XMW
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/(XMW*
     &  XSW2)
        F(7,1,-1) = F(7,1,-1)+(2D0*C2(1,2)*K(2)*QF(2)*PRE)/(XMW*
     &  XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*C2(1,2)*QF(2)*QF(3)*PRE)/XMW
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2))/
     &  XMW
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/(XMW*
     &  XSW2)
        F(8,1,-1) = F(8,1,-1)+(2D0*C2(1,2)*K(2)*QF(2)*PRE)/(XMW*
     &  XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*C2(1,2)*QF(2)*QF(3)*PRE)/XMW

C       G(T7,N110,FULL)
        CALL xC01234_(S34,RMF2(3),RMF2(3),CMF2(3),CMF2(3),XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S34-C1(2)*
     &  S34-C2(1,1)*S34-C2(1,2)*S34)*XCW2**(-3)*XMW)/(32D0*PI))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*XSW2**(-2)*(1D0+2D0*QF(2)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2)**3)/XSW
        F(1,-1,1) = F(1,-1,1)+8D0*QF(3)**3*PRE*XSW*(1D0+2D0*QF(2)*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2)**
     &  3)/(XSW*XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(2)*QF(3)**3*PRE*XSW*XSW2

C       G(T7,N107,FULL)
        CALL xC01234_(S34,RMF2(3),RMF2(3),CMF2(4),CMF2(4),XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S34-C1(2)*S34-
     &  C2(1,1)*S34-C2(1,2)*S34)*XCW2**(-2)*XMW*(1D0-2D0*QF(4)*
     &  XSW2))/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(2)*PRE

C       G(T2,N5,FULL)+G(T2,N7,FULL)
        CALL xC01234_(T12,MH2,RMF2(2),CMF2(2),XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*XCW2**(-3)*XMW)/(32D0*PI*S34)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*XSW2**(-2)*(1D0+2D0*QF(2)*
     &  XSW2)**2*(PZ34*S34+2D0*QF(2)*PZ34*S34*XSW2+2D0*QF(3)*PZ34*
     &  S34*XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*QF(2)*QF(3)*PZ34*S34*
     &  XSW2**2))/XSW
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2)**
     &  2*(PZ34*S34+2D0*QF(2)*XCW2+2D0*QF(2)*PZ34*S34*XSW2))/(XSW*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*QF(2)**3*PRE*XSW*(PZ34*S34+2D0*
     &  QF(3)*XCW2+2D0*QF(3)*PZ34*S34*XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(2)**3*QF(3)*PRE*XSW*(XCW2+PZ34*
     &  S34*XSW2)

C       G(T4,N14,FULL)+G(T4,N16,FULL)
        CALL xC01234_(T13,MH2,RMF2(3),CMF2(3),XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*XCW2**(-3)*XMW)/(32D0*PI*S12)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*XSW2**(-2)*(1D0+2D0*QF(3)*
     &  XSW2)**2*(PZ12*S12+2D0*QF(2)*PZ12*S12*XSW2+2D0*QF(3)*PZ12*
     &  S12*XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*QF(2)*QF(3)*PZ12*S12*
     &  XSW2**2))/XSW
        F(1,-1,1) = F(1,-1,1)+8D0*QF(3)**3*PRE*XSW*(PZ12*S12+2D0*
     &  QF(2)*XCW2+2D0*QF(2)*PZ12*S12*XSW2)
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2)**
     &  2*(PZ12*S12+2D0*QF(3)*XCW2+2D0*QF(3)*PZ12*S12*XSW2))/(XSW*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(2)*QF(3)**3*PRE*XSW*(XCW2+PZ12*
     &  S12*XSW2)

C       G(T6,N103,FULL)+G(T6,N105,FULL)
        CALL xC01234_(T14,MH2,RMF2(3),CMF2(3),XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*XCW2**(-3)*XMW)/(32D0*PI*S12)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*XSW2**(-2)*(1D0+2D0*QF(3)*
     &  XSW2)**2*(PZ12*S12+2D0*QF(2)*PZ12*S12*XSW2+2D0*QF(3)*PZ12*
     &  S12*XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*QF(2)*QF(3)*PZ12*S12*
     &  XSW2**2))/XSW
        F(1,-1,1) = F(1,-1,1)+8D0*QF(3)**3*PRE*XSW*(PZ12*S12+2D0*
     &  QF(2)*XCW2+2D0*QF(2)*PZ12*S12*XSW2)
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2)**
     &  2*(PZ12*S12+2D0*QF(3)*XCW2+2D0*QF(3)*PZ12*S12*XSW2))/(XSW*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(2)*QF(3)**3*PRE*XSW*(XCW2+PZ12*
     &  S12*XSW2)

C       G(T6,N104,FULL)+G(T6,N106,FULL)
        CALL xC01234_(T14,MH2,RMF2(3),CMF2(4),XMW2,XMW2,C
     &	0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*XMW)/(16D0*PI*S12*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(PZ12*S12+2D0*QF(2)*PZ12*S12*
     &  XSW2+2D0*QF(3)*PZ12*S12*XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*
     &  QF(2)*QF(3)*PZ12*S12*XSW2**2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(2)*PRE*(PZ12*S12+2D0*QF(3)*
     &  XCW2+2D0*QF(3)*PZ12*S12*XSW2)

c*** counterterms
c----------------
        PRE = (PZ12*PZ34*XCW2**(-2)*XMW)/4D0

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
     &          *( ct_hzz + ct_zddl + ct_zddl
     &             +dZza/2d0*(-qd/gdd(-1)/s12/pz12-qd/gdd(-1)/s34/pz34))
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/XSW
     &          *( ct_hzz + ct_zddl + ct_zddr
     &             +dZza/2d0*(-qd/gdd(-1)/s12/pz12-qd/gdd(+1)/s34/pz34))
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/XSW
     &          *( ct_hzz + ct_zddr + ct_zddl
     &             +dZza/2d0*(-qd/gdd(+1)/s12/pz12-qd/gdd(-1)/s34/pz34))
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*XSW
     &          *( ct_hzz + ct_zddr + ct_zddr
     &             +dZza/2d0*(-qd/gdd(+1)/s12/pz12-qd/gdd(+1)/s34/pz34))

	end

************************************************************************
        subroutine add_HZZ2233_box(F,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for ZZ-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    down     anti-down     down     anti-down
*       box corrections         
*-----------------------------------------------------------------------
*       30.12.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(9)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pz12,pz34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        COMPLEX*16 xD0_,D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        COMPLEX*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)
	integer i

        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)

C       Process: S1F22aF22F23aF23,   Model: SM4f

C       G(T6,N18,FULL)+G(T6,N19,FULL)+G(T6,N20,FULL)+G(T6,N21,FULL)
        CALL xD012345_(RMF2(2),MH2,S34,RMF2(2),S12,T11,CMF2(1),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-PZ34*S34
        K(2) = PZ34*S34-2D0*QF(3)*XSW2+2D0*QF(3)*PZ34*S34*XSW2
        K(3) = -(3D0*XCW2)+4D0*PZ34*S34*XCW2+PZ34*S34*XSW2
        K(4) = 4D0*PZ34*S34*XCW2+PZ34*S34*XSW2-6D0*QF(3)*XCW2*XSW2+
     &  8D0*QF(3)*PZ34*S34*XCW2*XSW2+2D0*QF(3)*PZ34*S34*XSW2**2

        PRE = -((ALPHA*XMW)/(32D0*PI*S34*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(-(4D0*D1(3)*K(2)*(S23+S24))+
     &  (D2(1,3)*K(4)*S12)/XCW2-(D2(2,3)*K(4)*(S23+S24))/XCW2-(D2(2,
     &  2)*K(4)*T11)/XCW2+(D2(1,2)*K(4)*(MH2-T11))/XCW2-(4D0*D2(0,
     &  0)*(6D0*PZ34*S34*XCW2+PZ34*S34*XSW2-10D0*QF(3)*XCW2*XSW2+
     &  12D0*QF(3)*PZ34*S34*XCW2*XSW2+2D0*QF(3)*PZ34*S34*XSW2**2))/
     &  XCW2+(2D0*D1(1)*(PZ34*S12*S34*XCW2-PZ34*S13*S34*XCW2-PZ34*
     &  S14*S34*XCW2+MH2*PZ34*S34*XSW2-PZ34*S34*T11*XSW2+2D0*QF(3)*
     &  MH2*XCW2*XSW2-2D0*QF(3)*S12*XCW2*XSW2+2D0*QF(3)*S13*XCW2*
     &  XSW2+2D0*QF(3)*S14*XCW2*XSW2+2D0*QF(3)*PZ34*S12*S34*XCW2*
     &  XSW2-2D0*QF(3)*PZ34*S13*S34*XCW2*XSW2-2D0*QF(3)*PZ34*S14*
     &  S34*XCW2*XSW2-2D0*QF(3)*T11*XCW2*XSW2+2D0*QF(3)*MH2*PZ34*
     &  S34*XSW2**2-2D0*QF(3)*PZ34*S34*T11*XSW2**2))/XCW2-(2D0*
     &  D1(2)*(3D0*PZ34*S23*S34*XCW2+3D0*PZ34*S24*S34*XCW2+PZ34*
     &  S34**2*XCW2+PZ34*S34*T11*XSW2-6D0*QF(3)*S23*XCW2*XSW2-6D0*
     &  QF(3)*S24*XCW2*XSW2-2D0*QF(3)*S34*XCW2*XSW2+6D0*QF(3)*PZ34*
     &  S23*S34*XCW2*XSW2+6D0*QF(3)*PZ34*S24*S34*XCW2*XSW2+2D0*
     &  QF(3)*PZ34*S34**2*XCW2*XSW2+2D0*QF(3)*T11*XCW2*XSW2+2D0*
     &  QF(3)*PZ34*S34*T11*XSW2**2))/XCW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*(4D0*D1(3)*K(1)*(S23+
     &  S24)+(D2(1,3)*K(3)*S12)/XCW2-(D2(2,3)*K(3)*(S23+S24))/XCW2-
     &  (D2(2,2)*K(3)*T11)/XCW2+(D2(1,2)*K(3)*(MH2-T11))/XCW2-(4D0*
     &  D2(0,0)*(-(5D0*XCW2)+6D0*PZ34*S34*XCW2+PZ34*S34*XSW2))/XCW2-
     &  (2D0*D1(2)*(-(3D0*S23*XCW2)-3D0*S24*XCW2-S34*XCW2+3D0*PZ34*
     &  S23*S34*XCW2+3D0*PZ34*S24*S34*XCW2+PZ34*S34**2*XCW2+T11*
     &  XCW2+PZ34*S34*T11*XSW2))/XCW2+(2D0*D1(1)*(MH2*XCW2-S12*XCW2+
     &  S13*XCW2+S14*XCW2+PZ34*S12*S34*XCW2-PZ34*S13*S34*XCW2-PZ34*
     &  S14*S34*XCW2-T11*XCW2+MH2*PZ34*S34*XSW2-PZ34*S34*T11*XSW2))/
     &  XCW2)
        F(5,-1,-1) = F(5,-1,-1)+(8D0*(D1(1)+D2(1,2))*K(2)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-16D0*(D1(1)+D2(1,2))*K(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(4D0*PRE*(-(2D0*D2(2,2)*K(2))-2D0*
     &  D2(2,3)*K(2)+(D1(3)*(PZ34*S34*XCW2-PZ34*S34*XSW2-4D0*QF(3)*
     &  XCW2*XSW2+2D0*QF(3)*PZ34*S34*XCW2*XSW2-2D0*QF(3)*PZ34*S34*
     &  XSW2**2))/XCW2))/XSW2
        F(6,-1,1) = F(6,-1,1)-8D0*QF(3)*PRE*(-(2D0*D2(2,2)*K(1))-
     &  2D0*D2(2,3)*K(1)+(D1(3)*(2D0*XCW2-PZ34*S34*XCW2+PZ34*S34*
     &  XSW2))/XCW2)
        F(7,-1,-1) = F(7,-1,-1)+(8D0*(D1(1)+D2(1,2))*K(2)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-16D0*(D1(1)+D2(1,2))*K(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(4D0*PRE*(-(2D0*D2(2,2)*K(2))-2D0*
     &  D2(2,3)*K(2)+(D1(3)*(PZ34*S34*XCW2-PZ34*S34*XSW2-4D0*QF(3)*
     &  XCW2*XSW2+2D0*QF(3)*PZ34*S34*XCW2*XSW2-2D0*QF(3)*PZ34*S34*
     &  XSW2**2))/XCW2))/XSW2
        F(8,-1,1) = F(8,-1,1)-8D0*QF(3)*PRE*(-(2D0*D2(2,2)*K(1))-
     &  2D0*D2(2,3)*K(1)+(D1(3)*(2D0*XCW2-PZ34*S34*XCW2+PZ34*S34*
     &  XSW2))/XCW2)

C       G(T1,N1,FULL)+G(T1,N2,FULL)+G(T1,N3,FULL)+G(T1,N4,FULL)
        CALL xD012345_(RMF2(2),MH2,S34,RMF2(2),S12,T12,CMF2(1),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-PZ34*S34
        K(2) = PZ34*S34-2D0*QF(3)*XSW2+2D0*QF(3)*PZ34*S34*XSW2
        K(3) = -(3D0*XCW2)+4D0*PZ34*S34*XCW2+PZ34*S34*XSW2
        K(4) = 4D0*PZ34*S34*XCW2+PZ34*S34*XSW2-6D0*QF(3)*XCW2*XSW2+
     &  8D0*QF(3)*PZ34*S34*XCW2*XSW2+2D0*QF(3)*PZ34*S34*XSW2**2

        PRE = -((ALPHA*XMW)/(32D0*PI*S34*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(-(4D0*D1(3)*K(2)*(S13+S14))+
     &  (D2(1,3)*K(4)*S12)/XCW2-(D2(2,3)*K(4)*(S13+S14))/XCW2-(D2(2,
     &  2)*K(4)*T12)/XCW2+(D2(1,2)*K(4)*(MH2-T12))/XCW2-(4D0*D2(0,
     &  0)*(6D0*PZ34*S34*XCW2+PZ34*S34*XSW2-10D0*QF(3)*XCW2*XSW2+
     &  12D0*QF(3)*PZ34*S34*XCW2*XSW2+2D0*QF(3)*PZ34*S34*XSW2**2))/
     &  XCW2+(2D0*D1(1)*(PZ34*S12*S34*XCW2-PZ34*S23*S34*XCW2-PZ34*
     &  S24*S34*XCW2+MH2*PZ34*S34*XSW2-PZ34*S34*T12*XSW2+2D0*QF(3)*
     &  MH2*XCW2*XSW2-2D0*QF(3)*S12*XCW2*XSW2+2D0*QF(3)*S23*XCW2*
     &  XSW2+2D0*QF(3)*S24*XCW2*XSW2+2D0*QF(3)*PZ34*S12*S34*XCW2*
     &  XSW2-2D0*QF(3)*PZ34*S23*S34*XCW2*XSW2-2D0*QF(3)*PZ34*S24*
     &  S34*XCW2*XSW2-2D0*QF(3)*T12*XCW2*XSW2+2D0*QF(3)*MH2*PZ34*
     &  S34*XSW2**2-2D0*QF(3)*PZ34*S34*T12*XSW2**2))/XCW2-(2D0*
     &  D1(2)*(3D0*PZ34*S13*S34*XCW2+3D0*PZ34*S14*S34*XCW2+PZ34*
     &  S34**2*XCW2+PZ34*S34*T12*XSW2-6D0*QF(3)*S13*XCW2*XSW2-6D0*
     &  QF(3)*S14*XCW2*XSW2-2D0*QF(3)*S34*XCW2*XSW2+6D0*QF(3)*PZ34*
     &  S13*S34*XCW2*XSW2+6D0*QF(3)*PZ34*S14*S34*XCW2*XSW2+2D0*
     &  QF(3)*PZ34*S34**2*XCW2*XSW2+2D0*QF(3)*T12*XCW2*XSW2+2D0*
     &  QF(3)*PZ34*S34*T12*XSW2**2))/XCW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*(4D0*D1(3)*K(1)*(S13+
     &  S14)+(D2(1,3)*K(3)*S12)/XCW2-(D2(2,3)*K(3)*(S13+S14))/XCW2-
     &  (D2(2,2)*K(3)*T12)/XCW2+(D2(1,2)*K(3)*(MH2-T12))/XCW2-(4D0*
     &  D2(0,0)*(-(5D0*XCW2)+6D0*PZ34*S34*XCW2+PZ34*S34*XSW2))/XCW2-
     &  (2D0*D1(2)*(-(3D0*S13*XCW2)-3D0*S14*XCW2-S34*XCW2+3D0*PZ34*
     &  S13*S34*XCW2+3D0*PZ34*S14*S34*XCW2+PZ34*S34**2*XCW2+T12*
     &  XCW2+PZ34*S34*T12*XSW2))/XCW2+(2D0*D1(1)*(MH2*XCW2-S12*XCW2+
     &  S23*XCW2+S24*XCW2+PZ34*S12*S34*XCW2-PZ34*S23*S34*XCW2-PZ34*
     &  S24*S34*XCW2-T12*XCW2+MH2*PZ34*S34*XSW2-PZ34*S34*T12*XSW2))/
     &  XCW2)
        F(5,-1,-1) = F(5,-1,-1)+(4D0*PRE*(-(2D0*D2(2,2)*K(2))-2D0*
     &  D2(2,3)*K(2)+(D1(3)*(PZ34*S34*XCW2-PZ34*S34*XSW2-4D0*QF(3)*
     &  XCW2*XSW2+2D0*QF(3)*PZ34*S34*XCW2*XSW2-2D0*QF(3)*PZ34*S34*
     &  XSW2**2))/XCW2))/XSW2
        F(5,-1,1) = F(5,-1,1)-8D0*QF(3)*PRE*(-(2D0*D2(2,2)*K(1))-
     &  2D0*D2(2,3)*K(1)+(D1(3)*(2D0*XCW2-PZ34*S34*XCW2+PZ34*S34*
     &  XSW2))/XCW2)
        F(6,-1,-1) = F(6,-1,-1)+(8D0*(D1(1)+D2(1,2))*K(2)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-16D0*(D1(1)+D2(1,2))*K(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(4D0*PRE*(-(2D0*D2(2,2)*K(2))-2D0*
     &  D2(2,3)*K(2)+(D1(3)*(PZ34*S34*XCW2-PZ34*S34*XSW2-4D0*QF(3)*
     &  XCW2*XSW2+2D0*QF(3)*PZ34*S34*XCW2*XSW2-2D0*QF(3)*PZ34*S34*
     &  XSW2**2))/XCW2))/XSW2
        F(7,-1,1) = F(7,-1,1)-8D0*QF(3)*PRE*(-(2D0*D2(2,2)*K(1))-
     &  2D0*D2(2,3)*K(1)+(D1(3)*(2D0*XCW2-PZ34*S34*XCW2+PZ34*S34*
     &  XSW2))/XCW2)
        F(8,-1,-1) = F(8,-1,-1)+(8D0*(D1(1)+D2(1,2))*K(2)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-16D0*(D1(1)+D2(1,2))*K(1)*QF(3)*PRE

C       G(T7,N22,FULL)+G(T7,N23,FULL)+G(T7,N24,FULL)+G(T7,N25,FULL)
        CALL xD012345_(RMF2(3),MH2,S12,RMF2(3),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-PZ12*S12
        K(2) = PZ12*S12-2D0*QF(2)*XSW2+2D0*QF(2)*PZ12*S12*XSW2
        K(3) = -(3D0*XCW2)+4D0*PZ12*S12*XCW2+PZ12*S12*XSW2
        K(4) = 4D0*PZ12*S12*XCW2+PZ12*S12*XSW2-6D0*QF(2)*XCW2*XSW2+
     &  8D0*QF(2)*PZ12*S12*XCW2*XSW2+2D0*QF(2)*PZ12*S12*XSW2**2

        PRE = -((ALPHA*XMW)/(32D0*PI*S12*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(-(4D0*D1(3)*K(2)*(S14+S24))-
     &  (D2(2,3)*K(4)*(S14+S24))/XCW2+(D2(1,3)*K(4)*S34)/XCW2-(D2(2,
     &  2)*K(4)*T13)/XCW2+(D2(1,2)*K(4)*(MH2-T13))/XCW2-(4D0*D2(0,
     &  0)*(6D0*PZ12*S12*XCW2+PZ12*S12*XSW2-10D0*QF(2)*XCW2*XSW2+
     &  12D0*QF(2)*PZ12*S12*XCW2*XSW2+2D0*QF(2)*PZ12*S12*XSW2**2))/
     &  XCW2-(2D0*D1(2)*(PZ12*S12**2*XCW2+3D0*PZ12*S12*S14*XCW2+3D0*
     &  PZ12*S12*S24*XCW2+PZ12*S12*T13*XSW2-2D0*QF(2)*S12*XCW2*XSW2+
     &  2D0*QF(2)*PZ12*S12**2*XCW2*XSW2-6D0*QF(2)*S14*XCW2*XSW2+6D0*
     &  QF(2)*PZ12*S12*S14*XCW2*XSW2-6D0*QF(2)*S24*XCW2*XSW2+6D0*
     &  QF(2)*PZ12*S12*S24*XCW2*XSW2+2D0*QF(2)*T13*XCW2*XSW2+2D0*
     &  QF(2)*PZ12*S12*T13*XSW2**2))/XCW2-(2D0*D1(1)*(PZ12*S12*S13*
     &  XCW2+PZ12*S12*S23*XCW2-PZ12*S12*S34*XCW2-MH2*PZ12*S12*XSW2+
     &  PZ12*S12*T13*XSW2-2D0*QF(2)*MH2*XCW2*XSW2-2D0*QF(2)*S13*
     &  XCW2*XSW2+2D0*QF(2)*PZ12*S12*S13*XCW2*XSW2-2D0*QF(2)*S23*
     &  XCW2*XSW2+2D0*QF(2)*PZ12*S12*S23*XCW2*XSW2+2D0*QF(2)*S34*
     &  XCW2*XSW2-2D0*QF(2)*PZ12*S12*S34*XCW2*XSW2+2D0*QF(2)*T13*
     &  XCW2*XSW2-2D0*QF(2)*MH2*PZ12*S12*XSW2**2+2D0*QF(2)*PZ12*S12*
     &  T13*XSW2**2))/XCW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(2)*PRE*(4D0*D1(3)*K(1)*(S14+
     &  S24)-(D2(2,3)*K(3)*(S14+S24))/XCW2+(D2(1,3)*K(3)*S34)/XCW2-
     &  (D2(2,2)*K(3)*T13)/XCW2+(D2(1,2)*K(3)*(MH2-T13))/XCW2-(4D0*
     &  D2(0,0)*(-(5D0*XCW2)+6D0*PZ12*S12*XCW2+PZ12*S12*XSW2))/XCW2+
     &  (2D0*D1(2)*(S12*XCW2-PZ12*S12**2*XCW2+3D0*S14*XCW2-3D0*PZ12*
     &  S12*S14*XCW2+3D0*S24*XCW2-3D0*PZ12*S12*S24*XCW2-T13*XCW2-
     &  PZ12*S12*T13*XSW2))/XCW2+(2D0*D1(1)*(MH2*XCW2+S13*XCW2-PZ12*
     &  S12*S13*XCW2+S23*XCW2-PZ12*S12*S23*XCW2-S34*XCW2+PZ12*S12*
     &  S34*XCW2-T13*XCW2+MH2*PZ12*S12*XSW2-PZ12*S12*T13*XSW2))/
     &  XCW2)
        F(5,-1,-1) = F(5,-1,-1)+(8D0*(D1(1)+D2(1,2))*K(2)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-16D0*(D1(1)+D2(1,2))*K(1)*QF(2)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(8D0*(D1(1)+D2(1,2))*K(2)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-16D0*(D1(1)+D2(1,2))*K(1)*QF(2)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(4D0*PRE*(-(2D0*D2(2,2)*K(2))-2D0*
     &  D2(2,3)*K(2)+(D1(3)*(PZ12*S12*XCW2-PZ12*S12*XSW2-4D0*QF(2)*
     &  XCW2*XSW2+2D0*QF(2)*PZ12*S12*XCW2*XSW2-2D0*QF(2)*PZ12*S12*
     &  XSW2**2))/XCW2))/XSW2
        F(7,1,-1) = F(7,1,-1)-8D0*QF(2)*PRE*(-(2D0*D2(2,2)*K(1))-
     &  2D0*D2(2,3)*K(1)+(D1(3)*(2D0*XCW2-PZ12*S12*XCW2+PZ12*S12*
     &  XSW2))/XCW2)
        F(8,-1,-1) = F(8,-1,-1)+(4D0*PRE*(-(2D0*D2(2,2)*K(2))-2D0*
     &  D2(2,3)*K(2)+(D1(3)*(PZ12*S12*XCW2-PZ12*S12*XSW2-4D0*QF(2)*
     &  XCW2*XSW2+2D0*QF(2)*PZ12*S12*XCW2*XSW2-2D0*QF(2)*PZ12*S12*
     &  XSW2**2))/XCW2))/XSW2
        F(8,1,-1) = F(8,1,-1)-8D0*QF(2)*PRE*(-(2D0*D2(2,2)*K(1))-
     &  2D0*D2(2,3)*K(1)+(D1(3)*(2D0*XCW2-PZ12*S12*XCW2+PZ12*S12*
     &  XSW2))/XCW2)

C       G(T9,N28,FULL)+G(T9,N29,FULL)+G(T9,N30,FULL)+G(T9,N31,FULL)
        CALL xD012345_(RMF2(3),S12,MH2,RMF2(3),S34,T14,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-PZ12*S12
        K(2) = PZ12*S12-2D0*QF(2)*XSW2+2D0*QF(2)*PZ12*S12*XSW2
        K(3) = -(3D0*XCW2)+4D0*PZ12*S12*XCW2+PZ12*S12*XSW2
        K(4) = 4D0*PZ12*S12*XCW2+PZ12*S12*XSW2-6D0*QF(2)*XCW2*XSW2+
     &  8D0*QF(2)*PZ12*S12*XCW2*XSW2+2D0*QF(2)*PZ12*S12*XSW2**2

        PRE = -((ALPHA*XMW)/(32D0*PI*S12*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(-(4D0*D1(1)*K(2)*(S13+S23))-
     &  (D2(1,2)*K(4)*(S13+S23))/XCW2+(D2(1,3)*K(4)*S34)/XCW2-(D2(2,
     &  2)*K(4)*T14)/XCW2+(D2(2,3)*K(4)*(MH2-T14))/XCW2-(4D0*D2(0,
     &  0)*(6D0*PZ12*S12*XCW2+PZ12*S12*XSW2-10D0*QF(2)*XCW2*XSW2+
     &  12D0*QF(2)*PZ12*S12*XCW2*XSW2+2D0*QF(2)*PZ12*S12*XSW2**2))/
     &  XCW2-(2D0*D1(2)*(PZ12*S12**2*XCW2+3D0*PZ12*S12*S13*XCW2+3D0*
     &  PZ12*S12*S23*XCW2+PZ12*S12*T14*XSW2-2D0*QF(2)*S12*XCW2*XSW2+
     &  2D0*QF(2)*PZ12*S12**2*XCW2*XSW2-6D0*QF(2)*S13*XCW2*XSW2+6D0*
     &  QF(2)*PZ12*S12*S13*XCW2*XSW2-6D0*QF(2)*S23*XCW2*XSW2+6D0*
     &  QF(2)*PZ12*S12*S23*XCW2*XSW2+2D0*QF(2)*T14*XCW2*XSW2+2D0*
     &  QF(2)*PZ12*S12*T14*XSW2**2))/XCW2-(2D0*D1(3)*(PZ12*S12*S14*
     &  XCW2+PZ12*S12*S24*XCW2-PZ12*S12*S34*XCW2-MH2*PZ12*S12*XSW2+
     &  PZ12*S12*T14*XSW2-2D0*QF(2)*MH2*XCW2*XSW2-2D0*QF(2)*S14*
     &  XCW2*XSW2+2D0*QF(2)*PZ12*S12*S14*XCW2*XSW2-2D0*QF(2)*S24*
     &  XCW2*XSW2+2D0*QF(2)*PZ12*S12*S24*XCW2*XSW2+2D0*QF(2)*S34*
     &  XCW2*XSW2-2D0*QF(2)*PZ12*S12*S34*XCW2*XSW2+2D0*QF(2)*T14*
     &  XCW2*XSW2-2D0*QF(2)*MH2*PZ12*S12*XSW2**2+2D0*QF(2)*PZ12*S12*
     &  T14*XSW2**2))/XCW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(2)*PRE*(4D0*D1(1)*K(1)*(S13+
     &  S23)-(D2(1,2)*K(3)*(S13+S23))/XCW2+(D2(1,3)*K(3)*S34)/XCW2-
     &  (D2(2,2)*K(3)*T14)/XCW2+(D2(2,3)*K(3)*(MH2-T14))/XCW2-(4D0*
     &  D2(0,0)*(-(5D0*XCW2)+6D0*PZ12*S12*XCW2+PZ12*S12*XSW2))/XCW2+
     &  (2D0*D1(2)*(S12*XCW2-PZ12*S12**2*XCW2+3D0*S13*XCW2-3D0*PZ12*
     &  S12*S13*XCW2+3D0*S23*XCW2-3D0*PZ12*S12*S23*XCW2-T14*XCW2-
     &  PZ12*S12*T14*XSW2))/XCW2+(2D0*D1(3)*(MH2*XCW2+S14*XCW2-PZ12*
     &  S12*S14*XCW2+S24*XCW2-PZ12*S12*S24*XCW2-S34*XCW2+PZ12*S12*
     &  S34*XCW2-T14*XCW2+MH2*PZ12*S12*XSW2-PZ12*S12*T14*XSW2))/
     &  XCW2)
        F(5,-1,-1) = F(5,-1,-1)+(4D0*PRE*(-(2D0*D2(1,2)*K(2))-2D0*
     &  D2(2,2)*K(2)+(D1(1)*(PZ12*S12*XCW2-PZ12*S12*XSW2-4D0*QF(2)*
     &  XCW2*XSW2+2D0*QF(2)*PZ12*S12*XCW2*XSW2-2D0*QF(2)*PZ12*S12*
     &  XSW2**2))/XCW2))/XSW2
        F(5,1,-1) = F(5,1,-1)-8D0*QF(2)*PRE*(-(2D0*D2(1,2)*K(1))-
     &  2D0*D2(2,2)*K(1)+(D1(1)*(2D0*XCW2-PZ12*S12*XCW2+PZ12*S12*
     &  XSW2))/XCW2)
        F(6,-1,-1) = F(6,-1,-1)+(4D0*PRE*(-(2D0*D2(1,2)*K(2))-2D0*
     &  D2(2,2)*K(2)+(D1(1)*(PZ12*S12*XCW2-PZ12*S12*XSW2-4D0*QF(2)*
     &  XCW2*XSW2+2D0*QF(2)*PZ12*S12*XCW2*XSW2-2D0*QF(2)*PZ12*S12*
     &  XSW2**2))/XCW2))/XSW2
        F(6,1,-1) = F(6,1,-1)-8D0*QF(2)*PRE*(-(2D0*D2(1,2)*K(1))-
     &  2D0*D2(2,2)*K(1)+(D1(1)*(2D0*XCW2-PZ12*S12*XCW2+PZ12*S12*
     &  XSW2))/XCW2)
        F(7,-1,-1) = F(7,-1,-1)+(8D0*(D1(3)+D2(2,3))*K(2)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-16D0*(D1(3)+D2(2,3))*K(1)*QF(2)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(8D0*(D1(3)+D2(2,3))*K(2)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-16D0*(D1(3)+D2(2,3))*K(1)*QF(2)*PRE

C       G(T5,N14,FULL)+G(T5,N16,FULL)
        CALL xD012345_(S12,RMF2(3),MH2,RMF2(3),T13,T14,CMF2(3),
     &  CMF2(3),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = S14+S24
        K(3) = D2(1,2)+D2(2,2)
        K(4) = 2D0*S12+S13+S23
        K(5) = PZ12*S12+2D0*QF(2)*XCW2+2D0*QF(2)*PZ12*S12*XSW2
        K(6) = PZ12*S12+2D0*QF(3)*XCW2+2D0*QF(3)*PZ12*S12*XSW2
        K(7) = D1(3)+D2(1,3)+D2(2,3)
        K(8) = PZ12*S12+2D0*QF(2)*PZ12*S12*XSW2+2D0*QF(3)*PZ12*S12*
     &  XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*QF(2)*QF(3)*PZ12*S12*
     &  XSW2**2
        K(9) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S12+(D2(1,2)*(2D0*
     &  S12+S13+S23))/S12-(D1(3)*(S14+S24))/S12-(D2(1,3)*(S14+S24))/
     &  S12+(D2(2,2)*T14)/S12-(D2(2,3)*(MH2-T14))/S12

        PRE = (ALPHA*XCW2**(-3)*XMW)/(32D0*PI)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)**2*K(8)*K(9)*PRE*XSW2**(-2))/
     &  XSW
        F(1,-1,1) = F(1,-1,1)+8D0*K(5)*K(9)*QF(3)**3*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(1)**2*K(6)*K(9)*QF(2)*PRE)/
     &  (XSW*XSW2)
        F(1,1,1) = F(1,1,1)+16D0*K(9)*QF(2)*QF(3)**3*PRE*XSW*(XCW2+
     &  PZ12*S12*XSW2)
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)**2*K(3)*K(8)*PRE*XSW2**(-
     &  2))/(S12*XSW)
        F(5,-1,1) = F(5,-1,1)-(16D0*K(3)*K(5)*QF(3)**3*PRE*XSW)/S12
        F(5,1,-1) = F(5,1,-1)-(4D0*K(1)**2*K(3)*K(6)*QF(2)*PRE)/
     &  (S12*XSW*XSW2)
        F(5,1,1) = F(5,1,1)-(32D0*K(3)*QF(2)*QF(3)**3*PRE*XSW*(XCW2+
     &  PZ12*S12*XSW2))/S12
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)**2*K(3)*K(8)*PRE*XSW2**(-
     &  2))/(S12*XSW)
        F(6,-1,1) = F(6,-1,1)-(16D0*K(3)*K(5)*QF(3)**3*PRE*XSW)/S12
        F(6,1,-1) = F(6,1,-1)-(4D0*K(1)**2*K(3)*K(6)*QF(2)*PRE)/
     &  (S12*XSW*XSW2)
        F(6,1,1) = F(6,1,1)-(32D0*K(3)*QF(2)*QF(3)**3*PRE*XSW*(XCW2+
     &  PZ12*S12*XSW2))/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)**2*K(7)*K(8)*PRE*XSW2**(-
     &  2))/(S12*XSW)
        F(7,-1,1) = F(7,-1,1)+(16D0*K(5)*K(7)*QF(3)**3*PRE*XSW)/S12
        F(7,1,-1) = F(7,1,-1)+(4D0*K(1)**2*K(6)*K(7)*QF(2)*PRE)/
     &  (S12*XSW*XSW2)
        F(7,1,1) = F(7,1,1)+(32D0*K(7)*QF(2)*QF(3)**3*PRE*XSW*(XCW2+
     &  PZ12*S12*XSW2))/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)**2*K(7)*K(8)*PRE*XSW2**(-
     &  2))/(S12*XSW)
        F(8,-1,1) = F(8,-1,1)+(16D0*K(5)*K(7)*QF(3)**3*PRE*XSW)/S12
        F(8,1,-1) = F(8,1,-1)+(4D0*K(1)**2*K(6)*K(7)*QF(2)*PRE)/
     &  (S12*XSW*XSW2)
        F(8,1,1) = F(8,1,1)+(32D0*K(7)*QF(2)*QF(3)**3*PRE*XSW*(XCW2+
     &  PZ12*S12*XSW2))/S12

C       G(T5,N15,FULL)+G(T5,N17,FULL)
        CALL xD012345_(S12,RMF2(3),MH2,RMF2(3),T13,T14,CMF2(4),
     &  CMF2(4),XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = PZ12*S12-2D0*QF(4)*XCW2-2D0*QF(4)*PZ12*S12*XSW2
        K(2) = D1(3)+D2(1,3)+D2(2,3)
        K(3) = PZ12*S12+2D0*QF(2)*PZ12*S12*XSW2-2D0*QF(4)*PZ12*S12*
     &  XSW2-4D0*QF(2)*QF(4)*XCW2*XSW2-4D0*QF(2)*QF(4)*PZ12*S12*
     &  XSW2**2
        K(4) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S12+(D2(1,2)*(2D0*
     &  S12+S13+S23))/S12-(D1(3)*(S14+S24))/S12-(D2(1,3)*(S14+S24))/
     &  S12+(D2(2,2)*T14)/S12-(D2(2,3)*(MH2-T14))/S12

        PRE = -((ALPHA*XMW)/(16D0*PI*XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(K(3)*K(4)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(1)*K(4)*QF(2)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*K(3)*PRE)/
     &  (S12*XSW2)
        F(5,1,-1) = F(5,1,-1)-(4D0*(D2(1,2)+D2(2,2))*K(1)*QF(2)*
     &  PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*K(3)*PRE)/
     &  (S12*XSW2)
        F(6,1,-1) = F(6,1,-1)-(4D0*(D2(1,2)+D2(2,2))*K(1)*QF(2)*
     &  PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(2)*K(3)*PRE)/(S12*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(1)*K(2)*QF(2)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(2)*K(3)*PRE)/(S12*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(1)*K(2)*QF(2)*PRE)/S12

C       G(T4,N11,FULL)+G(T4,N13,FULL)
        CALL xD012345_(S34,RMF2(2),MH2,RMF2(2),T12,T11,CMF2(1),
     &  CMF2(1),XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = PZ34*S34-2D0*QF(1)*XCW2-2D0*QF(1)*PZ34*S34*XSW2
        K(2) = D1(3)+D2(1,3)+D2(2,3)
        K(3) = PZ34*S34-2D0*QF(1)*PZ34*S34*XSW2+2D0*QF(3)*PZ34*S34*
     &  XSW2-4D0*QF(1)*QF(3)*XCW2*XSW2-4D0*QF(1)*QF(3)*PZ34*S34*
     &  XSW2**2
        K(4) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S34-(D1(3)*(S13+
     &  S14))/S34-(D2(1,3)*(S13+S14))/S34+(D2(1,2)*(S23+S24+2D0*
     &  S34))/S34+(D2(2,2)*T11)/S34-(D2(2,3)*(MH2-T11))/S34

        PRE = -((ALPHA*XMW)/(16D0*PI*XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(K(3)*K(4)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(1)*K(4)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(2)*K(3)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(1)*K(2)*QF(3)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*K(3)*PRE)/
     &  (S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(4D0*(D2(1,2)+D2(2,2))*K(1)*QF(3)*
     &  PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(2)*K(3)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(1)*K(2)*QF(3)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*K(3)*PRE)/
     &  (S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(4D0*(D2(1,2)+D2(2,2))*K(1)*QF(3)*
     &  PRE)/S34

C       G(T4,N10,FULL)+G(T4,N12,FULL)
        CALL xD012345_(S34,RMF2(2),MH2,RMF2(2),T12,T11,CMF2(2),
     &  CMF2(2),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = S13+S14
        K(3) = D2(1,2)+D2(2,2)
        K(4) = S23+S24+2D0*S34
        K(5) = PZ34*S34+2D0*QF(2)*XCW2+2D0*QF(2)*PZ34*S34*XSW2
        K(6) = PZ34*S34+2D0*QF(3)*XCW2+2D0*QF(3)*PZ34*S34*XSW2
        K(7) = D1(3)+D2(1,3)+D2(2,3)
        K(8) = PZ34*S34+2D0*QF(2)*PZ34*S34*XSW2+2D0*QF(3)*PZ34*S34*
     &  XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*QF(2)*QF(3)*PZ34*S34*
     &  XSW2**2
        K(9) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S34-(D1(3)*(S13+
     &  S14))/S34-(D2(1,3)*(S13+S14))/S34+(D2(1,2)*(S23+S24+2D0*
     &  S34))/S34+(D2(2,2)*T11)/S34-(D2(2,3)*(MH2-T11))/S34

        PRE = (ALPHA*XCW2**(-3)*XMW)/(32D0*PI)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)**2*K(8)*K(9)*PRE*XSW2**(-2))/
     &  XSW
        F(1,-1,1) = F(1,-1,1)+(2D0*K(1)**2*K(5)*K(9)*QF(3)*PRE)/
     &  (XSW*XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*K(6)*K(9)*QF(2)**3*PRE*XSW
        F(1,1,1) = F(1,1,1)+16D0*K(9)*QF(2)**3*QF(3)*PRE*XSW*(XCW2+
     &  PZ34*S34*XSW2)
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)**2*K(7)*K(8)*PRE*XSW2**(-
     &  2))/(S34*XSW)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(1)**2*K(5)*K(7)*QF(3)*PRE)/
     &  (S34*XSW*XSW2)
        F(5,1,-1) = F(5,1,-1)+(16D0*K(6)*K(7)*QF(2)**3*PRE*XSW)/S34
        F(5,1,1) = F(5,1,1)+(32D0*K(7)*QF(2)**3*QF(3)*PRE*XSW*(XCW2+
     &  PZ34*S34*XSW2))/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)**2*K(3)*K(8)*PRE*XSW2**(-
     &  2))/(S34*XSW)
        F(6,-1,1) = F(6,-1,1)-(4D0*K(1)**2*K(3)*K(5)*QF(3)*PRE)/
     &  (S34*XSW*XSW2)
        F(6,1,-1) = F(6,1,-1)-(16D0*K(3)*K(6)*QF(2)**3*PRE*XSW)/S34
        F(6,1,1) = F(6,1,1)-(32D0*K(3)*QF(2)**3*QF(3)*PRE*XSW*(XCW2+
     &  PZ34*S34*XSW2))/S34
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)**2*K(7)*K(8)*PRE*XSW2**(-
     &  2))/(S34*XSW)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(1)**2*K(5)*K(7)*QF(3)*PRE)/
     &  (S34*XSW*XSW2)
        F(7,1,-1) = F(7,1,-1)+(16D0*K(6)*K(7)*QF(2)**3*PRE*XSW)/S34
        F(7,1,1) = F(7,1,1)+(32D0*K(7)*QF(2)**3*QF(3)*PRE*XSW*(XCW2+
     &  PZ34*S34*XSW2))/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)**2*K(3)*K(8)*PRE*XSW2**(-
     &  2))/(S34*XSW)
        F(8,-1,1) = F(8,-1,1)-(4D0*K(1)**2*K(3)*K(5)*QF(3)*PRE)/
     &  (S34*XSW*XSW2)
        F(8,1,-1) = F(8,1,-1)-(16D0*K(3)*K(6)*QF(2)**3*PRE*XSW)/S34
        F(8,1,1) = F(8,1,1)-(32D0*K(3)*QF(2)**3*QF(3)*PRE*XSW*(XCW2+
     &  PZ34*S34*XSW2))/S34

	end

************************************************************************
        subroutine add_HZZ2233_pent(F,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for ZZ-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    down     anti-down     down     anti-down
*       pentagon corrections         
*-----------------------------------------------------------------------
*       30.12.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(10)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pz12,pz34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        COMPLEX*16 xD0_,D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        COMPLEX*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
        COMPLEX*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
        COMPLEX*16 E4n(0:4,0:4,0:4,0:4)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)
	integer i

        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)

C       Process: S1F22aF22F23aF23,   Model: SM4f

C       G(T3,N7,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(3),RMF2(3),MH2,RMF2(2),S14,S34,
     &  T13,T12,S12,CMF2(1),XMW2,CMF2(4),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*XMW*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)-E1N(4)*S12-
     &  2D0*E2N(1,4)*S12+E1N(1)*S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+
     &  2D0*E2N(1,3)*S14+2D0*E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+
     &  2D0*E2N(3,3)*(S14+S34)+E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*
     &  (2D0*S14+S34)-2D0*E2N(3,4)*(MH2-T12))
        F(2,-1,-1) = F(2,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(3,-1,-1) = F(3,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)+4D0*E2N(3,4)*PRE
        F(7,-1,-1) = F(7,-1,-1)-4D0*K(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)-E2N(3,4)*PRE
        F(11,-1,-1) = F(11,-1,-1)+K(1)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

C       G(T3,N8,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(3),RMF2(3),MH2,RMF2(2),S14,S34,
     &  T13,T12,S12,CMF2(2),NULL,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*S14+S34
        K(4) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(5) = E1N(4)+E2N(2,4)+E2N(3,4)
        K(6) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(7) = 2D0*E1N(3)+3D0*E2N(1,3)+3D0*E2N(2,3)+3D0*E2N(3,3)
        K(8) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(9) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(10) = 10D0*E2N(0,0)-E1N(4)*S12-2D0*E2N(1,4)*S12+E1N(1)*
     &  S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+2D0*E2N(1,3)*S14+2D0*
     &  E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+2D0*E2N(3,3)*(S14+S34)+
     &  E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*(2D0*S14+S34)-2D0*E2N(3,
     &  4)*(MH2-T12)

        PRE = -((QF(2)*QF(3)*ALPHA*XCW2**(-2)*XMW)/(16D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)-(4D0*K(10)*K(2)*QF(2)*PRE)/XSW
        F(1,1,1) = F(1,1,1)-8D0*K(10)*QF(2)*QF(3)*PRE*XSW
        F(2,-1,-1) = F(2,-1,-1)-(2D0*K(1)*K(2)*K(8)*PRE)/(XSW*XSW2)
        F(2,-1,1) = F(2,-1,1)-(4D0*K(1)*K(8)*QF(3)*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)-(4D0*K(2)*K(8)*QF(2)*PRE)/XSW
        F(2,1,1) = F(2,1,1)-8D0*K(8)*QF(2)*QF(3)*PRE*XSW
        F(3,-1,-1) = F(3,-1,-1)+(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(3,-1,1) = F(3,-1,1)+(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)+(4D0*K(2)*K(4)*QF(2)*PRE)/XSW
        F(3,1,1) = F(3,1,1)+8D0*K(4)*QF(2)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(4D0*K(1)*K(2)*K(7)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)-(8D0*K(1)*K(7)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(8D0*K(2)*K(7)*QF(2)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-16D0*K(7)*QF(2)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(4D0*E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(6,-1,1) = F(6,-1,1)+(8D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(8D0*E2N(3,4)*K(2)*QF(2)*PRE)/XSW
        F(6,1,1) = F(6,1,1)+16D0*E2N(3,4)*QF(2)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(4D0*K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)-(8D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(8D0*K(2)*K(9)*QF(2)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-16D0*K(9)*QF(2)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)+(4D0*K(1)*K(2)*K(5)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(8D0*K(1)*K(5)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(8D0*K(2)*K(5)*QF(2)*PRE)/XSW
        F(8,1,1) = F(8,1,1)+16D0*K(5)*QF(2)*QF(3)*PRE*XSW
        F(9,-1,-1) = F(9,-1,-1)+(K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(9,-1,1) = F(9,-1,1)+(2D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(2D0*K(2)*K(6)*QF(2)*PRE)/XSW
        F(9,1,1) = F(9,1,1)+4D0*K(6)*QF(2)*QF(3)*PRE*XSW
        F(10,-1,-1) = F(10,-1,-1)-(E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(10,-1,1) = F(10,-1,1)-(2D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)-(2D0*E2N(3,4)*K(2)*QF(2)*PRE)/XSW
        F(10,1,1) = F(10,1,1)-4D0*E2N(3,4)*QF(2)*QF(3)*PRE*XSW
        F(11,-1,-1) = F(11,-1,-1)+(K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(11,-1,1) = F(11,-1,1)+(2D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(11,1,-1) = F(11,1,-1)+(2D0*K(2)*K(9)*QF(2)*PRE)/XSW
        F(11,1,1) = F(11,1,1)+4D0*K(9)*QF(2)*QF(3)*PRE*XSW
        F(12,-1,-1) = F(12,-1,-1)-((E2N(2,4)+E2N(3,4))*K(1)*K(2)*
     &  PRE)/(XSW*XSW2)
        F(12,-1,1) = F(12,-1,1)-(2D0*(E2N(2,4)+E2N(3,4))*K(1)*QF(3)*
     &  PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(2D0*(E2N(2,4)+E2N(3,4))*K(2)*QF(2)*
     &  PRE)/XSW
        F(12,1,1) = F(12,1,1)-4D0*(E2N(2,4)+E2N(3,4))*QF(2)*QF(3)*
     &  PRE*XSW
        F(13,-1,-1) = F(13,-1,-1)+(E2N(0,0)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(13,-1,1) = F(13,-1,1)+(2D0*E2N(0,0)*K(1)*QF(3)*PRE)/XSW
        F(13,1,-1) = F(13,1,-1)+(2D0*E2N(0,0)*K(2)*QF(2)*PRE)/XSW
        F(13,1,1) = F(13,1,1)+4D0*E2N(0,0)*QF(2)*QF(3)*PRE*XSW

C       G(T3,N9,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(3),RMF2(3),MH2,RMF2(2),S14,S34,
     &  T13,T12,S12,CMF2(2),XMZ2,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*S14+S34
        K(4) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(5) = E1N(4)+E2N(2,4)+E2N(3,4)
        K(6) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(7) = 2D0*E1N(3)+3D0*E2N(1,3)+3D0*E2N(2,3)+3D0*E2N(3,3)
        K(8) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(9) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(10) = 10D0*E2N(0,0)-E1N(4)*S12-2D0*E2N(1,4)*S12+E1N(1)*
     &  S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+2D0*E2N(1,3)*S14+2D0*
     &  E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+2D0*E2N(3,3)*(S14+S34)+
     &  E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*(2D0*S14+S34)-2D0*E2N(3,
     &  4)*(MH2-T12)

        PRE = -((ALPHA*XCW2**(-3)*XMW)/(64D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(2D0*K(1)**2*K(10)*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(1,-1,1) = F(1,-1,1)-(8D0*K(1)**2*K(10)*QF(3)**2*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)-(8D0*K(10)*K(2)**2*QF(2)**2*PRE)/XSW
        F(1,1,1) = F(1,1,1)-32D0*K(10)*QF(2)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(2,-1,-1) = F(2,-1,-1)-(2D0*K(1)**2*K(2)**2*K(8)*PRE*XSW2**
     &  (-2))/XSW
        F(2,-1,1) = F(2,-1,1)-(8D0*K(1)**2*K(8)*QF(3)**2*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)-(8D0*K(2)**2*K(8)*QF(2)**2*PRE)/XSW
        F(2,1,1) = F(2,1,1)-32D0*K(8)*QF(2)**2*QF(3)**2*PRE*XSW*XSW2
        F(3,-1,-1) = F(3,-1,-1)+(2D0*K(1)**2*K(2)**2*K(4)*PRE*XSW2**
     &  (-2))/XSW
        F(3,-1,1) = F(3,-1,1)+(8D0*K(1)**2*K(4)*QF(3)**2*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)+(8D0*K(2)**2*K(4)*QF(2)**2*PRE)/XSW
        F(3,1,1) = F(3,1,1)+32D0*K(4)*QF(2)**2*QF(3)**2*PRE*XSW*XSW2
        F(5,-1,-1) = F(5,-1,-1)-(4D0*K(1)**2*K(2)**2*K(7)*PRE*XSW2**
     &  (-2))/XSW
        F(5,-1,1) = F(5,-1,1)-(16D0*K(1)**2*K(7)*QF(3)**2*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(16D0*K(2)**2*K(7)*QF(2)**2*PRE)/XSW
        F(5,1,1) = F(5,1,1)-64D0*K(7)*QF(2)**2*QF(3)**2*PRE*XSW*XSW2
        F(6,-1,-1) = F(6,-1,-1)+(4D0*E2N(3,4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(6,-1,1) = F(6,-1,1)+(16D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(6,1,-1) = F(6,1,-1)+(16D0*E2N(3,4)*K(2)**2*QF(2)**2*PRE)/
     &  XSW
        F(6,1,1) = F(6,1,1)+64D0*E2N(3,4)*QF(2)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(7,-1,-1) = F(7,-1,-1)-(4D0*K(1)**2*K(2)**2*K(9)*PRE*XSW2**
     &  (-2))/XSW
        F(7,-1,1) = F(7,-1,1)-(16D0*K(1)**2*K(9)*QF(3)**2*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(16D0*K(2)**2*K(9)*QF(2)**2*PRE)/XSW
        F(7,1,1) = F(7,1,1)-64D0*K(9)*QF(2)**2*QF(3)**2*PRE*XSW*XSW2
        F(8,-1,-1) = F(8,-1,-1)+(4D0*K(1)**2*K(2)**2*K(5)*PRE*XSW2**
     &  (-2))/XSW
        F(8,-1,1) = F(8,-1,1)+(16D0*K(1)**2*K(5)*QF(3)**2*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(16D0*K(2)**2*K(5)*QF(2)**2*PRE)/XSW
        F(8,1,1) = F(8,1,1)+64D0*K(5)*QF(2)**2*QF(3)**2*PRE*XSW*XSW2
        F(9,-1,-1) = F(9,-1,-1)+(K(1)**2*K(2)**2*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(9,-1,1) = F(9,-1,1)+(4D0*K(1)**2*K(6)*QF(3)**2*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(4D0*K(2)**2*K(6)*QF(2)**2*PRE)/XSW
        F(9,1,1) = F(9,1,1)+16D0*K(6)*QF(2)**2*QF(3)**2*PRE*XSW*XSW2
        F(10,-1,-1) = F(10,-1,-1)-(E2N(3,4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(10,-1,1) = F(10,-1,1)-(4D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(10,1,-1) = F(10,1,-1)-(4D0*E2N(3,4)*K(2)**2*QF(2)**2*PRE)/
     &  XSW
        F(10,1,1) = F(10,1,1)-16D0*E2N(3,4)*QF(2)**2*QF(3)**2*PRE*
     &  XSW*XSW2
        F(11,-1,-1) = F(11,-1,-1)+(K(1)**2*K(2)**2*K(9)*PRE*XSW2**(-
     &  2))/XSW
        F(11,-1,1) = F(11,-1,1)+(4D0*K(1)**2*K(9)*QF(3)**2*PRE)/XSW
        F(11,1,-1) = F(11,1,-1)+(4D0*K(2)**2*K(9)*QF(2)**2*PRE)/XSW
        F(11,1,1) = F(11,1,1)+16D0*K(9)*QF(2)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(12,-1,-1) = F(12,-1,-1)-((E2N(2,4)+E2N(3,4))*K(1)**2*
     &  K(2)**2*PRE*XSW2**(-2))/XSW
        F(12,-1,1) = F(12,-1,1)-(4D0*(E2N(2,4)+E2N(3,4))*K(1)**2*
     &  QF(3)**2*PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(4D0*(E2N(2,4)+E2N(3,4))*K(2)**2*
     &  QF(2)**2*PRE)/XSW
        F(12,1,1) = F(12,1,1)-16D0*(E2N(2,4)+E2N(3,4))*QF(2)**2*
     &  QF(3)**2*PRE*XSW*XSW2
        F(13,-1,-1) = F(13,-1,-1)+(E2N(0,0)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(13,-1,1) = F(13,-1,1)+(4D0*E2N(0,0)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(13,1,-1) = F(13,1,-1)+(4D0*E2N(0,0)*K(2)**2*QF(2)**2*PRE)/
     &  XSW
        F(13,1,1) = F(13,1,1)+16D0*E2N(0,0)*QF(2)**2*QF(3)**2*PRE*
     &  XSW*XSW2

C       G(T8,N26,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(3),RMF2(3),MH2,RMF2(2),S24,S34,
     &  T13,T11,S12,CMF2(2),NULL,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(4) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(5) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(6) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = (QF(2)*QF(3)*ALPHA*XCW2**(-2)*XMW)/(16D0*PI)

        F(1,-1,-1) = F(1,-1,-1)-(2D0*K(1)*K(2)*PRE*(-(2D0*E2N(3,4)*
     &  S13)+E1N(1)*S24))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(4D0*K(1)*QF(3)*PRE*(-(2D0*E2N(3,4)*
     &  S13)+E1N(1)*S24))/XSW
        F(1,1,-1) = F(1,1,-1)-(4D0*K(2)*QF(2)*PRE*(-(2D0*E2N(3,4)*
     &  S13)+E1N(1)*S24))/XSW
        F(1,1,1) = F(1,1,1)-8D0*QF(2)*QF(3)*PRE*(-(2D0*E2N(3,4)*
     &  S13)+E1N(1)*S24)*XSW
        F(2,-1,-1) = F(2,-1,-1)+(2D0*K(1)*K(2)*K(5)*PRE)/(XSW*XSW2)
        F(2,-1,1) = F(2,-1,1)+(4D0*K(1)*K(5)*QF(3)*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(4D0*K(2)*K(5)*QF(2)*PRE)/XSW
        F(2,1,1) = F(2,1,1)+8D0*K(5)*QF(2)*QF(3)*PRE*XSW
        F(3,-1,-1) = F(3,-1,-1)-(2D0*K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(3,-1,1) = F(3,-1,1)-(4D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(4D0*K(2)*K(3)*QF(2)*PRE)/XSW
        F(3,1,1) = F(3,1,1)-8D0*K(3)*QF(2)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(8D0*E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(5,-1,1) = F(5,-1,1)-(16D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(16D0*E2N(3,4)*K(2)*QF(2)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-32D0*E2N(3,4)*QF(2)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(4D0*E1N(3)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(6,-1,1) = F(6,-1,1)+(8D0*E1N(3)*K(1)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(8D0*E1N(3)*K(2)*QF(2)*PRE)/XSW
        F(6,1,1) = F(6,1,1)+16D0*E1N(3)*QF(2)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(4D0*E1N(4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(7,-1,1) = F(7,-1,1)+(8D0*E1N(4)*K(1)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(8D0*E1N(4)*K(2)*QF(2)*PRE)/XSW
        F(7,1,1) = F(7,1,1)+16D0*E1N(4)*QF(2)*QF(3)*PRE*XSW
        F(9,-1,-1) = F(9,-1,-1)+(E2N(3,4)*K(1)*K(2)*PRE)/(XSW*XSW2)
        F(9,-1,1) = F(9,-1,1)+(2D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(2D0*E2N(3,4)*K(2)*QF(2)*PRE)/XSW
        F(9,1,1) = F(9,1,1)+4D0*E2N(3,4)*QF(2)*QF(3)*PRE*XSW
        F(10,-1,-1) = F(10,-1,-1)-(K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(10,-1,1) = F(10,-1,1)-(2D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)-(2D0*K(2)*K(4)*QF(2)*PRE)/XSW
        F(10,1,1) = F(10,1,1)-4D0*K(4)*QF(2)*QF(3)*PRE*XSW
        F(11,-1,-1) = F(11,-1,-1)+((E2N(2,4)+E2N(3,4))*K(1)*K(2)*
     &  PRE)/(XSW*XSW2)
        F(11,-1,1) = F(11,-1,1)+(2D0*(E2N(2,4)+E2N(3,4))*K(1)*QF(3)*
     &  PRE)/XSW
        F(11,1,-1) = F(11,1,-1)+(2D0*(E2N(2,4)+E2N(3,4))*K(2)*QF(2)*
     &  PRE)/XSW
        F(11,1,1) = F(11,1,1)+4D0*(E2N(2,4)+E2N(3,4))*QF(2)*QF(3)*
     &  PRE*XSW
        F(12,-1,-1) = F(12,-1,-1)-(K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(12,-1,1) = F(12,-1,1)-(2D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(2D0*K(2)*K(6)*QF(2)*PRE)/XSW
        F(12,1,1) = F(12,1,1)-4D0*K(6)*QF(2)*QF(3)*PRE*XSW
        F(13,-1,-1) = F(13,-1,-1)-(E2N(0,0)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(13,-1,1) = F(13,-1,1)-(2D0*E2N(0,0)*K(1)*QF(3)*PRE)/XSW
        F(13,1,-1) = F(13,1,-1)-(2D0*E2N(0,0)*K(2)*QF(2)*PRE)/XSW
        F(13,1,1) = F(13,1,1)-4D0*E2N(0,0)*QF(2)*QF(3)*PRE*XSW

C       G(T8,N27,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(3),RMF2(3),MH2,RMF2(2),S24,S34,
     &  T13,T11,S12,CMF2(2),XMZ2,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(4) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(5) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(6) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = (ALPHA*XCW2**(-3)*XMW)/(64D0*PI)

        F(1,-1,-1) = F(1,-1,-1)-(2D0*K(1)**2*K(2)**2*PRE*(-(2D0*
     &  E2N(3,4)*S13)+E1N(1)*S24)*XSW2**(-2))/XSW
        F(1,-1,1) = F(1,-1,1)-(8D0*K(1)**2*QF(3)**2*PRE*(-(2D0*
     &  E2N(3,4)*S13)+E1N(1)*S24))/XSW
        F(1,1,-1) = F(1,1,-1)-(8D0*K(2)**2*QF(2)**2*PRE*(-(2D0*
     &  E2N(3,4)*S13)+E1N(1)*S24))/XSW
        F(1,1,1) = F(1,1,1)-32D0*QF(2)**2*QF(3)**2*PRE*(-(2D0*E2N(3,
     &  4)*S13)+E1N(1)*S24)*XSW*XSW2
        F(2,-1,-1) = F(2,-1,-1)+(2D0*K(1)**2*K(2)**2*K(5)*PRE*XSW2**
     &  (-2))/XSW
        F(2,-1,1) = F(2,-1,1)+(8D0*K(1)**2*K(5)*QF(3)**2*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(8D0*K(2)**2*K(5)*QF(2)**2*PRE)/XSW
        F(2,1,1) = F(2,1,1)+32D0*K(5)*QF(2)**2*QF(3)**2*PRE*XSW*XSW2
        F(3,-1,-1) = F(3,-1,-1)-(2D0*K(1)**2*K(2)**2*K(3)*PRE*XSW2**
     &  (-2))/XSW
        F(3,-1,1) = F(3,-1,1)-(8D0*K(1)**2*K(3)*QF(3)**2*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(8D0*K(2)**2*K(3)*QF(2)**2*PRE)/XSW
        F(3,1,1) = F(3,1,1)-32D0*K(3)*QF(2)**2*QF(3)**2*PRE*XSW*XSW2
        F(5,-1,-1) = F(5,-1,-1)-(8D0*E2N(3,4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(5,-1,1) = F(5,-1,1)-(32D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(5,1,-1) = F(5,1,-1)-(32D0*E2N(3,4)*K(2)**2*QF(2)**2*PRE)/
     &  XSW
        F(5,1,1) = F(5,1,1)-128D0*E2N(3,4)*QF(2)**2*QF(3)**2*PRE*
     &  XSW*XSW2
        F(6,-1,-1) = F(6,-1,-1)+(4D0*E1N(3)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(6,-1,1) = F(6,-1,1)+(16D0*E1N(3)*K(1)**2*QF(3)**2*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(16D0*E1N(3)*K(2)**2*QF(2)**2*PRE)/XSW
        F(6,1,1) = F(6,1,1)+64D0*E1N(3)*QF(2)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(7,-1,-1) = F(7,-1,-1)+(4D0*E1N(4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(7,-1,1) = F(7,-1,1)+(16D0*E1N(4)*K(1)**2*QF(3)**2*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(16D0*E1N(4)*K(2)**2*QF(2)**2*PRE)/XSW
        F(7,1,1) = F(7,1,1)+64D0*E1N(4)*QF(2)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(9,-1,-1) = F(9,-1,-1)+(E2N(3,4)*K(1)**2*K(2)**2*PRE*XSW2**
     &  (-2))/XSW
        F(9,-1,1) = F(9,-1,1)+(4D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(9,1,-1) = F(9,1,-1)+(4D0*E2N(3,4)*K(2)**2*QF(2)**2*PRE)/
     &  XSW
        F(9,1,1) = F(9,1,1)+16D0*E2N(3,4)*QF(2)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(10,-1,-1) = F(10,-1,-1)-(K(1)**2*K(2)**2*K(4)*PRE*XSW2**(-
     &  2))/XSW
        F(10,-1,1) = F(10,-1,1)-(4D0*K(1)**2*K(4)*QF(3)**2*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)-(4D0*K(2)**2*K(4)*QF(2)**2*PRE)/XSW
        F(10,1,1) = F(10,1,1)-16D0*K(4)*QF(2)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(11,-1,-1) = F(11,-1,-1)+((E2N(2,4)+E2N(3,4))*K(1)**2*
     &  K(2)**2*PRE*XSW2**(-2))/XSW
        F(11,-1,1) = F(11,-1,1)+(4D0*(E2N(2,4)+E2N(3,4))*K(1)**2*
     &  QF(3)**2*PRE)/XSW
        F(11,1,-1) = F(11,1,-1)+(4D0*(E2N(2,4)+E2N(3,4))*K(2)**2*
     &  QF(2)**2*PRE)/XSW
        F(11,1,1) = F(11,1,1)+16D0*(E2N(2,4)+E2N(3,4))*QF(2)**2*
     &  QF(3)**2*PRE*XSW*XSW2
        F(12,-1,-1) = F(12,-1,-1)-(K(1)**2*K(2)**2*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(12,-1,1) = F(12,-1,1)-(4D0*K(1)**2*K(6)*QF(3)**2*PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(4D0*K(2)**2*K(6)*QF(2)**2*PRE)/XSW
        F(12,1,1) = F(12,1,1)-16D0*K(6)*QF(2)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(13,-1,-1) = F(13,-1,-1)-(E2N(0,0)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(13,-1,1) = F(13,-1,1)-(4D0*E2N(0,0)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(13,1,-1) = F(13,1,-1)-(4D0*E2N(0,0)*K(2)**2*QF(2)**2*PRE)/
     &  XSW
        F(13,1,1) = F(13,1,1)-16D0*E2N(0,0)*QF(2)**2*QF(3)**2*PRE*
     &  XSW*XSW2

C       G(T2,N5,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(2),MH2,RMF2(3),S13,S12,
     &  T12,T14,S34,CMF2(3),NULL,CMF2(2),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(4) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(5) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(6) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(7) = E1N(1)+2D0*E1N(2)+2D0*E1N(3)+2D0*E2N(1,2)+2D0*E2N(1,
     &  3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*E2N(3,3)

        PRE = -((QF(2)*QF(3)*ALPHA*XCW2**(-2)*XMW)/(16D0*PI))

        F(1,-1,-1) = F(1,-1,-1)+(2D0*K(1)*K(2)*K(7)*PRE*S13)/(XSW*
     &  XSW2)
        F(1,-1,1) = F(1,-1,1)+(4D0*K(1)*K(7)*QF(3)*PRE*S13)/XSW
        F(1,1,-1) = F(1,1,-1)+(4D0*K(2)*K(7)*QF(2)*PRE*S13)/XSW
        F(1,1,1) = F(1,1,1)+8D0*K(7)*QF(2)*QF(3)*PRE*S13*XSW
        F(2,-1,-1) = F(2,-1,-1)+(2D0*K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(2,-1,1) = F(2,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(4D0*K(2)*K(3)*QF(2)*PRE)/XSW
        F(2,1,1) = F(2,1,1)+8D0*K(3)*QF(2)*QF(3)*PRE*XSW
        F(3,-1,-1) = F(3,-1,-1)-(2D0*K(1)*K(2)*K(5)*PRE)/(XSW*XSW2)
        F(3,-1,1) = F(3,-1,1)-(4D0*K(1)*K(5)*QF(3)*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(4D0*K(2)*K(5)*QF(2)*PRE)/XSW
        F(3,1,1) = F(3,1,1)-8D0*K(5)*QF(2)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(8D0*K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)-(16D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(16D0*K(2)*K(6)*QF(2)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-32D0*K(6)*QF(2)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(4D0*E1N(3)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(6,-1,1) = F(6,-1,1)-(8D0*E1N(3)*K(1)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(8D0*E1N(3)*K(2)*QF(2)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-16D0*E1N(3)*QF(2)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(4D0*E1N(4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(7,-1,1) = F(7,-1,1)-(8D0*E1N(4)*K(1)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(8D0*E1N(4)*K(2)*QF(2)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-16D0*E1N(4)*QF(2)*QF(3)*PRE*XSW
        F(9,-1,-1) = F(9,-1,-1)+(K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(9,-1,1) = F(9,-1,1)+(2D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(2D0*K(2)*K(6)*QF(2)*PRE)/XSW
        F(9,1,1) = F(9,1,1)+4D0*K(6)*QF(2)*QF(3)*PRE*XSW
        F(10,-1,-1) = F(10,-1,-1)+(K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(10,-1,1) = F(10,-1,1)+(2D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)+(2D0*K(2)*K(4)*QF(2)*PRE)/XSW
        F(10,1,1) = F(10,1,1)+4D0*K(4)*QF(2)*QF(3)*PRE*XSW
        F(11,-1,-1) = F(11,-1,-1)-((E2N(2,4)+E2N(3,4))*K(1)*K(2)*
     &  PRE)/(XSW*XSW2)
        F(11,-1,1) = F(11,-1,1)-(2D0*(E2N(2,4)+E2N(3,4))*K(1)*QF(3)*
     &  PRE)/XSW
        F(11,1,-1) = F(11,1,-1)-(2D0*(E2N(2,4)+E2N(3,4))*K(2)*QF(2)*
     &  PRE)/XSW
        F(11,1,1) = F(11,1,1)-4D0*(E2N(2,4)+E2N(3,4))*QF(2)*QF(3)*
     &  PRE*XSW
        F(12,-1,-1) = F(12,-1,-1)-(E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(12,-1,1) = F(12,-1,1)-(2D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(2D0*E2N(3,4)*K(2)*QF(2)*PRE)/XSW
        F(12,1,1) = F(12,1,1)-4D0*E2N(3,4)*QF(2)*QF(3)*PRE*XSW
        F(13,-1,-1) = F(13,-1,-1)+(E2N(0,0)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(13,-1,1) = F(13,-1,1)+(2D0*E2N(0,0)*K(1)*QF(3)*PRE)/XSW
        F(13,1,-1) = F(13,1,-1)+(2D0*E2N(0,0)*K(2)*QF(2)*PRE)/XSW
        F(13,1,1) = F(13,1,1)+4D0*E2N(0,0)*QF(2)*QF(3)*PRE*XSW

C       G(T2,N6,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(2),MH2,RMF2(3),S13,S12,
     &  T12,T14,S34,CMF2(3),XMZ2,CMF2(2),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(4) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(5) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(6) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(7) = E1N(1)+2D0*E1N(2)+2D0*E1N(3)+2D0*E2N(1,2)+2D0*E2N(1,
     &  3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*E2N(3,3)

        PRE = -((ALPHA*XCW2**(-3)*XMW)/(64D0*PI))

        F(1,-1,-1) = F(1,-1,-1)+(2D0*K(1)**2*K(2)**2*K(7)*PRE*S13*
     &  XSW2**(-2))/XSW
        F(1,-1,1) = F(1,-1,1)+(8D0*K(1)**2*K(7)*QF(3)**2*PRE*S13)/
     &  XSW
        F(1,1,-1) = F(1,1,-1)+(8D0*K(2)**2*K(7)*QF(2)**2*PRE*S13)/
     &  XSW
        F(1,1,1) = F(1,1,1)+32D0*K(7)*QF(2)**2*QF(3)**2*PRE*S13*XSW*
     &  XSW2
        F(2,-1,-1) = F(2,-1,-1)+(2D0*K(1)**2*K(2)**2*K(3)*PRE*XSW2**
     &  (-2))/XSW
        F(2,-1,1) = F(2,-1,1)+(8D0*K(1)**2*K(3)*QF(3)**2*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(8D0*K(2)**2*K(3)*QF(2)**2*PRE)/XSW
        F(2,1,1) = F(2,1,1)+32D0*K(3)*QF(2)**2*QF(3)**2*PRE*XSW*XSW2
        F(3,-1,-1) = F(3,-1,-1)-(2D0*K(1)**2*K(2)**2*K(5)*PRE*XSW2**
     &  (-2))/XSW
        F(3,-1,1) = F(3,-1,1)-(8D0*K(1)**2*K(5)*QF(3)**2*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(8D0*K(2)**2*K(5)*QF(2)**2*PRE)/XSW
        F(3,1,1) = F(3,1,1)-32D0*K(5)*QF(2)**2*QF(3)**2*PRE*XSW*XSW2
        F(5,-1,-1) = F(5,-1,-1)-(8D0*K(1)**2*K(2)**2*K(6)*PRE*XSW2**
     &  (-2))/XSW
        F(5,-1,1) = F(5,-1,1)-(32D0*K(1)**2*K(6)*QF(3)**2*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(32D0*K(2)**2*K(6)*QF(2)**2*PRE)/XSW
        F(5,1,1) = F(5,1,1)-128D0*K(6)*QF(2)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(6,-1,-1) = F(6,-1,-1)-(4D0*E1N(3)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(6,-1,1) = F(6,-1,1)-(16D0*E1N(3)*K(1)**2*QF(3)**2*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(16D0*E1N(3)*K(2)**2*QF(2)**2*PRE)/XSW
        F(6,1,1) = F(6,1,1)-64D0*E1N(3)*QF(2)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(7,-1,-1) = F(7,-1,-1)-(4D0*E1N(4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(7,-1,1) = F(7,-1,1)-(16D0*E1N(4)*K(1)**2*QF(3)**2*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(16D0*E1N(4)*K(2)**2*QF(2)**2*PRE)/XSW
        F(7,1,1) = F(7,1,1)-64D0*E1N(4)*QF(2)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(9,-1,-1) = F(9,-1,-1)+(K(1)**2*K(2)**2*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(9,-1,1) = F(9,-1,1)+(4D0*K(1)**2*K(6)*QF(3)**2*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(4D0*K(2)**2*K(6)*QF(2)**2*PRE)/XSW
        F(9,1,1) = F(9,1,1)+16D0*K(6)*QF(2)**2*QF(3)**2*PRE*XSW*XSW2
        F(10,-1,-1) = F(10,-1,-1)+(K(1)**2*K(2)**2*K(4)*PRE*XSW2**(-
     &  2))/XSW
        F(10,-1,1) = F(10,-1,1)+(4D0*K(1)**2*K(4)*QF(3)**2*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)+(4D0*K(2)**2*K(4)*QF(2)**2*PRE)/XSW
        F(10,1,1) = F(10,1,1)+16D0*K(4)*QF(2)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(11,-1,-1) = F(11,-1,-1)-((E2N(2,4)+E2N(3,4))*K(1)**2*
     &  K(2)**2*PRE*XSW2**(-2))/XSW
        F(11,-1,1) = F(11,-1,1)-(4D0*(E2N(2,4)+E2N(3,4))*K(1)**2*
     &  QF(3)**2*PRE)/XSW
        F(11,1,-1) = F(11,1,-1)-(4D0*(E2N(2,4)+E2N(3,4))*K(2)**2*
     &  QF(2)**2*PRE)/XSW
        F(11,1,1) = F(11,1,1)-16D0*(E2N(2,4)+E2N(3,4))*QF(2)**2*
     &  QF(3)**2*PRE*XSW*XSW2
        F(12,-1,-1) = F(12,-1,-1)-(E2N(3,4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(12,-1,1) = F(12,-1,1)-(4D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(12,1,-1) = F(12,1,-1)-(4D0*E2N(3,4)*K(2)**2*QF(2)**2*PRE)/
     &  XSW
        F(12,1,1) = F(12,1,1)-16D0*E2N(3,4)*QF(2)**2*QF(3)**2*PRE*
     &  XSW*XSW2
        F(13,-1,-1) = F(13,-1,-1)+(E2N(0,0)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(13,-1,1) = F(13,-1,1)+(4D0*E2N(0,0)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(13,1,-1) = F(13,1,-1)+(4D0*E2N(0,0)*K(2)**2*QF(2)**2*PRE)/
     &  XSW
        F(13,1,1) = F(13,1,1)+16D0*E2N(0,0)*QF(2)**2*QF(3)**2*PRE*
     &  XSW*XSW2

C       G(T10,N32,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(2),MH2,RMF2(3),S23,S12,
     &  T11,T14,S34,CMF2(3),NULL,CMF2(2),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S12+2D0*S23
        K(4) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(5) = E1N(4)+E2N(2,4)+E2N(3,4)
        K(6) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(7) = 2D0*E1N(3)+3D0*E2N(1,3)+3D0*E2N(2,3)+3D0*E2N(3,3)
        K(8) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(9) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(10) = 10D0*E2N(0,0)+E1N(1)*S23+2D0*E1N(2)*S23+2D0*E2N(1,
     &  2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,2)*S23+2D0*E2N(3,3)*(S12+
     &  S23)+E1N(3)*(S12+2D0*S23)+2D0*E2N(2,3)*(S12+2D0*S23)-E1N(4)*
     &  S34-2D0*E2N(1,4)*S34-2D0*E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*
     &  (MH2-T14)

        PRE = -((QF(2)*QF(3)*ALPHA*XCW2**(-2)*XMW)/(16D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)-(4D0*K(10)*K(2)*QF(2)*PRE)/XSW
        F(1,1,1) = F(1,1,1)-8D0*K(10)*QF(2)*QF(3)*PRE*XSW
        F(2,-1,-1) = F(2,-1,-1)+(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(2,-1,1) = F(2,-1,1)+(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(4D0*K(2)*K(4)*QF(2)*PRE)/XSW
        F(2,1,1) = F(2,1,1)+8D0*K(4)*QF(2)*QF(3)*PRE*XSW
        F(3,-1,-1) = F(3,-1,-1)-(2D0*K(1)*K(2)*K(8)*PRE)/(XSW*XSW2)
        F(3,-1,1) = F(3,-1,1)-(4D0*K(1)*K(8)*QF(3)*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(4D0*K(2)*K(8)*QF(2)*PRE)/XSW
        F(3,1,1) = F(3,1,1)-8D0*K(8)*QF(2)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(4D0*K(1)*K(2)*K(7)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)-(8D0*K(1)*K(7)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(8D0*K(2)*K(7)*QF(2)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-16D0*K(7)*QF(2)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(4D0*K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)-(8D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(8D0*K(2)*K(9)*QF(2)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-16D0*K(9)*QF(2)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(4D0*E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(7,-1,1) = F(7,-1,1)+(8D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(8D0*E2N(3,4)*K(2)*QF(2)*PRE)/XSW
        F(7,1,1) = F(7,1,1)+16D0*E2N(3,4)*QF(2)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)+(4D0*K(1)*K(2)*K(5)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(8D0*K(1)*K(5)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(8D0*K(2)*K(5)*QF(2)*PRE)/XSW
        F(8,1,1) = F(8,1,1)+16D0*K(5)*QF(2)*QF(3)*PRE*XSW
        F(9,-1,-1) = F(9,-1,-1)+(K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(9,-1,1) = F(9,-1,1)+(2D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(2D0*K(2)*K(6)*QF(2)*PRE)/XSW
        F(9,1,1) = F(9,1,1)+4D0*K(6)*QF(2)*QF(3)*PRE*XSW
        F(10,-1,-1) = F(10,-1,-1)+(K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(10,-1,1) = F(10,-1,1)+(2D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)+(2D0*K(2)*K(9)*QF(2)*PRE)/XSW
        F(10,1,1) = F(10,1,1)+4D0*K(9)*QF(2)*QF(3)*PRE*XSW
        F(11,-1,-1) = F(11,-1,-1)-(E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(11,-1,1) = F(11,-1,1)-(2D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(11,1,-1) = F(11,1,-1)-(2D0*E2N(3,4)*K(2)*QF(2)*PRE)/XSW
        F(11,1,1) = F(11,1,1)-4D0*E2N(3,4)*QF(2)*QF(3)*PRE*XSW
        F(12,-1,-1) = F(12,-1,-1)-((E2N(2,4)+E2N(3,4))*K(1)*K(2)*
     &  PRE)/(XSW*XSW2)
        F(12,-1,1) = F(12,-1,1)-(2D0*(E2N(2,4)+E2N(3,4))*K(1)*QF(3)*
     &  PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(2D0*(E2N(2,4)+E2N(3,4))*K(2)*QF(2)*
     &  PRE)/XSW
        F(12,1,1) = F(12,1,1)-4D0*(E2N(2,4)+E2N(3,4))*QF(2)*QF(3)*
     &  PRE*XSW
        F(13,-1,-1) = F(13,-1,-1)+(E2N(0,0)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(13,-1,1) = F(13,-1,1)+(2D0*E2N(0,0)*K(1)*QF(3)*PRE)/XSW
        F(13,1,-1) = F(13,1,-1)+(2D0*E2N(0,0)*K(2)*QF(2)*PRE)/XSW
        F(13,1,1) = F(13,1,1)+4D0*E2N(0,0)*QF(2)*QF(3)*PRE*XSW

C       G(T10,N33,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(2),MH2,RMF2(3),S23,S12,
     &  T11,T14,S34,CMF2(3),XMZ2,CMF2(2),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S12+2D0*S23
        K(4) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(5) = E1N(4)+E2N(2,4)+E2N(3,4)
        K(6) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(7) = 2D0*E1N(3)+3D0*E2N(1,3)+3D0*E2N(2,3)+3D0*E2N(3,3)
        K(8) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(9) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(10) = 10D0*E2N(0,0)+E1N(1)*S23+2D0*E1N(2)*S23+2D0*E2N(1,
     &  2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,2)*S23+2D0*E2N(3,3)*(S12+
     &  S23)+E1N(3)*(S12+2D0*S23)+2D0*E2N(2,3)*(S12+2D0*S23)-E1N(4)*
     &  S34-2D0*E2N(1,4)*S34-2D0*E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*
     &  (MH2-T14)

        PRE = -((ALPHA*XCW2**(-3)*XMW)/(64D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(2D0*K(1)**2*K(10)*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(1,-1,1) = F(1,-1,1)-(8D0*K(1)**2*K(10)*QF(3)**2*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)-(8D0*K(10)*K(2)**2*QF(2)**2*PRE)/XSW
        F(1,1,1) = F(1,1,1)-32D0*K(10)*QF(2)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(2,-1,-1) = F(2,-1,-1)+(2D0*K(1)**2*K(2)**2*K(4)*PRE*XSW2**
     &  (-2))/XSW
        F(2,-1,1) = F(2,-1,1)+(8D0*K(1)**2*K(4)*QF(3)**2*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(8D0*K(2)**2*K(4)*QF(2)**2*PRE)/XSW
        F(2,1,1) = F(2,1,1)+32D0*K(4)*QF(2)**2*QF(3)**2*PRE*XSW*XSW2
        F(3,-1,-1) = F(3,-1,-1)-(2D0*K(1)**2*K(2)**2*K(8)*PRE*XSW2**
     &  (-2))/XSW
        F(3,-1,1) = F(3,-1,1)-(8D0*K(1)**2*K(8)*QF(3)**2*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(8D0*K(2)**2*K(8)*QF(2)**2*PRE)/XSW
        F(3,1,1) = F(3,1,1)-32D0*K(8)*QF(2)**2*QF(3)**2*PRE*XSW*XSW2
        F(5,-1,-1) = F(5,-1,-1)-(4D0*K(1)**2*K(2)**2*K(7)*PRE*XSW2**
     &  (-2))/XSW
        F(5,-1,1) = F(5,-1,1)-(16D0*K(1)**2*K(7)*QF(3)**2*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(16D0*K(2)**2*K(7)*QF(2)**2*PRE)/XSW
        F(5,1,1) = F(5,1,1)-64D0*K(7)*QF(2)**2*QF(3)**2*PRE*XSW*XSW2
        F(6,-1,-1) = F(6,-1,-1)-(4D0*K(1)**2*K(2)**2*K(9)*PRE*XSW2**
     &  (-2))/XSW
        F(6,-1,1) = F(6,-1,1)-(16D0*K(1)**2*K(9)*QF(3)**2*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(16D0*K(2)**2*K(9)*QF(2)**2*PRE)/XSW
        F(6,1,1) = F(6,1,1)-64D0*K(9)*QF(2)**2*QF(3)**2*PRE*XSW*XSW2
        F(7,-1,-1) = F(7,-1,-1)+(4D0*E2N(3,4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(7,-1,1) = F(7,-1,1)+(16D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(7,1,-1) = F(7,1,-1)+(16D0*E2N(3,4)*K(2)**2*QF(2)**2*PRE)/
     &  XSW
        F(7,1,1) = F(7,1,1)+64D0*E2N(3,4)*QF(2)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(8,-1,-1) = F(8,-1,-1)+(4D0*K(1)**2*K(2)**2*K(5)*PRE*XSW2**
     &  (-2))/XSW
        F(8,-1,1) = F(8,-1,1)+(16D0*K(1)**2*K(5)*QF(3)**2*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(16D0*K(2)**2*K(5)*QF(2)**2*PRE)/XSW
        F(8,1,1) = F(8,1,1)+64D0*K(5)*QF(2)**2*QF(3)**2*PRE*XSW*XSW2
        F(9,-1,-1) = F(9,-1,-1)+(K(1)**2*K(2)**2*K(6)*PRE*XSW2**(-
     &  2))/XSW
        F(9,-1,1) = F(9,-1,1)+(4D0*K(1)**2*K(6)*QF(3)**2*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(4D0*K(2)**2*K(6)*QF(2)**2*PRE)/XSW
        F(9,1,1) = F(9,1,1)+16D0*K(6)*QF(2)**2*QF(3)**2*PRE*XSW*XSW2
        F(10,-1,-1) = F(10,-1,-1)+(K(1)**2*K(2)**2*K(9)*PRE*XSW2**(-
     &  2))/XSW
        F(10,-1,1) = F(10,-1,1)+(4D0*K(1)**2*K(9)*QF(3)**2*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)+(4D0*K(2)**2*K(9)*QF(2)**2*PRE)/XSW
        F(10,1,1) = F(10,1,1)+16D0*K(9)*QF(2)**2*QF(3)**2*PRE*XSW*
     &  XSW2
        F(11,-1,-1) = F(11,-1,-1)-(E2N(3,4)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(11,-1,1) = F(11,-1,1)-(4D0*E2N(3,4)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(11,1,-1) = F(11,1,-1)-(4D0*E2N(3,4)*K(2)**2*QF(2)**2*PRE)/
     &  XSW
        F(11,1,1) = F(11,1,1)-16D0*E2N(3,4)*QF(2)**2*QF(3)**2*PRE*
     &  XSW*XSW2
        F(12,-1,-1) = F(12,-1,-1)-((E2N(2,4)+E2N(3,4))*K(1)**2*
     &  K(2)**2*PRE*XSW2**(-2))/XSW
        F(12,-1,1) = F(12,-1,1)-(4D0*(E2N(2,4)+E2N(3,4))*K(1)**2*
     &  QF(3)**2*PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(4D0*(E2N(2,4)+E2N(3,4))*K(2)**2*
     &  QF(2)**2*PRE)/XSW
        F(12,1,1) = F(12,1,1)-16D0*(E2N(2,4)+E2N(3,4))*QF(2)**2*
     &  QF(3)**2*PRE*XSW*XSW2
        F(13,-1,-1) = F(13,-1,-1)+(E2N(0,0)*K(1)**2*K(2)**2*PRE*
     &  XSW2**(-2))/XSW
        F(13,-1,1) = F(13,-1,1)+(4D0*E2N(0,0)*K(1)**2*QF(3)**2*PRE)/
     &  XSW
        F(13,1,-1) = F(13,1,-1)+(4D0*E2N(0,0)*K(2)**2*QF(2)**2*PRE)/
     &  XSW
        F(13,1,1) = F(13,1,1)+16D0*E2N(0,0)*QF(2)**2*QF(3)**2*PRE*
     &  XSW*XSW2

C       G(T10,N34,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(2),MH2,RMF2(3),S23,S12,
     &  T11,T14,S34,CMF2(4),XMW2,CMF2(1),XMW2,XMW2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = -((ALPHA*XMW*XSW2**(-2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-2D0*PRE*(10D0*E2N(0,0)+E1N(1)*S23+
     &  2D0*E1N(2)*S23+2D0*E2N(1,2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,
     &  2)*S23+2D0*E2N(3,3)*(S12+S23)+E1N(3)*(S12+2D0*S23)+2D0*
     &  E2N(2,3)*(S12+2D0*S23)-E1N(4)*S34-2D0*E2N(1,4)*S34-2D0*
     &  E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*(MH2-T14))
        F(2,-1,-1) = F(2,-1,-1)+2D0*(E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,
     &  3))*PRE
        F(3,-1,-1) = F(3,-1,-1)-2D0*(E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,
     &  4)+2D0*E2N(3,4))*PRE
        F(5,-1,-1) = F(5,-1,-1)-4D0*(2D0*E1N(3)+3D0*E2N(1,3)+3D0*
     &  E2N(2,3)+3D0*E2N(3,3))*PRE
        F(6,-1,-1) = F(6,-1,-1)-4D0*K(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+4D0*E2N(3,4)*PRE
        F(8,-1,-1) = F(8,-1,-1)+4D0*(E1N(4)+E2N(2,4)+E2N(3,4))*PRE
        F(9,-1,-1) = F(9,-1,-1)+(E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3))*
     &  PRE
        F(10,-1,-1) = F(10,-1,-1)+K(1)*PRE
        F(11,-1,-1) = F(11,-1,-1)-E2N(3,4)*PRE
        F(12,-1,-1) = F(12,-1,-1)+(-(E2N(2,4))-E2N(3,4))*PRE
        F(13,-1,-1) = F(13,-1,-1)+E2N(0,0)*PRE

	end

************************************************************************
        subroutine add_HZZ2233_self_bgf(F,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for ZZ-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    down     anti-down     down     anti-down
*       self-energy contributions
*       boson loops only
*       background-field formalism
*-----------------------------------------------------------------------
*       30.12.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(1)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pz12,pz34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
        complex*16 dZuur,dZuul,dZddr,dZddl
        complex*16 ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl
	integer i

        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/xrenc_bgf/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &         dZuur,dZuul,dZddr,dZddl,
     &         ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl

C       Process: S10F2200aF2200F2300aF2300,   Model: SMbgf4f

C       G(T1,N6,FULL)+G(T2,N16,FULL)
        A0 = xA0_(XMH2)

        PRE = -((A0*ALPHA*PZ12*PZ34*(PZ12+PZ34)*XCW2**(-3)*XMW)/
     &  (64D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T1,N1,FULL)+G(T1,N10,FULL)+G(T1,N2,FULL)+G(T1,N3,FULL)+
C       G(T1,N4,FULL)+G(T1,N5,FULL)+G(T1,N8,FULL)+G(T1,N9,FULL)+
C       G(T2,N11,FULL)+G(T2,N12,FULL)+G(T2,N13,FULL)+G(T2,N14,FULL)+
C       G(T2,N15,FULL)+G(T2,N18,FULL)+G(T2,N19,FULL)+G(T2,N20,FULL)
        A0 = xA0_(XMW2)

        PRE = -((ALPHA*PZ12*PZ34*XMW)/(32D0*PI*S12*S34*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(-(8D0*XMW2*(PZ12*
     &  S12*S34+PZ34*S12*S34-2D0*QF(3)*S12*XSW2-2D0*QF(2)*S34*XSW2+
     &  2D0*QF(2)*PZ12*S12*S34*XSW2+2D0*QF(3)*PZ12*S12*S34*XSW2+2D0*
     &  QF(2)*PZ34*S12*S34*XSW2+2D0*QF(3)*PZ34*S12*S34*XSW2-4D0*
     &  QF(2)*QF(3)*S12*XSW2**2-4D0*QF(2)*QF(3)*S34*XSW2**2+4D0*
     &  QF(2)*QF(3)*PZ12*S12*S34*XSW2**2+4D0*QF(2)*QF(3)*PZ34*S12*
     &  S34*XSW2**2))+A0*XCW2**(-2)*(9D0*PZ12*S12*S34*XCW2**2+9D0*
     &  PZ34*S12*S34*XCW2**2-2D0*PZ12*S12*S34*XCW2*XSW2-2D0*PZ34*
     &  S12*S34*XCW2*XSW2-20D0*QF(3)*S12*XCW2**2*XSW2-20D0*QF(2)*
     &  S34*XCW2**2*XSW2+18D0*QF(2)*PZ12*S12*S34*XCW2**2*XSW2+18D0*
     &  QF(3)*PZ12*S12*S34*XCW2**2*XSW2+18D0*QF(2)*PZ34*S12*S34*
     &  XCW2**2*XSW2+18D0*QF(3)*PZ34*S12*S34*XCW2**2*XSW2+PZ12*S12*
     &  S34*XSW2**2+PZ34*S12*S34*XSW2**2+4D0*QF(3)*S12*XCW2*XSW2**2+
     &  4D0*QF(2)*S34*XCW2*XSW2**2-4D0*QF(2)*PZ12*S12*S34*XCW2*
     &  XSW2**2-4D0*QF(3)*PZ12*S12*S34*XCW2*XSW2**2-4D0*QF(2)*PZ34*
     &  S12*S34*XCW2*XSW2**2-4D0*QF(3)*PZ34*S12*S34*XCW2*XSW2**2-
     &  40D0*QF(2)*QF(3)*S12*XCW2**2*XSW2**2-40D0*QF(2)*QF(3)*S34*
     &  XCW2**2*XSW2**2+36D0*QF(2)*QF(3)*PZ12*S12*S34*XCW2**2*XSW2**
     &  2+36D0*QF(2)*QF(3)*PZ34*S12*S34*XCW2**2*XSW2**2+2D0*QF(2)*
     &  PZ12*S12*S34*XSW2**3+2D0*QF(3)*PZ12*S12*S34*XSW2**3+2D0*
     &  QF(2)*PZ34*S12*S34*XSW2**3+2D0*QF(3)*PZ34*S12*S34*XSW2**3+
     &  8D0*QF(2)*QF(3)*S12*XCW2*XSW2**3+8D0*QF(2)*QF(3)*S34*XCW2*
     &  XSW2**3-8D0*QF(2)*QF(3)*PZ12*S12*S34*XCW2*XSW2**3-8D0*QF(2)*
     &  QF(3)*PZ34*S12*S34*XCW2*XSW2**3+4D0*QF(2)*QF(3)*PZ12*S12*
     &  S34*XSW2**4+4D0*QF(2)*QF(3)*PZ34*S12*S34*XSW2**4))
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(8D0*XMW2*(S12-PZ12*
     &  S12*S34-PZ34*S12*S34+2D0*QF(2)*S12*XSW2+2D0*QF(2)*S34*XSW2-
     &  2D0*QF(2)*PZ12*S12*S34*XSW2-2D0*QF(2)*PZ34*S12*S34*XSW2)+A0*
     &  XCW2**(-2)*(-(10D0*S12*XCW2**2)+9D0*PZ12*S12*S34*XCW2**2+
     &  9D0*PZ34*S12*S34*XCW2**2+2D0*S12*XCW2*XSW2-2D0*PZ12*S12*S34*
     &  XCW2*XSW2-2D0*PZ34*S12*S34*XCW2*XSW2-20D0*QF(2)*S12*XCW2**2*
     &  XSW2-20D0*QF(2)*S34*XCW2**2*XSW2+18D0*QF(2)*PZ12*S12*S34*
     &  XCW2**2*XSW2+18D0*QF(2)*PZ34*S12*S34*XCW2**2*XSW2+PZ12*S12*
     &  S34*XSW2**2+PZ34*S12*S34*XSW2**2+4D0*QF(2)*S12*XCW2*XSW2**2+
     &  4D0*QF(2)*S34*XCW2*XSW2**2-4D0*QF(2)*PZ12*S12*S34*XCW2*
     &  XSW2**2-4D0*QF(2)*PZ34*S12*S34*XCW2*XSW2**2+2D0*QF(2)*PZ12*
     &  S12*S34*XSW2**3+2D0*QF(2)*PZ34*S12*S34*XSW2**3)))/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(8D0*XMW2*(S34-PZ12*
     &  S12*S34-PZ34*S12*S34+2D0*QF(3)*S12*XSW2+2D0*QF(3)*S34*XSW2-
     &  2D0*QF(3)*PZ12*S12*S34*XSW2-2D0*QF(3)*PZ34*S12*S34*XSW2)+A0*
     &  XCW2**(-2)*(-(10D0*S34*XCW2**2)+9D0*PZ12*S12*S34*XCW2**2+
     &  9D0*PZ34*S12*S34*XCW2**2+2D0*S34*XCW2*XSW2-2D0*PZ12*S12*S34*
     &  XCW2*XSW2-2D0*PZ34*S12*S34*XCW2*XSW2-20D0*QF(3)*S12*XCW2**2*
     &  XSW2-20D0*QF(3)*S34*XCW2**2*XSW2+18D0*QF(3)*PZ12*S12*S34*
     &  XCW2**2*XSW2+18D0*QF(3)*PZ34*S12*S34*XCW2**2*XSW2+PZ12*S12*
     &  S34*XSW2**2+PZ34*S12*S34*XSW2**2+4D0*QF(3)*S12*XCW2*XSW2**2+
     &  4D0*QF(3)*S34*XCW2*XSW2**2-4D0*QF(3)*PZ12*S12*S34*XCW2*
     &  XSW2**2-4D0*QF(3)*PZ34*S12*S34*XCW2*XSW2**2+2D0*QF(3)*PZ12*
     &  S12*S34*XSW2**3+2D0*QF(3)*PZ34*S12*S34*XSW2**3)))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(8D0*(S12+S34-PZ12*
     &  S12*S34-PZ34*S12*S34)*XMW2+A0*XCW2**(-2)*(-(10D0*S12*XCW2**
     &  2)-10D0*S34*XCW2**2+9D0*PZ12*S12*S34*XCW2**2+9D0*PZ34*S12*
     &  S34*XCW2**2+2D0*S12*XCW2*XSW2+2D0*S34*XCW2*XSW2-2D0*PZ12*
     &  S12*S34*XCW2*XSW2-2D0*PZ34*S12*S34*XCW2*XSW2+PZ12*S12*S34*
     &  XSW2**2+PZ34*S12*S34*XSW2**2))

C       G(T1,N7,FULL)+G(T2,N17,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((A0*ALPHA*PZ12*PZ34*(PZ12+PZ34)*XCW2**(-3)*XMW)/
     &  (64D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T3,N23,FULL)+G(T3,N24,FULL)+G(T3,N47,FULL)+G(T3,N48,FULL)
        CALL xB012345_(S12,XMH2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((ALPHA*PZ12**2*PZ34*XCW2**(-3)*XMW*(-(B2(0,0))+(B0*
     &  XMW2)/XCW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T3,N21,FULL)+G(T3,N22,FULL)+G(T3,N32,FULL)+G(T3,N33,FULL)+
C       G(T3,N34,FULL)+G(T3,N35,FULL)+G(T3,N44,FULL)+G(T3,N45,FULL)+
C       G(T3,N46,FULL)+G(T3,N49,FULL)+G(T3,N50,FULL)+G(T3,N51,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 9D0*PZ12*S12*XCW2**2-2D0*PZ12*S12*XCW2*XSW2-20D0*
     &  QF(2)*XCW2**2*XSW2+18D0*QF(2)*PZ12*S12*XCW2**2*XSW2+PZ12*
     &  S12*XSW2**2+4D0*QF(2)*XCW2*XSW2**2-4D0*QF(2)*PZ12*S12*XCW2*
     &  XSW2**2+2D0*QF(2)*PZ12*S12*XSW2**3

        PRE = (ALPHA*PZ12*PZ34*XMW)/(48D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2)*
     &  ((3D0*B2(0,0)*K(1)*XCW2**(-2))/S12+(2D0*(S12-6D0*XMW2)*
     &  (PZ12*S12-2D0*QF(2)*XSW2+2D0*QF(2)*PZ12*S12*XSW2))/S12+6D0*
     &  B0*XCW2**(-2)*(4D0*PZ12*S12*XCW2**2-PZ12*XMW2-8D0*QF(2)*
     &  XCW2**2*XSW2+8D0*QF(2)*PZ12*S12*XCW2**2*XSW2-2D0*QF(2)*PZ12*
     &  XMW2*XSW2))
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*((3D0*B2(0,0)*K(1)*
     &  XCW2**(-2))/S12+(2D0*(S12-6D0*XMW2)*(PZ12*S12-2D0*QF(2)*
     &  XSW2+2D0*QF(2)*PZ12*S12*XSW2))/S12+6D0*B0*XCW2**(-2)*(4D0*
     &  PZ12*S12*XCW2**2-PZ12*XMW2-8D0*QF(2)*XCW2**2*XSW2+8D0*QF(2)*
     &  PZ12*S12*XCW2**2*XSW2-2D0*QF(2)*PZ12*XMW2*XSW2)))/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2)*(-
     &  ((2D0*(1D0-PZ12*S12)*(S12-6D0*XMW2))/S12)+6D0*B0*XCW2**(-2)*
     &  (-(4D0*XCW2**2)+4D0*PZ12*S12*XCW2**2-PZ12*XMW2)+(3D0*B2(0,
     &  0)*XCW2**(-2)*(-(10D0*XCW2**2)+9D0*PZ12*S12*XCW2**2+2D0*
     &  XCW2*XSW2-2D0*PZ12*S12*XCW2*XSW2+PZ12*S12*XSW2**2))/S12))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(-((2D0*(1D0-PZ12*
     &  S12)*(S12-6D0*XMW2))/S12)+6D0*B0*XCW2**(-2)*(-(4D0*XCW2**2)+
     &  4D0*PZ12*S12*XCW2**2-PZ12*XMW2)+(3D0*B2(0,0)*XCW2**(-2)*(-
     &  (10D0*XCW2**2)+9D0*PZ12*S12*XCW2**2+2D0*XCW2*XSW2-2D0*PZ12*
     &  S12*XCW2*XSW2+PZ12*S12*XSW2**2))/S12)

C       G(T4,N54,FULL)+G(T4,N55,FULL)+G(T4,N78,FULL)+G(T4,N79,FULL)
        CALL xB012345_(S34,XMH2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((ALPHA*PZ12*PZ34**2*XCW2**(-3)*XMW*(-(B2(0,0))+(B0*
     &  XMW2)/XCW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T4,N52,FULL)+G(T4,N53,FULL)+G(T4,N63,FULL)+G(T4,N64,FULL)+
C       G(T4,N65,FULL)+G(T4,N66,FULL)+G(T4,N75,FULL)+G(T4,N76,FULL)+
C       G(T4,N77,FULL)+G(T4,N80,FULL)+G(T4,N81,FULL)+G(T4,N82,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 9D0*PZ34*S34*XCW2**2-2D0*PZ34*S34*XCW2*XSW2-20D0*
     &  QF(3)*XCW2**2*XSW2+18D0*QF(3)*PZ34*S34*XCW2**2*XSW2+PZ34*
     &  S34*XSW2**2+4D0*QF(3)*XCW2*XSW2**2-4D0*QF(3)*PZ34*S34*XCW2*
     &  XSW2**2+2D0*QF(3)*PZ34*S34*XSW2**3

        PRE = (ALPHA*PZ12*PZ34*XMW)/(48D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  ((3D0*B2(0,0)*K(1)*XCW2**(-2))/S34+(2D0*(S34-6D0*XMW2)*
     &  (PZ34*S34-2D0*QF(3)*XSW2+2D0*QF(3)*PZ34*S34*XSW2))/S34+6D0*
     &  B0*XCW2**(-2)*(4D0*PZ34*S34*XCW2**2-PZ34*XMW2-8D0*QF(3)*
     &  XCW2**2*XSW2+8D0*QF(3)*PZ34*S34*XCW2**2*XSW2-2D0*QF(3)*PZ34*
     &  XMW2*XSW2))
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2)*(-
     &  ((2D0*(1D0-PZ34*S34)*(S34-6D0*XMW2))/S34)+6D0*B0*XCW2**(-2)*
     &  (-(4D0*XCW2**2)+4D0*PZ34*S34*XCW2**2-PZ34*XMW2)+(3D0*B2(0,
     &  0)*XCW2**(-2)*(-(10D0*XCW2**2)+9D0*PZ34*S34*XCW2**2+2D0*
     &  XCW2*XSW2-2D0*PZ34*S34*XCW2*XSW2+PZ34*S34*XSW2**2))/S34))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*((3D0*B2(0,0)*K(1)*
     &  XCW2**(-2))/S34+(2D0*(S34-6D0*XMW2)*(PZ34*S34-2D0*QF(3)*
     &  XSW2+2D0*QF(3)*PZ34*S34*XSW2))/S34+6D0*B0*XCW2**(-2)*(4D0*
     &  PZ34*S34*XCW2**2-PZ34*XMW2-8D0*QF(3)*XCW2**2*XSW2+8D0*QF(3)*
     &  PZ34*S34*XCW2**2*XSW2-2D0*QF(3)*PZ34*XMW2*XSW2)))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(-((2D0*(1D0-PZ34*
     &  S34)*(S34-6D0*XMW2))/S34)+6D0*B0*XCW2**(-2)*(-(4D0*XCW2**2)+
     &  4D0*PZ34*S34*XCW2**2-PZ34*XMW2)+(3D0*B2(0,0)*XCW2**(-2)*(-
     &  (10D0*XCW2**2)+9D0*PZ34*S34*XCW2**2+2D0*XCW2*XSW2-2D0*PZ34*
     &  S34*XCW2*XSW2+PZ34*S34*XSW2**2))/S34)

c*** counterterms
c----------------
        PRE = (PZ12*PZ34*XCW2**(-2)*XMW)/4D0

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
     &          *(-2d0*dZzz + dmz2*pz12 + dmz2*pz34
     &            -(dZaz/2d0+dZza/2d0/s12/pz12)*(-qd/gdd(-1))
     &            -(dZaz/2d0+dZza/2d0/s34/pz34)*(-qd/gdd(-1)) )
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/XSW
     &          *(-2d0*dZzz + dmz2*pz12 + dmz2*pz34
     &            -(dZaz/2d0+dZza/2d0/s12/pz12)*(-qd/gdd(-1))
     &            -(dZaz/2d0+dZza/2d0/s34/pz34)*(-qd/gdd(+1)) )
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/XSW
     &          *(-2d0*dZzz + dmz2*pz12 + dmz2*pz34
     &            -(dZaz/2d0+dZza/2d0/s12/pz12)*(-qd/gdd(+1))
     &            -(dZaz/2d0+dZza/2d0/s34/pz34)*(-qd/gdd(-1)) )
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*XSW
     &          *(-2d0*dZzz + dmz2*pz12 + dmz2*pz34
     &            -(dZaz/2d0+dZza/2d0/s12/pz12)*(-qd/gdd(+1))
     &            -(dZaz/2d0+dZza/2d0/s34/pz34)*(-qd/gdd(+1)) )

	end

************************************************************************
        subroutine add_HZZ2233_vert_bgf(F,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for ZZ-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    down     anti-down     down     anti-down
*       vertex corrections         
*       boson loops only
*       background-field formalism
*-----------------------------------------------------------------------
*       30.12.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(15)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pz12,pz34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
        complex*16 dZuur,dZuul,dZddr,dZddl
        complex*16 ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)
	integer i

        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/xrenc_bgf/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &         dZuur,dZuul,dZddr,dZddl,
     &         ct_hww,ct_hzz,ct_wud,ct_zuur,ct_zuul,ct_zddr,ct_zddl

C       Process: S10F2200aF2200F2300aF2300,   Model: SMbgf4f

C       G(T8,N96,FULL)
        CALL xB012345_(MH2,XMH2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((3D0*ALPHA*B0*PZ12*PZ34*XCW2**(-2)*XMH2)/(128D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T8,N100,FULL)+G(T8,N83,FULL)+G(T8,N84,FULL)+G(T8,N85,
C       FULL)+G(T8,N86,FULL)+G(T8,N87,FULL)+G(T8,N88,FULL)+G(T8,N89,
C       FULL)+G(T8,N90,FULL)+G(T8,N91,FULL)+G(T8,N92,FULL)+G(T8,N93,
C       FULL)+G(T8,N94,FULL)+G(T8,N95,FULL)+G(T8,N98,FULL)+G(T8,N99,
C       FULL)
        CALL xB012345_(MH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA)/(64D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(-(16D0*XMW*(PZ12*
     &  S12-2D0*QF(2)*XSW2+2D0*QF(2)*PZ12*S12*XSW2)*(PZ34*S34-2D0*
     &  QF(3)*XSW2+2D0*QF(3)*PZ34*S34*XSW2))+(B0*XCW2**(-2)*(PZ12*
     &  PZ34*S12*S34*XCW2**2*XMH2+18D0*PZ12*PZ34*S12*S34*XCW2**2*
     &  XMW2-2D0*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2-4D0*QF(3)*PZ12*
     &  S12*XCW2**2*XMH2*XSW2-4D0*QF(2)*PZ34*S34*XCW2**2*XMH2*XSW2+
     &  2D0*QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+2D0*QF(3)*
     &  PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2-4D0*PZ12*PZ34*S12*S34*
     &  XCW2*XMW2*XSW2-40D0*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2-40D0*
     &  QF(2)*PZ34*S34*XCW2**2*XMW2*XSW2+36D0*QF(2)*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2*XSW2+36D0*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*
     &  XMW2*XSW2+PZ12*PZ34*S12*S34*XMH2*XSW2**2+4D0*QF(3)*PZ12*S12*
     &  XCW2*XMH2*XSW2**2+4D0*QF(2)*PZ34*S34*XCW2*XMH2*XSW2**2-4D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2-4D0*QF(3)*PZ12*
     &  PZ34*S12*S34*XCW2*XMH2*XSW2**2+16D0*QF(2)*QF(3)*XCW2**2*
     &  XMH2*XSW2**2-8D0*QF(2)*QF(3)*PZ12*S12*XCW2**2*XMH2*XSW2**2-
     &  8D0*QF(2)*QF(3)*PZ34*S34*XCW2**2*XMH2*XSW2**2+4D0*QF(2)*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2**2+2D0*PZ12*PZ34*
     &  S12*S34*XMW2*XSW2**2+8D0*QF(3)*PZ12*S12*XCW2*XMW2*XSW2**2+
     &  8D0*QF(2)*PZ34*S34*XCW2*XMW2*XSW2**2-8D0*QF(2)*PZ12*PZ34*
     &  S12*S34*XCW2*XMW2*XSW2**2-8D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*
     &  XMW2*XSW2**2+96D0*QF(2)*QF(3)*XCW2**2*XMW2*XSW2**2-80D0*
     &  QF(2)*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2**2-80D0*QF(2)*QF(3)*
     &  PZ34*S34*XCW2**2*XMW2*XSW2**2+72D0*QF(2)*QF(3)*PZ12*PZ34*
     &  S12*S34*XCW2**2*XMW2*XSW2**2+2D0*QF(2)*PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**3+2D0*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+8D0*
     &  QF(2)*QF(3)*PZ12*S12*XCW2*XMH2*XSW2**3+8D0*QF(2)*QF(3)*PZ34*
     &  S34*XCW2*XMH2*XSW2**3-8D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2*XMH2*XSW2**3+4D0*QF(2)*PZ12*PZ34*S12*S34*XMW2*XSW2**3+
     &  4D0*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**3+16D0*QF(2)*QF(3)*
     &  PZ12*S12*XCW2*XMW2*XSW2**3+16D0*QF(2)*QF(3)*PZ34*S34*XCW2*
     &  XMW2*XSW2**3-16D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XCW2*XMW2*
     &  XSW2**3+4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**4+8D0*
     &  QF(2)*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**4))/XMW)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(16D0*(1D0-PZ34*S34)*
     &  XMW*(PZ12*S12-2D0*QF(2)*XSW2+2D0*QF(2)*PZ12*S12*XSW2)+(B0*
     &  XCW2**(-2)*(-(2D0*PZ12*S12*XCW2**2*XMH2)+PZ12*PZ34*S12*S34*
     &  XCW2**2*XMH2-20D0*PZ12*S12*XCW2**2*XMW2+18D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2+2D0*PZ12*S12*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*
     &  S12*S34*XCW2*XMH2*XSW2+8D0*QF(2)*XCW2**2*XMH2*XSW2-4D0*
     &  QF(2)*PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(2)*PZ34*S34*XCW2**2*
     &  XMH2*XSW2+2D0*QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+4D0*
     &  PZ12*S12*XCW2*XMW2*XSW2-4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*
     &  XSW2+48D0*QF(2)*XCW2**2*XMW2*XSW2-40D0*QF(2)*PZ12*S12*XCW2**
     &  2*XMW2*XSW2-40D0*QF(2)*PZ34*S34*XCW2**2*XMW2*XSW2+36D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**2+4D0*QF(2)*PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(2)*
     &  PZ34*S34*XCW2*XMH2*XSW2**2-4D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*
     &  XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(2)*
     &  PZ12*S12*XCW2*XMW2*XSW2**2+8D0*QF(2)*PZ34*S34*XCW2*XMW2*
     &  XSW2**2-8D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2**2+2D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+4D0*QF(2)*PZ12*PZ34*
     &  S12*S34*XMW2*XSW2**3))/XMW))/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(16D0*(1D0-PZ12*S12)*
     &  XMW*(PZ34*S34-2D0*QF(3)*XSW2+2D0*QF(3)*PZ34*S34*XSW2)+(B0*
     &  XCW2**(-2)*(-(2D0*PZ34*S34*XCW2**2*XMH2)+PZ12*PZ34*S12*S34*
     &  XCW2**2*XMH2-20D0*PZ34*S34*XCW2**2*XMW2+18D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2+2D0*PZ34*S34*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*
     &  S12*S34*XCW2*XMH2*XSW2+8D0*QF(3)*XCW2**2*XMH2*XSW2-4D0*
     &  QF(3)*PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(3)*PZ34*S34*XCW2**2*
     &  XMH2*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+4D0*
     &  PZ34*S34*XCW2*XMW2*XSW2-4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*
     &  XSW2+48D0*QF(3)*XCW2**2*XMW2*XSW2-40D0*QF(3)*PZ12*S12*XCW2**
     &  2*XMW2*XSW2-40D0*QF(3)*PZ34*S34*XCW2**2*XMW2*XSW2+36D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**2+4D0*QF(3)*PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(3)*
     &  PZ34*S34*XCW2*XMH2*XSW2**2-4D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*
     &  XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(3)*
     &  PZ12*S12*XCW2*XMW2*XSW2**2+8D0*QF(3)*PZ34*S34*XCW2*XMW2*
     &  XSW2**2-8D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2**2+2D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+4D0*QF(3)*PZ12*PZ34*
     &  S12*S34*XMW2*XSW2**3))/XMW))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(-(16D0*(1D0-PZ12*
     &  S12)*(1D0-PZ34*S34)*XMW)+(B0*XCW2**(-2)*(4D0*XCW2**2*XMH2-
     &  2D0*PZ12*S12*XCW2**2*XMH2-2D0*PZ34*S34*XCW2**2*XMH2+PZ12*
     &  PZ34*S12*S34*XCW2**2*XMH2+24D0*XCW2**2*XMW2-20D0*PZ12*S12*
     &  XCW2**2*XMW2-20D0*PZ34*S34*XCW2**2*XMW2+18D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2+2D0*PZ12*S12*XCW2*XMH2*XSW2+2D0*PZ34*S34*
     &  XCW2*XMH2*XSW2-2D0*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2+4D0*
     &  PZ12*S12*XCW2*XMW2*XSW2+4D0*PZ34*S34*XCW2*XMW2*XSW2-4D0*
     &  PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2+PZ12*PZ34*S12*S34*XMH2*
     &  XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2))/XMW)

C       G(T8,N97,FULL)
        CALL xB012345_(MH2,XMZ2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*XCW2**(-3)*(XCW2*XMH2+2D0*
     &  XMW2))/(128D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T10,N104,FULL)+G(T10,N105,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*XCW2**(-2)*XMW)/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T10,N106,FULL)
        CALL xB012345_(S12,XMZ2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*XCW2**(-3)*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T9,N101,FULL)+G(T9,N102,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*XCW2**(-2)*XMW)/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T9,N103,FULL)
        CALL xB012345_(S34,XMZ2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*XCW2**(-3)*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(2)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE

C       G(T3,N10,FULL)+G(T3,N12,FULL)
        CALL xC01234_(RMF2(2),MH2,T11,CMF2(1),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*XMW)/(16D0*PI*S34*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(PZ34*S34+2D0*QF(2)*PZ34*S34*
     &  XSW2+2D0*QF(3)*PZ34*S34*XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*
     &  QF(2)*QF(3)*PZ34*S34*XSW2**2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*(PZ34*S34+2D0*QF(2)*
     &  XCW2+2D0*QF(2)*PZ34*S34*XSW2)

C       G(T3,N11,FULL)+G(T3,N9,FULL)
        CALL xC01234_(RMF2(2),MH2,T11,CMF2(2),XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*XCW2**(-3)*XMW)/(32D0*PI*S34)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*XSW2**(-2)*(1D0+2D0*QF(2)*
     &  XSW2)**2*(PZ34*S34+2D0*QF(2)*PZ34*S34*XSW2+2D0*QF(3)*PZ34*
     &  S34*XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*QF(2)*QF(3)*PZ34*S34*
     &  XSW2**2))/XSW
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2)**
     &  2*(PZ34*S34+2D0*QF(2)*XCW2+2D0*QF(2)*PZ34*S34*XSW2))/(XSW*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*QF(2)**3*PRE*XSW*(PZ34*S34+2D0*
     &  QF(3)*XCW2+2D0*QF(3)*PZ34*S34*XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(2)**3*QF(3)*PRE*XSW*(XCW2+PZ34*
     &  S34*XSW2)

C       G(T2,N6,FULL)+G(T2,N8,FULL)
        CALL xC01234_(RMF2(2),MH2,T12,CMF2(1),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*XMW)/(16D0*PI*S34*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(PZ34*S34+2D0*QF(2)*PZ34*S34*
     &  XSW2+2D0*QF(3)*PZ34*S34*XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*
     &  QF(2)*QF(3)*PZ34*S34*XSW2**2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*(PZ34*S34+2D0*QF(2)*
     &  XCW2+2D0*QF(2)*PZ34*S34*XSW2)

C       G(T1,N3,FULL)
        CALL xC01234_(RMF2(2),S12,RMF2(2),NULL,CMF2(2),CMF2(2),
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(2)**2*ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S12+C1(2)*S12+C2(1,2)*S12+C0*S12)*XCW2**(-2)*XMW)/(8D0*PI))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*XSW

C       G(T1,N2,FULL)
        CALL xC01234_(RMF2(2),S12,RMF2(2),CMF2(1),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PZ12*PZ34*(1D0-4D0*C2(0,0)+2D0*C1(1)*S12+2D0*
     &  C1(2)*S12)*XMW)/(16D0*PI*XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE

C       G(T4,N13,FULL)+G(T4,N15,FULL)
        CALL xC01234_(RMF2(3),MH2,T13,CMF2(4),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*XMW)/(16D0*PI*S12*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(PZ12*S12+2D0*QF(2)*PZ12*S12*
     &  XSW2+2D0*QF(3)*PZ12*S12*XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*
     &  QF(2)*QF(3)*PZ12*S12*XSW2**2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(2)*PRE*(PZ12*S12+2D0*QF(3)*
     &  XCW2+2D0*QF(3)*PZ12*S12*XSW2)

C       G(T7,N81,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(3),NULL,CMF2(3),CMF2(3),
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(3)**2*ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S34+C1(2)*S34+C2(1,2)*S34+C0*S34)*XCW2**(-2)*XMW)/(8D0*PI))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*XSW

C       G(T7,N80,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(3),CMF2(4),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PZ12*PZ34*(1D0-4D0*C2(0,0)+2D0*C1(1)*S34+2D0*
     &  C1(2)*S34)*XMW)/(16D0*PI*XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(2)*PRE

C       G(T1,N1,FULL)
        CALL xC01234_(S12,RMF2(2),RMF2(2),CMF2(1),CMF2(1),XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S12-C1(2)*S12-
     &  C2(1,1)*S12-C2(1,2)*S12)*XCW2**(-2)*XMW*(1D0-2D0*QF(1)*
     &  XSW2))/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE

C       G(T1,N4,FULL)
        CALL xC01234_(S12,RMF2(2),RMF2(2),CMF2(2),CMF2(2),XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S12-C1(2)*
     &  S12-C2(1,1)*S12-C2(1,2)*S12)*XCW2**(-3)*XMW)/(32D0*PI))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*XSW2**(-2)*(1D0+2D0*QF(2)*
     &  XSW2)**3*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2)**
     &  3)/(XSW*XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*QF(2)**3*PRE*XSW*(1D0+2D0*QF(3)*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(2)**3*QF(3)*PRE*XSW*XSW2

C       G(T5,N49,FULL)+G(T5,N50,FULL)+G(T5,N55,FULL)+G(T5,N56,FULL)
        CALL xC01234_(S12,MH2,S34,XMH2,XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = XCW2*XMH2+2D0*XMW2
        K(4) = 2D0*C1(1)*XMW+2D0*C1(2)*XMW+(C2(1,2)*(XCW2*XMH2+2D0*
     &  XMW2))/XMW

        PRE = -((ALPHA*PZ12*PZ34*XCW2**(-3))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(1)*K(2)*PRE*(-((C2(0,0)*K(3))/
     &  XMW)+(2D0*C0*XMW*XMW2)/XCW2)*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)+(2D0*K(1)*QF(3)*PRE*(-((C2(0,0)*K(3))/
     &  XMW)+(2D0*C0*XMW*XMW2)/XCW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(2)*PRE*(-((C2(0,0)*K(3))/
     &  XMW)+(2D0*C0*XMW*XMW2)/XCW2))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*(-((C2(0,0)*K(3))/
     &  XMW)+(2D0*C0*XMW*XMW2)/XCW2)
        F(5,-1,-1) = F(5,-1,-1)+K(1)*K(2)*K(4)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*K(4)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)+(2D0*K(2)*K(4)*QF(2)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)+4D0*K(4)*QF(2)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)+K(1)*K(2)*K(4)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*K(4)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)+(2D0*K(2)*K(4)*QF(2)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)+4D0*K(4)*QF(2)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)+K(1)*K(2)*K(4)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*K(4)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)+(2D0*K(2)*K(4)*QF(2)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)+4D0*K(4)*QF(2)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)+K(1)*K(2)*K(4)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*K(4)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)+(2D0*K(2)*K(4)*QF(2)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)+4D0*K(4)*QF(2)*QF(3)*PRE

C       G(T5,N17,FULL)+G(T5,N18,FULL)+G(T5,N19,FULL)+G(T5,N20,FULL)+
C       G(T5,N21,FULL)+G(T5,N22,FULL)+G(T5,N23,FULL)+G(T5,N24,FULL)+
C       G(T5,N25,FULL)+G(T5,N26,FULL)+G(T5,N27,FULL)+G(T5,N28,FULL)+
C       G(T5,N29,FULL)+G(T5,N30,FULL)+G(T5,N31,FULL)+G(T5,N32,FULL)+
C       G(T5,N33,FULL)+G(T5,N34,FULL)+G(T5,N35,FULL)+G(T5,N36,FULL)+
C       G(T5,N37,FULL)+G(T5,N38,FULL)+G(T5,N39,FULL)+G(T5,N40,FULL)+
C       G(T5,N41,FULL)+G(T5,N42,FULL)+G(T5,N43,FULL)+G(T5,N44,FULL)+
C       G(T5,N45,FULL)+G(T5,N46,FULL)+G(T5,N47,FULL)+G(T5,N48,FULL)+
C       G(T5,N51,FULL)+G(T5,N52,FULL)+G(T5,N53,FULL)+G(T5,N54,FULL)+
C       G(T5,N57,FULL)+G(T5,N58,FULL)+G(T5,N59,FULL)+G(T5,N60,FULL)+
C       G(T5,N63,FULL)+G(T5,N64,FULL)+G(T5,N65,FULL)+G(T5,N66,FULL)+
C       G(T5,N67,FULL)+G(T5,N68,FULL)+G(T5,N69,FULL)+G(T5,N70,FULL)+
C       G(T5,N71,FULL)+G(T5,N72,FULL)+G(T5,N73,FULL)+G(T5,N74,FULL)
        CALL xC01234_(S12,MH2,S34,XMW2,XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = XCW2+XSW2
        K(4) = -((2D0*C1(1)*PZ12*PZ34*XMW*(XCW2+XSW2)*(1D0+2D0*
     &  QF(2)*XSW2))/XCW2)-(2D0*C1(2)*PZ12*PZ34*XMW*(XCW2+XSW2)*
     &  (1D0+2D0*QF(2)*XSW2))/XCW2+(4D0*C0*XMW*(PZ12*S12-2D0*PZ12*
     &  PZ34*S12*S34-4D0*PZ12*S12*XCW2+4D0*PZ12*PZ34*S12*S34*XCW2+
     &  2D0*QF(2)*PZ12*S12*XSW2+2D0*QF(2)*PZ34*S34*XSW2-4D0*QF(2)*
     &  PZ12*PZ34*S12*S34*XSW2+8D0*QF(2)*XCW2*XSW2-8D0*QF(2)*PZ12*
     &  S12*XCW2*XSW2-8D0*QF(2)*PZ34*S34*XCW2*XSW2+8D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XCW2*XSW2))/(S12*S34)-(C2(1,2)*(-(2D0*PZ12*S12*
     &  XCW2**2*XMH2)+PZ12*PZ34*S12*S34*XCW2**2*XMH2-20D0*PZ12*S12*
     &  XCW2**2*XMW2+18D0*PZ12*PZ34*S12*S34*XCW2**2*XMW2+2D0*PZ12*
     &  S12*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2+8D0*
     &  QF(2)*XCW2**2*XMH2*XSW2-4D0*QF(2)*PZ12*S12*XCW2**2*XMH2*
     &  XSW2-4D0*QF(2)*PZ34*S34*XCW2**2*XMH2*XSW2+2D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XCW2**2*XMH2*XSW2+4D0*PZ12*S12*XCW2*XMW2*XSW2-
     &  4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2+48D0*QF(2)*XCW2**2*
     &  XMW2*XSW2-40D0*QF(2)*PZ12*S12*XCW2**2*XMW2*XSW2-40D0*QF(2)*
     &  PZ34*S34*XCW2**2*XMW2*XSW2+36D0*QF(2)*PZ12*PZ34*S12*S34*
     &  XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*XMH2*XSW2**2+4D0*QF(2)*
     &  PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(2)*PZ34*S34*XCW2*XMH2*
     &  XSW2**2-4D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2+2D0*
     &  PZ12*PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(2)*PZ12*S12*XCW2*XMW2*
     &  XSW2**2+8D0*QF(2)*PZ34*S34*XCW2*XMW2*XSW2**2-8D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XCW2*XMW2*XSW2**2+2D0*QF(2)*PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**3+4D0*QF(2)*PZ12*PZ34*S12*S34*XMW2*XSW2**3))/
     &  (S12*S34*XCW2*XMW)
        K(5) = -((2D0*C1(1)*PZ12*PZ34*XMW*(XCW2+XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XCW2)-(2D0*C1(2)*PZ12*PZ34*XMW*(XCW2+XSW2)*
     &  (1D0+2D0*QF(3)*XSW2))/XCW2+(4D0*C0*XMW*(PZ34*S34-2D0*PZ12*
     &  PZ34*S12*S34-4D0*PZ34*S34*XCW2+4D0*PZ12*PZ34*S12*S34*XCW2+
     &  2D0*QF(3)*PZ12*S12*XSW2+2D0*QF(3)*PZ34*S34*XSW2-4D0*QF(3)*
     &  PZ12*PZ34*S12*S34*XSW2+8D0*QF(3)*XCW2*XSW2-8D0*QF(3)*PZ12*
     &  S12*XCW2*XSW2-8D0*QF(3)*PZ34*S34*XCW2*XSW2+8D0*QF(3)*PZ12*
     &  PZ34*S12*S34*XCW2*XSW2))/(S12*S34)-(C2(1,2)*(-(2D0*PZ34*S34*
     &  XCW2**2*XMH2)+PZ12*PZ34*S12*S34*XCW2**2*XMH2-20D0*PZ34*S34*
     &  XCW2**2*XMW2+18D0*PZ12*PZ34*S12*S34*XCW2**2*XMW2+2D0*PZ34*
     &  S34*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2+8D0*
     &  QF(3)*XCW2**2*XMH2*XSW2-4D0*QF(3)*PZ12*S12*XCW2**2*XMH2*
     &  XSW2-4D0*QF(3)*PZ34*S34*XCW2**2*XMH2*XSW2+2D0*QF(3)*PZ12*
     &  PZ34*S12*S34*XCW2**2*XMH2*XSW2+4D0*PZ34*S34*XCW2*XMW2*XSW2-
     &  4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2+48D0*QF(3)*XCW2**2*
     &  XMW2*XSW2-40D0*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2-40D0*QF(3)*
     &  PZ34*S34*XCW2**2*XMW2*XSW2+36D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*XMH2*XSW2**2+4D0*QF(3)*
     &  PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(3)*PZ34*S34*XCW2*XMH2*
     &  XSW2**2-4D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2+2D0*
     &  PZ12*PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(3)*PZ12*S12*XCW2*XMW2*
     &  XSW2**2+8D0*QF(3)*PZ34*S34*XCW2*XMW2*XSW2**2-8D0*QF(3)*PZ12*
     &  PZ34*S12*S34*XCW2*XMW2*XSW2**2+2D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**3+4D0*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**3))/
     &  (S12*S34*XCW2*XMW)
        K(6) = (2D0*C1(1)*PZ12*PZ34*XMW*(XCW2+XSW2)*(1D0+2D0*QF(2)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2))/XCW2+(2D0*C1(2)*PZ12*PZ34*XMW*
     &  (XCW2+XSW2)*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*QF(3)*XSW2))/XCW2+
     &  (8D0*C0*XMW*(PZ12*PZ34*S12*S34-2D0*PZ12*PZ34*S12*S34*XCW2-
     &  QF(3)*PZ12*S12*XSW2-QF(2)*PZ34*S34*XSW2+2D0*QF(2)*PZ12*PZ34*
     &  S12*S34*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*XSW2+4D0*QF(3)*
     &  PZ12*S12*XCW2*XSW2+4D0*QF(2)*PZ34*S34*XCW2*XSW2-4D0*QF(2)*
     &  PZ12*PZ34*S12*S34*XCW2*XSW2-4D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2*XSW2-2D0*QF(2)*QF(3)*PZ12*S12*XSW2**2-2D0*QF(2)*QF(3)*
     &  PZ34*S34*XSW2**2+4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**2-
     &  8D0*QF(2)*QF(3)*XCW2*XSW2**2+8D0*QF(2)*QF(3)*PZ12*S12*XCW2*
     &  XSW2**2+8D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**2-8D0*QF(2)*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2*XSW2**2))/(S12*S34)+(C2(1,2)*
     &  (PZ12*PZ34*S12*S34*XCW2**2*XMH2+18D0*PZ12*PZ34*S12*S34*
     &  XCW2**2*XMW2-2D0*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2-4D0*QF(3)*
     &  PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(2)*PZ34*S34*XCW2**2*XMH2*
     &  XSW2+2D0*QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+2D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2-4D0*PZ12*PZ34*S12*
     &  S34*XCW2*XMW2*XSW2-40D0*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2-
     &  40D0*QF(2)*PZ34*S34*XCW2**2*XMW2*XSW2+36D0*QF(2)*PZ12*PZ34*
     &  S12*S34*XCW2**2*XMW2*XSW2+36D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*XMH2*XSW2**2+4D0*QF(3)*
     &  PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(2)*PZ34*S34*XCW2*XMH2*
     &  XSW2**2-4D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2-4D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2+16D0*QF(2)*QF(3)*
     &  XCW2**2*XMH2*XSW2**2-8D0*QF(2)*QF(3)*PZ12*S12*XCW2**2*XMH2*
     &  XSW2**2-8D0*QF(2)*QF(3)*PZ34*S34*XCW2**2*XMH2*XSW2**2+4D0*
     &  QF(2)*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2**2+2D0*PZ12*
     &  PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(3)*PZ12*S12*XCW2*XMW2*
     &  XSW2**2+8D0*QF(2)*PZ34*S34*XCW2*XMW2*XSW2**2-8D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XCW2*XMW2*XSW2**2-8D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2*XMW2*XSW2**2+96D0*QF(2)*QF(3)*XCW2**2*XMW2*XSW2**2-
     &  80D0*QF(2)*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2**2-80D0*QF(2)*
     &  QF(3)*PZ34*S34*XCW2**2*XMW2*XSW2**2+72D0*QF(2)*QF(3)*PZ12*
     &  PZ34*S12*S34*XCW2**2*XMW2*XSW2**2+2D0*QF(2)*PZ12*PZ34*S12*
     &  S34*XMH2*XSW2**3+2D0*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+
     &  8D0*QF(2)*QF(3)*PZ12*S12*XCW2*XMH2*XSW2**3+8D0*QF(2)*QF(3)*
     &  PZ34*S34*XCW2*XMH2*XSW2**3-8D0*QF(2)*QF(3)*PZ12*PZ34*S12*
     &  S34*XCW2*XMH2*XSW2**3+4D0*QF(2)*PZ12*PZ34*S12*S34*XMW2*
     &  XSW2**3+4D0*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**3+16D0*QF(2)*
     &  QF(3)*PZ12*S12*XCW2*XMW2*XSW2**3+16D0*QF(2)*QF(3)*PZ34*S34*
     &  XCW2*XMW2*XSW2**3-16D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XCW2*
     &  XMW2*XSW2**3+4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**4+
     &  8D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**4))/(S12*S34*
     &  XCW2*XMW)
        K(7) = (4D0*C0*(PZ12*S12+PZ34*S34-2D0*PZ12*PZ34*S12*S34+4D0*
     &  XCW2-4D0*PZ12*S12*XCW2-4D0*PZ34*S34*XCW2+4D0*PZ12*PZ34*S12*
     &  S34*XCW2)*XMW)/(S12*S34)-(2D0*C1(1)*PZ12*PZ34*XMW*(XCW2+
     &  XSW2))/XCW2-(2D0*C1(2)*PZ12*PZ34*XMW*(XCW2+XSW2))/XCW2-
     &  (C2(1,2)*(4D0*XCW2**2*XMH2-2D0*PZ12*S12*XCW2**2*XMH2-2D0*
     &  PZ34*S34*XCW2**2*XMH2+PZ12*PZ34*S12*S34*XCW2**2*XMH2+24D0*
     &  XCW2**2*XMW2-20D0*PZ12*S12*XCW2**2*XMW2-20D0*PZ34*S34*XCW2**
     &  2*XMW2+18D0*PZ12*PZ34*S12*S34*XCW2**2*XMW2+2D0*PZ12*S12*
     &  XCW2*XMH2*XSW2+2D0*PZ34*S34*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*
     &  S12*S34*XCW2*XMH2*XSW2+4D0*PZ12*S12*XCW2*XMW2*XSW2+4D0*PZ34*
     &  S34*XCW2*XMW2*XSW2-4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2+
     &  PZ12*PZ34*S12*S34*XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*
     &  XSW2**2))/(S12*S34*XCW2*XMW)
        K(8) = PZ12*S12+PZ34*S34-2D0*PZ12*PZ34*S12*S34+4D0*XCW2-4D0*
     &  PZ12*S12*XCW2-4D0*PZ34*S34*XCW2+4D0*PZ12*PZ34*S12*S34*XCW2
        K(9) = PZ12*S12-2D0*PZ12*PZ34*S12*S34-4D0*PZ12*S12*XCW2+4D0*
     &  PZ12*PZ34*S12*S34*XCW2+2D0*QF(2)*PZ12*S12*XSW2+2D0*QF(2)*
     &  PZ34*S34*XSW2-4D0*QF(2)*PZ12*PZ34*S12*S34*XSW2+8D0*QF(2)*
     &  XCW2*XSW2-8D0*QF(2)*PZ12*S12*XCW2*XSW2-8D0*QF(2)*PZ34*S34*
     &  XCW2*XSW2+8D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*XSW2
        K(10) = PZ34*S34-2D0*PZ12*PZ34*S12*S34-4D0*PZ34*S34*XCW2+
     &  4D0*PZ12*PZ34*S12*S34*XCW2+2D0*QF(3)*PZ12*S12*XSW2+2D0*
     &  QF(3)*PZ34*S34*XSW2-4D0*QF(3)*PZ12*PZ34*S12*S34*XSW2+8D0*
     &  QF(3)*XCW2*XSW2-8D0*QF(3)*PZ12*S12*XCW2*XSW2-8D0*QF(3)*PZ34*
     &  S34*XCW2*XSW2+8D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*XSW2
        K(11) = 4D0*XCW2**2*XMH2-2D0*PZ12*S12*XCW2**2*XMH2-2D0*PZ34*
     &  S34*XCW2**2*XMH2+PZ12*PZ34*S12*S34*XCW2**2*XMH2+24D0*XCW2**
     &  2*XMW2-20D0*PZ12*S12*XCW2**2*XMW2-20D0*PZ34*S34*XCW2**2*
     &  XMW2+18D0*PZ12*PZ34*S12*S34*XCW2**2*XMW2+2D0*PZ12*S12*XCW2*
     &  XMH2*XSW2+2D0*PZ34*S34*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*S12*S34*
     &  XCW2*XMH2*XSW2+4D0*PZ12*S12*XCW2*XMW2*XSW2+4D0*PZ34*S34*
     &  XCW2*XMW2*XSW2-4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2+PZ12*
     &  PZ34*S12*S34*XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2
        K(12) = PZ12*PZ34*S12*S34-2D0*PZ12*PZ34*S12*S34*XCW2-QF(3)*
     &  PZ12*S12*XSW2-QF(2)*PZ34*S34*XSW2+2D0*QF(2)*PZ12*PZ34*S12*
     &  S34*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*XSW2+4D0*QF(3)*PZ12*
     &  S12*XCW2*XSW2+4D0*QF(2)*PZ34*S34*XCW2*XSW2-4D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XCW2*XSW2-4D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*
     &  XSW2-2D0*QF(2)*QF(3)*PZ12*S12*XSW2**2-2D0*QF(2)*QF(3)*PZ34*
     &  S34*XSW2**2+4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XSW2**2-8D0*
     &  QF(2)*QF(3)*XCW2*XSW2**2+8D0*QF(2)*QF(3)*PZ12*S12*XCW2*
     &  XSW2**2+8D0*QF(2)*QF(3)*PZ34*S34*XCW2*XSW2**2-8D0*QF(2)*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2*XSW2**2
        K(13) = -(2D0*PZ12*S12*XCW2**2*XMH2)+PZ12*PZ34*S12*S34*
     &  XCW2**2*XMH2-20D0*PZ12*S12*XCW2**2*XMW2+18D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2+2D0*PZ12*S12*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*
     &  S12*S34*XCW2*XMH2*XSW2+8D0*QF(2)*XCW2**2*XMH2*XSW2-4D0*
     &  QF(2)*PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(2)*PZ34*S34*XCW2**2*
     &  XMH2*XSW2+2D0*QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+4D0*
     &  PZ12*S12*XCW2*XMW2*XSW2-4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*
     &  XSW2+48D0*QF(2)*XCW2**2*XMW2*XSW2-40D0*QF(2)*PZ12*S12*XCW2**
     &  2*XMW2*XSW2-40D0*QF(2)*PZ34*S34*XCW2**2*XMW2*XSW2+36D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**2+4D0*QF(2)*PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(2)*
     &  PZ34*S34*XCW2*XMH2*XSW2**2-4D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*
     &  XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(2)*
     &  PZ12*S12*XCW2*XMW2*XSW2**2+8D0*QF(2)*PZ34*S34*XCW2*XMW2*
     &  XSW2**2-8D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2**2+2D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+4D0*QF(2)*PZ12*PZ34*
     &  S12*S34*XMW2*XSW2**3
        K(14) = -(2D0*PZ34*S34*XCW2**2*XMH2)+PZ12*PZ34*S12*S34*
     &  XCW2**2*XMH2-20D0*PZ34*S34*XCW2**2*XMW2+18D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2+2D0*PZ34*S34*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*
     &  S12*S34*XCW2*XMH2*XSW2+8D0*QF(3)*XCW2**2*XMH2*XSW2-4D0*
     &  QF(3)*PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(3)*PZ34*S34*XCW2**2*
     &  XMH2*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+4D0*
     &  PZ34*S34*XCW2*XMW2*XSW2-4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*
     &  XSW2+48D0*QF(3)*XCW2**2*XMW2*XSW2-40D0*QF(3)*PZ12*S12*XCW2**
     &  2*XMW2*XSW2-40D0*QF(3)*PZ34*S34*XCW2**2*XMW2*XSW2+36D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**2+4D0*QF(3)*PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(3)*
     &  PZ34*S34*XCW2*XMH2*XSW2**2-4D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*
     &  XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(3)*
     &  PZ12*S12*XCW2*XMW2*XSW2**2+8D0*QF(3)*PZ34*S34*XCW2*XMW2*
     &  XSW2**2-8D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2**2+2D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+4D0*QF(3)*PZ12*PZ34*
     &  S12*S34*XMW2*XSW2**3
        K(15) = PZ12*PZ34*S12*S34*XCW2**2*XMH2+18D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2-2D0*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2-4D0*
     &  QF(3)*PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(2)*PZ34*S34*XCW2**2*
     &  XMH2*XSW2+2D0*QF(2)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+2D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2-4D0*PZ12*PZ34*S12*
     &  S34*XCW2*XMW2*XSW2-40D0*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2-
     &  40D0*QF(2)*PZ34*S34*XCW2**2*XMW2*XSW2+36D0*QF(2)*PZ12*PZ34*
     &  S12*S34*XCW2**2*XMW2*XSW2+36D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*XMH2*XSW2**2+4D0*QF(3)*
     &  PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(2)*PZ34*S34*XCW2*XMH2*
     &  XSW2**2-4D0*QF(2)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2-4D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2+16D0*QF(2)*QF(3)*
     &  XCW2**2*XMH2*XSW2**2-8D0*QF(2)*QF(3)*PZ12*S12*XCW2**2*XMH2*
     &  XSW2**2-8D0*QF(2)*QF(3)*PZ34*S34*XCW2**2*XMH2*XSW2**2+4D0*
     &  QF(2)*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2**2+2D0*PZ12*
     &  PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(3)*PZ12*S12*XCW2*XMW2*
     &  XSW2**2+8D0*QF(2)*PZ34*S34*XCW2*XMW2*XSW2**2-8D0*QF(2)*PZ12*
     &  PZ34*S12*S34*XCW2*XMW2*XSW2**2-8D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2*XMW2*XSW2**2+96D0*QF(2)*QF(3)*XCW2**2*XMW2*XSW2**2-
     &  80D0*QF(2)*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2**2-80D0*QF(2)*
     &  QF(3)*PZ34*S34*XCW2**2*XMW2*XSW2**2+72D0*QF(2)*QF(3)*PZ12*
     &  PZ34*S12*S34*XCW2**2*XMW2*XSW2**2+2D0*QF(2)*PZ12*PZ34*S12*
     &  S34*XMH2*XSW2**3+2D0*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+
     &  8D0*QF(2)*QF(3)*PZ12*S12*XCW2*XMH2*XSW2**3+8D0*QF(2)*QF(3)*
     &  PZ34*S34*XCW2*XMH2*XSW2**3-8D0*QF(2)*QF(3)*PZ12*PZ34*S12*
     &  S34*XCW2*XMH2*XSW2**3+4D0*QF(2)*PZ12*PZ34*S12*S34*XMW2*
     &  XSW2**3+4D0*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**3+16D0*QF(2)*
     &  QF(3)*PZ12*S12*XCW2*XMW2*XSW2**3+16D0*QF(2)*QF(3)*PZ34*S34*
     &  XCW2*XMW2*XSW2**3-16D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XCW2*
     &  XMW2*XSW2**3+4D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**4+
     &  8D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**4

        PRE = -((ALPHA)/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*XSW2**(-2)*(-((C2(0,0)*K(15)*
     &  XCW2**(-2))/XMW)+4D0*XMW*(PZ12*S12-2D0*QF(2)*XSW2+2D0*QF(2)*
     &  PZ12*S12*XSW2)*(PZ34*S34-2D0*QF(3)*XSW2+2D0*QF(3)*PZ34*S34*
     &  XSW2)+C0*XCW2**(-2)*XMW*(-(4D0*PZ12*PZ34*S12**2*S34*XCW2)-
     &  4D0*PZ12*PZ34*S12*S13*S34*XCW2-4D0*PZ12*PZ34*S12*S14*S34*
     &  XCW2-4D0*PZ12*PZ34*S12*S23*S34*XCW2-4D0*PZ12*PZ34*S12*S24*
     &  S34*XCW2-4D0*PZ12*PZ34*S12*S34**2*XCW2+8D0*PZ12*PZ34*S12*
     &  S13*S34*XCW2**2+8D0*PZ12*PZ34*S12*S14*S34*XCW2**2+8D0*PZ12*
     &  PZ34*S12*S23*S34*XCW2**2+8D0*PZ12*PZ34*S12*S24*S34*XCW2**2+
     &  PZ12*PZ34*S12*S34*XMH2+4D0*PZ12*PZ34*S12*S34*XMW2+4D0*QF(3)*
     &  PZ12*S12*S13*XCW2*XSW2+4D0*QF(3)*PZ12*S12*S14*XCW2*XSW2+4D0*
     &  QF(3)*PZ12*S12*S23*XCW2*XSW2+4D0*QF(3)*PZ12*S12*S24*XCW2*
     &  XSW2+8D0*QF(3)*PZ12*S12*S34*XCW2*XSW2+8D0*QF(2)*PZ34*S12*
     &  S34*XCW2*XSW2-8D0*QF(2)*PZ12*PZ34*S12**2*S34*XCW2*XSW2-8D0*
     &  QF(3)*PZ12*PZ34*S12**2*S34*XCW2*XSW2+4D0*QF(2)*PZ34*S13*S34*
     &  XCW2*XSW2-8D0*QF(2)*PZ12*PZ34*S12*S13*S34*XCW2*XSW2-8D0*
     &  QF(3)*PZ12*PZ34*S12*S13*S34*XCW2*XSW2+4D0*QF(2)*PZ34*S14*
     &  S34*XCW2*XSW2-8D0*QF(2)*PZ12*PZ34*S12*S14*S34*XCW2*XSW2-8D0*
     &  QF(3)*PZ12*PZ34*S12*S14*S34*XCW2*XSW2+4D0*QF(2)*PZ34*S23*
     &  S34*XCW2*XSW2-8D0*QF(2)*PZ12*PZ34*S12*S23*S34*XCW2*XSW2-8D0*
     &  QF(3)*PZ12*PZ34*S12*S23*S34*XCW2*XSW2+4D0*QF(2)*PZ34*S24*
     &  S34*XCW2*XSW2-8D0*QF(2)*PZ12*PZ34*S12*S24*S34*XCW2*XSW2-8D0*
     &  QF(3)*PZ12*PZ34*S12*S24*S34*XCW2*XSW2-8D0*QF(2)*PZ12*PZ34*
     &  S12*S34**2*XCW2*XSW2-8D0*QF(3)*PZ12*PZ34*S12*S34**2*XCW2*
     &  XSW2-16D0*QF(3)*PZ12*S12*S13*XCW2**2*XSW2-16D0*QF(3)*PZ12*
     &  S12*S14*XCW2**2*XSW2-16D0*QF(3)*PZ12*S12*S23*XCW2**2*XSW2-
     &  16D0*QF(3)*PZ12*S12*S24*XCW2**2*XSW2-16D0*QF(2)*PZ34*S13*
     &  S34*XCW2**2*XSW2+16D0*QF(2)*PZ12*PZ34*S12*S13*S34*XCW2**2*
     &  XSW2+16D0*QF(3)*PZ12*PZ34*S12*S13*S34*XCW2**2*XSW2-16D0*
     &  QF(2)*PZ34*S14*S34*XCW2**2*XSW2+16D0*QF(2)*PZ12*PZ34*S12*
     &  S14*S34*XCW2**2*XSW2+16D0*QF(3)*PZ12*PZ34*S12*S14*S34*XCW2**
     &  2*XSW2-16D0*QF(2)*PZ34*S23*S34*XCW2**2*XSW2+16D0*QF(2)*PZ12*
     &  PZ34*S12*S23*S34*XCW2**2*XSW2+16D0*QF(3)*PZ12*PZ34*S12*S23*
     &  S34*XCW2**2*XSW2-16D0*QF(2)*PZ34*S24*S34*XCW2**2*XSW2+16D0*
     &  QF(2)*PZ12*PZ34*S12*S24*S34*XCW2**2*XSW2+16D0*QF(3)*PZ12*
     &  PZ34*S12*S24*S34*XCW2**2*XSW2+2D0*QF(2)*PZ12*PZ34*S12*S34*
     &  XMH2*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2+8D0*QF(2)*
     &  PZ12*PZ34*S12*S34*XMW2*XSW2+8D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XMW2*XSW2+8D0*QF(2)*QF(3)*PZ12*S12*S13*XCW2*XSW2**2+8D0*
     &  QF(2)*QF(3)*PZ12*S12*S14*XCW2*XSW2**2+8D0*QF(2)*QF(3)*PZ12*
     &  S12*S23*XCW2*XSW2**2+8D0*QF(2)*QF(3)*PZ12*S12*S24*XCW2*
     &  XSW2**2+16D0*QF(2)*QF(3)*PZ12*S12*S34*XCW2*XSW2**2+16D0*
     &  QF(2)*QF(3)*PZ34*S12*S34*XCW2*XSW2**2-16D0*QF(2)*QF(3)*PZ12*
     &  PZ34*S12**2*S34*XCW2*XSW2**2+8D0*QF(2)*QF(3)*PZ34*S13*S34*
     &  XCW2*XSW2**2-16D0*QF(2)*QF(3)*PZ12*PZ34*S12*S13*S34*XCW2*
     &  XSW2**2+8D0*QF(2)*QF(3)*PZ34*S14*S34*XCW2*XSW2**2-16D0*
     &  QF(2)*QF(3)*PZ12*PZ34*S12*S14*S34*XCW2*XSW2**2+8D0*QF(2)*
     &  QF(3)*PZ34*S23*S34*XCW2*XSW2**2-16D0*QF(2)*QF(3)*PZ12*PZ34*
     &  S12*S23*S34*XCW2*XSW2**2+8D0*QF(2)*QF(3)*PZ34*S24*S34*XCW2*
     &  XSW2**2-16D0*QF(2)*QF(3)*PZ12*PZ34*S12*S24*S34*XCW2*XSW2**2-
     &  16D0*QF(2)*QF(3)*PZ12*PZ34*S12*S34**2*XCW2*XSW2**2+32D0*
     &  QF(2)*QF(3)*S13*XCW2**2*XSW2**2-32D0*QF(2)*QF(3)*PZ12*S12*
     &  S13*XCW2**2*XSW2**2+32D0*QF(2)*QF(3)*S14*XCW2**2*XSW2**2-
     &  32D0*QF(2)*QF(3)*PZ12*S12*S14*XCW2**2*XSW2**2+32D0*QF(2)*
     &  QF(3)*S23*XCW2**2*XSW2**2-32D0*QF(2)*QF(3)*PZ12*S12*S23*
     &  XCW2**2*XSW2**2+32D0*QF(2)*QF(3)*S24*XCW2**2*XSW2**2-32D0*
     &  QF(2)*QF(3)*PZ12*S12*S24*XCW2**2*XSW2**2-32D0*QF(2)*QF(3)*
     &  PZ34*S13*S34*XCW2**2*XSW2**2+32D0*QF(2)*QF(3)*PZ12*PZ34*S12*
     &  S13*S34*XCW2**2*XSW2**2-32D0*QF(2)*QF(3)*PZ34*S14*S34*XCW2**
     &  2*XSW2**2+32D0*QF(2)*QF(3)*PZ12*PZ34*S12*S14*S34*XCW2**2*
     &  XSW2**2-32D0*QF(2)*QF(3)*PZ34*S23*S34*XCW2**2*XSW2**2+32D0*
     &  QF(2)*QF(3)*PZ12*PZ34*S12*S23*S34*XCW2**2*XSW2**2-32D0*
     &  QF(2)*QF(3)*PZ34*S24*S34*XCW2**2*XSW2**2+32D0*QF(2)*QF(3)*
     &  PZ12*PZ34*S12*S24*S34*XCW2**2*XSW2**2+4D0*QF(2)*QF(3)*PZ12*
     &  PZ34*S12*S34*XMH2*XSW2**2+16D0*QF(2)*QF(3)*PZ12*PZ34*S12*
     &  S34*XMW2*XSW2**2)))/(S12*S34)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(-((C2(0,0)*K(13)*
     &  XCW2**(-2))/XMW)-4D0*(1D0-PZ34*S34)*XMW*(PZ12*S12-2D0*QF(2)*
     &  XSW2+2D0*QF(2)*PZ12*S12*XSW2)+C0*XCW2**(-2)*XMW*(2D0*PZ12*
     &  S12*S13*XCW2+2D0*PZ12*S12*S14*XCW2+2D0*PZ12*S12*S23*XCW2+
     &  2D0*PZ12*S12*S24*XCW2+4D0*PZ12*S12*S34*XCW2-4D0*PZ12*PZ34*
     &  S12**2*S34*XCW2-4D0*PZ12*PZ34*S12*S13*S34*XCW2-4D0*PZ12*
     &  PZ34*S12*S14*S34*XCW2-4D0*PZ12*PZ34*S12*S23*S34*XCW2-4D0*
     &  PZ12*PZ34*S12*S24*S34*XCW2-4D0*PZ12*PZ34*S12*S34**2*XCW2-
     &  8D0*PZ12*S12*S13*XCW2**2-8D0*PZ12*S12*S14*XCW2**2-8D0*PZ12*
     &  S12*S23*XCW2**2-8D0*PZ12*S12*S24*XCW2**2+8D0*PZ12*PZ34*S12*
     &  S13*S34*XCW2**2+8D0*PZ12*PZ34*S12*S14*S34*XCW2**2+8D0*PZ12*
     &  PZ34*S12*S23*S34*XCW2**2+8D0*PZ12*PZ34*S12*S24*S34*XCW2**2+
     &  PZ12*PZ34*S12*S34*XMH2+4D0*PZ12*PZ34*S12*S34*XMW2+4D0*QF(2)*
     &  PZ12*S12*S13*XCW2*XSW2+4D0*QF(2)*PZ12*S12*S14*XCW2*XSW2+4D0*
     &  QF(2)*PZ12*S12*S23*XCW2*XSW2+4D0*QF(2)*PZ12*S12*S24*XCW2*
     &  XSW2+8D0*QF(2)*PZ12*S12*S34*XCW2*XSW2+8D0*QF(2)*PZ34*S12*
     &  S34*XCW2*XSW2-8D0*QF(2)*PZ12*PZ34*S12**2*S34*XCW2*XSW2+4D0*
     &  QF(2)*PZ34*S13*S34*XCW2*XSW2-8D0*QF(2)*PZ12*PZ34*S12*S13*
     &  S34*XCW2*XSW2+4D0*QF(2)*PZ34*S14*S34*XCW2*XSW2-8D0*QF(2)*
     &  PZ12*PZ34*S12*S14*S34*XCW2*XSW2+4D0*QF(2)*PZ34*S23*S34*XCW2*
     &  XSW2-8D0*QF(2)*PZ12*PZ34*S12*S23*S34*XCW2*XSW2+4D0*QF(2)*
     &  PZ34*S24*S34*XCW2*XSW2-8D0*QF(2)*PZ12*PZ34*S12*S24*S34*XCW2*
     &  XSW2-8D0*QF(2)*PZ12*PZ34*S12*S34**2*XCW2*XSW2+16D0*QF(2)*
     &  S13*XCW2**2*XSW2-16D0*QF(2)*PZ12*S12*S13*XCW2**2*XSW2+16D0*
     &  QF(2)*S14*XCW2**2*XSW2-16D0*QF(2)*PZ12*S12*S14*XCW2**2*XSW2+
     &  16D0*QF(2)*S23*XCW2**2*XSW2-16D0*QF(2)*PZ12*S12*S23*XCW2**2*
     &  XSW2+16D0*QF(2)*S24*XCW2**2*XSW2-16D0*QF(2)*PZ12*S12*S24*
     &  XCW2**2*XSW2-16D0*QF(2)*PZ34*S13*S34*XCW2**2*XSW2+16D0*
     &  QF(2)*PZ12*PZ34*S12*S13*S34*XCW2**2*XSW2-16D0*QF(2)*PZ34*
     &  S14*S34*XCW2**2*XSW2+16D0*QF(2)*PZ12*PZ34*S12*S14*S34*XCW2**
     &  2*XSW2-16D0*QF(2)*PZ34*S23*S34*XCW2**2*XSW2+16D0*QF(2)*PZ12*
     &  PZ34*S12*S23*S34*XCW2**2*XSW2-16D0*QF(2)*PZ34*S24*S34*XCW2**
     &  2*XSW2+16D0*QF(2)*PZ12*PZ34*S12*S24*S34*XCW2**2*XSW2+2D0*
     &  QF(2)*PZ12*PZ34*S12*S34*XMH2*XSW2+8D0*QF(2)*PZ12*PZ34*S12*
     &  S34*XMW2*XSW2)))/(S12*S34*XSW2)
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(-((C2(0,0)*K(14)*
     &  XCW2**(-2))/XMW)-4D0*(1D0-PZ12*S12)*XMW*(PZ34*S34-2D0*QF(3)*
     &  XSW2+2D0*QF(3)*PZ34*S34*XSW2)+C0*XCW2**(-2)*XMW*(4D0*PZ34*
     &  S12*S34*XCW2-4D0*PZ12*PZ34*S12**2*S34*XCW2+2D0*PZ34*S13*S34*
     &  XCW2-4D0*PZ12*PZ34*S12*S13*S34*XCW2+2D0*PZ34*S14*S34*XCW2-
     &  4D0*PZ12*PZ34*S12*S14*S34*XCW2+2D0*PZ34*S23*S34*XCW2-4D0*
     &  PZ12*PZ34*S12*S23*S34*XCW2+2D0*PZ34*S24*S34*XCW2-4D0*PZ12*
     &  PZ34*S12*S24*S34*XCW2-4D0*PZ12*PZ34*S12*S34**2*XCW2-8D0*
     &  PZ34*S13*S34*XCW2**2+8D0*PZ12*PZ34*S12*S13*S34*XCW2**2-8D0*
     &  PZ34*S14*S34*XCW2**2+8D0*PZ12*PZ34*S12*S14*S34*XCW2**2-8D0*
     &  PZ34*S23*S34*XCW2**2+8D0*PZ12*PZ34*S12*S23*S34*XCW2**2-8D0*
     &  PZ34*S24*S34*XCW2**2+8D0*PZ12*PZ34*S12*S24*S34*XCW2**2+PZ12*
     &  PZ34*S12*S34*XMH2+4D0*PZ12*PZ34*S12*S34*XMW2+4D0*QF(3)*PZ12*
     &  S12*S13*XCW2*XSW2+4D0*QF(3)*PZ12*S12*S14*XCW2*XSW2+4D0*
     &  QF(3)*PZ12*S12*S23*XCW2*XSW2+4D0*QF(3)*PZ12*S12*S24*XCW2*
     &  XSW2+8D0*QF(3)*PZ12*S12*S34*XCW2*XSW2+8D0*QF(3)*PZ34*S12*
     &  S34*XCW2*XSW2-8D0*QF(3)*PZ12*PZ34*S12**2*S34*XCW2*XSW2+4D0*
     &  QF(3)*PZ34*S13*S34*XCW2*XSW2-8D0*QF(3)*PZ12*PZ34*S12*S13*
     &  S34*XCW2*XSW2+4D0*QF(3)*PZ34*S14*S34*XCW2*XSW2-8D0*QF(3)*
     &  PZ12*PZ34*S12*S14*S34*XCW2*XSW2+4D0*QF(3)*PZ34*S23*S34*XCW2*
     &  XSW2-8D0*QF(3)*PZ12*PZ34*S12*S23*S34*XCW2*XSW2+4D0*QF(3)*
     &  PZ34*S24*S34*XCW2*XSW2-8D0*QF(3)*PZ12*PZ34*S12*S24*S34*XCW2*
     &  XSW2-8D0*QF(3)*PZ12*PZ34*S12*S34**2*XCW2*XSW2+16D0*QF(3)*
     &  S13*XCW2**2*XSW2-16D0*QF(3)*PZ12*S12*S13*XCW2**2*XSW2+16D0*
     &  QF(3)*S14*XCW2**2*XSW2-16D0*QF(3)*PZ12*S12*S14*XCW2**2*XSW2+
     &  16D0*QF(3)*S23*XCW2**2*XSW2-16D0*QF(3)*PZ12*S12*S23*XCW2**2*
     &  XSW2+16D0*QF(3)*S24*XCW2**2*XSW2-16D0*QF(3)*PZ12*S12*S24*
     &  XCW2**2*XSW2-16D0*QF(3)*PZ34*S13*S34*XCW2**2*XSW2+16D0*
     &  QF(3)*PZ12*PZ34*S12*S13*S34*XCW2**2*XSW2-16D0*QF(3)*PZ34*
     &  S14*S34*XCW2**2*XSW2+16D0*QF(3)*PZ12*PZ34*S12*S14*S34*XCW2**
     &  2*XSW2-16D0*QF(3)*PZ34*S23*S34*XCW2**2*XSW2+16D0*QF(3)*PZ12*
     &  PZ34*S12*S23*S34*XCW2**2*XSW2-16D0*QF(3)*PZ34*S24*S34*XCW2**
     &  2*XSW2+16D0*QF(3)*PZ12*PZ34*S12*S24*S34*XCW2**2*XSW2+2D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2+8D0*QF(3)*PZ12*PZ34*S12*
     &  S34*XMW2*XSW2)))/(S12*S34*XSW2)
        F(1,1,1) = F(1,1,1)+(4D0*QF(2)*QF(3)*PRE*(4D0*(1D0-PZ12*
     &  S12)*(1D0-PZ34*S34)*XMW-(C2(0,0)*K(11)*XCW2**(-2))/XMW+C0*
     &  XCW2**(-2)*XMW*(2D0*PZ12*S12*S13*XCW2+2D0*PZ12*S12*S14*XCW2+
     &  2D0*PZ12*S12*S23*XCW2+2D0*PZ12*S12*S24*XCW2+4D0*PZ12*S12*
     &  S34*XCW2+4D0*PZ34*S12*S34*XCW2-4D0*PZ12*PZ34*S12**2*S34*
     &  XCW2+2D0*PZ34*S13*S34*XCW2-4D0*PZ12*PZ34*S12*S13*S34*XCW2+
     &  2D0*PZ34*S14*S34*XCW2-4D0*PZ12*PZ34*S12*S14*S34*XCW2+2D0*
     &  PZ34*S23*S34*XCW2-4D0*PZ12*PZ34*S12*S23*S34*XCW2+2D0*PZ34*
     &  S24*S34*XCW2-4D0*PZ12*PZ34*S12*S24*S34*XCW2-4D0*PZ12*PZ34*
     &  S12*S34**2*XCW2+8D0*S13*XCW2**2-8D0*PZ12*S12*S13*XCW2**2+
     &  8D0*S14*XCW2**2-8D0*PZ12*S12*S14*XCW2**2+8D0*S23*XCW2**2-
     &  8D0*PZ12*S12*S23*XCW2**2+8D0*S24*XCW2**2-8D0*PZ12*S12*S24*
     &  XCW2**2-8D0*PZ34*S13*S34*XCW2**2+8D0*PZ12*PZ34*S12*S13*S34*
     &  XCW2**2-8D0*PZ34*S14*S34*XCW2**2+8D0*PZ12*PZ34*S12*S14*S34*
     &  XCW2**2-8D0*PZ34*S23*S34*XCW2**2+8D0*PZ12*PZ34*S12*S23*S34*
     &  XCW2**2-8D0*PZ34*S24*S34*XCW2**2+8D0*PZ12*PZ34*S12*S24*S34*
     &  XCW2**2+PZ12*PZ34*S12*S34*XMH2+4D0*PZ12*PZ34*S12*S34*
     &  XMW2)))/(S12*S34)
        F(5,-1,-1) = F(5,-1,-1)+(K(6)*PRE*XSW2**(-2))/XCW2
        F(5,-1,1) = F(5,-1,1)-(2D0*K(4)*QF(3)*PRE)/(XCW2*XSW2)
        F(5,1,-1) = F(5,1,-1)-(2D0*K(5)*QF(2)*PRE)/(XCW2*XSW2)
        F(5,1,1) = F(5,1,1)-(4D0*K(7)*QF(2)*QF(3)*PRE)/XCW2
        F(6,-1,-1) = F(6,-1,-1)+(K(6)*PRE*XSW2**(-2))/XCW2
        F(6,-1,1) = F(6,-1,1)-(2D0*K(4)*QF(3)*PRE)/(XCW2*XSW2)
        F(6,1,-1) = F(6,1,-1)-(2D0*K(5)*QF(2)*PRE)/(XCW2*XSW2)
        F(6,1,1) = F(6,1,1)-(4D0*K(7)*QF(2)*QF(3)*PRE)/XCW2
        F(7,-1,-1) = F(7,-1,-1)+(K(6)*PRE*XSW2**(-2))/XCW2
        F(7,-1,1) = F(7,-1,1)-(2D0*K(4)*QF(3)*PRE)/(XCW2*XSW2)
        F(7,1,-1) = F(7,1,-1)-(2D0*K(5)*QF(2)*PRE)/(XCW2*XSW2)
        F(7,1,1) = F(7,1,1)-(4D0*K(7)*QF(2)*QF(3)*PRE)/XCW2
        F(8,-1,-1) = F(8,-1,-1)+(K(6)*PRE*XSW2**(-2))/XCW2
        F(8,-1,1) = F(8,-1,1)-(2D0*K(4)*QF(3)*PRE)/(XCW2*XSW2)
        F(8,1,-1) = F(8,1,-1)-(2D0*K(5)*QF(2)*PRE)/(XCW2*XSW2)
        F(8,1,1) = F(8,1,1)-(4D0*K(7)*QF(2)*QF(3)*PRE)/XCW2

C       G(T5,N61,FULL)+G(T5,N62,FULL)
        CALL xC01234_(S12,MH2,S34,XMZ2,XMH2,XMH2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,0)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = -((3D0*ALPHA*PZ12*PZ34*XCW2**(-2)*XMH2)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(1)*K(2)*PRE*((C0*XMW)/XCW2-(C2(0,
     &  0))/XMW)*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)+(2D0*K(1)*QF(3)*PRE*((C0*XMW)/XCW2-
     &  (C2(0,0))/XMW))/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(2)*PRE*((C0*XMW)/XCW2-
     &  (C2(0,0))/XMW))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*((C0*XMW)/XCW2-
     &  (C2(0,0))/XMW)
        F(5,-1,-1) = F(5,-1,-1)+(C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2))/
     &  XMW
        F(5,-1,1) = F(5,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/(XMW*
     &  XSW2)
        F(5,1,-1) = F(5,1,-1)+(2D0*C2(1,2)*K(2)*QF(2)*PRE)/(XMW*
     &  XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*C2(1,2)*QF(2)*QF(3)*PRE)/XMW
        F(6,-1,-1) = F(6,-1,-1)+(C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2))/
     &  XMW
        F(6,-1,1) = F(6,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/(XMW*
     &  XSW2)
        F(6,1,-1) = F(6,1,-1)+(2D0*C2(1,2)*K(2)*QF(2)*PRE)/(XMW*
     &  XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*C2(1,2)*QF(2)*QF(3)*PRE)/XMW
        F(7,-1,-1) = F(7,-1,-1)+(C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2))/
     &  XMW
        F(7,-1,1) = F(7,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/(XMW*
     &  XSW2)
        F(7,1,-1) = F(7,1,-1)+(2D0*C2(1,2)*K(2)*QF(2)*PRE)/(XMW*
     &  XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*C2(1,2)*QF(2)*QF(3)*PRE)/XMW
        F(8,-1,-1) = F(8,-1,-1)+(C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2))/
     &  XMW
        F(8,-1,1) = F(8,-1,1)+(2D0*C2(1,2)*K(1)*QF(3)*PRE)/(XMW*
     &  XSW2)
        F(8,1,-1) = F(8,1,-1)+(2D0*C2(1,2)*K(2)*QF(2)*PRE)/(XMW*
     &  XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*C2(1,2)*QF(2)*QF(3)*PRE)/XMW

C       G(T7,N82,FULL)
        CALL xC01234_(S34,RMF2(3),RMF2(3),CMF2(3),CMF2(3),XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S34-C1(2)*
     &  S34-C2(1,1)*S34-C2(1,2)*S34)*XCW2**(-3)*XMW)/(32D0*PI))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*XSW2**(-2)*(1D0+2D0*QF(2)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2)**3)/XSW
        F(1,-1,1) = F(1,-1,1)+8D0*QF(3)**3*PRE*XSW*(1D0+2D0*QF(2)*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2)**
     &  3)/(XSW*XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(2)*QF(3)**3*PRE*XSW*XSW2

C       G(T7,N79,FULL)
        CALL xC01234_(S34,RMF2(3),RMF2(3),CMF2(4),CMF2(4),XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S34-C1(2)*S34-
     &  C2(1,1)*S34-C2(1,2)*S34)*XCW2**(-2)*XMW*(1D0-2D0*QF(4)*
     &  XSW2))/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(2)*PRE

C       G(T2,N5,FULL)+G(T2,N7,FULL)
        CALL xC01234_(T12,MH2,RMF2(2),CMF2(2),XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*XCW2**(-3)*XMW)/(32D0*PI*S34)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*XSW2**(-2)*(1D0+2D0*QF(2)*
     &  XSW2)**2*(PZ34*S34+2D0*QF(2)*PZ34*S34*XSW2+2D0*QF(3)*PZ34*
     &  S34*XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*QF(2)*QF(3)*PZ34*S34*
     &  XSW2**2))/XSW
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2)**
     &  2*(PZ34*S34+2D0*QF(2)*XCW2+2D0*QF(2)*PZ34*S34*XSW2))/(XSW*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*QF(2)**3*PRE*XSW*(PZ34*S34+2D0*
     &  QF(3)*XCW2+2D0*QF(3)*PZ34*S34*XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(2)**3*QF(3)*PRE*XSW*(XCW2+PZ34*
     &  S34*XSW2)

C       G(T4,N14,FULL)+G(T4,N16,FULL)
        CALL xC01234_(T13,MH2,RMF2(3),CMF2(3),XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*XCW2**(-3)*XMW)/(32D0*PI*S12)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*XSW2**(-2)*(1D0+2D0*QF(3)*
     &  XSW2)**2*(PZ12*S12+2D0*QF(2)*PZ12*S12*XSW2+2D0*QF(3)*PZ12*
     &  S12*XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*QF(2)*QF(3)*PZ12*S12*
     &  XSW2**2))/XSW
        F(1,-1,1) = F(1,-1,1)+8D0*QF(3)**3*PRE*XSW*(PZ12*S12+2D0*
     &  QF(2)*XCW2+2D0*QF(2)*PZ12*S12*XSW2)
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2)**
     &  2*(PZ12*S12+2D0*QF(3)*XCW2+2D0*QF(3)*PZ12*S12*XSW2))/(XSW*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(2)*QF(3)**3*PRE*XSW*(XCW2+PZ12*
     &  S12*XSW2)

C       G(T6,N75,FULL)+G(T6,N77,FULL)
        CALL xC01234_(T14,MH2,RMF2(3),CMF2(3),XMZ2,XMZ2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*XCW2**(-3)*XMW)/(32D0*PI*S12)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*XSW2**(-2)*(1D0+2D0*QF(3)*
     &  XSW2)**2*(PZ12*S12+2D0*QF(2)*PZ12*S12*XSW2+2D0*QF(3)*PZ12*
     &  S12*XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*QF(2)*QF(3)*PZ12*S12*
     &  XSW2**2))/XSW
        F(1,-1,1) = F(1,-1,1)+8D0*QF(3)**3*PRE*XSW*(PZ12*S12+2D0*
     &  QF(2)*XCW2+2D0*QF(2)*PZ12*S12*XSW2)
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2)**
     &  2*(PZ12*S12+2D0*QF(3)*XCW2+2D0*QF(3)*PZ12*S12*XSW2))/(XSW*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(2)*QF(3)**3*PRE*XSW*(XCW2+PZ12*
     &  S12*XSW2)

C       G(T6,N76,FULL)+G(T6,N78,FULL)
        CALL xC01234_(T14,MH2,RMF2(3),CMF2(4),XMW2,XMW2,
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*XMW)/(16D0*PI*S12*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(PZ12*S12+2D0*QF(2)*PZ12*S12*
     &  XSW2+2D0*QF(3)*PZ12*S12*XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*
     &  QF(2)*QF(3)*PZ12*S12*XSW2**2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(2)*PRE*(PZ12*S12+2D0*QF(3)*
     &  XCW2+2D0*QF(3)*PZ12*S12*XSW2)

c*** counterterms
c----------------
        PRE = (PZ12*PZ34*XCW2**(-2)*XMW)/4D0

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
     &          *( ct_hzz + ct_zddl + ct_zddl
     &             +dZza/2d0*(-qd/gdd(-1)/s12/pz12-qd/gdd(-1)/s34/pz34))
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/XSW
     &          *( ct_hzz + ct_zddl + ct_zddr
     &             +dZza/2d0*(-qd/gdd(-1)/s12/pz12-qd/gdd(+1)/s34/pz34))
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/XSW
     &          *( ct_hzz + ct_zddr + ct_zddl
     &             +dZza/2d0*(-qd/gdd(+1)/s12/pz12-qd/gdd(-1)/s34/pz34))
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*XSW
     &          *( ct_hzz + ct_zddr + ct_zddr
     &             +dZza/2d0*(-qd/gdd(+1)/s12/pz12-qd/gdd(+1)/s34/pz34))

	end

************************************************************************
        subroutine add_HZZ2233_box_bgf(F,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for ZZ-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    down     anti-down     down     anti-down
*       box corrections         
*       background-field formalism
*-----------------------------------------------------------------------
*       30.12.05 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(9)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pz12,pz34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        COMPLEX*16 xD0_,D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        COMPLEX*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)
	integer i

        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)

C       Process: S10F2200aF2200F2300aF2300,   Model: SMbgf4f

C       G(T6,N17,FULL)+G(T6,N18,FULL)+G(T6,N19,FULL)
        CALL xD012345_(RMF2(2),MH2,S34,RMF2(2),S12,T11,CMF2(1),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-PZ34*S34
        K(2) = PZ34*S34-2D0*QF(3)*XSW2+2D0*QF(3)*PZ34*S34*XSW2

        PRE = -((ALPHA*XMW)/(16D0*PI*S34*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(-(4D0*D2(0,0)*K(2))-2D0*D1(3)*
     &  K(2)*(S23+S24)+(D1(1)*(MH2*PZ34*S34-PZ34*S34*T11-2D0*PZ34*
     &  S13*S34*XCW2-2D0*PZ34*S14*S34*XCW2+2D0*QF(3)*MH2*PZ34*S34*
     &  XSW2-2D0*QF(3)*PZ34*S34*T11*XSW2+4D0*QF(3)*S13*XCW2*XSW2+
     &  4D0*QF(3)*S14*XCW2*XSW2-4D0*QF(3)*PZ34*S13*S34*XCW2*XSW2-
     &  4D0*QF(3)*PZ34*S14*S34*XCW2*XSW2))/XCW2-(D1(2)*(PZ34*S34*
     &  T11+2D0*PZ34*S23*S34*XCW2+2D0*PZ34*S24*S34*XCW2+2D0*QF(3)*
     &  PZ34*S34*T11*XSW2-4D0*QF(3)*S23*XCW2*XSW2-4D0*QF(3)*S24*
     &  XCW2*XSW2+4D0*QF(3)*PZ34*S23*S34*XCW2*XSW2+4D0*QF(3)*PZ34*
     &  S24*S34*XCW2*XSW2))/XCW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*(4D0*D2(0,0)*K(1)+2D0*
     &  D1(3)*K(1)*(S23+S24)+(D1(1)*(MH2*PZ34*S34-PZ34*S34*T11+2D0*
     &  S13*XCW2+2D0*S14*XCW2-2D0*PZ34*S13*S34*XCW2-2D0*PZ34*S14*
     &  S34*XCW2))/XCW2-(D1(2)*(PZ34*S34*T11-2D0*S23*XCW2-2D0*S24*
     &  XCW2+2D0*PZ34*S23*S34*XCW2+2D0*PZ34*S24*S34*XCW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)+(4D0*(D1(1)+D2(1,2))*K(2)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-8D0*(D1(1)+D2(1,2))*K(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(2D0*PRE*(2D0*D2(2,2)*K(2)+2D0*D2(2,
     &  3)*K(2)+(D1(3)*(PZ34*S34-2D0*PZ34*S34*XCW2+2D0*QF(3)*PZ34*
     &  S34*XSW2+4D0*QF(3)*XCW2*XSW2-4D0*QF(3)*PZ34*S34*XCW2*XSW2))/
     &  XCW2))/XSW2
        F(6,-1,1) = F(6,-1,1)-4D0*QF(3)*PRE*(-(2D0*D2(2,2)*K(1))-
     &  2D0*D2(2,3)*K(1)+(D1(3)*(PZ34*S34+2D0*XCW2-2D0*PZ34*S34*
     &  XCW2))/XCW2)
        F(7,-1,-1) = F(7,-1,-1)+(4D0*(D1(1)+D2(1,2))*K(2)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-8D0*(D1(1)+D2(1,2))*K(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(2D0*PRE*(2D0*D2(2,2)*K(2)+2D0*D2(2,
     &  3)*K(2)+(D1(3)*(PZ34*S34-2D0*PZ34*S34*XCW2+2D0*QF(3)*PZ34*
     &  S34*XSW2+4D0*QF(3)*XCW2*XSW2-4D0*QF(3)*PZ34*S34*XCW2*XSW2))/
     &  XCW2))/XSW2
        F(8,-1,1) = F(8,-1,1)-4D0*QF(3)*PRE*(-(2D0*D2(2,2)*K(1))-
     &  2D0*D2(2,3)*K(1)+(D1(3)*(PZ34*S34+2D0*XCW2-2D0*PZ34*S34*
     &  XCW2))/XCW2)

C       G(T1,N1,FULL)+G(T1,N2,FULL)+G(T1,N3,FULL)
        CALL xD012345_(RMF2(2),MH2,S34,RMF2(2),S12,T12,CMF2(1),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-PZ34*S34
        K(2) = PZ34*S34-2D0*QF(3)*XSW2+2D0*QF(3)*PZ34*S34*XSW2

        PRE = -((ALPHA*XMW)/(16D0*PI*S34*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(-(4D0*D2(0,0)*K(2))-2D0*D1(3)*
     &  K(2)*(S13+S14)-(D1(2)*(PZ34*S34*T12+2D0*PZ34*S13*S34*XCW2+
     &  2D0*PZ34*S14*S34*XCW2+2D0*QF(3)*PZ34*S34*T12*XSW2-4D0*QF(3)*
     &  S13*XCW2*XSW2-4D0*QF(3)*S14*XCW2*XSW2+4D0*QF(3)*PZ34*S13*
     &  S34*XCW2*XSW2+4D0*QF(3)*PZ34*S14*S34*XCW2*XSW2))/XCW2+
     &  (D1(1)*(MH2*PZ34*S34-PZ34*S34*T12-2D0*PZ34*S23*S34*XCW2-2D0*
     &  PZ34*S24*S34*XCW2+2D0*QF(3)*MH2*PZ34*S34*XSW2-2D0*QF(3)*
     &  PZ34*S34*T12*XSW2+4D0*QF(3)*S23*XCW2*XSW2+4D0*QF(3)*S24*
     &  XCW2*XSW2-4D0*QF(3)*PZ34*S23*S34*XCW2*XSW2-4D0*QF(3)*PZ34*
     &  S24*S34*XCW2*XSW2))/XCW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*(4D0*D2(0,0)*K(1)+2D0*
     &  D1(3)*K(1)*(S13+S14)-(D1(2)*(PZ34*S34*T12-2D0*S13*XCW2-2D0*
     &  S14*XCW2+2D0*PZ34*S13*S34*XCW2+2D0*PZ34*S14*S34*XCW2))/XCW2+
     &  (D1(1)*(MH2*PZ34*S34-PZ34*S34*T12+2D0*S23*XCW2+2D0*S24*XCW2-
     &  2D0*PZ34*S23*S34*XCW2-2D0*PZ34*S24*S34*XCW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)-(2D0*PRE*(2D0*D2(2,2)*K(2)+2D0*D2(2,
     &  3)*K(2)+(D1(3)*(PZ34*S34-2D0*PZ34*S34*XCW2+2D0*QF(3)*PZ34*
     &  S34*XSW2+4D0*QF(3)*XCW2*XSW2-4D0*QF(3)*PZ34*S34*XCW2*XSW2))/
     &  XCW2))/XSW2
        F(5,-1,1) = F(5,-1,1)-4D0*QF(3)*PRE*(-(2D0*D2(2,2)*K(1))-
     &  2D0*D2(2,3)*K(1)+(D1(3)*(PZ34*S34+2D0*XCW2-2D0*PZ34*S34*
     &  XCW2))/XCW2)
        F(6,-1,-1) = F(6,-1,-1)+(4D0*(D1(1)+D2(1,2))*K(2)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-8D0*(D1(1)+D2(1,2))*K(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(2D0*PRE*(2D0*D2(2,2)*K(2)+2D0*D2(2,
     &  3)*K(2)+(D1(3)*(PZ34*S34-2D0*PZ34*S34*XCW2+2D0*QF(3)*PZ34*
     &  S34*XSW2+4D0*QF(3)*XCW2*XSW2-4D0*QF(3)*PZ34*S34*XCW2*XSW2))/
     &  XCW2))/XSW2
        F(7,-1,1) = F(7,-1,1)-4D0*QF(3)*PRE*(-(2D0*D2(2,2)*K(1))-
     &  2D0*D2(2,3)*K(1)+(D1(3)*(PZ34*S34+2D0*XCW2-2D0*PZ34*S34*
     &  XCW2))/XCW2)
        F(8,-1,-1) = F(8,-1,-1)+(4D0*(D1(1)+D2(1,2))*K(2)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-8D0*(D1(1)+D2(1,2))*K(1)*QF(3)*PRE

C       G(T7,N20,FULL)+G(T7,N21,FULL)+G(T7,N22,FULL)
        CALL xD012345_(RMF2(3),MH2,S12,RMF2(3),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-PZ12*S12
        K(2) = PZ12*S12-2D0*QF(2)*XSW2+2D0*QF(2)*PZ12*S12*XSW2

        PRE = -((ALPHA*XMW)/(16D0*PI*S12*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(-(4D0*D2(0,0)*K(2))-2D0*D1(3)*
     &  K(2)*(S14+S24)+(D1(1)*(MH2*PZ12*S12-PZ12*S12*T13-2D0*PZ12*
     &  S12*S13*XCW2-2D0*PZ12*S12*S23*XCW2+2D0*QF(2)*MH2*PZ12*S12*
     &  XSW2-2D0*QF(2)*PZ12*S12*T13*XSW2+4D0*QF(2)*S13*XCW2*XSW2-
     &  4D0*QF(2)*PZ12*S12*S13*XCW2*XSW2+4D0*QF(2)*S23*XCW2*XSW2-
     &  4D0*QF(2)*PZ12*S12*S23*XCW2*XSW2))/XCW2-(D1(2)*(PZ12*S12*
     &  T13+2D0*PZ12*S12*S14*XCW2+2D0*PZ12*S12*S24*XCW2+2D0*QF(2)*
     &  PZ12*S12*T13*XSW2-4D0*QF(2)*S14*XCW2*XSW2+4D0*QF(2)*PZ12*
     &  S12*S14*XCW2*XSW2-4D0*QF(2)*S24*XCW2*XSW2+4D0*QF(2)*PZ12*
     &  S12*S24*XCW2*XSW2))/XCW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(2)*PRE*(4D0*D2(0,0)*K(1)+2D0*
     &  D1(3)*K(1)*(S14+S24)+(D1(1)*(MH2*PZ12*S12-PZ12*S12*T13+2D0*
     &  S13*XCW2-2D0*PZ12*S12*S13*XCW2+2D0*S23*XCW2-2D0*PZ12*S12*
     &  S23*XCW2))/XCW2-(D1(2)*(PZ12*S12*T13-2D0*S14*XCW2+2D0*PZ12*
     &  S12*S14*XCW2-2D0*S24*XCW2+2D0*PZ12*S12*S24*XCW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)+(4D0*(D1(1)+D2(1,2))*K(2)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-8D0*(D1(1)+D2(1,2))*K(1)*QF(2)*PRE
        F(6,-1,-1) = F(6,-1,-1)+(4D0*(D1(1)+D2(1,2))*K(2)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-8D0*(D1(1)+D2(1,2))*K(1)*QF(2)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(2D0*PRE*(2D0*D2(2,2)*K(2)+2D0*D2(2,
     &  3)*K(2)+(D1(3)*(PZ12*S12-2D0*PZ12*S12*XCW2+2D0*QF(2)*PZ12*
     &  S12*XSW2+4D0*QF(2)*XCW2*XSW2-4D0*QF(2)*PZ12*S12*XCW2*XSW2))/
     &  XCW2))/XSW2
        F(7,1,-1) = F(7,1,-1)-4D0*QF(2)*PRE*(-(2D0*D2(2,2)*K(1))-
     &  2D0*D2(2,3)*K(1)+(D1(3)*(PZ12*S12+2D0*XCW2-2D0*PZ12*S12*
     &  XCW2))/XCW2)
        F(8,-1,-1) = F(8,-1,-1)-(2D0*PRE*(2D0*D2(2,2)*K(2)+2D0*D2(2,
     &  3)*K(2)+(D1(3)*(PZ12*S12-2D0*PZ12*S12*XCW2+2D0*QF(2)*PZ12*
     &  S12*XSW2+4D0*QF(2)*XCW2*XSW2-4D0*QF(2)*PZ12*S12*XCW2*XSW2))/
     &  XCW2))/XSW2
        F(8,1,-1) = F(8,1,-1)-4D0*QF(2)*PRE*(-(2D0*D2(2,2)*K(1))-
     &  2D0*D2(2,3)*K(1)+(D1(3)*(PZ12*S12+2D0*XCW2-2D0*PZ12*S12*
     &  XCW2))/XCW2)

C       G(T9,N25,FULL)+G(T9,N26,FULL)+G(T9,N27,FULL)
        CALL xD012345_(RMF2(3),S12,MH2,RMF2(3),S34,T14,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-PZ12*S12
        K(2) = PZ12*S12-2D0*QF(2)*XSW2+2D0*QF(2)*PZ12*S12*XSW2

        PRE = -((ALPHA*XMW)/(16D0*PI*S12*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(4D0*D2(0,0)*K(2)+2D0*D1(1)*
     &  K(2)*(S13+S23)+(D1(2)*(PZ12*S12*T14+2D0*PZ12*S12*S13*XCW2+
     &  2D0*PZ12*S12*S23*XCW2+2D0*QF(2)*PZ12*S12*T14*XSW2-4D0*QF(2)*
     &  S13*XCW2*XSW2+4D0*QF(2)*PZ12*S12*S13*XCW2*XSW2-4D0*QF(2)*
     &  S23*XCW2*XSW2+4D0*QF(2)*PZ12*S12*S23*XCW2*XSW2))/XCW2-
     &  (D1(3)*(MH2*PZ12*S12-PZ12*S12*T14-2D0*PZ12*S12*S14*XCW2-2D0*
     &  PZ12*S12*S24*XCW2+2D0*QF(2)*MH2*PZ12*S12*XSW2-2D0*QF(2)*
     &  PZ12*S12*T14*XSW2+4D0*QF(2)*S14*XCW2*XSW2-4D0*QF(2)*PZ12*
     &  S12*S14*XCW2*XSW2+4D0*QF(2)*S24*XCW2*XSW2-4D0*QF(2)*PZ12*
     &  S12*S24*XCW2*XSW2))/XCW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(2)*PRE*(4D0*D2(0,0)*K(1)+2D0*
     &  D1(1)*K(1)*(S13+S23)-(D1(2)*(PZ12*S12*T14-2D0*S13*XCW2+2D0*
     &  PZ12*S12*S13*XCW2-2D0*S23*XCW2+2D0*PZ12*S12*S23*XCW2))/XCW2+
     &  (D1(3)*(MH2*PZ12*S12-PZ12*S12*T14+2D0*S14*XCW2-2D0*PZ12*S12*
     &  S14*XCW2+2D0*S24*XCW2-2D0*PZ12*S12*S24*XCW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)-(2D0*PRE*(2D0*D2(1,2)*K(2)+2D0*D2(2,
     &  2)*K(2)+(D1(1)*(PZ12*S12-2D0*PZ12*S12*XCW2+2D0*QF(2)*PZ12*
     &  S12*XSW2+4D0*QF(2)*XCW2*XSW2-4D0*QF(2)*PZ12*S12*XCW2*XSW2))/
     &  XCW2))/XSW2
        F(5,1,-1) = F(5,1,-1)-4D0*QF(2)*PRE*(-(2D0*D2(1,2)*K(1))-
     &  2D0*D2(2,2)*K(1)+(D1(1)*(PZ12*S12+2D0*XCW2-2D0*PZ12*S12*
     &  XCW2))/XCW2)
        F(6,-1,-1) = F(6,-1,-1)-(2D0*PRE*(2D0*D2(1,2)*K(2)+2D0*D2(2,
     &  2)*K(2)+(D1(1)*(PZ12*S12-2D0*PZ12*S12*XCW2+2D0*QF(2)*PZ12*
     &  S12*XSW2+4D0*QF(2)*XCW2*XSW2-4D0*QF(2)*PZ12*S12*XCW2*XSW2))/
     &  XCW2))/XSW2
        F(6,1,-1) = F(6,1,-1)-4D0*QF(2)*PRE*(-(2D0*D2(1,2)*K(1))-
     &  2D0*D2(2,2)*K(1)+(D1(1)*(PZ12*S12+2D0*XCW2-2D0*PZ12*S12*
     &  XCW2))/XCW2)
        F(7,-1,-1) = F(7,-1,-1)+(4D0*(D1(3)+D2(2,3))*K(2)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-8D0*(D1(3)+D2(2,3))*K(1)*QF(2)*PRE
        F(8,-1,-1) = F(8,-1,-1)+(4D0*(D1(3)+D2(2,3))*K(2)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-8D0*(D1(3)+D2(2,3))*K(1)*QF(2)*PRE

C       G(T5,N13,FULL)+G(T5,N15,FULL)
        CALL xD012345_(S12,RMF2(3),MH2,RMF2(3),T13,T14,CMF2(3),
     &  CMF2(3),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = S14+S24
        K(3) = D2(1,2)+D2(2,2)
        K(4) = 2D0*S12+S13+S23
        K(5) = PZ12*S12+2D0*QF(2)*XCW2+2D0*QF(2)*PZ12*S12*XSW2
        K(6) = PZ12*S12+2D0*QF(3)*XCW2+2D0*QF(3)*PZ12*S12*XSW2
        K(7) = D1(3)+D2(1,3)+D2(2,3)
        K(8) = PZ12*S12+2D0*QF(2)*PZ12*S12*XSW2+2D0*QF(3)*PZ12*S12*
     &  XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*QF(2)*QF(3)*PZ12*S12*
     &  XSW2**2
        K(9) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S12+(D2(1,2)*(2D0*
     &  S12+S13+S23))/S12-(D1(3)*(S14+S24))/S12-(D2(1,3)*(S14+S24))/
     &  S12+(D2(2,2)*T14)/S12-(D2(2,3)*(MH2-T14))/S12

        PRE = (ALPHA*XCW2**(-3)*XMW)/(32D0*PI)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)**2*K(8)*K(9)*PRE*XSW2**(-2))/
     &  XSW
        F(1,-1,1) = F(1,-1,1)+8D0*K(5)*K(9)*QF(3)**3*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(1)**2*K(6)*K(9)*QF(2)*PRE)/
     &  (XSW*XSW2)
        F(1,1,1) = F(1,1,1)+16D0*K(9)*QF(2)*QF(3)**3*PRE*XSW*(XCW2+
     &  PZ12*S12*XSW2)
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)**2*K(3)*K(8)*PRE*XSW2**(-
     &  2))/(S12*XSW)
        F(5,-1,1) = F(5,-1,1)-(16D0*K(3)*K(5)*QF(3)**3*PRE*XSW)/S12
        F(5,1,-1) = F(5,1,-1)-(4D0*K(1)**2*K(3)*K(6)*QF(2)*PRE)/
     &  (S12*XSW*XSW2)
        F(5,1,1) = F(5,1,1)-(32D0*K(3)*QF(2)*QF(3)**3*PRE*XSW*(XCW2+
     &  PZ12*S12*XSW2))/S12
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)**2*K(3)*K(8)*PRE*XSW2**(-
     &  2))/(S12*XSW)
        F(6,-1,1) = F(6,-1,1)-(16D0*K(3)*K(5)*QF(3)**3*PRE*XSW)/S12
        F(6,1,-1) = F(6,1,-1)-(4D0*K(1)**2*K(3)*K(6)*QF(2)*PRE)/
     &  (S12*XSW*XSW2)
        F(6,1,1) = F(6,1,1)-(32D0*K(3)*QF(2)*QF(3)**3*PRE*XSW*(XCW2+
     &  PZ12*S12*XSW2))/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)**2*K(7)*K(8)*PRE*XSW2**(-
     &  2))/(S12*XSW)
        F(7,-1,1) = F(7,-1,1)+(16D0*K(5)*K(7)*QF(3)**3*PRE*XSW)/S12
        F(7,1,-1) = F(7,1,-1)+(4D0*K(1)**2*K(6)*K(7)*QF(2)*PRE)/
     &  (S12*XSW*XSW2)
        F(7,1,1) = F(7,1,1)+(32D0*K(7)*QF(2)*QF(3)**3*PRE*XSW*(XCW2+
     &  PZ12*S12*XSW2))/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)**2*K(7)*K(8)*PRE*XSW2**(-
     &  2))/(S12*XSW)
        F(8,-1,1) = F(8,-1,1)+(16D0*K(5)*K(7)*QF(3)**3*PRE*XSW)/S12
        F(8,1,-1) = F(8,1,-1)+(4D0*K(1)**2*K(6)*K(7)*QF(2)*PRE)/
     &  (S12*XSW*XSW2)
        F(8,1,1) = F(8,1,1)+(32D0*K(7)*QF(2)*QF(3)**3*PRE*XSW*(XCW2+
     &  PZ12*S12*XSW2))/S12

C       G(T5,N14,FULL)+G(T5,N16,FULL)
        CALL xD012345_(S12,RMF2(3),MH2,RMF2(3),T13,T14,CMF2(4),
     &  CMF2(4),XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = PZ12*S12-2D0*QF(4)*XCW2-2D0*QF(4)*PZ12*S12*XSW2
        K(2) = D1(3)+D2(1,3)+D2(2,3)
        K(3) = PZ12*S12+2D0*QF(2)*PZ12*S12*XSW2-2D0*QF(4)*PZ12*S12*
     &  XSW2-4D0*QF(2)*QF(4)*XCW2*XSW2-4D0*QF(2)*QF(4)*PZ12*S12*
     &  XSW2**2
        K(4) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S12+(D2(1,2)*(2D0*
     &  S12+S13+S23))/S12-(D1(3)*(S14+S24))/S12-(D2(1,3)*(S14+S24))/
     &  S12+(D2(2,2)*T14)/S12-(D2(2,3)*(MH2-T14))/S12

        PRE = -((ALPHA*XMW)/(16D0*PI*XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(K(3)*K(4)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(1)*K(4)*QF(2)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*K(3)*PRE)/
     &  (S12*XSW2)
        F(5,1,-1) = F(5,1,-1)-(4D0*(D2(1,2)+D2(2,2))*K(1)*QF(2)*
     &  PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*K(3)*PRE)/
     &  (S12*XSW2)
        F(6,1,-1) = F(6,1,-1)-(4D0*(D2(1,2)+D2(2,2))*K(1)*QF(2)*
     &  PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(2)*K(3)*PRE)/(S12*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(1)*K(2)*QF(2)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(2)*K(3)*PRE)/(S12*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(1)*K(2)*QF(2)*PRE)/S12

C       G(T4,N10,FULL)+G(T4,N12,FULL)
        CALL xD012345_(S34,RMF2(2),MH2,RMF2(2),T12,T11,CMF2(1),
     &  CMF2(1),XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = PZ34*S34-2D0*QF(1)*XCW2-2D0*QF(1)*PZ34*S34*XSW2
        K(2) = D1(3)+D2(1,3)+D2(2,3)
        K(3) = PZ34*S34-2D0*QF(1)*PZ34*S34*XSW2+2D0*QF(3)*PZ34*S34*
     &  XSW2-4D0*QF(1)*QF(3)*XCW2*XSW2-4D0*QF(1)*QF(3)*PZ34*S34*
     &  XSW2**2
        K(4) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S34-(D1(3)*(S13+
     &  S14))/S34-(D2(1,3)*(S13+S14))/S34+(D2(1,2)*(S23+S24+2D0*
     &  S34))/S34+(D2(2,2)*T11)/S34-(D2(2,3)*(MH2-T11))/S34

        PRE = -((ALPHA*XMW)/(16D0*PI*XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(K(3)*K(4)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(1)*K(4)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(2)*K(3)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(1)*K(2)*QF(3)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*K(3)*PRE)/
     &  (S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(4D0*(D2(1,2)+D2(2,2))*K(1)*QF(3)*
     &  PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(2)*K(3)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(1)*K(2)*QF(3)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*K(3)*PRE)/
     &  (S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(4D0*(D2(1,2)+D2(2,2))*K(1)*QF(3)*
     &  PRE)/S34

C       G(T4,N11,FULL)+G(T4,N9,FULL)
        CALL xD012345_(S34,RMF2(2),MH2,RMF2(2),T12,T11,CMF2(2),
     &  CMF2(2),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = S13+S14
        K(3) = D2(1,2)+D2(2,2)
        K(4) = S23+S24+2D0*S34
        K(5) = PZ34*S34+2D0*QF(2)*XCW2+2D0*QF(2)*PZ34*S34*XSW2
        K(6) = PZ34*S34+2D0*QF(3)*XCW2+2D0*QF(3)*PZ34*S34*XSW2
        K(7) = D1(3)+D2(1,3)+D2(2,3)
        K(8) = PZ34*S34+2D0*QF(2)*PZ34*S34*XSW2+2D0*QF(3)*PZ34*S34*
     &  XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*QF(2)*QF(3)*PZ34*S34*
     &  XSW2**2
        K(9) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S34-(D1(3)*(S13+
     &  S14))/S34-(D2(1,3)*(S13+S14))/S34+(D2(1,2)*(S23+S24+2D0*
     &  S34))/S34+(D2(2,2)*T11)/S34-(D2(2,3)*(MH2-T11))/S34

        PRE = (ALPHA*XCW2**(-3)*XMW)/(32D0*PI)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)**2*K(8)*K(9)*PRE*XSW2**(-2))/
     &  XSW
        F(1,-1,1) = F(1,-1,1)+(2D0*K(1)**2*K(5)*K(9)*QF(3)*PRE)/
     &  (XSW*XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*K(6)*K(9)*QF(2)**3*PRE*XSW
        F(1,1,1) = F(1,1,1)+16D0*K(9)*QF(2)**3*QF(3)*PRE*XSW*(XCW2+
     &  PZ34*S34*XSW2)
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)**2*K(7)*K(8)*PRE*XSW2**(-
     &  2))/(S34*XSW)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(1)**2*K(5)*K(7)*QF(3)*PRE)/
     &  (S34*XSW*XSW2)
        F(5,1,-1) = F(5,1,-1)+(16D0*K(6)*K(7)*QF(2)**3*PRE*XSW)/S34
        F(5,1,1) = F(5,1,1)+(32D0*K(7)*QF(2)**3*QF(3)*PRE*XSW*(XCW2+
     &  PZ34*S34*XSW2))/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)**2*K(3)*K(8)*PRE*XSW2**(-
     &  2))/(S34*XSW)
        F(6,-1,1) = F(6,-1,1)-(4D0*K(1)**2*K(3)*K(5)*QF(3)*PRE)/
     &  (S34*XSW*XSW2)
        F(6,1,-1) = F(6,1,-1)-(16D0*K(3)*K(6)*QF(2)**3*PRE*XSW)/S34
        F(6,1,1) = F(6,1,1)-(32D0*K(3)*QF(2)**3*QF(3)*PRE*XSW*(XCW2+
     &  PZ34*S34*XSW2))/S34
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)**2*K(7)*K(8)*PRE*XSW2**(-
     &  2))/(S34*XSW)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(1)**2*K(5)*K(7)*QF(3)*PRE)/
     &  (S34*XSW*XSW2)
        F(7,1,-1) = F(7,1,-1)+(16D0*K(6)*K(7)*QF(2)**3*PRE*XSW)/S34
        F(7,1,1) = F(7,1,1)+(32D0*K(7)*QF(2)**3*QF(3)*PRE*XSW*(XCW2+
     &  PZ34*S34*XSW2))/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)**2*K(3)*K(8)*PRE*XSW2**(-
     &  2))/(S34*XSW)
        F(8,-1,1) = F(8,-1,1)-(4D0*K(1)**2*K(3)*K(5)*QF(3)*PRE)/
     &  (S34*XSW*XSW2)
        F(8,1,-1) = F(8,1,-1)-(16D0*K(3)*K(6)*QF(2)**3*PRE*XSW)/S34
        F(8,1,1) = F(8,1,1)-(32D0*K(3)*QF(2)**3*QF(3)*PRE*XSW*(XCW2+
     &  PZ34*S34*XSW2))/S34

	end

************************************************************************
        subroutine add_HZZ2233_endp(F,Fgd,Fgnd,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for ZZ-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    down     anti-down     down     anti-down
*	endpoint contribution for dipole subtraction
*-----------------------------------------------------------------------
*       1.1.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pz12,pz34
        COMPLEX*16 Fgd(13,-1:1,-1:1),Fgnd(13,-1:1,-1:1)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        real*8 s(4,4),sh(4),q(4),m2(4)
        integer i,j
        integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        common/constsub/constff,constfi,constif,constii
        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        COMMON/IR/LAMBDA,LAMBDA2,DELTAS
        common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp

        L(p2,mi2,mj2) =  (log(mi2/p2)+log(mj2/p2)+2d0)*log(lambda2/p2)
     &                  -log(mi2/p2)**2/2d0+log(mi2/p2)/2d0
     &                  -log(mj2/p2)**2/2d0+log(mj2/p2)/2d0

        q(1)  = qd
        q(2)  = qd
        q(3)  = qd
        q(4)  = qd
        m2(1) = md2
        m2(2) = md2
        m2(3) = md2
        m2(4) = md2

        s(1,2) = s12
        s(1,3) = s13
        s(1,4) = s14
        s(2,3) = s23
        s(2,4) = s24
        s(3,4) = s34
        sh(1)  = t11
        sh(2)  = t12
        sh(3)  = t13
        sh(4)  = t14

        Gsub = 0d0
        Gsubgd = 0d0
        Gsubgnd = 0d0
        do 20 i=2,4
        do 20 j=1,i-1
          diri = sign(1d0,sh(i))
          dirj = sign(1d0,sh(j))
          if (diri*dirj.lt.0d0) const = constif+constfi+1d0
          if ((diri.lt.0d0).and.(dirj.lt.0d0)) const = 2d0*constii+1d0
          if ((diri.gt.0d0).and.(dirj.gt.0d0)) const = 2d0*constff+1d0
          fac = (-1)**(i+j)*(L(abs(s(j,i)),m2(i),m2(j)) + const)
          if (qbos.ne.0)
     &      Gsub = Gsub - q(i)*q(j)*fac
          if ((qqcddiag.ne.0).and.((i+j.eq.3).or.(i+j.eq.7)))
     &      Gsubgd = Gsubgd - fac
          if (qqcdnondiag.ne.0)
     &      Gsubgnd = Gsubgnd - fac
20      continue

        Gsub = Gsub*alpha/4d0/pi
        Gsubgd = Gsubgd*alphas/3d0/pi
        Gsubgnd = Gsubgnd*alphas/3d0/pi

        PRE = (PZ12*PZ34*XCW2**(-2)*XMW)/4D0

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2) * Gsub
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/XSW
     &                  *Gsub
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/XSW
     &                  *Gsub
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*XSW * Gsub

        Fgd(1,-1,-1) = Fgd(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2) * Gsubgd
        Fgd(1,-1,1) = Fgd(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))
     &                  /XSW*Gsubgd
        Fgd(1,1,-1) = Fgd(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))
     &                  /XSW*Gsubgd
        Fgd(1,1,1) = Fgd(1,1,1)+4D0*QF(2)*QF(3)*PRE*XSW * Gsubgd

        Fgnd(1,-1,-1) = Fgnd(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)
     &  *(1D0+2D0*QF(3)*XSW2))/(XSW*XSW2) * Gsubgnd
        Fgnd(1,-1,1) = Fgnd(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))
     &                  /XSW*Gsubgnd
        Fgnd(1,1,-1) = Fgnd(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))
     &                  /XSW*Gsubgnd
        Fgnd(1,1,1) = Fgnd(1,1,1)+4D0*QF(2)*QF(3)*PRE*XSW * Gsubgnd

        end

************************************************************************
        subroutine add_HZZ2233_qcdv(F,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for ZZ-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    down     anti-down     down     anti-down
*       gluonic vertex corrections
*-----------------------------------------------------------------------
*       4.1.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(20)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pz12,pz34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 dZdd
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)
	integer i

        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)
        COMMON/UV/MUDIM2
        COMMON/IR/LAMBDA,LAMBDA2,DELTAS

        dZdd = -1d0/3D0/PI*(log(mudim2/md2)+4d0+4d0*log(lambda/md))

C       G(T1,N3,FULL)
        CALL xC01234_(RMF2(2),S12,RMF2(2),NULL,CMF2(2),CMF2(2),
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((4d0/3d0*alphas*PZ12*PZ34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S12+C1(2)*S12+C2(1,2)*S12+C0*S12)*XCW2**(-2)*XMW)/(8D0*PI))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*XSW

c counterterm
        PRE = (PZ12*PZ34*XCW2**(-2)*XMW)/4D0

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2) * alphas*dZdd
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/XSW
     &          * alphas*dZdd
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/XSW
     &          * alphas*dZdd
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*XSW * alphas*dZdd

C       G(T7,N109,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(3),NULL,CMF2(3),CMF2(3),
     &	C0,C1,C2,C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((4d0/3d0*alphas*PZ12*PZ34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S34+C1(2)*S34+C2(1,2)*S34+C0*S34)*XCW2**(-2)*XMW)/(8D0*PI))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*XSW

c counterterm
        PRE = (PZ12*PZ34*XCW2**(-2)*XMW)/4D0

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2) * alphas*dZdd
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/XSW
     &          * alphas*dZdd
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/XSW
     &          * alphas*dZdd
        F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*XSW * alphas*dZdd

	end

************************************************************************
        subroutine add_HZZ2233_gpent(F,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for ZZ-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    down     anti-down     down     anti-down
*       gluonic pentagon corrections         
*-----------------------------------------------------------------------
*       4.1.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(10)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pz12,pz34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        COMPLEX*16 xD0_,D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        COMPLEX*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
        COMPLEX*16 E0n,E1n(4),E2n(0:4,0:4),E3n(0:4,0:4,4)
        COMPLEX*16 E4n(0:4,0:4,0:4,0:4)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)
	integer i

        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)

c squared Higgs momentum
        ph2 = s12+s13+s14+s23+s24+s34

C       Process: S1F22aF22F23aF23,   Model: SM4f

C       G(T3,N8,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(3),RMF2(3),ph2,RMF2(2),S14,S34,
     &  T13,T12,S12,CMF2(2),NULL,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = 2D0*S14+S34
        K(4) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(5) = E1N(4)+E2N(2,4)+E2N(3,4)
        K(6) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(7) = 2D0*E1N(3)+3D0*E2N(1,3)+3D0*E2N(2,3)+3D0*E2N(3,3)
        K(8) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(9) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(10) = 10D0*E2N(0,0)-E1N(4)*S12-2D0*E2N(1,4)*S12+E1N(1)*
     &  S14+2D0*E1N(2)*S14+2D0*E2N(1,2)*S14+2D0*E2N(1,3)*S14+2D0*
     &  E2N(2,2)*S14-2D0*E2N(2,4)*(S12+S24)+2D0*E2N(3,3)*(S14+S34)+
     &  E1N(3)*(2D0*S14+S34)+2D0*E2N(2,3)*(2D0*S14+S34)-2D0*E2N(3,
     &  4)*(ph2-T12)

        PRE = -((4d0/3d0*alphas*XCW2**(-2)*XMW)/(16D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)-(4D0*K(10)*K(2)*QF(2)*PRE)/XSW
        F(1,1,1) = F(1,1,1)-8D0*K(10)*QF(2)*QF(3)*PRE*XSW
        F(2,-1,-1) = F(2,-1,-1)-(2D0*K(1)*K(2)*K(8)*PRE)/(XSW*XSW2)
        F(2,-1,1) = F(2,-1,1)-(4D0*K(1)*K(8)*QF(3)*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)-(4D0*K(2)*K(8)*QF(2)*PRE)/XSW
        F(2,1,1) = F(2,1,1)-8D0*K(8)*QF(2)*QF(3)*PRE*XSW
        F(3,-1,-1) = F(3,-1,-1)+(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(3,-1,1) = F(3,-1,1)+(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)+(4D0*K(2)*K(4)*QF(2)*PRE)/XSW
        F(3,1,1) = F(3,1,1)+8D0*K(4)*QF(2)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(4D0*K(1)*K(2)*K(7)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)-(8D0*K(1)*K(7)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(8D0*K(2)*K(7)*QF(2)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-16D0*K(7)*QF(2)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(4D0*E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(6,-1,1) = F(6,-1,1)+(8D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(8D0*E2N(3,4)*K(2)*QF(2)*PRE)/XSW
        F(6,1,1) = F(6,1,1)+16D0*E2N(3,4)*QF(2)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(4D0*K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(7,-1,1) = F(7,-1,1)-(8D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(8D0*K(2)*K(9)*QF(2)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-16D0*K(9)*QF(2)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)+(4D0*K(1)*K(2)*K(5)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(8D0*K(1)*K(5)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(8D0*K(2)*K(5)*QF(2)*PRE)/XSW
        F(8,1,1) = F(8,1,1)+16D0*K(5)*QF(2)*QF(3)*PRE*XSW
        F(9,-1,-1) = F(9,-1,-1)+(K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(9,-1,1) = F(9,-1,1)+(2D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(2D0*K(2)*K(6)*QF(2)*PRE)/XSW
        F(9,1,1) = F(9,1,1)+4D0*K(6)*QF(2)*QF(3)*PRE*XSW
        F(10,-1,-1) = F(10,-1,-1)-(E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(10,-1,1) = F(10,-1,1)-(2D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)-(2D0*E2N(3,4)*K(2)*QF(2)*PRE)/XSW
        F(10,1,1) = F(10,1,1)-4D0*E2N(3,4)*QF(2)*QF(3)*PRE*XSW
        F(11,-1,-1) = F(11,-1,-1)+(K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(11,-1,1) = F(11,-1,1)+(2D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(11,1,-1) = F(11,1,-1)+(2D0*K(2)*K(9)*QF(2)*PRE)/XSW
        F(11,1,1) = F(11,1,1)+4D0*K(9)*QF(2)*QF(3)*PRE*XSW
        F(12,-1,-1) = F(12,-1,-1)-((E2N(2,4)+E2N(3,4))*K(1)*K(2)*
     &  PRE)/(XSW*XSW2)
        F(12,-1,1) = F(12,-1,1)-(2D0*(E2N(2,4)+E2N(3,4))*K(1)*QF(3)*
     &  PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(2D0*(E2N(2,4)+E2N(3,4))*K(2)*QF(2)*
     &  PRE)/XSW
        F(12,1,1) = F(12,1,1)-4D0*(E2N(2,4)+E2N(3,4))*QF(2)*QF(3)*
     &  PRE*XSW
        F(13,-1,-1) = F(13,-1,-1)+(E2N(0,0)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(13,-1,1) = F(13,-1,1)+(2D0*E2N(0,0)*K(1)*QF(3)*PRE)/XSW
        F(13,1,-1) = F(13,1,-1)+(2D0*E2N(0,0)*K(2)*QF(2)*PRE)/XSW
        F(13,1,1) = F(13,1,1)+4D0*E2N(0,0)*QF(2)*QF(3)*PRE*XSW

C       G(T8,N26,FULL)
        CALL xE01234_NEW(RMF2(2),RMF2(3),RMF2(3),ph2,RMF2(2),S24,S34,
     &  T13,T11,S12,CMF2(2),NULL,CMF2(3),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(4) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(5) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(6) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)

        PRE = (4d0/3d0*alphas*XCW2**(-2)*XMW)/(16D0*PI)

        F(1,-1,-1) = F(1,-1,-1)-(2D0*K(1)*K(2)*PRE*(-(2D0*E2N(3,4)*
     &  S13)+E1N(1)*S24))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(4D0*K(1)*QF(3)*PRE*(-(2D0*E2N(3,4)*
     &  S13)+E1N(1)*S24))/XSW
        F(1,1,-1) = F(1,1,-1)-(4D0*K(2)*QF(2)*PRE*(-(2D0*E2N(3,4)*
     &  S13)+E1N(1)*S24))/XSW
        F(1,1,1) = F(1,1,1)-8D0*QF(2)*QF(3)*PRE*(-(2D0*E2N(3,4)*
     &  S13)+E1N(1)*S24)*XSW
        F(2,-1,-1) = F(2,-1,-1)+(2D0*K(1)*K(2)*K(5)*PRE)/(XSW*XSW2)
        F(2,-1,1) = F(2,-1,1)+(4D0*K(1)*K(5)*QF(3)*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(4D0*K(2)*K(5)*QF(2)*PRE)/XSW
        F(2,1,1) = F(2,1,1)+8D0*K(5)*QF(2)*QF(3)*PRE*XSW
        F(3,-1,-1) = F(3,-1,-1)-(2D0*K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(3,-1,1) = F(3,-1,1)-(4D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(4D0*K(2)*K(3)*QF(2)*PRE)/XSW
        F(3,1,1) = F(3,1,1)-8D0*K(3)*QF(2)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(8D0*E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(5,-1,1) = F(5,-1,1)-(16D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(16D0*E2N(3,4)*K(2)*QF(2)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-32D0*E2N(3,4)*QF(2)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)+(4D0*E1N(3)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(6,-1,1) = F(6,-1,1)+(8D0*E1N(3)*K(1)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)+(8D0*E1N(3)*K(2)*QF(2)*PRE)/XSW
        F(6,1,1) = F(6,1,1)+16D0*E1N(3)*QF(2)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(4D0*E1N(4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(7,-1,1) = F(7,-1,1)+(8D0*E1N(4)*K(1)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(8D0*E1N(4)*K(2)*QF(2)*PRE)/XSW
        F(7,1,1) = F(7,1,1)+16D0*E1N(4)*QF(2)*QF(3)*PRE*XSW
        F(9,-1,-1) = F(9,-1,-1)+(E2N(3,4)*K(1)*K(2)*PRE)/(XSW*XSW2)
        F(9,-1,1) = F(9,-1,1)+(2D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(2D0*E2N(3,4)*K(2)*QF(2)*PRE)/XSW
        F(9,1,1) = F(9,1,1)+4D0*E2N(3,4)*QF(2)*QF(3)*PRE*XSW
        F(10,-1,-1) = F(10,-1,-1)-(K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(10,-1,1) = F(10,-1,1)-(2D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)-(2D0*K(2)*K(4)*QF(2)*PRE)/XSW
        F(10,1,1) = F(10,1,1)-4D0*K(4)*QF(2)*QF(3)*PRE*XSW
        F(11,-1,-1) = F(11,-1,-1)+((E2N(2,4)+E2N(3,4))*K(1)*K(2)*
     &  PRE)/(XSW*XSW2)
        F(11,-1,1) = F(11,-1,1)+(2D0*(E2N(2,4)+E2N(3,4))*K(1)*QF(3)*
     &  PRE)/XSW
        F(11,1,-1) = F(11,1,-1)+(2D0*(E2N(2,4)+E2N(3,4))*K(2)*QF(2)*
     &  PRE)/XSW
        F(11,1,1) = F(11,1,1)+4D0*(E2N(2,4)+E2N(3,4))*QF(2)*QF(3)*
     &  PRE*XSW
        F(12,-1,-1) = F(12,-1,-1)-(K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(12,-1,1) = F(12,-1,1)-(2D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(2D0*K(2)*K(6)*QF(2)*PRE)/XSW
        F(12,1,1) = F(12,1,1)-4D0*K(6)*QF(2)*QF(3)*PRE*XSW
        F(13,-1,-1) = F(13,-1,-1)-(E2N(0,0)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(13,-1,1) = F(13,-1,1)-(2D0*E2N(0,0)*K(1)*QF(3)*PRE)/XSW
        F(13,1,-1) = F(13,1,-1)-(2D0*E2N(0,0)*K(2)*QF(2)*PRE)/XSW
        F(13,1,1) = F(13,1,1)-4D0*E2N(0,0)*QF(2)*QF(3)*PRE*XSW

C       G(T2,N5,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(2),ph2,RMF2(3),S13,S12,
     &  T12,T14,S34,CMF2(3),NULL,CMF2(2),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(4) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(5) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(6) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(7) = E1N(1)+2D0*E1N(2)+2D0*E1N(3)+2D0*E2N(1,2)+2D0*E2N(1,
     &  3)+2D0*E2N(2,2)+4D0*E2N(2,3)+2D0*E2N(3,3)

        PRE = -((4d0/3d0*alphas*XCW2**(-2)*XMW)/(16D0*PI))

        F(1,-1,-1) = F(1,-1,-1)+(2D0*K(1)*K(2)*K(7)*PRE*S13)/(XSW*
     &  XSW2)
        F(1,-1,1) = F(1,-1,1)+(4D0*K(1)*K(7)*QF(3)*PRE*S13)/XSW
        F(1,1,-1) = F(1,1,-1)+(4D0*K(2)*K(7)*QF(2)*PRE*S13)/XSW
        F(1,1,1) = F(1,1,1)+8D0*K(7)*QF(2)*QF(3)*PRE*S13*XSW
        F(2,-1,-1) = F(2,-1,-1)+(2D0*K(1)*K(2)*K(3)*PRE)/(XSW*XSW2)
        F(2,-1,1) = F(2,-1,1)+(4D0*K(1)*K(3)*QF(3)*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(4D0*K(2)*K(3)*QF(2)*PRE)/XSW
        F(2,1,1) = F(2,1,1)+8D0*K(3)*QF(2)*QF(3)*PRE*XSW
        F(3,-1,-1) = F(3,-1,-1)-(2D0*K(1)*K(2)*K(5)*PRE)/(XSW*XSW2)
        F(3,-1,1) = F(3,-1,1)-(4D0*K(1)*K(5)*QF(3)*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(4D0*K(2)*K(5)*QF(2)*PRE)/XSW
        F(3,1,1) = F(3,1,1)-8D0*K(5)*QF(2)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(8D0*K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)-(16D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(16D0*K(2)*K(6)*QF(2)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-32D0*K(6)*QF(2)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(4D0*E1N(3)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(6,-1,1) = F(6,-1,1)-(8D0*E1N(3)*K(1)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(8D0*E1N(3)*K(2)*QF(2)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-16D0*E1N(3)*QF(2)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)-(4D0*E1N(4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(7,-1,1) = F(7,-1,1)-(8D0*E1N(4)*K(1)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)-(8D0*E1N(4)*K(2)*QF(2)*PRE)/XSW
        F(7,1,1) = F(7,1,1)-16D0*E1N(4)*QF(2)*QF(3)*PRE*XSW
        F(9,-1,-1) = F(9,-1,-1)+(K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(9,-1,1) = F(9,-1,1)+(2D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(2D0*K(2)*K(6)*QF(2)*PRE)/XSW
        F(9,1,1) = F(9,1,1)+4D0*K(6)*QF(2)*QF(3)*PRE*XSW
        F(10,-1,-1) = F(10,-1,-1)+(K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(10,-1,1) = F(10,-1,1)+(2D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)+(2D0*K(2)*K(4)*QF(2)*PRE)/XSW
        F(10,1,1) = F(10,1,1)+4D0*K(4)*QF(2)*QF(3)*PRE*XSW
        F(11,-1,-1) = F(11,-1,-1)-((E2N(2,4)+E2N(3,4))*K(1)*K(2)*
     &  PRE)/(XSW*XSW2)
        F(11,-1,1) = F(11,-1,1)-(2D0*(E2N(2,4)+E2N(3,4))*K(1)*QF(3)*
     &  PRE)/XSW
        F(11,1,-1) = F(11,1,-1)-(2D0*(E2N(2,4)+E2N(3,4))*K(2)*QF(2)*
     &  PRE)/XSW
        F(11,1,1) = F(11,1,1)-4D0*(E2N(2,4)+E2N(3,4))*QF(2)*QF(3)*
     &  PRE*XSW
        F(12,-1,-1) = F(12,-1,-1)-(E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(12,-1,1) = F(12,-1,1)-(2D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(2D0*E2N(3,4)*K(2)*QF(2)*PRE)/XSW
        F(12,1,1) = F(12,1,1)-4D0*E2N(3,4)*QF(2)*QF(3)*PRE*XSW
        F(13,-1,-1) = F(13,-1,-1)+(E2N(0,0)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(13,-1,1) = F(13,-1,1)+(2D0*E2N(0,0)*K(1)*QF(3)*PRE)/XSW
        F(13,1,-1) = F(13,1,-1)+(2D0*E2N(0,0)*K(2)*QF(2)*PRE)/XSW
        F(13,1,1) = F(13,1,1)+4D0*E2N(0,0)*QF(2)*QF(3)*PRE*XSW

C       G(T10,N32,FULL)
        CALL xE01234_NEW(RMF2(3),RMF2(2),RMF2(2),ph2,RMF2(3),S23,S12,
     &  T11,T14,S34,CMF2(3),NULL,CMF2(2),XMZ2,XMZ2,E0N,E1N,E2N,E3N,
     &  E4N,D0,D1,D2,D3,2,1)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = S12+2D0*S23
        K(4) = E1N(3)+2D0*E2N(2,3)+2D0*E2N(3,3)
        K(5) = E1N(4)+E2N(2,4)+E2N(3,4)
        K(6) = E1N(3)+E2N(1,3)+E2N(2,3)+E2N(3,3)
        K(7) = 2D0*E1N(3)+3D0*E2N(1,3)+3D0*E2N(2,3)+3D0*E2N(3,3)
        K(8) = E1N(4)+2D0*E2N(1,4)+2D0*E2N(2,4)+2D0*E2N(3,4)
        K(9) = E1N(2)+E1N(3)+E2N(1,2)+E2N(1,3)+E2N(2,2)+2D0*E2N(2,
     &  3)+E2N(3,3)
        K(10) = 10D0*E2N(0,0)+E1N(1)*S23+2D0*E1N(2)*S23+2D0*E2N(1,
     &  2)*S23+2D0*E2N(1,3)*S23+2D0*E2N(2,2)*S23+2D0*E2N(3,3)*(S12+
     &  S23)+E1N(3)*(S12+2D0*S23)+2D0*E2N(2,3)*(S12+2D0*S23)-E1N(4)*
     &  S34-2D0*E2N(1,4)*S34-2D0*E2N(2,4)*(S24+S34)-2D0*E2N(3,4)*
     &  (ph2-T14)

        PRE = -((4d0/3d0*alphas*XCW2**(-2)*XMW)/(16D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(2D0*K(1)*K(10)*K(2)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(4D0*K(1)*K(10)*QF(3)*PRE)/XSW
        F(1,1,-1) = F(1,1,-1)-(4D0*K(10)*K(2)*QF(2)*PRE)/XSW
        F(1,1,1) = F(1,1,1)-8D0*K(10)*QF(2)*QF(3)*PRE*XSW
        F(2,-1,-1) = F(2,-1,-1)+(2D0*K(1)*K(2)*K(4)*PRE)/(XSW*XSW2)
        F(2,-1,1) = F(2,-1,1)+(4D0*K(1)*K(4)*QF(3)*PRE)/XSW
        F(2,1,-1) = F(2,1,-1)+(4D0*K(2)*K(4)*QF(2)*PRE)/XSW
        F(2,1,1) = F(2,1,1)+8D0*K(4)*QF(2)*QF(3)*PRE*XSW
        F(3,-1,-1) = F(3,-1,-1)-(2D0*K(1)*K(2)*K(8)*PRE)/(XSW*XSW2)
        F(3,-1,1) = F(3,-1,1)-(4D0*K(1)*K(8)*QF(3)*PRE)/XSW
        F(3,1,-1) = F(3,1,-1)-(4D0*K(2)*K(8)*QF(2)*PRE)/XSW
        F(3,1,1) = F(3,1,1)-8D0*K(8)*QF(2)*QF(3)*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(4D0*K(1)*K(2)*K(7)*PRE)/(XSW*XSW2)
        F(5,-1,1) = F(5,-1,1)-(8D0*K(1)*K(7)*QF(3)*PRE)/XSW
        F(5,1,-1) = F(5,1,-1)-(8D0*K(2)*K(7)*QF(2)*PRE)/XSW
        F(5,1,1) = F(5,1,1)-16D0*K(7)*QF(2)*QF(3)*PRE*XSW
        F(6,-1,-1) = F(6,-1,-1)-(4D0*K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(6,-1,1) = F(6,-1,1)-(8D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(6,1,-1) = F(6,1,-1)-(8D0*K(2)*K(9)*QF(2)*PRE)/XSW
        F(6,1,1) = F(6,1,1)-16D0*K(9)*QF(2)*QF(3)*PRE*XSW
        F(7,-1,-1) = F(7,-1,-1)+(4D0*E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(7,-1,1) = F(7,-1,1)+(8D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(7,1,-1) = F(7,1,-1)+(8D0*E2N(3,4)*K(2)*QF(2)*PRE)/XSW
        F(7,1,1) = F(7,1,1)+16D0*E2N(3,4)*QF(2)*QF(3)*PRE*XSW
        F(8,-1,-1) = F(8,-1,-1)+(4D0*K(1)*K(2)*K(5)*PRE)/(XSW*XSW2)
        F(8,-1,1) = F(8,-1,1)+(8D0*K(1)*K(5)*QF(3)*PRE)/XSW
        F(8,1,-1) = F(8,1,-1)+(8D0*K(2)*K(5)*QF(2)*PRE)/XSW
        F(8,1,1) = F(8,1,1)+16D0*K(5)*QF(2)*QF(3)*PRE*XSW
        F(9,-1,-1) = F(9,-1,-1)+(K(1)*K(2)*K(6)*PRE)/(XSW*XSW2)
        F(9,-1,1) = F(9,-1,1)+(2D0*K(1)*K(6)*QF(3)*PRE)/XSW
        F(9,1,-1) = F(9,1,-1)+(2D0*K(2)*K(6)*QF(2)*PRE)/XSW
        F(9,1,1) = F(9,1,1)+4D0*K(6)*QF(2)*QF(3)*PRE*XSW
        F(10,-1,-1) = F(10,-1,-1)+(K(1)*K(2)*K(9)*PRE)/(XSW*XSW2)
        F(10,-1,1) = F(10,-1,1)+(2D0*K(1)*K(9)*QF(3)*PRE)/XSW
        F(10,1,-1) = F(10,1,-1)+(2D0*K(2)*K(9)*QF(2)*PRE)/XSW
        F(10,1,1) = F(10,1,1)+4D0*K(9)*QF(2)*QF(3)*PRE*XSW
        F(11,-1,-1) = F(11,-1,-1)-(E2N(3,4)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(11,-1,1) = F(11,-1,1)-(2D0*E2N(3,4)*K(1)*QF(3)*PRE)/XSW
        F(11,1,-1) = F(11,1,-1)-(2D0*E2N(3,4)*K(2)*QF(2)*PRE)/XSW
        F(11,1,1) = F(11,1,1)-4D0*E2N(3,4)*QF(2)*QF(3)*PRE*XSW
        F(12,-1,-1) = F(12,-1,-1)-((E2N(2,4)+E2N(3,4))*K(1)*K(2)*
     &  PRE)/(XSW*XSW2)
        F(12,-1,1) = F(12,-1,1)-(2D0*(E2N(2,4)+E2N(3,4))*K(1)*QF(3)*
     &  PRE)/XSW
        F(12,1,-1) = F(12,1,-1)-(2D0*(E2N(2,4)+E2N(3,4))*K(2)*QF(2)*
     &  PRE)/XSW
        F(12,1,1) = F(12,1,1)-4D0*(E2N(2,4)+E2N(3,4))*QF(2)*QF(3)*
     &  PRE*XSW
        F(13,-1,-1) = F(13,-1,-1)+(E2N(0,0)*K(1)*K(2)*PRE)/(XSW*
     &  XSW2)
        F(13,-1,1) = F(13,-1,1)+(2D0*E2N(0,0)*K(1)*QF(3)*PRE)/XSW
        F(13,1,-1) = F(13,1,-1)+(2D0*E2N(0,0)*K(2)*QF(2)*PRE)/XSW
        F(13,1,1) = F(13,1,1)+4D0*E2N(0,0)*QF(2)*QF(3)*PRE*XSW

	end

************************************************************************
        subroutine add_HZZ2233_qcdv2(F,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for ZZ-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    down     anti-down     down     anti-down
*       gluonic vertex corrections with tree-level g->qq splitting
*-----------------------------------------------------------------------
*       15.10.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pz12,pz34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)

        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)

c squared Higgs momentum
        ph2 = s12+s13+s14+s23+s24+s34

C       Process: S1F22aF22F23aF23,   Model: SM4f

C       G(T5,N282,FULL)+G(T5,N283,FULL)+G(T5,N286,FULL)+G(T5,N287,
C       FULL)
        CALL xC01234_(RMF2(2),ph2,T11,CMF2(1),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*4d0/3d0*ALPHAS*XMW)/(4D0*PI*S34*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE

C       G(T5,N279,FULL)

C       G(T5,N280,FULL)+G(T5,N285,FULL)
        CALL xC01234_(RMF2(2),ph2,T11,CMF2(2),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*4d0/3d0*ALPHAS*XCW2**(-2)*XMW)/(8D0*PI*S34)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,-1,1) = F(1,-1,1)+(PRE*(1D0+2D0*QF(2)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+4D0*QF(2)**2*PRE*XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(2)**2*PRE*XSW

C       G(T4,N202,FULL)+G(T4,N203,FULL)+G(T4,N206,FULL)+G(T4,N207,
C       FULL)
        CALL xC01234_(RMF2(2),ph2,T12,CMF2(1),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*4d0/3d0*ALPHAS*XMW)/(4D0*PI*S34*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,-1,1) = F(1,-1,1)+PRE

C       G(T7,N422,FULL)+G(T7,N423,FULL)+G(T7,N427,FULL)+G(T7,N428,
C       FULL)
        CALL xC01234_(RMF2(3),ph2,T13,CMF2(4),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(2)*4d0/3d0*ALPHAS*XMW)/(4D0*PI*S12*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE

C       G(T12,N1374,FULL)

C       G(T12,N1375,FULL)

C       G(T5,N335,FULL)

C       G(T5,N336,FULL)

C       G(T4,N255,FULL)

C       G(T4,N256,FULL)

C       G(T7,N478,FULL)

C       G(T7,N479,FULL)

C       G(T11,N1258,FULL)

C       G(T11,N1259,FULL)

C       G(T6,N360,FULL)

C       G(T6,N361,FULL)

C       G(T10,N1195,FULL)

C       G(T10,N1196,FULL)

C       G(T8,N504,FULL)

C       G(T8,N505,FULL)

C       G(T4,N199,FULL)

C       G(T4,N200,FULL)+G(T4,N205,FULL)
        CALL xC01234_(T12,ph2,RMF2(2),CMF2(2),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*4d0/3d0*ALPHAS*XCW2**(-2)*XMW)/(8D0*PI*S34)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,-1,1) = F(1,-1,1)+(PRE*(1D0+2D0*QF(2)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+4D0*QF(2)**2*PRE*XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(2)**2*PRE*XSW

C       G(T7,N424,FULL)

C       G(T7,N425,FULL)+G(T7,N430,FULL)
        CALL xC01234_(T13,ph2,RMF2(3),CMF2(3),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*4d0/3d0*ALPHAS*XCW2**(-2)*XMW)/(8D0*PI*S12)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,-1,1) = F(1,-1,1)+4D0*QF(3)**2*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(3)**2*PRE*XSW

C       G(T12,N1318,FULL)

C       G(T12,N1319,FULL)+G(T12,N1324,FULL)
        CALL xC01234_(T14,ph2,RMF2(3),CMF2(3),XMZ2,XMZ2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*4d0/3d0*ALPHAS*XCW2**(-2)*XMW)/(8D0*PI*S12)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,-1,1) = F(1,-1,1)+4D0*QF(3)**2*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2)**2)/(XSW*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+4D0*QF(3)**2*PRE*XSW

C       G(T12,N1321,FULL)+G(T12,N1322,FULL)+G(T12,N1325,FULL)+G(T12,
C       N1326,FULL)
        CALL xC01234_(T14,ph2,RMF2(3),CMF2(4),XMW2,XMW2,C0,C1,C2,C3,C4,
     &  B0,B1,B2,B3,1,1)

        PRE = (C1(1)*4d0/3d0*ALPHAS*XMW)/(4D0*PI*S12*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+PRE
        F(1,1,-1) = F(1,1,-1)+PRE

	end

************************************************************************
        subroutine add_HZZ2233_qcdbox(F,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for ZZ-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    down     anti-down     down     anti-down
*       gluonic box corrections with tree-level g->qq splitting
*-----------------------------------------------------------------------
*       15.10.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(6)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pz12,pz34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        COMPLEX*16 xD0_,D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        COMPLEX*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)

        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)

c squared Higgs momentum
        ph2 = s12+s13+s14+s23+s24+s34

C       Process: S1F22aF22F23aF23,   Model: SM4f

C       G(T5,N18,FULL)
        CALL xD012345_(S12,RMF2(3),ph2,RMF2(3),T13,T14,CMF2(3),
     &  CMF2(3),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = S14+S24
        K(3) = D2(1,2)+D2(2,2)
        K(4) = 2D0*S12+S13+S23
        K(5) = D1(3)+D2(1,3)+D2(2,3)
        K(6) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S12+(D2(1,2)*(2D0*
     &  S12+S13+S23))/S12-(D1(3)*(S14+S24))/S12-(D2(1,3)*(S14+S24))/
     &  S12+(D2(2,2)*T14)/S12-(D2(2,3)*(ph2-T14))/S12

        PRE = (4d0/3d0*ALPHAS*XCW2**(-2)*XMW)/(8D0*PI)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)**2*K(6)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)+4D0*K(6)*QF(3)**2*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(K(1)**2*K(6)*PRE)/(XSW*XSW2)
        F(1,1,1) = F(1,1,1)+4D0*K(6)*QF(3)**2*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)**2*K(3)*PRE)/(S12*XSW*
     &  XSW2)
        F(5,-1,1) = F(5,-1,1)-(8D0*K(3)*QF(3)**2*PRE*XSW)/S12
        F(5,1,-1) = F(5,1,-1)-(2D0*K(1)**2*K(3)*PRE)/(S12*XSW*XSW2)
        F(5,1,1) = F(5,1,1)-(8D0*K(3)*QF(3)**2*PRE*XSW)/S12
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)**2*K(3)*PRE)/(S12*XSW*
     &  XSW2)
        F(6,-1,1) = F(6,-1,1)-(8D0*K(3)*QF(3)**2*PRE*XSW)/S12
        F(6,1,-1) = F(6,1,-1)-(2D0*K(1)**2*K(3)*PRE)/(S12*XSW*XSW2)
        F(6,1,1) = F(6,1,1)-(8D0*K(3)*QF(3)**2*PRE*XSW)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)**2*K(5)*PRE)/(S12*XSW*
     &  XSW2)
        F(7,-1,1) = F(7,-1,1)+(8D0*K(5)*QF(3)**2*PRE*XSW)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)**2*K(5)*PRE)/(S12*XSW*XSW2)
        F(7,1,1) = F(7,1,1)+(8D0*K(5)*QF(3)**2*PRE*XSW)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)**2*K(5)*PRE)/(S12*XSW*
     &  XSW2)
        F(8,-1,1) = F(8,-1,1)+(8D0*K(5)*QF(3)**2*PRE*XSW)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)**2*K(5)*PRE)/(S12*XSW*XSW2)
        F(8,1,1) = F(8,1,1)+(8D0*K(5)*QF(3)**2*PRE*XSW)/S12

C       G(T5,N19,FULL)
        CALL xD012345_(S12,RMF2(3),ph2,RMF2(3),T13,T14,CMF2(4),
     &  CMF2(4),XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)+D2(1,3)+D2(2,3)
        K(2) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S12+(D2(1,2)*(2D0*
     &  S12+S13+S23))/S12-(D1(3)*(S14+S24))/S12-(D2(1,3)*(S14+S24))/
     &  S12+(D2(2,2)*T14)/S12-(D2(2,3)*(ph2-T14))/S12

        PRE = (4d0/3d0*ALPHAS*XMW)/(4D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+K(2)*PRE
        F(1,1,-1) = F(1,1,-1)+K(2)*PRE
        F(5,-1,-1) = F(5,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S12
        F(5,1,-1) = F(5,1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S12
        F(6,1,-1) = F(6,1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/S12
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE)/S12
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*PRE)/S12

C       G(T4,N13,FULL)
        CALL xD012345_(S34,RMF2(2),ph2,RMF2(2),T12,T11,CMF2(1),
     &  CMF2(1),XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = D1(3)+D2(1,3)+D2(2,3)
        K(2) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S34-(D1(3)*(S13+
     &  S14))/S34-(D2(1,3)*(S13+S14))/S34+(D2(1,2)*(S23+S24+2D0*
     &  S34))/S34+(D2(2,2)*T11)/S34-(D2(2,3)*(ph2-T11))/S34

        PRE = (4d0/3d0*ALPHAS*XMW)/(4D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+K(2)*PRE
        F(1,-1,1) = F(1,-1,1)+K(2)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE)/S34
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S34
        F(6,-1,1) = F(6,-1,1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/S34
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S34
        F(8,-1,1) = F(8,-1,1)-(2D0*(D2(1,2)+D2(2,2))*PRE)/S34

C       G(T4,N12,FULL)
        CALL xD012345_(S34,RMF2(2),ph2,RMF2(2),T12,T11,CMF2(2),
     &  CMF2(2),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0+2D0*QF(2)*XSW2
        K(2) = S13+S14
        K(3) = D2(1,2)+D2(2,2)
        K(4) = S23+S24+2D0*S34
        K(5) = D1(3)+D2(1,3)+D2(2,3)
        K(6) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S34-(D1(3)*(S13+
     &  S14))/S34-(D2(1,3)*(S13+S14))/S34+(D2(1,2)*(S23+S24+2D0*
     &  S34))/S34+(D2(2,2)*T11)/S34-(D2(2,3)*(ph2-T11))/S34

        PRE = (4d0/3d0*ALPHAS*XCW2**(-2)*XMW)/(8D0*PI)

        F(1,-1,-1) = F(1,-1,-1)+(K(1)**2*K(6)*PRE)/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)+(K(1)**2*K(6)*PRE)/(XSW*XSW2)
        F(1,1,-1) = F(1,1,-1)+4D0*K(6)*QF(2)**2*PRE*XSW
        F(1,1,1) = F(1,1,1)+4D0*K(6)*QF(2)**2*PRE*XSW
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)**2*K(5)*PRE)/(S34*XSW*
     &  XSW2)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)**2*K(5)*PRE)/(S34*XSW*XSW2)
        F(5,1,-1) = F(5,1,-1)+(8D0*K(5)*QF(2)**2*PRE*XSW)/S34
        F(5,1,1) = F(5,1,1)+(8D0*K(5)*QF(2)**2*PRE*XSW)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*K(1)**2*K(3)*PRE)/(S34*XSW*
     &  XSW2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)**2*K(3)*PRE)/(S34*XSW*XSW2)
        F(6,1,-1) = F(6,1,-1)-(8D0*K(3)*QF(2)**2*PRE*XSW)/S34
        F(6,1,1) = F(6,1,1)-(8D0*K(3)*QF(2)**2*PRE*XSW)/S34
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)**2*K(5)*PRE)/(S34*XSW*
     &  XSW2)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)**2*K(5)*PRE)/(S34*XSW*XSW2)
        F(7,1,-1) = F(7,1,-1)+(8D0*K(5)*QF(2)**2*PRE*XSW)/S34
        F(7,1,1) = F(7,1,1)+(8D0*K(5)*QF(2)**2*PRE*XSW)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)**2*K(3)*PRE)/(S34*XSW*
     &  XSW2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)**2*K(3)*PRE)/(S34*XSW*XSW2)
        F(8,1,-1) = F(8,1,-1)-(8D0*K(3)*QF(2)**2*PRE*XSW)/S34
        F(8,1,1) = F(8,1,1)-(8D0*K(3)*QF(2)**2*PRE*XSW)/S34

	end

************************************************************************
        subroutine add_HZZ2233_qcdferm(F,pz12,pz34,
     &			s12,s13,s14,s23,s24,s34,t11,t12,t13,t14)
************************************************************************
*       form factors for ZZ-mediated channel
*           H(p) --> f1(k1) + anti-f2(k2) + f3(k3) + anti-f4(k4)
*                    down     anti-down     down     anti-down
*       gluon-fusion graphs via quark loops                      
*-----------------------------------------------------------------------
*       15.10.06 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
        COMPLEX*16 K(4)
        COMPLEX*16 F(13,-1:1,-1:1),PRE,pz12,pz34
        COMPLEX*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
        complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
        COMPLEX*16 C4(0:2,0:2,0:2,0:2)
        complex*16 v,cv
        complex*16 xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null
        complex*16 xml,xml2,xmqp,xmqp2,xmqm,xmqm2
        complex*16 guu,gdd            
        complex*16 cme2,cmf2(5)
        real*8 mf2(5),rmf2(5)
	integer i

        common/qf/qu,qd,ql,qn,qf(4),guu(-1:1),gdd(-1:1),mu,mu2,md,md2
        common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2
        common/param/pi,el,alpha,alpha0,alphaz,GF,alphas,
     &         v(3,3),cv(3,3),cw,cw2,sw,sw2,mw,mw2,gw,mz,mz2,gz,mh,mh2,
     &         ml(3),ml2(3),mqp(3),mqp2(3),mqm(3),mqm2(3)
        common/xparam/xcw,xcw2,xsw,xsw2,xmw,xmw2,xmz,xmz2,xmh,xmh2,null,
     &                xml(3),xml2(3),xmqp(3),xmqp2(3),xmqm(3),xmqm2(3)

c squared Higgs momentum
        ph2 = s12+s13+s14+s23+s24+s34

	do 100 i=1,3

C       Process: S1F22aF22F23aF23,   Model: SM4f

C       G(T9,N569,FULL)+G(T9,N572,FULL)
        CALL xC01234_(S12,ph2,S34,XMQM2(I),XMQM2(I),XMQM2(I),C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,0)
        K(1) = -(4D0*C2(1,2))+C0
        K(2) = S13+S14+S23+S24
        K(3) = S13+S14+S23+S24-2D0*XMQM2(I)
        K(4) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)+
     &  (2D0*C2(1,2)*(S13+S14+S23+S24))/(S12*S34)-(C0*(S13+S14+S23+
     &  S24-2D0*XMQM2(I)))/(S12*S34)

        PRE = -((4d0/3d0*ALPHAS**2*XMQM2(I))/(4D0*ALPHA*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(4)*PRE
        F(1,-1,1) = F(1,-1,1)+K(4)*PRE
        F(1,1,-1) = F(1,1,-1)+K(4)*PRE
        F(1,1,1) = F(1,1,1)+K(4)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(1)*PRE)/(S12*S34)

C       G(T9,N570,FULL)+G(T9,N571,FULL)
        CALL xC01234_(S12,ph2,S34,XMQP2(I),XMQP2(I),XMQP2(I),C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,0)
        K(1) = -(4D0*C2(1,2))+C0
        K(2) = S13+S14+S23+S24
        K(3) = S13+S14+S23+S24-2D0*XMQP2(I)
        K(4) = -((2D0*C2(2,2))/S12)-(2D0*C2(1,1))/S34+1/(S12*S34)+
     &  (2D0*C2(1,2)*(S13+S14+S23+S24))/(S12*S34)-(C0*(S13+S14+S23+
     &  S24-2D0*XMQP2(I)))/(S12*S34)

        PRE = -((4d0/3d0*ALPHAS**2*XMQP2(I))/(4D0*ALPHA*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)+K(4)*PRE
        F(1,-1,1) = F(1,-1,1)+K(4)*PRE
        F(1,1,-1) = F(1,1,-1)+K(4)*PRE
        F(1,1,1) = F(1,1,1)+K(4)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,-1,1) = F(5,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,-1) = F(5,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(5,1,1) = F(5,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,-1,1) = F(6,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,-1) = F(6,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(6,1,1) = F(6,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,-1,1) = F(7,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,-1) = F(7,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(7,1,1) = F(7,1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,-1,1) = F(8,-1,1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,-1) = F(8,1,-1)+(2D0*K(1)*PRE)/(S12*S34)
        F(8,1,1) = F(8,1,1)+(2D0*K(1)*PRE)/(S12*S34)

100	continue

	end
