***********************************************************************
*     file crosssection.F                                             *
*     adapted from COFFERGG by Markus Roth                            *
*---------------------------------------------------------------------*
*     30.01.06  Ansgar Denner     last changed  31.03.10              *
***********************************************************************

* extra Mat2born
#define EXTRABORN


***********************************************************************
      subroutine crosssection(k,x1,x2,generator,phasespace,em,sp,
     &    switch)
***********************************************************************
*     calculation of cross sections                                   *
*     adapted from COFFERGG by Markus Roth                            *
*     only valid for unpolarized case!!!                              *
*     subtraction terms for 4 flavors!!!!!!                           *
*     Born for 4 or 5 flavors                                         *
*---------------------------------------------------------------------*
*     22.03.06  Ansgar Denner     last changed  07.04.10              *
***********************************************************************
      implicit none

#include "mcparams.h"
#include "mccommon.h"

#ifdef multpdf
#include "multpdf.h"
      integer nset
#endif
c local variables
      integer em,sp
      real*8 k(maxe,0:3),q(0:3),q1(0:3)
      real*8 km(6,0:3),kmcms(6,0:3)
      real*8 kons(6,0:3),konscms(6,0:3)
      real*8 x1,x2
      real*8 sh,bwfac
      logical belthr
      integer i1,i2,generator,phasespace,switch,lnext
      integer i3,i4,i6,j1,j2,j3
      integer nvirtinit
      data nvirtinit /0/
      save nvirtinit

c for testting
      character*5 part(-5:5)
      real*8 sij(maxe,maxe)

      real*8 m2i(-5:5,-5:5),m2i0(-5:5,-5:5)
      real*8 m2if(-5:5,-5:5,-5:5,-5:5),m2if0(-5:5,-5:5,-5:5,-5:5)
      real*8 m2if0_22(-5:5,-5:5,-5:5,-5:5)
      real*8 m2if0_33(-5:5,-5:5,-5:5,-5:5)
      real*8 m2if0_44(-5:5,-5:5,-5:5,-5:5)
      real*8 m2if0_nd(-5:5,-5:5,-5:5,-5:5)
      real*8 m2i_phot(-5:5,-5:5),m2if_phot(-5:5,-5:5,-5:5,-5:5)
      real*8 m2i_iphot(-5:5)
      real*8 pdf1l(-6:6),pdf2l(-6:6)
      real*8 qparton(-4:4)
      data   qparton /-0.66666666666666666666d0,
     &     0.33333333333333333333d0,
     &    -0.66666666666666666666d0,0.33333333333333333333d0,0d0,
     &    -0.33333333333333333333d0,0.66666666666666666666d0,
     &    -0.33333333333333333333d0,0.66666666666666666666d0/
      data m2i0/121*0/

c      real*8 test(0:4,0:4),test2(2)
      real*8 constff,constfi,constif,constii
      common/constsub/constff,constfi,constif,constii

      integer qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
      common/rcoptions/qborn,qw,qz,qschan,qtchan,qch2,qchint,
     &                   qbini,qbfin,qwidth,qfact,qbos,qferm,qsoft,qhh2,
     &                   qqcddiag,qqcdnondiag,qqcdgsplit,qqcdggfus,qcp
      complex*16 dalpz,drbos,drferm
      integer qalp
      common/rscheme/dalpz,drbos,drferm,qalp


 1031 format(1x,'crosssection: ',a5,a5,a22,':  = ',g18.10)
 1032 format(1x,'crosssection: ',a17,a16,' = ',2g18.10)

c squared matrix elements from std
c    momenta km(6,0:3), km(1),km(2) incoming, km(3),..,km(6) outgoing
c    Higgs km(5)
c    bremsstrahlung photon km(6)
c    Born matrix elements m2i0(-5:5,-5:5), m2if0(-5:5,-5:5,-5:5,-5:5)
c    Full matrix elements m2i(-5:5,-5:5), m2if(-5:5,-5:5,-5:5,-5:5)
c    m2i, m2i0: summed over final states, including symmetry factor 1/2
c    m2if, m2if0 is populated according to following convention:
c    initial state     populated final states        symmetry factor
c      q1    q2         q3 q4       and q4 q3              1/2
c      q1bar q2bar      q3bar q4bar and q4bar q3bar        1/2
c      q1bar q2         only  q3bar q4                      1
c      q1    q2bar      only  q3    q4bar                   1

c     m2if0_22 contribution of Born matrix element squared where
c              fermion lines connect external fermions 1 and  2
c     m2if0_33 contribution of Born matrix element squared where
c              fermion lines connect external fermions 1 and  3
c     m2if0_44 contribution of Born matrix element squared where
c              fermion lines connect external fermions 1 and  4
c     m2if0_nd contribution of interferences of Born matrix elements

c    real photon matrix elements (outgoing photon):
c                  m2i_phot(-5:5,-5:5), m2if_phot(-5:5,-5:5,-5:5,-5:5)

c        write(*,*) 'crosssection: k1  ',(km(1,i1),i1=0,3)
c        write(*,*) 'crosssection: k2  ',(km(2,i1),i1=0,3)
c        write(*,*) 'crosssection: k3  ',(km(3,i1),i1=0,3)
c        write(*,*) 'crosssection: k4  ',(km(4,i1),i1=0,3)
c        write(*,*) 'crosssection: k5  ',(km(5,i1),i1=0,3)
c        write(*,*) 'crosssection: k  ',km



      if(switch.gt.0)return

      if(generator.eq.0.or.phasespace.gt.1)then
        lnext=5
      else
        lnext=6
      endif

c combine momenta of Higgs decay particles to Higgs momentum
      do ext=1,lnext
      do vcomp=0,3
        km(ext,vcomp)=k(ext,vcomp)
      enddo
      enddo

      if(shtr.ge.1) then
        if(lnext.eq.5)then
          do vcomp=0,3
            km(5,vcomp)=k(5,vcomp)+k(6,vcomp)
          enddo
        else
          do vcomp=0,3
            km(5,vcomp)=k(5,vcomp)+k(6,vcomp)
            km(6,vcomp)=k(7,vcomp)
          enddo
        endif
      endif

c Breit-Wigner for off-shell Higgs boson

      sh = km(5,0)*km(5,0)-km(5,1)*km(5,1)
     &    -km(5,2)*km(5,2)-km(5,3)*km(5,3)
      if(shtr.eq.0)then
        bwfac=1d0
      else
        bwfac = 16d0*pi*hbr*mcm(25)*mcw(25)/
     &      ((sh-mcm(25)*mcm(25))**2+(mcm(25)*mcw(25))**2)
      endif


















c      call getqcdfacscale(mcm(25))
c#ifdef multpdf
c      call wpdf(x1,qcdfacscale,pdf1,mpdf1,pdf_phot1,spdf)
c      call wpdf(x2,qcdfacscale,pdf2,mpdf2,pdf_phot2,spdf)
c#else
c      call wpdf(x1,qcdfacscale,pdf1,pdf_phot1,spdf)
c      call wpdf(x2,qcdfacscale,pdf2,pdf_phot2,spdf)
c#endif

c     kmcms(2,0)=kmcms(1,0)
c     kmcms(2,1)=-kmcms(1,1)
c     kmcms(2,2)=-kmcms(1,2)
c     kmcms(2,3)=-kmcms(1,3)


c       write(*,*) 'crosssection: kmcms ',kmcms

c incoming momenta
      do vcomp=0,3
        q(vcomp)=km(1,vcomp)+km(2,vcomp)
      enddo

c     boost momenta to cms
      do ext=1,lnext
        do vcomp=0,3
          q1(vcomp)=km(ext,vcomp)
        enddo
        call boost(0d0,q,q1,1d0,switch)
        do vcomp=0,3
          kmcms(ext,vcomp)=q1(vcomp)
        enddo
      enddo


      if(generator.eq.0)then



c lowest-order cross section

        if(phasespace.eq.1)then
          call onsproj(km,kons,belthr,lnext,switch)

          if(.not.belthr)then
c incoming ons momenta
            do vcomp=0,3
              q(vcomp)=kons(1,vcomp)+kons(2,vcomp)
            enddo

c     boost ons momenta to cms
            do ext=1,lnext
              do vcomp=0,3
                q1(vcomp)=kons(ext,vcomp)
              enddo
              call boost(0d0,q,q1,1d0,switch)
              do vcomp=0,3
                konscms(ext,vcomp)=q1(vcomp)
              enddo
            enddo
          endif

          if((lgencon(0,3).or.lgencon(0,4)).and.
     &       ((lgencon(0,2).or.lgencon(0,5))
     &        .and.sendp(generator).eq.1))then

            call Mat2born(kmcms,m2i0,m2if0,
     &          m2if0_22,m2if0_33,m2if0_44,m2if0_nd,max(sbini,sbfin))

            if(.not.lonsborn) then
            m2pdfpdf_0(phasespace)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdf_0(aref)=0d0
      enddo
#endif

            do i1=-5,5
            do i2=-5,5
            if (i1*i2.ne.0) then
#ifdef multpdf
              m2pdfpdfii_0(phasespace,i1,i2)=
     &            m2i0(i1,i2)
c average over colours and spins
     &            /36d0
     &            *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfii_0(aref,i1,i2)=
     &        m2pdfpdfii_0(phasespace,i1,i2)
     &        *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
              m2pdfpdfii_0(phasespace,i1,i2)=
     &        m2pdfpdfii_0(phasespace,i1,i2)
     &         *pdf1(i1)*pdf2(i2)
#else
              m2pdfpdfii_0(phasespace,i1,i2)=
     &            m2i0(i1,i2)*pdf1(i1)*pdf2(i2)
c average over colours and spins
     &            /36d0
     &            *bwfac
#endif

c sum over initial state partons
              m2pdfpdf_0(phasespace)=m2pdfpdf_0(phasespace)
     &            + m2pdfpdfii_0(phasespace,i1,i2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdf_0(aref)=mm2pdfpdf_0(aref)
     &            + mm2pdfpdfii_0(aref,i1,i2)
      enddo
#endif

            endif
            enddo
            enddo
            endif

            m2pdfpdfqq_0(phasespace,1,2)=0d0
            m2pdfpdfqq_0(phasespace,1,3)=0d0
            m2pdfpdfqq_0(phasespace,1,4)=0d0
            m2pdfpdfqq_0(phasespace,2,3)=0d0
            m2pdfpdfqq_0(phasespace,2,4)=0d0
            m2pdfpdfqq_0(phasespace,3,4)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdfqq_0(aref,1,2)=0d0
            mm2pdfpdfqq_0(aref,1,3)=0d0
            mm2pdfpdfqq_0(aref,1,4)=0d0
            mm2pdfpdfqq_0(aref,2,3)=0d0
            mm2pdfpdfqq_0(aref,2,4)=0d0
            mm2pdfpdfqq_0(aref,3,4)=0d0
      enddo
#endif

            m2pdfpdftt_0(phasespace,1,2)=0d0
            m2pdfpdftt_0(phasespace,1,3)=0d0
            m2pdfpdftt_0(phasespace,1,4)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdftt_0(aref,1,2)=0d0
            mm2pdfpdftt_0(aref,1,3)=0d0
            mm2pdfpdftt_0(aref,1,4)=0d0
      enddo
#endif

            do i1=-4,4
            do i2=-4,4
            if (i1*i2.ne.0) then

              if(lgencon(0,3))then
                m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)=0d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)=0d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)=0d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,2,3)=0d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)=0d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                mm2pdfpdfiiqq_0(aref,i1,i2,1,2)=0d0
                mm2pdfpdfiiqq_0(aref,i1,i2,1,3)=0d0
                mm2pdfpdfiiqq_0(aref,i1,i2,1,4)=0d0
                mm2pdfpdfiiqq_0(aref,i1,i2,2,3)=0d0
                mm2pdfpdfiiqq_0(aref,i1,i2,2,4)=0d0
                mm2pdfpdfiiqq_0(aref,i1,i2,3,4)=0d0
      enddo
#endif
              endif

              if(lgencon(0,4))then
                m2pdfpdfiitt_0(phasespace,i1,i2,1,2)=0d0
                m2pdfpdfiitt_0(phasespace,i1,i2,1,3)=0d0
                m2pdfpdfiitt_0(phasespace,i1,i2,1,4)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                mm2pdfpdfiitt_0(aref,i1,i2,1,2)=0d0
                mm2pdfpdfiitt_0(aref,i1,i2,1,3)=0d0
                mm2pdfpdfiitt_0(aref,i1,i2,1,4)=0d0
      enddo
#endif
              endif

              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then

                  if(lgencon(0,2).and..not.lonsew)then
#ifdef multpdf
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i2)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i3)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i4)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i2)*qparton(i3)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i2)*qparton(i4)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i3)*qparton(i4)/36d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,2)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,3)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,4)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,3)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,4)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,4)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)
     &               *pdf1(i1)*pdf2(i2)
#else
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i2)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i3)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i4)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i2)*qparton(i3)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i2)*qparton(i4)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i3)*qparton(i4)/36d0
     &                  *bwfac
#endif

                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,1)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,1)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,4,1)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,2)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,4,2)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,4,3)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,1)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,1)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,3)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,4,1)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,4)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,2)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,3)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,4,2)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,4)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,4,3)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,4)
      enddo
#endif
                  endif

                  if(lgencon(0,5).and..not.lonsqcd)then
#ifdef multpdf
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)=
     &                (sqcddiag*m2if0_22(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i2)/27d0
     &                  *bwfac
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)=
     &                (sqcddiag*m2if0_33(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i3)/27d0
     &                  *bwfac
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)=
     &                (sqcddiag*m2if0_44(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i4)/27d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,2)=
CAM     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,3)=
CAM     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,4)=
CAM     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)=
     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)=
     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)=
     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)
     &               *pdf1(i1)*pdf2(i2)
#else
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)=
     &                (sqcddiag*m2if0_22(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i2)/27d0
     &                  *bwfac
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)=
     &                (sqcddiag*m2if0_33(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i3)/27d0
     &                  *bwfac
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)=
     &                (sqcddiag*m2if0_44(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i4)/27d0
     &                  *bwfac
#endif

                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,4)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,4)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,3)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,1)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,1)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,4,1)=
     &                m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,2)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,3)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,4,2)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,4)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,4,3)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,4)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,2)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,4)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,3)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,3)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,4)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,1)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,2)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,1)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,3)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,4,1)=
CAM     &                mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,4)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,2)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,3)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,4,2)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,4)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,4,3)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,4)
      enddo
#endif
                  endif

c     sum over final state partons
                  if(lgencon(0,3))then
#ifdef multpdf
                    keep(  1)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i2)
     &                  *bwfac
                    keep(  2)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i3)
     &                  *bwfac
                    keep(  3)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i4)
     &                  *bwfac
                    keep(  4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i2)*qparton(i3)
     &                  *bwfac
                    keep(  5)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i2)*qparton(i4)
     &                  *bwfac
                    keep(  6)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i3)*qparton(i4)
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                    mm2pdfpdfiiqq_0(aref,i1,i2,1,2)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,2)+keep(  1)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiiqq_0(aref,i1,i2,1,3)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,3)+keep(  2)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiiqq_0(aref,i1,i2,1,4)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,4)+keep(  3)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiiqq_0(aref,i1,i2,2,3) =
     &              mm2pdfpdfiiqq_0(aref,i1,i2,2,3) +keep(  4)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiiqq_0(aref,i1,i2,2,4)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,2,4)+keep(  5)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiiqq_0(aref,i1,i2,3,4)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,3,4)+keep(  6)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                    m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)+
     &               keep(  1)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)+
     &               keep(  2)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)+
     &               keep(  3)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,2,3) =
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,2,3) +
     &               keep(  4)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)+
     &               keep(  5)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)+
     &               keep(  6)*pdf1(i1)*pdf2(i2)
#else
                    m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,1,2) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i2)
     &                  *bwfac
                    m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,1,3) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i3)
     &                  *bwfac
                    m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,1,4) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i4)
     &                  *bwfac
                    m2pdfpdfiiqq_0(phasespace,i1,i2,2,3) =
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,2,3) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i2)*qparton(i3)
     &                  *bwfac
                    m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,2,4) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i2)*qparton(i4)
     &                  *bwfac
                    m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,3,4) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i3)*qparton(i4)
     &                  *bwfac
#endif
                  endif
                  if(lgencon(0,4))then
#ifdef multpdf
                    keep(  1)=
     &                  (sqcddiag*m2if0_22(i1,i2,i3,i4)
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i2)
     &                  *bwfac
                    keep(  2)=
     &                  (sqcddiag*m2if0_33(i1,i2,i3,i4)
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i3)
     &                  *bwfac
                    keep(  3)=
     &                  (sqcddiag*m2if0_44(i1,i2,i3,i4)
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i4)
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                    mm2pdfpdfiitt_0(aref,i1,i2,1,2)=
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,2)+keep(  1)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiitt_0(aref,i1,i2,1,3)=
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,3)+keep(  2)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiitt_0(aref,i1,i2,1,4)=
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,4)+keep(  3)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                    m2pdfpdfiitt_0(phasespace,i1,i2,1,2)=
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,2)+
     &               keep(  1)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiitt_0(phasespace,i1,i2,1,3)=
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,3)+
     &               keep(  2)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiitt_0(phasespace,i1,i2,1,4)=
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,4)+
     &               keep(  3)*pdf1(i1)*pdf2(i2)
#else
                    m2pdfpdfiitt_0(phasespace,i1,i2,1,2)=
     &                  m2pdfpdfiitt_0(phasespace,i1,i2,1,2) +
     &                  (sqcddiag*m2if0_22(i1,i2,i3,i4)
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i2)
     &                  *bwfac
                    m2pdfpdfiitt_0(phasespace,i1,i2,1,3)=
     &                  m2pdfpdfiitt_0(phasespace,i1,i2,1,3) +
     &                  (sqcddiag*m2if0_33(i1,i2,i3,i4)
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i3)
     &                  *bwfac
                    m2pdfpdfiitt_0(phasespace,i1,i2,1,4)=
     &                  m2pdfpdfiitt_0(phasespace,i1,i2,1,4) +
     &                  (sqcddiag*m2if0_44(i1,i2,i3,i4)
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i4)
     &                  *bwfac
#endif
                  endif
                endif
              enddo
              enddo

              if(lgencon(0,3))then
c average over colours and spins
                m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)/36d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)/36d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)/36d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,2,3)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,2,3)/36d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)/36d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)/36d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                mm2pdfpdfiiqq_0(aref,i1,i2,1,2)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,2)/36d0
                mm2pdfpdfiiqq_0(aref,i1,i2,1,3)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,3)/36d0
                mm2pdfpdfiiqq_0(aref,i1,i2,1,4)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,4)/36d0
                mm2pdfpdfiiqq_0(aref,i1,i2,2,3)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,2,3)/36d0
                mm2pdfpdfiiqq_0(aref,i1,i2,2,4)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,2,4)/36d0
                mm2pdfpdfiiqq_0(aref,i1,i2,3,4)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,3,4)/36d0
      enddo
#endif

c sum over initial state partons
                m2pdfpdfqq_0(phasespace,1,2)=
     &              m2pdfpdfqq_0(phasespace,1,2) +
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)
                m2pdfpdfqq_0(phasespace,1,3)=
     &              m2pdfpdfqq_0(phasespace,1,3) +
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)
                m2pdfpdfqq_0(phasespace,1,4)=
     &              m2pdfpdfqq_0(phasespace,1,4) +
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)
                m2pdfpdfqq_0(phasespace,2,3) =
     &              m2pdfpdfqq_0(phasespace,2,3) +
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,2,3)
                m2pdfpdfqq_0(phasespace,2,4)=
     &              m2pdfpdfqq_0(phasespace,2,4) +
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)
                m2pdfpdfqq_0(phasespace,3,4)=
     &              m2pdfpdfqq_0(phasespace,3,4) +
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                mm2pdfpdfqq_0(aref,1,2)=
     &              mm2pdfpdfqq_0(aref,1,2) +
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,2)
                mm2pdfpdfqq_0(aref,1,3)=
     &              mm2pdfpdfqq_0(aref,1,3) +
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,3)
                mm2pdfpdfqq_0(aref,1,4)=
     &              mm2pdfpdfqq_0(aref,1,4) +
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,4)
                mm2pdfpdfqq_0(aref,2,3) =
     &              mm2pdfpdfqq_0(aref,2,3) +
     &              mm2pdfpdfiiqq_0(aref,i1,i2,2,3)
                mm2pdfpdfqq_0(aref,2,4)=
     &              mm2pdfpdfqq_0(aref,2,4) +
     &              mm2pdfpdfiiqq_0(aref,i1,i2,2,4)
                mm2pdfpdfqq_0(aref,3,4)=
     &              mm2pdfpdfqq_0(aref,3,4) +
     &              mm2pdfpdfiiqq_0(aref,i1,i2,3,4)
      enddo
#endif
              endif

              if(lgencon(0,4))then
c average over colours and spins including CF:  4/3 /36
                m2pdfpdfiitt_0(phasespace,i1,i2,1,2)=
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,2)/27d0
                m2pdfpdfiitt_0(phasespace,i1,i2,1,3)=
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,3)/27d0
                m2pdfpdfiitt_0(phasespace,i1,i2,1,4)=
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,4)/27d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                mm2pdfpdfiitt_0(aref,i1,i2,1,2)=
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,2)/27d0
                mm2pdfpdfiitt_0(aref,i1,i2,1,3)=
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,3)/27d0
                mm2pdfpdfiitt_0(aref,i1,i2,1,4)=
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,4)/27d0
      enddo
#endif

c     sum over initial state partons
                m2pdfpdftt_0(phasespace,1,2)=
     &              m2pdfpdftt_0(phasespace,1,2) +
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,2)
                m2pdfpdftt_0(phasespace,1,3)=
     &              m2pdfpdftt_0(phasespace,1,3) +
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,3)
                m2pdfpdftt_0(phasespace,1,4)=
     &              m2pdfpdftt_0(phasespace,1,4) +
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                mm2pdfpdftt_0(aref,1,2)=
     &              mm2pdfpdftt_0(aref,1,2) +
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,2)
                mm2pdfpdftt_0(aref,1,3)=
     &              mm2pdfpdftt_0(aref,1,3) +
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,3)
                mm2pdfpdftt_0(aref,1,4)=
     &              mm2pdfpdftt_0(aref,1,4) +
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,4)
      enddo
#endif
              endif
            endif
            enddo
            enddo

            if((lonsborn.or.lonsqcd.or.lonsew).and..not.belthr)then
              call Mat2born(konscms,m2i0,m2if0,
     &            m2if0_22,m2if0_33,m2if0_44,m2if0_nd,max(sbini,sbfin))
            endif

            if(lonsborn)then
              m2pdfpdf_0(phasespace)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdf_0(aref)=0d0
      enddo
#endif

              do i1=-5,5
              do i2=-5,5
              if (i1*i2.ne.0) then
                if(belthr)then
                  m2pdfpdfii_0(phasespace,i1,i2)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfii_0(aref,i1,i2)=0d0
      enddo
#endif
                else
#ifdef multpdf
                  m2pdfpdfii_0(phasespace,i1,i2)=
     &              m2i0(i1,i2)
c average over colours and spins
     &                /36d0
     &                *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfii_0(aref,i1,i2)=
     &            m2pdfpdfii_0(phasespace,i1,i2)
     &            *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfii_0(phasespace,i1,i2)=
     &            m2pdfpdfii_0(phasespace,i1,i2)
     &             *pdf1(i1)*pdf2(i2)
#else
                  m2pdfpdfii_0(phasespace,i1,i2)=
     &              m2i0(i1,i2)*pdf1(i1)*pdf2(i2)
c average over colours and spins
     &                /36d0
     &                *bwfac
#endif

c sum over initial state partons
                  m2pdfpdf_0(phasespace)=m2pdfpdf_0(phasespace)
     &                + m2pdfpdfii_0(phasespace,i1,i2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdf_0(aref)=mm2pdfpdf_0(aref)
     &                + mm2pdfpdfii_0(aref,i1,i2)
      enddo
#endif
                endif
              endif
              enddo
              enddo
            endif

            do i1=-4,4
            do i2=-4,4
            if (i1*i2.ne.0) then
              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then

                  if(lgencon(0,2).and.lonsew)then
                    if(belthr)then
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,2)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,3)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,4)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,3)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,4)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,4)=0d0
      enddo
#endif

                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,1)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,1)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,4,1)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,2)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,4,2)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,4,3)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,1)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,1)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,4,1)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,2)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,4,2)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,4,3)=0d0
      enddo
#endif
                    else
#ifdef multpdf
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i2)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i3)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i4)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)=
     &                   m2if0(i1,i2,i3,i4)
     &                  *qparton(i2)*qparton(i3)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i2)*qparton(i4)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i3)*qparton(i4)/36d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,2)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,3)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,4)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,3)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,4)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,4)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)
     &               *pdf1(i1)*pdf2(i2)
#else
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i2)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i3)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i4)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)=
     &                   m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i2)*qparton(i3)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i2)*qparton(i4)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i3)*qparton(i4)/36d0
     &                  *bwfac
#endif

                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,1)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,1)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,4,1)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,2)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,4,2)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,4,3)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,1)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,1)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,3)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,4,1)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,4)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,2)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,3)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,4,2)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,4)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,4,3)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,4)
      enddo
#endif
                    endif
                  endif
                  if(lgencon(0,5).and.lonsqcd)then
                    if(belthr)then
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,2)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,3)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,4)=0d0
      enddo
#endif

                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,4)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,4)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,3)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,1)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,1)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,4,1)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,2)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,4,2)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,4,3)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,4)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,4)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,3)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,1)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,1)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,4,1)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,2)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,4,2)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,4,3)=0d0
      enddo
#endif
                    else
#ifdef multpdf
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)=
     &                (sqcddiag*m2if0_22(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i2)/27d0
     &                  *bwfac
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)=
     &                (sqcddiag*m2if0_33(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i3)/27d0
     &                  *bwfac
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)=
     &                (sqcddiag*m2if0_44(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i4)/27d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,2)=
CAM     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,3)=
CAM     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,4)=
CAM     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)=
     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)=
     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)=
     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)
     &               *pdf1(i1)*pdf2(i2)
#else
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)=
     &                (sqcddiag*m2if0_22(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i2)/27d0
     &                  *bwfac
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)=
     &                (sqcddiag*m2if0_33(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i3)/27d0
     &                  *bwfac
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)=
     &                (sqcddiag*m2if0_44(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i4)/27d0
     &                  *bwfac
#endif

                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,4)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,4)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,3)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,1)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,1)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,4,1)=
     &                m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,2)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,3)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,4,2)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,4)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,4,3)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,4)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,2)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,4)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,3)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,3)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,4)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,1)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,2)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,1)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,3)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,4,1)=
CAM     &                mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,4)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,2)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,3)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,4,2)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,4)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,4,3)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,4)
      enddo
#endif
                  endif
                  endif
                endif
                enddo
                enddo
              endif
              enddo
              enddo

c average over colours and spins
c          write(*,*) 'crosssection',m2b,m2bb,
c     &        m2pdfpdf_0(phasespace)

c symmetric contributions
            if(lgencon(0,3))then
              m2pdfpdfqq_0(phasespace,2,1)=m2pdfpdfqq_0(phasespace,1,2)
              m2pdfpdfqq_0(phasespace,3,1)=m2pdfpdfqq_0(phasespace,1,3)
              m2pdfpdfqq_0(phasespace,4,1)=m2pdfpdfqq_0(phasespace,1,4)
              m2pdfpdfqq_0(phasespace,3,2)=m2pdfpdfqq_0(phasespace,2,3)
              m2pdfpdfqq_0(phasespace,4,2)=m2pdfpdfqq_0(phasespace,2,4)
              m2pdfpdfqq_0(phasespace,4,3)=m2pdfpdfqq_0(phasespace,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfqq_0(aref,2,1)=mm2pdfpdfqq_0(aref,1,2)
              mm2pdfpdfqq_0(aref,3,1)=mm2pdfpdfqq_0(aref,1,3)
              mm2pdfpdfqq_0(aref,4,1)=mm2pdfpdfqq_0(aref,1,4)
              mm2pdfpdfqq_0(aref,3,2)=mm2pdfpdfqq_0(aref,2,3)
              mm2pdfpdfqq_0(aref,4,2)=mm2pdfpdfqq_0(aref,2,4)
              mm2pdfpdfqq_0(aref,4,3)=mm2pdfpdfqq_0(aref,3,4)
      enddo
#endif
              do i1=-4,4
                do i2=-4,4
                  if(i1*i2.ne.0)then
                    m2pdfpdfiiqq_0(phasespace,i1,i2,2,1)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,3,1)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,4,1)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,3,2)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,2,3)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,4,2)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,4,3)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                    mm2pdfpdfiiqq_0(aref,i1,i2,2,1)=
     &                  mm2pdfpdfiiqq_0(aref,i1,i2,1,2)
                    mm2pdfpdfiiqq_0(aref,i1,i2,3,1)=
     &                  mm2pdfpdfiiqq_0(aref,i1,i2,1,3)
                    mm2pdfpdfiiqq_0(aref,i1,i2,4,1)=
     &                  mm2pdfpdfiiqq_0(aref,i1,i2,1,4)
                    mm2pdfpdfiiqq_0(aref,i1,i2,3,2)=
     &                  mm2pdfpdfiiqq_0(aref,i1,i2,2,3)
                    mm2pdfpdfiiqq_0(aref,i1,i2,4,2)=
     &                  mm2pdfpdfiiqq_0(aref,i1,i2,2,4)
                    mm2pdfpdfiiqq_0(aref,i1,i2,4,3)=
     &                  mm2pdfpdfiiqq_0(aref,i1,i2,3,4)
      enddo
#endif
                  endif
                enddo
              enddo
            endif

            if(lgencon(0,4))then
              m2pdfpdftt_0(phasespace,3,4)=m2pdfpdftt_0(phasespace,1,2)
              m2pdfpdftt_0(phasespace,2,4)=m2pdfpdftt_0(phasespace,1,3)
              m2pdfpdftt_0(phasespace,2,3)=m2pdfpdftt_0(phasespace,1,4)
              m2pdfpdftt_0(phasespace,2,1)=m2pdfpdftt_0(phasespace,1,2)
              m2pdfpdftt_0(phasespace,3,1)=m2pdfpdftt_0(phasespace,1,3)
              m2pdfpdftt_0(phasespace,4,1)=m2pdfpdftt_0(phasespace,1,4)
              m2pdfpdftt_0(phasespace,3,2)=m2pdfpdftt_0(phasespace,2,3)
              m2pdfpdftt_0(phasespace,4,2)=m2pdfpdftt_0(phasespace,2,4)
              m2pdfpdftt_0(phasespace,4,3)=m2pdfpdftt_0(phasespace,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdftt_0(aref,3,4)=mm2pdfpdftt_0(aref,1,2)
              mm2pdfpdftt_0(aref,2,4)=mm2pdfpdftt_0(aref,1,3)
              mm2pdfpdftt_0(aref,2,3)=mm2pdfpdftt_0(aref,1,4)
              mm2pdfpdftt_0(aref,2,1)=mm2pdfpdftt_0(aref,1,2)
              mm2pdfpdftt_0(aref,3,1)=mm2pdfpdftt_0(aref,1,3)
              mm2pdfpdftt_0(aref,4,1)=mm2pdfpdftt_0(aref,1,4)
              mm2pdfpdftt_0(aref,3,2)=mm2pdfpdftt_0(aref,2,3)
              mm2pdfpdftt_0(aref,4,2)=mm2pdfpdftt_0(aref,2,4)
              mm2pdfpdftt_0(aref,4,3)=mm2pdfpdftt_0(aref,3,4)
      enddo
#endif
              do i1=-4,4
                do i2=-4,4
                  if(i1*i2.ne.0)then
                    m2pdfpdfiitt_0(phasespace,i1,i2,3,4)=
     &                  m2pdfpdfiitt_0(phasespace,i1,i2,1,2)
                    m2pdfpdfiitt_0(phasespace,i1,i2,2,4)=
     &                  m2pdfpdfiitt_0(phasespace,i1,i2,1,3)
                    m2pdfpdfiitt_0(phasespace,i1,i2,2,3)=
     &                  m2pdfpdfiitt_0(phasespace,i1,i2,1,4)
                    m2pdfpdfiitt_0(phasespace,i1,i2,2,1)=
     &                  m2pdfpdfiitt_0(phasespace,i1,i2,1,2)
                    m2pdfpdfiitt_0(phasespace,i1,i2,3,1)=
     &                  m2pdfpdfiitt_0(phasespace,i1,i2,1,3)
                    m2pdfpdfiitt_0(phasespace,i1,i2,4,1)=
     &                  m2pdfpdfiitt_0(phasespace,i1,i2,1,4)
                    m2pdfpdfiitt_0(phasespace,i1,i2,3,2)=
     &                  m2pdfpdfiitt_0(phasespace,i1,i2,2,3)
                    m2pdfpdfiitt_0(phasespace,i1,i2,4,2)=
     &                  m2pdfpdfiitt_0(phasespace,i1,i2,2,4)
                    m2pdfpdfiitt_0(phasespace,i1,i2,4,3)=
     &                  m2pdfpdfiitt_0(phasespace,i1,i2,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                    mm2pdfpdfiitt_0(aref,i1,i2,3,4)=
     &                  mm2pdfpdfiitt_0(aref,i1,i2,1,2)
                    mm2pdfpdfiitt_0(aref,i1,i2,2,4)=
     &                  mm2pdfpdfiitt_0(aref,i1,i2,1,3)
                    mm2pdfpdfiitt_0(aref,i1,i2,2,3)=
     &                  mm2pdfpdfiitt_0(aref,i1,i2,1,4)
                    mm2pdfpdfiitt_0(aref,i1,i2,2,1)=
     &                  mm2pdfpdfiitt_0(aref,i1,i2,1,2)
                    mm2pdfpdfiitt_0(aref,i1,i2,3,1)=
     &                  mm2pdfpdfiitt_0(aref,i1,i2,1,3)
                    mm2pdfpdfiitt_0(aref,i1,i2,4,1)=
     &                  mm2pdfpdfiitt_0(aref,i1,i2,1,4)
                    mm2pdfpdfiitt_0(aref,i1,i2,3,2)=
     &                  mm2pdfpdfiitt_0(aref,i1,i2,2,3)
                    mm2pdfpdfiitt_0(aref,i1,i2,4,2)=
     &                  mm2pdfpdfiitt_0(aref,i1,i2,2,4)
                    mm2pdfpdfiitt_0(aref,i1,i2,4,3)=
     &                  mm2pdfpdfiitt_0(aref,i1,i2,3,4)
      enddo
#endif
                  endif
                enddo
              enddo
            endif


          elseif(lgencon(0,3).or.lgencon(0,4))then

            call Mat2born(kmcms,m2i0,m2if0,
     &            m2if0_22,m2if0_33,m2if0_44,m2if0_nd,max(sbini,sbfin))

            m2pdfpdfqq_0(phasespace,1,2)=0d0
            m2pdfpdfqq_0(phasespace,1,3)=0d0
            m2pdfpdfqq_0(phasespace,1,4)=0d0
            m2pdfpdfqq_0(phasespace,2,3)=0d0
            m2pdfpdfqq_0(phasespace,2,4)=0d0
            m2pdfpdfqq_0(phasespace,3,4)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdfqq_0(aref,1,2)=0d0
            mm2pdfpdfqq_0(aref,1,3)=0d0
            mm2pdfpdfqq_0(aref,1,4)=0d0
            mm2pdfpdfqq_0(aref,2,3)=0d0
            mm2pdfpdfqq_0(aref,2,4)=0d0
            mm2pdfpdfqq_0(aref,3,4)=0d0
      enddo
#endif

            m2pdfpdftt_0(phasespace,1,2)=0d0
            m2pdfpdftt_0(phasespace,1,3)=0d0
            m2pdfpdftt_0(phasespace,1,4)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdftt_0(aref,1,2)=0d0
            mm2pdfpdftt_0(aref,1,3)=0d0
            mm2pdfpdftt_0(aref,1,4)=0d0
      enddo
#endif

            do i1=-4,4
            do i2=-4,4
            if (i1*i2.ne.0) then
              if(lgencon(0,3))then
                m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)=0d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)=0d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)=0d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,2,3)=0d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)=0d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                mm2pdfpdfiiqq_0(aref,i1,i2,1,2)=0d0
                mm2pdfpdfiiqq_0(aref,i1,i2,1,3)=0d0
                mm2pdfpdfiiqq_0(aref,i1,i2,1,4)=0d0
                mm2pdfpdfiiqq_0(aref,i1,i2,2,3)=0d0
                mm2pdfpdfiiqq_0(aref,i1,i2,2,4)=0d0
                mm2pdfpdfiiqq_0(aref,i1,i2,3,4)=0d0
      enddo
#endif
              endif

              if(lgencon(0,4))then
                m2pdfpdfiitt_0(phasespace,i1,i2,1,2)=0d0
                m2pdfpdfiitt_0(phasespace,i1,i2,1,3)=0d0
                m2pdfpdfiitt_0(phasespace,i1,i2,1,4)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                mm2pdfpdfiitt_0(aref,i1,i2,1,2)=0d0
                mm2pdfpdfiitt_0(aref,i1,i2,1,3)=0d0
                mm2pdfpdfiitt_0(aref,i1,i2,1,4)=0d0
      enddo
#endif
              endif

              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then

c sum over final state partons
                  if(lgencon(0,3))then
#ifdef multpdf
                    keep(  1)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i2)
     &                  *bwfac
                    keep(  2)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i3)
     &                  *bwfac
                    keep(  3)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i4)
     &                  *bwfac
                    keep(  4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i2)*qparton(i3)
     &                  *bwfac
                    keep(  5)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i2)*qparton(i4)
     &                  *bwfac
                    keep(  6)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i3)*qparton(i4)
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                    mm2pdfpdfiiqq_0(aref,i1,i2,1,2)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,2)+keep(  1)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiiqq_0(aref,i1,i2,1,3)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,3)+keep(  2)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiiqq_0(aref,i1,i2,1,4)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,4)+keep(  3)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiiqq_0(aref,i1,i2,2,3) =
     &              mm2pdfpdfiiqq_0(aref,i1,i2,2,3) +keep(  4)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiiqq_0(aref,i1,i2,2,4)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,2,4)+keep(  5)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiiqq_0(aref,i1,i2,3,4)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,3,4)+keep(  6)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                    m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)+
     &               keep(  1)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)+
     &               keep(  2)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)+
     &               keep(  3)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,2,3) =
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,2,3) +
     &               keep(  4)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)+
     &               keep(  5)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)+
     &               keep(  6)*pdf1(i1)*pdf2(i2)
#else
                    m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,1,2) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i2)
     &                  *bwfac
                    m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,1,3) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i3)
     &                  *bwfac
                    m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,1,4) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i4)
     &                  *bwfac
                    m2pdfpdfiiqq_0(phasespace,i1,i2,2,3) =
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,2,3) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i2)*qparton(i3)
     &                  *bwfac
                    m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,2,4) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i2)*qparton(i4)
     &                  *bwfac
                    m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,3,4) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i3)*qparton(i4)
     &                  *bwfac
#endif
                  endif
                  if(lgencon(0,4))then
#ifdef multpdf
                    keep(  1)=
     &                  (sqcddiag*m2if0_22(i1,i2,i3,i4)
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i2)
     &                  *bwfac
                    keep(  2)=
     &                  (sqcddiag*m2if0_33(i1,i2,i3,i4)
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i3)
     &                  *bwfac
                    keep(  3)=
     &                  (sqcddiag*m2if0_44(i1,i2,i3,i4)
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i4)
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                    mm2pdfpdfiitt_0(aref,i1,i2,1,2)=
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,2)+keep(  1)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiitt_0(aref,i1,i2,1,3)=
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,3)+keep(  2)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiitt_0(aref,i1,i2,1,4)=
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,4)+keep(  3)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                    m2pdfpdfiitt_0(phasespace,i1,i2,1,2)=
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,2)+
     &               keep(  1)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiitt_0(phasespace,i1,i2,1,3)=
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,3)+
     &               keep(  2)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiitt_0(phasespace,i1,i2,1,4)=
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,4)+
     &               keep(  3)*pdf1(i1)*pdf2(i2)
#else
                    m2pdfpdfiitt_0(phasespace,i1,i2,1,2)=
     &                  m2pdfpdfiitt_0(phasespace,i1,i2,1,2) +
     &                  (sqcddiag*m2if0_22(i1,i2,i3,i4)
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i2)
     &                  *bwfac
                    m2pdfpdfiitt_0(phasespace,i1,i2,1,3)=
     &                  m2pdfpdfiitt_0(phasespace,i1,i2,1,3) +
     &                  (sqcddiag*m2if0_33(i1,i2,i3,i4)
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i3)
     &                  *bwfac
                    m2pdfpdfiitt_0(phasespace,i1,i2,1,4)=
     &                  m2pdfpdfiitt_0(phasespace,i1,i2,1,4) +
     &                  (sqcddiag*m2if0_44(i1,i2,i3,i4)
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i4)
     &                  *bwfac
#endif
                  endif
                endif
              enddo
              enddo

              if(lgencon(0,3))then
c average over colours and spins
                m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)/36d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)/36d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)/36d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,2,3)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,2,3)/36d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)/36d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)/36d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                mm2pdfpdfiiqq_0(aref,i1,i2,1,2)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,2)/36d0
                mm2pdfpdfiiqq_0(aref,i1,i2,1,3)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,3)/36d0
                mm2pdfpdfiiqq_0(aref,i1,i2,1,4)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,4)/36d0
                mm2pdfpdfiiqq_0(aref,i1,i2,2,3)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,2,3)/36d0
                mm2pdfpdfiiqq_0(aref,i1,i2,2,4)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,2,4)/36d0
                mm2pdfpdfiiqq_0(aref,i1,i2,3,4)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,3,4)/36d0
      enddo
#endif

c sum over initial state partons
                m2pdfpdfqq_0(phasespace,1,2)=
     &              m2pdfpdfqq_0(phasespace,1,2) +
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)
                m2pdfpdfqq_0(phasespace,1,3)=
     &              m2pdfpdfqq_0(phasespace,1,3) +
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)
                m2pdfpdfqq_0(phasespace,1,4)=
     &              m2pdfpdfqq_0(phasespace,1,4) +
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)
                m2pdfpdfqq_0(phasespace,2,3) =
     &              m2pdfpdfqq_0(phasespace,2,3) +
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,2,3)
                m2pdfpdfqq_0(phasespace,2,4)=
     &              m2pdfpdfqq_0(phasespace,2,4) +
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)
                m2pdfpdfqq_0(phasespace,3,4)=
     &              m2pdfpdfqq_0(phasespace,3,4) +
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                mm2pdfpdfqq_0(aref,1,2)=
     &              mm2pdfpdfqq_0(aref,1,2) +
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,2)
                mm2pdfpdfqq_0(aref,1,3)=
     &              mm2pdfpdfqq_0(aref,1,3) +
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,3)
                mm2pdfpdfqq_0(aref,1,4)=
     &              mm2pdfpdfqq_0(aref,1,4) +
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,4)
                mm2pdfpdfqq_0(aref,2,3) =
     &              mm2pdfpdfqq_0(aref,2,3) +
     &              mm2pdfpdfiiqq_0(aref,i1,i2,2,3)
                mm2pdfpdfqq_0(aref,2,4)=
     &              mm2pdfpdfqq_0(aref,2,4) +
     &              mm2pdfpdfiiqq_0(aref,i1,i2,2,4)
                mm2pdfpdfqq_0(aref,3,4)=
     &              mm2pdfpdfqq_0(aref,3,4) +
     &              mm2pdfpdfiiqq_0(aref,i1,i2,3,4)
      enddo
#endif
              endif

              if(lgencon(0,4))then
c average over colours and spins including CF:  4/3 /36
                m2pdfpdfiitt_0(phasespace,i1,i2,1,2)=
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,2)/27d0
                m2pdfpdfiitt_0(phasespace,i1,i2,1,3)=
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,3)/27d0
                m2pdfpdfiitt_0(phasespace,i1,i2,1,4)=
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,4)/27d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                mm2pdfpdfiitt_0(aref,i1,i2,1,2)=
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,2)/27d0
                mm2pdfpdfiitt_0(aref,i1,i2,1,3)=
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,3)/27d0
                mm2pdfpdfiitt_0(aref,i1,i2,1,4)=
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,4)/27d0
      enddo
#endif

c     sum over initial state partons
                m2pdfpdftt_0(phasespace,1,2)=
     &              m2pdfpdftt_0(phasespace,1,2) +
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,2)
                m2pdfpdftt_0(phasespace,1,3)=
     &              m2pdfpdftt_0(phasespace,1,3) +
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,3)
                m2pdfpdftt_0(phasespace,1,4)=
     &              m2pdfpdftt_0(phasespace,1,4) +
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                mm2pdfpdftt_0(aref,1,2)=
     &              mm2pdfpdftt_0(aref,1,2) +
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,2)
                mm2pdfpdftt_0(aref,1,3)=
     &              mm2pdfpdftt_0(aref,1,3) +
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,3)
                mm2pdfpdftt_0(aref,1,4)=
     &              mm2pdfpdftt_0(aref,1,4) +
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,4)
      enddo
#endif
              endif
            endif
            enddo
            enddo

            if(lonsborn.and..not.belthr)then
              call Mat2born0(konscms,m2i0,m2if0,max(sbini,sbfin))
            endif

            m2pdfpdf_0(phasespace)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdf_0(aref)=0d0
      enddo
#endif

            do i1=-5,5
              do i2=-5,5
                if (i1*i2.ne.0) then
                  if(belthr.and.lonsborn)then
                    m2pdfpdfii_0(phasespace,i1,i2)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                    mm2pdfpdfii_0(aref,i1,i2)=0d0
      enddo
#endif
                  else
#ifdef multpdf
                    m2pdfpdfii_0(phasespace,i1,i2)=
     &                  m2i0(i1,i2)
c average over colours and spins
     &                  /36d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                    mm2pdfpdfii_0(aref,i1,i2)=
     &              m2pdfpdfii_0(phasespace,i1,i2)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                    m2pdfpdfii_0(phasespace,i1,i2)=
     &              m2pdfpdfii_0(phasespace,i1,i2)
     &               *pdf1(i1)*pdf2(i2)
#else
                    m2pdfpdfii_0(phasespace,i1,i2)=
     &                  m2i0(i1,i2)*pdf1(i1)*pdf2(i2)
c average over colours and spins
     &                  /36d0
     &                  *bwfac
#endif


c sum over initial state partons
                    m2pdfpdf_0(phasespace)=m2pdfpdf_0(phasespace)
     &                  + m2pdfpdfii_0(phasespace,i1,i2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                    mm2pdfpdf_0(aref)=mm2pdfpdf_0(aref)
     &                  + mm2pdfpdfii_0(aref,i1,i2)
      enddo
#endif
                  endif
                endif
              enddo
            enddo

c symmetric contributions
          if(lgencon(0,3))then
            m2pdfpdfqq_0(phasespace,2,1)=m2pdfpdfqq_0(phasespace,1,2)
            m2pdfpdfqq_0(phasespace,3,1)=m2pdfpdfqq_0(phasespace,1,3)
            m2pdfpdfqq_0(phasespace,4,1)=m2pdfpdfqq_0(phasespace,1,4)
            m2pdfpdfqq_0(phasespace,3,2)=m2pdfpdfqq_0(phasespace,2,3)
            m2pdfpdfqq_0(phasespace,4,2)=m2pdfpdfqq_0(phasespace,2,4)
            m2pdfpdfqq_0(phasespace,4,3)=m2pdfpdfqq_0(phasespace,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdfqq_0(aref,2,1)=mm2pdfpdfqq_0(aref,1,2)
            mm2pdfpdfqq_0(aref,3,1)=mm2pdfpdfqq_0(aref,1,3)
            mm2pdfpdfqq_0(aref,4,1)=mm2pdfpdfqq_0(aref,1,4)
            mm2pdfpdfqq_0(aref,3,2)=mm2pdfpdfqq_0(aref,2,3)
            mm2pdfpdfqq_0(aref,4,2)=mm2pdfpdfqq_0(aref,2,4)
            mm2pdfpdfqq_0(aref,4,3)=mm2pdfpdfqq_0(aref,3,4)
      enddo
#endif
            do i1=-4,4
              do i2=-4,4
                if(i1*i2.ne.0)then
                  m2pdfpdfiiqq_0(phasespace,i1,i2,2,1)=
     &                m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)
                  m2pdfpdfiiqq_0(phasespace,i1,i2,3,1)=
     &                m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)
                  m2pdfpdfiiqq_0(phasespace,i1,i2,4,1)=
     &                m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)
                  m2pdfpdfiiqq_0(phasespace,i1,i2,3,2)=
     &                m2pdfpdfiiqq_0(phasespace,i1,i2,2,3)
                  m2pdfpdfiiqq_0(phasespace,i1,i2,4,2)=
     &                m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)
                  m2pdfpdfiiqq_0(phasespace,i1,i2,4,3) =
     &                m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiiqq_0(aref,i1,i2,2,1)=
     &                mm2pdfpdfiiqq_0(aref,i1,i2,1,2)
                  mm2pdfpdfiiqq_0(aref,i1,i2,3,1)=
     &                mm2pdfpdfiiqq_0(aref,i1,i2,1,3)
                  mm2pdfpdfiiqq_0(aref,i1,i2,4,1)=
     &                mm2pdfpdfiiqq_0(aref,i1,i2,1,4)
                  mm2pdfpdfiiqq_0(aref,i1,i2,3,2)=
     &                mm2pdfpdfiiqq_0(aref,i1,i2,2,3)
                  mm2pdfpdfiiqq_0(aref,i1,i2,4,2)=
     &                mm2pdfpdfiiqq_0(aref,i1,i2,2,4)
                  mm2pdfpdfiiqq_0(aref,i1,i2,4,3) =
     &                mm2pdfpdfiiqq_0(aref,i1,i2,3,4)
      enddo
#endif
                endif
              enddo
            enddo
          endif

          if(lgencon(0,4))then
            m2pdfpdftt_0(phasespace,3,4)=m2pdfpdftt_0(phasespace,1,2)
            m2pdfpdftt_0(phasespace,2,4)=m2pdfpdftt_0(phasespace,1,3)
            m2pdfpdftt_0(phasespace,2,3)=m2pdfpdftt_0(phasespace,1,4)
            m2pdfpdftt_0(phasespace,2,1)=m2pdfpdftt_0(phasespace,1,2)
            m2pdfpdftt_0(phasespace,3,1)=m2pdfpdftt_0(phasespace,1,3)
            m2pdfpdftt_0(phasespace,4,1)=m2pdfpdftt_0(phasespace,1,4)
            m2pdfpdftt_0(phasespace,3,2)=m2pdfpdftt_0(phasespace,2,3)
            m2pdfpdftt_0(phasespace,4,2)=m2pdfpdftt_0(phasespace,2,4)
            m2pdfpdftt_0(phasespace,4,3)=m2pdfpdftt_0(phasespace,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdftt_0(aref,3,4)=mm2pdfpdftt_0(aref,1,2)
            mm2pdfpdftt_0(aref,2,4)=mm2pdfpdftt_0(aref,1,3)
            mm2pdfpdftt_0(aref,2,3)=mm2pdfpdftt_0(aref,1,4)
            mm2pdfpdftt_0(aref,2,1)=mm2pdfpdftt_0(aref,1,2)
            mm2pdfpdftt_0(aref,3,1)=mm2pdfpdftt_0(aref,1,3)
            mm2pdfpdftt_0(aref,4,1)=mm2pdfpdftt_0(aref,1,4)
            mm2pdfpdftt_0(aref,3,2)=mm2pdfpdftt_0(aref,2,3)
            mm2pdfpdftt_0(aref,4,2)=mm2pdfpdftt_0(aref,2,4)
            mm2pdfpdftt_0(aref,4,3)=mm2pdfpdftt_0(aref,3,4)
      enddo
#endif
            do i1=-4,4
              do i2=-4,4
                if(i1*i2.ne.0)then
                  m2pdfpdfiitt_0(phasespace,i1,i2,3,4)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,1,2)
                  m2pdfpdfiitt_0(phasespace,i1,i2,2,4)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,1,3)
                  m2pdfpdfiitt_0(phasespace,i1,i2,2,3)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,1,4)
                  m2pdfpdfiitt_0(phasespace,i1,i2,2,1)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,1,2)
                  m2pdfpdfiitt_0(phasespace,i1,i2,3,1)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,1,3)
                  m2pdfpdfiitt_0(phasespace,i1,i2,4,1)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,1,4)
                  m2pdfpdfiitt_0(phasespace,i1,i2,3,2)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,2,3)
                  m2pdfpdfiitt_0(phasespace,i1,i2,4,2)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,2,4)
                  m2pdfpdfiitt_0(phasespace,i1,i2,4,3)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiitt_0(aref,i1,i2,3,4)=
     &                mm2pdfpdfiitt_0(aref,i1,i2,1,2)
                  mm2pdfpdfiitt_0(aref,i1,i2,2,4)=
     &                mm2pdfpdfiitt_0(aref,i1,i2,1,3)
                  mm2pdfpdfiitt_0(aref,i1,i2,2,3)=
     &                mm2pdfpdfiitt_0(aref,i1,i2,1,4)
                  mm2pdfpdfiitt_0(aref,i1,i2,2,1)=
     &                mm2pdfpdfiitt_0(aref,i1,i2,1,2)
                  mm2pdfpdfiitt_0(aref,i1,i2,3,1)=
     &                mm2pdfpdfiitt_0(aref,i1,i2,1,3)
                  mm2pdfpdfiitt_0(aref,i1,i2,4,1)=
     &                mm2pdfpdfiitt_0(aref,i1,i2,1,4)
                  mm2pdfpdfiitt_0(aref,i1,i2,3,2)=
     &                mm2pdfpdfiitt_0(aref,i1,i2,2,3)
                  mm2pdfpdfiitt_0(aref,i1,i2,4,2)=
     &                mm2pdfpdfiitt_0(aref,i1,i2,2,4)
                  mm2pdfpdfiitt_0(aref,i1,i2,4,3)=
     &                mm2pdfpdfiitt_0(aref,i1,i2,3,4)
      enddo
#endif
                endif
              enddo
            enddo
          endif


          elseif ((lgencon(0,2).or.lgencon(0,5))
     &        .and.sendp(generator).eq.1)then

            call Mat2born(kmcms,m2i0,m2if0,
     &          m2if0_22,m2if0_33,m2if0_44,m2if0_nd,max(sbini,sbfin))

            do i1=-4,4
            do i2=-4,4
              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then
c                  write(*,*) 'crosssection end ',sendp(generator)
                  if(lgencon(0,2).and..not.lonsew)then
#ifdef multpdf
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i2)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i3)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i4)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i2)*qparton(i3)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i2)*qparton(i4)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i3)*qparton(i4)/36d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,2)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,3)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,4)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,3)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,4)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,4)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)
     &               *pdf1(i1)*pdf2(i2)
#else
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i2)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i3)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i4)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i2)*qparton(i3)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i2)*qparton(i4)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i3)*qparton(i4)/36d0
     &                  *bwfac
#endif

                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,1)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,1)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,4,1)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,2)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,4,2)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,4,3)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,1)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,1)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,3)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,4,1)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,4)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,2)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,3)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,4,2)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,4)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,4,3)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,4)
      enddo
#endif
                  endif
                  if(lgencon(0,5).and..not.lonsqcd)then
#ifdef multpdf
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)=
     &                (sqcddiag*m2if0_22(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i2)/27d0
     &                  *bwfac
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)=
     &                (sqcddiag*m2if0_33(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i3)/27d0
     &                  *bwfac
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)=
     &                (sqcddiag*m2if0_44(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i4)/27d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,2)=
CAM     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,3)=
CAM     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,4)=
CAM     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)=
     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)=
     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)=
     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)
     &               *pdf1(i1)*pdf2(i2)
#else
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)=
     &                (sqcddiag*m2if0_22(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i2)/27d0
     &                  *bwfac
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)=
     &                (sqcddiag*m2if0_33(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i3)/27d0
     &                  *bwfac
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)=
     &                (sqcddiag*m2if0_44(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i4)/27d0
     &                  *bwfac
#endif

                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,4)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,4)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,3)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,1)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,1)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,4,1)=
     &                m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,2)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,3)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,4,2)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,4)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,4,3)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,4)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,2)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,4)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,3)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,3)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,4)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,1)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,2)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,1)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,3)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,4,1)=
CAM     &                mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,4)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,2)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,3)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,4,2)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,4)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,4,3)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,4)
      enddo
#endif
                  endif
                endif
              enddo
              enddo
            enddo
            enddo

            if((lonsborn.or.lonsqcd.or.lonsew).and..not.belthr)then
              call Mat2born(konscms,m2i0,m2if0,
     &            m2if0_22,m2if0_33,m2if0_44,m2if0_nd,max(sbini,sbfin))
            endif

            if(lonsborn)then
              do i1=-5,5
              do i2=-5,5
              if (i1*i2.ne.0) then
                if(belthr)then
                  m2pdfpdfii_0(phasespace,i1,i2)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfii_0(aref,i1,i2)=0d0
      enddo
#endif
                else
#ifdef multpdf
                  m2pdfpdfii_0(phasespace,i1,i2)=
     &              m2i0(i1,i2)
c average over colours and spins
     &                /36d0
     &                *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfii_0(aref,i1,i2)=
     &            m2pdfpdfii_0(phasespace,i1,i2)
     &            *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfii_0(phasespace,i1,i2)=
     &            m2pdfpdfii_0(phasespace,i1,i2)
     &             *pdf1(i1)*pdf2(i2)
#else
                  m2pdfpdfii_0(phasespace,i1,i2)=
     &              m2i0(i1,i2)*pdf1(i1)*pdf2(i2)
c average over colours and spins
     &                /36d0
     &                *bwfac
#endif

c sum over initial state partons
                  m2pdfpdf_0(phasespace)=m2pdfpdf_0(phasespace)
     &                + m2pdfpdfii_0(phasespace,i1,i2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdf_0(aref)=mm2pdfpdf_0(aref)
     &                + mm2pdfpdfii_0(aref,i1,i2)
      enddo
#endif
                endif
              endif
              enddo
              enddo
            endif

            do i1=-4,4
            do i2=-4,4
            if (i1*i2.ne.0) then
              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then

                  if(lgencon(0,2).and.lonsew)then
                    if(belthr)then
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,2)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,3)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,4)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,3)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,4)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,4)=0d0
      enddo
#endif

                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,1)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,1)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,4,1)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,2)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,4,2)=0d0
                      m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,4,3)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,1)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,1)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,4,1)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,2)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,4,2)=0d0
CAM                      mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,4,3)=0d0
      enddo
#endif
                    else
#ifdef multpdf
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i2)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i3)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i4)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i2)*qparton(i3)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i2)*qparton(i4)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i3)*qparton(i4)/36d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,2)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,3)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,4)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,3)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,4)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,4)=
CAM     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)=
     &              m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)
     &               *pdf1(i1)*pdf2(i2)
#else
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i2)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i3)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i4)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i2)*qparton(i3)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i2)*qparton(i4)/36d0
     &                  *bwfac
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i3)*qparton(i4)/36d0
     &                  *bwfac
#endif

                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,1)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,2)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,1)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,3)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,4,1)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,1,4)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,2)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,3)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,4,2)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,2,4)
                    m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,4,3)=
     &                  m2pdfpdfiiiiqq_0(phasespace,i1,i2,i3,i4,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,1)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,2)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,1)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,3)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,4,1)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,1,4)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,2)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,3)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,4,2)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,2,4)
CAM                    mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,4,3)=
CAM     &                  mm2pdfpdfiiiiqq_0(aref,i1,i2,i3,i4,3,4)
      enddo
#endif
                    endif
                  endif
                  if(lgencon(0,5).and.lonsqcd)then
                    if(belthr)then
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,2)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,3)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,4)=0d0
      enddo
#endif

                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,4)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,4)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,3)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,1)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,1)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,4,1)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,2)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,4,2)=0d0
                      m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,4,3)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,4)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,4)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,3)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,1)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,1)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,4,1)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,2)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,4,2)=0d0
CAM                      mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,4,3)=0d0
      enddo
#endif
                    else
#ifdef multpdf
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)=
     &                (sqcddiag*m2if0_22(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i2)/27d0
     &                  *bwfac
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)=
     &                (sqcddiag*m2if0_33(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i3)/27d0
     &                  *bwfac
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)=
     &                (sqcddiag*m2if0_44(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i4)/27d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,2)=
CAM     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,3)=
CAM     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,4)=
CAM     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)
CAM     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)=
     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)=
     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)
     &               *pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)=
     &              m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)
     &               *pdf1(i1)*pdf2(i2)
#else
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)=
     &                (sqcddiag*m2if0_22(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i2)/27d0
     &                  *bwfac
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)=
     &                (sqcddiag*m2if0_33(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i3)/27d0
     &                  *bwfac
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)=
     &                (sqcddiag*m2if0_44(i1,i2,i3,i4)
     &                +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i4)/27d0
     &                  *bwfac
#endif

                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,4)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,4)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,3)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,1)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,2)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,1)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,3)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,4,1)=
     &                m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,1,4)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,2)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,3)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,4,2)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,2,4)
                    m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,4,3)=
     &                  m2pdfpdfiiiitt_0(phasespace,i1,i2,i3,i4,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        Write(*,*) "unexpected branch for multpdf"
        Write(*,*) "Program stops here"
        Stop
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,4)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,2)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,4)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,3)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,3)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,4)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,1)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,2)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,1)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,3)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,4,1)=
CAM     &                mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,1,4)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,2)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,3)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,4,2)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,2,4)
CAM                    mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,4,3)=
CAM     &                  mm2pdfpdfiiiitt_0(aref,i1,i2,i3,i4,3,4)
      enddo
#endif
                  endif
                  endif
                endif
              enddo
              enddo
            endif
            enddo
            enddo

c test output of |M|^2

          else if (lgencon(0,1).or.lwborn(0)) then

            if(belthr.and.lonsborn)then
              m2pdfpdf_0(phasespace)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdf_0(aref)=0d0
      enddo
#endif
              do i1=-5,5
                do i2=-5,5
                  m2pdfpdfii_0(phasespace,i1,i2)= 0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfii_0(aref,i1,i2)= 0d0
      enddo
#endif
                enddo
              enddo

            else         ! above threshold

            call Mat2born(kmcms,m2i0,m2if0,
     &          m2if0_22,m2if0_33,m2if0_44,m2if0_nd,max(sbini,sbfin))

            if(lonsborn)then
              call Mat2born0(konscms,m2i0,m2if0,max(sbini,sbfin))
            endif

            m2pdfpdf_0(phasespace)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdf_0(aref)=0d0
      enddo
#endif
            do i1=-5,5
              do i2=-5,5
                if (i1*i2.ne.0) then
#ifdef multpdf
                  m2pdfpdfii_0(phasespace,i1,i2)=
     &                m2i0(i1,i2)
c average over colours and spins
     &                /36d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfii_0(aref,i1,i2)=
     &            m2pdfpdfii_0(phasespace,i1,i2)
     &            *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfii_0(phasespace,i1,i2)=
     &            m2pdfpdfii_0(phasespace,i1,i2)
     &             *pdf1(i1)*pdf2(i2)
#else
                  m2pdfpdfii_0(phasespace,i1,i2)=
     &                m2i0(i1,i2)*pdf1(i1)*pdf2(i2)
c average over colours and spins
     &                /36d0
     &                  *bwfac
#endif



                  m2pdfpdf_0(phasespace)=m2pdfpdf_0(phasespace)
     &                + m2pdfpdfii_0(phasespace,i1,i2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdf_0(aref)=mm2pdfpdf_0(aref)
     &                + mm2pdfpdfii_0(aref,i1,i2)
      enddo
#endif
                endif
              enddo
            enddo

            endif                 ! if(belthr)



c average over colours and spins

c          write(*,*) 'crosssection ',m2b,m2bb,m2pdfpdf_0(phasespace)

c symmetric contributions


c test output of |M|^2


          endif

c partonic phasespace (no convolution)
c        m2pdfpdf_0=1d-7
c        born(0,1)=1d-7
c        born(0,2)=1d-7
c weighted hadronic phase space (with convolution)
c        m2pdfpdf_0=1d-7
c        born(0,1)=1d-7/x1/x2
c        born(0,2)=1d-7/x1/x2
c weighted hadronic phase space with proton charge
c        born(0,1)=1d-7/x1/x2
c     &      *(2d0/3d0*(pdf1(2)-pdf1(-2))-1d0/3d0*(pdf1(1)-pdf1(-1)))
c        born(0,2)=1d-7/x1/x2
c     &      *(2d0/3d0*(pdf1(2)-pdf1(-2))-1d0/3d0*(pdf1(1)-pdf1(-1)))
c weighted hadronic phase space with neutron charge
c        born(0,1)=1d-7/x1/x2
c     &      *(2d0/3d0*(pdf1(1)-pdf1(-1))-1d0/3d0*(pdf1(2)-pdf1(-2)))
c        born(0,2)=1d-7/x1/x2
c     &      *(2d0/3d0*(pdf1(1)-pdf1(-1))-1d0/3d0*(pdf1(2)-pdf1(-2)))
c weighted hadronic phase space with charm content
c        born(0,1)=1d-7/x1/x2
c     &      *(pdf1(3)-pdf1(-3))
c        born(0,2)=1d-7/x1/x2
c     &      *(pdf1(3)-pdf1(-3))


          if(svirt(generator).ne.0.and.
     &        (lgencon(0,2).or.lgencon(0,5)))then
c virtual corrections

c     boost momenta to cms
            do i1=1,lnext
              do i2=0,3
                q1(i2)=km(i1,i2)
              enddo
              call boost(0d0,q,q1,1d0,switch)
              do i2=0,3
                kmcms(i1,i2)=q1(i2)
              enddo
            enddo
            if(switch.ne.0) return

c qcd corrections must be calculated with ew corrections to
c ensure proper use of cache for loop integrals
            if((lgencon(0,5).or.
     &          lgencon(0,2).and.sgencon(0,5).eq.1)
     &          .and..not.(lonsqcd.and.belthr)
     &          .and..not.(lonsew.and.belthr.and.nvirtinit.le.10))then

c initializes cache for loop integrals
	      call fastinit(6)

              qferm=0
              qbos =0
              qhh2 =0
              if(lonsqcd)then
                call Mat2(konscms,m2i0,m2if0,m2i,m2if)
              else
                call Mat2(kmcms,m2i0,m2if0,m2i,m2if)
              endif
              qferm=sferm
              qbos =sbos
              qhh2 =shh2

              m2pdfpdf_vs(phasespace)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdf_vs(aref)=0d0
      enddo
#endif
              do i1=-4,4
                do i2=-4,4
                  if (i1*i2.ne.0) then
#ifdef multpdf
                    m2pdfpdfii_vs(phasespace,i1,i2)=
     &                  m2i(i1,i2)
     &                  /(36d0)
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                    mm2pdfpdfii_vs(aref,i1,i2)=
     &              m2pdfpdfii_vs(phasespace,i1,i2)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                    m2pdfpdfii_vs(phasespace,i1,i2)=
     &              m2pdfpdfii_vs(phasespace,i1,i2)
     &               *pdf1(i1)*pdf2(i2)
#else
                    m2pdfpdfii_vs(phasespace,i1,i2)=
     &                  m2i(i1,i2)*pdf1(i1)*pdf2(i2)
     &                  /(36d0)
     &                  *bwfac
#endif

                    m2pdfpdf_vs(phasespace)=m2pdfpdf_vs(phasespace)
     &                  + m2pdfpdfii_vs(phasespace,i1,i2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                    mm2pdfpdf_vs(aref)=mm2pdfpdf_vs(aref)
     &                  + mm2pdfpdfii_vs(aref,i1,i2)
      enddo
#endif


                  endif
                enddo
              enddo

            else
              do i1=-4,4
                do i2=-4,4
                  m2pdfpdfii_vs(phasespace,i1,i2) =0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfii_vs(aref,i1,i2) =0d0
      enddo
#endif
                enddo
              enddo
              m2pdfpdf_vs(phasespace)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdf_vs(aref)=0d0
      enddo
#endif
            endif

c  to initialize cache for loop integrals, qcd and ew corrections
c  must be calculated for the first 10 times together
c (counted by nvirtinit)
            if((lgencon(0,2).or.
     &          nvirtinit.le.10.and.lgencon(0,5)
     &          .and..not.(lonsqcd.and.belthr))
     &          .and..not.(lonsew.and.belthr))then
              nvirtinit=nvirtinit+1
              qqcddiag=0
              qqcdnondiag=0
              qqcdgsplit=0
              qqcdggfus=0
              call Mat2(konscms,m2i0,m2if0,m2i,m2if)
              qqcddiag=sqcddiag
              qqcdnondiag=sqcdnondiag
              qqcdgsplit=sqcdgsplit
              qqcdggfus=sqcdggfus

c          write(*,*) 'crosssection: m2pdfpdf_v a ',
c     &        phasespace,m2pdfpdf_v(phasespace)
              m2pdfpdf_vw(phasespace)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdf_vw(aref)=0d0
      enddo
#endif
              do i1=-4,4
                do i2=-4,4
                  if (i1*i2.ne.0) then
#ifdef multpdf
                    m2pdfpdfii_vw(phasespace,i1,i2)=
     &                  m2i(i1,i2)
     &                  /(36d0)
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                    mm2pdfpdfii_vw(aref,i1,i2)=
     &              m2pdfpdfii_vw(phasespace,i1,i2)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                    m2pdfpdfii_vw(phasespace,i1,i2)=
     &              m2pdfpdfii_vw(phasespace,i1,i2)
     &               *pdf1(i1)*pdf2(i2)
#else
                    m2pdfpdfii_vw(phasespace,i1,i2)=
     &                  m2i(i1,i2)*pdf1(i1)*pdf2(i2)
     &                  /(36d0)
     &                  *bwfac
#endif

                    m2pdfpdf_vw(phasespace)=m2pdfpdf_vw(phasespace)
     &                  + m2pdfpdfii_vw(phasespace,i1,i2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                    mm2pdfpdf_vw(aref)=mm2pdfpdf_vw(aref)
     &                  + mm2pdfpdfii_vw(aref,i1,i2)
      enddo
#endif

c          write(*,*) 'crosssection: m2i ',m2i0(i1,i2),m2i(i1,i2),
c     &       m2pdfpdfii_v(phasespace,i1,i2), m2pdfpdf_v(phasespace)
c              write(*,*) 'crosssecction c ',
c     &            m2i(i1,i2)/36d0,m2pdfpdfii_v(phasespace,i1,i2),
c     &           pdf1(i1),pdf2(i2)
c              write(*,*) 'crosssecction s ',
c     &            m2v/36d0,m2pdfpdf_v(phasespace)

                  endif
                enddo
              enddo
c          write(*,*) 'crosssection: m2pdfpdf_v b ',
c     &        phasespace,m2pdfpdf_v(phasespace)
c          write(*,*) 'crosssection: m2v,m2vv ',m2v/36d0,m2vv/36d0

            else
              m2pdfpdf_vw(phasespace)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdf_vw(aref)=0d0
      enddo
#endif
              do i1=-4,4
                do i2=-4,4
                  m2pdfpdfii_vw(phasespace,i1,i2) =0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfii_vw(aref,i1,i2) =0d0
      enddo
#endif
                enddo
              enddo
            endif

          endif

        elseif((phasespace.eq.2.or.phasespace.eq.3).and.
     &        (lgencon(0,3).or.lgencon(0,4)))then


          call Mat2born(kmcms,m2i0,m2if0,
     &        m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)

c          m2pdfpdf_0(phasespace)=0d0

          m2pdfpdfqq_0(phasespace,1,2)=0d0
          m2pdfpdfqq_0(phasespace,1,3)=0d0
          m2pdfpdfqq_0(phasespace,1,4)=0d0
          m2pdfpdfqq_0(phasespace,2,3)=0d0
          m2pdfpdfqq_0(phasespace,2,4)=0d0
          m2pdfpdfqq_0(phasespace,3,4)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdfqq_0(aref,1,2)=0d0
          mm2pdfpdfqq_0(aref,1,3)=0d0
          mm2pdfpdfqq_0(aref,1,4)=0d0
          mm2pdfpdfqq_0(aref,2,3)=0d0
          mm2pdfpdfqq_0(aref,2,4)=0d0
          mm2pdfpdfqq_0(aref,3,4)=0d0
      enddo
#endif

          m2pdfpdftt_0(phasespace,1,2)=0d0
          m2pdfpdftt_0(phasespace,1,3)=0d0
          m2pdfpdftt_0(phasespace,1,4)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdftt_0(aref,1,2)=0d0
          mm2pdfpdftt_0(aref,1,3)=0d0
          mm2pdfpdftt_0(aref,1,4)=0d0
      enddo
#endif

          do i1=-4,4
          do i2=-4,4
            if (i1*i2.ne.0) then
c              m2pdfpdfii_0(phasespace,i1,i2)=
c     &            m2i0(i1,i2)*pdf1(i1)*pdf2(i2)

              if(lgencon(0,3))then
                m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)=0d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)=0d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)=0d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,2,3)=0d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)=0d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                mm2pdfpdfiiqq_0(aref,i1,i2,1,2)=0d0
                mm2pdfpdfiiqq_0(aref,i1,i2,1,3)=0d0
                mm2pdfpdfiiqq_0(aref,i1,i2,1,4)=0d0
                mm2pdfpdfiiqq_0(aref,i1,i2,2,3)=0d0
                mm2pdfpdfiiqq_0(aref,i1,i2,2,4)=0d0
                mm2pdfpdfiiqq_0(aref,i1,i2,3,4)=0d0
      enddo
#endif
              endif

              if(lgencon(0,4))then
                m2pdfpdfiitt_0(phasespace,i1,i2,1,2)=0d0
                m2pdfpdfiitt_0(phasespace,i1,i2,1,3)=0d0
                m2pdfpdfiitt_0(phasespace,i1,i2,1,4)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                mm2pdfpdfiitt_0(aref,i1,i2,1,2)=0d0
                mm2pdfpdfiitt_0(aref,i1,i2,1,3)=0d0
                mm2pdfpdfiitt_0(aref,i1,i2,1,4)=0d0
      enddo
#endif
              endif

              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then

c sum over final state partons
                  if(lgencon(0,3))then
#ifdef multpdf
                    keep(  1)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i2)
     &                  *bwfac
                    keep(  2)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i3)
     &                  *bwfac
                    keep(  3)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i1)*qparton(i4)
     &                  *bwfac
                    keep(  4)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i2)*qparton(i3)
     &                  *bwfac
                    keep(  5)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i2)*qparton(i4)
     &                  *bwfac
                    keep(  6)=
     &                  m2if0(i1,i2,i3,i4)
     &                  *qparton(i3)*qparton(i4)
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                    mm2pdfpdfiiqq_0(aref,i1,i2,1,2)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,2)+keep(  1)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiiqq_0(aref,i1,i2,1,3)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,3)+keep(  2)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiiqq_0(aref,i1,i2,1,4)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,4)+keep(  3)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiiqq_0(aref,i1,i2,2,3) =
     &              mm2pdfpdfiiqq_0(aref,i1,i2,2,3) +keep(  4)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiiqq_0(aref,i1,i2,2,4)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,2,4)+keep(  5)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiiqq_0(aref,i1,i2,3,4)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,3,4)+keep(  6)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                    m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)+
     &               keep(  1)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)+
     &               keep(  2)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)+
     &               keep(  3)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,2,3) =
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,2,3) +
     &               keep(  4)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)+
     &               keep(  5)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)+
     &               keep(  6)*pdf1(i1)*pdf2(i2)
#else
                    m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,1,2) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i2)
     &                  *bwfac
                    m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,1,3) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i3)
     &                  *bwfac
                    m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,1,4) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i4)
     &                  *bwfac
                    m2pdfpdfiiqq_0(phasespace,i1,i2,2,3) =
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,2,3) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i2)*qparton(i3)
     &                  *bwfac
                    m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,2,4) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i2)*qparton(i4)
     &                  *bwfac
                    m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)=
     &                  m2pdfpdfiiqq_0(phasespace,i1,i2,3,4) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(i2)*qparton(i3)*qparton(i4)
     &                  *bwfac
#endif
                  endif
                  if(lgencon(0,4))then
#ifdef multpdf
                    keep(  1)=
     &                  (sqcddiag*m2if0_22(i1,i2,i3,i4)
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i2)
     &                  *bwfac
                    keep(  2)=
     &                  (sqcddiag*m2if0_33(i1,i2,i3,i4)
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i3)
     &                  *bwfac
                    keep(  3)=
     &                  (sqcddiag*m2if0_44(i1,i2,i3,i4)
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *sign(1,i1*i4)
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                    mm2pdfpdfiitt_0(aref,i1,i2,1,2)=
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,2)+keep(  1)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiitt_0(aref,i1,i2,1,3)=
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,3)+keep(  2)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
                    mm2pdfpdfiitt_0(aref,i1,i2,1,4)=
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,4)+keep(  3)
     &              *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                    m2pdfpdfiitt_0(phasespace,i1,i2,1,2)=
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,2)+
     &               keep(  1)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiitt_0(phasespace,i1,i2,1,3)=
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,3)+
     &               keep(  2)*pdf1(i1)*pdf2(i2)
                    m2pdfpdfiitt_0(phasespace,i1,i2,1,4)=
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,4)+
     &               keep(  3)*pdf1(i1)*pdf2(i2)
#else
                    m2pdfpdfiitt_0(phasespace,i1,i2,1,2)=
     &                  m2pdfpdfiitt_0(phasespace,i1,i2,1,2) +
     &                  (sqcddiag*m2if0_22(i1,i2,i3,i4)
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i2)
     &                  *bwfac
                    m2pdfpdfiitt_0(phasespace,i1,i2,1,3)=
     &                  m2pdfpdfiitt_0(phasespace,i1,i2,1,3) +
     &                  (sqcddiag*m2if0_33(i1,i2,i3,i4)
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i3)
     &                  *bwfac
                    m2pdfpdfiitt_0(phasespace,i1,i2,1,4)=
     &                  m2pdfpdfiitt_0(phasespace,i1,i2,1,4) +
     &                  (sqcddiag*m2if0_44(i1,i2,i3,i4)
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                  *pdf1(i1)*pdf2(i2)*sign(1,i1*i4)
     &                  *bwfac
#endif
                  endif
                endif
              enddo
              enddo


c average over colours and spins
c              m2pdfpdfii_0(phasespace,i1,i2)=
c     &            m2pdfpdfii_0(phasespace,i1,i2)/36d0

c sum over initial state partons
c              m2pdfpdf_0(phasespace)=m2pdfpdf_0(phasespace)
c     &            + m2pdfpdfii_0(phasespace,i1,i2)

              if(lgencon(0,3))then
c average over colours and spins
                m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)/36d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)/36d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)/36d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,2,3)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,2,3)/36d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)/36d0
                m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)=
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)/36d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                mm2pdfpdfiiqq_0(aref,i1,i2,1,2)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,2)/36d0
                mm2pdfpdfiiqq_0(aref,i1,i2,1,3)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,3)/36d0
                mm2pdfpdfiiqq_0(aref,i1,i2,1,4)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,4)/36d0
                mm2pdfpdfiiqq_0(aref,i1,i2,2,3)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,2,3)/36d0
                mm2pdfpdfiiqq_0(aref,i1,i2,2,4)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,2,4)/36d0
                mm2pdfpdfiiqq_0(aref,i1,i2,3,4)=
     &              mm2pdfpdfiiqq_0(aref,i1,i2,3,4)/36d0
      enddo
#endif

c sum over initial state partons
                m2pdfpdfqq_0(phasespace,1,2)=
     &              m2pdfpdfqq_0(phasespace,1,2) +
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)
                m2pdfpdfqq_0(phasespace,1,3)=
     &              m2pdfpdfqq_0(phasespace,1,3) +
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)
                m2pdfpdfqq_0(phasespace,1,4)=
     &              m2pdfpdfqq_0(phasespace,1,4) +
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)
                m2pdfpdfqq_0(phasespace,2,3) =
     &              m2pdfpdfqq_0(phasespace,2,3) +
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,2,3)
                m2pdfpdfqq_0(phasespace,2,4)=
     &              m2pdfpdfqq_0(phasespace,2,4) +
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)
                m2pdfpdfqq_0(phasespace,3,4)=
     &              m2pdfpdfqq_0(phasespace,3,4) +
     &              m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                mm2pdfpdfqq_0(aref,1,2)=
     &              mm2pdfpdfqq_0(aref,1,2) +
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,2)
                mm2pdfpdfqq_0(aref,1,3)=
     &              mm2pdfpdfqq_0(aref,1,3) +
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,3)
                mm2pdfpdfqq_0(aref,1,4)=
     &              mm2pdfpdfqq_0(aref,1,4) +
     &              mm2pdfpdfiiqq_0(aref,i1,i2,1,4)
                mm2pdfpdfqq_0(aref,2,3) =
     &              mm2pdfpdfqq_0(aref,2,3) +
     &              mm2pdfpdfiiqq_0(aref,i1,i2,2,3)
                mm2pdfpdfqq_0(aref,2,4)=
     &              mm2pdfpdfqq_0(aref,2,4) +
     &              mm2pdfpdfiiqq_0(aref,i1,i2,2,4)
                mm2pdfpdfqq_0(aref,3,4)=
     &              mm2pdfpdfqq_0(aref,3,4) +
     &              mm2pdfpdfiiqq_0(aref,i1,i2,3,4)
      enddo
#endif
              endif

              if(lgencon(0,4))then
c average over colours and spins including CF:  4/3 /36
                m2pdfpdfiitt_0(phasespace,i1,i2,1,2)=
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,2)/27d0
                m2pdfpdfiitt_0(phasespace,i1,i2,1,3)=
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,3)/27d0
                m2pdfpdfiitt_0(phasespace,i1,i2,1,4)=
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,4)/27d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                mm2pdfpdfiitt_0(aref,i1,i2,1,2)=
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,2)/27d0
                mm2pdfpdfiitt_0(aref,i1,i2,1,3)=
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,3)/27d0
                mm2pdfpdfiitt_0(aref,i1,i2,1,4)=
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,4)/27d0
      enddo
#endif

c     sum over initial state partons
                m2pdfpdftt_0(phasespace,1,2)=
     &              m2pdfpdftt_0(phasespace,1,2) +
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,2)
                m2pdfpdftt_0(phasespace,1,3)=
     &              m2pdfpdftt_0(phasespace,1,3) +
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,3)
                m2pdfpdftt_0(phasespace,1,4)=
     &              m2pdfpdftt_0(phasespace,1,4) +
     &              m2pdfpdfiitt_0(phasespace,i1,i2,1,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                mm2pdfpdftt_0(aref,1,2)=
     &              mm2pdfpdftt_0(aref,1,2) +
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,2)
                mm2pdfpdftt_0(aref,1,3)=
     &              mm2pdfpdftt_0(aref,1,3) +
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,3)
                mm2pdfpdftt_0(aref,1,4)=
     &              mm2pdfpdftt_0(aref,1,4) +
     &              mm2pdfpdfiitt_0(aref,i1,i2,1,4)
      enddo
#endif
              endif
            endif
          enddo
          enddo

c average over colours and spins
c          write(*,*) 'crosssection',m2b,m2bb,
c     &        m2pdfpdf_0(phasespace)

c symmetric contributions
         if(lgencon(0,3))then
           m2pdfpdfqq_0(phasespace,2,1)=m2pdfpdfqq_0(phasespace,1,2)
           m2pdfpdfqq_0(phasespace,3,1)=m2pdfpdfqq_0(phasespace,1,3)
           m2pdfpdfqq_0(phasespace,4,1)=m2pdfpdfqq_0(phasespace,1,4)
           m2pdfpdfqq_0(phasespace,3,2)=m2pdfpdfqq_0(phasespace,2,3)
           m2pdfpdfqq_0(phasespace,4,2)=m2pdfpdfqq_0(phasespace,2,4)
           m2pdfpdfqq_0(phasespace,4,3)=m2pdfpdfqq_0(phasespace,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
           mm2pdfpdfqq_0(aref,2,1)=mm2pdfpdfqq_0(aref,1,2)
           mm2pdfpdfqq_0(aref,3,1)=mm2pdfpdfqq_0(aref,1,3)
           mm2pdfpdfqq_0(aref,4,1)=mm2pdfpdfqq_0(aref,1,4)
           mm2pdfpdfqq_0(aref,3,2)=mm2pdfpdfqq_0(aref,2,3)
           mm2pdfpdfqq_0(aref,4,2)=mm2pdfpdfqq_0(aref,2,4)
           mm2pdfpdfqq_0(aref,4,3)=mm2pdfpdfqq_0(aref,3,4)
      enddo
#endif
           do i1=-4,4
             do i2=-4,4
               if(i1*i2.ne.0)then
                 m2pdfpdfiiqq_0(phasespace,i1,i2,2,1)=
     &               m2pdfpdfiiqq_0(phasespace,i1,i2,1,2)
                 m2pdfpdfiiqq_0(phasespace,i1,i2,3,1)=
     &               m2pdfpdfiiqq_0(phasespace,i1,i2,1,3)
                 m2pdfpdfiiqq_0(phasespace,i1,i2,4,1)=
     &               m2pdfpdfiiqq_0(phasespace,i1,i2,1,4)
                 m2pdfpdfiiqq_0(phasespace,i1,i2,3,2)=
     &               m2pdfpdfiiqq_0(phasespace,i1,i2,2,3)
                 m2pdfpdfiiqq_0(phasespace,i1,i2,4,2)=
     &               m2pdfpdfiiqq_0(phasespace,i1,i2,2,4)
                 m2pdfpdfiiqq_0(phasespace,i1,i2,4,3)=
     &               m2pdfpdfiiqq_0(phasespace,i1,i2,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                 mm2pdfpdfiiqq_0(aref,i1,i2,2,1)=
     &               mm2pdfpdfiiqq_0(aref,i1,i2,1,2)
                 mm2pdfpdfiiqq_0(aref,i1,i2,3,1)=
     &               mm2pdfpdfiiqq_0(aref,i1,i2,1,3)
                 mm2pdfpdfiiqq_0(aref,i1,i2,4,1)=
     &               mm2pdfpdfiiqq_0(aref,i1,i2,1,4)
                 mm2pdfpdfiiqq_0(aref,i1,i2,3,2)=
     &               mm2pdfpdfiiqq_0(aref,i1,i2,2,3)
                 mm2pdfpdfiiqq_0(aref,i1,i2,4,2)=
     &               mm2pdfpdfiiqq_0(aref,i1,i2,2,4)
                 mm2pdfpdfiiqq_0(aref,i1,i2,4,3)=
     &               mm2pdfpdfiiqq_0(aref,i1,i2,3,4)
      enddo
#endif
               endif
             enddo
           enddo
         endif

         if(lgencon(0,4))then
           m2pdfpdftt_0(phasespace,3,4)=m2pdfpdftt_0(phasespace,1,2)
           m2pdfpdftt_0(phasespace,2,4)=m2pdfpdftt_0(phasespace,1,3)
           m2pdfpdftt_0(phasespace,2,3)=m2pdfpdftt_0(phasespace,1,4)
           m2pdfpdftt_0(phasespace,2,1)=m2pdfpdftt_0(phasespace,1,2)
           m2pdfpdftt_0(phasespace,3,1)=m2pdfpdftt_0(phasespace,1,3)
           m2pdfpdftt_0(phasespace,4,1)=m2pdfpdftt_0(phasespace,1,4)
           m2pdfpdftt_0(phasespace,3,2)=m2pdfpdftt_0(phasespace,2,3)
           m2pdfpdftt_0(phasespace,4,2)=m2pdfpdftt_0(phasespace,2,4)
           m2pdfpdftt_0(phasespace,4,3)=m2pdfpdftt_0(phasespace,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
           mm2pdfpdftt_0(aref,3,4)=mm2pdfpdftt_0(aref,1,2)
           mm2pdfpdftt_0(aref,2,4)=mm2pdfpdftt_0(aref,1,3)
           mm2pdfpdftt_0(aref,2,3)=mm2pdfpdftt_0(aref,1,4)
           mm2pdfpdftt_0(aref,2,1)=mm2pdfpdftt_0(aref,1,2)
           mm2pdfpdftt_0(aref,3,1)=mm2pdfpdftt_0(aref,1,3)
           mm2pdfpdftt_0(aref,4,1)=mm2pdfpdftt_0(aref,1,4)
           mm2pdfpdftt_0(aref,3,2)=mm2pdfpdftt_0(aref,2,3)
           mm2pdfpdftt_0(aref,4,2)=mm2pdfpdftt_0(aref,2,4)
           mm2pdfpdftt_0(aref,4,3)=mm2pdfpdftt_0(aref,3,4)
      enddo
#endif
           do i1=-4,4
             do i2=-4,4
               if(i1*i2.ne.0)then
                 m2pdfpdfiitt_0(phasespace,i1,i2,3,4)=
     &               m2pdfpdfiitt_0(phasespace,i1,i2,1,2)
                 m2pdfpdfiitt_0(phasespace,i1,i2,2,4)=
     &               m2pdfpdfiitt_0(phasespace,i1,i2,1,3)
                 m2pdfpdfiitt_0(phasespace,i1,i2,2,3)=
     &               m2pdfpdfiitt_0(phasespace,i1,i2,1,4)
                 m2pdfpdfiitt_0(phasespace,i1,i2,2,1)=
     &               m2pdfpdfiitt_0(phasespace,i1,i2,1,2)
                 m2pdfpdfiitt_0(phasespace,i1,i2,3,1)=
     &               m2pdfpdfiitt_0(phasespace,i1,i2,1,3)
                 m2pdfpdfiitt_0(phasespace,i1,i2,4,1)=
     &               m2pdfpdfiitt_0(phasespace,i1,i2,1,4)
                 m2pdfpdfiitt_0(phasespace,i1,i2,3,2)=
     &               m2pdfpdfiitt_0(phasespace,i1,i2,2,3)
                 m2pdfpdfiitt_0(phasespace,i1,i2,4,2)=
     &               m2pdfpdfiitt_0(phasespace,i1,i2,2,4)
                 m2pdfpdfiitt_0(phasespace,i1,i2,4,3)=
     &               m2pdfpdfiitt_0(phasespace,i1,i2,3,4)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                 mm2pdfpdfiitt_0(aref,i1,i2,3,4)=
     &               mm2pdfpdfiitt_0(aref,i1,i2,1,2)
                 mm2pdfpdfiitt_0(aref,i1,i2,2,4)=
     &               mm2pdfpdfiitt_0(aref,i1,i2,1,3)
                 mm2pdfpdfiitt_0(aref,i1,i2,2,3)=
     &               mm2pdfpdfiitt_0(aref,i1,i2,1,4)
                 mm2pdfpdfiitt_0(aref,i1,i2,2,1)=
     &               mm2pdfpdfiitt_0(aref,i1,i2,1,2)
                 mm2pdfpdfiitt_0(aref,i1,i2,3,1)=
     &               mm2pdfpdfiitt_0(aref,i1,i2,1,3)
                 mm2pdfpdfiitt_0(aref,i1,i2,4,1)=
     &               mm2pdfpdfiitt_0(aref,i1,i2,1,4)
                 mm2pdfpdfiitt_0(aref,i1,i2,3,2)=
     &               mm2pdfpdfiitt_0(aref,i1,i2,2,3)
                 mm2pdfpdfiitt_0(aref,i1,i2,4,2)=
     &               mm2pdfpdfiitt_0(aref,i1,i2,2,4)
                 mm2pdfpdfiitt_0(aref,i1,i2,4,3)=
     &               mm2pdfpdfiitt_0(aref,i1,i2,3,4)
      enddo
#endif
               endif
             enddo
           enddo
         endif



        elseif((phasespace.eq.4.or.phasespace.eq.5).and.
     &        (lgencon(0,6).or.lgencon(0,7).or.
     &         lgencon(0,8).or.lgencon(0,9)))then


          call Mat2born(kmcms,m2i0,m2if0,
     &        m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)

c          m2pdfpdf_0(phasespace)=0d0

          m2pdfpdfq2_0(phasespace,1)=0d0
          m2pdfpdfq2_0(phasespace,2)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdfq2_0(aref,1)=0d0
          mm2pdfpdfq2_0(aref,2)=0d0
      enddo
#endif

          m2pdfpdft2_0(phasespace,1)=0d0
          m2pdfpdft2_0(phasespace,2)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdft2_0(aref,1)=0d0
          mm2pdfpdft2_0(aref,2)=0d0
      enddo
#endif

          do i1=-4,4

            m2pdfpdfiiq2_0(phasespace,0,i1,1)=0d0
            m2pdfpdfiiq2_0(phasespace,i1,0,2)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdfiiq2_0(aref,0,i1,1)=0d0
            mm2pdfpdfiiq2_0(aref,i1,0,2)=0d0
      enddo
#endif

            m2pdfpdfiit2_0(phasespace,0,i1,1)=0d0
            m2pdfpdfiit2_0(phasespace,i1,0,2)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdfiit2_0(aref,0,i1,1)=0d0
            mm2pdfpdfiit2_0(aref,i1,0,2)=0d0
      enddo
#endif

          do i2=-4,4
            if (i1*i2.ne.0) then
c              m2pdfpdfii_0(phasespace,i1,i2)=
c     &            m2i0(i1,i2)*pdf1(i1)*pdf2(i2)

              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then

c sum over final state partons

                  if(lgencon(0,6).or.lgencon(0,7))then
#ifdef multpdf
                    keep(  1)=
     &                  m2if0(i2,i1,i4,i3)
     &                  *qparton(i2)*qparton(i2)
     &                  *bwfac
                    keep(  2)=
     &                  m2if0(i1,i2,i3,i4)
     &                *qparton(i2)*qparton(i2)
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        If(pdf_phot1.NE.0D0 .OR. pdf_phot2.NE.0D0) Then
          write(*,*) 'multiple PDF sets not supported for photon PDF'
	  write(*,*) 'program stopped'
	  Stop
	Endif
      enddo
                    m2pdfpdfiiq2_0(phasespace,0,i1,1)=
     &              m2pdfpdfiiq2_0(phasespace,0,i1,1)+
     &               keep(  1)
     &                  *pdf_phot1*pdf2(i1)
                    m2pdfpdfiiq2_0(phasespace,i1,0,2)=
     &              m2pdfpdfiiq2_0(phasespace,i1,0,2)+
     &               keep(  2)
     &                  *pdf1(i1)*pdf_phot2
#else
                    m2pdfpdfiiq2_0(phasespace,0,i1,1)=
     &                  m2pdfpdfiiq2_0(phasespace,0,i1,1) +
     &                  m2if0(i2,i1,i4,i3)
     &                  *pdf_phot1*pdf2(i1)
     &                  *qparton(i2)*qparton(i2)
     &                  *bwfac
                    m2pdfpdfiiq2_0(phasespace,i1,0,2)=
     &                  m2pdfpdfiiq2_0(phasespace,i1,0,2) +
     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf_phot2
     &                *qparton(i2)*qparton(i2)
     &                  *bwfac
#endif
                  endif
                  if(lgencon(0,8).or.lgencon(0,9))then
#ifdef multpdf
                    keep(  1)=
     &                  (sqcddiag*(m2if0_22(i2,i1,i4,i3)
     &                  +m2if0_33(i2,i1,i4,i3)+m2if0_44(i2,i1,i4,i3))
     &                  +sqcdnondiag*m2if0_nd(i2,i1,i4,i3))
c     &                  m2if0(i2,i1,i4,i3)
     &
     &                  *bwfac
                    keep(  2)=
     &                  (sqcddiag*(m2if0_22(i1,i2,i3,i4)
     &                  +m2if0_33(i1,i2,i3,i4)+m2if0_44(i1,i2,i3,i4))
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
c     &                  m2if0(i1,i2,i3,i4)
     &
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                    mm2pdfpdfiit2_0(aref,0,i1,1)=
     &              mm2pdfpdfiit2_0(aref,0,i1,1)+keep(  1)
     &              *mpdf1(nset,0)*mpdf2(nset,i1)
                    mm2pdfpdfiit2_0(aref,i1,0,2)=
     &              mm2pdfpdfiit2_0(aref,i1,0,2)+keep(  2)
     &              *mpdf1(nset,i1)*mpdf2(nset,0)
      enddo
                    m2pdfpdfiit2_0(phasespace,0,i1,1)=
     &              m2pdfpdfiit2_0(phasespace,0,i1,1)+
     &               keep(  1)*pdf1(0)*pdf2(i1)
                    m2pdfpdfiit2_0(phasespace,i1,0,2)=
     &              m2pdfpdfiit2_0(phasespace,i1,0,2)+
     &               keep(  2)*pdf1(i1)*pdf2(0)
#else
                    m2pdfpdfiit2_0(phasespace,0,i1,1)=
     &                  m2pdfpdfiit2_0(phasespace,0,i1,1) +
     &                  (sqcddiag*(m2if0_22(i2,i1,i4,i3)
     &                  +m2if0_33(i2,i1,i4,i3)+m2if0_44(i2,i1,i4,i3))
     &                  +sqcdnondiag*m2if0_nd(i2,i1,i4,i3))
c     &                  m2if0(i2,i1,i4,i3)
     &                  *pdf1(0)*pdf2(i1)
     &                  *bwfac
                    m2pdfpdfiit2_0(phasespace,i1,0,2)=
     &                  m2pdfpdfiit2_0(phasespace,i1,0,2) +
     &                  (sqcddiag*(m2if0_22(i1,i2,i3,i4)
     &                  +m2if0_33(i1,i2,i3,i4)+m2if0_44(i1,i2,i3,i4))
     &                  +sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
c     &                  m2if0(i1,i2,i3,i4)
     &                  *pdf1(i1)*pdf2(0)
     &                  *bwfac
#endif
                  endif
                endif
              enddo
              enddo


c average over colours and spins
c              m2pdfpdfii_0(phasespace,i1,i2)=
c     &            m2pdfpdfii_0(phasespace,i1,i2)/36d0

c sum over initial state partons
c              m2pdfpdf_0(phasespace)=m2pdfpdf_0(phasespace)
c     &            + m2pdfpdfii_0(phasespace,i1,i2)
            endif
          enddo

          if(lgencon(0,6).or.lgencon(0,7))then
c average over colours and spins: 1/Nf *1/4
            m2pdfpdfiiq2_0(phasespace,0,i1,1)=
     &          m2pdfpdfiiq2_0(phasespace,0,i1,1)/12d0
            m2pdfpdfiiq2_0(phasespace,i1,0,2)=
     &          m2pdfpdfiiq2_0(phasespace,i1,0,2)/12d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdfiiq2_0(aref,0,i1,1)=
     &          mm2pdfpdfiiq2_0(aref,0,i1,1)/12d0
            mm2pdfpdfiiq2_0(aref,i1,0,2)=
     &          mm2pdfpdfiiq2_0(aref,i1,0,2)/12d0
      enddo
#endif

c sum over initial state partons
            m2pdfpdfq2_0(phasespace,1)=
     &          m2pdfpdfq2_0(phasespace,1) +
     &          m2pdfpdfiiq2_0(phasespace,0,i1,1)
            m2pdfpdfq2_0(phasespace,2)=
     &          m2pdfpdfq2_0(phasespace,2) +
     &          m2pdfpdfiiq2_0(phasespace,i1,0,2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdfq2_0(aref,1)=
     &          mm2pdfpdfq2_0(aref,1) +
     &          mm2pdfpdfiiq2_0(aref,0,i1,1)
            mm2pdfpdfq2_0(aref,2)=
     &          mm2pdfpdfq2_0(aref,2) +
     &          mm2pdfpdfiiq2_0(aref,i1,0,2)
      enddo
#endif
          endif

          if(lgencon(0,8).or.lgencon(0,9))then
c average over colours and spins and coupling factor Cf:   Cf/Nf/8 *1/4
              m2pdfpdfiit2_0(phasespace,0,i1,1)=
     &            m2pdfpdfiit2_0(phasespace,0,i1,1)/72d0
              m2pdfpdfiit2_0(phasespace,i1,0,2)=
     &            m2pdfpdfiit2_0(phasespace,i1,0,2)/72d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiit2_0(aref,0,i1,1)=
     &            mm2pdfpdfiit2_0(aref,0,i1,1)/72d0
              mm2pdfpdfiit2_0(aref,i1,0,2)=
     &            mm2pdfpdfiit2_0(aref,i1,0,2)/72d0
      enddo
#endif

c sum over initial state partons
              m2pdfpdft2_0(phasespace,1)=
     &            m2pdfpdft2_0(phasespace,1) +
     &            m2pdfpdfiit2_0(phasespace,0,i1,1)
              m2pdfpdft2_0(phasespace,2)=
     &            m2pdfpdft2_0(phasespace,2) +
     &            m2pdfpdfiit2_0(phasespace,i1,0,2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdft2_0(aref,1)=
     &            mm2pdfpdft2_0(aref,1) +
     &            mm2pdfpdfiit2_0(aref,0,i1,1)
              mm2pdfpdft2_0(aref,2)=
     &            mm2pdfpdft2_0(aref,2) +
     &            mm2pdfpdfiit2_0(aref,i1,0,2)
      enddo
#endif
          endif
          enddo


        endif

      elseif(generator.eq.1.and.phasespace.eq.1)then
c real corrections
        call Mat2photon_out(kmcms,m2i_phot,m2if_phot)
        m2pdfpdf_0(phasespace)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        mm2pdfpdf_0(aref)=0d0
      enddo
#endif
        do i1=-4,4
        do i2=-4,4
          if (i1*i2.ne.0) then
#ifdef multpdf
            m2pdfpdfii_0(phasespace,i1,i2)=
     &          m2i_phot(i1,i2)
     &          /(36d0)
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdfii_0(aref,i1,i2)=
     &      m2pdfpdfii_0(phasespace,i1,i2)
     &      *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
            m2pdfpdfii_0(phasespace,i1,i2)=
     &      m2pdfpdfii_0(phasespace,i1,i2)
     &       *pdf1(i1)*pdf2(i2)
#else
            m2pdfpdfii_0(phasespace,i1,i2)=
     &          m2i_phot(i1,i2)*pdf1(i1)*pdf2(i2)
     &          /(36d0)
     &                  *bwfac
#endif

            m2pdfpdf_0(phasespace)=m2pdfpdf_0(phasespace)
     &          + m2pdfpdfii_0(phasespace,i1,i2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdf_0(aref)=mm2pdfpdf_0(aref)
     &          + mm2pdfpdfii_0(aref,i1,i2)
      enddo
#endif
          endif
        enddo
        enddo

c        write(*,*) 'cross section: m2pdfpdf_0 real ',m2pdfpdf_0(1)*36
c        write(*,*) 'cross section: m2i_phot',m2i_phot

c test output of |M|^2

c real photon radiation

      elseif(generator.eq.1.and.phasespace.ne.1)then
c tree-level amplitudes for subtraction functions for real corrections

#ifdef EXTRABORN
          call Mat2born1(kmcms,m2if0,0)
#else
          call Mat2born(kmcms,m2i0,m2if0,
     &        m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)
#endif

        if (em.eq.1.and.sp.eq.2.or.em.eq.2.and.sp.eq.1) then

          m2pdfpdfqq_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdfqq_0(aref,em,sp)=0d0
      enddo
#endif
          do i1=-4,4
          do i2=-4,4
            if (i1*i2.ne.0) then
              m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then
#ifdef multpdf
                  keep(  1)=
     &                m2if0(i1,i2,i3,i4)
     &                *qparton(i1)*qparton(i2)/36d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1(i1)*pdf2(i2)
#else
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp) +
     &                m2if0(i1,i2,i3,i4)
     &                *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i2)/36d0
     &                  *bwfac
#endif
                endif
              enddo
              enddo
              m2pdfpdfqq_0(phasespace,em,sp)=
     &            m2pdfpdfqq_0(phasespace,em,sp) +
     &            m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfqq_0(aref,em,sp)=
     &            mm2pdfpdfqq_0(aref,em,sp) +
     &            mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)
      enddo
#endif
            endif
          enddo
          enddo

        elseif (em.eq.1.and.sp.eq.3.or.em.eq.3.and.sp.eq.1) then

          m2pdfpdfqq_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdfqq_0(aref,em,sp)=0d0
      enddo
#endif
          do i1=-4,4
          do i2=-4,4
            if (i1*i2.ne.0) then
              m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then
#ifdef multpdf
                  keep(  1)=
     &                m2if0(i1,i2,i3,i4)
     &                *qparton(i1)*qparton(i3)/(36d0)
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1(i1)*pdf2(i2)
#else
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp) +
     &                m2if0(i1,i2,i3,i4)
     &                *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i3)/(36d0)
     &                  *bwfac
#endif
                endif
              enddo
             enddo
             m2pdfpdfqq_0(phasespace,em,sp)=
     &           m2pdfpdfqq_0(phasespace,em,sp) +
     &           m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
             mm2pdfpdfqq_0(aref,em,sp)=
     &           mm2pdfpdfqq_0(aref,em,sp) +
     &           mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)
      enddo
#endif
           endif
         enddo
         enddo

        elseif (em.eq.1.and.sp.eq.4.or.em.eq.4.and.sp.eq.1) then

          m2pdfpdfqq_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdfqq_0(aref,em,sp)=0d0
      enddo
#endif
          do i1=-4,4
          do i2=-4,4
            if (i1*i2.ne.0) then
              m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then
#ifdef multpdf
                  keep(  1)=
     &                m2if0(i1,i2,i3,i4)
     &                *qparton(i1)*qparton(i4)/(36d0)
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1(i1)*pdf2(i2)
#else
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp) +
     &                m2if0(i1,i2,i3,i4)
     &                *pdf1(i1)*pdf2(i2)*qparton(i1)*qparton(i4)/(36d0)
     &                  *bwfac
#endif
                endif
              enddo
             enddo
             m2pdfpdfqq_0(phasespace,em,sp)=
     &           m2pdfpdfqq_0(phasespace,em,sp) +
     &           m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
             mm2pdfpdfqq_0(aref,em,sp)=
     &           mm2pdfpdfqq_0(aref,em,sp) +
     &           mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)
      enddo
#endif
           endif
         enddo
         enddo

       elseif (em.eq.2.and.sp.eq.3.or.em.eq.3.and.sp.eq.2) then

          m2pdfpdfqq_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdfqq_0(aref,em,sp)=0d0
      enddo
#endif
          do i1=-4,4
          do i2=-4,4
            if (i1*i2.ne.0) then
              m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then
#ifdef multpdf
                  keep(  1)=
     &                m2if0(i1,i2,i3,i4)
     &                *qparton(i2)*qparton(i3)/(36d0)
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1(i1)*pdf2(i2)
#else
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp) +
     &                m2if0(i1,i2,i3,i4)
     &                *pdf1(i1)*pdf2(i2)*qparton(i2)*qparton(i3)/(36d0)
     &                  *bwfac
#endif
                endif
              enddo
             enddo
             m2pdfpdfqq_0(phasespace,em,sp)=
     &           m2pdfpdfqq_0(phasespace,em,sp) +
     &           m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
             mm2pdfpdfqq_0(aref,em,sp)=
     &           mm2pdfpdfqq_0(aref,em,sp) +
     &           mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)
      enddo
#endif
           endif
         enddo
         enddo

       elseif (em.eq.2.and.sp.eq.4.or.em.eq.4.and.sp.eq.2) then

          m2pdfpdfqq_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdfqq_0(aref,em,sp)=0d0
      enddo
#endif
          do i1=-4,4
          do i2=-4,4
            if (i1*i2.ne.0) then
              m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then
#ifdef multpdf
                  keep(  1)=
     &                m2if0(i1,i2,i3,i4)
     &                *qparton(i2)*qparton(i4)/(36d0)
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1(i1)*pdf2(i2)
#else
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp) +
     &                m2if0(i1,i2,i3,i4)
     &                *pdf1(i1)*pdf2(i2)*qparton(i2)*qparton(i4)/(36d0)
     &                  *bwfac
#endif
                endif
              enddo
             enddo
             m2pdfpdfqq_0(phasespace,em,sp)=
     &           m2pdfpdfqq_0(phasespace,em,sp) +
     &           m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
             mm2pdfpdfqq_0(aref,em,sp)=
     &           mm2pdfpdfqq_0(aref,em,sp) +
     &           mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)
      enddo
#endif
           endif
         enddo
         enddo

       elseif (em.eq.3.and.sp.eq.4.or.em.eq.4.and.sp.eq.3) then

          m2pdfpdfqq_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdfqq_0(aref,em,sp)=0d0
      enddo
#endif
          do i1=-4,4
          do i2=-4,4
            if (i1*i2.ne.0) then
              m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then
#ifdef multpdf
                  keep(  1)=
     &                m2if0(i1,i2,i3,i4)
     &                *qparton(i3)*qparton(i4)/(36d0)
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1(i1)*pdf2(i2)
#else
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp) +
     &                m2if0(i1,i2,i3,i4)
     &                *pdf1(i1)*pdf2(i2)*qparton(i3)*qparton(i4)/(36d0)
     &                  *bwfac
#endif
                endif
              enddo
             enddo
             m2pdfpdfqq_0(phasespace,em,sp)=
     &           m2pdfpdfqq_0(phasespace,em,sp) +
     &           m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
             mm2pdfpdfqq_0(aref,em,sp)=
     &           mm2pdfpdfqq_0(aref,em,sp) +
     &           mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)
      enddo
#endif
           endif
         enddo
         enddo

       else

         write(*,*) 'program stopped'
         write(*,*) 'crosssection: outga ',
     &       'not implemented em=co,sp=',em,sp
         stop

       endif


c real gluon radiation

      elseif(generator.eq.2.and.phasespace.eq.1)then
c real corrections
        call Mat2gluon_out(km,m2i_phot,m2if_phot)
        m2pdfpdf_0(phasespace)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        mm2pdfpdf_0(aref)=0d0
      enddo
#endif
        do i1=-4,4
        do i2=-4,4
          if (i1*i2.ne.0) then
#ifdef multpdf
            m2pdfpdfii_0(phasespace,i1,i2)=
     &          m2i_phot(i1,i2)/36d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdfii_0(aref,i1,i2)=
     &      m2pdfpdfii_0(phasespace,i1,i2)
     &      *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
            m2pdfpdfii_0(phasespace,i1,i2)=
     &      m2pdfpdfii_0(phasespace,i1,i2)
     &       *pdf1(i1)*pdf2(i2)
#else
            m2pdfpdfii_0(phasespace,i1,i2)=
     &          m2i_phot(i1,i2)*pdf1(i1)*pdf2(i2)/36d0
     &                  *bwfac
#endif

            m2pdfpdf_0(phasespace)=m2pdfpdf_0(phasespace)
     &          + m2pdfpdfii_0(phasespace,i1,i2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdf_0(aref)=mm2pdfpdf_0(aref)
     &          + mm2pdfpdfii_0(aref,i1,i2)
      enddo
#endif
          endif
        enddo
        enddo

c        write(*,*) 'cross section: m2pdfpdf_0 real gluon ',
c     &      m2pdfpdf_0(1)*36
c        write(*,*) 'cross section: m2i_phot',m2i_phot

c test output of |M|^2

      elseif(generator.eq.2.and.phasespace.ne.1)then
c tree-level amplitudes for subtraction functions for real gluon corrections


#ifdef EXTRABORN
          call  Mat2born2(kmcms,m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)
#else
          call Mat2born(kmcms,m2i0,m2if0,
     &        m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)
#endif


c          write(*,*) 'crosssection  m2if0_22', m2if0_22


        if (em.eq.1.and.sp.eq.2.or.em.eq.2.and.sp.eq.1) then

          m2pdfpdftt_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdftt_0(aref,em,sp)=0d0
      enddo
#endif
          do i1=-4,4
          do i2=-4,4
            if (i1*i2.ne.0) then
              m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then
#ifdef multpdf
                  keep(  1)=
     &                (sqcddiag*m2if0_22(i1,i2,i3,i4)
     &                + sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                *sign(1,i1*i2)/27d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiitt_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1(i1)*pdf2(i2)
#else
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,em,sp) +
     &                (sqcddiag*m2if0_22(i1,i2,i3,i4)
     &                + sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                *pdf1(i1)*pdf2(i2)*sign(1,i1*i2)/27d0
     &                  *bwfac
#endif
                endif
              enddo
              enddo
              m2pdfpdftt_0(phasespace,em,sp)=
     &            m2pdfpdftt_0(phasespace,em,sp) +
     &            m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdftt_0(aref,em,sp)=
     &            mm2pdfpdftt_0(aref,em,sp) +
     &            mm2pdfpdfiitt_0(aref,i1,i2,em,sp)
      enddo
#endif
            endif
          enddo
          enddo

        elseif (em.eq.1.and.sp.eq.3.or.em.eq.3.and.sp.eq.1) then

          m2pdfpdftt_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdftt_0(aref,em,sp)=0d0
      enddo
#endif
          do i1=-4,4
          do i2=-4,4
            if (i1*i2.ne.0) then
              m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then
#ifdef multpdf
                  keep(  1)=
     &                (sqcddiag*m2if0_33(i1,i2,i3,i4)
     &                + sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                *sign(1,i1*i3)/27d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiitt_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1(i1)*pdf2(i2)
#else
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,em,sp) +
     &                (sqcddiag*m2if0_33(i1,i2,i3,i4)
     &                + sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                *pdf1(i1)*pdf2(i2)*sign(1,i1*i3)/27d0
     &                  *bwfac
#endif
                endif
              enddo
             enddo
             m2pdfpdftt_0(phasespace,em,sp)=
     &           m2pdfpdftt_0(phasespace,em,sp) +
     &           m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
             mm2pdfpdftt_0(aref,em,sp)=
     &           mm2pdfpdftt_0(aref,em,sp) +
     &           mm2pdfpdfiitt_0(aref,i1,i2,em,sp)
      enddo
#endif
           endif
         enddo
         enddo

        elseif (em.eq.1.and.sp.eq.4.or.em.eq.4.and.sp.eq.1) then

          m2pdfpdftt_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdftt_0(aref,em,sp)=0d0
      enddo
#endif
          do i1=-4,4
          do i2=-4,4
            if (i1*i2.ne.0) then
              m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then
#ifdef multpdf
                  keep(  1)=
     &                (sqcddiag*m2if0_44(i1,i2,i3,i4)
     &                + sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                *sign(1,i1*i4)/27d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiitt_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1(i1)*pdf2(i2)
#else
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,em,sp) +
     &                (sqcddiag*m2if0_44(i1,i2,i3,i4)
     &                + sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                *pdf1(i1)*pdf2(i2)*sign(1,i1*i4)/27d0
     &                  *bwfac
#endif
                endif
              enddo
             enddo
             m2pdfpdftt_0(phasespace,em,sp)=
     &           m2pdfpdftt_0(phasespace,em,sp) +
     &           m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
             mm2pdfpdftt_0(aref,em,sp)=
     &           mm2pdfpdftt_0(aref,em,sp) +
     &           mm2pdfpdfiitt_0(aref,i1,i2,em,sp)
      enddo
#endif
           endif
         enddo
         enddo

       elseif (em.eq.2.and.sp.eq.3.or.em.eq.3.and.sp.eq.2) then

          m2pdfpdftt_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdftt_0(aref,em,sp)=0d0
      enddo
#endif
          do i1=-4,4
          do i2=-4,4
            if (i1*i2.ne.0) then
              m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then
#ifdef multpdf
                  keep(  1)=
     &                (sqcddiag*m2if0_44(i1,i2,i3,i4)
     &                + sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                *sign(1,i3*i2)/27d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiitt_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1(i1)*pdf2(i2)
#else
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,em,sp) +
     &                (sqcddiag*m2if0_44(i1,i2,i3,i4)
     &                + sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                *pdf1(i1)*pdf2(i2)*sign(1,i3*i2)/27d0
     &                  *bwfac
#endif
                endif
              enddo
             enddo
             m2pdfpdftt_0(phasespace,em,sp)=
     &           m2pdfpdftt_0(phasespace,em,sp) +
     &           m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
             mm2pdfpdftt_0(aref,em,sp)=
     &           mm2pdfpdftt_0(aref,em,sp) +
     &           mm2pdfpdfiitt_0(aref,i1,i2,em,sp)
      enddo
#endif
           endif
         enddo
         enddo

       elseif (em.eq.2.and.sp.eq.4.or.em.eq.4.and.sp.eq.2) then

          m2pdfpdftt_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdftt_0(aref,em,sp)=0d0
      enddo
#endif
          do i1=-4,4
          do i2=-4,4
            if (i1*i2.ne.0) then
              m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then
#ifdef multpdf
                  keep(  1)=
     &                (sqcddiag*m2if0_33(i1,i2,i3,i4)
     &                + sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                *sign(1,i4*i2)/27d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiitt_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1(i1)*pdf2(i2)
#else
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,em,sp) +
     &                (sqcddiag*m2if0_33(i1,i2,i3,i4)
     &                + sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                *pdf1(i1)*pdf2(i2)*sign(1,i4*i2)/27d0
     &                  *bwfac
#endif
                endif
              enddo
             enddo
             m2pdfpdftt_0(phasespace,em,sp)=
     &           m2pdfpdftt_0(phasespace,em,sp) +
     &           m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
             mm2pdfpdftt_0(aref,em,sp)=
     &           mm2pdfpdftt_0(aref,em,sp) +
     &           mm2pdfpdfiitt_0(aref,i1,i2,em,sp)
      enddo
#endif
           endif
         enddo
         enddo

       elseif (em.eq.3.and.sp.eq.4.or.em.eq.4.and.sp.eq.3) then

          m2pdfpdftt_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdftt_0(aref,em,sp)=0d0
      enddo
#endif
          do i1=-4,4
          do i2=-4,4
            if (i1*i2.ne.0) then
              m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i2)
                if (nint(qparton(i1)+qparton(i2)
     &              -qparton(i3)-qparton(i4)).eq.0) then
#ifdef multpdf
                  keep(  1)=
     &                (sqcddiag*m2if0_22(i1,i2,i3,i4)
     &                + sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                *sign(1,i3*i4)/27d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiitt_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,i1)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1(i1)*pdf2(i2)
#else
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,em,sp) +
     &                (sqcddiag*m2if0_22(i1,i2,i3,i4)
     &                + sqcdnondiag*m2if0_nd(i1,i2,i3,i4))
     &                *pdf1(i1)*pdf2(i2)*sign(1,i3*i4)/27d0
     &                  *bwfac
#endif


                endif
              enddo
             enddo
             m2pdfpdftt_0(phasespace,em,sp)=
     &           m2pdfpdftt_0(phasespace,em,sp) +
     &           m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
             mm2pdfpdftt_0(aref,em,sp)=
     &           mm2pdfpdftt_0(aref,em,sp) +
     &           mm2pdfpdfiitt_0(aref,i1,i2,em,sp)
      enddo
#endif
           endif
         enddo
         enddo

       else

         write(*,*) 'program stopped'
         write(*,*) 'crosssection: outgl ',
     &       'not implemented em=co,sp=',em,sp
         stop

       endif

c     &      m2pdfpdfiitt_0(phasespace,-4,-4,3,4)


c        write(*,*) 'cross section m2b,m2bb ',m2b,m2bb

c        write(*,*) 'cross section m2pdfpdftt_0 ',
c     &      m2pdfpdfiitt_0(phasespace,-4,-4,3,4)

c        write(*,*) 'cross section m2pdfpdftt_0 ',
c     &      m2pdfpdfiitt_0(phasespace,-4,-4,1,2),
c     &          m2i0(-4,-4),pdf1(-4),pdf2(-4),
c     &          qparton(-4),qparton(-4),(36d0)

      elseif(generator.eq.3.and.phasespace.eq.1)then
c real incoming photon contributions 1
        call Mat2photon_in1(kmcms,m2i_iphot,m2if_phot)
        m2pdfpdf_0(phasespace)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        mm2pdfpdf_0(aref)=0d0
      enddo
#endif
        i1=0
        pdf1l(i1)=pdf_phot1
        do i2=-4,4
          if (i2.ne.0) then
#ifdef multpdf
            m2pdfpdfii_0(phasespace,i1,i2)=
     &          m2i_iphot(i2)
     &          /12d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        If(pdf_phot1.NE.0D0 .OR. pdf_phot2.NE.0D0) Then
          write(*,*) 'multiple PDF sets not supported for photon PDF'
	  write(*,*) 'program stopped'
	  Stop
	Endif
      enddo
            m2pdfpdfii_0(phasespace,i1,i2)=
     &      m2pdfpdfii_0(phasespace,i1,i2)
     &       *pdf1l(i1)*pdf2(i2)
#else
            m2pdfpdfii_0(phasespace,i1,i2)=
     &          m2i_iphot(i2)*pdf1l(i1)*pdf2(i2)
     &          /12d0
     &                  *bwfac
#endif

            m2pdfpdf_0(phasespace)=m2pdfpdf_0(phasespace)
     &          + m2pdfpdfii_0(phasespace,i1,i2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdf_0(aref)=mm2pdfpdf_0(aref)
     &          + mm2pdfpdfii_0(aref,i1,i2)
      enddo
#endif
          endif
        enddo

c test output of |M|^2

      elseif(generator.eq.3.and.phasespace.ne.1)then
c tree level amplitudes for subtraction terms for incoming photon 1
c em=co here!
        if (em.eq.3.and.sp.eq.2) then
c         do vcomp=0,3
c           kmcms(3,vcomp)=kmcms(6,vcomp)
c         enddo

#ifdef EXTRABORN
          call Mat2born1(kmcms,m2if0,0)
#else
          call Mat2born(kmcms,m2i0,m2if0,
     &        m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)
#endif

          m2pdfpdfqq_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdfqq_0(aref,em,sp)=0d0
      enddo
#endif
          i1=0
          pdf1l(i1)=pdf_phot1
          do i2=-4,4
            if (i2.ne.0) then
              m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
              do j3=1,4
                i3 = sign(j1,i2)
                i4 = sign(j2,i2)
                i6 = -sign(j3,i2)
                if (nint(qparton(i2)-qparton(i3)
     &              -qparton(i4)-qparton(i6)).eq.0) then
c MODIFIED FOR TESTING
cm                if(i3.eq.i2.and.i4.eq.i2.and.i6.eq.-i2)then
#ifdef multpdf
                  keep(  1)=
     &                m2if0(-i3,i2,i6,i4)
     &                *qparton(i3)*qparton(i3)/24d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,0)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1l(i1)*pdf2(i2)
#else
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp) +
     &                m2if0(-i3,i2,i6,i4)
     &                *pdf1l(i1)*pdf2(i2)*qparton(i3)*qparton(i3)/24d0
     &                  *bwfac
#endif

                endif
cm                endif
              enddo
              enddo
              enddo
              m2pdfpdfqq_0(phasespace,em,sp)=
     &          m2pdfpdfqq_0(phasespace,em,sp) +
     &          m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfqq_0(aref,em,sp)=
     &          mm2pdfpdfqq_0(aref,em,sp) +
     &          mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)
      enddo
#endif
            endif
          enddo

        elseif (em.eq.4.and.sp.eq.2) then

c         do vcomp=0,3
c           kmcms(4,vcomp)=kmcms(3,vcomp)
c           kmcms(3,vcomp)=kmcms(6,vcomp)
c         enddo

#ifdef EXTRABORN
          call Mat2born1(kmcms,m2if0,0)
#else
          call Mat2born(kmcms,m2i0,m2if0,
     &        m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)
#endif

          m2pdfpdfqq_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdfqq_0(aref,em,sp)=0d0
      enddo
#endif
          i1=0
          pdf1l(i1)=pdf_phot1
          do i2=-4,4
            if (i2.ne.0) then
              m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
              do j3=1,4
                i3 = sign(j1,i2)
                i4 = sign(j2,i2)
                i6 = -sign(j3,i2)
                if (nint(qparton(i2)-qparton(i3)
     &              -qparton(i4)-qparton(i6)).eq.0) then
#ifdef multpdf
                  keep(  1)=
     &                m2if0(-i4,i2,i6,i3)
     &                *qparton(i4)*qparton(i4)/24d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,0)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1l(i1)*pdf2(i2)
#else
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp) +
     &                m2if0(-i4,i2,i6,i3)
     &                *pdf1l(i1)*pdf2(i2)*qparton(i4)*qparton(i4)/24d0
     &                  *bwfac
#endif
                endif
              enddo
              enddo
              enddo
              m2pdfpdfqq_0(phasespace,em,sp)=
     &          m2pdfpdfqq_0(phasespace,em,sp) +
     &          m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfqq_0(aref,em,sp)=
     &          mm2pdfpdfqq_0(aref,em,sp) +
     &          mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)
      enddo
#endif
            endif
          enddo

        elseif ((em.eq.6.and.shtr.eq.0.or.em.eq.7.and.shtr.gt.0)
     &        .and.sp.eq.2) then

#ifdef EXTRABORN
          call Mat2born1(kmcms,m2if0,0)
#else
          call Mat2born(kmcms,m2i0,m2if0,
     &        m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)
#endif

          m2pdfpdfqq_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdfqq_0(aref,em,sp)=0d0
      enddo
#endif
          i1=0
          pdf1l(i1)=pdf_phot1
          do i2=-4,4
            if (i2.ne.0) then
              m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
              do j3=1,4
                i3 = sign(j1,i2)
                i4 = sign(j2,i2)
                i6 = -sign(j3,i2)
                if (nint(qparton(i2)-qparton(i3)
     &              -qparton(i4)-qparton(i6)).eq.0) then
#ifdef multpdf
                  keep(  1)=
     &                m2if0(-i6,i2,i3,i4)
     &                *qparton(i6)*qparton(i6)/12d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,0)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1l(i1)*pdf2(i2)
#else
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp) +
     &                m2if0(-i6,i2,i3,i4)
     &                *pdf1l(i1)*pdf2(i2)*qparton(i6)*qparton(i6)/12d0
     &                  *bwfac
#endif
                endif
cm                endif
              enddo
              enddo
              enddo
              m2pdfpdfqq_0(phasespace,em,sp)=
     &          m2pdfpdfqq_0(phasespace,em,sp) +
     &          m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfqq_0(aref,em,sp)=
     &          mm2pdfpdfqq_0(aref,em,sp) +
     &          mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)
      enddo
#endif
            endif
          enddo

       else

         write(*,*) 'program stopped'
         write(*,*) 'crosssection: inga1 ',
     &       'not implemented em=co,sp=',em,sp
         stop

       endif

      elseif(generator.eq.4.and.phasespace.eq.1)then
c real incoming photon contribution 2
        call Mat2photon_in2(kmcms,m2i_iphot,m2if_phot)
        m2pdfpdf_0(phasespace)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        mm2pdfpdf_0(aref)=0d0
      enddo
#endif
        i2=0
        pdf2l(i2)=pdf_phot2
        do i1=-4,4
          if (i1.ne.0) then
#ifdef multpdf
            m2pdfpdfii_0(phasespace,i1,i2)=
     &          m2i_iphot(i1)
     &          /12d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        If(pdf_phot1.NE.0D0 .OR. pdf_phot2.NE.0D0) Then
          write(*,*) 'multiple PDF sets not supported for photon PDF'
	  write(*,*) 'program stopped'
	  Stop
	Endif
      enddo
            m2pdfpdfii_0(phasespace,i1,i2)=
     &      m2pdfpdfii_0(phasespace,i1,i2)
     &       *pdf1(i1)*pdf2l(i2)
#else
            m2pdfpdfii_0(phasespace,i1,i2)=
     &          m2i_iphot(i1)*pdf1(i1)*pdf2l(i2)
     &          /12d0
     &                  *bwfac
#endif

            m2pdfpdf_0(phasespace)=m2pdfpdf_0(phasespace)
     &          + m2pdfpdfii_0(phasespace,i1,i2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdf_0(aref)=mm2pdfpdf_0(aref)
     &          + mm2pdfpdfii_0(aref,i1,i2)
      enddo
#endif
          endif
        enddo
c        write(*,*) 'cross section: m2pdfpdf_0 real ',m2pdfpdf_0(1)*12
c        write(*,*) 'cross section: m2i_iphot',m2i_phot

c test output of |M|^2

      elseif(generator.eq.4.and.phasespace.ne.1)then
c tree level amplitudes for subtraction terms for incoming photons
c em=co here!
        if (em.eq.3.and.sp.eq.1) then
c         do vcomp=0,3
c           kmcms(3,vcomp)=kmcms(4,vcomp)
c           kmcms(4,vcomp)=kmcms(6,vcomp)
c         enddo

#ifdef EXTRABORN
          call Mat2born1(kmcms,m2if0,0)
#else
          call Mat2born(kmcms,m2i0,m2if0,
     &        m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)
#endif

          m2pdfpdfqq_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdfqq_0(aref,em,sp)=0d0
      enddo
#endif
          i2=0
          pdf2l(i2)=pdf_phot2
          do i1=-4,4
            if (i1.ne.0) then
              m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
              do j3=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i1)
                i6 = -sign(j3,i1)
                if (nint(qparton(i1)-qparton(i3)
     &              -qparton(i4)-qparton(i6)).eq.0) then
c MODIFIED FOR TESTING
cm                if(i3.eq.i1.and.i4.eq.i1.and.i6.eq.-i1)then
#ifdef multpdf
                  keep(  1)=
     &                m2if0(i1,-i3,i4,i6)
     &                *qparton(i3)*qparton(i3)/24d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,i1)*mpdf2(nset,0)
      enddo
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1(i1)*pdf2l(i2)
#else
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp) +
     &                m2if0(i1,-i3,i4,i6)
     &                *pdf1(i1)*pdf2l(i2)*qparton(i3)*qparton(i3)/24d0
     &                  *bwfac
#endif

                endif
cm                endif
              enddo
              enddo
              enddo
              m2pdfpdfqq_0(phasespace,em,sp)=
     &          m2pdfpdfqq_0(phasespace,em,sp) +
     &          m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfqq_0(aref,em,sp)=
     &          mm2pdfpdfqq_0(aref,em,sp) +
     &          mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)
      enddo
#endif
            endif
          enddo

        elseif (em.eq.4.and.sp.eq.1) then

c         do vcomp=0,3
c           kmcms(4,vcomp)=kmcms(6,vcomp)
c         enddo

#ifdef EXTRABORN
          call Mat2born1(kmcms,m2if0,0)
#else
          call Mat2born(kmcms,m2i0,m2if0,
     &        m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)
#endif

          m2pdfpdfqq_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdfqq_0(aref,em,sp)=0d0
      enddo
#endif
          i2=0
          pdf2l(i2)=pdf_phot2
          do i1=-4,4
            if (i1.ne.0) then
              m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
              do j3=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i1)
                i6 = -sign(j3,i1)
                if (nint(qparton(i1)-qparton(i3)
     &              -qparton(i4)-qparton(i6)).eq.0) then
c MODIFIED FOR TESTING
cm                if(i3.eq.i1.and.i4.eq.i1.and.i6.eq.-i1)then
#ifdef multpdf
                  keep(  1)=
     &                m2if0(i1,-i4,i3,i6)
     &                *qparton(i4)*qparton(i4)/24d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,i1)*mpdf2(nset,0)
      enddo
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1(i1)*pdf2l(i2)
#else
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp) +
     &                m2if0(i1,-i4,i3,i6)
     &                *pdf1(i1)*pdf2l(i2)*qparton(i4)*qparton(i4)/24d0
     &                  *bwfac
#endif

cm                endif
                endif
              enddo
              enddo
              enddo
              m2pdfpdfqq_0(phasespace,em,sp)=
     &          m2pdfpdfqq_0(phasespace,em,sp) +
     &          m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfqq_0(aref,em,sp)=
     &          mm2pdfpdfqq_0(aref,em,sp) +
     &          mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)
      enddo
#endif
            endif
          enddo

c        elseif (em.eq.6.and.sp.eq.1) then
        elseif ((em.eq.6.and.shtr.eq.0.or.em.eq.7.and.shtr.gt.0)
     &        .and.sp.eq.1) then

#ifdef EXTRABORN
          call Mat2born1(kmcms,m2if0,0)
#else
          call Mat2born(kmcms,m2i0,m2if0,
     &        m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)
#endif

          m2pdfpdfqq_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdfqq_0(aref,em,sp)=0d0
      enddo
#endif
          i2=0
          pdf2l(i2)=pdf_phot2
          do i1=-4,4
            if (i1.ne.0) then
              m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
              do j3=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i1)
                i6 = -sign(j3,i1)
                if (nint(qparton(i1)-qparton(i3)
     &              -qparton(i4)-qparton(i6)).eq.0) then
c MODIFIED FOR TESTING
cm                if(i3.eq.i1.and.i4.eq.i1.and.i6.eq.-i1)then
#ifdef multpdf
                  keep(  1)=
     &                m2if0(-i6,i1,i3,i4)
     &                *qparton(i6)*qparton(i6)/12d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,i1)*mpdf2(nset,0)
      enddo
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1(i1)*pdf2l(i2)
#else
                  m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp) +
     &                m2if0(-i6,i1,i3,i4)
     &                *pdf1(i1)*pdf2l(i2)*qparton(i6)*qparton(i6)/12d0
     &                  *bwfac
#endif
                endif
cm                endif
              enddo
              enddo
              enddo
              m2pdfpdfqq_0(phasespace,em,sp)=
     &          m2pdfpdfqq_0(phasespace,em,sp) +
     &          m2pdfpdfiiqq_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfqq_0(aref,em,sp)=
     &          mm2pdfpdfqq_0(aref,em,sp) +
     &          mm2pdfpdfiiqq_0(aref,i1,i2,em,sp)
      enddo
#endif
            endif
          enddo

       else

         write(*,*) 'program stopped'
         write(*,*) 'crosssection: inga2 ',
     &       'not implemented em=co,sp=',em,sp
         stop

       endif

      elseif(generator.eq.5.and.phasespace.eq.1)then
c real incoming gluon contribution 1
        call Mat2gluon_in1(kmcms,m2i_iphot,m2if_phot)
        m2pdfpdf_0(phasespace)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        mm2pdfpdf_0(aref)=0d0
      enddo
#endif
        i1=0
        pdf1l(i1)=pdf1(0)
        do i2=-4,4
          if (i2.ne.0) then
#ifdef multpdf
            m2pdfpdfii_0(phasespace,i1,i2)=
     &          m2i_iphot(i2)
c average over 2x2 spins and 3x8 colours
     &          /96d0
     &          *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdfii_0(aref,i1,i2)=
     &      m2pdfpdfii_0(phasespace,i1,i2)
     &      *mpdf1(nset,0)*mpdf2(nset,i2)
      enddo
            m2pdfpdfii_0(phasespace,i1,i2)=
     &      m2pdfpdfii_0(phasespace,i1,i2)
     &       *pdf1l(i1)*pdf2(i2)
#else
            m2pdfpdfii_0(phasespace,i1,i2)=
     &          m2i_iphot(i2)*pdf1l(i1)*pdf2(i2)
c average over 2x2 spins and 3x8 colours
     &          /96d0
     &          *bwfac
#endif

            m2pdfpdf_0(phasespace)=m2pdfpdf_0(phasespace)
     &          + m2pdfpdfii_0(phasespace,i1,i2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdf_0(aref)=mm2pdfpdf_0(aref)
     &          + mm2pdfpdfii_0(aref,i1,i2)
      enddo
#endif
          endif
        enddo

c test output of |M|^2

      elseif(generator.eq.5.and.phasespace.ne.1)then
c tree level amplitudes for subtraction terms for incoming gluon 1
c em=co here!


        if (em.eq.3.and.sp.eq.2) then
c         do vcomp=0,3
c           kmcms(3,vcomp)=kmcms(6,vcomp)
c         enddo

          call Mat2born(kmcms,m2i0,m2if0,
     &        m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)

          m2pdfpdftt_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdftt_0(aref,em,sp)=0d0
      enddo
#endif
          i1=0
          pdf1l(i1)=pdf1(0)
          do i2=-4,4
            if (i2.ne.0) then
              m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
              do j3=1,4
                i3 = sign(j1,i2)
                i4 = sign(j2,i2)
                i6 = -sign(j3,i2)
                if (nint(qparton(i2)-qparton(i3)
     &              -qparton(i4)-qparton(i6)).eq.0) then
#ifdef multpdf
                  keep(  1)=
     &                (sqcddiag*(m2if0_22(-i3,i2,i6,i4)
     &                +m2if0_33(-i3,i2,i6,i4)+m2if0_44(-i3,i2,i6,i4))
     &                +sqcdnondiag*m2if0_nd(-i3,i2,i6,i4))
     &                /144d0
c factor 144 includes average over 2x2 spins and 3x8 colours
c symmetry factor 1/2  and Casimir operator 4/3
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiitt_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,0)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1l(i1)*pdf2(i2)
#else
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,em,sp) +
     &                (sqcddiag*(m2if0_22(-i3,i2,i6,i4)
     &                +m2if0_33(-i3,i2,i6,i4)+m2if0_44(-i3,i2,i6,i4))
     &                +sqcdnondiag*m2if0_nd(-i3,i2,i6,i4))
     &                *pdf1l(i1)*pdf2(i2)/144d0
c factor 144 includes average over 2x2 spins and 3x8 colours
c symmetry factor 1/2  and Casimir operator 4/3
     &                  *bwfac
#endif


                endif
              enddo
              enddo
              enddo
              m2pdfpdftt_0(phasespace,em,sp)=
     &          m2pdfpdftt_0(phasespace,em,sp) +
     &          m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdftt_0(aref,em,sp)=
     &          mm2pdfpdftt_0(aref,em,sp) +
     &          mm2pdfpdfiitt_0(aref,i1,i2,em,sp)
      enddo
#endif
            endif
          enddo


        elseif (em.eq.4.and.sp.eq.2) then

c         do vcomp=0,3
c           kmcms(4,vcomp)=kmcms(3,vcomp)
c           kmcms(3,vcomp)=kmcms(6,vcomp)
c         enddo

          call Mat2born(kmcms,m2i0,m2if0,
     &        m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)

          m2pdfpdftt_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdftt_0(aref,em,sp)=0d0
      enddo
#endif
          i1=0
          pdf1l(i1)=pdf1(0)
          do i2=-4,4
            if (i2.ne.0) then
              m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
              do j3=1,4
                i3 = sign(j1,i2)
                i4 = sign(j2,i2)
                i6 = -sign(j3,i2)
                if (nint(qparton(i2)-qparton(i3)
     &              -qparton(i4)-qparton(i6)).eq.0) then
c MODIFIED FOR TESTING
cm                if(i3.eq.i2.and.i4.eq.i2.and.i6.eq.-i2)then
#ifdef multpdf
                  keep(  1)=
     &                  (sqcddiag*(m2if0_22(-i4,i2,i6,i3)
     &                  +m2if0_33(-i4,i2,i6,i3)+m2if0_44(-i4,i2,i6,i3))
     &                  +sqcdnondiag*m2if0_nd(-i4,i2,i6,i3))
c     &                m2if0(-i4,i2,i6,i3)
     &                /144d0
c factor 144 includes average over 2x2 spins and 3x8 colours
c symmetry factor 1/2  and Casimir operator 4/3
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiitt_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,0)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1l(i1)*pdf2(i2)
#else
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,em,sp) +
     &                  (sqcddiag*(m2if0_22(-i4,i2,i6,i3)
     &                  +m2if0_33(-i4,i2,i6,i3)+m2if0_44(-i4,i2,i6,i3))
     &                  +sqcdnondiag*m2if0_nd(-i4,i2,i6,i3))
c     &                m2if0(-i4,i2,i6,i3)
     &                *pdf1l(i1)*pdf2(i2)/144d0
c factor 144 includes average over 2x2 spins and 3x8 colours
c symmetry factor 1/2  and Casimir operator 4/3
     &                  *bwfac
#endif

cm                endif
                endif
              enddo
              enddo
              enddo
              m2pdfpdftt_0(phasespace,em,sp)=
     &          m2pdfpdftt_0(phasespace,em,sp) +
     &          m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdftt_0(aref,em,sp)=
     &          mm2pdfpdftt_0(aref,em,sp) +
     &          mm2pdfpdfiitt_0(aref,i1,i2,em,sp)
      enddo
#endif
            endif
          enddo


        elseif ((em.eq.6.and.shtr.eq.0.or.em.eq.7.and.shtr.gt.0)
     &        .and.sp.eq.2) then

          call Mat2born(kmcms,m2i0,m2if0,
     &        m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)

          m2pdfpdftt_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdftt_0(aref,em,sp)=0d0
      enddo
#endif
          i1=0
          pdf1l(i1)=pdf1(0)
          do i2=-4,4
            if (i2.ne.0) then
              m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
              do j3=1,4
                i3 = sign(j1,i2)
                i4 = sign(j2,i2)
                i6 = -sign(j3,i2)
                if (nint(qparton(i2)-qparton(i3)
     &              -qparton(i4)-qparton(i6)).eq.0) then
c MODIFIED FOR TESTING
cm                if(i3.eq.i2.and.i4.eq.i2.and.i6.eq.-i2)then
#ifdef multpdf
                  keep(  1)=
     &                  (sqcddiag*(m2if0_22(-i6,i2,i3,i4)
     &                  +m2if0_33(-i6,i2,i3,i4)+m2if0_44(-i6,i2,i3,i4))
     &                  +sqcdnondiag*m2if0_nd(-i6,i2,i3,i4))
c     &                m2if0(-i6,i2,i3,i4)
     &                /72d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiitt_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,0)*mpdf2(nset,i2)
      enddo
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1l(i1)*pdf2(i2)
#else
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,em,sp) +
     &                  (sqcddiag*(m2if0_22(-i6,i2,i3,i4)
     &                  +m2if0_33(-i6,i2,i3,i4)+m2if0_44(-i6,i2,i3,i4))
     &                  +sqcdnondiag*m2if0_nd(-i6,i2,i3,i4))
c     &                m2if0(-i6,i2,i3,i4)
     &                *pdf1l(i1)*pdf2(i2)/72d0
     &                  *bwfac
#endif

                endif
cm                endif
              enddo
              enddo
              enddo
              m2pdfpdftt_0(phasespace,em,sp)=
     &          m2pdfpdftt_0(phasespace,em,sp) +
     &          m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdftt_0(aref,em,sp)=
     &          mm2pdfpdftt_0(aref,em,sp) +
     &          mm2pdfpdfiitt_0(aref,i1,i2,em,sp)
      enddo
#endif
            endif
          enddo


       else

         write(*,*) 'program stopped'
         write(*,*) 'crosssection: ingl1 ',
     &       'not implemented em=co,sp=',em,sp
         stop

       endif

      elseif(generator.eq.6.and.phasespace.eq.1)then
c real incoming photon contribution 2
        call Mat2gluon_in2(kmcms,m2i_iphot,m2if_phot)
        m2pdfpdf_0(phasespace)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
        mm2pdfpdf_0(aref)=0d0
      enddo
#endif
        i2=0
        pdf2l(i2)=pdf2(0)
        do i1=-4,4
          if (i1.ne.0) then
#ifdef multpdf
            m2pdfpdfii_0(phasespace,i1,i2)=
     &          m2i_iphot(i1)
c average over 2x2 spins and 3x8 colours
     &          /96d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdfii_0(aref,i1,i2)=
     &      m2pdfpdfii_0(phasespace,i1,i2)
     &      *mpdf1(nset,i1)*mpdf2(nset,0)
      enddo
            m2pdfpdfii_0(phasespace,i1,i2)=
     &      m2pdfpdfii_0(phasespace,i1,i2)
     &       *pdf1(i1)*pdf2l(i2)
#else
            m2pdfpdfii_0(phasespace,i1,i2)=
     &          m2i_iphot(i1)*pdf1(i1)*pdf2l(i2)
c average over 2x2 spins and 3x8 colours
     &          /96d0
     &                  *bwfac
#endif

            m2pdfpdf_0(phasespace)=m2pdfpdf_0(phasespace)
     &          + m2pdfpdfii_0(phasespace,i1,i2)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
            mm2pdfpdf_0(aref)=mm2pdfpdf_0(aref)
     &          + mm2pdfpdfii_0(aref,i1,i2)
      enddo
#endif
          endif
        enddo
c       endif  ! belthr

c        write(*,*) 'cross section: m2pdfpdf_0 real ',m2pdfpdf_0(1)*12
c        write(*,*) 'cross section: m2i_iphot',m2i_phot

c test output of |M|^2

      elseif(generator.eq.6.and.phasespace.ne.1)then
c tree level amplitudes for subtraction terms for incoming gluon 2
c em=co here!


        if (em.eq.3.and.sp.eq.1) then

c         do vcomp=0,3
c           kmcms(3,vcomp)=kmcms(4,vcomp)
c           kmcms(4,vcomp)=kmcms(6,vcomp)
c         enddo

          call Mat2born(kmcms,m2i0,m2if0,
     &        m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)

          m2pdfpdftt_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdftt_0(aref,em,sp)=0d0
      enddo
#endif
          i2=0
          pdf2l(i2)=pdf2(0)
          do i1=-4,4
            if (i1.ne.0) then
              m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
              do j3=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i1)
                i6 = -sign(j3,i1)
                if (nint(qparton(i1)-qparton(i3)
     &              -qparton(i4)-qparton(i6)).eq.0) then
c MODIFIED FOR TESTING
cm                if(i3.eq.i1.and.i4.eq.i1.and.i6.eq.-i1)then
#ifdef multpdf
                  keep(  1)=
     &                  (sqcddiag*(m2if0_22(i1,-i3,i4,i6)
     &                  +m2if0_33(i1,-i3,i4,i6)+m2if0_44(i1,-i3,i4,i6))
     &                  +sqcdnondiag*m2if0_nd(i1,-i3,i4,i6))
c     &                m2if0(i1,-i3,i4,i6)
     &                /144d0
c factor 144 includes average over 2x2 spins and 3x8 colours
c symmetry factor 1/2  and Casimir operator 4/3
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiitt_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,i1)*mpdf2(nset,0)
      enddo
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1(i1)*pdf2l(i2)
#else
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,em,sp) +
     &                  (sqcddiag*(m2if0_22(i1,-i3,i4,i6)
     &                  +m2if0_33(i1,-i3,i4,i6)+m2if0_44(i1,-i3,i4,i6))
     &                  +sqcdnondiag*m2if0_nd(i1,-i3,i4,i6))
c     &                m2if0(i1,-i3,i4,i6)
     &                *pdf1(i1)*pdf2l(i2)/144d0
c factor 144 includes average over 2x2 spins and 3x8 colours
c symmetry factor 1/2  and Casimir operator 4/3
     &                  *bwfac
#endif

                endif
cm                endif
              enddo
              enddo
              enddo
              m2pdfpdftt_0(phasespace,em,sp)=
     &          m2pdfpdftt_0(phasespace,em,sp) +
     &          m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdftt_0(aref,em,sp)=
     &          mm2pdfpdftt_0(aref,em,sp) +
     &          mm2pdfpdfiitt_0(aref,i1,i2,em,sp)
      enddo
#endif
            endif
          enddo

        elseif (em.eq.4.and.sp.eq.1) then

c         do vcomp=0,3
c           kmcms(4,vcomp)=kmcms(6,vcomp)
c         enddo

          call Mat2born(kmcms,m2i0,m2if0,
     &        m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)

          m2pdfpdftt_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdftt_0(aref,em,sp)=0d0
      enddo
#endif
          i2=0
          pdf2l(i2)=pdf2(0)
          do i1=-4,4
            if (i1.ne.0) then
              m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
              do j3=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i1)
                i6 = -sign(j3,i1)
                if (nint(qparton(i1)-qparton(i3)
     &              -qparton(i4)-qparton(i6)).eq.0) then
c MODIFIED FOR TESTING
cm                if(i3.eq.i1.and.i4.eq.i1.and.i6.eq.-i1)then
#ifdef multpdf
                  keep(  1)=
     &                  (sqcddiag*(m2if0_22(i1,-i4,i3,i6)
     &                  +m2if0_33(i1,-i4,i3,i6)+m2if0_44(i1,-i4,i3,i6))
     &                  +sqcdnondiag*m2if0_nd(i1,-i4,i3,i6))
c     &                m2if0(i1,-i4,i3,i6)
     &                /144d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiitt_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,i1)*mpdf2(nset,0)
      enddo
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1(i1)*pdf2l(i2)
#else
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,em,sp) +
     &                  (sqcddiag*(m2if0_22(i1,-i4,i3,i6)
     &                  +m2if0_33(i1,-i4,i3,i6)+m2if0_44(i1,-i4,i3,i6))
     &                  +sqcdnondiag*m2if0_nd(i1,-i4,i3,i6))
c     &                m2if0(i1,-i4,i3,i6)
     &                *pdf1(i1)*pdf2l(i2)/144d0
     &                  *bwfac
#endif

cm                endif
                endif
              enddo
              enddo
              enddo
              m2pdfpdftt_0(phasespace,em,sp)=
     &          m2pdfpdftt_0(phasespace,em,sp) +
     &          m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdftt_0(aref,em,sp)=
     &          mm2pdfpdftt_0(aref,em,sp) +
     &          mm2pdfpdfiitt_0(aref,i1,i2,em,sp)
      enddo
#endif
            endif
          enddo

        elseif ((em.eq.6.and.shtr.eq.0.or.em.eq.7.and.shtr.gt.0)
     &        .and.sp.eq.1) then

          call Mat2born(kmcms,m2i0,m2if0,
     &        m2if0_22,m2if0_33,m2if0_44,m2if0_nd,0)

          m2pdfpdftt_0(phasespace,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
          mm2pdfpdftt_0(aref,em,sp)=0d0
      enddo
#endif
          i2=0
          pdf2l(i2)=pdf2(0)
          do i1=-4,4
            if (i1.ne.0) then
              m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=0d0
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=0d0
      enddo
#endif
              do j1=1,4
              do j2=1,4
              do j3=1,4
                i3 = sign(j1,i1)
                i4 = sign(j2,i1)
                i6 = -sign(j3,i1)
                if (nint(qparton(i1)-qparton(i3)
     &              -qparton(i4)-qparton(i6)).eq.0) then
c MODIFIED FOR TESTING
cm                if(i3.eq.i1.and.i4.eq.i1.and.i6.eq.-i1)then
#ifdef multpdf
                  keep(  1)=
     &                  (sqcddiag*(m2if0_22(-i6,i1,i3,i4)
     &                  +m2if0_33(-i6,i1,i3,i4)+m2if0_44(-i6,i1,i3,i4))
     &                  +sqcdnondiag*m2if0_nd(-i6,i1,i3,i4))
c     &                m2if0(-i6,i1,i3,i4)
     &                /72d0
     &                  *bwfac
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
                  mm2pdfpdfiitt_0(aref,i1,i2,em,sp)=
     &            mm2pdfpdfiitt_0(aref,i1,i2,em,sp)+keep(  1)
     &            *mpdf1(nset,i1)*mpdf2(nset,0)
      enddo
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &            m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)+
     &             keep(  1)*pdf1(i1)*pdf2l(i2)
#else
                  m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)=
     &                m2pdfpdfiitt_0(phasespace,i1,i2,em,sp) +
     &                  (sqcddiag*(m2if0_22(-i6,i1,i3,i4)
     &                  +m2if0_33(-i6,i1,i3,i4)+m2if0_44(-i6,i1,i3,i4))
     &                  +sqcdnondiag*m2if0_nd(-i6,i1,i3,i4))
c     &                m2if0(-i6,i1,i3,i4)
     &                *pdf1(i1)*pdf2l(i2)/72d0
     &                  *bwfac
#endif

                endif
cm                endif
              enddo
              enddo
              enddo
              m2pdfpdftt_0(phasespace,em,sp)=
     &          m2pdfpdftt_0(phasespace,em,sp) +
     &          m2pdfpdfiitt_0(phasespace,i1,i2,em,sp)
#ifdef multpdf
      do nset=1,pdfmemberto-pdfmemberfrom+1
        aref=(nset-1)*maxps+phasespace
              mm2pdfpdftt_0(aref,em,sp)=
     &          mm2pdfpdftt_0(aref,em,sp) +
     &          mm2pdfpdfiitt_0(aref,i1,i2,em,sp)
      enddo
#endif
            endif
          enddo

       else

         write(*,*) 'program stopped'
         write(*,*) 'crosssection: ingl2 ',
     &       'not implemented em=co,sp=',em,sp
         stop

       endif

      endif

      end

***********************************************************************
      subroutine onsproj(k,kons,belthr,lnext,switch)
***********************************************************************
*     on-shell projection of external momenta                         *
*     projects Higgs momentum on-shell by rescaling other momenta     *
*---------------------------------------------------------------------*
*     04.03.10  Ansgar Denner     last changed  22.03.10              *
***********************************************************************
      implicit none

#include "mcparams.h"
#include "mccommon.h"

c local variables
      integer lnext,switch
      real*8 k(6,0:3)
      real*8 kons(6,0:3)
      real*8 scafac,sh,sinc,shin,disc
      logical belthr

      belthr=.false.
      if(shtr.eq.0) then
        do ext=1,lnext
          do vcomp=0,3
            kons(ext,vcomp)=k(ext,vcomp)
          enddo
        enddo
      else if (shtr.ge.1) then
        if(sonsproj.eq.0) then
          do ext=1,lnext
            do vcomp=0,3
              kons(ext,vcomp)=k(ext,vcomp)
            enddo
          enddo
        elseif(sonsproj.eq.1)then
          sh = k(5,0)*k(5,0)-k(5,1)*k(5,1)-k(5,2)*k(5,2)-k(5,3)*k(5,3)
          sinc= (k(1,0)+k(2,0))*(k(1,0)+k(2,0))
     &        -(k(1,1)+k(2,1))*(k(1,1)+k(2,1))
     &        -(k(1,2)+k(2,2))*(k(1,2)+k(2,2))
     &        -(k(1,3)+k(2,3))*(k(1,3)+k(2,3))
          shin= (k(1,0)+k(2,0))*k(5,0)
     &        -(k(1,1)+k(2,1))*k(5,1)
     &        -(k(1,2)+k(2,2))*k(5,2)
     &        -(k(1,3)+k(2,3))*k(5,3)
          disc = shin*shin-sinc*sh+mcm(25)*mcm(25)*(sinc-2d0*shin+sh)

          if(sinc.lt.mcm(25)*mcm(25).or.disc.lt.0d0) then
            belthr=.true.
            return
          else
            scafac= (sinc-mcm(25)*mcm(25))/(sinc-shin+sqrt(disc))
c          else
c            scafac= (sinc-shin+sqrt(disc))/(sinc-2d0*shin+sh)
          endif


          if(lnext.eq.5)then
            do vcomp=0,3
              kons(1,vcomp)=k(1,vcomp)
              kons(2,vcomp)=k(2,vcomp)
              kons(3,vcomp)=k(3,vcomp)*scafac
              kons(4,vcomp)=k(4,vcomp)*scafac
              kons(5,vcomp)=kons(1,vcomp)+kons(2,vcomp)
     &            -kons(3,vcomp)-kons(4,vcomp)
            enddo
          elseif(lnext.eq.6)then
            do vcomp=0,3
              kons(1,vcomp)=k(1,vcomp)
              kons(2,vcomp)=k(2,vcomp)
              kons(3,vcomp)=k(3,vcomp)*scafac
              kons(4,vcomp)=k(4,vcomp)*scafac
              kons(6,vcomp)=k(6,vcomp)*scafac
              kons(5,vcomp)=kons(1,vcomp)+kons(2,vcomp)
     &            -kons(3,vcomp)-kons(4,vcomp)-kons(6,vcomp)
            enddo
          else
            write(*,*) 'onshprj: wrong number of external particles:',
     &          lnext
          endif
        elseif(sonsproj.eq.2)then
          sh = k(5,0)*k(5,0)-k(5,1)*k(5,1)-k(5,2)*k(5,2)-k(5,3)*k(5,3)
          scafac= mcm(25)/sqrt(sh)
          do ext=1,lnext
            do vcomp=0,3
              kons(ext,vcomp)=k(ext,vcomp)*scafac
            enddo
          enddo
        endif
      else
        write(*,*) 'onsproj : unknown input shtr = ',shtr
        stop
      endif

      return

      sh = k(5,0)*k(5,0)-k(5,1)*k(5,1)-k(5,2)*k(5,2)-k(5,3)*k(5,3)
      write(*,*) 'onsproj',sonsproj
      write(*,*) 'onsproj:  sh     = ',sh
      write(*,*) 'onsproj:  shproj = ',
     &    kons(5,0)*kons(5,0)-kons(5,1)*kons(5,1)
     &    -kons(5,2)*kons(5,2)-kons(5,3)*kons(5,3),
     &    mcm(25)*mcm(25)
      call printmomenta(0d0,0d0,k,lnext)
      call printmomenta(0d0,0d0,kons,lnext)

      end
